/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/platform","vs/base/common/path","vs/base/common/errors","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ne){for(var e=[],a=0,A=ne.length;a<A;a++)e[a]=De[ne[a]];return e};define(De[61],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(C,P){const S=Object.create(null);for(const k of C){const L=P(k);let T=S[L];T||(T=S[L]=[]),T.push(k)}return S}e.groupBy=a;function A(C,P){const S=[],k=[];for(const L of C)P.has(L)||S.push(L);for(const L of P)C.has(L)||k.push(L);return{removed:S,added:k}}e.diffSets=A;function l(C,P){const S=[],k=[];for(const[L,T]of C)P.has(L)||S.push(T);for(const[L,T]of P)C.has(L)||k.push(T);return{removed:S,added:k}}e.diffMaps=l;class R{constructor(){this.a=new Map}add(P,S){let k=this.a.get(P);k||(k=new Set,this.a.set(P,k)),k.add(S)}delete(P,S){const k=this.a.get(P);!k||(k.delete(S),k.size===0&&this.a.delete(P))}forEach(P,S){const k=this.a.get(P);!k||k.forEach(S)}}e.SetMap=R}),define(De[62],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(C){return(P,S,k)=>{let L=null,T=null;if(typeof k.value=="function"?(L="value",T=k.value):typeof k.get=="function"&&(L="get",T=k.get),!T)throw new Error("not supported");k[L]=C(T,S)}}function A(C,P,S){let k=null,L=null;if(typeof S.value=="function"?(k="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",L=S.get),!L)throw new Error("not supported");const T=`$memoize$${P}`;S[k]=function(...v){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[T]}}e.memoize=A;function l(C,P,S){return a((k,L)=>{const T=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...I){this[v]||(this[v]=S?S():void 0),clearTimeout(this[T]),P&&(this[v]=P(this[v],...I),I=[this[v]]),this[T]=setTimeout(()=>{k.apply(this,I),this[v]=S?S():void 0},C)}})}e.debounce=l;function R(C,P,S){return a((k,L)=>{const T=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,y=`$throttle$pending$${L}`;return function(...h){if(this[v]||(this[v]=S?S():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...h)),this[y])return;const d=this[I]+C;d<=Date.now()?(this[I]=Date.now(),k.apply(this,[this[v]]),this[v]=S?S():void 0):(this[y]=!0,this[T]=setTimeout(()=>{this[y]=!1,this[I]=Date.now(),k.apply(this,[this[v]]),this[v]=S?S():void 0},d-Date.now()))}})}e.throttle=R}),define(De[12],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?D.isErrorNoTelemetry(o)?new D(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(r=>{r(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=a,e.errorHandler=new a;function A(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=A;function l(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function R(i){k(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=R;function C(i){k(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=C;function P(i){if(i instanceof Error){const{name:o,message:r}=i,c=i.stacktrace||i.stack;return{$isError:!0,name:o,message:r,stack:c,noTelemetry:D.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=P;const S="Canceled";function k(i){return i instanceof L?!0:i instanceof Error&&i.name===S&&i.message===S}e.isCancellationError=k;class L extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=L;function T(){const i=new Error(S);return i.name=i.message,i}e.canceled=T;function v(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=v;function I(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=I;function y(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=h;function d(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=d;class u extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=u;class g extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=g;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class D extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof D)return o;const r=new D;return r.message=o.message,r.stack=o.stack,r}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class p extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(De[15],Ce([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(oe,le=0){return oe[oe.length-(1+le)]}e.tail=A;function l(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=l;function R(oe,le,ue=(te,ce)=>te===ce){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let te=0,ce=oe.length;te<ce;te++)if(!ue(oe[te],le[te]))return!1;return!0}e.equals=R;function C(oe,le){const ue=oe.length-1;le<ue&&(oe[le]=oe[ue]),oe.pop()}e.removeFastWithoutKeepingOrder=C;function P(oe,le,ue){return S(oe.length,te=>ue(oe[te],le))}e.binarySearch=P;function S(oe,le){let ue=0,te=oe-1;for(;ue<=te;){const ce=(ue+te)/2|0,se=le(ce);if(se<0)ue=ce+1;else if(se>0)te=ce-1;else return ce}return-(ue+1)}e.binarySearch2=S;function k(oe,le){let ue=0,te=oe.length;if(te===0)return 0;for(;ue<te;){const ce=Math.floor((ue+te)/2);le(oe[ce])?te=ce:ue=ce+1}return ue}e.findFirstInSorted=k;function L(oe,le,ue){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const te=le[Math.floor(le.length*Math.random())],ce=[],se=[],M=[];for(const W of le){const G=ue(W,te);G<0?ce.push(W):G>0?se.push(W):M.push(W)}return oe<ce.length?L(oe,ce,ue):oe<ce.length+M.length?M[0]:L(oe-(ce.length+M.length),se,ue)}e.quickSelect=L;function T(oe,le){const ue=[];let te;for(const ce of oe.slice(0).sort(le))!te||le(te[0],ce)!==0?(te=[ce],ue.push(te)):te.push(ce);return ue}e.groupBy=T;function v(oe,le,ue){const te=[];function ce(W,G,_){if(G===0&&_.length===0)return;const de=te[te.length-1];de&&de.start+de.deleteCount===W?(de.deleteCount+=G,de.toInsert.push(..._)):te.push({start:W,deleteCount:G,toInsert:_})}let se=0,M=0;for(;;){if(se===oe.length){ce(se,0,le.slice(M));break}if(M===le.length){ce(se,oe.length-se,[]);break}const W=oe[se],G=le[M],_=ue(W,G);_===0?(se+=1,M+=1):_<0?(ce(se,1,[]),se+=1):_>0&&(ce(se,0,[G]),M+=1)}return te}e.sortedDiff=v;function I(oe,le,ue){const te=v(oe,le,ue),ce=[],se=[];for(const M of te)ce.push(...oe.slice(M.start,M.start+M.deleteCount)),se.push(...M.toInsert);return{removed:ce,added:se}}e.delta=I;function y(oe,le,ue){if(ue===0)return[];const te=oe.slice(0,ue).sort(le);return d(oe,le,te,ue,oe.length),te}e.top=y;function h(oe,le,ue,te,ce){return ue===0?Promise.resolve([]):new Promise((se,M)=>{(async()=>{const W=oe.length,G=oe.slice(0,ue).sort(le);for(let _=ue,de=Math.min(ue+te,W);_<W;_=de,de=Math.min(de+te,W)){if(_>ue&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new a.CancellationError;d(oe,le,G,_,de)}return G})().then(se,M)})}e.topAsync=h;function d(oe,le,ue,te,ce){for(const se=ue.length;te<ce;te++){const M=oe[te];if(le(M,ue[se-1])<0){ue.pop();const W=k(ue,G=>le(M,G)<0);ue.splice(W,0,M)}}}function u(oe){return oe.filter(le=>!!le)}e.coalesce=u;function g(oe){let le=0;for(let ue=0;ue<oe.length;ue++)oe[ue]&&(oe[le]=oe[ue],le+=1);oe.length=le}e.coalesceInPlace=g;function b(oe,le,ue){oe.splice(ue,0,oe.splice(le,1)[0])}e.move=b;function D(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=D;function p(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=p;function i(oe,le=ue=>ue){const ue=new Set;return oe.filter(te=>{const ce=le(te);return ue.has(ce)?!1:(ue.add(ce),!0)})}e.distinct=i;function o(oe){const le=new Set;return ue=>{const te=oe(ue);return le.has(te)?!1:(le.add(te),!0)}}e.uniqueFilter=o;function r(oe,le){const ue=c(oe,le);if(ue!==-1)return oe[ue]}e.findLast=r;function c(oe,le){for(let ue=oe.length-1;ue>=0;ue--){const te=oe[ue];if(le(te))return ue}return-1}e.lastIndex=c;function s(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=s;function m(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=m;function n(oe,le,ue=(te,ce)=>te===ce){let te=0;for(let ce=0,se=Math.min(oe.length,le.length);ce<se&&ue(oe[ce],le[ce]);ce++)te++;return te}e.commonPrefixLength=n;function t(oe){return[].concat(...oe)}e.flatten=t;function f(oe,le){let ue=typeof le=="number"?oe:0;typeof le=="number"?ue=oe:(ue=0,le=oe);const te=[];if(ue<=le)for(let ce=ue;ce<le;ce++)te.push(ce);else for(let ce=ue;ce>le;ce--)te.push(ce);return te}e.range=f;function E(oe,le,ue){return oe.reduce((te,ce)=>(te[le(ce)]=ue?ue(ce):ce,te),Object.create(null))}e.index=E;function w(oe,le){return oe.push(le),()=>O(oe,le)}e.insert=w;function O(oe,le){const ue=oe.indexOf(le);if(ue>-1)return oe.splice(ue,1),le}e.remove=O;function V(oe,le,ue){const te=oe.slice(0,le),ce=oe.slice(le);return te.concat(ue,ce)}e.arrayInsert=V;function j(oe,le){let ue;if(typeof le=="number"){let te=le;ue=()=>{const ce=Math.sin(te++)*179426549;return ce-Math.floor(ce)}}else ue=Math.random;for(let te=oe.length-1;te>0;te-=1){const ce=Math.floor(ue()*(te+1)),se=oe[te];oe[te]=oe[ce],oe[ce]=se}}e.shuffle=j;function F(oe,le){const ue=oe.indexOf(le);ue>-1&&(oe.splice(ue,1),oe.unshift(le))}e.pushToStart=F;function B(oe,le){const ue=oe.indexOf(le);ue>-1&&(oe.splice(ue,1),oe.push(le))}e.pushToEnd=B;function N(oe,le){for(const ue of le)oe.push(ue)}e.pushMany=N;function U(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=U;function $(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=$;function z(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=z;function ae(oe,le){for(const ue of oe){const te=le(ue);if(te!==void 0)return te}}e.mapFind=ae;function ee(oe,le,ue){const te=J(oe,le),ce=oe.length,se=ue.length;oe.length=ce+se;for(let M=ce-1;M>=te;M--)oe[M+se]=oe[M];for(let M=0;M<se;M++)oe[M+te]=ue[M]}e.insertInto=ee;function q(oe,le,ue,te){const ce=J(oe,le),se=oe.splice(ce,ue);return ee(oe,ce,te),se}e.splice=q;function J(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var ie;(function(oe){function le(ce){return ce<0}oe.isLessThan=le;function ue(ce){return ce>0}oe.isGreaterThan=ue;function te(ce){return ce===0}oe.isNeitherLessOrGreaterThan=te,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function ge(oe,le){return(ue,te)=>le(oe(ue),oe(te))}e.compareBy=ge;function X(...oe){return(le,ue)=>{for(const te of oe){const ce=te(le,ue);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function Z(oe,le){if(oe.length===0)return;let ue=oe[0];for(let te=1;te<oe.length;te++){const ce=oe[te];le(ce,ue)>0&&(ue=ce)}return ue}e.findMaxBy=Z;function fe(oe,le){if(oe.length===0)return;let ue=oe[0];for(let te=1;te<oe.length;te++){const ce=oe[te];le(ce,ue)>=0&&(ue=ce)}return ue}e.findLastMaxBy=fe;function ve(oe,le){return Z(oe,(ue,te)=>-le(ue,te))}e.findMinBy=ve;class ke{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let ue=this.c;for(;ue<this.f.length&&le(this.f[ue]);)ue++;const te=ue===this.c?null:this.f.slice(this.c,ue);return this.c=ue,te}takeFromEndWhile(le){let ue=this.d;for(;ue>=0&&le(this.f[ue]);)ue--;const te=ue===this.d?null:this.f.slice(ue+1,this.d+1);return this.d=ue,te}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const ue=this.f.slice(this.c,this.c+le);return this.c+=le,ue}}e.ArrayQueue=ke;class Oe{constructor(le){this.iterate=le}forEach(le){this.iterate(ue=>(le(ue),!0))}toArray(){const le=[];return this.iterate(ue=>(le.push(ue),!0)),le}filter(le){return new Oe(ue=>this.iterate(te=>le(te)?ue(te):!0))}map(le){return new Oe(ue=>this.iterate(te=>ue(le(te))))}some(le){let ue=!1;return this.iterate(te=>(ue=le(te),!ue)),ue}findFirst(le){let ue;return this.iterate(te=>le(te)?(ue=te,!1):!0),ue}findLast(le){let ue;return this.iterate(te=>(le(te)&&(ue=te),!0)),ue}findLastMaxBy(le){let ue,te=!0;return this.iterate(ce=>((te||ie.isGreaterThan(le(ce,ue)))&&(te=!1,ue=ce),!0)),ue}}Oe.empty=new Oe(oe=>{}),e.CallbackIterable=Oe}),define(De[50],Ce([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(S,k){if(!S)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=A;function l(S,k="Unreachable"){throw new Error(k)}e.assertNever=l;function R(S){if(!S)throw new a.BugIndicatingError("Assertion Failed")}e.assert=R;function C(S){if(!S()){debugger;S(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function P(S,k){let L=0;for(;L<S.length-1;){const T=S[L],v=S[L+1];if(!k(T,v))return!1;L++}return!0}e.checkAdjacentItems=P}),define(De[63],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(A){const l=this;let R=!1,C;return function(){return R||(R=!0,C=A.apply(l,arguments)),C}}e.once=a}),define(De[101],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(De[64],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(A){function l(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}A.is=l;const R=Object.freeze([]);function C(){return R}A.empty=C;function*P(D){yield D}A.single=P;function S(D){return l(D)?D:P(D)}A.wrap=S;function k(D){return D||R}A.from=k;function L(D){return!D||D[Symbol.iterator]().next().done===!0}A.isEmpty=L;function T(D){return D[Symbol.iterator]().next().value}A.first=T;function v(D,p){for(const i of D)if(p(i))return!0;return!1}A.some=v;function I(D,p){for(const i of D)if(p(i))return i}A.find=I;function*y(D,p){for(const i of D)p(i)&&(yield i)}A.filter=y;function*h(D,p){let i=0;for(const o of D)yield p(o,i++)}A.map=h;function*d(...D){for(const p of D)for(const i of p)yield i}A.concat=d;function u(D,p,i){let o=i;for(const r of D)o=p(o,r);return o}A.reduce=u;function*g(D,p,i=D.length){for(p<0&&(p+=D.length),i<0?i+=D.length:i>D.length&&(i=D.length);p<i;p++)yield D[p]}A.slice=g;function b(D,p=Number.POSITIVE_INFINITY){const i=[];if(p===0)return[i,D];const o=D[Symbol.iterator]();for(let r=0;r<p;r++){const c=o.next();if(c.done)return[i,A.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return o}}]}A.consume=b})(a=e.Iterable||(e.Iterable={}))}),define(De[146],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function C(i,o=!1){let r=0;const c=i.length;let s="",m=0,n=16,t=0;function f(B){let N=0,U=0;for(;N<B;){const $=i.charCodeAt(r);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;r++,N++}return N<B&&(U=-1),U}function E(B){r=B,s="",m=0,n=16,t=0}function w(){const B=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&k(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&k(i.charCodeAt(r)))for(r++;r<i.length&&k(i.charCodeAt(r));)r++;else return t=3,i.substring(B,r);let N=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&k(i.charCodeAt(r))){for(r++;r<i.length&&k(i.charCodeAt(r));)r++;N=r}else t=3;return i.substring(B,N)}function O(){let B="",N=r;for(;;){if(r>=c){B+=i.substring(N,r),t=2;break}const U=i.charCodeAt(r);if(U===34){B+=i.substring(N,r),r++;break}if(U===92){if(B+=i.substring(N,r),r++,r>=c){t=2;break}switch(i.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const z=f(4);z>=0?B+=String.fromCharCode(z):t=4;break}default:t=5}N=r;continue}if(U>=0&&U<=31)if(S(U)){B+=i.substring(N,r),t=2;break}else t=6;r++}return B}function V(){if(s="",t=0,m=r,r>=c)return m=c,n=17;let B=i.charCodeAt(r);if(P(B)){do r++,s+=String.fromCharCode(B),B=i.charCodeAt(r);while(P(B));return n=15}if(S(B))return r++,s+=String.fromCharCode(B),B===13&&i.charCodeAt(r)===10&&(r++,s+=`
`),n=14;switch(B){case 123:return r++,n=1;case 125:return r++,n=2;case 91:return r++,n=3;case 93:return r++,n=4;case 58:return r++,n=6;case 44:return r++,n=5;case 34:return r++,s=O(),n=10;case 47:{const N=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<c&&!S(i.charCodeAt(r));)r++;return s=i.substring(N,r),n=12}if(i.charCodeAt(r+1)===42){r+=2;const U=c-1;let $=!1;for(;r<U;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,t=1),s=i.substring(N,r),n=13}return s+=String.fromCharCode(B),r++,n=16}case 45:if(s+=String.fromCharCode(B),r++,r===c||!k(i.charCodeAt(r)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=w(),n=11;default:for(;r<c&&j(B);)r++,B=i.charCodeAt(r);if(m!==r){switch(s=i.substring(m,r),s){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return s+=String.fromCharCode(B),r++,n=16}}function j(B){if(P(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let B;do B=V();while(B>=12&&B<=15);return B}return{setPosition:E,getPosition:()=>r,scan:o?F:V,getToken:()=>n,getTokenValue:()=>s,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>t}}e.createScanner=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function T(i,o){const r=[],c=new Object;let s;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function t(f,E,w,O){m.value=f,m.offset=E,m.length=w,m.type=O,m.colonOffset=void 0,s=m}try{b(i,{onObjectBegin:(f,E)=>{if(o<=f)throw c;s=void 0,n=o>f,r.push("")},onObjectProperty:(f,E,w)=>{if(o<E||(t(f,E,w,"property"),r[r.length-1]=f,o<=E+w))throw c},onObjectEnd:(f,E)=>{if(o<=f)throw c;s=void 0,r.pop()},onArrayBegin:(f,E)=>{if(o<=f)throw c;s=void 0,r.push(0)},onArrayEnd:(f,E)=>{if(o<=f)throw c;s=void 0,r.pop()},onLiteralValue:(f,E,w)=>{if(o<E||(t(f,E,w,p(f)),o<=E+w))throw c},onSeparator:(f,E,w)=>{if(o<=E)throw c;if(f===":"&&s&&s.type==="property")s.colonOffset=E,n=!1,s=void 0;else if(f===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(n=!0,r[r.length-1]=""),s=void 0}}})}catch(f){if(f!==c)throw f}return{path:r,previousNode:s,isAtPropertyKey:n,matches:f=>{let E=0;for(let w=0;E<f.length&&w<r.length;w++)if(f[E]===r[w]||f[E]==="*")E++;else if(f[E]!=="**")return!1;return E===f.length}}}e.getLocation=T;function v(i,o=[],r=R.DEFAULT){let c=null,s=[];const m=[];function n(f){Array.isArray(s)?s.push(f):c!==null&&(s[c]=f)}return b(i,{onObjectBegin:()=>{const f={};n(f),m.push(s),s=f,c=null},onObjectProperty:f=>{c=f},onObjectEnd:()=>{s=m.pop()},onArrayBegin:()=>{const f=[];n(f),m.push(s),s=f,c=null},onArrayEnd:()=>{s=m.pop()},onLiteralValue:n,onError:(f,E,w)=>{o.push({error:f,offset:E,length:w})}},r),s[0]}e.parse=v;function I(i,o=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(f){c.type==="property"&&(c.length=f-c.offset,c=c.parent)}function m(f){return c.children.push(f),f}b(i,{onObjectBegin:f=>{c=m({type:"object",offset:f,length:-1,parent:c,children:[]})},onObjectProperty:(f,E,w)=>{c=m({type:"property",offset:E,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:f,offset:E,length:w,parent:c})},onObjectEnd:(f,E)=>{c.length=f+E-c.offset,c=c.parent,s(f+E)},onArrayBegin:(f,E)=>{c=m({type:"array",offset:f,length:-1,parent:c,children:[]})},onArrayEnd:(f,E)=>{c.length=f+E-c.offset,c=c.parent,s(f+E)},onLiteralValue:(f,E,w)=>{m({type:p(f),offset:E,length:w,parent:c,value:f}),s(E+w)},onSeparator:(f,E,w)=>{c.type==="property"&&(f===":"?c.colonOffset=E:f===","&&s(E))},onError:(f,E,w)=>{o.push({error:f,offset:E,length:w})}},r);const t=c.children[0];return t&&delete t.parent,t}e.parseTree=I;function y(i,o){if(!i)return;let r=i;for(const c of o)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===c){r=m.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=y;function h(i){if(!i.parent||!i.parent.children)return[];const o=h(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.getNodePath=h;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const o=Object.create(null);for(const r of i.children){const c=r.children[1];c&&(o[r.children[0].value]=d(c))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function u(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.contains=u;function g(i,o,r=!1){if(u(i,o,r)){const c=i.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=o;s++){const m=g(c[s],o,r);if(m)return m}return i}}e.findNodeAtOffset=g;function b(i,o,r=R.DEFAULT){const c=C(i,!1);function s(ge){return ge?()=>ge(c.getTokenOffset(),c.getTokenLength()):()=>!0}function m(ge){return ge?X=>ge(X,c.getTokenOffset(),c.getTokenLength()):()=>!0}const n=s(o.onObjectBegin),t=m(o.onObjectProperty),f=s(o.onObjectEnd),E=s(o.onArrayBegin),w=s(o.onArrayEnd),O=m(o.onLiteralValue),V=m(o.onSeparator),j=s(o.onComment),F=m(o.onError),B=r&&r.disallowComments,N=r&&r.allowTrailingComma;function U(){for(;;){const ge=c.scan();switch(c.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:B||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ge){case 12:case 13:B?$(10):j();break;case 16:$(1);break;case 15:case 14:break;default:return ge}}}function $(ge,X=[],Y=[]){if(F(ge),X.length+Y.length>0){let Z=c.getToken();for(;Z!==17;){if(X.indexOf(Z)!==-1){U();break}else if(Y.indexOf(Z)!==-1)break;Z=U()}}}function z(ge){const X=c.getTokenValue();return ge?O(X):t(X),U(),!0}function ae(){switch(c.getToken()){case 11:{let ge=0;try{ge=JSON.parse(c.getTokenValue()),typeof ge!="number"&&($(2),ge=0)}catch{$(2)}O(ge);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function ee(){return c.getToken()!==10?($(3,[],[2,5]),!1):(z(!1),c.getToken()===6?(V(":"),U(),ie()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function q(){n(),U();let ge=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(ge||$(4,[],[]),V(","),U(),c.getToken()===2&&N)break}else ge&&$(6,[],[]);ee()||$(4,[],[2,5]),ge=!0}return f(),c.getToken()!==2?$(7,[2],[]):U(),!0}function J(){E(),U();let ge=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(ge||$(4,[],[]),V(","),U(),c.getToken()===4&&N)break}else ge&&$(6,[],[]);ie()||$(4,[],[4,5]),ge=!0}return w(),c.getToken()!==4?$(8,[4],[]):U(),!0}function ie(){switch(c.getToken()){case 3:return J();case 1:return q();case 10:return z(!0);default:return ae()}}return U(),c.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):ie()?(c.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=b;function D(i,o){const r=C(i),c=[];let s,m=0,n;do switch(n=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:m!==n&&c.push(i.substring(m,n)),o!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,o)),m=r.getPosition();break}while(s!==17);return c.join("")}e.stripComments=D;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(De[65],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=a}),define(De[6],Ce([1,0,63,64]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let R=null;function C(m){R=m}if(e.setDisposableTracker=C,l){const m="__is_disposable_tracked__";C(new class{trackDisposable(n){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[m]||console.log(t)},3e3)}setParent(n,t){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsDisposed(n){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsSingleton(n){}})}function P(m){return R?.trackDisposable(m),m}function S(m){R?.markAsDisposed(m)}function k(m,n){R?.setParent(m,n)}function L(m,n){if(!!R)for(const t of m)R.setParent(t,n)}function T(m){return R?.markAsSingleton(m),m}e.markAsSingleton=T;function v(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=v;function I(m){if(A.Iterable.is(m)){const n=[];for(const t of m)if(t)try{t.dispose()}catch(f){n.push(f)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=I;function y(m){for(const n of m)v(n)&&n.dispose();return[]}e.disposeIfDisposable=y;function h(...m){const n=d(()=>I(m));return L(m,n),n}e.combinedDisposable=h;function d(m){const n=P({dispose:(0,a.once)(()=>{S(n),m()})});return n}e.toDisposable=d;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{I(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return k(n,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class g{constructor(){this.q=new u,P(this),k(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class b{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&k(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&k(n,null),n}}e.MutableDisposable=b;class D{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=D;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(n){let t=n;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,S(this))},this}}e.SafeDisposable=p;class i{constructor(){this.a=new Map}acquire(n,...t){let f=this.a.get(n);f||(f={counter:0,object:this.b(n,...t)},this.a.set(n,f));const{object:E}=f,w=(0,a.once)(()=>{--f.counter===0&&(this.c(n,f.object),this.a.delete(n))});return f.counter++,{object:E,dispose:w}}}e.ReferenceCollection=i;class o{constructor(n){this.a=n}async acquire(n,...t){const f=this.a.acquire(n,...t);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(E){throw f.dispose(),E}}}e.AsyncReferenceCollection=o;class r{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=r;function c(m){const n=new u;try{m(n)}finally{n.dispose()}}e.disposeOnReturn=c;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{I(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,t,f=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),f||this.a.get(n)?.dispose(),this.a.set(n,t)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(De[66],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(R){this.element=R,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class A{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let R=this.a;for(;R!==a.Undefined;){const C=R.next;R.prev=a.Undefined,R.next=a.Undefined,R=C}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const P=new a(R);if(this.a===a.Undefined)this.a=P,this.b=P;else if(C){const k=this.b;this.b=P,P.prev=k,k.next=P}else{const k=this.a;this.a=P,P.next=k,k.prev=P}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(P))}}shift(){if(this.a!==a.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==a.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==a.Undefined&&R.next!==a.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===a.Undefined&&R.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):R.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):R.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==a.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(De[28],Ce([1,0]),function(ne,e){"use strict";var a,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(y,h,d){let u=y.get(h);return u===void 0&&(u=d,y.set(h,u)),u}e.getOrSet=R;function C(y){const h=[];return y.forEach((d,u)=>{h.push(`${u} => ${d}`)}),`Map(${y.size}) {${h.join(", ")}}`}e.mapToString=C;function P(y){const h=[];return y.forEach(d=>{h.push(d)}),`Set(${y.size}) {${h.join(", ")}}`}e.setToString=P;class S{constructor(h,d){this.uri=h,this.value=d}}class k{constructor(h,d){this[a]="ResourceMap",h instanceof k?(this.b=new Map(h.b),this.c=d??k.a):(this.b=new Map,this.c=h??k.a)}set(h,d){return this.b.set(this.c(h),new S(h,d)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,d){typeof d<"u"&&(h=h.bind(d));for(const[u,g]of this.b)h(g.value,g.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}k.a=y=>y.toString(),e.ResourceMap=k;class L{constructor(h,d){this[A]="ResourceSet",!h||typeof h=="function"?this.a=new k(h):(this.a=new k(d),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,d){this.a.forEach((u,g)=>h.call(d,g,g,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var T;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class v{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,d=0){const u=this.a.get(h);if(!!u)return d!==0&&this.j(u,d),u.value}set(h,d,u=0){let g=this.a.get(h);if(g)g.value=d,u!==0&&this.j(g,u);else{switch(g={key:h,value:d,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(h,g),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const d=this.a.get(h);if(!!d)return this.a.delete(h),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,d){const u=this.e;let g=this.b;for(;g;){if(d?h.bind(d)(g.value,g.key,this):h(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const h=this,d=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.key,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}values(){const h=this,d=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.value,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}entries(){const h=this,d=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:[u.key,u.value],done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let d=this.b,u=this.size;for(;d&&u>h;)this.a.delete(d.key),d=d.next,u--;this.b=d,this.d=u,d&&(d.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const d=h.next,u=h.previous;if(!d||!u)throw new Error("Invalid list");d.previous=u,u.next=d}h.next=void 0,h.previous=void 0,this.e++}j(h,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(h===this.b)return;const u=h.next,g=h.previous;h===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(d===2){if(h===this.c)return;const u=h.next,g=h.previous;h===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((d,u)=>{h.push([u,d])}),h}fromJSON(h){this.clear();for(const[d,u]of h)this.set(d,u)}}e.LinkedMap=v;class I extends v{constructor(h,d=1){super(),this.k=h,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,d=2){return super.get(h,d)}peek(h){return super.get(h,0)}set(h,d){return super.set(h,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=I}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[147],Ce([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(oe,le){for(var ue=0;ue<le.length;ue++){var te=le[ue];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(oe,te.key,te)}}function a(oe,le,ue){return le&&e(oe.prototype,le),ue&&e(oe,ue),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function A(oe,le){if(!!oe){if(typeof oe=="string")return l(oe,le);var ue=Object.prototype.toString.call(oe).slice(8,-1);if(ue==="Object"&&oe.constructor&&(ue=oe.constructor.name),ue==="Map"||ue==="Set")return Array.from(oe);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return l(oe,le)}}function l(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var ue=0,te=new Array(le);ue<le;ue++)te[ue]=oe[ue];return te}function R(oe,le){var ue=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(ue)return(ue=ue.call(oe)).next.bind(ue);if(Array.isArray(oe)||(ue=A(oe))||le&&oe&&typeof oe.length=="number"){ue&&(oe=ue);var te=0;return function(){return te>=oe.length?{done:!0}:{done:!1,value:oe[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=C();function P(oe){ne.defaults=oe}var S=/[&<>"']/,k=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(le){return v[le]};function y(oe,le){if(le){if(S.test(oe))return oe.replace(k,I)}else if(L.test(oe))return oe.replace(T,I);return oe}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(oe){return oe.replace(h,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var u=/(^|[^\[])\^/g;function g(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var ue={replace:function(ce,se){return se=se.source||se,se=se.replace(u,"$1"),oe=oe.replace(ce,se),ue},getRegex:function(){return new RegExp(oe,le)}};return ue}var b=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(oe,le,ue){if(oe){var te;try{te=decodeURIComponent(d(ue)).replace(b,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}le&&!D.test(ue)&&(ue=s(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},o=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(oe,le){i[" "+oe]||(o.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=f(oe,"/",!0)),oe=i[" "+oe];var ue=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:oe.replace(r,"$1")+le:le.charAt(0)==="/"?ue?le:oe.replace(c,"$1")+le:oe+le}var m={exec:function(){}};function n(oe){for(var le=1,ue,te;le<arguments.length;le++){ue=arguments[le];for(te in ue)Object.prototype.hasOwnProperty.call(ue,te)&&(oe[te]=ue[te])}return oe}function t(oe,le){var ue=oe.replace(/\|/g,function(se,M,W){for(var G=!1,_=M;--_>=0&&W[_]==="\\";)G=!G;return G?"|":" |"}),te=ue.split(/ \|/),ce=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>le)te.splice(le);else for(;te.length<le;)te.push("");for(;ce<te.length;ce++)te[ce]=te[ce].trim().replace(/\\\|/g,"|");return te}function f(oe,le,ue){var te=oe.length;if(te===0)return"";for(var ce=0;ce<te;){var se=oe.charAt(te-ce-1);if(se===le&&!ue)ce++;else if(se!==le&&ue)ce++;else break}return oe.slice(0,te-ce)}function E(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var ue=oe.length,te=0,ce=0;ce<ue;ce++)if(oe[ce]==="\\")ce++;else if(oe[ce]===le[0])te++;else if(oe[ce]===le[1]&&(te--,te<0))return ce;return-1}function w(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(oe,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=oe),le>>=1,oe+=oe;return ue+oe}function V(oe,le,ue,te){var ce=le.href,se=le.title?y(le.title):null,M=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){te.state.inLink=!0;var W={type:"link",raw:ue,href:ce,title:se,text:M,tokens:te.inlineTokens(M)};return te.state.inLink=!1,W}return{type:"image",raw:ue,href:ce,title:se,text:y(M)}}function j(oe,le){var ue=oe.match(/^(\s+)(?:```)/);if(ue===null)return le;var te=ue[1];return le.split(`
`).map(function(ce){var se=ce.match(/^\s+/);if(se===null)return ce;var M=se[0];return M.length>=te.length?ce.slice(te.length):ce}).join(`
`)}var F=function(){function oe(ue){this.options=ue||ne.defaults}var le=oe.prototype;return le.space=function(te){var ce=this.rules.block.newline.exec(te);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},le.code=function(te){var ce=this.rules.block.code.exec(te);if(ce){var se=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?se:f(se,`
`)}}},le.fences=function(te){var ce=this.rules.block.fences.exec(te);if(ce){var se=ce[0],M=j(se,ce[3]||"");return{type:"code",raw:se,lang:ce[2]?ce[2].trim():ce[2],text:M}}},le.heading=function(te){var ce=this.rules.block.heading.exec(te);if(ce){var se=ce[2].trim();if(/#$/.test(se)){var M=f(se,"#");(this.options.pedantic||!M||/ $/.test(M))&&(se=M.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:se,tokens:this.lexer.inline(se)}}},le.hr=function(te){var ce=this.rules.block.hr.exec(te);if(ce)return{type:"hr",raw:ce[0]}},le.blockquote=function(te){var ce=this.rules.block.blockquote.exec(te);if(ce){var se=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},le.list=function(te){var ce=this.rules.block.list.exec(te);if(ce){var se,M,W,G,_,de,we,Ae,be,Ie,Te,Ve,Ge=ce[1].trim(),nt=Ge.length>1,Qe={type:"list",raw:"",ordered:nt,start:nt?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=nt?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=nt?Ge:"[*+-]");for(var it=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&(Ve=!1,!(!(ce=it.exec(te))||this.rules.block.hr.test(te)));){if(se=ce[0],te=te.substring(se.length),Ae=ce[2].split(`
`,1)[0],be=te.split(`
`,1)[0],this.options.pedantic?(G=2,Te=Ae.trimLeft()):(G=ce[2].search(/[^ ]/),G=G>4?1:G,Te=Ae.slice(G),G+=ce[1].length),de=!1,!Ae&&/^ *$/.test(be)&&(se+=be+`
`,te=te.substring(be.length+1),Ve=!0),!Ve)for(var rt=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");te&&(Ie=te.split(`
`,1)[0],Ae=Ie,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Ae)||Ee.test(Ae)||rt.test(Ae)||ct.test(te)));){if(Ae.search(/[^ ]/)>=G||!Ae.trim())Te+=`
`+Ae.slice(G);else if(!de)Te+=`
`+Ae;else break;!de&&!Ae.trim()&&(de=!0),se+=Ie+`
`,te=te.substring(Ie.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(se)&&(we=!0)),this.options.gfm&&(M=/^\[[ xX]\] /.exec(Te),M&&(W=M[0]!=="[ ] ",Te=Te.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:se,task:!!M,checked:W,loose:!1,text:Te}),Qe.raw+=se}Qe.items[Qe.items.length-1].raw=se.trimRight(),Qe.items[Qe.items.length-1].text=Te.trimRight(),Qe.raw=Qe.raw.trimRight();var K=Qe.items.length;for(_=0;_<K;_++){this.lexer.state.top=!1,Qe.items[_].tokens=this.lexer.blockTokens(Qe.items[_].text,[]);var Q=Qe.items[_].tokens.filter(function(Le){return Le.type==="space"}),pe=Q.every(function(Le){for(var $e=Le.raw.split(""),je=0,Ye=R($e),et;!(et=Ye()).done;){var ot=et.value;if(ot===`
`&&(je+=1),je>1)return!0}return!1});!Qe.loose&&Q.length&&pe&&(Qe.loose=!0,Qe.items[_].loose=!0)}return Qe}},le.html=function(te){var ce=this.rules.block.html.exec(te);if(ce){var se={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var M=this.options.sanitizer?this.options.sanitizer(ce[0]):y(ce[0]);se.type="paragraph",se.text=M,se.tokens=this.lexer.inline(M)}return se}},le.def=function(te){var ce=this.rules.block.def.exec(te);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var se=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:ce[0],href:ce[2],title:ce[3]}}},le.table=function(te){var ce=this.rules.block.table.exec(te);if(ce){var se={type:"table",header:t(ce[1]).map(function(we){return{text:we}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=ce[0];var M=se.align.length,W,G,_,de;for(W=0;W<M;W++)/^ *-+: *$/.test(se.align[W])?se.align[W]="right":/^ *:-+: *$/.test(se.align[W])?se.align[W]="center":/^ *:-+ *$/.test(se.align[W])?se.align[W]="left":se.align[W]=null;for(M=se.rows.length,W=0;W<M;W++)se.rows[W]=t(se.rows[W],se.header.length).map(function(we){return{text:we}});for(M=se.header.length,G=0;G<M;G++)se.header[G].tokens=this.lexer.inline(se.header[G].text);for(M=se.rows.length,G=0;G<M;G++)for(de=se.rows[G],_=0;_<de.length;_++)de[_].tokens=this.lexer.inline(de[_].text);return se}}},le.lheading=function(te){var ce=this.rules.block.lheading.exec(te);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},le.paragraph=function(te){var ce=this.rules.block.paragraph.exec(te);if(ce){var se=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:se,tokens:this.lexer.inline(se)}}},le.text=function(te){var ce=this.rules.block.text.exec(te);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},le.escape=function(te){var ce=this.rules.inline.escape.exec(te);if(ce)return{type:"escape",raw:ce[0],text:y(ce[1])}},le.tag=function(te){var ce=this.rules.inline.tag.exec(te);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):y(ce[0]):ce[0]}},le.link=function(te){var ce=this.rules.inline.link.exec(te);if(ce){var se=ce[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var M=f(se.slice(0,-1),"\\");if((se.length-M.length)%2===0)return}else{var W=E(ce[2],"()");if(W>-1){var G=ce[0].indexOf("!")===0?5:4,_=G+ce[1].length+W;ce[2]=ce[2].substring(0,W),ce[0]=ce[0].substring(0,_).trim(),ce[3]=""}}var de=ce[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Ae&&(de=Ae[1],we=Ae[3])}else we=ce[3]?ce[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(se)?de=de.slice(1):de=de.slice(1,-1)),V(ce,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},le.reflink=function(te,ce){var se;if((se=this.rules.inline.reflink.exec(te))||(se=this.rules.inline.nolink.exec(te))){var M=(se[2]||se[1]).replace(/\s+/g," ");if(M=ce[M.toLowerCase()],!M||!M.href){var W=se[0].charAt(0);return{type:"text",raw:W,text:W}}return V(se,M,se[0],this.lexer)}},le.emStrong=function(te,ce,se){se===void 0&&(se="");var M=this.rules.inline.emStrong.lDelim.exec(te);if(!!M&&!(M[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=M[1]||M[2]||"";if(!W||W&&(se===""||this.rules.inline.punctuation.exec(se))){var G=M[0].length-1,_,de,we=G,Ae=0,be=M[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,ce=ce.slice(-1*te.length+G);(M=be.exec(ce))!=null;)if(_=M[1]||M[2]||M[3]||M[4]||M[5]||M[6],!!_){if(de=_.length,M[3]||M[4]){we+=de;continue}else if((M[5]||M[6])&&G%3&&!((G+de)%3)){Ae+=de;continue}if(we-=de,!(we>0)){if(de=Math.min(de,de+we+Ae),Math.min(G,de)%2){var Ie=te.slice(1,G+M.index+de);return{type:"em",raw:te.slice(0,G+M.index+de+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var Te=te.slice(2,G+M.index+de-1);return{type:"strong",raw:te.slice(0,G+M.index+de+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}}}}},le.codespan=function(te){var ce=this.rules.inline.code.exec(te);if(ce){var se=ce[2].replace(/\n/g," "),M=/[^ ]/.test(se),W=/^ /.test(se)&&/ $/.test(se);return M&&W&&(se=se.substring(1,se.length-1)),se=y(se,!0),{type:"codespan",raw:ce[0],text:se}}},le.br=function(te){var ce=this.rules.inline.br.exec(te);if(ce)return{type:"br",raw:ce[0]}},le.del=function(te){var ce=this.rules.inline.del.exec(te);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},le.autolink=function(te,ce){var se=this.rules.inline.autolink.exec(te);if(se){var M,W;return se[2]==="@"?(M=y(this.options.mangle?ce(se[1]):se[1]),W="mailto:"+M):(M=y(se[1]),W=M),{type:"link",raw:se[0],text:M,href:W,tokens:[{type:"text",raw:M,text:M}]}}},le.url=function(te,ce){var se;if(se=this.rules.inline.url.exec(te)){var M,W;if(se[2]==="@")M=y(this.options.mangle?ce(se[0]):se[0]),W="mailto:"+M;else{var G;do G=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(G!==se[0]);M=y(se[0]),se[1]==="www."?W="http://"+M:W=M}return{type:"link",raw:se[0],text:M,href:W,tokens:[{type:"text",raw:M,text:M}]}}},le.inlineText=function(te,ce){var se=this.rules.inline.text.exec(te);if(se){var M;return this.lexer.state.inRawBlock?M=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):y(se[0]):se[0]:M=y(this.options.smartypants?ce(se[0]):se[0]),{type:"text",raw:se[0],text:M}}},oe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=n({},B),B.gfm=n({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=n({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=g(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=g(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=g(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=g(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=g(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=g(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=g(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=g(N.reflink).replace("label",N._label).replace("ref",B._label).getRegex(),N.nolink=g(N.nolink).replace("ref",B._label).getRegex(),N.reflinkSearch=g(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=n({},N),N.pedantic=n({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=n({},N.normal,{escape:g(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=g(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=n({},N.gfm,{br:g(N.br).replace("{2,}","*").getRegex(),text:g(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(oe){var le="",ue,te,ce=oe.length;for(ue=0;ue<ce;ue++)te=oe.charCodeAt(ue),Math.random()>.5&&(te="x"+te.toString(16)),le+="&#"+te+";";return le}var z=function(){function oe(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||ne.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:B.normal,inline:N.normal};this.options.pedantic?(te.block=B.pedantic,te.inline=N.pedantic):this.options.gfm&&(te.block=B.gfm,this.options.breaks?te.inline=N.breaks:te.inline=N.gfm),this.tokenizer.rules=te}oe.lex=function(te,ce){var se=new oe(ce);return se.lex(te)},oe.lexInline=function(te,ce){var se=new oe(ce);return se.inlineTokens(te)};var le=oe.prototype;return le.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},le.blockTokens=function(te,ce){var se=this;ce===void 0&&(ce=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(we,Ae,be){return Ae+"    ".repeat(be.length)});for(var M,W,G,_;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(M=we.call({lexer:se},te,ce))?(te=te.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.space(te)){te=te.substring(M.raw.length),M.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(M);continue}if(M=this.tokenizer.code(te)){te=te.substring(M.raw.length),W=ce[ce.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+M.raw,W.text+=`
`+M.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):ce.push(M);continue}if(M=this.tokenizer.fences(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.heading(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.hr(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.blockquote(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.list(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.html(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.def(te)){te=te.substring(M.raw.length),W=ce[ce.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+M.raw,W.text+=`
`+M.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[M.tag]||(this.tokens.links[M.tag]={href:M.href,title:M.title});continue}if(M=this.tokenizer.table(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.lheading(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(G=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=te.slice(1),be=void 0;se.options.extensions.startBlock.forEach(function(Ie){be=Ie.call({lexer:this},Ae),typeof be=="number"&&be>=0&&(we=Math.min(we,be))}),we<1/0&&we>=0&&(G=te.substring(0,we+1))}(),this.state.top&&(M=this.tokenizer.paragraph(G))){W=ce[ce.length-1],_&&W.type==="paragraph"?(W.raw+=`
`+M.raw,W.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ce.push(M),_=G.length!==te.length,te=te.substring(M.raw.length);continue}if(M=this.tokenizer.text(te)){te=te.substring(M.raw.length),W=ce[ce.length-1],W&&W.type==="text"?(W.raw+=`
`+M.raw,W.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ce.push(M);continue}if(te){var de="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ce},le.inline=function(te,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:te,tokens:ce}),ce},le.inlineTokens=function(te,ce){var se=this;ce===void 0&&(ce=[]);var M,W,G,_=te,de,we,Ae;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(_))!=null;)be.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(_=_.slice(0,de.index)+"["+O("a",de[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(_))!=null;)_=_.slice(0,de.index)+"["+O("a",de[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(_))!=null;)_=_.slice(0,de.index)+"++"+_.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Te){return(M=Te.call({lexer:se},te,ce))?(te=te.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.escape(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.tag(te)){te=te.substring(M.raw.length),W=ce[ce.length-1],W&&M.type==="text"&&W.type==="text"?(W.raw+=M.raw,W.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.link(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(M.raw.length),W=ce[ce.length-1],W&&M.type==="text"&&W.type==="text"?(W.raw+=M.raw,W.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.emStrong(te,_,Ae)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.codespan(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.br(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.del(te)){te=te.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.autolink(te,$)){te=te.substring(M.raw.length),ce.push(M);continue}if(!this.state.inLink&&(M=this.tokenizer.url(te,$))){te=te.substring(M.raw.length),ce.push(M);continue}if(G=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Te=1/0,Ve=te.slice(1),Ge=void 0;se.options.extensions.startInline.forEach(function(nt){Ge=nt.call({lexer:this},Ve),typeof Ge=="number"&&Ge>=0&&(Te=Math.min(Te,Ge))}),Te<1/0&&Te>=0&&(G=te.substring(0,Te+1))}(),M=this.tokenizer.inlineText(G,U)){te=te.substring(M.raw.length),M.raw.slice(-1)!=="_"&&(Ae=M.raw.slice(-1)),we=!0,W=ce[ce.length-1],W&&W.type==="text"?(W.raw+=M.raw,W.text+=M.text):ce.push(M);continue}if(te){var Ie="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ce},a(oe,null,[{key:"rules",get:function(){return{block:B,inline:N}}}]),oe}(),ae=function(){function oe(ue){this.options=ue||ne.defaults}var le=oe.prototype;return le.code=function(te,ce,se){var M=(ce||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(te,M);W!=null&&W!==te&&(se=!0,te=W)}return te=te.replace(/\n$/,"")+`
`,M?'<pre><code class="'+this.options.langPrefix+y(M,!0)+'">'+(se?te:y(te,!0))+`</code></pre>
`:"<pre><code>"+(se?te:y(te,!0))+`</code></pre>
`},le.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},le.html=function(te){return te},le.heading=function(te,ce,se,M){if(this.options.headerIds){var W=this.options.headerPrefix+M.slug(se);return"<h"+ce+' id="'+W+'">'+te+"</h"+ce+`>
`}return"<h"+ce+">"+te+"</h"+ce+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(te,ce,se){var M=ce?"ol":"ul",W=ce&&se!==1?' start="'+se+'"':"";return"<"+M+W+`>
`+te+"</"+M+`>
`},le.listitem=function(te){return"<li>"+te+`</li>
`},le.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(te){return"<p>"+te+`</p>
`},le.table=function(te,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ce+`</table>
`},le.tablerow=function(te){return`<tr>
`+te+`</tr>
`},le.tablecell=function(te,ce){var se=ce.header?"th":"td",M=ce.align?"<"+se+' align="'+ce.align+'">':"<"+se+">";return M+te+("</"+se+`>
`)},le.strong=function(te){return"<strong>"+te+"</strong>"},le.em=function(te){return"<em>"+te+"</em>"},le.codespan=function(te){return"<code>"+te+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(te){return"<del>"+te+"</del>"},le.link=function(te,ce,se){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return se;var M='<a href="'+y(te)+'"';return ce&&(M+=' title="'+ce+'"'),M+=">"+se+"</a>",M},le.image=function(te,ce,se){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return se;var M='<img src="'+te+'" alt="'+se+'"';return ce&&(M+=' title="'+ce+'"'),M+=this.options.xhtml?"/>":">",M},le.text=function(te){return te},oe}(),ee=function(){function oe(){}var le=oe.prototype;return le.strong=function(te){return te},le.em=function(te){return te},le.codespan=function(te){return te},le.del=function(te){return te},le.html=function(te){return te},le.text=function(te){return te},le.link=function(te,ce,se){return""+se},le.image=function(te,ce,se){return""+se},le.br=function(){return""},oe}(),q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(te,ce){var se=te,M=0;if(this.seen.hasOwnProperty(se)){M=this.seen[te];do M++,se=te+"-"+M;while(this.seen.hasOwnProperty(se))}return ce||(this.seen[te]=M,this.seen[se]=0),se},le.slug=function(te,ce){ce===void 0&&(ce={});var se=this.serialize(te);return this.getNextSafeSlug(se,ce.dryrun)},oe}(),J=function(){function oe(ue){this.options=ue||ne.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new q}oe.parse=function(te,ce){var se=new oe(ce);return se.parse(te)},oe.parseInline=function(te,ce){var se=new oe(ce);return se.parseInline(te)};var le=oe.prototype;return le.parse=function(te,ce){ce===void 0&&(ce=!0);var se="",M,W,G,_,de,we,Ae,be,Ie,Te,Ve,Ge,nt,Qe,it,rt,ct,Me,Ee,K=te.length;for(M=0;M<K;M++){if(Te=te[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(Ee=this.options.extensions.renderers[Te.type].call({parser:this},Te),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Te.type))){se+=Ee||"";continue}switch(Te.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(Te.tokens),Te.depth,d(this.parseInline(Te.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(Te.text,Te.lang,Te.escaped);continue}case"table":{for(be="",Ae="",_=Te.header.length,W=0;W<_;W++)Ae+=this.renderer.tablecell(this.parseInline(Te.header[W].tokens),{header:!0,align:Te.align[W]});for(be+=this.renderer.tablerow(Ae),Ie="",_=Te.rows.length,W=0;W<_;W++){for(we=Te.rows[W],Ae="",de=we.length,G=0;G<de;G++)Ae+=this.renderer.tablecell(this.parseInline(we[G].tokens),{header:!1,align:Te.align[G]});Ie+=this.renderer.tablerow(Ae)}se+=this.renderer.table(be,Ie);continue}case"blockquote":{Ie=this.parse(Te.tokens),se+=this.renderer.blockquote(Ie);continue}case"list":{for(Ve=Te.ordered,Ge=Te.start,nt=Te.loose,_=Te.items.length,Ie="",W=0;W<_;W++)it=Te.items[W],rt=it.checked,ct=it.task,Qe="",it.task&&(Me=this.renderer.checkbox(rt),nt?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Me+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Me+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Me}):Qe+=Me),Qe+=this.parse(it.tokens,nt),Ie+=this.renderer.listitem(Qe,ct,rt);se+=this.renderer.list(Ie,Ve,Ge);continue}case"html":{se+=this.renderer.html(Te.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(Te.tokens));continue}case"text":{for(Ie=Te.tokens?this.parseInline(Te.tokens):Te.text;M+1<K&&te[M+1].type==="text";)Te=te[++M],Ie+=`
`+(Te.tokens?this.parseInline(Te.tokens):Te.text);se+=ce?this.renderer.paragraph(Ie):Ie;continue}default:{var Q='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return se},le.parseInline=function(te,ce){ce=ce||this.renderer;var se="",M,W,G,_=te.length;for(M=0;M<_;M++){if(W=te[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(G=this.options.extensions.renderers[W.type].call({parser:this},W),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){se+=G||"";continue}switch(W.type){case"escape":{se+=ce.text(W.text);break}case"html":{se+=ce.html(W.text);break}case"link":{se+=ce.link(W.href,W.title,this.parseInline(W.tokens,ce));break}case"image":{se+=ce.image(W.href,W.title,W.text);break}case"strong":{se+=ce.strong(this.parseInline(W.tokens,ce));break}case"em":{se+=ce.em(this.parseInline(W.tokens,ce));break}case"codespan":{se+=ce.codespan(W.text);break}case"br":{se+=ce.br();break}case"del":{se+=ce.del(this.parseInline(W.tokens,ce));break}case"text":{se+=ce.text(W.text);break}default:{var de='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return se},oe}();function ie(oe,le,ue){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=n({},ie.defaults,le||{}),w(le),ue){var te=le.highlight,ce;try{ce=z.lex(oe,le)}catch(_){return ue(_)}var se=function(de){var we;if(!de)try{le.walkTokens&&ie.walkTokens(ce,le.walkTokens),we=J.parse(ce,le)}catch(Ae){de=Ae}return le.highlight=te,de?ue(de):ue(null,we)};if(!te||te.length<3||(delete le.highlight,!ce.length))return se();var M=0;ie.walkTokens(ce,function(_){_.type==="code"&&(M++,setTimeout(function(){te(_.text,_.lang,function(de,we){if(de)return se(de);we!=null&&we!==_.text&&(_.text=we,_.escaped=!0),M--,M===0&&se()})},0))}),M===0&&se();return}function W(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+y(_.message+"",!0)+"</pre>";throw _}try{var G=z.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(ie.walkTokens(G,le.walkTokens)).then(function(){return J.parse(G,le)}).catch(W);ie.walkTokens(G,le.walkTokens)}return J.parse(G,le)}catch(_){W(_)}}ie.options=ie.setOptions=function(oe){return n(ie.defaults,oe),P(ie.defaults),ie},ie.getDefaults=C,ie.defaults=ne.defaults,ie.use=function(){for(var oe=arguments.length,le=new Array(oe),ue=0;ue<oe;ue++)le[ue]=arguments[ue];var te=n.apply(void 0,[{}].concat(le)),ce=ie.defaults.extensions||{renderers:{},childTokens:{}},se;le.forEach(function(M){if(M.extensions&&(se=!0,M.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var _=ce.renderers?ce.renderers[G.name]:null;_?ce.renderers[G.name]=function(){for(var de=arguments.length,we=new Array(de),Ae=0;Ae<de;Ae++)we[Ae]=arguments[Ae];var be=G.renderer.apply(this,we);return be===!1&&(be=_.apply(this,we)),be}:ce.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[G.level]?ce[G.level].unshift(G.tokenizer):ce[G.level]=[G.tokenizer],G.start&&(G.level==="block"?ce.startBlock?ce.startBlock.push(G.start):ce.startBlock=[G.start]:G.level==="inline"&&(ce.startInline?ce.startInline.push(G.start):ce.startInline=[G.start]))}G.childTokens&&(ce.childTokens[G.name]=G.childTokens)})),M.renderer&&function(){var G=ie.defaults.renderer||new ae,_=function(Ae){var be=G[Ae];G[Ae]=function(){for(var Ie=arguments.length,Te=new Array(Ie),Ve=0;Ve<Ie;Ve++)Te[Ve]=arguments[Ve];var Ge=M.renderer[Ae].apply(G,Te);return Ge===!1&&(Ge=be.apply(G,Te)),Ge}};for(var de in M.renderer)_(de);te.renderer=G}(),M.tokenizer&&function(){var G=ie.defaults.tokenizer||new F,_=function(Ae){var be=G[Ae];G[Ae]=function(){for(var Ie=arguments.length,Te=new Array(Ie),Ve=0;Ve<Ie;Ve++)Te[Ve]=arguments[Ve];var Ge=M.tokenizer[Ae].apply(G,Te);return Ge===!1&&(Ge=be.apply(G,Te)),Ge}};for(var de in M.tokenizer)_(de);te.tokenizer=G}(),M.walkTokens){var W=ie.defaults.walkTokens;te.walkTokens=function(G){var _=[];return _.push(M.walkTokens.call(this,G)),W&&(_=_.concat(W.call(this,G))),_}}se&&(te.extensions=ce),ie.setOptions(te)})},ie.walkTokens=function(oe,le){for(var ue=[],te=function(){var W=se.value;switch(ue=ue.concat(le.call(ie,W)),W.type){case"table":{for(var G=R(W.header),_;!(_=G()).done;){var de=_.value;ue=ue.concat(ie.walkTokens(de.tokens,le))}for(var we=R(W.rows),Ae;!(Ae=we()).done;)for(var be=Ae.value,Ie=R(be),Te;!(Te=Ie()).done;){var Ve=Te.value;ue=ue.concat(ie.walkTokens(Ve.tokens,le))}break}case"list":{ue=ue.concat(ie.walkTokens(W.items,le));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[W.type]?ie.defaults.extensions.childTokens[W.type].forEach(function(Ge){ue=ue.concat(ie.walkTokens(W[Ge],le))}):W.tokens&&(ue=ue.concat(ie.walkTokens(W.tokens,le)))}},ce=R(oe),se;!(se=ce()).done;)te();return ue},ie.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=n({},ie.defaults,le||{}),w(le);try{var ue=z.lexInline(oe,le);return le.walkTokens&&ie.walkTokens(ue,le.walkTokens),J.parseInline(ue,le)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+y(te.message+"",!0)+"</pre>";throw te}},ie.Parser=J,ie.parser=J.parse,ie.Renderer=ae,ie.TextRenderer=ee,ie.Lexer=z,ie.lexer=z.lex,ie.Tokenizer=F,ie.Slugger=q,ie.parse=ie;var ge=ie.options,X=ie.setOptions,Y=ie.use,Z=ie.walkTokens,fe=ie.parseInline,ve=ie,ke=J.parse,Oe=z.lex;ne.Lexer=z,ne.Parser=J,ne.Renderer=ae,ne.Slugger=q,ne.TextRenderer=ee,ne.Tokenizer=F,ne.getDefaults=C,ne.lexer=Oe,ne.marked=ie,ne.options=ge,ne.parse=ve,ne.parseInline=fe,ne.parser=ke,ne.setOptions=X,ne.use=Y,ne.walkTokens=Z,Object.defineProperty(ne,"__esModule",{value:!0})}),define(De[86],Ce([1,0,28]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new a.LRUCache(1e4);function l(k){return S(k,"NFC",A)}e.normalizeNFC=l;const R=new a.LRUCache(1e4);function C(k){return S(k,"NFD",R)}e.normalizeNFD=C;const P=/[^\u0000-\u0080]/;function S(k,L,T){if(!k)return k;const v=T.get(k);if(v)return v;let I;return P.test(k)?I=k.normalize(L):I=k,T.set(k,I),I}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(L){return C(L).replace(k,"")}}()}),define(De[102],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(P,S,k){return Math.min(Math.max(P,S),k)}e.clamp=a;function A(P,S){return(S+P%S)%S}e.rot=A;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class R{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ne(l){const R=[];typeof l=="number"&&R.push("code/timeOrigin",l);function C(S){R.push(S,Date.now())}function P(){const S=[];for(let k=0;k<R.length;k+=2)S.push({name:R[k],startTime:R[k+1]});return S}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(l+C.startTime)});return R}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function a(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=a(A))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var A in a)(typeof exports=="object"?exports:ne)[A]=a[A]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function a(A){if(e[A])return e[A].exports;var l=e[A]={i:A,l:!1,exports:{}};return ne[A].call(l.exports,l,l.exports,a),l.l=!0,l.exports}return a.m=ne,a.c=e,a.d=function(A,l,R){a.o(A,l)||Object.defineProperty(A,l,{enumerable:!0,get:R})},a.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},a.t=function(A,l){if(1&l&&(A=a(A)),8&l||4&l&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(a.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&l&&typeof A!="string")for(var C in A)a.d(R,C,function(P){return A[P]}.bind(null,C));return R},a.n=function(A){var l=A&&A.__esModule?function(){return A.default}:function(){return A};return a.d(l,"a",l),l},a.o=function(A,l){return Object.prototype.hasOwnProperty.call(A,l)},a.p="",a(a.s=0)}([function(ne,e,a){(function(A){var l;e=ne.exports=Y,l=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var be=Array.prototype.slice.call(arguments,0);be.unshift("SEMVER"),console.log.apply(console,be)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],k=0,L=k++;S[L]="0|[1-9]\\d*";var T=k++;S[T]="[0-9]+";var v=k++;S[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=k++;S[I]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var y=k++;S[y]="("+S[T]+")\\.("+S[T]+")\\.("+S[T]+")";var h=k++;S[h]="(?:"+S[L]+"|"+S[v]+")";var d=k++;S[d]="(?:"+S[T]+"|"+S[v]+")";var u=k++;S[u]="(?:-("+S[h]+"(?:\\."+S[h]+")*))";var g=k++;S[g]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var b=k++;S[b]="[0-9A-Za-z-]+";var D=k++;S[D]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var p=k++,i="v?"+S[I]+S[u]+"?"+S[D]+"?";S[p]="^"+i+"$";var o="[v=\\s]*"+S[y]+S[g]+"?"+S[D]+"?",r=k++;S[r]="^"+o+"$";var c=k++;S[c]="((?:<|>)?=?)";var s=k++;S[s]=S[T]+"|x|X|\\*";var m=k++;S[m]=S[L]+"|x|X|\\*";var n=k++;S[n]="[v=\\s]*("+S[m]+")(?:\\.("+S[m]+")(?:\\.("+S[m]+")(?:"+S[u]+")?"+S[D]+"?)?)?";var t=k++;S[t]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[g]+")?"+S[D]+"?)?)?";var f=k++;S[f]="^"+S[c]+"\\s*"+S[n]+"$";var E=k++;S[E]="^"+S[c]+"\\s*"+S[t]+"$";var w=k++;S[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=k++;S[O]="(?:~>?)";var V=k++;S[V]="(\\s*)"+S[O]+"\\s+",P[V]=new RegExp(S[V],"g");var j=k++;S[j]="^"+S[O]+S[n]+"$";var F=k++;S[F]="^"+S[O]+S[t]+"$";var B=k++;S[B]="(?:\\^)";var N=k++;S[N]="(\\s*)"+S[B]+"\\s+",P[N]=new RegExp(S[N],"g");var U=k++;S[U]="^"+S[B]+S[n]+"$";var $=k++;S[$]="^"+S[B]+S[t]+"$";var z=k++;S[z]="^"+S[c]+"\\s*("+o+")$|^$";var ae=k++;S[ae]="^"+S[c]+"\\s*("+i+")$|^$";var ee=k++;S[ee]="(\\s*)"+S[c]+"\\s*("+o+"|"+S[n]+")",P[ee]=new RegExp(S[ee],"g");var q=k++;S[q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var J=k++;S[J]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var ie=k++;S[ie]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)l(ge,S[ge]),P[ge]||(P[ge]=new RegExp(S[ge]));function X(be,Ie){if(be instanceof Y)return be;if(typeof be!="string"||be.length>R||!(Ie?P[r]:P[p]).test(be))return null;try{return new Y(be,Ie)}catch{return null}}function Y(be,Ie){if(be instanceof Y){if(be.loose===Ie)return be;be=be.version}else if(typeof be!="string")throw new TypeError("Invalid Version: "+be);if(be.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Y))return new Y(be,Ie);l("SemVer",be,Ie),this.loose=Ie;var Te=be.trim().match(Ie?P[r]:P[p]);if(!Te)throw new TypeError("Invalid Version: "+be);if(this.raw=be,this.major=+Te[1],this.minor=+Te[2],this.patch=+Te[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Te[4]?this.prerelease=Te[4].split(".").map(function(Ve){if(/^[0-9]+$/.test(Ve)){var Ge=+Ve;if(Ge>=0&&Ge<C)return Ge}return Ve}):this.prerelease=[],this.build=Te[5]?Te[5].split("."):[],this.format()}e.parse=X,e.valid=function(be,Ie){var Te=X(be,Ie);return Te?Te.version:null},e.clean=function(be,Ie){var Te=X(be.trim().replace(/^[=v]+/,""),Ie);return Te?Te.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(be){return l("SemVer.compare",this.version,this.loose,be),be instanceof Y||(be=new Y(be,this.loose)),this.compareMain(be)||this.comparePre(be)},Y.prototype.compareMain=function(be){return be instanceof Y||(be=new Y(be,this.loose)),fe(this.major,be.major)||fe(this.minor,be.minor)||fe(this.patch,be.patch)},Y.prototype.comparePre=function(be){if(be instanceof Y||(be=new Y(be,this.loose)),this.prerelease.length&&!be.prerelease.length)return-1;if(!this.prerelease.length&&be.prerelease.length)return 1;if(!this.prerelease.length&&!be.prerelease.length)return 0;var Ie=0;do{var Te=this.prerelease[Ie],Ve=be.prerelease[Ie];if(l("prerelease compare",Ie,Te,Ve),Te===void 0&&Ve===void 0)return 0;if(Ve===void 0)return 1;if(Te===void 0)return-1;if(Te!==Ve)return fe(Te,Ve)}while(++Ie)},Y.prototype.inc=function(be,Ie){switch(be){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Te=this.prerelease.length;--Te>=0;)typeof this.prerelease[Te]=="number"&&(this.prerelease[Te]++,Te=-2);Te===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+be)}return this.format(),this.raw=this.version,this},e.inc=function(be,Ie,Te,Ve){typeof Te=="string"&&(Ve=Te,Te=void 0);try{return new Y(be,Te).inc(Ie,Ve).version}catch{return null}},e.diff=function(be,Ie){if(oe(be,Ie))return null;var Te=X(be),Ve=X(Ie);if(Te.prerelease.length||Ve.prerelease.length){for(var Ge in Te)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&Te[Ge]!==Ve[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in Te)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&Te[Ge]!==Ve[Ge])return Ge},e.compareIdentifiers=fe;var Z=/^[0-9]+$/;function fe(be,Ie){var Te=Z.test(be),Ve=Z.test(Ie);return Te&&Ve&&(be=+be,Ie=+Ie),Te&&!Ve?-1:Ve&&!Te?1:be<Ie?-1:be>Ie?1:0}function ve(be,Ie,Te){return new Y(be,Te).compare(new Y(Ie,Te))}function ke(be,Ie,Te){return ve(be,Ie,Te)>0}function Oe(be,Ie,Te){return ve(be,Ie,Te)<0}function oe(be,Ie,Te){return ve(be,Ie,Te)===0}function le(be,Ie,Te){return ve(be,Ie,Te)!==0}function ue(be,Ie,Te){return ve(be,Ie,Te)>=0}function te(be,Ie,Te){return ve(be,Ie,Te)<=0}function ce(be,Ie,Te,Ve){var Ge;switch(Ie){case"===":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),Ge=be===Te;break;case"!==":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),Ge=be!==Te;break;case"":case"=":case"==":Ge=oe(be,Te,Ve);break;case"!=":Ge=le(be,Te,Ve);break;case">":Ge=ke(be,Te,Ve);break;case">=":Ge=ue(be,Te,Ve);break;case"<":Ge=Oe(be,Te,Ve);break;case"<=":Ge=te(be,Te,Ve);break;default:throw new TypeError("Invalid operator: "+Ie)}return Ge}function se(be,Ie){if(be instanceof se){if(be.loose===Ie)return be;be=be.value}if(!(this instanceof se))return new se(be,Ie);l("comparator",be,Ie),this.loose=Ie,this.parse(be),this.semver===M?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(be,Ie){return fe(Ie,be)},e.major=function(be,Ie){return new Y(be,Ie).major},e.minor=function(be,Ie){return new Y(be,Ie).minor},e.patch=function(be,Ie){return new Y(be,Ie).patch},e.compare=ve,e.compareLoose=function(be,Ie){return ve(be,Ie,!0)},e.rcompare=function(be,Ie,Te){return ve(Ie,be,Te)},e.sort=function(be,Ie){return be.sort(function(Te,Ve){return e.compare(Te,Ve,Ie)})},e.rsort=function(be,Ie){return be.sort(function(Te,Ve){return e.rcompare(Te,Ve,Ie)})},e.gt=ke,e.lt=Oe,e.eq=oe,e.neq=le,e.gte=ue,e.lte=te,e.cmp=ce,e.Comparator=se;var M={};function W(be,Ie){if(be instanceof W)return be.loose===Ie?be:new W(be.raw,Ie);if(be instanceof se)return new W(be.value,Ie);if(!(this instanceof W))return new W(be,Ie);if(this.loose=Ie,this.raw=be,this.set=be.split(/\s*\|\|\s*/).map(function(Te){return this.parseRange(Te.trim())},this).filter(function(Te){return Te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+be);this.format()}function G(be){return!be||be.toLowerCase()==="x"||be==="*"}function _(be,Ie,Te,Ve,Ge,nt,Qe,it,rt,ct,Me,Ee,K){return((Ie=G(Te)?"":G(Ve)?">="+Te+".0.0":G(Ge)?">="+Te+"."+Ve+".0":">="+Ie)+" "+(it=G(rt)?"":G(ct)?"<"+(+rt+1)+".0.0":G(Me)?"<"+rt+"."+(+ct+1)+".0":Ee?"<="+rt+"."+ct+"."+Me+"-"+Ee:"<="+it)).trim()}function de(be,Ie){for(var Te=0;Te<be.length;Te++)if(!be[Te].test(Ie))return!1;if(Ie.prerelease.length){for(Te=0;Te<be.length;Te++)if(l(be[Te].semver),be[Te].semver!==M&&be[Te].semver.prerelease.length>0){var Ve=be[Te].semver;if(Ve.major===Ie.major&&Ve.minor===Ie.minor&&Ve.patch===Ie.patch)return!0}return!1}return!0}function we(be,Ie,Te){try{Ie=new W(Ie,Te)}catch{return!1}return Ie.test(be)}function Ae(be,Ie,Te,Ve){var Ge,nt,Qe,it,rt;switch(be=new Y(be,Ve),Ie=new W(Ie,Ve),Te){case">":Ge=ke,nt=te,Qe=Oe,it=">",rt=">=";break;case"<":Ge=Oe,nt=ue,Qe=ke,it="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(be,Ie,Ve))return!1;for(var ct=0;ct<Ie.set.length;++ct){var Me=Ie.set[ct],Ee=null,K=null;if(Me.forEach(function(Q){Q.semver===M&&(Q=new se(">=0.0.0")),Ee=Ee||Q,K=K||Q,Ge(Q.semver,Ee.semver,Ve)?Ee=Q:Qe(Q.semver,K.semver,Ve)&&(K=Q)}),Ee.operator===it||Ee.operator===rt||(!K.operator||K.operator===it)&&nt(be,K.semver)||K.operator===rt&&Qe(be,K.semver))return!1}return!0}se.prototype.parse=function(be){var Ie=this.loose?P[z]:P[ae],Te=be.match(Ie);if(!Te)throw new TypeError("Invalid comparator: "+be);this.operator=Te[1],this.operator==="="&&(this.operator=""),Te[2]?this.semver=new Y(Te[2],this.loose):this.semver=M},se.prototype.toString=function(){return this.value},se.prototype.test=function(be){return l("Comparator.test",be,this.loose),this.semver===M||(typeof be=="string"&&(be=new Y(be,this.loose)),ce(be,this.operator,this.semver,this.loose))},se.prototype.intersects=function(be,Ie){if(!(be instanceof se))throw new TypeError("a Comparator is required");var Te;if(this.operator==="")return Te=new W(be.value,Ie),we(this.value,Te,Ie);if(be.operator==="")return Te=new W(this.value,Ie),we(be.semver,Te,Ie);var Ve=!(this.operator!==">="&&this.operator!==">"||be.operator!==">="&&be.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||be.operator!=="<="&&be.operator!=="<"),nt=this.semver.version===be.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||be.operator!==">="&&be.operator!=="<="),it=ce(this.semver,"<",be.semver,Ie)&&(this.operator===">="||this.operator===">")&&(be.operator==="<="||be.operator==="<"),rt=ce(this.semver,">",be.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(be.operator===">="||be.operator===">");return Ve||Ge||nt&&Qe||it||rt},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(be){return be.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(be){var Ie=this.loose;be=be.trim(),l("range",be,Ie);var Te=Ie?P[J]:P[q];be=be.replace(Te,_),l("hyphen replace",be),be=be.replace(P[ee],"$1$2$3"),l("comparator trim",be,P[ee]),be=(be=(be=be.replace(P[V],"$1~")).replace(P[N],"$1^")).split(/\s+/).join(" ");var Ve=Ie?P[z]:P[ae],Ge=be.split(" ").map(function(nt){return function(Qe,it){return l("comp",Qe),Qe=function(rt,ct){return rt.trim().split(/\s+/).map(function(Me){return function(Ee,K){l("caret",Ee,K);var Q=K?P[$]:P[U];return Ee.replace(Q,function(pe,Le,$e,je,Ye){var et;return l("caret",Ee,pe,Le,$e,je,Ye),G(Le)?et="":G($e)?et=">="+Le+".0.0 <"+(+Le+1)+".0.0":G(je)?et=Le==="0"?">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+".0 <"+(+Le+1)+".0.0":Ye?(l("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),et=Le==="0"?$e==="0"?">="+Le+"."+$e+"."+je+Ye+" <"+Le+"."+$e+"."+(+je+1):">="+Le+"."+$e+"."+je+Ye+" <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+"."+je+Ye+" <"+(+Le+1)+".0.0"):(l("no pr"),et=Le==="0"?$e==="0"?">="+Le+"."+$e+"."+je+" <"+Le+"."+$e+"."+(+je+1):">="+Le+"."+$e+"."+je+" <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+"."+je+" <"+(+Le+1)+".0.0"),l("caret return",et),et})}(Me,ct)}).join(" ")}(Qe,it),l("caret",Qe),Qe=function(rt,ct){return rt.trim().split(/\s+/).map(function(Me){return function(Ee,K){var Q=K?P[F]:P[j];return Ee.replace(Q,function(pe,Le,$e,je,Ye){var et;return l("tilde",Ee,pe,Le,$e,je,Ye),G(Le)?et="":G($e)?et=">="+Le+".0.0 <"+(+Le+1)+".0.0":G(je)?et=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0":Ye?(l("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),et=">="+Le+"."+$e+"."+je+Ye+" <"+Le+"."+(+$e+1)+".0"):et=">="+Le+"."+$e+"."+je+" <"+Le+"."+(+$e+1)+".0",l("tilde return",et),et})}(Me,ct)}).join(" ")}(Qe,it),l("tildes",Qe),Qe=function(rt,ct){return l("replaceXRanges",rt,ct),rt.split(/\s+/).map(function(Me){return function(Ee,K){Ee=Ee.trim();var Q=K?P[E]:P[f];return Ee.replace(Q,function(pe,Le,$e,je,Ye,et){l("xRange",Ee,pe,Le,$e,je,Ye,et);var ot=G($e),ft=ot||G(je),bt=ft||G(Ye);return Le==="="&&bt&&(Le=""),ot?pe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&bt?(ft&&(je=0),bt&&(Ye=0),Le===">"?(Le=">=",ft?($e=+$e+1,je=0,Ye=0):bt&&(je=+je+1,Ye=0)):Le==="<="&&(Le="<",ft?$e=+$e+1:je=+je+1),pe=Le+$e+"."+je+"."+Ye):ft?pe=">="+$e+".0.0 <"+(+$e+1)+".0.0":bt&&(pe=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),l("xRange return",pe),pe})}(Me,ct)}).join(" ")}(Qe,it),l("xrange",Qe),Qe=function(rt,ct){return l("replaceStars",rt,ct),rt.trim().replace(P[ie],"")}(Qe,it),l("stars",Qe),Qe}(nt,Ie)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(nt){return!!nt.match(Ve)})),Ge=Ge.map(function(nt){return new se(nt,Ie)})},W.prototype.intersects=function(be,Ie){if(!(be instanceof W))throw new TypeError("a Range is required");return this.set.some(function(Te){return Te.every(function(Ve){return be.set.some(function(Ge){return Ge.every(function(nt){return Ve.intersects(nt,Ie)})})})})},e.toComparators=function(be,Ie){return new W(be,Ie).set.map(function(Te){return Te.map(function(Ve){return Ve.value}).join(" ").trim().split(" ")})},W.prototype.test=function(be){if(!be)return!1;typeof be=="string"&&(be=new Y(be,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if(de(this.set[Ie],be))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(be,Ie,Te){var Ve=null,Ge=null;try{var nt=new W(Ie,Te)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(Ve&&Ge.compare(Qe)!==-1||(Ge=new Y(Ve=Qe,Te)))}),Ve},e.minSatisfying=function(be,Ie,Te){var Ve=null,Ge=null;try{var nt=new W(Ie,Te)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(Ve&&Ge.compare(Qe)!==1||(Ge=new Y(Ve=Qe,Te)))}),Ve},e.validRange=function(be,Ie){try{return new W(be,Ie).range||"*"}catch{return null}},e.ltr=function(be,Ie,Te){return Ae(be,Ie,"<",Te)},e.gtr=function(be,Ie,Te){return Ae(be,Ie,">",Te)},e.outside=Ae,e.prerelease=function(be,Ie){var Te=X(be,Ie);return Te&&Te.prerelease.length?Te.prerelease:null},e.intersects=function(be,Ie,Te){return be=new W(be,Te),Ie=new W(Ie,Te),be.intersects(Ie)},e.coerce=function(be){if(be instanceof Y)return be;if(typeof be!="string")return null;var Ie=be.match(P[w]);return Ie==null?null:X((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,a(1))},function(ne,e){var a,A,l=ne.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(d){if(a===setTimeout)return setTimeout(d,0);if((a===R||!a)&&setTimeout)return a=setTimeout,setTimeout(d,0);try{return a(d,0)}catch{try{return a.call(null,d,0)}catch{return a.call(this,d,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:R}catch{a=R}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var S,k=[],L=!1,T=-1;function v(){L&&S&&(L=!1,S.length?k=S.concat(k):T=-1,k.length&&I())}function I(){if(!L){var d=P(v);L=!0;for(var u=k.length;u;){for(S=k,k=[];++T<u;)S&&S[T].run();T=-1,u=k.length}S=null,L=!1,function(g){if(A===clearTimeout)return clearTimeout(g);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(g);try{A(g)}catch{try{return A.call(null,g)}catch{return A.call(this,g)}}}(d)}}function y(d,u){this.fun=d,this.array=u}function h(){}l.nextTick=function(d){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];k.push(new y(d,u)),k.length!==1||L||P(I)},y.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=h,l.addListener=h,l.once=h,l.off=h,l.removeListener=h,l.removeAllListeners=h,l.emit=h,l.prependListener=h,l.prependOnceListener=h,l.listeners=function(d){return[]},l.binding=function(d){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(d){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(De[103],Ce([1,0,12,6]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(D){const p=D;return p?typeof p.read=="function":!1}e.isReadable=l;function R(D){const p=D;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function C(D){const p=D;return p?R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(D,p){return new S(D,p)}e.newWriteableStream=P;class S{constructor(p,i){this.e=p,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(i=>i(p))}h(p){this.c.error.length===0?(0,a.onUnexpectedError)(p):this.c.error.slice(0).forEach(i=>i(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,i){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(p,i){if(this.a.destroyed)return;let o;switch(p){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(D,p){const i=[];let o;for(;(o=D.read())!==null;)i.push(o);return p(i)}e.consumeReadable=k;function L(D,p,i){const o=[];let r;for(;(r=D.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?p(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return D.read()}}}e.peekReadable=L;function T(D,p){return new Promise((i,o)=>{const r=[];v(D,{onData:c=>{p&&r.push(c)},onError:c=>{p?o(c):i(void 0)},onEnd:()=>{i(p?p(r):void 0)}})})}e.consumeStream=T;function v(D,p){let i=!1;return D.on("error",o=>{i||p.onError(o)}),D.on("end",()=>{i||p.onEnd()}),D.on("data",o=>{i||p.onData(o)}),(0,A.toDisposable)(()=>i=!0)}e.listenStream=v;function I(D,p){return new Promise((i,o)=>{const r=new A.DisposableStore,c=[],s=t=>{if(c.push(t),c.length>p)return r.dispose(),D.pause(),i({stream:D,buffer:c,ended:!1})},m=t=>o(t),n=()=>i({stream:D,buffer:c,ended:!0});r.add((0,A.toDisposable)(()=>D.removeListener("error",m))),D.on("error",m),r.add((0,A.toDisposable)(()=>D.removeListener("end",n))),D.on("end",n),r.add((0,A.toDisposable)(()=>D.removeListener("data",s))),D.on("data",s)})}e.peekStream=I;function y(D,p){const i=P(p);return i.end(D),i}e.toStream=y;function h(){const D=P(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=h;function d(D){let p=!1;return{read:()=>p?null:(p=!0,D)}}e.toReadable=d;function u(D,p,i){const o=P(i);return v(D,{onData:r=>o.write(p.data(r)),onError:r=>o.error(p.error?p.error(r):r),onEnd:()=>o.end()}),o}e.transform=u;function g(D,p,i){let o=!1;return{read:()=>{const r=p.read();return o?r:(o=!0,r!==null?i([D,r]):D)}}}e.prefixedReadable=g;function b(D,p,i){let o=!1;const r=P(i);return v(p,{onData:c=>o?r.write(c):(o=!0,r.write(i([D,c]))),onError:c=>r.error(c),onEnd:()=>{o||(o=!0,r.write(D)),r.end()}}),r}e.prefixedStream=b}),define(De[22],Ce([1,0,103]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let l,R;class C{static alloc(t){return A?new C(Buffer.allocUnsafe(t)):new C(new Uint8Array(t))}static wrap(t){return A&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new C(t)}static fromString(t,f){return!(f?.dontUseNodeBuffer||!1)&&A?new C(Buffer.from(t)):(l||(l=new TextEncoder),new C(l.encode(t)))}static fromByteArray(t){const f=C.alloc(t.length);for(let E=0,w=t.length;E<w;E++)f.buffer[E]=t[E];return f}static concat(t,f){if(typeof f>"u"){f=0;for(let O=0,V=t.length;O<V;O++)f+=t[O].byteLength}const E=C.alloc(f);let w=0;for(let O=0,V=t.length;O<V;O++){const j=t[O];E.set(j,w),w+=j.byteLength}return E}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=C.alloc(this.byteLength);return t.set(this),t}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,f){return new C(this.buffer.subarray(t,f))}set(t,f){if(t instanceof C)this.buffer.set(t.buffer,f);else if(t instanceof Uint8Array)this.buffer.set(t,f);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),f);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return k(this.buffer,t)}writeUInt32BE(t,f){L(this.buffer,t,f)}readUInt32LE(t){return T(this.buffer,t)}writeUInt32LE(t,f){v(this.buffer,t,f)}readUInt8(t){return I(this.buffer,t)}writeUInt8(t,f){y(this.buffer,t,f)}}e.VSBuffer=C;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function S(n,t,f){n[f+0]=t&255,t=t>>>8,n[f+1]=t&255}e.writeUInt16LE=S;function k(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=k;function L(n,t,f){n[f+3]=t,t=t>>>8,n[f+2]=t,t=t>>>8,n[f+1]=t,t=t>>>8,n[f]=t}e.writeUInt32BE=L;function T(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=T;function v(n,t,f){n[f+0]=t&255,t=t>>>8,n[f+1]=t&255,t=t>>>8,n[f+2]=t&255,t=t>>>8,n[f+3]=t&255}e.writeUInt32LE=v;function I(n,t){return n[t]}e.readUInt8=I;function y(n,t,f){n[f]=t}e.writeUInt8=y;function h(n){return a.consumeReadable(n,t=>C.concat(t))}e.readableToBuffer=h;function d(n){return a.toReadable(n)}e.bufferToReadable=d;function u(n){return a.consumeStream(n,t=>C.concat(t))}e.streamToBuffer=u;async function g(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await u(n.stream)])}e.bufferedStreamToBuffer=g;function b(n){return a.toStream(n,t=>C.concat(t))}e.bufferToStream=b;function D(n){return a.transform(n,{data:t=>typeof t=="string"?C.fromString(t):C.wrap(t)},t=>C.concat(t))}e.streamToBufferReadableStream=D;function p(n){return a.newWriteableStream(t=>C.concat(t),n)}e.newWriteableBufferStream=p;function i(n,t){return a.prefixedReadable(n,t,f=>C.concat(f))}e.prefixedBufferReadable=i;function o(n,t){return a.prefixedStream(n,t,f=>C.concat(f))}e.prefixedBufferStream=o;function r(n){let t=0,f=0,E=0;const w=new Uint8Array(Math.floor(n.length/4*3)),O=j=>{switch(f){case 3:w[E++]=t|j,f=0;break;case 2:w[E++]=t|j>>>2,t=j<<6,f=3;break;case 1:w[E++]=t|j>>>4,t=j<<4,f=2;break;default:t=j<<2,f=1}};for(let j=0;j<n.length;j++){const F=n.charCodeAt(j);if(F>=65&&F<=90)O(F-65);else if(F>=97&&F<=122)O(F-97+26);else if(F>=48&&F<=57)O(F-48+52);else if(F===43||F===45)O(62);else if(F===47||F===95)O(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${n[j]}`)}}const V=E;for(;f>0;)O(0);return C.wrap(w).slice(0,V)}e.decodeBase64=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:n},t=!0,f=!1){const E=f?s:c;let w="";const O=n.byteLength%3;let V=0;for(;V<n.byteLength-O;V+=3){const j=n[V+0],F=n[V+1],B=n[V+2];w+=E[j>>>2],w+=E[(j<<4|F>>>4)&63],w+=E[(F<<2|B>>>6)&63],w+=E[B&63]}if(O===1){const j=n[V+0];w+=E[j>>>2],w+=E[j<<4&63],t&&(w+="==")}else if(O===2){const j=n[V+0],F=n[V+1];w+=E[j>>>2],w+=E[(j<<4|F>>>4)&63],w+=E[F<<2&63],t&&(w+="=")}return w}e.encodeBase64=m}),define(De[148],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[9],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(o){return typeof o=="string"}e.isString=a;function A(o){return Array.isArray(o)&&o.every(r=>a(r))}e.isStringArray=A;function l(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=l;function R(o){const r=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof r}e.isTypedArray=R;function C(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=C;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function S(o){return o===!0||o===!1}e.isBoolean=S;function k(o){return typeof o>"u"}e.isUndefined=k;function L(o){return!T(o)}e.isDefined=L;function T(o){return k(o)||o===null}e.isUndefinedOrNull=T;function v(o,r){if(!o)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=v;function I(o){if(T(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=I;function y(...o){const r=[];for(let c=0;c<o.length;c++){const s=o[c];if(T(s))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);r.push(s)}return r}e.assertAllDefined=y;const h=Object.prototype.hasOwnProperty;function d(o){if(!l(o))return!1;for(const r in o)if(h.call(o,r))return!1;return!0}e.isEmptyObject=d;function u(o){return typeof o=="function"}e.isFunction=u;function g(...o){return o.length>0&&o.every(u)}e.areFunctions=g;function b(o,r){const c=Math.min(o.length,r.length);for(let s=0;s<c;s++)D(o[s],r[s])}e.validateConstraints=b;function D(o,r){if(a(r)){if(typeof o!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(u(r)){try{if(o instanceof r)return}catch{}if(!T(o)&&o.constructor===r||r.length===1&&r.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function p(o){return o===null?void 0:o}e.withNullAsUndefined=p;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(De[67],Ce([1,0,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function l(P,S){if((0,a.isString)(S)){const k=A[S];if(k===void 0)throw new Error(`${P} references an unknown codicon: ${S}`);S=k}return A[P]=S,{id:P}}function R(){return A}e.getCodiconFontCharacters=R;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([b,D])=>{g[b]=D&&typeof D=="object"?A(D):D}),g}e.deepClone=A;function l(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const b=g.shift();Object.freeze(b);for(const D in b)if(R.call(b,D)){const p=b[D];typeof p=="object"&&!Object.isFrozen(p)&&!(0,a.isTypedArray)(p)&&g.push(p)}}return u}e.deepFreeze=l;const R=Object.prototype.hasOwnProperty;function C(u,g){return P(u,g,new Set)}e.cloneAndChange=C;function P(u,g,b){if((0,a.isUndefinedOrNull)(u))return u;const D=g(u);if(typeof D<"u")return D;if(Array.isArray(u)){const p=[];for(const i of u)p.push(P(i,g,b));return p}if((0,a.isObject)(u)){if(b.has(u))throw new Error("Cannot clone recursive data-structure");b.add(u);const p={};for(const i in u)R.call(u,i)&&(p[i]=P(u[i],g,b));return b.delete(u),p}return u}function S(u,g,b=!0){return(0,a.isObject)(u)?((0,a.isObject)(g)&&Object.keys(g).forEach(D=>{D in u?b&&((0,a.isObject)(u[D])&&(0,a.isObject)(g[D])?S(u[D],g[D],b):u[D]=g[D]):u[D]=g[D]}),u):g}e.mixin=S;function k(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let b,D;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(b=0;b<u.length;b++)if(!k(u[b],g[b]))return!1}else{const p=[];for(D in u)p.push(D);p.sort();const i=[];for(D in g)i.push(D);if(i.sort(),!k(p,i))return!1;for(b=0;b<p.length;b++)if(!k(u[p[b]],g[p[b]]))return!1}return!0}e.equals=k;function L(u){const g=new Set;return JSON.stringify(u,(b,D)=>{if((0,a.isObject)(D)||Array.isArray(D)){if(g.has(D))return"[Circular]";g.add(D)}return D})}e.safeStringify=L;function T(u,g){const b=Object.create(null);return!u||!g||Object.keys(g).forEach(p=>{const i=u[p],o=g[p];k(i,o)||(b[p]=o)}),b}e.distinct=T;function v(u,g){const b=g.toLowerCase(),D=Object.keys(u).find(p=>p.toLowerCase()===b);return D?u[D]:u[g]}e.getCaseInsensitive=v;function I(u,g){const b=Object.create(null);for(const[D,p]of Object.entries(u))g(D,p)&&(b[D]=p);return b}e.filter=I;function y(u){let g=[],b=Object.getPrototypeOf(u);for(;Object.prototype!==b;)g=g.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return g}e.getAllPropertyNames=y;function h(u){const g=[];for(const b of y(u))typeof u[b]=="function"&&g.push(b);return g}e.getAllMethodNames=h;function d(u,g){const b=p=>function(){const i=Array.prototype.slice.call(arguments,0);return g(p,i)},D={};for(const p of u)D[p]=b(p);return D}e.createProxyObject=d}),define(De[51],Ce([1,0,67]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(C){function P(S){return S&&typeof S=="object"&&typeof S.id=="string"}C.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function l(C){return{id:C}}e.themeColorFromId=l;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(g){const b=P.exec(g.id);if(!b)return S(a.Codicon.error);const[,D,p]=b,i=["codicon","codicon-"+D];return p&&i.push("codicon-modifier-"+p.substring(1)),i}C.asClassNameArray=S;function k(g){return S(g).join(" ")}C.asClassName=k;function L(g){return"."+S(g).join(".")}C.asCSSSelector=L;function T(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||A.isThemeColor(g.color))}C.isThemeIcon=T;const v=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function I(g){const b=v.exec(g);if(!b)return;const[,D]=b;return{id:D}}C.fromString=I;function y(g){return{id:g}}C.fromId=y;function h(g,b){let D=g.id;const p=D.lastIndexOf("~");return p!==-1&&(D=D.substring(0,p)),b&&(D=`${D}~${b}`),{id:D}}C.modify=h;function d(g){const b=g.id.lastIndexOf("~");if(b!==-1)return g.id.substring(b+1)}C.getModifier=d;function u(g,b){return g.id===b.id&&g.color?.id===b.color?.id}C.isEqual=u})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(De[104],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function l(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=l}),define(De[30],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(l){return a.test(l)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){l(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,k="";return k+=C[R[S++]],k+=C[R[S++]],k+=C[R[S++]],k+=C[R[S++]],k+="-",k+=C[R[S++]],k+=C[R[S++]],k+="-",k+=C[R[S++]],k+=C[R[S++]],k+="-",k+=C[R[S++]],k+=C[R[S++]],k+="-",k+=C[R[S++]],k+=C[R[S++]],k+=C[R[S++]],k+=C[R[S++]],k+=C[R[S++]],k+=C[R[S++]],k}}()}),define(De[149],Ce([1,0,15,30]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(P){return{id:(0,A.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=l;function R(P,S,k){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=R;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const L=this.a.get(S);L?L.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const L of k)yield[S,L]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,L]of this.entries())S(L,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:P=>(0,a.distinct)(P.map(S=>S.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(S=>!S.startsWith("#"))})}),define(De[105],Ce([1,0,104]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){const S=(0,a.toUint8)(P);this.c=S,this.a=A.d(S),this.b=new Map}static d(P){const S=new Uint8Array(256);return S.fill(P),S}set(P,S){const k=(0,a.toUint8)(S);P>=0&&P<256?this.a[P]=k:this.b.set(P,k)}get(P){return P>=0&&P<256?this.a[P]:this.b.get(P)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var l;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(l||(l={}));class R{constructor(){this.a=new A(0)}add(P){this.a.set(P,1)}has(P){return this.a.get(P)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(De[52],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(l,R){this.lineNumber=l,this.column=R}with(l=this.lineNumber,R=this.column){return l===this.lineNumber&&R===this.column?this:new a(l,R)}delta(l=0,R=0){return this.with(this.lineNumber+l,this.column+R)}equals(l){return a.equals(this,l)}static equals(l,R){return!l&&!R?!0:!!l&&!!R&&l.lineNumber===R.lineNumber&&l.column===R.column}isBefore(l){return a.isBefore(this,l)}static isBefore(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<R.column}isBeforeOrEqual(l){return a.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<=R.column}static compare(l,R){const C=l.lineNumber|0,P=R.lineNumber|0;if(C===P){const S=l.column|0,k=R.column|0;return S-k}return C-P}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new a(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=a}),define(De[32],Ce([1,0,52]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,C,P,S){R>P||R===P&&C>S?(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=R,this.endColumn=C):(this.startLineNumber=R,this.startColumn=C,this.endLineNumber=P,this.endColumn=S)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,C){return!(C.lineNumber<R.startLineNumber||C.lineNumber>R.endLineNumber||C.lineNumber===R.startLineNumber&&C.column<R.startColumn||C.lineNumber===R.endLineNumber&&C.column>R.endColumn)}static strictContainsPosition(R,C){return!(C.lineNumber<R.startLineNumber||C.lineNumber>R.endLineNumber||C.lineNumber===R.startLineNumber&&C.column<=R.startColumn||C.lineNumber===R.endLineNumber&&C.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,C){return!(C.startLineNumber<R.startLineNumber||C.endLineNumber<R.startLineNumber||C.startLineNumber>R.endLineNumber||C.endLineNumber>R.endLineNumber||C.startLineNumber===R.startLineNumber&&C.startColumn<R.startColumn||C.endLineNumber===R.endLineNumber&&C.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,C){return!(C.startLineNumber<R.startLineNumber||C.endLineNumber<R.startLineNumber||C.startLineNumber>R.endLineNumber||C.endLineNumber>R.endLineNumber||C.startLineNumber===R.startLineNumber&&C.startColumn<=R.startColumn||C.endLineNumber===R.endLineNumber&&C.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,C){let P,S,k,L;return C.startLineNumber<R.startLineNumber?(P=C.startLineNumber,S=C.startColumn):C.startLineNumber===R.startLineNumber?(P=C.startLineNumber,S=Math.min(C.startColumn,R.startColumn)):(P=R.startLineNumber,S=R.startColumn),C.endLineNumber>R.endLineNumber?(k=C.endLineNumber,L=C.endColumn):C.endLineNumber===R.endLineNumber?(k=C.endLineNumber,L=Math.max(C.endColumn,R.endColumn)):(k=R.endLineNumber,L=R.endColumn),new A(P,S,k,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,C){let P=R.startLineNumber,S=R.startColumn,k=R.endLineNumber,L=R.endColumn;const T=C.startLineNumber,v=C.startColumn,I=C.endLineNumber,y=C.endColumn;return P<T?(P=T,S=v):P===T&&(S=Math.max(S,v)),k>I?(k=I,L=y):k===I&&(L=Math.min(L,y)),P>k||P===k&&S>L?null:new A(P,S,k,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,C){return!R&&!C?!0:!!R&&!!C&&R.startLineNumber===C.startLineNumber&&R.startColumn===C.startColumn&&R.endLineNumber===C.endLineNumber&&R.endColumn===C.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new a.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new a.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,C){return new A(this.startLineNumber,this.startColumn,R,C)}setStartPosition(R,C){return new A(R,C,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,C=R){return new A(R.lineNumber,R.column,C.lineNumber,C.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,C){return!(R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn||C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn)}static areIntersecting(R,C){return!(R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn||C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,C){if(R&&C){const k=R.startLineNumber|0,L=C.startLineNumber|0;if(k===L){const T=R.startColumn|0,v=C.startColumn|0;if(T===v){const I=R.endLineNumber|0,y=C.endLineNumber|0;if(I===y){const h=R.endColumn|0,d=C.endColumn|0;return h-d}return I-y}return T-v}return k-L}return(R?1:0)-(C?1:0)}static compareRangesUsingEnds(R,C){return R.endLineNumber===C.endLineNumber?R.endColumn===C.endColumn?R.startLineNumber===C.startLineNumber?R.startColumn-C.startColumn:R.startLineNumber-C.startLineNumber:R.endColumn-C.endColumn:R.endLineNumber-C.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(De[150],Ce([1,0,52,32]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(l=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(P,S,k,L){super(P,S,k,L),this.selectionStartLineNumber=P,this.selectionStartColumn=S,this.positionLineNumber=k,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return R.selectionsEqual(this,P)}static selectionsEqual(P,S){return P.selectionStartLineNumber===S.selectionStartLineNumber&&P.selectionStartColumn===S.selectionStartColumn&&P.positionLineNumber===S.positionLineNumber&&P.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,S){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,P,S):new R(P,S,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,S){return this.getDirection()===0?new R(P,S,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,P,S)}static fromPositions(P,S=P){return new R(P.lineNumber,P.column,S.lineNumber,S.column)}static fromRange(P,S){return S===0?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new R(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new R(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,S){if(P&&!S||!P&&S)return!1;if(!P&&!S)return!0;if(P.length!==S.length)return!1;for(let k=0,L=P.length;k<L;k++)if(!this.selectionsEqual(P[k],S[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,S,k,L,T){return T===0?new R(P,S,k,L):new R(k,L,P,S)}}e.Selection=R}),define(De[151],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[152],Ce([1,0,105]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class l extends a.CharacterClassifier{constructor(P){super(0);for(let S=0,k=P.length;S<k;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function R(C){const P={};return S=>(P.hasOwnProperty(S)||(P[S]=C(S)),P[S])}e.getMapForWordSeparators=R(C=>new l(C))}),define(De[106],Ce([1,0,64,6,66]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(T=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)T.indexOf(I)>=0||(v+="\\"+I);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function C(T){let v=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)v=T;else{let I="g";T.ignoreCase&&(I+="i"),T.multiline&&(I+="m"),T.unicode&&(I+="u"),v=new RegExp(T.source,I)}return v.lastIndex=0,v}e.ensureValidWordDefinition=C;const P=new l.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(T){const v=P.unshift(T);return(0,A.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=S;function k(T,v,I,y,h){if(h||(h=a.Iterable.first(P)),I.length>h.maxLen){let D=T-h.maxLen/2;return D<0?D=0:y+=D,I=I.substring(D,T+h.maxLen/2),k(T,v,I,y,h)}const d=Date.now(),u=T-1-y;let g=-1,b=null;for(let D=1;!(Date.now()-d>=h.timeBudget);D++){const p=u-h.windowSize*D;v.lastIndex=Math.max(0,p);const i=L(v,I,u,g);if(!i&&b||(b=i,p<=0))break;g=p}if(b){const D={word:b[0],startColumn:y+1+b.index,endColumn:y+1+b.index+b[0].length};return v.lastIndex=0,D}return null}e.getWordAtText=k;function L(T,v,I,y){let h;for(;h=T.exec(v);){const d=h.index||0;if(d<=I&&T.lastIndex>=I)return h;if(y>0&&d>y)return null}return null}}),define(De[153],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class A{constructor(P){if(this.e=null,this.f=!1,this.open=P.open,this.close=P.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(P.notIn))for(let S=0,k=P.notIn.length;S<k;S++)switch(P.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(P,S){if(P.getTokenCount()===0)return!0;const k=P.findTokenIndexAtOffset(S-2),L=P.getStandardTokenType(k);return this.isOK(L)}g(P,S){for(let k=P;k<=S;k++){const L=String.fromCharCode(k);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class l{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)R(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),R(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),R(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),R(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&R(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=l;function R(C,P,S){C.has(P)?C.get(P).push(S):C.set(P,[S])}}),define(De[154],Ce([1,0,105]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class l{constructor(y,h,d){const u=new Uint8Array(y*h);for(let g=0,b=y*h;g<b;g++)u[g]=d;this.a=u,this.rows=y,this.cols=h}get(y,h){return this.a[y*this.cols+h]}set(y,h,d){this.a[y*this.cols+h]=d}}class R{constructor(y){let h=0,d=0;for(let g=0,b=y.length;g<b;g++){const[D,p,i]=y[g];p>h&&(h=p),D>d&&(d=D),i>d&&(d=i)}h++,d++;const u=new l(d,h,0);for(let g=0,b=y.length;g<b;g++){const[D,p,i]=y[g];u.set(D,p,i)}this.a=u,this.b=h}nextState(y,h){return h<0||h>=this.b?0:this.a.get(y,h)}}e.StateMachine=R;let C=null;function P(){return C===null&&(C=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let k=null;function L(){if(k===null){k=new a.CharacterClassifier(0);const I=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<I.length;h++)k.set(I.charCodeAt(h),1);const y=".;:";for(let h=0;h<y.length;h++)k.set(y.charCodeAt(h),2)}return k}class T{static a(y,h,d,u,g){let b=g-1;do{const D=h.charCodeAt(b);if(y.get(D)!==2)break;b--}while(b>u);if(u>0){const D=h.charCodeAt(u-1),p=h.charCodeAt(b);(D===40&&p===41||D===91&&p===93||D===123&&p===125)&&b--}return{range:{startLineNumber:d,startColumn:u+1,endLineNumber:d,endColumn:b+2},url:h.substring(u,b+1)}}static computeLinks(y,h=P()){const d=L(),u=[];for(let g=1,b=y.getLineCount();g<=b;g++){const D=y.getLineContent(g),p=D.length;let i=0,o=0,r=0,c=1,s=!1,m=!1,n=!1,t=!1;for(;i<p;){let f=!1;const E=D.charCodeAt(i);if(c===13){let w;switch(E){case 40:s=!0,w=0;break;case 41:w=s?0:1;break;case 91:n=!0,m=!0,w=0;break;case 93:n=!1,w=m?0:1;break;case 123:t=!0,w=0;break;case 125:w=t?0:1;break;case 39:case 34:case 96:r===E?w=1:r===39||r===34||r===96?w=0:w=1;break;case 42:w=r===42?1:0;break;case 124:w=r===124?1:0;break;case 32:w=n?0:1;break;default:w=d.get(E)}w===1&&(u.push(T.a(d,D,g,o,i)),f=!0)}else if(c===12){let w;E===91?(m=!0,w=0):w=d.get(E),w===1?f=!0:c=13}else c=h.nextState(c,E),c===0&&(f=!0);f&&(c=1,s=!1,m=!1,t=!1,o=i+1,r=E),i++}c===13&&u.push(T.a(d,D,g,o,p))}return u}}e.LinkComputer=T;function v(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:T.computeLinks(I)}e.computeLinks=v}),define(De[107],Ce([1,0,23]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var l;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(l=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),D.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,D.indentSize|0),this.a=!1),this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.a===D.a&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class L{constructor(D,p){this._findMatchBrand=void 0,this.range=D,this.matches=p}}e.FindMatch=L;var T;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var I;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(I=e.PositionAffinity||(e.PositionAffinity={}));var y;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(y=e.ModelConstants||(e.ModelConstants={}));class h{constructor(D,p,i,o,r,c){this.identifier=D,this.range=p,this.text=i,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=r,this._isTracked=c}}e.ValidAnnotatedEditOperation=h;class d{constructor(D,p,i){this.regex=D,this.wordSeparators=p,this.simpleSearch=i}}e.SearchData=d;class u{constructor(D,p,i){this.reverseEdits=D,this.changes=p,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=u;function g(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(De[155],Ce([1,0,15,104]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,k){S=(0,A.toUint32)(S);const L=this.a,T=this.b,v=k.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S),S+v),this.a.set(k,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}setValue(S,k){return S=(0,A.toUint32)(S),k=(0,A.toUint32)(k),this.a[S]===k?!1:(this.a[S]=k,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,k){S=(0,A.toUint32)(S),k=(0,A.toUint32)(k);const L=this.a,T=this.b;if(S>=L.length)return!1;const v=L.length-S;return k>=v&&(k=v),k===0?!1:(this.a=new Uint32Array(L.length-k),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S+k),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,A.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),S>=this.a.length&&(S=this.a.length-1);for(let L=k;L<=S;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let k=0,L=this.a.length-1,T=0,v=0,I=0;for(;k<=L;)if(T=k+(L-k)/2|0,v=this.b[T],I=v-this.a[T],S<I)L=T-1;else if(S>=v)k=T+1;else break;return new C(T,S-I)}}e.PrefixSumComputer=l;class R{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const k=this.e[S],L=k>0?this.d[k-1]:0;return new C(k,S-L)}removeValues(S,k){this.a.splice(S,k),this.f(S)}insertValues(S,k){this.a=(0,a.arrayInsert)(this.a,S,k),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,k=this.a.length;S<k;S++){const L=this.a[S],T=S>0?this.d[S-1]:0;this.d[S]=T+L;for(let v=0;v<L;v++)this.e[T+v]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,k){this.a[S]!==k&&(this.a[S]=k,this.f(S))}}e.ConstantTimePrefixSumComputer=R;class C{constructor(S,k){this.index=S,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=k}}e.PrefixSumIndexOfResult=C}),define(De[156],Ce([17,18]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(De[157],Ce([17,18]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(De[158],Ce([1,0,157]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,l=A*60,R=l*24,C=R*7,P=R*30,S=R*365;function k(T,v,I,y){typeof T!="number"&&(T=T.getTime());const h=Math.round((new Date().getTime()-T)/1e3);if(h<-30)return(0,a.localize)(0,null,k(new Date().getTime()+h*1e3,!1));if(!y&&h<30)return(0,a.localize)(1,null);let d;return h<A?(d=h,v?d===1?I?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):I?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?I?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):I?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):h<l?(d=Math.floor(h/A),v?d===1?I?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):I?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?I?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):I?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):h<R?(d=Math.floor(h/l),v?d===1?I?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):I?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?I?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):I?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):h<C?(d=Math.floor(h/R),v?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):h<P?(d=Math.floor(h/C),v?d===1?I?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):I?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?I?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):I?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):h<S?(d=Math.floor(h/P),v?d===1?I?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):I?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?I?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):I?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(h/S),v?d===1?I?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):I?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?I?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):I?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=k;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(De[159],Ce([17,18]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(De[45],Ce([1,0,15,9,159]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(T,v){return v&&(T.stack||T.stacktrace)?l.localize(0,null,P(T),C(T.stack)||C(T.stacktrace)):P(T)}function C(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?l.localize(1,null,T.message):T.message||l.localize(2,null)}function S(T=null,v=!1){if(!T)return l.localize(3,null);if(Array.isArray(T)){const I=a.coalesce(T),y=S(I[0],v);return I.length>1?l.localize(4,null,y,I.length):y}if(A.isString(T))return T;if(T.detail){const I=T.detail;if(I.error)return R(I.error,v);if(I.exception)return R(I.exception,v)}return T.stack?R(T,v):T.message?T.message:l.localize(5,null)}e.toErrorMessage=S;function k(T){const v=T;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=k;function L(T,v){let I;return typeof T=="string"?I=new Error(T):I=T,I.actions=v,I}e.createErrorWithActions=L}),define(De[160],Ce([17,18]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(De[10],Ce([1,0,160]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,l=!1,R=!1,C=!1,P=!1,S=!1,k=!1,L=!1,T=!1,v=!1,I,y=e.LANGUAGE_DEFAULT,h,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",b=g&&u?.type==="renderer";if(typeof navigator=="object"&&!b)d=navigator.userAgent,A=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,S=!0,I=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,y=I;else if(typeof u=="object"){A=u.platform==="win32",l=u.platform==="darwin",R=u.platform==="linux",C=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,k=g,T=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),f=t.availableLanguages["*"];I=t.locale,y=f||e.LANGUAGE_DEFAULT,h=t._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var D;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function p(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let i=0;l?i=1:A?i=3:R&&(i=2),e.isWindows=A,e.isMacintosh=l,e.isLinux=R,e.isLinuxSnap=C,e.isNative=P,e.isElectron=k,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=T,e.platform=i,e.userAgent=d,e.language=y;var o;(function(n){function t(){return e.language}n.value=t;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=f;function E(){return e.language==="en"}n.isDefault=E})(o=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let E=0,w=n.length;E<w;E++){const O=n[E];if(O.id===f.data.vscodeScheduleAsyncWork){n.splice(E,1),O.callback();return}}});let t=0;return f=>{const E=++t;n.push({id:E,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return n=>setTimeout(n)})();var r;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||L?2:A?1:3;let c=!0,s=!1;function m(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,c=new Uint16Array(n.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=m,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[36],Ce([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const l=a.globals.vscode.process;A={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(De[11],Ce([1,0,36]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,l=97,R=90,C=122,P=46,S=47,k=92,L=58,T=63;class v extends Error{constructor(o,r,c){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const m=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${m} ${s} of type ${r}`;n+=`. Received type ${typeof c}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function I(i,o){if(i===null||typeof i!="object")throw new v(o,"Object",i)}function y(i,o){if(typeof i!="string")throw new v(o,"string",i)}const h=a.platform==="win32";function d(i){return i===S||i===k}function u(i){return i===S}function g(i){return i>=A&&i<=R||i>=l&&i<=C}function b(i,o,r,c){let s="",m=0,n=-1,t=0,f=0;for(let E=0;E<=i.length;++E){if(E<i.length)f=i.charCodeAt(E);else{if(c(f))break;f=S}if(c(f)){if(!(n===E-1||t===1))if(t===2){if(s.length<2||m!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const w=s.lastIndexOf(r);w===-1?(s="",m=0):(s=s.slice(0,w),m=s.length-1-s.lastIndexOf(r)),n=E,t=0;continue}else if(s.length!==0){s="",m=0,n=E,t=0;continue}}o&&(s+=s.length>0?`${r}..`:"..",m=2)}else s.length>0?s+=`${r}${i.slice(n+1,E)}`:s=i.slice(n+1,E),m=E-n-1;n=E,t=0}else f===P&&t!==-1?++t:t=-1}return s}function D(i,o){I(o,"pathObject");const r=o.dir||o.root,c=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${c}`:`${r}${i}${c}`:c}e.win32={resolve(...i){let o="",r="",c=!1;for(let s=i.length-1;s>=-1;s--){let m;if(s>=0){if(m=i[s],y(m,"path"),m.length===0)continue}else o.length===0?m=a.cwd():(m=a.env[`=${o}`]||a.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==o.toLowerCase()&&m.charCodeAt(2)===k)&&(m=`${o}\\`));const n=m.length;let t=0,f="",E=!1;const w=m.charCodeAt(0);if(n===1)d(w)&&(t=1,E=!0);else if(d(w))if(E=!0,d(m.charCodeAt(1))){let O=2,V=O;for(;O<n&&!d(m.charCodeAt(O));)O++;if(O<n&&O!==V){const j=m.slice(V,O);for(V=O;O<n&&d(m.charCodeAt(O));)O++;if(O<n&&O!==V){for(V=O;O<n&&!d(m.charCodeAt(O));)O++;(O===n||O!==V)&&(f=`\\\\${j}\\${m.slice(V,O)}`,t=O)}}}else t=1;else g(w)&&m.charCodeAt(1)===L&&(f=m.slice(0,2),t=2,n>2&&d(m.charCodeAt(2))&&(E=!0,t=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(c){if(o.length>0)break}else if(r=`${m.slice(t)}\\${r}`,c=E,E&&o.length>0)break}return r=b(r,!c,"\\",d),c?`${o}\\${r}`:`${o}${r}`||"."},normalize(i){y(i,"path");const o=i.length;if(o===0)return".";let r=0,c,s=!1;const m=i.charCodeAt(0);if(o===1)return u(m)?"\\":i;if(d(m))if(s=!0,d(i.charCodeAt(1))){let t=2,f=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==f){const E=i.slice(f,t);for(f=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==f){for(f=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return`\\\\${E}\\${i.slice(f)}\\`;t!==f&&(c=`\\\\${E}\\${i.slice(f,t)}`,r=t)}}}else r=1;else g(m)&&i.charCodeAt(1)===L&&(c=i.slice(0,2),r=2,o>2&&d(i.charCodeAt(2))&&(s=!0,r=3));let n=r<o?b(i.slice(r),!s,"\\",d):"";return n.length===0&&!s&&(n="."),n.length>0&&d(i.charCodeAt(o-1))&&(n+="\\"),c===void 0?s?`\\${n}`:n:s?`${c}\\${n}`:`${c}${n}`},isAbsolute(i){y(i,"path");const o=i.length;if(o===0)return!1;const r=i.charCodeAt(0);return d(r)||o>2&&g(r)&&i.charCodeAt(1)===L&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,r;for(let m=0;m<i.length;++m){const n=i[m];y(n,"path"),n.length>0&&(o===void 0?o=r=n:o+=`\\${n}`)}if(o===void 0)return".";let c=!0,s=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++s;const m=r.length;m>1&&d(r.charCodeAt(1))&&(++s,m>2&&(d(r.charCodeAt(2))?++s:c=!1))}if(c){for(;s<o.length&&d(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o)return"";const r=e.win32.resolve(i),c=e.win32.resolve(o);if(r===c||(i=r.toLowerCase(),o=c.toLowerCase(),i===o))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===k;)s++;let m=i.length;for(;m-1>s&&i.charCodeAt(m-1)===k;)m--;const n=m-s;let t=0;for(;t<o.length&&o.charCodeAt(t)===k;)t++;let f=o.length;for(;f-1>t&&o.charCodeAt(f-1)===k;)f--;const E=f-t,w=n<E?n:E;let O=-1,V=0;for(;V<w;V++){const F=i.charCodeAt(s+V);if(F!==o.charCodeAt(t+V))break;F===k&&(O=V)}if(V!==w){if(O===-1)return c}else{if(E>w){if(o.charCodeAt(t+V)===k)return c.slice(t+V+1);if(V===2)return c.slice(t+V)}n>w&&(i.charCodeAt(s+V)===k?O=V:V===2&&(O=3)),O===-1&&(O=0)}let j="";for(V=s+O+1;V<=m;++V)(V===m||i.charCodeAt(V)===k)&&(j+=j.length===0?"..":"\\..");return t+=O,j.length>0?`${j}${c.slice(t,f)}`:(c.charCodeAt(t)===k&&++t,c.slice(t,f))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===k){if(o.charCodeAt(1)===k){const r=o.charCodeAt(2);if(r!==T&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===k)return`\\\\?\\${o}`;return i},dirname(i){y(i,"path");const o=i.length;if(o===0)return".";let r=-1,c=0;const s=i.charCodeAt(0);if(o===1)return d(s)?i:".";if(d(s)){if(r=c=1,d(i.charCodeAt(1))){let t=2,f=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==f){for(f=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==f){for(f=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return i;t!==f&&(r=c=t+1)}}}}else g(s)&&i.charCodeAt(1)===L&&(r=o>2&&d(i.charCodeAt(2))?3:2,c=r);let m=-1,n=!0;for(let t=o-1;t>=c;--t)if(d(i.charCodeAt(t))){if(!n){m=t;break}}else n=!1;if(m===-1){if(r===-1)return".";m=r}return i.slice(0,m)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,c=-1,s=!0,m;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(r=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=r;--m){const f=i.charCodeAt(m);if(d(f)){if(!s){r=m+1;break}}else t===-1&&(s=!1,t=m+1),n>=0&&(f===o.charCodeAt(n)?--n===-1&&(c=m):(n=-1,c=t))}return r===c?c=t:c===-1&&(c=i.length),i.slice(r,c)}for(m=i.length-1;m>=r;--m)if(d(i.charCodeAt(m))){if(!s){r=m+1;break}}else c===-1&&(s=!1,c=m+1);return c===-1?"":i.slice(r,c)},extname(i){y(i,"path");let o=0,r=-1,c=0,s=-1,m=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&g(i.charCodeAt(0))&&(o=c=2);for(let t=i.length-1;t>=o;--t){const f=i.charCodeAt(t);if(d(f)){if(!m){c=t+1;break}continue}s===-1&&(m=!1,s=t+1),f===P?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||s===-1||n===0||n===1&&r===s-1&&r===c+1?"":i.slice(r,s)},format:D.bind(null,"\\"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.length;let c=0,s=i.charCodeAt(0);if(r===1)return d(s)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(d(s)){if(c=1,d(i.charCodeAt(1))){let O=2,V=O;for(;O<r&&!d(i.charCodeAt(O));)O++;if(O<r&&O!==V){for(V=O;O<r&&d(i.charCodeAt(O));)O++;if(O<r&&O!==V){for(V=O;O<r&&!d(i.charCodeAt(O));)O++;O===r?c=O:O!==V&&(c=O+1)}}}}else if(g(s)&&i.charCodeAt(1)===L){if(r<=2)return o.root=o.dir=i,o;if(c=2,d(i.charCodeAt(2))){if(r===3)return o.root=o.dir=i,o;c=3}}c>0&&(o.root=i.slice(0,c));let m=-1,n=c,t=-1,f=!0,E=i.length-1,w=0;for(;E>=c;--E){if(s=i.charCodeAt(E),d(s)){if(!f){n=E+1;break}continue}t===-1&&(f=!1,t=E+1),s===P?m===-1?m=E:w!==1&&(w=1):m!==-1&&(w=-1)}return t!==-1&&(m===-1||w===0||w===1&&m===t-1&&m===n+1?o.base=o.name=i.slice(n,t):(o.name=i.slice(n,m),o.base=i.slice(n,t),o.ext=i.slice(m,t))),n>0&&n!==c?o.dir=i.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(h){const i=/\\/g;return()=>{const o=a.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...i){let o="",r=!1;for(let c=i.length-1;c>=-1&&!r;c--){const s=c>=0?i[c]:p();y(s,"path"),s.length!==0&&(o=`${s}/${o}`,r=s.charCodeAt(0)===S)}return o=b(o,!r,"/",u),r?`/${o}`:o.length>0?o:"."},normalize(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S,r=i.charCodeAt(i.length-1)===S;return i=b(i,!o,"/",u),i.length===0?o?"/":r?"./":".":(r&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return y(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let o;for(let r=0;r<i.length;++r){const c=i[r];y(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const r=1,c=i.length,s=c-r,m=1,n=o.length-m,t=s<n?s:n;let f=-1,E=0;for(;E<t;E++){const O=i.charCodeAt(r+E);if(O!==o.charCodeAt(m+E))break;O===S&&(f=E)}if(E===t)if(n>t){if(o.charCodeAt(m+E)===S)return o.slice(m+E+1);if(E===0)return o.slice(m+E)}else s>t&&(i.charCodeAt(r+E)===S?f=E:E===0&&(f=0));let w="";for(E=r+f+1;E<=c;++E)(E===c||i.charCodeAt(E)===S)&&(w+=w.length===0?"..":"/..");return`${w}${o.slice(m+f)}`},toNamespacedPath(i){return i},dirname(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S;let r=-1,c=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===S){if(!c){r=s;break}}else c=!1;return r===-1?o?"/":".":o&&r===1?"//":i.slice(0,r)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,c=-1,s=!0,m;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=0;--m){const f=i.charCodeAt(m);if(f===S){if(!s){r=m+1;break}}else t===-1&&(s=!1,t=m+1),n>=0&&(f===o.charCodeAt(n)?--n===-1&&(c=m):(n=-1,c=t))}return r===c?c=t:c===-1&&(c=i.length),i.slice(r,c)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===S){if(!s){r=m+1;break}}else c===-1&&(s=!1,c=m+1);return c===-1?"":i.slice(r,c)},extname(i){y(i,"path");let o=-1,r=0,c=-1,s=!0,m=0;for(let n=i.length-1;n>=0;--n){const t=i.charCodeAt(n);if(t===S){if(!s){r=n+1;break}continue}c===-1&&(s=!1,c=n+1),t===P?o===-1?o=n:m!==1&&(m=1):o!==-1&&(m=-1)}return o===-1||c===-1||m===0||m===1&&o===c-1&&o===r+1?"":i.slice(o,c)},format:D.bind(null,"/"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.charCodeAt(0)===S;let c;r?(o.root="/",c=1):c=0;let s=-1,m=0,n=-1,t=!0,f=i.length-1,E=0;for(;f>=c;--f){const w=i.charCodeAt(f);if(w===S){if(!t){m=f+1;break}continue}n===-1&&(t=!1,n=f+1),w===P?s===-1?s=f:E!==1&&(E=1):s!==-1&&(E=-1)}if(n!==-1){const w=m===0&&r?1:m;s===-1||E===0||E===1&&s===n-1&&s===m+1?o.base=o.name=i.slice(w,n):(o.name=i.slice(w,s),o.base=i.slice(w,n),o.ext=i.slice(s,n))}return m>0?o.dir=i.slice(0,m-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h?e.win32.normalize:e.posix.normalize,e.isAbsolute=h?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h?e.win32.join:e.posix.join,e.resolve=h?e.win32.resolve:e.posix.resolve,e.relative=h?e.win32.relative:e.posix.relative,e.dirname=h?e.win32.dirname:e.posix.dirname,e.basename=h?e.win32.basename:e.posix.basename,e.extname=h?e.win32.extname:e.posix.extname,e.format=h?e.win32.format:e.posix.format,e.parse=h?e.win32.parse:e.posix.parse,e.toNamespacedPath=h?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h?e.win32.sep:e.posix.sep,e.delimiter=h?e.win32.delimiter:e.posix.delimiter}),define(De[108],Ce([1,0,65,11]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new a.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),R=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(t,f,E=!1){const w=t||"",O=f||"",V=l.value.collator.compare(w,O);return l.value.collatorIsNumeric&&V===0&&w!==O?w<O?-1:1:V}e.compareFileNames=P;function S(t,f){const E=R.value.collator;return t=t||"",f=f||"",D(E,t,f)}e.compareFileNamesDefault=S;function k(t,f){const E=R.value.collator;return t=t||"",f=f||"",r(t,f)||D(E,t,f)}e.compareFileNamesUpper=k;function L(t,f){const E=R.value.collator;return t=t||"",f=f||"",o(t,f)||D(E,t,f)}e.compareFileNamesLower=L;function T(t,f){return t=t||"",f=f||"",t===f?0:t<f?-1:1}e.compareFileNamesUnicode=T;function v(t,f){const[E,w]=g(t),[O,V]=g(f);let j=l.value.collator.compare(w,V);if(j===0){if(l.value.collatorIsNumeric&&w!==V)return w<V?-1:1;if(j=l.value.collator.compare(E,O),l.value.collatorIsNumeric&&j===0&&E!==O)return E<O?-1:1}return j}e.compareFileExtensions=v;function I(t,f){t=t||"",f=f||"";const E=b(t),w=b(f),O=R.value.collator,V=C.value.collator;return D(V,E,w)||D(O,t,f)}e.compareFileExtensionsDefault=I;function y(t,f){t=t||"",f=f||"";const E=b(t),w=b(f),O=R.value.collator,V=C.value.collator;return D(V,E,w)||r(t,f)||D(O,t,f)}e.compareFileExtensionsUpper=y;function h(t,f){t=t||"",f=f||"";const E=b(t),w=b(f),O=R.value.collator,V=C.value.collator;return D(V,E,w)||o(t,f)||D(O,t,f)}e.compareFileExtensionsLower=h;function d(t,f){t=t||"",f=f||"";const E=b(t).toLowerCase(),w=b(f).toLowerCase();return E!==w?E<w?-1:1:t!==f?t<f?-1:1:0}e.compareFileExtensionsUnicode=d;const u=/^(.*?)(\.([^.]*))?$/;function g(t,f=!1){const E=t?u.exec(t):[];let w=[E&&E[1]||"",E&&E[3]||""];return f&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function b(t){const f=t?u.exec(t):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function D(t,f,E){const w=t.compare(f,E);return w!==0?w:f.length!==E.length?f.length<E.length?-1:1:0}function p(t){const f=t.charAt(0);return f.toLocaleUpperCase()!==f}function i(t){const f=t.charAt(0);return f.toLocaleLowerCase()!==f}function o(t,f){return p(t)&&i(f)?-1:i(t)&&p(f)?1:0}function r(t,f){return i(t)&&p(f)?-1:p(t)&&i(f)?1:0}function c(t,f,E=!1){return E||(t=t&&t.toLowerCase(),f=f&&f.toLowerCase()),t===f?0:t<f?-1:1}function s(t,f,E=!1){const w=t.split(A.sep),O=f.split(A.sep),V=w.length-1,j=O.length-1;let F,B;for(let N=0;;N++){if(F=V===N,B=j===N,F&&B)return P(w[N],O[N],E);if(F)return-1;if(B)return 1;const U=c(w[N],O[N],E);if(U!==0)return U}}e.comparePaths=s;function m(t,f,E){const w=t.toLowerCase(),O=f.toLowerCase(),V=n(t,f,E);if(V)return V;const j=w.endsWith(E),F=O.endsWith(E);if(j!==F)return j?-1:1;const B=P(w,O);return B!==0?B:w.localeCompare(O)}e.compareAnything=m;function n(t,f,E){const w=t.toLowerCase(),O=f.toLowerCase(),V=w.startsWith(E),j=O.startsWith(E);if(V!==j)return V?-1:1;if(V&&j){if(w.length<O.length)return-1;if(w.length>O.length)return 1}return 0}e.compareByPrefix=n}),define(De[87],Ce([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const T=(0,a.extname)(L),v=A[T.toLowerCase()];return v!==void 0?v:C(L)}e.getMediaOrTextMime=R;function C(L){const T=(0,a.extname)(L);return l[T.toLowerCase()]}e.getMediaMime=C;function P(L){for(const T in l)if(l[T]===L)return T}e.getExtensionForMimeType=P;const S=/^(.+)\/(.+?)(;.+)?$/;function k(L,T){const v=S.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:T?void 0:L}e.normalizeMimeType=k}),define(De[109],Ce([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...S){const k=S.reduce((v,I)=>(v[I]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!k[v]).forEach(v=>{for(let I=0;I<L.length;I++)if(v.search(L[I])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=R;function C(P){!P||(delete P.DEBUG,a.isMacintosh&&delete P.DYLD_LIBRARY_PATH,a.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(De[43],Ce([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=a.globals.performance&&typeof a.globals.performance.now=="function";class l{static create(C=!0){return new l(C)}constructor(C){this.a=A&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=l}),define(De[3],Ce([1,0,12,63,6,66,43]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,S=!1;var k;(function(m){m.None=()=>l.Disposable.None;function n(ve){if(S){const{onDidAddListener:ke}=ve,Oe=y.create();let oe=0;ve.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Oe.print()),ke?.()}}}function t(ve,ke){return N(ve,()=>{},0,void 0,!0,void 0,ke)}m.defer=t;function f(ve){return(ke,Oe=null,oe)=>{let le=!1,ue;return ue=ve(te=>{if(!le)return ue?ue.dispose():le=!0,ke.call(Oe,te)},null,oe),le&&ue.dispose(),ue}}m.once=f;function E(ve,ke,Oe){return B((oe,le=null,ue)=>ve(te=>oe.call(le,ke(te)),null,ue),Oe)}m.map=E;function w(ve,ke,Oe){return B((oe,le=null,ue)=>ve(te=>{ke(te),oe.call(le,te)},null,ue),Oe)}m.forEach=w;function O(ve,ke,Oe){return B((oe,le=null,ue)=>ve(te=>ke(te)&&oe.call(le,te),null,ue),Oe)}m.filter=O;function V(ve){return ve}m.signal=V;function j(...ve){return(ke,Oe=null,oe)=>(0,l.combinedDisposable)(...ve.map(le=>le(ue=>ke.call(Oe,ue),null,oe)))}m.any=j;function F(ve,ke,Oe,oe){let le=Oe;return E(ve,ue=>(le=ke(le,ue),le),oe)}m.reduce=F;function B(ve,ke){let Oe;const oe={onWillAddFirstListener(){Oe=ve(le.fire,le)},onDidRemoveLastListener(){Oe?.dispose()}};ke||n(oe);const le=new d(oe);return ke?.add(le),le.event}function N(ve,ke,Oe=100,oe=!1,le=!1,ue,te){let ce,se,M,W=0,G;const _={leakWarningThreshold:ue,onWillAddFirstListener(){ce=ve(we=>{W++,se=ke(se,we),oe&&!M&&(de.fire(se),se=void 0),G=()=>{const Ae=se;se=void 0,M=void 0,(!oe||W>1)&&de.fire(Ae),W=0},typeof Oe=="number"?(clearTimeout(M),M=setTimeout(G,Oe)):M===void 0&&(M=0,queueMicrotask(G))})},onWillRemoveListener(){le&&W>0&&G?.()},onDidRemoveLastListener(){G=void 0,ce.dispose()}};te||n(_);const de=new d(_);return te?.add(de),de.event}m.debounce=N;function U(ve,ke=0,Oe){return m.debounce(ve,(oe,le)=>oe?(oe.push(le),oe):[le],ke,void 0,!0,void 0,Oe)}m.accumulate=U;function $(ve,ke=(oe,le)=>oe===le,Oe){let oe=!0,le;return O(ve,ue=>{const te=oe||!ke(ue,le);return oe=!1,le=ue,te},Oe)}m.latch=$;function z(ve,ke,Oe){return[m.filter(ve,ke,Oe),m.filter(ve,oe=>!ke(oe),Oe)]}m.split=z;function ae(ve,ke=!1,Oe=[]){let oe=Oe.slice(),le=ve(ce=>{oe?oe.push(ce):te.fire(ce)});const ue=()=>{oe?.forEach(ce=>te.fire(ce)),oe=null},te=new d({onWillAddFirstListener(){le||(le=ve(ce=>te.fire(ce)))},onDidAddFirstListener(){oe&&(ke?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return te.event}m.buffer=ae;class ee{constructor(ke){this.event=ke,this.c=new l.DisposableStore}map(ke){return new ee(E(this.event,ke,this.c))}forEach(ke){return new ee(w(this.event,ke,this.c))}filter(ke){return new ee(O(this.event,ke,this.c))}reduce(ke,Oe){return new ee(F(this.event,ke,Oe,this.c))}latch(){return new ee($(this.event,void 0,this.c))}debounce(ke,Oe=100,oe=!1,le=!1,ue){return new ee(N(this.event,ke,Oe,oe,le,ue,this.c))}on(ke,Oe,oe){return this.event(ke,Oe,oe)}once(ke,Oe,oe){return f(this.event)(ke,Oe,oe)}dispose(){this.c.dispose()}}function q(ve){return new ee(ve)}m.chain=q;function J(ve,ke,Oe=oe=>oe){const oe=(...ce)=>te.fire(Oe(...ce)),le=()=>ve.on(ke,oe),ue=()=>ve.removeListener(ke,oe),te=new d({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return te.event}m.fromNodeEventEmitter=J;function ie(ve,ke,Oe=oe=>oe){const oe=(...ce)=>te.fire(Oe(...ce)),le=()=>ve.addEventListener(ke,oe),ue=()=>ve.removeEventListener(ke,oe),te=new d({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return te.event}m.fromDOMEventEmitter=ie;function ge(ve){return new Promise(ke=>f(ve)(ke))}m.toPromise=ge;function X(ve,ke){return ke(void 0),ve(Oe=>ke(Oe))}m.runAndSubscribe=X;function Y(ve,ke){let Oe=null;function oe(ue){Oe?.dispose(),Oe=new l.DisposableStore,ke(ue,Oe)}oe(void 0);const le=ve(ue=>oe(ue));return(0,l.toDisposable)(()=>{le.dispose(),Oe?.dispose()})}m.runAndSubscribeWithStore=Y;class Z{constructor(ke,Oe){this.obs=ke,this.c=0,this.d=!1;const oe={onWillAddFirstListener:()=>{ke.addObserver(this)},onDidRemoveLastListener:()=>{ke.removeObserver(this)}};Oe||n(oe),this.emitter=new d(oe),Oe&&Oe.add(this.emitter)}beginUpdate(ke){this.c++}handleChange(ke,Oe){this.d=!0}endUpdate(ke){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function fe(ve,ke){return new Z(ve,ke).emitter.event}m.fromObservable=fe})(k=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new C.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}L.all=new Set,L.c=0,e.EventProfiling=L;let T=-1;function v(m){const n=T;return T=m,{dispose(){T=n}}}e.setGlobalLeakWarningThreshold=v;class I{constructor(n,t=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=t,this.d=0}dispose(){this.c?.clear()}check(n,t){const f=this.threshold;if(f<=0||t<f)return;this.c||(this.c=new Map);const E=this.c.get(n.value)||0;if(this.c.set(n.value,E+1),this.d-=1,this.d<=0){this.d=f*.5;let w,O=0;for(const[V,j]of this.c)(!w||O<j)&&(w=V,O=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${O}):`),console.warn(w)}return()=>{const w=this.c.get(n.value)||0;this.c.set(n.value,w-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(n,t,f){this.callback=n,this.callbackThis=t,this.stack=f,this.subscription=new l.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class d{constructor(n){this.j=!1,this.d=n,this.f=T>0||this.d?.leakWarningThreshold?new I(this.d?.leakWarningThreshold??T):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const n=Array.from(this.q);queueMicrotask(()=>{for(const t of n)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,t,f)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let w,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=y.create(),w=this.f.check(O,this.q.size+1)),P&&(O=O??y.create());const V=new h(n,t,O),j=this.q.push(V);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,t);const F=V.subscription.set(()=>{w?.(),this.j||(this.d?.onWillRemoveListener?.(this),j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return f instanceof l.DisposableStore?f.add(F):Array.isArray(f)&&f.push(F),F}),this.l}fire(n){if(this.q){this.m||(this.m=new g);for(const t of this.q)this.m.push(this,t,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,t,f){this.c.push(new b(n,t,f))}clear(n){const t=new R.LinkedList;for(const f of this.c)f.emitter!==n&&t.push(f);this.c=t}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(t){(0,a.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=u;class g extends u{clear(n){this.c.clear()}}class b{constructor(n,t,f){this.emitter=n,this.listener=t,this.event=f}}class D extends d{async fireAsync(n,t,f){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,n]);for(;this.c.size>0&&!t.isCancellationRequested;){const[E,w]=this.c.shift(),O=[],V={...w,token:t,waitUntil:j=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");f&&(j=f(j,E.callback)),O.push(j)}};try{E.invoke(V)}catch(j){(0,a.onUnexpectedError)(j);continue}Object.freeze(O),await Promise.allSettled(O).then(j=>{for(const F of j)F.status==="rejected"&&(0,a.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=D;class p extends d{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=p;class i extends p{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class o extends d{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(t=>super.fire(t)),this.c=[]}))}}e.MicrotaskEmitter=o;class r{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const t={event:n,listener:null};this.f.push(t),this.d&&this.j(t);const f=()=>{this.d&&this.k(t);const E=this.f.indexOf(t);this.f.splice(E,1)};return(0,l.toDisposable)((0,A.once)(f))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(t=>this.c.fire(t))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class c{constructor(){this.c=[]}wrapEvent(n){return(t,f,E)=>n(w=>{const O=this.c[this.c.length-1];O?O.push(()=>t.call(f,w)):t.call(f,w)},void 0,E)}bufferEvents(n){const t=[];this.c.push(t);const f=n();return this.c.pop(),t.forEach(E=>E()),f}}e.EventBufferer=c;class s{constructor(){this.c=!1,this.d=k.None,this.f=l.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(De[161],Ce([1,0,3,6,156]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(v,I="",y="",h=!0,d){super(),this.h=this.B(new a.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=I,this.u=y,this.w=h,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,I){this.C&&await this.C(v)}}e.Action=R;class C extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new a.Emitter),this.onWillRun=this.f.event,this.h=this.B(new a.Emitter),this.onDidRun=this.h.event}async run(v,I){if(!v.enabled)return;this.f.fire({action:v});let y;try{await this.runAction(v,I)}catch(h){y=h}this.h.fire({action:v,error:y})}async runAction(v,I){await v.run(I)}}e.ActionRunner=C;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let I=[];for(const y of v)y.length&&(I.length?I=[...I,new P,...y]:I=y);return I}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class S{get actions(){return this.a}constructor(v,I,y,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=I,this.class=h,this.a=y}async run(){}}e.SubmenuAction=S;class k extends R{constructor(){super(k.ID,l.localize(0,null),void 0,!1)}}k.ID="vs.actions.empty",e.EmptySubmenuAction=k;function L(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async()=>T.run(),tooltip:T.label}}e.toAction=L}),define(De[21],Ce([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,S){const k=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(k)}}});var l;(function(P){function S(k){return k===P.None||k===P.Cancelled||k instanceof R?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(l=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=l.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=C}),define(De[162],Ce([1,0,21]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new a.CancellationTokenSource,S=this.b(P.token);return this.a={promise:S,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class l{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const S=JSON.stringify(P);return this.b!==S&&(this.b=S,this.a=this.c(P)),this.a}}e.LRUCachedFunction=l;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const S=this.b(P);return this.a.set(P,S),S}}e.CachedFunction=R}),define(De[8],Ce([1,0,162,65]),function(ne,e,a,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Ee){return!Ee||typeof Ee!="string"?!0:Ee.trim().length===0}e.isFalsyOrWhitespace=R;const C=/{(\d+)}/g;function P(Ee,...K){return K.length===0?Ee:Ee.replace(C,function(Q,pe){const Le=parseInt(pe,10);return isNaN(Le)||Le<0||Le>=K.length?Q:K[Le]})}e.format=P;const S=/{([^}]+)}/g;function k(Ee,K){return Ee.replace(S,(Q,pe)=>K[pe]??Q)}e.format2=k;function L(Ee){return Ee.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}e.escape=L;function T(Ee){return Ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function v(Ee,K){let Q=0;const pe=K.charCodeAt(0);for(let Le=Ee.length-1;Le>=0;Le--)Ee.charCodeAt(Le)===pe&&Q++;return Q}e.count=v;function I(Ee,K,Q="\u2026"){return Ee.length<=K?Ee:`${Ee.substr(0,K)}${Q}`}e.truncate=I;function y(Ee,K=" "){const Q=h(Ee,K);return d(Q,K)}e.trim=y;function h(Ee,K){if(!Ee||!K)return Ee;const Q=K.length;if(Q===0||Ee.length===0)return Ee;let pe=0;for(;Ee.indexOf(K,pe)===pe;)pe=pe+Q;return Ee.substring(pe)}e.ltrim=h;function d(Ee,K){if(!Ee||!K)return Ee;const Q=K.length,pe=Ee.length;if(Q===0||pe===0)return Ee;let Le=pe,$e=-1;for(;$e=Ee.lastIndexOf(K,Le-1),!($e===-1||$e+Q!==Le);){if($e===0)return"";Le=$e}return Ee.substring(0,Le)}e.rtrim=d;function u(Ee){return Ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(Ee){return Ee.replace(/\*/g,"")}e.stripWildcards=g;function b(Ee,K,Q={}){if(!Ee)throw new Error("Cannot create regex from empty string");K||(Ee=T(Ee)),Q.wholeWord&&(/\B/.test(Ee.charAt(0))||(Ee="\\b"+Ee),/\B/.test(Ee.charAt(Ee.length-1))||(Ee=Ee+"\\b"));let pe="";return Q.global&&(pe+="g"),Q.matchCase||(pe+="i"),Q.multiline&&(pe+="m"),Q.unicode&&(pe+="u"),new RegExp(Ee,pe)}e.createRegExp=b;function D(Ee){return Ee.source==="^"||Ee.source==="^$"||Ee.source==="$"||Ee.source==="^\\s*$"?!1:!!(Ee.exec("")&&Ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function p(Ee){return!!Ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function i(Ee){return(Ee.global?"g":"")+(Ee.ignoreCase?"i":"")+(Ee.multiline?"m":"")+(Ee.unicode?"u":"")}e.regExpFlags=i;function o(Ee){return Ee.split(/\r\n|\r|\n/)}e.splitLines=o;function r(Ee){for(let K=0,Q=Ee.length;K<Q;K++){const pe=Ee.charCodeAt(K);if(pe!==32&&pe!==9)return K}return-1}e.firstNonWhitespaceIndex=r;function c(Ee,K=0,Q=Ee.length){for(let pe=K;pe<Q;pe++){const Le=Ee.charCodeAt(pe);if(Le!==32&&Le!==9)return Ee.substring(K,pe)}return Ee.substring(K,Q)}e.getLeadingWhitespace=c;function s(Ee,K=Ee.length-1){for(let Q=K;Q>=0;Q--){const pe=Ee.charCodeAt(Q);if(pe!==32&&pe!==9)return Q}return-1}e.lastNonWhitespaceIndex=s;function m(Ee,K,Q){const pe=[];let Le=0;for(const $e of Ee.matchAll(K)){if(pe.push(Ee.slice(Le,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");Le=$e.index+$e[0].length,pe.push(Q($e[0],...$e.slice(1),$e.index,Ee,$e.groups))}return pe.push(Ee.slice(Le)),Promise.all(pe).then($e=>$e.join(""))}e.replaceAsync=m;function n(Ee,K){return Ee<K?-1:Ee>K?1:0}e.compare=n;function t(Ee,K,Q=0,pe=Ee.length,Le=0,$e=K.length){for(;Q<pe&&Le<$e;Q++,Le++){const et=Ee.charCodeAt(Q),ot=K.charCodeAt(Le);if(et<ot)return-1;if(et>ot)return 1}const je=pe-Q,Ye=$e-Le;return je<Ye?-1:je>Ye?1:0}e.compareSubstring=t;function f(Ee,K){return E(Ee,K,0,Ee.length,0,K.length)}e.compareIgnoreCase=f;function E(Ee,K,Q=0,pe=Ee.length,Le=0,$e=K.length){for(;Q<pe&&Le<$e;Q++,Le++){let et=Ee.charCodeAt(Q),ot=K.charCodeAt(Le);if(et===ot)continue;if(et>=128||ot>=128)return t(Ee.toLowerCase(),K.toLowerCase(),Q,pe,Le,$e);O(et)&&(et-=32),O(ot)&&(ot-=32);const ft=et-ot;if(ft!==0)return ft}const je=pe-Q,Ye=$e-Le;return je<Ye?-1:je>Ye?1:0}e.compareSubstringIgnoreCase=E;function w(Ee){return Ee>=48&&Ee<=57}e.isAsciiDigit=w;function O(Ee){return Ee>=97&&Ee<=122}e.isLowerAsciiLetter=O;function V(Ee){return Ee>=65&&Ee<=90}e.isUpperAsciiLetter=V;function j(Ee,K){return Ee.length===K.length&&E(Ee,K)===0}e.equalsIgnoreCase=j;function F(Ee,K){const Q=K.length;return K.length>Ee.length?!1:E(Ee,K,0,Q)===0}e.startsWithIgnoreCase=F;function B(Ee,K){const Q=Math.min(Ee.length,K.length);let pe;for(pe=0;pe<Q;pe++)if(Ee.charCodeAt(pe)!==K.charCodeAt(pe))return pe;return Q}e.commonPrefixLength=B;function N(Ee,K){const Q=Math.min(Ee.length,K.length);let pe;const Le=Ee.length-1,$e=K.length-1;for(pe=0;pe<Q;pe++)if(Ee.charCodeAt(Le-pe)!==K.charCodeAt($e-pe))return pe;return Q}e.commonSuffixLength=N;function U(Ee){return 55296<=Ee&&Ee<=56319}e.isHighSurrogate=U;function $(Ee){return 56320<=Ee&&Ee<=57343}e.isLowSurrogate=$;function z(Ee,K){return(Ee-55296<<10)+(K-56320)+65536}e.computeCodePoint=z;function ae(Ee,K,Q){const pe=Ee.charCodeAt(Q);if(U(pe)&&Q+1<K){const Le=Ee.charCodeAt(Q+1);if($(Le))return z(pe,Le)}return pe}e.getNextCodePoint=ae;function ee(Ee,K){const Q=Ee.charCodeAt(K-1);if($(Q)&&K>1){const pe=Ee.charCodeAt(K-2);if(U(pe))return z(pe,Q)}return Q}class q{get offset(){return this.e}constructor(K,Q=0){this.c=K,this.d=K.length,this.e=Q}setOffset(K){this.e=K}prevCodePoint(){const K=ee(this.c,this.e);return this.e-=K>=65536?2:1,K}nextCodePoint(){const K=ae(this.c,this.d,this.e);return this.e+=K>=65536?2:1,K}eol(){return this.e>=this.d}}e.CodePointIterator=q;class J{get offset(){return this.c.offset}constructor(K,Q=0){this.c=new q(K,Q)}nextGraphemeLength(){const K=Ve.getInstance(),Q=this.c,pe=Q.offset;let Le=K.getGraphemeBreakType(Q.nextCodePoint());for(;!Q.eol();){const $e=Q.offset,je=K.getGraphemeBreakType(Q.nextCodePoint());if(Ie(Le,je)){Q.setOffset($e);break}Le=je}return Q.offset-pe}prevGraphemeLength(){const K=Ve.getInstance(),Q=this.c,pe=Q.offset;let Le=K.getGraphemeBreakType(Q.prevCodePoint());for(;Q.offset>0;){const $e=Q.offset,je=K.getGraphemeBreakType(Q.prevCodePoint());if(Ie(je,Le)){Q.setOffset($e);break}Le=je}return pe-Q.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ie(Ee,K){return new J(Ee,K).nextGraphemeLength()}e.nextCharLength=ie;function ge(Ee,K){return new J(Ee,K).prevGraphemeLength()}e.prevCharLength=ge;function X(Ee,K){K>0&&$(Ee.charCodeAt(K))&&K--;const Q=K+ie(Ee,K);return[Q-ge(Ee,Q),Q]}e.getCharContainingOffset=X;function Y(Ee){const K=new J(Ee);let Q=0;for(;!K.eol();)Q++,K.nextGraphemeLength();return Q}e.charCount=Y;let Z;function fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Ee){return Z||(Z=fe()),Z.test(Ee)}e.containsRTL=ve;const ke=/^[\t\n\r\x20-\x7E]*$/;function Oe(Ee){return ke.test(Ee)}e.isBasicASCII=Oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(Ee){return e.UNUSUAL_LINE_TERMINATORS.test(Ee)}e.containsUnusualLineTerminators=oe;function le(Ee){return Ee>=11904&&Ee<=55215||Ee>=63744&&Ee<=64255||Ee>=65281&&Ee<=65374}e.isFullWidthCharacter=le;function ue(Ee){return Ee>=127462&&Ee<=127487||Ee===8986||Ee===8987||Ee===9200||Ee===9203||Ee>=9728&&Ee<=10175||Ee===11088||Ee===11093||Ee>=127744&&Ee<=128591||Ee>=128640&&Ee<=128764||Ee>=128992&&Ee<=129008||Ee>=129280&&Ee<=129535||Ee>=129648&&Ee<=129782}e.isEmojiImprecise=ue;function te(Ee,K){if(Ee.length<K)return Ee;const Q=/\b/g;let pe=0;for(;Q.test(Ee)&&!(Ee.length-Q.lastIndex<K);)pe=Q.lastIndex,Q.lastIndex+=1;return Ee.substring(pe).replace(/^\s/,"")}e.lcut=te;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function se(Ee){return Ee&&(Ee=Ee.replace(ce,"")),Ee}e.removeAnsiEscapeCodes=se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function M(Ee){return!!(Ee&&Ee.length>0&&Ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=M;function W(Ee){return M(Ee)?Ee.substr(1):Ee}e.stripUTF8BOM=W;function G(Ee,K){if(!Ee||!K||Ee.length<K.length)return!1;const Q=K.length,pe=Ee.toLowerCase();let Le=0,$e=-1;for(;Le<Q;){const je=pe.indexOf(K[Le],$e+1);if(je<0)return!1;$e=je,Le++}return!0}e.fuzzyContains=G;function _(Ee,K=!1){return Ee?(K&&(Ee=Ee.replace(/\\./g,"")),Ee.toLowerCase()!==Ee):!1}e.containsUppercaseCharacter=_;function de(Ee){return Ee.charAt(0).toUpperCase()+Ee.slice(1)}e.uppercaseFirstLetter=de;function we(Ee,K=1){if(K===0)return"";let Q=-1;do Q=Ee.indexOf(`
`,Q+1),K--;while(K>0&&Q>=0);return Q===-1?Ee:(Ee[Q-1]==="\r"&&Q--,Ee.substr(0,Q))}e.getNLines=we;function Ae(Ee){return Ee=Ee%(2*26),Ee<26?String.fromCharCode(97+Ee):String.fromCharCode(65+Ee-26)}e.singleLetterHash=Ae;function be(Ee){return Ve.getInstance().getGraphemeBreakType(Ee)}e.getGraphemeBreakType=be;function Ie(Ee,K){return Ee===0?K!==5&&K!==7:Ee===2&&K===3?!1:Ee===4||Ee===2||Ee===3||K===4||K===2||K===3?!0:!(Ee===8&&(K===8||K===9||K===11||K===12)||(Ee===11||Ee===9)&&(K===9||K===10)||(Ee===12||Ee===10)&&K===10||K===5||K===13||K===7||Ee===1||Ee===13&&K===14||Ee===6&&K===6)}var Te;(function(Ee){Ee[Ee.Other=0]="Other",Ee[Ee.Prepend=1]="Prepend",Ee[Ee.CR=2]="CR",Ee[Ee.LF=3]="LF",Ee[Ee.Control=4]="Control",Ee[Ee.Extend=5]="Extend",Ee[Ee.Regional_Indicator=6]="Regional_Indicator",Ee[Ee.SpacingMark=7]="SpacingMark",Ee[Ee.L=8]="L",Ee[Ee.V=9]="V",Ee[Ee.T=10]="T",Ee[Ee.LV=11]="LV",Ee[Ee.LVT=12]="LVT",Ee[Ee.ZWJ=13]="ZWJ",Ee[Ee.Extended_Pictographic=14]="Extended_Pictographic"})(Te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=Ge()}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const Q=this.d,pe=Q.length/3;let Le=1;for(;Le<=pe;)if(K<Q[3*Le])Le=2*Le;else if(K>Q[3*Le+1])Le=2*Le+1;else return Q[3*Le+2];return 0}}Ve.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(Ee,K){if(Ee===0)return 0;const Q=Qe(Ee,K);if(Q!==void 0)return Q;const pe=new q(K,Ee);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=nt;function Qe(Ee,K){const Q=new q(K,Ee);let pe=Q.prevCodePoint();for(;it(pe)||pe===65039||pe===8419;){if(Q.offset===0)return;pe=Q.prevCodePoint()}if(!ue(pe))return;let Le=Q.offset;return Le>0&&Q.prevCodePoint()===8205&&(Le=Q.offset),Le}function it(Ee){return 127995<=Ee&&Ee<=127999}var rt;(function(Ee){Ee[Ee.zwj=8205]="zwj",Ee[Ee.emojiVariantSelector=65039]="emojiVariantSelector",Ee[Ee.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class ct{static getInstance(K){return ct.d.get(Array.from(K))}static getLocales(){return ct.e.value}constructor(K){this.f=K}isAmbiguous(K){return this.f.has(K)}getPrimaryConfusable(K){return this.f.get(K)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=ct,ct.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ct.d=new a.LRUCachedFunction(Ee=>{function K(ot){const ft=new Map;for(let bt=0;bt<ot.length;bt+=2)ft.set(ot[bt],ot[bt+1]);return ft}function Q(ot,ft){const bt=new Map(ot);for(const[Lt,st]of ft)bt.set(Lt,st);return bt}function pe(ot,ft){if(!ot)return ft;const bt=new Map;for(const[Lt,st]of ot)ft.has(Lt)&&bt.set(Lt,st);return bt}const Le=l.c.value;let $e=Ee.filter(ot=>!ot.startsWith("_")&&ot in Le);$e.length===0&&($e=["_default"]);let je;for(const ot of $e){const ft=K(Le[ot]);je=pe(je,ft)}const Ye=K(Le._common),et=Q(Ye,je);return new ct(et)}),ct.e=new A.Lazy(()=>Object.keys(ct.c.value).filter(Ee=>!Ee.startsWith("_"))),e.AmbiguousCharacters=ct;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(K){return Me.e().has(K)}static get codePoints(){return Me.e()}}Me.d=void 0,e.InvisibleCharacters=Me}),define(De[33],Ce([1,0,11,10,8,9]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(s){return s===47||s===92}e.isPathSeparator=C;function P(s){return s.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=P;function S(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function k(s,m=a.posix.sep){if(!s)return"";const n=s.length,t=s.charCodeAt(0);if(C(t)){if(C(s.charCodeAt(1))&&!C(s.charCodeAt(2))){let E=3;const w=E;for(;E<n&&!C(s.charCodeAt(E));E++);if(w!==E&&!C(s.charCodeAt(E+1))){for(E+=1;E<n;E++)if(C(s.charCodeAt(E)))return s.slice(0,E+1).replace(/[\\/]/g,m)}}return m}else if(u(t)&&s.charCodeAt(1)===58)return C(s.charCodeAt(2))?s.slice(0,2)+m:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<n;f++)if(C(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=k;function L(s){if(!A.isWindows||!s||s.length<5)return!1;let m=s.charCodeAt(0);if(m!==92||(m=s.charCodeAt(1),m!==92))return!1;let n=2;const t=n;for(;n<s.length&&(m=s.charCodeAt(n),m!==92);n++);return!(t===n||(m=s.charCodeAt(n+1),isNaN(m)||m===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(s,m=A.isWindows){const n=m?T:v;return!(!s||s.length===0||/^\s+$/.test(s)||(n.lastIndex=0,n.test(s))||m&&I.test(s)||s==="."||s===".."||m&&s[s.length-1]==="."||m&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=y;function h(s,m,n){const t=s===m;return!n||t?t:!s||!m?!1:(0,l.equalsIgnoreCase)(s,m)}e.isEqual=h;function d(s,m,n,t=a.sep){if(s===m)return!0;if(!s||!m||m.length>s.length)return!1;if(n){if(!(0,l.startsWithIgnoreCase)(s,m))return!1;if(m.length===s.length)return!0;let E=m.length;return m.charAt(m.length-1)===t&&E--,s.charAt(E)===t}return m.charAt(m.length-1)!==t&&(m+=t),s.indexOf(m)===0}e.isEqualOrParent=d;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function g(s,m){return A.isWindows&&s.endsWith(":")&&(s+=a.sep),(0,a.isAbsolute)(s)||(s=(0,a.join)(m,s)),s=(0,a.normalize)(s),A.isWindows?(s=(0,l.rtrim)(s,a.sep),s.endsWith(":")&&(s+=a.sep)):(s=(0,l.rtrim)(s,a.sep),s||(s=a.sep)),s}e.sanitizeFilePath=g;function b(s){const m=(0,a.normalize)(s);return A.isWindows?s.length>3?!1:D(m)&&(s.length===2||m.charCodeAt(2)===92):m===a.posix.sep}e.isRootOrDriveLetter=b;function D(s,m=A.isWindows){return m?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function p(s){return D(s)?s[0]:void 0}e.getDriveLetter=p;function i(s,m,n){return m.length>s.length?-1:s===m?0:(n&&(s=s.toLowerCase(),m=m.toLowerCase()),s.indexOf(m))}e.indexOfPath=i;function o(s){const m=s.split(":");let n,t,f;for(const E of m){const w=Number(E);(0,R.isNumber)(w)?t===void 0?t=w:f===void 0&&(f=w):n=n?[n,E].join(":"):E}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:t!==void 0?t:void 0,column:f!==void 0?f:t!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(s,m,n=8){let t="";for(let E=0;E<n;E++)t+=r.charAt(Math.floor(Math.random()*r.length));let f;return m?f=`${m}-${t}`:f=t,s?(0,a.join)(s,f):f}e.randomPath=c}),define(De[110],Ce([1,0,28,8]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...se){return function(M,W){for(let G=0,_=se.length;G<_;G++){const de=se[G](M,W);if(de)return de}return null}}e.or=l,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(se,M,W){if(!W||W.length<M.length)return null;let G;return se?G=A.startsWithIgnoreCase(W,M):G=W.indexOf(M)===0,G?M.length>0?[{start:0,end:M.length}]:[]:null}function C(se,M){const W=M.toLowerCase().indexOf(se.toLowerCase());return W===-1?null:[{start:W,end:W+se.length}]}e.matchesContiguousSubString=C;function P(se,M){return S(se.toLowerCase(),M.toLowerCase(),0,0)}e.matchesSubString=P;function S(se,M,W,G){if(W===se.length)return[];if(G===M.length)return null;if(se[W]===M[G]){let _=null;return(_=S(se,M,W+1,G+1))?u({start:G,end:G+1},_):null}return S(se,M,W,G+1)}function k(se){return 97<=se&&se<=122}function L(se){return 65<=se&&se<=90}e.isUpper=L;function T(se){return 48<=se&&se<=57}function v(se){return se===32||se===9||se===10||se===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>I.add(se.charCodeAt(0)));function y(se){return v(se)||I.has(se)}function h(se,M){return se===M||y(se)&&y(M)}function d(se){return k(se)||L(se)||T(se)}function u(se,M){return M.length===0?M=[se]:se.end===M[0].start?M[0].start=se.start:M.unshift(se),M}function g(se,M){for(let W=M;W<se.length;W++){const G=se.charCodeAt(W);if(L(G)||T(G)||W>0&&!d(se.charCodeAt(W-1)))return W}return se.length}function b(se,M,W,G){if(W===se.length)return[];if(G===M.length)return null;if(se[W]!==M[G].toLowerCase())return null;{let _=null,de=G+1;for(_=b(se,M,W+1,G+1);!_&&(de=g(M,de))<M.length;)_=b(se,M,W+1,de),de++;return _===null?null:u({start:G,end:G+1},_)}}function D(se){let M=0,W=0,G=0,_=0,de=0;for(let Te=0;Te<se.length;Te++)de=se.charCodeAt(Te),L(de)&&M++,k(de)&&W++,d(de)&&G++,T(de)&&_++;const we=M/se.length,Ae=W/se.length,be=G/se.length,Ie=_/se.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:be,numericPercent:Ie}}function p(se){const{upperPercent:M,lowerPercent:W}=se;return W===0&&M>.6}function i(se){const{upperPercent:M,lowerPercent:W,alphaPercent:G,numericPercent:_}=se;return W>.2&&M<.8&&G>.6&&_<.2}function o(se){let M=0,W=0,G=0,_=0;for(let de=0;de<se.length;de++)G=se.charCodeAt(de),L(G)&&M++,k(G)&&W++,v(G)&&_++;return(M===0||W===0)&&_===0?se.length<=30:M<=5}function r(se,M){if(!M||(M=M.trim(),M.length===0)||!o(se)||M.length>60)return null;const W=D(M);if(!i(W)){if(!p(W))return null;M=M.toLowerCase()}let G=null,_=0;for(se=se.toLowerCase();_<M.length&&(G=b(se,M,0,_))===null;)_=g(M,_+1);return G}e.matchesCamelCase=r;function c(se,M,W=!1){if(!M||M.length===0)return null;let G=null,_=0;for(se=se.toLowerCase(),M=M.toLowerCase();_<M.length&&(G=s(se,M,0,_,W))===null;)_=m(M,_+1);return G}e.matchesWords=c;function s(se,M,W,G,_){if(W===se.length)return[];if(G===M.length)return null;if(h(se.charCodeAt(W),M.charCodeAt(G))){let de=null,we=G+1;if(de=s(se,M,W+1,G+1,_),!_)for(;!de&&(we=m(M,we))<M.length;)de=s(se,M,W+1,we,_),we++;return de?se.charCodeAt(W)!==M.charCodeAt(G)?de:u({start:G,end:G+1},de):null}else return null}function m(se,M){for(let W=M;W<se.length;W++)if(y(se.charCodeAt(W))||W>0&&y(se.charCodeAt(W-1)))return W;return se.length}const n=l(e.matchesPrefix,r,C),t=l(e.matchesPrefix,r,P),f=new a.LRUCache(1e4);function E(se,M,W=!1){if(typeof se!="string"||typeof M!="string")return null;let G=f.get(se);G||(G=new RegExp(A.convertSimple2RegExpPattern(se),"i"),f.set(se,G));const _=G.exec(M);return _?[{start:_.index,end:_.index+_[0].length}]:W?t(se,M):n(se,M)}e.matchesFuzzy=E;function w(se,M){const W=ke(se,se.toLowerCase(),0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?V(W):null}e.matchesFuzzy2=w;function O(se,M,W,G,_,de){const we=Math.min(13,se.length);for(;W<we;W++){const Ae=ke(se,M,W,G,_,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,de]}e.anyScore=O;function V(se){if(typeof se>"u")return[];const M=[],W=se[1];for(let G=se.length-1;G>1;G--){const _=se[G]+W,de=M[M.length-1];de&&de.end===_?de.end=_+1:M.push({start:_,end:_+1})}return M}e.createMatches=V;const j=128;function F(){const se=[],M=[];for(let W=0;W<=j;W++)M[W]=0;for(let W=0;W<=j;W++)se.push(M.slice(0));return se}function B(se){const M=[];for(let W=0;W<=se;W++)M[W]=0;return M}const N=B(2*j),U=B(2*j),$=F(),z=F(),ae=F(),ee=!1;function q(se,M,W,G,_){function de(Ae,be,Ie=" "){for(;Ae.length<be;)Ae=Ie+Ae;return Ae}let we=` |   |${G.split("").map(Ae=>de(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=W;Ae++)Ae===0?we+=" |":we+=`${M[Ae-1]}|`,we+=se[Ae].slice(0,_+1).map(be=>de(be.toString(),3)).join("|")+`
`;return we}function J(se,M,W,G){se=se.substr(M),W=W.substr(G),console.log(q(z,se,se.length,W,W.length)),console.log(q(ae,se,se.length,W,W.length)),console.log(q($,se,se.length,W,W.length))}function ie(se,M){if(M<0||M>=se.length)return!1;const W=se.codePointAt(M);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(W)}}function ge(se,M){if(M<0||M>=se.length)return!1;switch(se.charCodeAt(M)){case 32:case 9:return!0;default:return!1}}function X(se,M,W){return M[se]!==W[se]}function Y(se,M,W,G,_,de,we=!1){for(;M<W&&_<de;)se[M]===G[_]&&(we&&(N[M]=_),M+=1),_+=1;return M===W}e.isPatternInWord=Y;var Z;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var fe;(function(se){se.Default=[-100,0];function M(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}se.isDefault=M})(fe=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(M,W){this.firstMatchCanBeWeak=M,this.boostFullMatch=W}}ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ve;function ke(se,M,W,G,_,de,we=ve.default){const Ae=se.length>j?j:se.length,be=G.length>j?j:G.length;if(W>=Ae||de>=be||Ae-W>be-de||!Y(M,W,Ae,_,de,be,!0))return;Oe(Ae,be,W,de,M,_);let Ie=1,Te=1,Ve=W,Ge=de;const nt=[!1];for(Ie=1,Ve=W;Ve<Ae;Ie++,Ve++){const Me=N[Ve],Ee=U[Ve],K=Ve+1<Ae?U[Ve+1]:be;for(Te=Me-de+1,Ge=Me;Ge<K;Te++,Ge++){let Q=Number.MIN_SAFE_INTEGER,pe=!1;Ge<=Ee&&(Q=oe(se,M,Ve,W,G,_,Ge,be,de,$[Ie-1][Te-1]===0,nt));let Le=0;Q!==Number.MAX_SAFE_INTEGER&&(pe=!0,Le=Q+z[Ie-1][Te-1]);const $e=Ge>Me,je=$e?z[Ie][Te-1]+($[Ie][Te-1]>0?-5:0):0,Ye=Ge>Me+1&&$[Ie][Te-1]>0,et=Ye?z[Ie][Te-2]+($[Ie][Te-2]>0?-5:0):0;if(Ye&&(!$e||et>=je)&&(!pe||et>=Le))z[Ie][Te]=et,ae[Ie][Te]=3,$[Ie][Te]=0;else if($e&&(!pe||je>=Le))z[Ie][Te]=je,ae[Ie][Te]=2,$[Ie][Te]=0;else if(pe)z[Ie][Te]=Le,ae[Ie][Te]=1,$[Ie][Te]=$[Ie-1][Te-1]+1;else throw new Error("not possible")}}if(ee&&J(se,W,G,de),!nt[0]&&!we.firstMatchCanBeWeak)return;Ie--,Te--;const Qe=[z[Ie][Te],de];let it=0,rt=0;for(;Ie>=1;){let Me=Te;do{const Ee=ae[Ie][Me];if(Ee===3)Me=Me-2;else if(Ee===2)Me=Me-1;else break}while(Me>=1);it>1&&M[W+Ie-1]===_[de+Te-1]&&!X(Me+de-1,G,_)&&it+1>$[Ie][Me]&&(Me=Te),Me===Te?it++:it=1,rt||(rt=Me),Ie--,Te=Me-1,Qe.push(Te)}be===Ae&&we.boostFullMatch&&(Qe[0]+=2);const ct=rt-Ae;return Qe[0]-=ct,Qe}e.fuzzyScore=ke;function Oe(se,M,W,G,_,de){let we=se-1,Ae=M-1;for(;we>=W&&Ae>=G;)_[we]===de[Ae]&&(U[we]=Ae,we--),Ae--}function oe(se,M,W,G,_,de,we,Ae,be,Ie,Te){if(M[W]!==de[we])return Number.MIN_SAFE_INTEGER;let Ve=1,Ge=!1;return we===W-G?Ve=se[W]===_[we]?7:5:X(we,_,de)&&(we===0||!X(we-1,_,de))?(Ve=se[W]===_[we]?7:5,Ge=!0):ie(de,we)&&(we===0||!ie(de,we-1))?Ve=5:(ie(de,we-1)||ge(de,we-1))&&(Ve=5,Ge=!0),Ve>1&&W===G&&(Te[0]=!0),Ge||(Ge=X(we,_,de)||ie(de,we-1)||ge(de,we-1)),W===G?we>be&&(Ve-=Ge?3:5):Ie?Ve+=Ge?2:0:Ve+=Ge?0:1,we+1===Ae&&(Ve-=Ge?3:5),Ve}function le(se,M,W,G,_,de,we){return te(se,M,W,G,_,de,!0,we)}e.fuzzyScoreGracefulAggressive=le;function ue(se,M,W,G,_,de,we){return te(se,M,W,G,_,de,!1,we)}e.fuzzyScoreGraceful=ue;function te(se,M,W,G,_,de,we,Ae){let be=ke(se,M,W,G,_,de,Ae);if(be&&!we)return be;if(se.length>=3){const Ie=Math.min(7,se.length-1);for(let Te=W+1;Te<Ie;Te++){const Ve=ce(se,Te);if(Ve){const Ge=ke(Ve,Ve.toLowerCase(),W,G,_,de,Ae);Ge&&(Ge[0]-=3,(!be||Ge[0]>be[0])&&(be=Ge))}}}return be}function ce(se,M){if(M+1>=se.length)return;const W=se[M],G=se[M+1];if(W!==G)return se.slice(0,M)+G+W+se.slice(M+2)}}),define(De[88],Ce([1,0,8]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(u){return l(u,0)}e.hash=A;function l(u,g){switch(typeof u){case"object":return u===null?R(349,g):Array.isArray(u)?S(u,g):k(u,g);case"string":return P(u,g);case"boolean":return C(u,g);case"number":return R(u,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=l;function R(u,g){return(g<<5)-g+u|0}e.numberHash=R;function C(u,g){return R(u?433:863,g)}function P(u,g){g=R(149417,g);for(let b=0,D=u.length;b<D;b++)g=R(u.charCodeAt(b),g);return g}e.stringHash=P;function S(u,g){return g=R(104579,g),u.reduce((b,D)=>l(D,b),g)}function k(u,g){return g=R(181387,g),Object.keys(u).sort().reduce((b,D)=>(b=P(D,b),l(u[D],b)),g)}class L{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=l(g,this.g),this.g}}e.Hasher=L;var T;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function v(u,g,b=32){const D=b-g,p=~((1<<D)-1);return(u<<g|(p&u)>>>D)>>>0}function I(u,g=0,b=u.byteLength,D=0){for(let p=0;p<b;p++)u[g+p]=D}function y(u,g,b="0"){for(;u.length<g;)u=b+u;return u}function h(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(b=>b.toString(16).padStart(2,"0")).join(""):y((u>>>0).toString(16),g/4)}e.toHexString=h;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const b=g.length;if(b===0)return;const D=this.p;let p=this.r,i=this.u,o,r;for(i!==0?(o=i,r=-1,i=0):(o=g.charCodeAt(0),r=0);;){let c=o;if(a.isHighSurrogate(o))if(r+1<b){const s=g.charCodeAt(r+1);a.isLowSurrogate(s)?(r++,c=a.computeCodePoint(o,s)):c=65533}else{i=o;break}else a.isLowSurrogate(o)&&(c=65533);if(p=this.w(D,p,c),r++,r<b)o=g.charCodeAt(r);else break}this.r=p,this.u=i}w(g,b,D){return D<128?g[b++]=D:D<2048?(g[b++]=192|(D&1984)>>>6,g[b++]=128|(D&63)>>>0):D<65536?(g[b++]=224|(D&61440)>>>12,g[b++]=128|(D&4032)>>>6,g[b++]=128|(D&63)>>>0):(g[b++]=240|(D&1835008)>>>18,g[b++]=128|(D&258048)>>>12,g[b++]=128|(D&4032)>>>6,g[b++]=128|(D&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=d.g,b=this.q;for(let n=0;n<64;n+=4)g.setUint32(n,b.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)g.setUint32(n,v(g.getUint32(n-12,!1)^g.getUint32(n-32,!1)^g.getUint32(n-56,!1)^g.getUint32(n-64,!1),1),!1);let D=this.h,p=this.l,i=this.m,o=this.n,r=this.o,c,s,m;for(let n=0;n<80;n++)n<20?(c=p&i|~p&o,s=1518500249):n<40?(c=p^i^o,s=1859775393):n<60?(c=p&i|p&o|i&o,s=2400959708):(c=p^i^o,s=3395469782),m=v(D,5)+c+r+s+g.getUint32(n*4,!1)&4294967295,r=o,o=i,i=v(p,30),p=D,D=m;this.h=this.h+D&4294967295,this.l=this.l+p&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}d.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=d}),define(De[111],Ce([1,0,108,110,88,11,10,8]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,k=[S,[]];function L($,z,ae,ee){if(!$||!z)return k;const q=$.length,J=z.length;if(q<J)return k;const ie=$.toLowerCase();return T(z,ae,J,$,ie,q,ee)}e.scoreFuzzy=L;function T($,z,ae,ee,q,J,ie){const ge=[],X=[];for(let ve=0;ve<ae;ve++){const ke=ve*J,Oe=ke-J,oe=ve>0,le=$[ve],ue=z[ve];for(let te=0;te<J;te++){const ce=te>0,se=ke+te,M=se-1,W=Oe+te-1,G=ce?ge[M]:0,_=oe&&ce?ge[W]:0,de=oe&&ce?X[W]:0;let we;!_&&oe?we=0:we=v(le,ue,ee,q,te,de),we&&_+we>=G&&(ie||oe||q.startsWith(z,te))?(X[se]=de+1,ge[se]=_+we):(X[se]=S,ge[se]=G)}}const Y=[];let Z=ae-1,fe=J-1;for(;Z>=0&&fe>=0;){const ve=Z*J+fe;X[ve]===S||(Y.push(fe),Z--),fe--}return[ge[ae*J-1],Y.reverse()]}function v($,z,ae,ee,q,J){let ie=0;if(!I(z,ee[q]))return ie;if(ie+=1,J>0&&(ie+=J*5),$===ae[q]&&(ie+=1),q===0)ie+=8;else{const ge=y(ae.charCodeAt(q-1));ge?ie+=ge:(0,A.isUpper)(ae.charCodeAt(q))&&J===0&&(ie+=2)}return ie}function I($,z){return $===z?!0:$==="/"||$==="\\"?z==="/"||z==="\\":!1}function y($){switch($){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function d($,z,ae=0,ee=0){const q=z;return q.values&&q.values.length>1?u($,q.values,ae,ee):g($,z,ae,ee)}e.scoreFuzzy2=d;function u($,z,ae,ee){let q=0;const J=[];for(const ie of z){const[ge,X]=g($,ie,ae,ee);if(typeof ge!="number")return h;q+=ge,J.push(...X)}return[q,t(J)]}function g($,z,ae,ee){const q=(0,A.fuzzyScore)(z.original,z.originalLowercase,ae,$,$.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,A.createMatches)(q)]:h}const b=Object.freeze({score:0}),D=1<<18,p=1<<17,i=1<<16;function o($,z,ae,ee){const q=ee.values?ee.values:[ee];return(0,l.hash)({[ee.normalized]:{values:q.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:$,description:z,allowNonContiguousMatches:ae}})}function r($,z,ae,ee,q){if(!$||!z.normalized)return b;const J=ee.getItemLabel($);if(!J)return b;const ie=ee.getItemDescription($),ge=o(J,ie,ae,z),X=q[ge];if(X)return X;const Y=c(J,ie,ee.getItemPath($),z,ae);return q[ge]=Y,Y}e.scoreItemFuzzy=r;function c($,z,ae,ee,q){const J=!ae||!ee.containsPathSeparator;return ae&&(C.isLinux?ee.pathNormalized===ae:(0,P.equalsIgnoreCase)(ee.pathNormalized,ae))?{score:D,labelMatch:[{start:0,end:$.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:ee.values&&ee.values.length>1?s($,z,ae,ee.values,J,q):m($,z,ae,ee,J,q)}function s($,z,ae,ee,q,J){let ie=0;const ge=[],X=[];for(const Y of ee){const{score:Z,labelMatch:fe,descriptionMatch:ve}=m($,z,ae,Y,q,J);if(Z===S)return b;ie+=Z,fe&&ge.push(...fe),ve&&X.push(...ve)}return{score:ie,labelMatch:t(ge),descriptionMatch:t(X)}}function m($,z,ae,ee,q,J){if(q||!z){const[ie,ge]=L($,ee.normalized,ee.normalizedLowercase,J&&!ee.expectContiguousMatch);if(ie){const X=(0,A.matchesPrefix)(ee.normalized,$);let Y;return X?(Y=p,Y+=Math.round(ee.normalized.length/$.length*100)):Y=i,{score:Y+ie,labelMatch:X||n(ge)}}}if(z){let ie=z;ae&&(ie=`${z}${R.sep}`);const ge=ie.length,X=`${ie}${$}`,[Y,Z]=L(X,ee.normalized,ee.normalizedLowercase,J&&!ee.expectContiguousMatch);if(Y){const fe=n(Z),ve=[],ke=[];return fe.forEach(Oe=>{Oe.start<ge&&Oe.end>ge?(ve.push({start:0,end:Oe.end-ge}),ke.push({start:Oe.start,end:ge})):Oe.start>=ge?ve.push({start:Oe.start-ge,end:Oe.end-ge}):ke.push(Oe)}),{score:Y,labelMatch:ve,descriptionMatch:ke}}}return b}function n($){const z=[];if(!$)return z;let ae;for(const ee of $)ae&&ae.end===ee?ae.end+=1:(ae={start:ee,end:ee+1},z.push(ae));return z}function t($){const z=$.sort((q,J)=>q.start-J.start),ae=[];let ee;for(const q of z)!ee||!f(ee,q)?(ee=q,ae.push(q)):(ee.start=Math.min(ee.start,q.start),ee.end=Math.max(ee.end,q.end));return ae}function f($,z){return!($.end<z.start||z.end<$.start)}function E($,z,ae,ee,q,J){const ie=r($,ae,ee,q,J),ge=r(z,ae,ee,q,J),X=ie.score,Y=ge.score;if((X===D||Y===D)&&X!==Y)return X===D?-1:1;if(X>i||Y>i){if(X!==Y)return X>Y?-1:1;if(X<p&&Y<p){const le=O(ie.labelMatch,ge.labelMatch);if(le!==0)return le}const Oe=q.getItemLabel($)||"",oe=q.getItemLabel(z)||"";if(Oe.length!==oe.length)return Oe.length-oe.length}if(X!==Y)return X>Y?-1:1;const Z=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,fe=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(Z&&!fe)return-1;if(fe&&!Z)return 1;const ve=w($,ie,q),ke=w(z,ge,q);return ve&&ke&&ve!==ke?ke>ve?-1:1:V($,z,ae,q)}e.compareItemsByFuzzyScore=E;function w($,z,ae){let ee=-1,q=-1;if(z.descriptionMatch&&z.descriptionMatch.length?ee=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(ee=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(q=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const J=ae.getItemDescription($);J&&(q+=J.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(q=z.descriptionMatch[z.descriptionMatch.length-1].end);return q-ee}function O($,z){if(!$&&!z||(!$||!$.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!$||!$.length)return 1;const ae=$[0].start,q=$[$.length-1].end-ae,J=z[0].start,ge=z[z.length-1].end-J;return q===ge?0:ge<q?1:-1}function V($,z,ae,ee){const q=ee.getItemLabel($)||"",J=ee.getItemLabel(z)||"",ie=ee.getItemDescription($),ge=ee.getItemDescription(z),X=q.length+(ie?ie.length:0),Y=J.length+(ge?ge.length:0);if(X!==Y)return X-Y;const Z=ee.getItemPath($),fe=ee.getItemPath(z);return Z&&fe&&Z.length!==fe.length?Z.length-fe.length:q!==J?(0,a.compareAnything)(q,J,ae.normalized):ie&&ge&&ie!==ge?(0,a.compareAnything)(ie,ge,ae.normalized):Z&&fe&&Z!==fe?(0,a.compareAnything)(Z,fe,ae.normalized):0}function j($){return $.startsWith('"')&&$.endsWith('"')}const F=" ";function B($){typeof $!="string"&&($="");const z=$.toLowerCase(),{pathNormalized:ae,normalized:ee,normalizedLowercase:q}=N($),J=ae.indexOf(R.sep)>=0,ie=j($);let ge;const X=$.split(F);if(X.length>1)for(const Y of X){const Z=j(Y),{pathNormalized:fe,normalized:ve,normalizedLowercase:ke}=N(Y);ve&&(ge||(ge=[]),ge.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:fe,normalized:ve,normalizedLowercase:ke,expectContiguousMatch:Z}))}return{original:$,originalLowercase:z,pathNormalized:ae,normalized:ee,normalizedLowercase:q,values:ge,containsPathSeparator:J,expectContiguousMatch:ie}}e.prepareQuery=B;function N($){let z;C.isWindows?z=$.replace(/\//g,R.sep):z=$.replace(/\\/g,R.sep);const ae=(0,P.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:ae,normalizedLowercase:ae.toLowerCase()}}function U($){return Array.isArray($)?B($.map(z=>z.original).join(F)):B($.original)}e.pieceToQuery=U}),define(De[163],Ce([1,0,110,8,51]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",C=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${C.source}`,"g");function S(u){return u.replace(P,(g,b)=>b?g:`\\${g}`)}e.escapeIcons=S;const k=new RegExp(`\\\\${C.source}`,"g");function L(u){return u.replace(k,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(u){return u.indexOf(R)===-1?u:u.replace(T,(g,b,D,p)=>D?g:b||p||"")}e.stripIcons=v;function I(u){return u?u.replace(/\$\((.*?)\)/g,(g,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=I;const y=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(u){y.lastIndex=0;let g="";const b=[];let D=0;for(;;){const p=y.lastIndex,i=y.exec(u),o=u.substring(p,i?.index);if(o.length>0){g+=o;for(let r=0;r<o.length;r++)b.push(D)}if(!i)break;D+=i[0].length}return{text:g,iconOffsets:b}}e.parseLabelWithIcons=h;function d(u,g,b=!1){const{text:D,iconOffsets:p}=g;if(!p||p.length===0)return(0,a.matchesFuzzy)(u,D,b);const i=(0,A.ltrim)(D," "),o=D.length-i.length,r=(0,a.matchesFuzzy)(u,i,b);if(r)for(const c of r){const s=p[c.start+o]+o;c.start+=s,c.end+=s}return r}e.matchesFuzzyIconAware=d}),define(De[37],Ce([1,0,8]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(A||(A={})),function(l){const R="error",C="warning",P="warn",S="info",k="ignore";function L(v){return v?a.equalsIgnoreCase(R,v)?l.Error:a.equalsIgnoreCase(C,v)||a.equalsIgnoreCase(P,v)?l.Warning:a.equalsIgnoreCase(S,v)?l.Info:l.Ignore:l.Ignore}l.fromValue=L;function T(v){switch(v){case l.Error:return R;case l.Warning:return C;case l.Info:return S;default:return k}}l.toString=T}(A||(A={})),e.default=A}),define(De[68],Ce([1,0,15,8]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(I){return this.b=I,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(I){const y=I.charCodeAt(0),h=this.b.charCodeAt(this.c);return y-h}value(){return this.b[this.c]}}e.StringIterator=l;class R{constructor(I=!0){this.e=I}reset(I){return this.b=I,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let I=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(I)this.c++;else break;else I=!1;return this}cmp(I){return this.e?(0,A.compareSubstring)(I,this.b,0,I.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class C{constructor(I=!0,y=!0){this.f=I,this.g=y}reset(I){this.d=0,this.e=0,this.b=I,this.c=I.length;for(let y=I.length-1;y>=0;y--,this.c--){const h=this.b.charCodeAt(y);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let I=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(I)this.d++;else break;else I=!1}return this}cmp(I){return this.g?(0,A.compareSubstring)(I,this.b,0,I.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(I,y){this.f=I,this.g=y,this.d=[],this.e=0}reset(I){return this.c=I,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(I)),this.b.reset(I.path),this.b.value()&&this.d.push(3)),this.g(I)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(I){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(I,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(I,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(I);if(this.d[this.e]===4)return(0,A.compare)(I,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(I,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const I=this.right;return this.right=I.left,I.left=this,this.updateHeight(),I.updateHeight(),I}rotateRight(){const I=this.left;return this.left=I.right,I.right=this,this.updateHeight(),I.updateHeight(),I}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class T{static forUris(I=()=>!1,y=()=>!1){return new T(new S(I,y))}static forPaths(I=!1){return new T(new C(void 0,!I))}static forStrings(){return new T(new l)}static forConfigKeys(){return new T(new R)}constructor(I){this.b=I}clear(){this.c=void 0}fill(I,y){if(y){const h=y.slice(0);(0,a.shuffle)(h);for(const d of h)this.set(d,I)}else{const h=I.slice(0);(0,a.shuffle)(h);for(const d of h)this.set(d[0],d[1])}}set(I,y){const h=this.b.reset(I);let d;this.c||(this.c=new k,this.c.segment=h.value());const u=[];for(d=this.c;;){const b=h.cmp(d.segment);if(b>0)d.left||(d.left=new k,d.left.segment=h.value()),u.push([-1,d]),d=d.left;else if(b<0)d.right||(d.right=new k,d.right.segment=h.value()),u.push([1,d]),d=d.right;else if(h.hasNext())h.next(),d.mid||(d.mid=new k,d.mid.segment=h.value()),u.push([0,d]),d=d.mid;else break}const g=d.value;d.value=y,d.key=I;for(let b=u.length-1;b>=0;b--){const D=u[b][1];D.updateHeight();const p=D.balanceFactor();if(p<-1||p>1){const i=u[b][0],o=u[b+1][0];if(i===1&&o===1)u[b][1]=D.rotateLeft();else if(i===-1&&o===-1)u[b][1]=D.rotateRight();else if(i===1&&o===-1)D.right=u[b+1][1]=u[b+1][1].rotateRight(),u[b][1]=D.rotateLeft();else if(i===-1&&o===1)D.left=u[b+1][1]=u[b+1][1].rotateLeft(),u[b][1]=D.rotateRight();else throw new Error;if(b>0)switch(u[b-1][0]){case-1:u[b-1][1].left=u[b][1];break;case 1:u[b-1][1].right=u[b][1];break;case 0:u[b-1][1].mid=u[b][1];break}else this.c=u[0][1]}}return g}get(I){return this.d(I)?.value}d(I){const y=this.b.reset(I);let h=this.c;for(;h;){const d=y.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(y.hasNext())y.next(),h=h.mid;else break}return h}has(I){const y=this.d(I);return!(y?.value===void 0&&y?.mid===void 0)}delete(I){return this.e(I,!1)}deleteSuperstr(I){return this.e(I,!0)}e(I,y){const h=this.b.reset(I),d=[];let u=this.c;for(;u;){const g=h.cmp(u.segment);if(g>0)d.push([-1,u]),u=u.left;else if(g<0)d.push([1,u]),u=u.right;else if(h.hasNext())h.next(),d.push([0,u]),u=u.mid;else break}if(!!u){if(y?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:b,value:D,segment:p}=g;this.e(g.key,!1),u.key=b,u.value=D,u.segment=p}}else{const g=u.left??u.right;if(d.length>0){const[b,D]=d[d.length-1];switch(b){case-1:D.left=g;break;case 0:D.mid=g;break;case 1:D.right=g;break}}else this.c=g}for(let g=d.length-1;g>=0;g--){const b=d[g][1];b.updateHeight();const D=b.balanceFactor();if(D>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),d[g][1]=b.rotateLeft()):D<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),d[g][1]=b.rotateRight()),g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this.c=d[0][1]}}}f(I){for(;I.left;)I=I.left;return I}findSubstr(I){const y=this.b.reset(I);let h=this.c,d;for(;h;){const u=y.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(y.hasNext())y.next(),d=h.value||d,h=h.mid;else break}return h&&h.value||d}findSuperstr(I){return this.g(I,!1)}g(I,y){const h=this.b.reset(I);let d=this.c;for(;d;){const u=h.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(h.hasNext())h.next(),d=d.mid;else return d.mid?this.h(d.mid):y?d.value:void 0}}hasElementOrSubtree(I){return this.g(I,!0)!==void 0}forEach(I){for(const[y,h]of this)I(h,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(I){const y=[];return this.j(I,y),y[Symbol.iterator]()}j(I,y){!I||(I.left&&this.j(I.left,y),I.value&&y.push([I.key,I.value]),I.mid&&this.j(I.mid,y),I.right&&this.j(I.right,y))}_isBalanced(){const I=y=>{if(!y)return!0;const h=y.balanceFactor();return h<-1||h>1?!1:I(y.left)&&I(y.right)};return I(this.c)}}e.TernarySearchTree=T}),define(De[2],Ce([1,0,11,10]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function P(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,c){return!r&&!c?"file":r}function k(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==T&&(c=T+c):c=T;break}return c}const L="",T="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{static isUri(c){return c instanceof I?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,s,m,n,t,f=!1){typeof c=="object"?(this.scheme=c.scheme||L,this.authority=c.authority||L,this.path=c.path||L,this.query=c.query||L,this.fragment=c.fragment||L):(this.scheme=S(c,f),this.authority=s||L,this.path=k(this.scheme,m||L),this.query=n||L,this.fragment=t||L,P(this,f))}get fsPath(){return b(this,!1)}with(c){if(!c)return this;let{scheme:s,authority:m,path:n,query:t,fragment:f}=c;return s===void 0?s=this.scheme:s===null&&(s=L),m===void 0?m=this.authority:m===null&&(m=L),n===void 0?n=this.path:n===null&&(n=L),t===void 0?t=this.query:t===null&&(t=L),f===void 0?f=this.fragment:f===null&&(f=L),s===this.scheme&&m===this.authority&&n===this.path&&t===this.query&&f===this.fragment?this:new h(s,m,n,t,f)}static parse(c,s=!1){const m=v.exec(c);return m?new h(m[2]||L,o(m[4]||L),o(m[5]||L),o(m[7]||L),o(m[9]||L),s):new h(L,L,L,L,L)}static file(c){let s=L;if(A.isWindows&&(c=c.replace(/\\/g,T)),c[0]===T&&c[1]===T){const m=c.indexOf(T,2);m===-1?(s=c.substring(2),c=T):(s=c.substring(2,m),c=c.substring(m)||T)}return new h("file",s,c,L,L)}static from(c){const s=new h(c.scheme,c.authority,c.path,c.query,c.fragment);return P(s,!0),s}static joinPath(c,...s){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.isWindows&&c.scheme==="file"?m=I.file(a.win32.join(b(c,!0),...s)).path:m=a.posix.join(c.path,...s),c.with({path:m})}toString(c=!1){return D(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof I)return c;{const s=new h(c);return s._formatted=c.external,s._fsPath=c._sep===y?c.fsPath:null,s}}else return c}}e.URI=I;const y=A.isWindows?1:void 0;class h extends I{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(c=!1){return c?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=y),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(r,c,s){let m,n=-1;for(let t=0;t<r.length;t++){const f=r.charCodeAt(t);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||c&&f===47||s&&f===91||s&&f===93||s&&f===58)n!==-1&&(m+=encodeURIComponent(r.substring(n,t)),n=-1),m!==void 0&&(m+=r.charAt(t));else{m===void 0&&(m=r.substr(0,t));const E=d[f];E!==void 0?(n!==-1&&(m+=encodeURIComponent(r.substring(n,t)),n=-1),m+=E):n===-1&&(n=t)}}return n!==-1&&(m+=encodeURIComponent(r.substring(n))),m!==void 0?m:r}function g(r){let c;for(let s=0;s<r.length;s++){const m=r.charCodeAt(s);m===35||m===63?(c===void 0&&(c=r.substr(0,s)),c+=d[m]):c!==void 0&&(c+=r[s])}return c!==void 0?c:r}function b(r,c){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,A.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=b;function D(r,c){const s=c?g:u;let m="",{scheme:n,authority:t,path:f,query:E,fragment:w}=r;if(n&&(m+=n,m+=":"),(t||n==="file")&&(m+=T,m+=T),t){let O=t.indexOf("@");if(O!==-1){const V=t.substr(0,O);t=t.substr(O+1),O=V.lastIndexOf(":"),O===-1?m+=s(V,!1,!1):(m+=s(V.substr(0,O),!1,!1),m+=":",m+=s(V.substr(O+1),!1,!0)),m+="@"}t=t.toLowerCase(),O=t.lastIndexOf(":"),O===-1?m+=s(t,!1,!0):(m+=s(t.substr(0,O),!1,!0),m+=t.substr(O))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const O=f.charCodeAt(1);O>=65&&O<=90&&(f=`/${String.fromCharCode(O+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const O=f.charCodeAt(0);O>=65&&O<=90&&(f=`${String.fromCharCode(O+32)}:${f.substr(2)}`)}m+=s(f,!0,!1)}return E&&(m+="?",m+=s(E,!1,!1)),w&&(m+="#",m+=c?w:u(w,!1,!1)),m}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(i)?r.replace(i,c=>p(c)):r}}),define(De[69],Ce([1,0,22,8,2]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(k){return JSON.stringify(k,P)}e.stringify=R;function C(k){let L=JSON.parse(k);return L=S(L),L}e.parse=C;function P(k,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function S(k,L=0){if(!k||L>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return l.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof a.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let T=0;T<k.length;++T)k[T]=S(k[T],L+1);else for(const T in k)Object.hasOwnProperty.call(k,T)&&(k[T]=S(k[T],L+1))}return k}e.revive=S}),define(De[16],Ce([1,0,12,10,2]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,T,v){this.a[L]=T,this.b[L]=v}setConnectionToken(L,T){this.c[L]=T}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(d){return a.onUnexpectedError(d),L}const T=L.authority;let v=this.a[T];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const I=this.b[T],y=this.c[T];let h=`path=${encodeURIComponent(L.path)}`;return typeof y=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),l.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${I}`,path:this.f,query:h})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(L){const T=this.b(L,ne);return this.uriToBrowserUri(T)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${P.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||P.a,query:null,fragment:null}):L}asFileUri(L){const T=this.b(L,ne);return this.uriToFileUri(T)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==P.a?L.authority:null,query:null,fragment:null}):L}b(L,T){return l.URI.isUri(L)?L:l.URI.parse(T.toUrl(L))}}P.a="vscode-app",e.FileAccess=new P;var S;(function(k){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(L.get("3"));const T="vscode-coi";function v(y){let h;typeof y=="string"?h=new URL(y).searchParams:y instanceof URL?h=y.searchParams:l.URI.isUri(y)&&(h=new URL(y.toString(!0)).searchParams);const d=h?.get(T);if(!!d)return L.get(d)}k.getHeadersFromQuery=v;function I(y,h,d){if(!globalThis.crossOriginIsolated)return;const u=h&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(T,u):y[T]=u}k.addSearchParam=I})(S=e.COI||(e.COI={}))}),define(De[24],Ce([1,0,33,16,11,10,8,2]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(I){return(0,P.uriToFsPath)(I,!0)}e.originalFSPath=S;class k{constructor(y){this.a=y}compare(y,h,d=!1){return y===h?0:(0,C.compare)(this.getComparisonKey(y,d),this.getComparisonKey(h,d))}isEqual(y,h,d=!1){return y===h?!0:!y||!h?!1:this.getComparisonKey(y,d)===this.getComparisonKey(h,d)}getComparisonKey(y,h=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,h,d=!1){if(y.scheme===h.scheme){if(y.scheme===A.Schemas.file)return a.isEqualOrParent(S(y),S(h),this.a(y))&&y.query===h.query&&(d||y.fragment===h.fragment);if((0,e.isEqualAuthority)(y.authority,h.authority))return a.isEqualOrParent(y.path,h.path,this.a(y),"/")&&y.query===h.query&&(d||y.fragment===h.fragment)}return!1}joinPath(y,...h){return P.URI.joinPath(y,...h)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return l.posix.basename(y.path)}extname(y){return l.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let h;return y.scheme===A.Schemas.file?h=P.URI.file(l.dirname(S(y))).path:(h=l.posix.dirname(y.path),y.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),h="/")),y.with({path:h})}normalizePath(y){if(!y.path.length)return y;let h;return y.scheme===A.Schemas.file?h=P.URI.file(l.normalize(S(y))).path:h=l.posix.normalize(y.path),y.with({path:h})}relativePath(y,h){if(y.scheme!==h.scheme||!(0,e.isEqualAuthority)(y.authority,h.authority))return;if(y.scheme===A.Schemas.file){const g=l.relative(S(y),S(h));return R.isWindows?a.toSlashes(g):g}let d=y.path||"/";const u=h.path||"/";if(this.a(y)){let g=0;for(const b=Math.min(d.length,u.length);g<b&&!(d.charCodeAt(g)!==u.charCodeAt(g)&&d.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);d=u.substr(0,g)+d.substr(g)}return l.posix.relative(d,u)}resolvePath(y,h){if(y.scheme===A.Schemas.file){const d=P.URI.file(l.resolve(S(y),h));return y.with({authority:d.authority,path:d.path})}return h=a.toPosixPath(h),y.with({path:l.posix.resolve(y.path,h)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,h){return y===h||y!==void 0&&h!==void 0&&(0,C.equalsIgnoreCase)(y,h)}hasTrailingPathSeparator(y,h=l.sep){if(y.scheme===A.Schemas.file){const d=S(y);return d.length>a.getRoot(d).length&&d[d.length-1]===h}else{const d=y.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,h=l.sep){return(0,e.hasTrailingPathSeparator)(y,h)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,h=l.sep){let d=!1;if(y.scheme===A.Schemas.file){const u=S(y);d=u!==void 0&&u.length===a.getRoot(u).length&&u[u.length-1]===h}else{h="/";const u=y.path;d=u.length===1&&u.charCodeAt(u.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(y,h)?y.with({path:y.path+"/"}):y}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(I=>I.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new k(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,y){const h=[];for(let d=0;d<I.length;d++){const u=y(I[d]);I.some((g,b)=>b===d?!1:(0,e.isEqualOrParent)(u,y(g)))||h.push(I[d])}return h}e.distinctParents=L;var T;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function y(h){const d=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(b=>{const[D,p]=b.split(":");D&&p&&d.set(D,p)});const g=h.path.substring(0,h.path.indexOf(";"));return g&&d.set(I.META_DATA_MIME,g),d}I.parseMetaData=y})(T=e.DataUri||(e.DataUri={}));function v(I,y,h){if(y){let d=I.path;return d&&d[0]!==l.posix.sep&&(d=l.posix.sep+d),I.with({scheme:h,authority:y,path:d})}return I.with({scheme:h})}e.toLocalResource=v}),define(De[19],Ce([1,0,21,12,3,6,24,10,148]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=k;function L(Y){const Z=new a.CancellationTokenSource,fe=Y(Z.token),ve=new Promise((ke,Oe)=>{const oe=Z.token.onCancellationRequested(()=>{oe.dispose(),Z.dispose(),Oe(new A.CancellationError)});Promise.resolve(fe).then(le=>{oe.dispose(),Z.dispose(),ke(le)},le=>{oe.dispose(),Z.dispose(),Oe(le)})});return new class{cancel(){Z.cancel()}then(ke,Oe){return ve.then(ke,Oe)}catch(ke){return this.then(void 0,ke)}finally(ke){return ve.finally(ke)}}}e.createCancelablePromise=L;function T(Y,Z,fe){return new Promise((ve,ke)=>{const Oe=Z.onCancellationRequested(()=>{Oe.dispose(),ve(fe)});Y.then(ve,ke).finally(()=>Oe.dispose())})}e.raceCancellation=T;function v(Y,Z){return new Promise((fe,ve)=>{const ke=Z.onCancellationRequested(()=>{ke.dispose(),ve(new A.CancellationError)});Y.then(fe,ve).finally(()=>ke.dispose())})}e.raceCancellationError=v;async function I(Y){let Z=-1;const fe=Y.map((ke,Oe)=>ke.then(oe=>(Z=Oe,oe))),ve=await Promise.race(fe);return Y.forEach((ke,Oe)=>{Oe!==Z&&ke.cancel()}),ve}e.raceCancellablePromises=I;function y(Y,Z,fe){let ve;const ke=setTimeout(()=>{ve?.(void 0),fe?.()},Z);return Promise.race([Y.finally(()=>clearTimeout(ke)),new Promise(Oe=>ve=Oe)])}e.raceTimeout=y;function h(Y){return new Promise((Z,fe)=>{const ve=Y();k(ve)?ve.then(Z,fe):Z(ve)})}e.asPromise=h;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const fe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(fe,fe).then(ve)})}return new Promise((fe,ve)=>{this.b.then(fe,ve)})}return this.a=Z(),new Promise((fe,ve)=>{this.a.then(ke=>{this.a=null,fe(ke)},ke=>{this.a=null,ve(ke)})})}}e.Throttler=d;class u{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=u;class g{constructor(){this.a=new Map}queue(Z,fe){const ke=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(fe).finally(()=>{this.a.get(Z)===ke&&this.a.delete(Z)});return this.a.set(Z,ke),ke}}e.SequencerByKey=g;const b=(Y,Z)=>{let fe=!0;const ve=setTimeout(()=>{fe=!1,Z()},Y);return{isTriggered:()=>fe,dispose:()=>{clearTimeout(ve),fe=!1}}},D=Y=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,Y())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class p{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,fe=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((ke,Oe)=>{this.d=ke,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const ke=this.g;return this.g=null,ke()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=fe===S.MicrotaskDelay?D(ve):b(fe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class i{constructor(Z){this.a=new p(Z),this.b=new d}trigger(Z,fe){return this.a.trigger(()=>this.b.queue(Z),fe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this.a=!1,this.b=new Promise((Z,fe)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class r extends o{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function c(Y,Z){return Z?new Promise((fe,ve)=>{const ke=setTimeout(()=>{Oe.dispose(),fe()},Y),Oe=Z.onCancellationRequested(()=>{clearTimeout(ke),Oe.dispose(),ve(new A.CancellationError)})}):L(fe=>c(Y,fe))}e.timeout=c;function s(Y,Z=0){const fe=setTimeout(Y,Z);return(0,R.toDisposable)(()=>clearTimeout(fe))}e.disposableTimeout=s;function m(Y){const Z=[];let fe=0;const ve=Y.length;function ke(){return fe<ve?Y[fe++]():null}function Oe(oe){oe!=null&&Z.push(oe);const le=ke();return le?le.then(Oe):Promise.resolve(Z)}return Promise.resolve(null).then(Oe)}e.sequence=m;function n(Y,Z=ve=>!!ve,fe=null){let ve=0;const ke=Y.length,Oe=()=>{if(ve>=ke)return Promise.resolve(fe);const oe=Y[ve++];return Promise.resolve(oe()).then(ue=>Z(ue)?Promise.resolve(ue):Oe())};return Oe()}e.first=n;function t(Y,Z=ve=>!!ve,fe=null){if(Y.length===0)return Promise.resolve(fe);let ve=Y.length;const ke=()=>{ve=-1;for(const Oe of Y)Oe.cancel?.()};return new Promise((Oe,oe)=>{for(const le of Y)le.then(ue=>{--ve>=0&&Z(ue)?(ke(),Oe(ue)):ve===0&&Oe(fe)}).catch(ue=>{--ve>=0&&(ke(),oe(ue))})})}e.firstParallel=t;class f{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((fe,ve)=>{this.f.push({factory:Z,c:fe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const fe=Z.factory();fe.then(Z.c,Z.e),fe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class E extends f{constructor(){super(1)}}e.Queue=E;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new ee;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,fe=C.extUri){const ve=fe.getComparisonKey(Z);let ke=this.a.get(ve);return ke||(ke=new E,l.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,ke)),ke}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=w;class O{constructor(Z,fe){this.a=-1,typeof Z=="function"&&typeof fe=="number"&&this.setIfNotSet(Z,fe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,fe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},fe)}setIfNotSet(Z,fe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},fe))}}e.TimeoutTimer=O;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,fe){this.cancel(),this.a=setInterval(()=>{Z()},fe)}}e.IntervalTimer=V;class j{constructor(Z,fe){this.b=-1,this.a=Z,this.d=fe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class F{constructor(Z,fe){fe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${fe}ms is not a multiple of 1000ms.`),this.a=Z,this.b=fe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class B extends j{constructor(Z,fe){super(Z,fe),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class N extends R.Disposable{constructor(Z,fe){super(),this.g=Z,this.h=fe,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const fe of Z)this.a.push(fe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,P.setTimeout0)(()=>{if(Z)return;const fe=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(Y,Z)=>{const fe=requestIdleCallback(Y,typeof Z=="number"?{timeout:Z}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(fe))}}}}();class U{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(fe){this.g=fe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=U;async function $(Y,Z,fe){let ve;for(let ke=0;ke<fe;ke++)try{return await Y()}catch(Oe){ve=Oe,await c(Z)}throw ve}e.retry=$;class z{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,fe,ve){return this.a={taskId:Z,cancel:()=>ve?.(),promise:fe},fe.then(()=>this.d(Z),()=>this.d(Z)),fe}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let fe,ve;const ke=new Promise((Oe,oe)=>{fe=Oe,ve=oe});this.b={run:Z,promise:ke,promiseResolve:fe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class ae{constructor(Z,fe=()=>Date.now()){this.d=Z,this.f=fe,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=ae;class ee{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,fe)=>{this.a=Z,this.b=fe})}complete(Z){return new Promise(fe=>{this.a(Z),this.f=!0,fe()})}error(Z){return new Promise(fe=>{this.b(Z),this.d=!0,fe()})}cancel(){new Promise(Z=>{this.b(new A.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=ee;var q;(function(Y){async function Z(ve){let ke;const Oe=await Promise.all(ve.map(oe=>oe.then(le=>le,le=>{ke||(ke=le)})));if(typeof ke<"u")throw ke;return Oe}Y.settled=Z;function fe(ve){return new Promise(async(ke,Oe)=>{try{await ve(ke,Oe)}catch(oe){Oe(oe)}})}Y.withAsyncBody=fe})(q=e.Promises||(e.Promises={}));var J;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(J||(J={}));class ie{static fromArray(Z){return new ie(fe=>{fe.emitMany(Z)})}static fromPromise(Z){return new ie(async fe=>{fe.emitMany(await Z)})}static fromPromises(Z){return new ie(async fe=>{await Promise.all(Z.map(async ve=>fe.emitOne(await ve)))})}static merge(Z){return new ie(async fe=>{await Promise.all(Z.map(async ve=>{for await(const ke of ve)fe.emitOne(ke)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const fe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(Z(fe)),this.j()}catch(ve){this.k(ve)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,fe){return new ie(async ve=>{for await(const ke of Z)ve.emitOne(fe(ke))})}map(Z){return ie.map(this,Z)}static filter(Z,fe){return new ie(async ve=>{for await(const ke of Z)fe(ke)&&ve.emitOne(ke)})}filter(Z){return ie.filter(this,Z)}static coalesce(Z){return ie.filter(Z,fe=>!!fe)}coalesce(){return ie.coalesce(this)}static async toPromise(Z){const fe=[];for await(const ve of Z)fe.push(ve);return fe}toPromise(){return ie.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class ge extends ie{constructor(Z,fe){super(fe),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ge;function X(Y){const Z=new a.CancellationTokenSource,fe=Y(Z.token);return new ge(Z,async ve=>{const ke=Z.token.onCancellationRequested(()=>{ke.dispose(),Z.dispose(),ve.reject(new A.CancellationError)});try{for await(const Oe of fe){if(Z.token.isCancellationRequested)return;ve.emitOne(Oe)}ke.dispose(),Z.dispose()}catch(Oe){ke.dispose(),Z.dispose(),ve.reject(Oe)}})}e.createCancelableAsyncIterable=X}),define(De[38],Ce([1,0,15,19,33,28,11,10,8]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",T="[^/\\\\]",v=/\//g;function I(ae,ee){switch(ae){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}${ee?`|${L}${T}+`:""})*?`}}function y(ae,ee){if(!ae)return[];const q=[];let J=!1,ie=!1,ge="";for(const X of ae){switch(X){case ee:if(!J&&!ie){q.push(ge),ge="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ge+=X}return ge&&q.push(ge),q}e.splitGlobAware=y;function h(ae){if(!ae)return"";let ee="";const q=y(ae,e.GLOB_SPLIT);if(q.every(J=>J===e.GLOBSTAR))ee=".*";else{let J=!1;q.forEach((ie,ge)=>{if(ie===e.GLOBSTAR){if(J)return;ee+=I(2,ge===q.length-1)}else{let X=!1,Y="",Z=!1,fe="";for(const ve of ie){if(ve!=="}"&&X){Y+=ve;continue}if(Z&&(ve!=="]"||!fe)){let ke;ve==="-"?ke=ve:(ve==="^"||ve==="!")&&!fe?ke="^":ve===e.GLOB_SPLIT?ke="":ke=(0,S.escapeRegExpCharacters)(ve),fe+=ke;continue}switch(ve){case"{":X=!0;continue;case"[":Z=!0;continue;case"}":{ee+=`(?:${y(Y,",").map(oe=>h(oe)).join("|")})`,X=!1,Y="";break}case"]":{ee+="["+fe+"]",Z=!1,fe="";break}case"?":ee+=T;continue;case"*":ee+=I(1);continue;default:ee+=(0,S.escapeRegExpCharacters)(ve)}}ge<q.length-1&&(q[ge+1]!==e.GLOBSTAR||ge+2<q.length)&&(ee+=L)}J=ie===e.GLOBSTAR})}return ee}const d=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},r=function(){return null};function c(ae,ee){if(!ae)return r;let q;typeof ae!="string"?q=ae.pattern:q=ae,q=q.trim();const J=`${q}_${!!ee.trimForExclusions}`;let ie=i.get(J);if(ie)return s(ie,ae);let ge;return d.test(q)?ie=n(q.substr(4),q):(ge=u.exec(m(q,ee)))?ie=t(ge[1],q):(ee.trimForExclusions?b:g).test(q)?ie=f(q,ee):(ge=D.exec(m(q,ee)))?ie=E(ge[1].substr(1),q,!0):(ge=p.exec(m(q,ee)))?ie=E(ge[1],q,!1):ie=w(q),i.set(J,ie),s(ie,ae)}function s(ae,ee){if(typeof ee=="string")return ae;const q=function(J,ie){return(0,l.isEqualOrParent)(J,ee.base,!P.isLinux)?ae((0,S.ltrim)(J.substr(ee.base.length),C.sep),ie):null};return q.allBasenames=ae.allBasenames,q.allPaths=ae.allPaths,q.basenames=ae.basenames,q.patterns=ae.patterns,q}function m(ae,ee){return ee.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function n(ae,ee){return function(q,J){return typeof q=="string"&&q.endsWith(ae)?ee:null}}function t(ae,ee){const q=`/${ae}`,J=`\\${ae}`,ie=function(X,Y){return typeof X!="string"?null:Y?Y===ae?ee:null:X===ae||X.endsWith(q)||X.endsWith(J)?ee:null},ge=[ae];return ie.basenames=ge,ie.patterns=[ee],ie.allBasenames=ge,ie}function f(ae,ee){const q=$(ae.slice(1,-1).split(",").map(Y=>c(Y,ee)).filter(Y=>Y!==r),ae),J=q.length;if(!J)return r;if(J===1)return q[0];const ie=function(Y,Z){for(let fe=0,ve=q.length;fe<ve;fe++)if(q[fe](Y,Z))return ae;return null},ge=q.find(Y=>!!Y.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const X=q.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return X.length&&(ie.allPaths=X),ie}function E(ae,ee,q){const J=C.sep===C.posix.sep,ie=J?ae:ae.replace(v,C.sep),ge=C.sep+ie,X=C.posix.sep+ae;let Y;return q?Y=function(Z,fe){return typeof Z=="string"&&(Z===ie||Z.endsWith(ge)||!J&&(Z===ae||Z.endsWith(X)))?ee:null}:Y=function(Z,fe){return typeof Z=="string"&&(Z===ie||!J&&Z===ae)?ee:null},Y.allPaths=[(q?"*/":"./")+ae],Y}function w(ae){try{const ee=new RegExp(`^${h(ae)}$`);return function(q){return ee.lastIndex=0,typeof q=="string"&&ee.test(q)?ae:null}}catch{return r}}function O(ae,ee,q){return!ae||typeof ee!="string"?!1:V(ae)(ee,void 0,q)}e.match=O;function V(ae,ee={}){if(!ae)return o;if(typeof ae=="string"||j(ae)){const q=c(ae,ee);if(q===r)return o;const J=function(ie,ge){return!!q(ie,ge)};return q.allBasenames&&(J.allBasenames=q.allBasenames),q.allPaths&&(J.allPaths=q.allPaths),J}return N(ae,ee)}e.parse=V;function j(ae){const ee=ae;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.isRelativePattern=j;function F(ae){return ae.allBasenames||[]}e.getBasenameTerms=F;function B(ae){return ae.allPaths||[]}e.getPathTerms=B;function N(ae,ee){const q=$(Object.getOwnPropertyNames(ae).map(Y=>U(Y,ae[Y],ee)).filter(Y=>Y!==r)),J=q.length;if(!J)return r;if(!q.some(Y=>!!Y.requiresSiblings)){if(J===1)return q[0];const Y=function(ve,ke){let Oe;for(let oe=0,le=q.length;oe<le;oe++){const ue=q[oe](ve,ke);if(typeof ue=="string")return ue;(0,A.isThenable)(ue)&&(Oe||(Oe=[]),Oe.push(ue))}return Oe?(async()=>{for(const oe of Oe){const le=await oe;if(typeof le=="string")return le}return null})():null},Z=q.find(ve=>!!ve.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const fe=q.reduce((ve,ke)=>ke.allPaths?ve.concat(ke.allPaths):ve,[]);return fe.length&&(Y.allPaths=fe),Y}const ie=function(Y,Z,fe){let ve,ke;for(let Oe=0,oe=q.length;Oe<oe;Oe++){const le=q[Oe];le.requiresSiblings&&fe&&(Z||(Z=(0,C.basename)(Y)),ve||(ve=Z.substr(0,Z.length-(0,C.extname)(Y).length)));const ue=le(Y,Z,ve,fe);if(typeof ue=="string")return ue;(0,A.isThenable)(ue)&&(ke||(ke=[]),ke.push(ue))}return ke?(async()=>{for(const Oe of ke){const oe=await Oe;if(typeof oe=="string")return oe}return null})():null},ge=q.find(Y=>!!Y.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const X=q.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return X.length&&(ie.allPaths=X),ie}function U(ae,ee,q){if(ee===!1)return r;const J=c(ae,q);if(J===r)return r;if(typeof ee=="boolean")return J;if(ee){const ie=ee.when;if(typeof ie=="string"){const ge=(X,Y,Z,fe)=>{if(!fe||!J(X,Y))return null;const ve=ie.replace("$(basename)",()=>Z),ke=fe(ve);return(0,A.isThenable)(ke)?ke.then(Oe=>Oe?ae:null):ke?ae:null};return ge.requiresSiblings=!0,ge}}return J}function $(ae,ee){const q=ae.filter(Y=>!!Y.basenames);if(q.length<2)return ae;const J=q.reduce((Y,Z)=>{const fe=Z.basenames;return fe?Y.concat(fe):Y},[]);let ie;if(ee){ie=[];for(let Y=0,Z=J.length;Y<Z;Y++)ie.push(ee)}else ie=q.reduce((Y,Z)=>{const fe=Z.patterns;return fe?Y.concat(fe):Y},[]);const ge=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let ve;for(ve=Y.length;ve>0;ve--){const ke=Y.charCodeAt(ve-1);if(ke===47||ke===92)break}Z=Y.substr(ve)}const fe=J.indexOf(Z);return fe!==-1?ie[fe]:null};ge.basenames=J,ge.patterns=ie,ge.allBasenames=J;const X=ae.filter(Y=>!Y.basenames);return X.push(ge),X}function z(ae,ee){return(0,a.equals)(ae,ee,(q,J)=>typeof q=="string"&&typeof J=="string"?q===J:typeof q!="string"&&typeof J!="string"?q.base===J.base&&q.pattern===J.pattern:!1)}e.patternsEquals=z}),define(De[112],Ce([1,0,12,163,24,8,2]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(u="",g=!1){if(this.value=u,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(u,g=0){return this.value+=v(this.supportThemeIcons?(0,A.escapeIcons)(u):u).replace(/([ \t]+)/g,(b,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,g){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(u,g,b){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(u),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(u,g){const b=new RegExp((0,R.escapeRegExpCharacters)(g),"g");return u.replace(b,(D,p)=>u.charAt(p-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=S;function k(d){return L(d)?!d.value:Array.isArray(d)?d.every(k):!0}e.isEmptyMarkdownString=k;function L(d){return d instanceof S?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function T(d,u){return d===u?!0:!d||!u?!1:d.value===u.value&&d.isTrusted===u.isTrusted&&d.supportThemeIcons===u.supportThemeIcons&&d.supportHtml===u.supportHtml&&(d.baseUri===u.baseUri||!!d.baseUri&&!!u.baseUri&&(0,l.isEqual)(C.URI.from(d.baseUri),C.URI.from(u.baseUri)))}e.markdownStringEqual=T;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function I(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function y(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=y;function h(d){const u=[],g=d.split("|").map(D=>D.trim());d=g[0];const b=g[1];if(b){const D=/height=(\d+)/.exec(b),p=/width=(\d+)/.exec(b),i=D?D[1]:"",o=p?p[1]:"",r=isFinite(parseInt(o)),c=isFinite(parseInt(i));r&&u.push(`width="${o}"`),c&&u.push(`height="${i}"`)}return{href:d,dimensions:u}}e.parseHrefAndDimensions=h}),define(De[113],Ce([1,0,15,33,11,10,24,8]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,c){const{os:s,tildify:m,relative:n}=c;if(n){const E=k(r,n,s);if(typeof E=="string")return E}let t=r.fsPath;if(s===1&&!R.isWindows?t=t.replace(/\//g,"\\"):s!==1&&R.isWindows&&(t=t.replace(/\\/g,"/")),s!==1&&m?.userHome){const E=m.userHome.fsPath;let w;r.scheme!==m.userHome.scheme&&r.path.startsWith(l.posix.sep)?w=m.userHome.with({path:r.path}).fsPath:w=r.fsPath,t=v(w,E,s)}return(s===1?l.win32:l.posix).normalize(L(t,s===1))}e.getPathLabel=S;function k(r,c,s){const m=s===1?l.win32:l.posix,n=s===3?C.extUri:C.extUriIgnorePathCase,t=c.getWorkspace(),f=(0,a.firstOrDefault)(t.folders);if(!f)return;r.scheme!==f.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=f.uri.with({path:r.path}));const E=c.getWorkspaceFolder(r);if(!E)return;let w;if(n.isEqual(E.uri,r)?w="":w=n.relativePath(E.uri,r)??"",w&&(w=m.normalize(w)),t.folders.length>1&&!c.noPrefix){const O=E.name?E.name:n.basenameOrAuthority(E.uri);w=w?`${O} \u2022 ${w}`:O}return w}function L(r,c=R.isWindows){return(0,A.hasDriveLetter)(r,c)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let T=Object.create(null);function v(r,c,s=R.OS){if(s===1||!r||!c)return r;let m=T.original===c?T.normalized:void 0;m||(m=c,R.isWindows&&(m=(0,A.toSlashes)(m)),m=`${(0,P.rtrim)(m,l.posix.sep)}${l.posix.sep}`,T={original:c,normalized:m});let n=r;return R.isWindows&&(n=(0,A.toSlashes)(n)),(s===3?n.startsWith(m):(0,P.startsWithIgnoreCase)(n,m))?`~/${n.substr(m.length)}`:r}e.tildify=v;function I(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=I;const y="\u2026",h="\\\\",d="~";function u(r,c=l.sep){const s=new Array(r.length);let m=!1;for(let n=0;n<r.length;n++){const t=r[n];if(t===""){s[n]=`.${c}`;continue}if(!t){s[n]=t;continue}m=!0;let f="",E=t;E.indexOf(h)===0?(f=E.substr(0,E.indexOf(h)+h.length),E=E.substr(E.indexOf(h)+h.length)):E.indexOf(c)===0?(f=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length)):E.indexOf(d)===0&&(f=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length));const w=E.split(c);for(let O=1;m&&O<=w.length;O++)for(let V=w.length-O;m&&V>=0;V--){m=!1;let j=w.slice(V,V+O).join(c);for(let F=0;!m&&F<r.length;F++)if(F!==n&&r[F]&&r[F].indexOf(j)>-1){const B=V+O===w.length,N=V>0&&r[F].indexOf(c)>-1?c+j:j,U=r[F].endsWith(N);m=!B||U}if(!m){let F="";(w[0].endsWith(":")||f!=="")&&(V===1&&(V=0,O++,j=w[0]+c+j),V>0&&(F=w[0]+c),F=f+F),V>0&&(F=F+y+c),F=F+j,V+O<w.length&&(F=F+c+y),s[n]=F}}m&&(s[n]=t)}return s}e.shorten=u;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function b(r,c=Object.create(null)){const s=[];let m=!1,n="";for(const t of r)if(t==="$"||m&&t==="{")n&&s.push({value:n,type:g.TEXT}),n="",m=!0;else if(t==="}"&&m){const f=c[n];if(typeof f=="string")f.length&&s.push({value:f,type:g.VARIABLE});else if(f){const E=s[s.length-1];(!E||E.type!==g.SEPARATOR)&&s.push({value:f.label,type:g.SEPARATOR})}n="",m=!1}else n+=t;return n&&!m&&s.push({value:n,type:g.TEXT}),s.filter((t,f)=>{if(t.type===g.SEPARATOR){const E=s[f-1],w=s[f+1];return[E,w].every(O=>O&&(O.type===g.VARIABLE||O.type===g.TEXT)&&O.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=b;function D(r,c){return R.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function p(r,c){return R.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,s=>s==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(r){const c=r.indexOf("/")!==-1?l.posix:l.win32,s=c.basename(r),m=c.dirname(r);return s.length?{name:s,parentPath:m}:{name:m,parentPath:""}}e.splitName=o}),define(De[114],Ce([1,0,22,2]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(T){return T.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const I=this.a.transformIncoming(v);return I===v?v:l(A.URI.from(I))}transformOutgoing(v){const I=this.a.transformOutgoing(v);return I===v?v:l(A.URI.from(I))}transformOutgoingURI(v){const I=this.a.transformOutgoing(v);return I===v?v:A.URI.from(I)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function C(T,v,I){if(!T||I>200)return null;if(typeof T=="object"){if(T instanceof A.URI)return v.transformOutgoing(T);for(const y in T)if(Object.hasOwnProperty.call(T,y)){const h=C(T[y],v,I+1);h!==null&&(T[y]=h)}}return null}function P(T,v){const I=C(T,v,0);return I===null?T:I}e.transformOutgoingURIs=P;function S(T,v,I,y){if(!T||y>200)return null;if(typeof T=="object"){if(T.$mid===1)return I?A.URI.revive(v.transformIncoming(T)):v.transformIncoming(T);if(T instanceof a.VSBuffer)return null;for(const h in T)if(Object.hasOwnProperty.call(T,h)){const d=S(T[h],v,I,y+1);d!==null&&(T[h]=d)}}return null}function k(T,v){const I=S(T,v,!1,0);return I===null?T:I}e.transformIncomingURIs=k;function L(T,v){const I=S(T,v,!0,0);return I===null?T:I}e.transformAndReviveIncomingURIs=L}),define(De[29],Ce([1,0,70,89,318,19,33,86,11,10,24,2]),function(ne,e,a,A,l,R,C,P,S,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function I(N,U=v.UNLINK){if((0,C.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?h(N):y(N)}async function y(N){try{const U=(0,C.randomPath)((0,A.tmpdir)());try{await a.promises.rename(N,U)}catch($){return $.code==="ENOENT"?void 0:h(N)}h(U).catch($=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function h(N){return(0,l.promisify)(a.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function d(N){if((0,C.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function u(N,U){return D(await(U?g(N):(0,l.promisify)(a.readdir)(N)))}async function g(N){try{return await(0,l.promisify)(a.readdir)(N,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const U=[],$=await u(N);for(const z of $){let ae=!1,ee=!1,q=!1;try{const J=await e.Promises.lstat((0,S.join)(N,z));ae=J.isFile(),ee=J.isDirectory(),q=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}U.push({name:z,isFile:()=>ae,isDirectory:()=>ee,isSymbolicLink:()=>q})}return U}function b(N){return D(a.readdirSync(N))}e.readdirSync=b;function D(N){return N.map(U=>typeof U=="string"?k.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=k.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function p(N){const U=await u(N),$=[];for(const z of U)await o.existsDirectory((0,S.join)(N,z))&&$.push(z);return $}function i(N,U=1e3){return new Promise($=>{let z=!1;const ae=setInterval(()=>{z||(z=!0,a.access(N,ee=>{z=!1,ee&&(clearInterval(ae),$(void 0))}))},U)})}e.whenDeleted=i;var o;(function(N){async function U(ae){let ee;try{if(ee=await e.Promises.lstat(ae),!ee.isSymbolicLink())return{stat:ee}}catch{}try{return{stat:await e.Promises.stat(ae),symbolicLink:ee?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&ee)return{stat:ee,symbolicLink:{dangling:!0}};if(k.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ae)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&ee)return{stat:ee,symbolicLink:{dangling:!0}};throw J}throw q}}N.stat=U;async function $(ae){try{const{stat:ee,symbolicLink:q}=await N.stat(ae);return ee.isFile()&&q?.dangling!==!0}catch{}return!1}N.existsFile=$;async function z(ae){try{const{stat:ee,symbolicLink:q}=await N.stat(ae);return ee.isDirectory()&&q?.dangling!==!0}catch{}return!1}N.existsDirectory=z})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function c(N,U,$){return r.queueFor(T.URI.file(N),L.extUriBiasedIgnorePathCase).queue(()=>{const z=f($);return new Promise((ae,ee)=>n(N,U,z,q=>q?ee(q):ae()))})}let s=!0;function m(N){s=N}e.configureFlushOnWrite=m;function n(N,U,$,z){if(!s)return a.writeFile(N,U,{mode:$.mode,flag:$.flag},z);a.open(N,$.flag,$.mode,(ae,ee)=>{if(ae)return z(ae);a.writeFile(ee,U,q=>{if(q)return a.close(ee,()=>z(q));a.fdatasync(ee,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),m(!1)),a.close(ee,ie=>z(ie))))})})}function t(N,U,$){const z=f($);if(!s)return a.writeFileSync(N,U,{mode:z.mode,flag:z.flag});const ae=a.openSync(N,z.flag,z.mode);try{a.writeFileSync(ae,U);try{a.fdatasyncSync(ae)}catch(ee){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ee),m(!1)}}finally{a.closeSync(ae)}}e.writeFileSync=t;function f(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function E(N,U){if(N!==U)try{await e.Promises.rename(N,U)}catch($){if(N.toLowerCase()!==U.toLowerCase()&&$.code==="EXDEV"||N.endsWith("."))await w(N,U,{preserveSymlinks:!1}),await I(N,v.MOVE);else throw $}}async function w(N,U,$){return V(N,U,{root:{source:N,target:U},options:$,handledSourcePaths:new Set})}const O=511;async function V(N,U,$){if($.handledSourcePaths.has(N))return;$.handledSourcePaths.add(N);const{stat:z,symbolicLink:ae}=await o.stat(N);if(ae){if($.options.preserveSymlinks)try{return await B(N,U,$)}catch(ee){console.warn("[node.js fs] copy of symlink failed: ",ee)}if(ae.dangling)return}return z.isDirectory()?j(N,U,z.mode&O,$):F(N,U,z.mode&O)}async function j(N,U,$,z){await e.Promises.mkdir(U,{recursive:!0,mode:$});const ae=await u(N);for(const ee of ae)await V((0,S.join)(N,ee),(0,S.join)(U,ee),z)}async function F(N,U,$){await e.Promises.copyFile(N,U),await e.Promises.chmod(U,$)}async function B(N,U,$){let z=await e.Promises.readlink(N);(0,C.isEqualOrParent)(z,$.root.source,!k.isLinux)&&(z=(0,S.join)($.root.target,z.substr($.root.source.length+1))),await e.Promises.symlink(z,U)}e.Promises=new class{get access(){return(0,l.promisify)(a.access)}get stat(){return(0,l.promisify)(a.stat)}get lstat(){return(0,l.promisify)(a.lstat)}get utimes(){return(0,l.promisify)(a.utimes)}get read(){return(N,U,$,z,ae)=>new Promise((ee,q)=>{a.read(N,U,$,z,ae,(J,ie,ge)=>J?q(J):ee({bytesRead:ie,buffer:ge}))})}get readFile(){return(0,l.promisify)(a.readFile)}get write(){return(N,U,$,z,ae)=>new Promise((ee,q)=>{a.write(N,U,$,z,ae,(J,ie,ge)=>J?q(J):ee({bytesWritten:ie,buffer:ge}))})}get appendFile(){return(0,l.promisify)(a.appendFile)}get fdatasync(){return(0,l.promisify)(a.fdatasync)}get truncate(){return(0,l.promisify)(a.truncate)}get rename(){return(0,l.promisify)(a.rename)}get copyFile(){return(0,l.promisify)(a.copyFile)}get open(){return(0,l.promisify)(a.open)}get close(){return(0,l.promisify)(a.close)}get symlink(){return(0,l.promisify)(a.symlink)}get readlink(){return(0,l.promisify)(a.readlink)}get chmod(){return(0,l.promisify)(a.chmod)}get mkdir(){return(0,l.promisify)(a.mkdir)}get unlink(){return(0,l.promisify)(a.unlink)}get rmdir(){return(0,l.promisify)(a.rmdir)}get realpath(){return(0,l.promisify)(a.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return p}get writeFile(){return c}get rm(){return I}get move(){return E}get copy(){return w}}}),define(De[115],Ce([1,0,70,11,10,8,29]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(l.isLinux)return v;const I=(0,A.dirname)(v);if(v===I)return v;const y=((0,A.basename)(v)||v).toLowerCase();try{const d=(0,C.readdirSync)(I).filter(u=>u.toLowerCase()===y);if(d.length===1){const u=P(I);if(u)return(0,A.join)(u,d[0])}else if(d.length>1){const u=d.indexOf(y);if(u>=0){const g=P(I);if(g)return(0,A.join)(g,d[u])}}}catch{}return null}e.realcaseSync=P;async function S(v){if(l.isLinux)return v;const I=(0,A.dirname)(v);if(v===I)return v;const y=((0,A.basename)(v)||v).toLowerCase();try{const d=(await C.Promises.readdir(I)).filter(u=>u.toLowerCase()===y);if(d.length===1){const u=await S(I);if(u)return(0,A.join)(u,d[0])}else if(d.length>1){const u=d.indexOf(y);if(u>=0){const g=await S(I);if(g)return(0,A.join)(g,d[u])}}}catch{}return null}e.realcase=S;async function k(v){try{return await C.Promises.realpath(v)}catch{const y=T(v);return await C.Promises.access(y,a.constants.R_OK),y}}e.realpath=k;function L(v){try{return a.realpathSync(v)}catch{const y=T(v);return a.accessSync(y,a.constants.R_OK),y}}e.realpathSync=L;function T(v){return(0,R.rtrim)((0,A.normalize)(v),A.sep)}}),define(De[116],Ce([1,0,11,10,36,109,9,29]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function S(T=l.env){return T.comspec||"cmd.exe"}e.getWindowsShell=S;function k(T){let v=[],I=!1;const y=function(h){if(I){v.push(h);return}(!T.send(h,u=>{if(u&&console.error(u),I=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(b=>y(b))}})||A.isWindows)&&(I=!0)};return{send:y}}e.createQueuedSender=k;var L;(function(T){async function v(I,y,h){if(a.isAbsolute(I))return I;if(y===void 0&&(y=l.cwd()),a.dirname(I)!=="."||(h===void 0&&C.isString(l.env.PATH)&&(h=l.env.PATH.split(a.delimiter)),h===void 0||h.length===0))return a.join(y,I);async function u(g){if(await P.Promises.exists(g)){let b;try{b=await P.Promises.stat(g)}catch(D){D.message.startsWith("EACCES")&&(b=await P.Promises.lstat(g))}return b?!b.isDirectory():!1}return!1}for(const g of h){let b;if(a.isAbsolute(g)?b=a.join(g,I):b=a.join(y,g,I),await u(b))return b;let D=b+".com";if(await u(D)||(D=b+".exe",await u(D)))return D}return a.join(y,I)}T.findExecutable=v})(L=e.win32||(e.win32={}))});var xe=this&&this.__decorate||function(ne,e,a,A){var l=arguments.length,R=l<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,a):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,a,A);else for(var P=ne.length-1;P>=0;P--)(C=ne[P])&&(R=(l<3?C(R):l>3?C(e,a,R):C(e,a))||R);return l>3&&R&&Object.defineProperty(e,a,R),R};define(De[117],Ce([1,0,15,19,22,21,62,12,3,6,69,8,9]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(I||(I={}));function y(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(h||(h={}));function d(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(u||(u={}));function g(ee){let q=0;for(let J=0;;J+=7){const ie=ee.read(1);if(q|=(ie.buffer[0]&127)<<J,!(ie.buffer[0]&128))return q}}const b=r(0);function D(ee,q){if(q===0){ee.write(b);return}let J=0;for(let ge=q;ge!==0;ge=ge>>>7)J++;const ie=l.VSBuffer.alloc(J);for(let ge=0;q!==0;ge++)ie.buffer[ge]=q&127,q=q>>>7,q>0&&(ie.buffer[ge]|=128);ee.write(ie)}class p{constructor(q){this.b=q,this.a=0}read(q){const J=this.b.slice(this.a,this.a+q);return this.a+=J.byteLength,J}}e.BufferReader=p;class i{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(q){this.a.push(q)}}e.BufferWriter=i;var o;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(o||(o={}));function r(ee){const q=l.VSBuffer.alloc(1);return q.writeUInt8(ee,0),q}const c={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},s=typeof Buffer<"u";function m(ee,q){if(typeof q>"u")ee.write(c.Undefined);else if(typeof q=="string"){const J=l.VSBuffer.fromString(q);ee.write(c.String),D(ee,J.byteLength),ee.write(J)}else if(s&&Buffer.isBuffer(q)){const J=l.VSBuffer.wrap(q);ee.write(c.Buffer),D(ee,J.byteLength),ee.write(J)}else if(q instanceof l.VSBuffer)ee.write(c.VSBuffer),D(ee,q.byteLength),ee.write(q);else if(Array.isArray(q)){ee.write(c.Array),D(ee,q.length);for(const J of q)m(ee,J)}else if(typeof q=="number"&&(q|0)===q)ee.write(c.Uint),D(ee,q);else{const J=l.VSBuffer.fromString(JSON.stringify(q));ee.write(c.Object),D(ee,J.byteLength),ee.write(J)}}e.serialize=m;function n(ee){switch(ee.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return ee.read(g(ee)).toString();case o.Buffer:return ee.read(g(ee)).buffer;case o.VSBuffer:return ee.read(g(ee));case o.Array:{const J=g(ee),ie=[];for(let ge=0;ge<J;ge++)ie.push(n(ee));return ie}case o.Object:return JSON.parse(ee.read(g(ee)).toString());case o.Int:return g(ee)}}e.deserialize=n;class t{constructor(q,J,ie=null,ge=1e3){this.h=q,this.j=J,this.k=ie,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(q,J){this.b.set(q,J),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const J=this.o([q.type]);this.k?.logOutgoing(J,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const J=this.o([q.type,q.id],q.data);this.k?.logOutgoing(J,q.id,1,d(q.type),q.data);return}}}o(q,J=void 0){const ie=new i;return m(ie,q),m(ie,J),this.p(ie.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const J=new p(q),ie=n(J),ge=n(J),X=ie[0];switch(X){case 100:return this.k?.logIncoming(q.byteLength,ie[1],1,`${y(X)}: ${ie[2]}.${ie[3]}`,ge),this.s({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 102:return this.k?.logIncoming(q.byteLength,ie[1],1,`${y(X)}: ${ie[2]}.${ie[3]}`,ge),this.t({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 101:return this.k?.logIncoming(q.byteLength,ie[1],1,`${y(X)}`),this.u({type:X,id:ie[1]});case 103:return this.k?.logIncoming(q.byteLength,ie[1],1,`${y(X)}`),this.u({type:X,id:ie[1]})}}s(q){const J=this.b.get(q.channelName);if(!J){this.v(q);return}const ie=new R.CancellationTokenSource;let ge;try{ge=J.call(this.j,q.name,q.arg,ie.token)}catch(Z){ge=Promise.reject(Z)}const X=q.id;ge.then(Z=>{this.m({id:X,data:Z,type:201}),this.d.delete(q.id)},Z=>{Z instanceof Error?this.m({id:X,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.m({id:X,data:Z,type:203}),this.d.delete(q.id)});const Y=(0,k.toDisposable)(()=>ie.cancel());this.d.set(q.id,Y)}t(q){const J=this.b.get(q.channelName);if(!J){this.v(q);return}const ie=q.id,X=J.listen(this.j,q.name,q.arg)(Y=>this.m({id:ie,data:Y,type:204}));this.d.set(q.id,X)}u(q){const J=this.d.get(q.id);J&&(J.dispose(),this.d.delete(q.id))}v(q){let J=this.g.get(q.channelName);J||(J=[],this.g.set(q.channelName,J));const ie=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:q,timeoutTimer:ie})}w(q){const J=this.g.get(q);if(J){for(const ie of J)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=t;var f;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(q,J=null){this.l=q,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=J}getChannel(q){const J=this;return{call(ie,ge,X){return J.a?Promise.reject(new P.CancellationError):J.m(q,ie,ge,X)},listen(ie,ge){return J.a?S.Event.None:J.o(q,ie,ge)}}}m(q,J,ie,ge=R.CancellationToken.None){const X=this.g++,Z={id:X,type:100,channelName:q,name:J,arg:ie};if(ge.isCancellationRequested)return Promise.reject(new P.CancellationError);let fe;return new Promise((ke,Oe)=>{if(ge.isCancellationRequested)return Oe(new P.CancellationError);const oe=()=>{const ce=se=>{switch(se.type){case 201:this.f.delete(X),ke(se.data);break;case 202:{this.f.delete(X);const M=new Error(se.data.message);M.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,M.name=se.data.name,Oe(M);break}case 203:this.f.delete(X),Oe(se.data);break}};this.f.set(X,ce),this.p(Z)};let le=null;this.b===u.Idle?oe():(le=(0,A.createCancelablePromise)(ce=>this.u()),le.then(()=>{le=null,oe()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:X,type:101}),Oe(new P.CancellationError)},te=ge.onCancellationRequested(ue);fe=(0,k.combinedDisposable)((0,k.toDisposable)(ue),te),this.d.add(fe)}).finally(()=>{this.d.delete(fe)})}o(q,J,ie){const ge=this.g++,Y={id:ge,type:102,channelName:q,name:J,arg:ie};let Z=null;const fe=new S.Emitter({onWillAddFirstListener:()=>{Z=(0,A.createCancelablePromise)(ke=>this.u()),Z.then(()=>{Z=null,this.d.add(fe),this.p(Y)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.d.delete(fe),this.p({id:ge,type:103}))}}),ve=ke=>fe.fire(ke.data);return this.f.set(ge,ve),fe.event}p(q){switch(q.type){case 100:case 102:{const J=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(J,q.id,0,`${y(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const J=this.q([q.type,q.id]);this.j?.logOutgoing(J,q.id,0,y(q.type));return}}}q(q,J=void 0){const ie=new i;return m(ie,q),m(ie,J),this.r(ie.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const J=new p(q),ie=n(J),ge=n(J),X=ie[0];switch(X){case 200:return this.j?.logIncoming(q.byteLength,0,0,d(X)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,ie[1],0,d(X),ge),this.t({type:ie[0],id:ie[1],data:ge})}}t(q){if(q.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.dispose)(this.d.values()),this.d.clear()}}xe([C.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class w{get connections(){const q=[];return this.f.forEach(J=>q.push(J)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,q(({protocol:J,onDidClientDisconnect:ie})=>{S.Event.once(J.onMessage)(X=>{const Y=new p(X),Z=n(Y),fe=new t(J,Z),ve=new E(J);this.a.forEach((Oe,oe)=>fe.registerChannel(oe,Oe));const ke={channelServer:fe,channelClient:ve,ctx:Z};this.f.add(ke),this.g.fire(ke),ie(()=>{fe.dispose(),ve.dispose(),this.f.delete(ke),this.h.fire(ke)})})})}getChannel(q,J){const ie=this;return{call(ge,X,Y){let Z;if((0,v.isFunction)(J)){const ve=(0,a.getRandomElement)(ie.connections.filter(J));Z=ve?Promise.resolve(ve):S.Event.toPromise(S.Event.filter(ie.onDidAddConnection,J))}else Z=J.routeCall(ie,ge,X);const fe=Z.then(ve=>ve.channelClient.getChannel(q));return V(fe).call(ge,X,Y)},listen(ge,X){if((0,v.isFunction)(J))return ie.j(q,J,ge,X);const Y=J.routeEvent(ie,ge,X).then(Z=>Z.channelClient.getChannel(q));return V(Y).listen(ge,X)}}}j(q,J,ie,ge){const X=this;let Y=new k.DisposableStore;const Z=new S.Emitter({onWillAddFirstListener:()=>{Y=new k.DisposableStore;const fe=new S.EventMultiplexer,ve=new Map,ke=oe=>{const ue=oe.channelClient.getChannel(q).listen(ie,ge),te=fe.add(ue);ve.set(oe,te)},Oe=oe=>{const le=ve.get(oe);!le||(le.dispose(),ve.delete(oe))};X.connections.filter(J).forEach(ke),S.Event.filter(X.onDidAddConnection,J)(ke,void 0,Y),X.onDidRemoveConnection(Oe,void 0,Y),fe.event(Z.fire,Z,Y),Y.add(fe)},onDidRemoveLastListener:()=>{Y.dispose()}});return Z.event}registerChannel(q,J){this.a.set(q,J),this.f.forEach(ie=>{ie.channelServer.registerChannel(q,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=w;class O{constructor(q,J,ie=null){const ge=new i;m(ge,J),q.send(ge.buffer),this.a=new E(q,ie),this.d=new t(q,J,ie)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,J){this.d.registerChannel(q,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=O;function V(ee){return{call(q,J,ie){return ee.then(ge=>ge.call(q,J,ie))},listen(q,J){const ie=new S.Relay;return ee.then(ge=>ie.input=ge.listen(q,J)),ie.event}}}e.getDelayedChannel=V;function j(ee){let q=!1;return{call(J,ie,ge){return q?ee.call(J,ie,ge):(0,A.timeout)(0).then(()=>q=!0).then(()=>ee.call(J,ie,ge))},listen(J,ie){if(q)return ee.listen(J,ie);const ge=new S.Relay;return(0,A.timeout)(0).then(()=>q=!0).then(()=>ge.input=ee.listen(J,ie)),ge.event}}}e.getNextTickChannel=j;class F{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const J of q.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await S.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.StaticRouter=F;var B;(function(ee){function q(X,Y){const Z=X,fe=Y&&Y.disableMarshalling,ve=new Map;for(const ke in Z)ie(ke)&&ve.set(ke,S.Event.buffer(Z[ke],!0));return new class{listen(ke,Oe,oe){const le=ve.get(Oe);if(le)return le;if(ge(Oe)){const ue=Z[Oe];if(typeof ue=="function")return ue.call(Z,oe)}throw new Error(`Event not found: ${Oe}`)}call(ke,Oe,oe){const le=Z[Oe];if(typeof le=="function"){if(!fe&&Array.isArray(oe))for(let ue=0;ue<oe.length;ue++)oe[ue]=(0,L.revive)(oe[ue]);return le.apply(Z,oe)}throw new Error(`Method not found: ${Oe}`)}}}ee.fromService=q;function J(X,Y){const Z=Y&&Y.disableMarshalling;return new Proxy({},{get(fe,ve){if(typeof ve=="string")return Y?.properties?.has(ve)?Y.properties.get(ve):ge(ve)?function(ke){return X.listen(ve,ke)}:ie(ve)?X.listen(ve):async function(...ke){let Oe;Y&&!(0,v.isUndefinedOrNull)(Y.context)?Oe=[Y.context,...ke]:Oe=ke;const oe=await X.call(ve,Oe);return Z?oe:(0,L.revive)(oe)};throw new Error(`Property not found: ${String(ve)}`)}})}ee.toService=J;function ie(X){return X[0]==="o"&&X[1]==="n"&&T.isUpperAsciiLetter(X.charCodeAt(2))}function ge(X){return/^onDynamic/.test(X)&&T.isUpperAsciiLetter(X.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const q=ee.toString();if(q!=="[object Object]")return q}return ee}function $(ee){return Array.isArray(ee)?ee.map(U):U(ee)}function z(ee,q,J,ie,ge,X,Y){Y=$(Y);const Z=N[ge],fe=Z[ie%Z.length];let ve=[`%c[${ee}]%c[${String(q).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${fe}`];/\($/.test(X)?(ve=ve.concat(Y),ve.push(")")):ve.push(Y),console.log.apply(console,ve)}class ae{constructor(q,J){this.d=q,this.f=J,this.a=0,this.b=0}logOutgoing(q,J,ie,ge,X){this.b+=q,z(this.d,this.b,q,J,ie,ge,X)}logIncoming(q,J,ie,ge,X){this.a+=q,z(this.f,this.a,q,J,ie,ge,X)}}e.IPCLogger=ae}),define(De[118],Ce([1,0,19,22,3,6,117]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(E){E.enableDiagnostics=!1,E.records=[];const w=new WeakMap;let O=0;function V(F,B){if(!w.has(F)){const N=String(++O);w.set(F,N)}return w.get(F)}function j(F,B,N,U){if(!E.enableDiagnostics)return;const $=V(F,B);if(U instanceof A.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const z=A.VSBuffer.alloc(U.byteLength);z.set(U),E.records.push({timestamp:Date.now(),id:$,label:B,type:N,buff:z})}else E.records.push({timestamp:Date.now(),id:$,label:B,type:N,data:U})}E.traceSocketEvent=j})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var k;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function T(){return L||(L=A.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,O){if(w===0)return T();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const B=this.a[0];return O&&(this.a.shift(),this.b-=w),B}if(this.a[0].byteLength>w){const B=this.a[0].slice(0,w);return O&&(this.a[0]=this.a[0].slice(w),this.b-=w),B}const V=A.VSBuffer.alloc(w);let j=0,F=0;for(;w>0;){const B=this.a[F];if(B.byteLength>w){const N=B.slice(0,w);V.set(N,j),j+=w,O&&(this.a[F]=B.slice(w),this.b-=w),w-=w}else V.set(B,j),j+=B.byteLength,O?(this.a.shift(),this.b-=B.byteLength):F++,w-=B.byteLength}return V}}e.ChunkStream=v;var I;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(I||(I={}));function y(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var h;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(w,O,V,j){this.type=w,this.id=O,this.ack=V,this.data=j,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends R.Disposable{constructor(w){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=w,this.b=!1,this.c=new v,this.B(this.a.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const O=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=O.readUInt32BE(9),this.g.messageType=O.readUInt8(0),this.g.id=O.readUInt32BE(1),this.g.ack=O.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const V=this.g.messageType,j=this.g.id,F=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",O),this.f.fire(new d(V,j,F,O)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=A.VSBuffer.alloc(13);O.writeUInt8(w.type,0),O.writeUInt32BE(w.id,1),O.writeUInt32BE(w.ack,5),O.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",w.data),this.j(O,w.data)}g(w,O){const V=this.f===0;return this.d.push(w,O),this.f+=w.byteLength+O.byteLength,V}h(){const w=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,O){this.g(w,O)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:w.byteLength}),this.c.write(w)}}class b extends R.Disposable{constructor(w){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new g(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(O=>{O.type===1&&this.f.fire(O.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new d(1,0,0,w))}}e.Protocol=b;class D extends C.IPCClient{static fromSocket(w,O){return new D(new b(w),O)}get onDidDispose(){return this.b.onDidDispose}constructor(w,O,V=null){super(w,O,V),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.Client=D;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.BufferedEmitter=p;class i{constructor(w){this.data=w,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let w=0,O=this.a;for(;O;)O=O.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let O=0,V=this.a;for(;V;)w[O++]=V.data,V=V.next;return w}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const O=new i(w);if(!this.a){this.a=O,this.b=O;return}this.b.next=O,this.b=O}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const w=Date.now();for(let O=0;O<r.a;O++)this.c[O]=w-1e3*O;setInterval(()=>{for(let O=r.a;O>=1;O--)this.c[O]=this.c[O-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),O=(1+r.a)*1e3;let V=0;for(let j=0;j<r.a;j++)w-this.c[j]<=O&&V++;return 1-V/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var c;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(c=e.ConnectionHealth||(e.ConnectionHealth={}));function s(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class m{constructor(w){this.connectionHealth=w}}e.ConnectionHealthChangedEvent=m;class n{constructor(w,O){this.roundTripTime=w,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=n;class t{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.x=new p,this.onControlMessage=this.x.event,this.y=new p,this.onMessage=this.y.event,this.z=new p,this.onDidDispose=this.z.event,this.A=new p,this.onSocketClose=this.A.event,this.B=new p,this.onSocketTimeout=this.B.event,this.C=new p,this.onHighRoundTripTime=this.C.event,this.D=new p,this.onDidChangeConnectionHealth=this.D.event,this.u=w.loadEstimator??r.getInstance(),this.v=w.measureRoundTripTime??!1,this.w=w.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=w.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(O=>this.E(O))),this.t.add(this.o.onClose(O=>this.A.fire(O))),this.r=this.t.add(new f),this.t.add(this.r.onSendLatencyRequest(O=>this.J(O))),this.t.add(this.r.onHighRoundTripTime(O=>this.C.fire(O))),this.t.add(this.r.onDidChangeConnectionHealth(O=>this.D.fire(O))),this.v&&this.r.start(),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new d(5,0,0,T());this.p.write(w),this.p.flush()}sendPause(){const w=new d(7,0,0,T());this.p.write(w)}sendResume(){const w=new d(8,0,0,T());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,O){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(V=>this.E(V))),this.t.add(this.o.onClose(V=>this.A.fire(V))),this.r=this.t.add(new f),this.t.add(this.r.onSendLatencyRequest(V=>this.J(V))),this.t.add(this.r.onHighRoundTripTime(V=>this.C.fire(V))),this.t.add(this.r.onDidChangeConnectionHealth(V=>this.D.fire(V))),this.q.acceptChunk(O)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const w=new d(3,0,this.h,T());this.p.write(w);const O=this.b.toArray();for(let V=0,j=O.length;V<j;V++)this.p.write(O[V]);this.G()}acceptDisconnect(){this.z.fire()}E(w){if(w.ack>this.d){this.d=w.ack;do{const O=this.b.peek();if(O&&O.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case 0:break;case 1:{if(w.id>this.g)if(w.id!==this.g+1){const O=Date.now();O-this.m>1e4&&(this.m=O,this.p.write(new d(6,0,0,T())))}else this.g=w.id,this.j=Date.now(),this.F(),this.y.fire(w.data);break}case 2:{this.x.fire(w.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const O=this.b.toArray();for(let V=0,j=O.length;V<j;V++)this.p.write(O[V]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(w.data);break}case 11:{this.r.handleResponse(w.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const O=++this.c;this.h=this.g;const V=new d(1,O,this.h,w);this.b.push(V),this.a||(this.p.write(V),this.G())}sendControl(w){const O=new d(2,0,0,w);this.p.write(O)}F(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-w+5)}G(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),O=Date.now()-w.writtenTime,V=Date.now()-this.q.lastReadTime,j=Date.now()-this.n;if(O>=2e4&&V>=2e4&&j>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:V});return}const F=Math.max(2e4-O,2e4-V,2e4-j,500);this.f=setTimeout(()=>{this.f=null,this.G()},F)}H(){if(this.g<=this.h)return;this.h=this.g;const w=new d(3,0,this.h,T());this.p.write(w)}I(){this.h=this.g;const w=new d(9,0,this.h,T());this.p.write(w)}J(w){this.h=this.g;const O=new d(10,0,this.h,w);this.p.write(O)}K(w){this.h=this.g;const O=new d(11,0,this.h,w);this.p.write(O)}}e.PersistentProtocol=t;class f extends R.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},w=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const w=++this.h,O=A.VSBuffer.alloc(4);O.writeUInt32BE(w,0),this.a.fire(O)},6e4)}handleResponse(w){if(w.byteLength!==4)return;const O=w.readUInt32BE(0);if(this.g<=0||O!==this.h)return;const V=Date.now()-this.g,j=this.k++;this.j[j%this.j.length]=V;const F=this.l,B=this.j.filter(N=>N>=1e3).length;this.l=B>=3?1:0,V>1e3&&this.b.fire(new n(V,B)),F!==this.l&&this.c.fire(this.l)}}}),define(De[119],Ce([1,0,22,12,3,6,11,10,30,117,118]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function T(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,t){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,t)}constructor(n,t=""){this.f=!0,this.debugLabel=t,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,A.onUnexpectedError)(f)}},this.socket.on("error",this.a),this.b=f=>{this.traceSocketEvent("close",{hadError:f}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const t=f=>{this.traceSocketEvent("read",f),n(a.VSBuffer.wrap(f))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(n){const t=f=>{n({type:0,hadError:f,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(n){const t=()=>{n()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=v;var I;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var y;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(y||(y={}));class h extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,t){this.socket.traceSocketEvent(n,t)}constructor(n,t,f,E){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:f?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new d(this,t,f,E,this.f,(w,O)=>this.k(w,O))),this.B(this.a.onError(w=>{console.error(w),(0,A.onUnexpectedError)(w),this.g.fire({type:0,hadError:!0,error:w})})),this.b=new L.ChunkStream,this.B(this.socket.onData(w=>this.l(w))),this.B(this.socket.onClose(w=>this.g.fire(w)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,t){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let f=2;n.byteLength<126?f+=0:n.byteLength<2**16?f+=2:f+=8;const E=a.VSBuffer.alloc(f);if(t?E.writeUInt8(194,0):E.writeUInt8(130,0),n.byteLength<126)E.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){E.writeUInt8(126,1);let w=1;E.writeUInt8(n.byteLength>>>8&255,++w),E.writeUInt8(n.byteLength>>>0&255,++w)}else{E.writeUInt8(127,1);let w=1;E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(n.byteLength>>>24&255,++w),E.writeUInt8(n.byteLength>>>16&255,++w),E.writeUInt8(n.byteLength>>>8&255,++w),E.writeUInt8(n.byteLength>>>0&255,++w)}this.socket.write(a.VSBuffer.concat([E,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const t=this.b.peek(this.j.readLen),f=t.readUInt8(0),E=(f&128)>>>7,w=(f&64)>>>6,O=t.readUInt8(1),V=(O&128)>>>7,j=O&127;this.j.state=2,this.j.readLen=2+(V?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(w)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const t=this.b.read(this.j.readLen),f=t.readUInt8(1),E=(f&128)>>>7;let w=f&127,O=1;w===126?w=t.readUInt8(++O)*2**8+t.readUInt8(++O):w===127&&(w=t.readUInt8(++O)*0+t.readUInt8(++O)*0+t.readUInt8(++O)*0+t.readUInt8(++O)*0+t.readUInt8(++O)*2**24+t.readUInt8(++O)*2**16+t.readUInt8(++O)*2**8+t.readUInt8(++O));let V=0;E&&(V=t.readUInt8(++O)*2**24+t.readUInt8(++O)*2**16+t.readUInt8(++O)*2**8+t.readUInt8(++O)),this.j.state=3,this.j.readLen=w,this.j.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const t=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),b(t,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(t,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,t,f,E,w,O){super(),this.k=n,this.l=w,this.m=O,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,t?(this.b=this.B(new u(this.k,E,f,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(V=>this.a.fire(V))),this.B(this.f.onError(V=>this.a.fire(V)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const t=await this.r(this.f,n);this.m(t,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,t){return new Promise((f,E)=>{n.write(t),n.flush(w=>f(w))})}acceptFrame(n,t,f){this.h.push({data:n,isCompressed:t,isLastFrameOfMessage:f}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const t=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(t)}else this.l.fire(n.data)}this.s=!1}}u(n,t,f){return new Promise((E,w)=>{n.write(t),f&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(O=>E(O))})}}class u extends R.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(n,t,f,E){super(),this.h=n,this.j=t,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=T().zlib.createInflateRaw(E),this.b.on("error",w=>{this.h.traceSocketEvent("zlibInflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.h.traceSocketEvent("zlibInflateData",w),this.g.push(a.VSBuffer.wrap(w))}),f&&(this.h.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this.b.write(f.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const t=a.VSBuffer.concat(this.g);this.g.length=0,n(t)})}}class g extends R.Disposable{constructor(n,t){super(),this.g=n,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=T().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",f=>{this.g.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this.a.fire(f)}),this.b.on("data",f=>{this.g.traceSocketEvent("zlibDeflateData",f),this.f.push(a.VSBuffer.wrap(f))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let t=a.VSBuffer.concat(this.f);this.f.length=0,t=t.slice(0,t.byteLength-4),n(t)})}}function b(m,n){if(n===0)return;const t=m.byteLength>>>2;for(let j=0;j<t;j++){const F=m.readUInt32BE(j*4);m.writeUInt32BE(F^n,j*4)}const f=t*4,E=m.byteLength-f,w=n>>>24&255,O=n>>>16&255,V=n>>>8&255;E>=1&&m.writeUInt8(m.readUInt8(f)^w,f),E>=2&&m.writeUInt8(m.readUInt8(f+1)^O,f+1),E>=3&&m.writeUInt8(m.readUInt8(f+2)^V,f+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const D={[2]:107,[1]:103};function p(){const m=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):n=(0,C.join)(T().os.tmpdir(),`vscode-ipc-${m}.sock`),o(n),n}e.createRandomIPCHandle=p;function i(m,n,t){const f=T().crypto.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${t}-${n}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${t}-${n}.sock`):E=(0,C.join)(m,`${t}-${n}.sock`),o(E),E}e.createStaticIPCHandle=i;function o(m){const n=D[P.platform];typeof n=="number"&&m.length>=n&&console.warn(`WARNING: IPC handle "${m}" is longer than ${n} chars, try a shorter --user-data-dir`)}class r extends k.IPCServer{static b(n){const t=l.Event.fromNodeEventEmitter(n,"connection");return l.Event.map(t,f=>({protocol:new L.Protocol(new v(f,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(f,"close"))}))}constructor(n){super(r.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function c(m){return new Promise((n,t)=>{const f=T().net.createServer();f.on("error",t),f.listen(m,()=>{f.removeListener("error",t),n(new r(f))})})}e.serve=c;function s(m,n){return new Promise((t,f)=>{const E=T().net.createConnection(m,()=>{E.removeListener("error",f),t(L.Client.fromSocket(new v(E,`ipc-client${n}`),n))});E.once("error",f)})}e.connect=s}),define(De[164],Ce([1,0,38,11]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(R,C,P,S,k,L){if(Array.isArray(R)){let T=0;for(const v of R){const I=l(v,C,P,S,k,L);if(I===10)return I;I>T&&(T=I)}return T}else{if(typeof R=="string")return S?R==="*"?5:R===P?10:0:0;if(R){const{language:T,pattern:v,scheme:I,hasAccessToAllModels:y,notebookType:h}=R;if(!S&&!y)return 0;h&&k&&(C=k);let d=0;if(I)if(I===C.scheme)d=10;else if(I==="*")d=5;else return 0;if(T)if(T===P)d=10;else if(T==="*")d=Math.max(d,5);else return 0;if(h)if(h===L)d=10;else if(h==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(v){let u;if(typeof v=="string"?u=v:u={...v,base:(0,A.normalize)(v.base)},u===C.fsPath||(0,a.match)(u,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=l}),define(De[165],Ce([1,0,8,52,155]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(P,S,k,L){this.c=P,this.d=S,this.f=k,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(P){P.eol&&P.eol!==this.f&&(this.f=P.eol,this.h=null);const S=P.changes;for(const k of S)this.n(k.range),this.o(new A.Position(k.range.startLineNumber,k.range.startColumn),k.text);this.g=P.versionId,this.j=null}k(){if(!this.h){const P=this.f.length,S=this.d.length,k=new Uint32Array(S);for(let L=0;L<S;L++)k[L]=this.d[L].length+P;this.h=new l.PrefixSumComputer(k)}}l(P,S){this.d[P]=S,this.h&&this.h.setValue(P,this.d[P].length+this.f.length)}n(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.startLineNumber-1].substring(P.endColumn-1));return}this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.endLineNumber-1].substring(P.endColumn-1)),this.d.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this.h&&this.h.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}o(P,S){if(S.length===0)return;const k=(0,a.splitLines)(S);if(k.length===1){this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+k[0]+this.d[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this.d[P.lineNumber-1].substring(P.column-1),this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+k[0]);const L=new Uint32Array(k.length-1);for(let T=1;T<k.length;T++)this.d.splice(P.lineNumber+T-1,0,k[T]),L[T-1]=k[T].length+this.f.length;this.h&&this.h.insertValues(P.lineNumber,L)}}e.MirrorTextModel=R}),define(De[166],Ce([1,0,8,152,52,32,107]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(g,b,D,p){this.searchString=g,this.isRegex=b,this.matchCase=D,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=k(this.searchString):g=this.searchString.indexOf(`
`)>=0;let b=null;try{b=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!b)return null;let D=!this.isRegex&&!g;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new C.SearchData(b,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=S;function k(u){if(!u||u.length===0)return!1;for(let g=0,b=u.length;g<b;g++){const D=u.charCodeAt(g);if(D===10)return!0;if(D===92){if(g++,g>=b)break;const p=u.charCodeAt(g);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=k;function L(u,g,b){if(!b)return new C.FindMatch(u,null);const D=[];for(let p=0,i=g.length;p<i;p++)D[p]=g[p];return new C.FindMatch(u,D)}e.createFindMatch=L;class T{constructor(g){const b=[];let D=0;for(let p=0,i=g.length;p<i;p++)g.charCodeAt(p)===10&&(b[D++]=p);this.a=b}findLineFeedCountBeforeOffset(g){const b=this.a;let D=0,p=b.length-1;if(p===-1||g<=b[0])return 0;for(;D<p;){const i=D+((p-D)/2>>0);b[i]>=g?p=i-1:b[i+1]>=g?(D=i,p=i):D=i+1}return D+1}}class v{static findMatches(g,b,D,p,i){const o=b.parseSearchRequest();return o?o.regex.multiline?this.b(g,D,new d(o.wordSeparators,o.regex),p,i):this.c(g,D,o,p,i):[]}static a(g,b,D,p,i,o){let r,c=0;p?(c=p.findLineFeedCountBeforeOffset(i),r=b+i+c):r=b+i;let s;if(p){const f=p.findLineFeedCountBeforeOffset(i+o.length)-c;s=r+o.length+f}else s=r+o.length;const m=g.getPositionAt(r),n=g.getPositionAt(s);return new R.Range(m.lineNumber,m.column,n.lineNumber,n.column)}static b(g,b,D,p,i){const o=g.getOffsetAt(b.getStartPosition()),r=g.getValueInRange(b,1),c=g.getEOL()===`\r
`?new T(r):null,s=[];let m=0,n;for(D.reset(0);n=D.next(r);)if(s[m++]=L(this.a(g,o,r,c,n.index,n[0]),n,p),m>=i)return s;return s}static c(g,b,D,p,i){const o=[];let r=0;if(b.startLineNumber===b.endLineNumber){const s=g.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return r=this.d(D,s,b.startLineNumber,b.startColumn-1,r,o,p,i),o}const c=g.getLineContent(b.startLineNumber).substring(b.startColumn-1);r=this.d(D,c,b.startLineNumber,b.startColumn-1,r,o,p,i);for(let s=b.startLineNumber+1;s<b.endLineNumber&&r<i;s++)r=this.d(D,g.getLineContent(s),s,0,r,o,p,i);if(r<i){const s=g.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);r=this.d(D,s,b.endLineNumber,0,r,o,p,i)}return o}static d(g,b,D,p,i,o,r,c){const s=g.wordSeparators;if(!r&&g.simpleSearch){const t=g.simpleSearch,f=t.length,E=b.length;let w=-f;for(;(w=b.indexOf(t,w+f))!==-1;)if((!s||h(s,b,E,w,f))&&(o[i++]=new C.FindMatch(new R.Range(D,w+1+p,D,w+1+f+p),null),i>=c))return i;return i}const m=new d(g.wordSeparators,g.regex);let n;m.reset(0);do if(n=m.next(b),n&&(o[i++]=L(new R.Range(D,n.index+1+p,D,n.index+1+n[0].length+p),n,r),i>=c))return i;while(n);return i}static findNextMatch(g,b,D,p){const i=b.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.e(g,D,o,p):this.f(g,D,o,p)}static e(g,b,D,p){const i=new l.Position(b.lineNumber,1),o=g.getOffsetAt(i),r=g.getLineCount(),c=g.getValueInRange(new R.Range(i.lineNumber,i.column,r,g.getLineMaxColumn(r)),1),s=g.getEOL()===`\r
`?new T(c):null;D.reset(b.column-1);const m=D.next(c);return m?L(this.a(g,o,c,s,m.index,m[0]),m,p):b.lineNumber!==1||b.column!==1?this.e(g,new l.Position(1,1),D,p):null}static f(g,b,D,p){const i=g.getLineCount(),o=b.lineNumber,r=g.getLineContent(o),c=this.g(D,r,o,b.column,p);if(c)return c;for(let s=1;s<=i;s++){const m=(o+s-1)%i,n=g.getLineContent(m+1),t=this.g(D,n,m+1,1,p);if(t)return t}return null}static g(g,b,D,p,i){g.reset(p-1);const o=g.next(b);return o?L(new R.Range(D,o.index+1,D,o.index+1+o[0].length),o,i):null}static findPreviousMatch(g,b,D,p){const i=b.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.h(g,D,o,p):this.j(g,D,o,p)}static h(g,b,D,p){const i=this.b(g,new R.Range(1,1,b.lineNumber,b.column),D,p,10*P);if(i.length>0)return i[i.length-1];const o=g.getLineCount();return b.lineNumber!==o||b.column!==g.getLineMaxColumn(o)?this.h(g,new l.Position(o,g.getLineMaxColumn(o)),D,p):null}static j(g,b,D,p){const i=g.getLineCount(),o=b.lineNumber,r=g.getLineContent(o).substring(0,b.column-1),c=this.k(D,r,o,p);if(c)return c;for(let s=1;s<=i;s++){const m=(i+o-s-1)%i,n=g.getLineContent(m+1),t=this.k(D,n,m+1,p);if(t)return t}return null}static k(g,b,D,p){let i=null,o;for(g.reset(0);o=g.next(b);)i=L(new R.Range(D,o.index+1,D,o.index+1+o[0].length),o,p);return i}}e.TextModelSearch=v;function I(u,g,b,D,p){if(D===0)return!0;const i=g.charCodeAt(D-1);if(u.get(i)!==0||i===13||i===10)return!0;if(p>0){const o=g.charCodeAt(D);if(u.get(o)!==0)return!0}return!1}function y(u,g,b,D,p){if(D+p===b)return!0;const i=g.charCodeAt(D+p);if(u.get(i)!==0||i===13||i===10)return!0;if(p>0){const o=g.charCodeAt(D+p-1);if(u.get(o)!==0)return!0}return!1}function h(u,g,b,D,p){return I(u,g,b,D,p)&&y(u,g,b,D,p)}e.isValidMatch=h;class d{constructor(g,b){this._wordSeparators=g,this.a=b,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const b=g.length;let D;do{if(this.b+this.c===b||(D=this.a.exec(g),!D))return null;const p=D.index,i=D[0].length;if(p===this.b&&i===this.c){if(i===0){a.getNextCodePoint(g,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=i,!this._wordSeparators||h(this._wordSeparators,g,b,p,i))return D}while(D);return null}}e.Searcher=d}),define(De[120],Ce([1,0,22,10]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(l||(l={}));function R(T){for(let v=0,I=T.length;v<I;v+=4){const y=T[v+0],h=T[v+1],d=T[v+2],u=T[v+3];T[v+0]=u,T[v+1]=d,T[v+2]=h,T[v+3]=y}}function C(T){const v=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return A.isLittleEndian()||R(v),a.VSBuffer.wrap(v)}function P(T){const v=T.buffer;if(A.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const I=new Uint8Array(v.byteLength);return I.set(v),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function S(T){const v=new Uint32Array(k(T));let I=0;if(v[I++]=T.id,T.type==="full")v[I++]=1,v[I++]=T.data.length,v.set(T.data,I),I+=T.data.length;else{v[I++]=2,v[I++]=T.deltas.length;for(const y of T.deltas)v[I++]=y.start,v[I++]=y.deleteCount,y.data?(v[I++]=y.data.length,v.set(y.data,I),I+=y.data.length):v[I++]=0}return C(v)}e.encodeSemanticTokensDto=S;function k(T){let v=0;if(v+=1+1,T.type==="full")v+=1+T.data.length;else{v+=1,v+=(1+1+1)*T.deltas.length;for(const I of T.deltas)I.data&&(v+=I.data.length)}return v}function L(T){const v=P(T);let I=0;const y=v[I++];if(v[I++]===1){const g=v[I++],b=v.subarray(I,I+g);return I+=g,{id:y,type:"full",data:b}}const d=v[I++],u=[];for(let g=0;g<d;g++){const b=v[I++],D=v[I++],p=v[I++];let i;p>0&&(i=v.subarray(I,I+p),I+=p),u[g]={start:b,deleteCount:D,data:i}}return{id:y,type:"delta",deltas:u}}e.decodeSemanticTokensDto=L}),define(De[167],Ce([1,0,3,6]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,S){return this.a.set(P,S),this.fire([P]),(0,A.toDisposable)(()=>{this.a.get(P)===S&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,S){this.b.get(P)?.dispose();const k=new R(this,P,S);return this.b.set(P,k),(0,A.toDisposable)(()=>{const L=this.b.get(P);!L||L!==k||(this.b.delete(P),L.dispose())})}async getOrCreate(P){const S=this.get(P);if(S)return S;const k=this.b.get(P);return!k||k.isResolved?null:(await k.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const k=this.b.get(P);return!!(!k||k.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class R extends A.Disposable{get isResolved(){return this.c}constructor(P,S,k){super(),this.f=P,this.g=S,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(De[71],Ce([1,0,67,2,32,167]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(f,E,w){this._tokenBrand=void 0,this.offset=f,this.type=E,this.language=w}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class P{constructor(f,E){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=E}}e.TokenizationResult=P;class S{constructor(f,E){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=E}}e.EncodedTokenizationResult=S;var k;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(k=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(t){const f=new Map;f.set(0,a.Codicon.symbolMethod),f.set(1,a.Codicon.symbolFunction),f.set(2,a.Codicon.symbolConstructor),f.set(3,a.Codicon.symbolField),f.set(4,a.Codicon.symbolVariable),f.set(5,a.Codicon.symbolClass),f.set(6,a.Codicon.symbolStruct),f.set(7,a.Codicon.symbolInterface),f.set(8,a.Codicon.symbolModule),f.set(9,a.Codicon.symbolProperty),f.set(10,a.Codicon.symbolEvent),f.set(11,a.Codicon.symbolOperator),f.set(12,a.Codicon.symbolUnit),f.set(13,a.Codicon.symbolValue),f.set(15,a.Codicon.symbolEnum),f.set(14,a.Codicon.symbolConstant),f.set(15,a.Codicon.symbolEnum),f.set(16,a.Codicon.symbolEnumMember),f.set(17,a.Codicon.symbolKeyword),f.set(27,a.Codicon.symbolSnippet),f.set(18,a.Codicon.symbolText),f.set(19,a.Codicon.symbolColor),f.set(20,a.Codicon.symbolFile),f.set(21,a.Codicon.symbolReference),f.set(22,a.Codicon.symbolCustomColor),f.set(23,a.Codicon.symbolFolder),f.set(24,a.Codicon.symbolTypeParameter),f.set(25,a.Codicon.account),f.set(26,a.Codicon.issues);function E(V){let j=f.get(V);return j||(console.info("No codicon found for CompletionItemKind "+V),j=a.Codicon.symbolProperty),j}t.toIcon=E;const w=new Map;w.set("method",0),w.set("function",1),w.set("constructor",2),w.set("field",3),w.set("variable",4),w.set("class",5),w.set("struct",6),w.set("interface",7),w.set("module",8),w.set("property",9),w.set("event",10),w.set("operator",11),w.set("unit",12),w.set("value",13),w.set("constant",14),w.set("enum",15),w.set("enum-member",16),w.set("enumMember",16),w.set("keyword",17),w.set("snippet",27),w.set("text",18),w.set("color",19),w.set("file",20),w.set("reference",21),w.set("customcolor",22),w.set("folder",23),w.set("type-parameter",24),w.set("typeParameter",24),w.set("account",25),w.set("issue",26);function O(V,j){let F=w.get(V);return typeof F>"u"&&!j&&(F=9),F}t.fromString=O})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(t){t[t.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(t){return t&&A.URI.isUri(t.uri)&&l.Range.isIRange(t.range)&&(l.Range.isIRange(t.originSelectionRange)||l.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=g;var b;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var D;(function(t){t[t.Deprecated=1]="Deprecated"})(D=e.SymbolTag||(e.SymbolTag={}));var p;(function(t){const f=new Map;f.set(0,a.Codicon.symbolFile),f.set(1,a.Codicon.symbolModule),f.set(2,a.Codicon.symbolNamespace),f.set(3,a.Codicon.symbolPackage),f.set(4,a.Codicon.symbolClass),f.set(5,a.Codicon.symbolMethod),f.set(6,a.Codicon.symbolProperty),f.set(7,a.Codicon.symbolField),f.set(8,a.Codicon.symbolConstructor),f.set(9,a.Codicon.symbolEnum),f.set(10,a.Codicon.symbolInterface),f.set(11,a.Codicon.symbolFunction),f.set(12,a.Codicon.symbolVariable),f.set(13,a.Codicon.symbolConstant),f.set(14,a.Codicon.symbolString),f.set(15,a.Codicon.symbolNumber),f.set(16,a.Codicon.symbolBoolean),f.set(17,a.Codicon.symbolArray),f.set(18,a.Codicon.symbolObject),f.set(19,a.Codicon.symbolKey),f.set(20,a.Codicon.symbolNull),f.set(21,a.Codicon.symbolEnumMember),f.set(22,a.Codicon.symbolStruct),f.set(23,a.Codicon.symbolEvent),f.set(24,a.Codicon.symbolOperator),f.set(25,a.Codicon.symbolTypeParameter);function E(w){let O=f.get(w);return O||(console.info("No codicon found for SymbolKind "+w),O=a.Codicon.symbolProperty),O}t.toIcon=E})(p=e.SymbolKinds||(e.SymbolKinds={}));class i{static fromValue(f){switch(f){case"comment":return i.Comment;case"imports":return i.Imports;case"region":return i.Region}return new i(f)}constructor(f){this.value=f}}i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region"),e.FoldingRangeKind=i;var o;(function(t){function f(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}t.is=f})(o=e.Command||(e.Command={}));var r;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(c=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var m;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[168],Ce([17,18]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(De[121],Ce([1,0,168,10,106,15,23,151]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor(Q,pe,Le,$e){this.id=Q,this.name=pe,this.defaultValue=Le,this.schema=$e}applyUpdate(Q,pe){return I(Q,pe)}compute(Q,pe,Le){return Le}}class v{constructor(Q,pe){this.newValue=Q,this.didChange=pe}}e.ApplyUpdateResult=v;function I(K,Q){if(typeof K!="object"||typeof Q!="object"||!K||!Q)return new v(Q,K!==Q);if(Array.isArray(K)||Array.isArray(Q)){const Le=Array.isArray(K)&&Array.isArray(Q)&&R.equals(K,Q);return new v(Q,!Le)}let pe=!1;for(const Le in Q)if(Q.hasOwnProperty(Le)){const $e=I(K[Le],Q[Le]);$e.didChange&&(K[Le]=$e.newValue,pe=!0)}return new v(K,pe)}class y{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,pe){return I(Q,pe)}validate(Q){return this.defaultValue}}class h{constructor(Q,pe,Le,$e){this.id=Q,this.name=pe,this.defaultValue=Le,this.schema=$e}applyUpdate(Q,pe){return I(Q,pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,pe,Le){return Le}}function d(K,Q){return typeof K>"u"?Q:K==="false"?!1:Boolean(K)}e.boolean=d;class u extends h{constructor(Q,pe,Le,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Le),super(Q,pe,Le,$e)}validate(Q){return d(Q,this.defaultValue)}}function g(K,Q,pe,Le){if(typeof K>"u")return Q;let $e=parseInt(K,10);return isNaN($e)?Q:($e=Math.max(pe,$e),$e=Math.min(Le,$e),$e|0)}e.clampedInt=g;class b extends h{static clampedInt(Q,pe,Le,$e){return g(Q,pe,Le,$e)}constructor(Q,pe,Le,$e,je,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Le,Ye.minimum=$e,Ye.maximum=je),super(Q,pe,Le,Ye),this.minimum=$e,this.maximum=je}validate(Q){return b.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class D extends h{static clamp(Q,pe,Le){return Q<pe?pe:Q>Le?Le:Q}static float(Q,pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return pe;const Le=parseFloat(Q);return isNaN(Le)?pe:Le}constructor(Q,pe,Le,$e,je){typeof je<"u"&&(je.type="number",je.default=Le),super(Q,pe,Le,je),this.validationFn=$e}validate(Q){return this.validationFn(D.float(Q,this.defaultValue))}}class p extends h{static string(Q,pe){return typeof Q!="string"?pe:Q}constructor(Q,pe,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Le),super(Q,pe,Le,$e)}validate(Q){return p.string(Q,this.defaultValue)}}function i(K,Q,pe){return typeof K!="string"||pe.indexOf(K)===-1?Q:K}e.stringSet=i;class o extends h{constructor(Q,pe,Le,$e,je=void 0){typeof je<"u"&&(je.type="string",je.enum=$e,je.default=Le),super(Q,pe,Le,je),this.c=$e}validate(Q){return i(Q,this.defaultValue,this.c)}}class r extends T{constructor(Q,pe,Le,$e,je,Ye,et=void 0){typeof et<"u"&&(et.type="string",et.enum=je,et.default=$e),super(Q,pe,Le,et),this.c=je,this.d=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function c(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,pe,Le){return Le===0?Q.accessibilitySupport:Le}}class m extends T{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertSpace:d(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(K){switch(K){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function w(K){switch(K){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class O extends y{constructor(){super(135)}compute(Q,pe,Le){const $e=["monaco-editor"];return pe.get(36)&&$e.push(pe.get(36)),Q.extraEditorClassName&&$e.push(Q.extraEditorClassName),pe.get(70)==="default"?$e.push("mouse-default"):pe.get(70)==="copy"&&$e.push("mouse-copy"),pe.get(105)&&$e.push("showUnused"),pe.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class V extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Q,pe,Le){return Le&&Q.emptySelectionClipboard}}class j extends T{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{cursorMoveOnType:d(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":i(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":i(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(pe.loop,this.defaultValue.loop)}}}class F extends T{constructor(){super(48,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?F.OFF:Q==="true"?F.ON:Q:Boolean(Q)?F.ON:F.OFF}}F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on',e.EditorFontLigatures=F;class B extends T{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.TRANSLATE:Q:Boolean(Q)?B.TRANSLATE:B.OFF}compute(Q,pe,Le){return Q.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class N extends y{constructor(){super(47)}compute(Q,pe,Le){return Q.fontInfo}}class U extends h{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(Q){const pe=D.float(Q,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(pe,6,100)}compute(Q,pe,Le){return Q.fontInfo.fontSize}}class $ extends T{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.d,maximum:$.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(b.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,$.d,$.e))}}$.c=["normal","bold","100","200","300","400","500","600","700","800","900"],$.d=1,$.e=1e3;class z extends T{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:a.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{multiple:i(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??i(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??i(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??i(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??i(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??i(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends T{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:d(pe.enabled,this.defaultValue.enabled),delay:b.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:d(pe.sticky,this.defaultValue.sticky),above:d(pe.above,this.defaultValue.above)}}}var ee;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(ee=e.RenderMinimap||(e.RenderMinimap={}));class q extends y{constructor(){super(138)}compute(Q,pe,Le){return q.computeLayout(pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const pe=Q.height/Q.lineHeight,Le=Math.floor(Q.paddingTop/Q.lineHeight);let $e=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&($e=Math.max($e,pe-1));const je=(Le+Q.viewLineCount+$e)/(Q.pixelRatio*Q.height),Ye=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:$e,desiredRatio:je,minimapLineCount:Ye}}static c(Q,pe){const Le=Q.outerWidth,$e=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Ye=pe.stableMinimapLayoutInput,et=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.paddingTop===Ye.paddingTop&&Q.paddingBottom===Ye.paddingBottom&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,ot=Q.lineHeight,ft=Q.typicalHalfwidthCharacterWidth,bt=Q.scrollBeyondLastLine,Lt=Q.minimap.renderCharacters;let st=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const pt=Q.minimap.maxColumn,Ft=Q.minimap.size,Kt=Q.minimap.side,Pt=Q.verticalScrollbarWidth,mt=Q.viewLineCount,kt=Q.remainingWidth,$t=Q.isViewportWrapping,Ot=Lt?2:3;let Xe=Math.floor(je*$e);const Mt=Xe/je;let Ut=!1,Wt=!1,gt=Ot*st,Re=st/je,Ne=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:tt,extraLinesBeforeFirstLine:ut,extraLinesBeyondLastLine:Tt,desiredRatio:Et,minimapLineCount:St}=q.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:bt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:$e,lineHeight:ot,pixelRatio:je});if(mt/St>1)Ut=!0,Wt=!0,st=1,gt=1,Re=st/je;else{let yt=!1,Dt=st+1;if(Ft==="fit"){const qt=Math.ceil((ut+mt+Tt)*gt);$t&&et&&kt<=pe.stableFitRemainingWidth?(yt=!0,Dt=pe.stableFitMaxMinimapScale):yt=qt>Xe}if(Ft==="fill"||yt){Ut=!0;const qt=st;gt=Math.min(ot*je,Math.max(1,Math.floor(1/Et))),$t&&et&&kt<=pe.stableFitRemainingWidth&&(Dt=pe.stableFitMaxMinimapScale),st=Math.min(Dt,Math.max(1,Math.floor(gt/Ot))),st>qt&&(Ne=Math.min(2,st/qt)),Re=st/je/Ne,Xe=Math.ceil(Math.max(tt,ut+mt+Tt)*gt),$t?(pe.stableMinimapLayoutInput=Q,pe.stableFitRemainingWidth=kt,pe.stableFitMaxMinimapScale=st):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ye=Math.floor(pt*Re),re=Math.min(ye,Math.max(0,Math.floor((kt-Pt-2)*Re/(ft+Re)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(je*re);const He=Fe/je;Fe=Math.floor(Fe*Ne);const Je=Lt?1:2,qe=Kt==="left"?0:Le-re-Pt;return{renderMinimap:Je,minimapLeft:qe,minimapWidth:re,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Wt,minimapScale:st,minimapLineHeight:gt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:Mt}}static computeLayout(Q,pe){const Le=pe.outerWidth|0,$e=pe.outerHeight|0,je=pe.lineHeight|0,Ye=pe.lineNumbersDigitCount|0,et=pe.typicalHalfwidthCharacterWidth,ot=pe.maxDigitWidth,ft=pe.pixelRatio,bt=pe.viewLineCount,Lt=Q.get(130),st=Lt==="inherit"?Q.get(129):Lt,pt=st==="inherit"?Q.get(125):st,Ft=Q.get(128),Kt=pe.isDominatedByLongLines,Pt=Q.get(54),mt=Q.get(64).renderType!==0,kt=Q.get(65),$t=Q.get(99),Ot=Q.get(80),Xe=Q.get(69),Mt=Q.get(97),Ut=Mt.verticalScrollbarSize,Wt=Mt.verticalHasArrows,gt=Mt.arrowSize,Re=Mt.horizontalScrollbarSize,Ne=Q.get(40),ye=Q.get(104)!=="never";let re=Q.get(62);Ne&&ye&&(re+=16);let Fe=0;if(mt){const wt=Math.max(Ye,kt);Fe=Math.round(wt*ot)}let He=0;Pt&&(He=je);let Je=0,qe=Je+He,tt=qe+Fe,ut=tt+re;const Tt=Le-He-Fe-re;let Et=!1,St=!1,It=-1;st==="inherit"&&Kt?(Et=!0,St=!0):pt==="on"||pt==="bounded"?St=!0:pt==="wordWrapColumn"&&(It=Ft);const yt=q.c({outerWidth:Le,outerHeight:$e,lineHeight:je,typicalHalfwidthCharacterWidth:et,pixelRatio:ft,scrollBeyondLastLine:$t,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:bt,remainingWidth:Tt,isViewportWrapping:St},pe.memory||new L);yt.renderMinimap!==0&&yt.minimapLeft===0&&(Je+=yt.minimapWidth,qe+=yt.minimapWidth,tt+=yt.minimapWidth,ut+=yt.minimapWidth);const Dt=Tt-yt.minimapWidth,qt=Math.max(1,Math.floor((Dt-Ut-2)/et)),_t=Wt?gt:0;return St&&(It=Math.max(1,qt),pt==="bounded"&&(It=Math.min(It,Ft))),{width:Le,height:$e,glyphMarginLeft:Je,glyphMarginWidth:He,lineNumbersLeft:qe,lineNumbersWidth:Fe,decorationsLeft:tt,decorationsWidth:re,contentLeft:ut,contentWidth:Dt,minimap:yt,viewportColumn:qt,isWordWrapMinified:Et,isViewportWrapping:St,wrappingColumn:It,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Re,overviewRuler:{top:_t,width:Ut,height:$e-2*_t,right:0}}}}e.EditorLayoutInfoComputer=q;class J extends T{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(Q){return i(Q,"simple",["simple","advanced"])}compute(Q,pe,Le){return pe.get(2)===2?"advanced":Le}}class ie extends T{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:a.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class ge extends T{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:d(pe.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends T{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:a.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:i(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(pe.fontFamily,this.defaultValue.fontFamily),padding:d(pe.padding,this.defaultValue.padding)}}}class Y extends T{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):b.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,pe,Le){return Le<0?b.clampedInt(-Le*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class Z extends D{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>D.clamp(Q,0,150),{markdownDescription:a.localize(60,null)})}compute(Q,pe,Le){return Q.fontInfo.lineHeight}}class fe extends T{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:Q.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:d(pe.enabled,this.defaultValue.enabled),autohide:d(pe.autohide,this.defaultValue.autohide),size:i(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(pe.side,this.defaultValue.side,["right","left"]),showSlider:i(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(pe.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(pe.scale,1,1,3),maxColumn:b.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(K){return K==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends T{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{top:b.clampedInt(pe.top,0,0,1e3),bottom:b.clampedInt(pe.bottom,0,0,1e3)}}}class Oe extends T{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:d(pe.enabled,this.defaultValue.enabled),cycle:d(pe.cycle,this.defaultValue.cycle)}}}class oe extends y{constructor(){super(136)}compute(Q,pe,Le){return Q.pixelRatio}}class le extends T{constructor(){const Q={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Q.strings,description:a.localize(79,null)},comments:{anyOf:pe,default:Q.comments,description:a.localize(80,null)},other:{anyOf:pe,default:Q.other,description:a.localize(81,null)}},default:Q,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ft=Q?"on":"off";return{comments:ft,strings:ft,other:ft}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:pe,comments:Le,strings:$e}=Q,je=["on","inline","off"];let Ye,et,ot;return typeof pe=="boolean"?Ye=pe?"on":"off":Ye=i(pe,this.defaultValue.other,je),typeof Le=="boolean"?et=Le?"on":"off":et=i(Le,this.defaultValue.comments,je),typeof $e=="boolean"?ot=$e?"on":"off":ot=i($e,this.defaultValue.strings,je),{other:Ye,comments:et,strings:ot}}}var ue;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class te extends T{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(Q){let pe=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(pe=4,Le=Q):Q==="interval"?pe=3:Q==="relative"?pe=2:Q==="on"?pe=1:pe=0),{renderType:pe,renderFn:Le}}}function ce(K){const Q=K.get(92);return Q==="editable"?K.get(86):Q!=="on"}e.filterValidationDecorations=ce;class se extends T{constructor(){const Q=[],pe={type:"number",description:a.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:Q,description:a.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const pe=[];for(const Le of Q)if(typeof Le=="number")pe.push({column:b.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const $e=Le;pe.push({column:b.clampedInt($e.column,0,0,1e4),color:$e.color})}return pe.sort((Le,$e)=>Le.column-$e.column),pe}return this.defaultValue}}function M(K,Q){if(typeof K!="string")return Q;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends T{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q,Le=b.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=b.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(pe.vertical,this.defaultValue.vertical),horizontal:M(pe.horizontal,this.defaultValue.horizontal),useShadows:d(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:b.clampedInt(pe.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:b.clampedInt(pe.verticalSliderSize,$e,0,1e3),scrollByPage:d(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends T{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:a.localize(108,null)}})}applyUpdate(Q,pe){let Le=!1;pe.allowedCharacters&&Q&&(C.equals(Q.allowedCharacters,pe.allowedCharacters)||(Q={...Q,allowedCharacters:pe.allowedCharacters},Le=!0)),pe.allowedLocales&&Q&&(C.equals(Q.allowedLocales,pe.allowedLocales)||(Q={...Q,allowedLocales:pe.allowedLocales},Le=!0));const $e=super.applyUpdate(Q,pe);return Le?new v($e.newValue,!0):$e}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{nonBasicASCII:Ae(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,pe){if(typeof Q!="object"||!Q)return pe;const Le={};for(const[$e,je]of Object.entries(Q))je===!0&&(Le[$e]=!0);return Le}}class _ extends T{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(110,null),a.localize(111,null)],description:a.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:d(pe.enabled,this.defaultValue.enabled),mode:i(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class de extends T{constructor(){const Q={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:a.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:d(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends T{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:Q.bracketPairs,description:a.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(119,null),a.localize(120,null),a.localize(121,null)],default:Q.bracketPairsHorizontal,description:a.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(125,null),a.localize(126,null),a.localize(127,null)],default:Q.highlightActiveIndentation,description:a.localize(128,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{bracketPairs:Ae(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(K,Q,pe){const Le=pe.indexOf(K);return Le===-1?Q:pe[Le]}class be extends T{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(129,null),a.localize(130,null)],default:Q.insertMode,description:a.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(135,null),a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:Q.selectionMode,markdownDescription:a.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertMode:i(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(pe.showIcons,this.defaultValue.showIcons),showStatusBar:d(pe.showStatusBar,this.defaultValue.showStatusBar),preview:d(pe.preview,this.defaultValue.preview),previewMode:i(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(pe.showMethods,this.defaultValue.showMethods),showFunctions:d(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:d(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(pe.showFields,this.defaultValue.showFields),showVariables:d(pe.showVariables,this.defaultValue.showVariables),showClasses:d(pe.showClasses,this.defaultValue.showClasses),showStructs:d(pe.showStructs,this.defaultValue.showStructs),showInterfaces:d(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:d(pe.showModules,this.defaultValue.showModules),showProperties:d(pe.showProperties,this.defaultValue.showProperties),showEvents:d(pe.showEvents,this.defaultValue.showEvents),showOperators:d(pe.showOperators,this.defaultValue.showOperators),showUnits:d(pe.showUnits,this.defaultValue.showUnits),showValues:d(pe.showValues,this.defaultValue.showValues),showConstants:d(pe.showConstants,this.defaultValue.showConstants),showEnums:d(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:d(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(pe.showKeywords,this.defaultValue.showKeywords),showWords:d(pe.showWords,this.defaultValue.showWords),showColors:d(pe.showColors,this.defaultValue.showColors),showFiles:d(pe.showFiles,this.defaultValue.showFiles),showReferences:d(pe.showReferences,this.defaultValue.showReferences),showFolders:d(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:d(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(pe.showSnippets,this.defaultValue.showSnippets),showUsers:d(pe.showUsers,this.defaultValue.showUsers),showIssues:d(pe.showIssues,this.defaultValue.showIssues)}}}class Ie extends T{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(177,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Te extends y{constructor(){super(137)}compute(Q,pe,Le){return pe.get(86)?!0:Q.tabFocusMode}}var Ve;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(Ve=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends T{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null)],description:a.localize(182,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,pe,Le){return pe.get(2)===2?0:Le}}class nt extends y{constructor(){super(139)}compute(Q,pe,Le){const $e=pe.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class Qe extends T{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(183,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}const it="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?rt:A.isLinux?ct:it,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(K){return e.editorOptionsRegistry[K.id]=K,K}var Ee;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.bracketPairColorization=12]="bracketPairColorization",K[K.guides=13]="guides",K[K.codeLens=14]="codeLens",K[K.codeLensFontFamily=15]="codeLensFontFamily",K[K.codeLensFontSize=16]="codeLensFontSize",K[K.colorDecorators=17]="colorDecorators",K[K.colorDecoratorsLimit=18]="colorDecoratorsLimit",K[K.columnSelection=19]="columnSelection",K[K.comments=20]="comments",K[K.contextmenu=21]="contextmenu",K[K.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",K[K.cursorBlinking=23]="cursorBlinking",K[K.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",K[K.cursorStyle=25]="cursorStyle",K[K.cursorSurroundingLines=26]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",K[K.cursorWidth=28]="cursorWidth",K[K.disableLayerHinting=29]="disableLayerHinting",K[K.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",K[K.domReadOnly=31]="domReadOnly",K[K.dragAndDrop=32]="dragAndDrop",K[K.dropIntoEditor=33]="dropIntoEditor",K[K.emptySelectionClipboard=34]="emptySelectionClipboard",K[K.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",K[K.extraEditorClassName=36]="extraEditorClassName",K[K.fastScrollSensitivity=37]="fastScrollSensitivity",K[K.find=38]="find",K[K.fixedOverflowWidgets=39]="fixedOverflowWidgets",K[K.folding=40]="folding",K[K.foldingStrategy=41]="foldingStrategy",K[K.foldingHighlight=42]="foldingHighlight",K[K.foldingImportsByDefault=43]="foldingImportsByDefault",K[K.foldingMaximumRegions=44]="foldingMaximumRegions",K[K.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=46]="fontFamily",K[K.fontInfo=47]="fontInfo",K[K.fontLigatures=48]="fontLigatures",K[K.fontSize=49]="fontSize",K[K.fontWeight=50]="fontWeight",K[K.fontVariations=51]="fontVariations",K[K.formatOnPaste=52]="formatOnPaste",K[K.formatOnType=53]="formatOnType",K[K.glyphMargin=54]="glyphMargin",K[K.gotoLocation=55]="gotoLocation",K[K.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",K[K.hover=57]="hover",K[K.inDiffEditor=58]="inDiffEditor",K[K.inlineSuggest=59]="inlineSuggest",K[K.letterSpacing=60]="letterSpacing",K[K.lightbulb=61]="lightbulb",K[K.lineDecorationsWidth=62]="lineDecorationsWidth",K[K.lineHeight=63]="lineHeight",K[K.lineNumbers=64]="lineNumbers",K[K.lineNumbersMinChars=65]="lineNumbersMinChars",K[K.linkedEditing=66]="linkedEditing",K[K.links=67]="links",K[K.matchBrackets=68]="matchBrackets",K[K.minimap=69]="minimap",K[K.mouseStyle=70]="mouseStyle",K[K.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=72]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",K[K.multiCursorModifier=74]="multiCursorModifier",K[K.multiCursorPaste=75]="multiCursorPaste",K[K.multiCursorLimit=76]="multiCursorLimit",K[K.occurrencesHighlight=77]="occurrencesHighlight",K[K.overviewRulerBorder=78]="overviewRulerBorder",K[K.overviewRulerLanes=79]="overviewRulerLanes",K[K.padding=80]="padding",K[K.parameterHints=81]="parameterHints",K[K.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",K[K.quickSuggestions=84]="quickSuggestions",K[K.quickSuggestionsDelay=85]="quickSuggestionsDelay",K[K.readOnly=86]="readOnly",K[K.renameOnType=87]="renameOnType",K[K.renderControlCharacters=88]="renderControlCharacters",K[K.renderFinalNewline=89]="renderFinalNewline",K[K.renderLineHighlight=90]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=92]="renderValidationDecorations",K[K.renderWhitespace=93]="renderWhitespace",K[K.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",K[K.roundedSelection=95]="roundedSelection",K[K.rulers=96]="rulers",K[K.scrollbar=97]="scrollbar",K[K.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=99]="scrollBeyondLastLine",K[K.scrollPredominantAxis=100]="scrollPredominantAxis",K[K.selectionClipboard=101]="selectionClipboard",K[K.selectionHighlight=102]="selectionHighlight",K[K.selectOnLineNumbers=103]="selectOnLineNumbers",K[K.showFoldingControls=104]="showFoldingControls",K[K.showUnused=105]="showUnused",K[K.snippetSuggestions=106]="snippetSuggestions",K[K.smartSelect=107]="smartSelect",K[K.smoothScrolling=108]="smoothScrolling",K[K.stickyScroll=109]="stickyScroll",K[K.stickyTabStops=110]="stickyTabStops",K[K.stopRenderingLineAfter=111]="stopRenderingLineAfter",K[K.suggest=112]="suggest",K[K.suggestFontSize=113]="suggestFontSize",K[K.suggestLineHeight=114]="suggestLineHeight",K[K.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",K[K.suggestSelection=116]="suggestSelection",K[K.tabCompletion=117]="tabCompletion",K[K.tabIndex=118]="tabIndex",K[K.unicodeHighlighting=119]="unicodeHighlighting",K[K.unusualLineTerminators=120]="unusualLineTerminators",K[K.useShadowDOM=121]="useShadowDOM",K[K.useTabStops=122]="useTabStops",K[K.wordBreak=123]="wordBreak",K[K.wordSeparators=124]="wordSeparators",K[K.wordWrap=125]="wordWrap",K[K.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=128]="wordWrapColumn",K[K.wordWrapOverride1=129]="wordWrapOverride1",K[K.wordWrapOverride2=130]="wordWrapOverride2",K[K.wrappingIndent=131]="wrappingIndent",K[K.wrappingStrategy=132]="wrappingStrategy",K[K.showDeprecated=133]="showDeprecated",K[K.inlayHints=134]="inlayHints",K[K.editorClassName=135]="editorClassName",K[K.pixelRatio=136]="pixelRatio",K[K.tabFocusMode=137]="tabFocusMode",K[K.layoutInfo=138]="layoutInfo",K[K.wrappingInfo=139]="wrappingInfo"})(Ee=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(184,null)})),acceptSuggestionOnEnter:Me(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(185,null),""],markdownDescription:a.localize(186,null)})),accessibilitySupport:Me(new s),accessibilityPageSize:Me(new b(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(187,null),tags:["accessibility"]})),ariaLabel:Me(new p(4,"ariaLabel",a.localize(188,null))),autoClosingBrackets:Me(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoClosingDelete:Me(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(192,null),""],description:a.localize(193,null)})),autoClosingOvertype:Me(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(194,null),""],description:a.localize(195,null)})),autoClosingQuotes:Me(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(196,null),a.localize(197,null),""],description:a.localize(198,null)})),autoIndent:Me(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[a.localize(199,null),a.localize(200,null),a.localize(201,null),a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),automaticLayout:Me(new u(10,"automaticLayout",!1)),autoSurround:Me(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(205,null),a.localize(206,null),a.localize(207,null),""],description:a.localize(208,null)})),bracketPairColorization:Me(new de),bracketPairGuides:Me(new we),stickyTabStops:Me(new u(110,"stickyTabStops",!1,{description:a.localize(209,null)})),codeLens:Me(new u(14,"codeLens",!0,{description:a.localize(210,null)})),codeLensFontFamily:Me(new p(15,"codeLensFontFamily","",{description:a.localize(211,null)})),codeLensFontSize:Me(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(212,null)})),colorDecorators:Me(new u(17,"colorDecorators",!0,{description:a.localize(213,null)})),colorDecoratorsLimit:Me(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(214,null)})),columnSelection:Me(new u(19,"columnSelection",!1,{description:a.localize(215,null)})),comments:Me(new m),contextmenu:Me(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new u(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(216,null)})),cursorBlinking:Me(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:a.localize(217,null)})),cursorSmoothCaretAnimation:Me(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(218,null),a.localize(219,null),a.localize(220,null)],description:a.localize(221,null)})),cursorStyle:Me(new r(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:a.localize(222,null)})),cursorSurroundingLines:Me(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(223,null)})),cursorSurroundingLinesStyle:Me(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(224,null),a.localize(225,null)],description:a.localize(226,null)})),cursorWidth:Me(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(227,null)})),disableLayerHinting:Me(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new u(31,"domReadOnly",!1)),dragAndDrop:Me(new u(32,"dragAndDrop",!0,{description:a.localize(228,null)})),emptySelectionClipboard:Me(new V),dropIntoEditor:Me(new Qe),stickyScroll:Me(new ge),experimentalWhitespaceRendering:Me(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(229,null),a.localize(230,null),a.localize(231,null)],description:a.localize(232,null)})),extraEditorClassName:Me(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new D(37,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:a.localize(233,null)})),find:Me(new j),fixedOverflowWidgets:Me(new u(39,"fixedOverflowWidgets",!1)),folding:Me(new u(40,"folding",!0,{description:a.localize(234,null)})),foldingStrategy:Me(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),foldingHighlight:Me(new u(42,"foldingHighlight",!0,{description:a.localize(238,null)})),foldingImportsByDefault:Me(new u(43,"foldingImportsByDefault",!1,{description:a.localize(239,null)})),foldingMaximumRegions:Me(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(240,null)})),unfoldOnClickAfterEndOfLine:Me(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(241,null)})),fontFamily:Me(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(242,null)})),fontInfo:Me(new N),fontLigatures2:Me(new F),fontSize:Me(new U),fontWeight:Me(new $),fontVariations:Me(new B),formatOnPaste:Me(new u(52,"formatOnPaste",!1,{description:a.localize(243,null)})),formatOnType:Me(new u(53,"formatOnType",!1,{description:a.localize(244,null)})),glyphMargin:Me(new u(54,"glyphMargin",!0,{description:a.localize(245,null)})),gotoLocation:Me(new z),hideCursorInOverviewRuler:Me(new u(56,"hideCursorInOverviewRuler",!1,{description:a.localize(246,null)})),hover:Me(new ae),inDiffEditor:Me(new u(58,"inDiffEditor",!1)),letterSpacing:Me(new D(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>D.clamp(K,-5,20),{description:a.localize(247,null)})),lightbulb:Me(new ie),lineDecorationsWidth:Me(new Y),lineHeight:Me(new Z),lineNumbers:Me(new te),lineNumbersMinChars:Me(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new u(66,"linkedEditing",!1,{description:a.localize(248,null)})),links:Me(new u(67,"links",!0,{description:a.localize(249,null)})),matchBrackets:Me(new o(68,"matchBrackets","always",["always","near","never"],{description:a.localize(250,null)})),minimap:Me(new fe),mouseStyle:Me(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new D(71,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:a.localize(251,null)})),mouseWheelZoom:Me(new u(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(252,null)})),multiCursorMergeOverlapping:Me(new u(73,"multiCursorMergeOverlapping",!0,{description:a.localize(253,null)})),multiCursorModifier:Me(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorPaste:Me(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorLimit:Me(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(260,null)})),occurrencesHighlight:Me(new u(77,"occurrencesHighlight",!0,{description:a.localize(261,null)})),overviewRulerBorder:Me(new u(78,"overviewRulerBorder",!0,{description:a.localize(262,null)})),overviewRulerLanes:Me(new b(79,"overviewRulerLanes",3,0,3)),padding:Me(new ke),parameterHints:Me(new Oe),peekWidgetDefaultFocus:Me(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),definitionLinkOpensInPeek:Me(new u(83,"definitionLinkOpensInPeek",!1,{description:a.localize(266,null)})),quickSuggestions:Me(new le),quickSuggestionsDelay:Me(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(267,null)})),readOnly:Me(new u(86,"readOnly",!1)),renameOnType:Me(new u(87,"renameOnType",!1,{description:a.localize(268,null),markdownDeprecationMessage:a.localize(269,null)})),renderControlCharacters:Me(new u(88,"renderControlCharacters",!0,{description:a.localize(270,null),restricted:!0})),renderFinalNewline:Me(new o(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(271,null)})),renderLineHighlight:Me(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(272,null)],description:a.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Me(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(274,null)})),renderValidationDecorations:Me(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(275,null),a.localize(276,null),a.localize(277,null),""],description:a.localize(278,null)})),revealHorizontalRightPadding:Me(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new u(95,"roundedSelection",!0,{description:a.localize(279,null)})),rulers:Me(new se),scrollbar:Me(new W),scrollBeyondLastColumn:Me(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(280,null)})),scrollBeyondLastLine:Me(new u(99,"scrollBeyondLastLine",!0,{description:a.localize(281,null)})),scrollPredominantAxis:Me(new u(100,"scrollPredominantAxis",!0,{description:a.localize(282,null)})),selectionClipboard:Me(new u(101,"selectionClipboard",!0,{description:a.localize(283,null),included:A.isLinux})),selectionHighlight:Me(new u(102,"selectionHighlight",!0,{description:a.localize(284,null)})),selectOnLineNumbers:Me(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),showUnused:Me(new u(105,"showUnused",!0,{description:a.localize(289,null)})),showDeprecated:Me(new u(133,"showDeprecated",!0,{description:a.localize(290,null)})),inlayHints:Me(new X),snippetSuggestions:Me(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(291,null),a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),smartSelect:Me(new Ie),smoothScrolling:Me(new u(108,"smoothScrolling",!1,{description:a.localize(296,null)})),stopRenderingLineAfter:Me(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new be),inlineSuggest:Me(new _),suggestFontSize:Me(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new u(115,"suggestOnTriggerCharacters",!0,{description:a.localize(299,null)})),suggestSelection:Me(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(300,null),a.localize(301,null),a.localize(302,null)],description:a.localize(303,null)})),tabCompletion:Me(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(304,null),a.localize(305,null),a.localize(306,null)],description:a.localize(307,null)})),tabIndex:Me(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new G),unusualLineTerminators:Me(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(308,null),a.localize(309,null),a.localize(310,null)],description:a.localize(311,null)})),useShadowDOM:Me(new u(121,"useShadowDOM",!0)),useTabStops:Me(new u(122,"useTabStops",!0,{description:a.localize(312,null)})),wordBreak:Me(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(313,null),a.localize(314,null)],description:a.localize(315,null)})),wordSeparators:Me(new p(124,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:a.localize(316,null)})),wordWrap:Me(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(317,null),a.localize(318,null),a.localize(319,null),a.localize(320,null)],description:a.localize(321,null)})),wordWrapBreakAfterCharacters:Me(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(322,null)})),wordWrapOverride1:Me(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new O),pixelRatio:Me(new oe),tabFocusMode:Me(new Te),layoutInfo:Me(new q),wrappingInfo:Me(new nt),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new J)}}),define(De[169],Ce([17,18]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[170],Ce([17,18]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[171],Ce([17,18]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[172],Ce([17,18]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[173],Ce([17,18]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(De[174],Ce([17,18]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(De[175],Ce([17,18]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(De[176],Ce([17,18]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(De[177],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[178],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[179],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(De[180],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[181],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[182],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[183],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[184],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[185],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[186],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[187],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(De[188],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(De[189],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[190],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[191],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[192],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[193],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[194],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[195],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[196],Ce([17,18]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[197],Ce([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(R,C){this.a.set(R,C)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const C in R.contributes){const P=this.a.get(C);if(!P)continue;const S=R.contributes[C],k=Array.isArray(S)?S:[S];try{P(k,R.activationEvents)}catch(L){(0,a.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(De[198],Ce([1,0,24,37,171,319]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||C.test(u)}e.isValidVersionStr=S;function k(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(C);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function L(u){if(!u)return null;const g=u.majorBase,b=u.majorMustEqual,D=u.minorBase;let p=u.minorMustEqual;const i=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(g===0||(p=!1),o=!1);let r=0;if(u.preRelease){const c=P.exec(u.preRelease);if(c){const[,s,m,n]=c;r=Date.UTC(Number(s),Number(m)-1,Number(n))}}return{majorBase:g,majorMustEqual:b,minorBase:D,minorMustEqual:p,patchBase:i,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function T(u,g,b){let D;typeof u=="string"?D=L(k(u)):D=u;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let i;if(typeof b=="string"?i=L(k(b)):i=b,!D||!i)return!1;const o=D.majorBase,r=D.minorBase,c=D.patchBase;let s=i.majorBase,m=i.minorBase,n=i.patchBase;const t=i.notBefore;let f=i.majorMustEqual,E=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:r>m?!0:r<m||p&&p<t?!1:c>=n:(o===1&&s===0&&(!f||!E||!w)&&(s=1,m=0,n=0,f=!0,E=!1,w=!1),o<s?!1:o>s?!f:r<m?!1:r>m?!E:c<n?!1:c>n?!w:!(p&&p<t))}e.isValidVersion=T;function v(u,g,b,D,p){const i=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return i.push([A.default.Error,l.localize(0,null)]),i;if(typeof D.name!="string")return i.push([A.default.Error,l.localize(1,null,"name")]),i;if(typeof D.version!="string")return i.push([A.default.Error,l.localize(2,null,"version")]),i;if(!D.engines)return i.push([A.default.Error,l.localize(3,null,"engines")]),i;if(typeof D.engines.vscode!="string")return i.push([A.default.Error,l.localize(4,null,"engines.vscode")]),i;if(typeof D.extensionDependencies<"u"&&!d(D.extensionDependencies))return i.push([A.default.Error,l.localize(5,null,"extensionDependencies")]),i;if(typeof D.activationEvents<"u"){if(!d(D.activationEvents))return i.push([A.default.Error,l.localize(6,null,"activationEvents")]),i;if(typeof D.main>"u"&&typeof D.browser>"u")return i.push([A.default.Error,l.localize(7,null,"activationEvents","main")]),i}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&i.push([A.default.Warning,l.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return i.push([A.default.Error,l.localize(9,null,"main")]),i;{const c=(0,a.joinPath)(b,D.main);(0,a.isEqualOrParent)(c,b)||i.push([A.default.Warning,l.localize(10,null,c.path,b.path)])}if(typeof D.activationEvents>"u")return i.push([A.default.Error,l.localize(11,null,"activationEvents","main")]),i}if(typeof D.browser<"u"){if(typeof D.browser!="string")return i.push([A.default.Error,l.localize(12,null,"browser")]),i;{const c=(0,a.joinPath)(b,D.browser);(0,a.isEqualOrParent)(c,b)||i.push([A.default.Warning,l.localize(13,null,c.path,b.path)])}if(typeof D.activationEvents>"u")return i.push([A.default.Error,l.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(D.version))return i.push([A.default.Error,l.localize(15,null)]),i;const o=[];if(!I(u,g,D,p,o))for(const c of o)i.push([A.default.Error,c]);return i}e.validateExtensionManifest=v;function I(u,g,b,D,p){return D||typeof b.main>"u"&&typeof b.browser>"u"?!0:h(u,g,b.engines.vscode,p)}e.isValidExtensionVersion=I;function y(u,g,b){return u==="*"||h(g,b,u)}e.isEngineValid=y;function h(u,g,b,D=[]){const p=L(k(b));if(!p)return D.push(l.localize(16,null,b)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return D.push(l.localize(17,null,b)),!1}else if(!p.majorMustEqual)return D.push(l.localize(18,null,b)),!1;return T(u,g,p)?!0:(D.push(l.localize(19,null,u,b)),!1)}function d(u){if(!Array.isArray(u))return!1;for(let g=0,b=u.length;g<b;g++)if(typeof u[g]!="string")return!1;return!0}}),define(De[122],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(l,R=[],C=!1){this.ctor=l,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=a}),define(De[90],Ce([1,0,122]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function R(P,S,k){S instanceof a.SyncDescriptor||(S=new a.SyncDescriptor(S,[],Boolean(k))),A.push([P,S])}e.registerSingleton=R;function C(){return A}e.getSingletonServiceDescriptors=C}),define(De[199],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const P=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(C);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let P=this.a.get(C);return P||(P=new a(C,R),this.a.set(C,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,P]of this.a)R.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const P=new Set([R]),S=this.c(C,P);if(S)return S}}c(R,C){for(const[P,S]of R.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const k=this.c(S,C);if(k)return k;C.delete(P)}}}e.Graph=A}),define(De[4],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(a=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function A(C,P,S){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:C,index:S}):(P[a.DI_DEPENDENCIES]=[{id:C,index:S}],P[a.DI_TARGET]=P)}function l(C){if(a.serviceIds.has(C))return a.serviceIds.get(C);const P=function(S,k,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,S,L)};return P.toString=()=>C,a.serviceIds.set(C,P),P}e.createDecorator=l;function R(C){return C}e.refineServiceDecorator=R}),define(De[53],Ce([1,0,9,2,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof A.URI)}e.isConfigurationOverrides=R;function C(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=C;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(d,u){const g=Object.create(null);for(const b in d)L(g,b,d[b],u);return g}e.toValuesTree=k;function L(d,u,g,b){const D=u.split("."),p=D.pop();let i=d;for(let o=0;o<D.length;o++){const r=D[o];let c=i[r];switch(typeof c){case"undefined":c=i[r]=Object.create(null);break;case"object":break;default:b(`Ignoring ${u} as ${D.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[p]=g}catch{b(`Ignoring ${u} as ${D.join(".")} is ${JSON.stringify(i)}`)}else b(`Ignoring ${u} as ${D.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=L;function T(d,u){const g=u.split(".");v(d,g)}e.removeFromValueTree=T;function v(d,u){const g=u.shift();if(u.length===0){delete d[g];return}if(Object.keys(d).indexOf(g)!==-1){const b=d[g];typeof b=="object"&&!Array.isArray(b)&&(v(b,u),Object.keys(b).length===0&&delete d[g])}}function I(d,u,g){function b(i,o){let r=i;for(const c of o){if(typeof r!="object"||r===null)return;r=r[c]}return r}const D=u.split("."),p=b(d,D);return typeof p>"u"?g:p}e.getConfigurationValue=I;function y(d,u,g){Object.keys(u).forEach(b=>{b!=="__proto__"&&(b in d?a.isObject(d[b])&&a.isObject(u[b])?y(d[b],u[b],g):g&&(d[b]=u[b]):d[b]=u[b])})}e.merge=y;function h(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(De[54],Ce([1,0,10,8,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",a.isMacintosh),R.set("isLinux",a.isLinux),R.set("isWindows",a.isWindows),R.set("isWeb",a.isWeb),R.set("isMacNative",a.isMacintosh&&!a.isWeb),R.set("isEdge",a.isEdge),R.set("isFirefox",a.isFirefox),R.set("isChrome",a.isChrome),R.set("isSafari",a.isSafari);const C=Object.prototype.hasOwnProperty;var P;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return T.INSTANCE}static true(){return v.INSTANCE}static has(F){return I.create(F)}static equals(F,B){return y.create(F,B)}static notEquals(F,B){return u.create(F,B)}static regex(F,B){return r.create(F,B)}static in(F,B){return h.create(F,B)}static notIn(F,B){return d.create(F,B)}static not(F){return g.create(F)}static and(...F){return m.create(F,null,!0)}static or(...F){return n.create(F,null,!0)}static greater(F,B){return D.create(F,B)}static greaterEquals(F,B){return p.create(F,B)}static smaller(F,B){return i.create(F,B)}static smallerEquals(F,B){return o.create(F,B)}static deserialize(F){if(!!F)return this.c(F)}static c(F){const B=F.split("||");return n.create(B.map(N=>this.d(N)),null,!0)}static d(F){const B=F.split("&&");return m.create(B.map(N=>this.f(N)),null,!0)}static f(F){if(F=F.trim(),F.indexOf("!=")>=0){const B=F.split("!=");return u.create(B[0].trim(),this.g(B[1]))}if(F.indexOf("==")>=0){const B=F.split("==");return y.create(B[0].trim(),this.g(B[1]))}if(F.indexOf("=~")>=0){const B=F.split("=~");return r.create(B[0].trim(),this.h(B[1]))}if(F.indexOf(" not in ")>=0){const B=F.split(" not in ");return d.create(B[0].trim(),this.g(B[1]))}if(F.indexOf(" in ")>=0){const B=F.split(" in ");return h.create(B[0].trim(),this.g(B[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const B=F.split(">=");return p.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const B=F.split(">");return D.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const B=F.split("<=");return o.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const B=F.split("<");return i.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(F)?g.create(F.substr(1).trim()):I.create(F)}static g(F){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const B=/^'([^']*)'$/.exec(F);return B?B[1].trim():F}static h(F){if((0,A.isFalsyOrWhitespace)(F))return console.warn("missing regexp-value for =~-expression"),null;const B=F.indexOf("/"),N=F.lastIndexOf("/");if(B===N||B<0)return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null;const U=F.slice(B+1,N),$=F[N+1]==="i"?"i":"";try{return new RegExp(U,$)}catch(z){return console.warn(`bad regexp-value '${F}', parse error: ${z}`),null}}}e.ContextKeyExpr=S;function k(j,F){const B=j?j.substituteConstants():void 0,N=F?F.substituteConstants():void 0;return!B&&!N?!0:!B||!N?!1:B.equals(N)}e.expressionsAreEqualWithConstantSubstitution=k;function L(j,F){return j.cmp(F)}class T{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}T.INSTANCE=new T,e.ContextKeyFalseExpr=T;class v{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return T.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class I{static create(F,B=null){const N=R.get(F);return typeof N=="boolean"?N?v.INSTANCE:T.INSTANCE:new I(F,B)}constructor(F,B){this.key=F,this.c=B,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:f(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=R.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:T.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=I;class y{static create(F,B,N=null){if(typeof B=="boolean")return B?I.create(F,N):g.create(F,N);const U=R.get(F);return typeof U=="boolean"?B===(U?"true":"false")?v.INSTANCE:T.INSTANCE:new y(F,B,N)}constructor(F,B,N){this.c=F,this.d=B,this.f=N,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const B=F?"true":"false";return this.d===B?v.INSTANCE:T.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=y;class h{static create(F,B){return new h(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:E(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const B=F.getValue(this.f),N=F.getValue(this.d);return Array.isArray(B)?B.includes(N):typeof N=="string"&&typeof B=="object"&&B!==null?C.call(B,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=h;class d{static create(F,B){return new d(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=11,this.c=h.create(F,B)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class u{static create(F,B,N=null){if(typeof B=="boolean")return B?g.create(F,N):I.create(F,N);const U=R.get(F);return typeof U=="boolean"?B===(U?"true":"false")?T.INSTANCE:v.INSTANCE:new u(F,B,N)}constructor(F,B,N){this.c=F,this.d=B,this.f=N,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const B=F?"true":"false";return this.d===B?T.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class g{static create(F,B=null){const N=R.get(F);return typeof N=="boolean"?N?T.INSTANCE:v.INSTANCE:new g(F,B)}constructor(F,B){this.c=F,this.d=B,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:f(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=R.get(this.c);return typeof F=="boolean"?F?T.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function b(j,F){if(typeof j=="string"){const B=parseFloat(j);isNaN(B)||(j=B)}return typeof j=="string"||typeof j=="number"?F(j):T.INSTANCE}class D{static create(F,B,N=null){return b(B,U=>new D(F,U,N))}constructor(F,B,N){this.c=F,this.d=B,this.f=N,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=D;class p{static create(F,B,N=null){return b(B,U=>new p(F,U,N))}constructor(F,B,N){this.c=F,this.d=B,this.f=N,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class i{static create(F,B,N=null){return b(B,U=>new i(F,U,N))}constructor(F,B,N){this.c=F,this.d=B,this.f=N,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class o{static create(F,B,N=null){return b(B,U=>new o(F,U,N))}constructor(F,B,N){this.c=F,this.d=B,this.f=N,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class r{static create(F,B){return new r(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const B=this.f?this.f.source:"",N=F.f?F.f.source:"";return B<N?-1:B>N?1:0}equals(F){if(F.type===this.type){const B=this.f?this.f.source:"",N=F.f?F.f.source:"";return this.d===F.d&&B===N}return!1}substituteConstants(){return this}evaluate(F){const B=F.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=c.create(this)),this.c}}e.ContextKeyRegexExpr=r;class c{static create(F){return new c(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new c(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=c;function s(j){let F=null;for(let B=0,N=j.length;B<N;B++){const U=j[B].substituteConstants();if(j[B]!==U&&F===null){F=[];for(let $=0;$<B;$++)F[$]=j[$]}F!==null&&(F[B]=U)}return F===null?j:F}class m{static create(F,B,N){return m.d(F,B,N)}constructor(F,B){this.expr=F,this.c=B,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,N=this.expr.length;B<N;B++){const U=L(this.expr[B],F.expr[B]);if(U!==0)return U}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,N=this.expr.length;B<N;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=s(this.expr);return F===this.expr?this:m.create(F,this.c,!1)}evaluate(F){for(let B=0,N=this.expr.length;B<N;B++)if(!this.expr[B].evaluate(F))return!1;return!0}static d(F,B,N){const U=[];let $=!1;for(const z of F)if(!!z){if(z.type===1){$=!0;continue}if(z.type===0)return T.INSTANCE;if(z.type===6){U.push(...z.expr);continue}U.push(z)}if(U.length===0&&$)return v.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let z=1;z<U.length;z++)U[z-1].equals(U[z])&&(U.splice(z,1),z--);if(U.length===1)return U[0];for(;U.length>1;){const z=U[U.length-1];if(z.type!==9)break;U.pop();const ae=U.pop(),ee=U.length===0,q=n.create(z.expr.map(J=>m.create([J,ae],null,N)),null,ee);q&&(U.push(q),U.sort(L))}if(U.length===1)return U[0];if(N){for(let z=0;z<U.length;z++)for(let ae=z+1;ae<U.length;ae++)if(U[z].negate().equals(U[ae]))return T.INSTANCE;if(U.length===1)return U[0]}return new m(U,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const B of this.expr)F.push(...B.keys());return F}map(F){return new m(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.c){const F=[];for(const B of this.expr)F.push(B.negate());this.c=n.create(F,this,!0)}return this.c}}class n{static create(F,B,N){return n.d(F,B,N)}constructor(F,B){this.expr=F,this.c=B,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,N=this.expr.length;B<N;B++){const U=L(this.expr[B],F.expr[B]);if(U!==0)return U}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,N=this.expr.length;B<N;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=s(this.expr);return F===this.expr?this:n.create(F,this.c,!1)}evaluate(F){for(let B=0,N=this.expr.length;B<N;B++)if(this.expr[B].evaluate(F))return!0;return!1}static d(F,B,N){let U=[],$=!1;if(F){for(let z=0,ae=F.length;z<ae;z++){const ee=F[z];if(!!ee){if(ee.type===0){$=!0;continue}if(ee.type===1)return v.INSTANCE;if(ee.type===9){U=U.concat(ee.expr);continue}U.push(ee)}}if(U.length===0&&$)return T.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let z=1;z<U.length;z++)U[z-1].equals(U[z])&&(U.splice(z,1),z--);if(U.length===1)return U[0];if(N){for(let z=0;z<U.length;z++)for(let ae=z+1;ae<U.length;ae++)if(U[z].negate().equals(U[ae]))return v.INSTANCE;if(U.length===1)return U[0]}return new n(U,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const B of this.expr)F.push(...B.keys());return F}map(F){return new n(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.c){const F=[];for(const B of this.expr)F.push(B.negate());for(;F.length>1;){const B=F.shift(),N=F.shift(),U=[];for(const $ of V(B))for(const z of V(N))U.push(m.create([$,z],null,!1));F.unshift(n.create(U,null,!1))}this.c=n.create(F,this,!0)}return this.c}}class t extends I{static all(){return t.d.values()}constructor(F,B,N){super(F,null),this.f=B,typeof N=="object"?t.d.push({...N,key:F}):N!==!0&&t.d.push({key:F,description:N,type:B!=null?typeof B:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return y.create(this.key,F)}notEqualsTo(F){return u.create(this.key,F)}}t.d=[],e.RawContextKey=t,e.IContextKeyService=(0,l.createDecorator)("contextKeyService");function f(j,F){return j<F?-1:j>F?1:0}function E(j,F,B,N){return j<B?-1:j>B?1:F<N?-1:F>N?1:0}function w(j,F){if(j.type===0||F.type===1)return!0;if(j.type===9)return F.type===9?O(j.expr,F.expr):!1;if(F.type===9){for(const B of F.expr)if(w(j,B))return!0;return!1}if(j.type===6){if(F.type===6)return O(F.expr,j.expr);for(const B of j.expr)if(w(B,F))return!0;return!1}return j.equals(F)}e.implies=w;function O(j,F){let B=0,N=0;for(;B<j.length&&N<F.length;){const U=j[B].cmp(F[N]);if(U<0)return!1;U===0&&B++,N++}return B===j.length}function V(j){return j.type===9?j.expr:[j]}}),define(De[200],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(De[123],Ce([1,0,170,4]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function P(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function S(u,g,b){return P(g,b)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===b?!0:k(b).includes(u)}e.isTargetPlatformCompatible=S;function k(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function L(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=L;var T;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var I;(function(u){u.Install="install",u.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var y;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var h;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(g,b){super(g),this.code=b,this.name=b}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,a.localize)(1,null),original:"Preferences"}}),define(De[201],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(De[202],Ce([1,0,46,16,11,10,109,29,116,172,201]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=k.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends v{openTerminal(D,p){return this.spawnTerminal(a,D,S.getWindowsShell(),p)}spawnTerminal(D,p,i,o){const r=p.windowsExec||I.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=l.basename(r,".exe").toLowerCase();if(c==="cmder")return D.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),c==="wt"&&s.push("-d ."),new Promise((m,n)=>{const t=d(process),f=D.spawn(i,s,{cwd:o,env:t});f.on("error",n),f.on("exit",()=>m())})}runInTerminal(D,p,i,o,r){const c="windowsExec"in r&&r.windowsExec?r.windowsExec:I.getDefaultTerminalWindows();return new Promise((s,m)=>{const n=`"${p} - ${T}"`,t=`""${i.join('" "')}" & pause"`,f=Object.assign({},d(process),o);Object.keys(f).filter(j=>f[j]===null).forEach(j=>delete f[j]);const E={cwd:p,env:f,windowsVerbatimArguments:!0};let w,O;l.basename(c,".exe")==="wt"?(w=c,O=["-d",".",I.b,"/c",t]):(w=I.b,O=["/c","start",n,"/wait",c,"/c",t]),a.spawn(w,O,E).on("error",j=>{m(u(j))}),s(void 0)})}static getDefaultTerminalWindows(){if(!I.d){const D=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${D?"Sysnative":"System32"}\\cmd.exe`}return I.d}}I.b="cmd.exe",e.WindowsExternalTerminalService=I;class y extends v{openTerminal(D,p){return this.spawnTerminal(a,D,p)}runInTerminal(D,p,i,o,r){const c=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,m)=>{if(c===L.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const n=c===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",D||T,"-w",p];for(const O of i)f.push("-a"),f.push(O);if(o){const O=Object.assign({},d(process),o);for(const V in O){const j=O[V];j===null?(f.push("-u"),f.push(V)):(f.push("-e"),f.push(`${V}=${j}`))}}let E="";const w=a.spawn(y.b,f);w.on("error",O=>{m(u(O))}),w.stderr.on("data",O=>{E+=O.toString()}),w.on("exit",O=>{if(O===0)s(void 0);else if(E){const V=E.split(`
`,1);m(new Error(V[0]))}else m(new Error(k.localize(1,null,n,O)))})}else m(new Error(k.localize(2,null,c)))})}spawnTerminal(D,p,i){const o=p.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{const s=["-a",o];i&&s.push(i);const m=d(process),n=D.spawn("/usr/bin/open",s,{cwd:i,env:m});n.on("error",c),n.on("exit",()=>r())})}}y.b="/usr/bin/osascript",e.MacExternalTerminalService=y;class h extends v{openTerminal(D,p){return this.spawnTerminal(a,D,p)}runInTerminal(D,p,i,o,r){const c=r.linuxExec?Promise.resolve(r.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,m)=>{const n=[];c.then(t=>{t.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const f=`${g(i)}; echo; read -p "${h.b}" -n1;`;n.push(`''${f}''`);const E=Object.assign({},d(process),o);Object.keys(E).filter(j=>E[j]===null).forEach(j=>delete E[j]);const w={cwd:p,env:E};let O="";const V=a.spawn(t,n,w);V.on("error",j=>{m(u(j))}),V.stderr.on("data",j=>{O+=j.toString()}),V.on("exit",j=>{if(j===0)s(void 0);else if(O){const F=O.split(`
`,1);m(new Error(F[0]))}else m(new Error(k.localize(4,null,t,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!h.d)if(!R.isLinux)h.d=Promise.resolve("xterm");else{const D=await P.Promises.exists("/etc/debian_version");h.d=new Promise(p=>{D?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return h.d}spawnTerminal(D,p,i){const o=p.linuxExec?Promise.resolve(p.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{o.then(s=>{const m=d(process),n=D.spawn(s,[],{cwd:i,env:m});n.on("error",c),n.on("exit",()=>r())})})}}h.b=k.localize(3,null),e.LinuxExternalTerminalService=h;function d(b){const D={...b.env};return(0,C.sanitizeProcessEnvironment)(D),D}function u(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(k.localize(5,null,b.path)):b}function g(b){let D="";for(const p of b)p.indexOf(" ")>=0?D+='"'+p+'"':D+=p,D+=" ";return D}}),define(De[44],Ce([1,0,68,11,8,9,2,173,4,10,16]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function T(q){return q.create===!0}e.isFileOpenForWriteOptions=T;var v;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var I;(function(q){q[q.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var y;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=h;function d(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=d;function u(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=u;function g(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=b;function D(q){return h(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var p;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(J,ie){const ge=new i(J.toString(),ie);return c(ge,ie),ge}constructor(J,ie){super(J),this.code=ie}}e.FileSystemProviderError=i;function o(q,J){return i.create(q,J)}e.createFileSystemProviderError=o;function r(q){return q||o((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function c(q,J){return q.name=J?`${J} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=c;function s(q){if(!q)return p.Unknown;if(q instanceof i)return q.code;const J=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=s;function m(q){if(q instanceof O)return q.fileOperationResult;switch(s(q)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=m;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(J,ie,ge){this.resource=J,this.operation=ie,this.target=ge}isOperation(J){return this.operation===J}}e.FileOperationEvent=t;var f;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class E{constructor(J,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ge=new Map;for(const X of J){const Y=ge.get(X.type);switch(Y?Y.push([X.resource,X]):ge.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,Y]of ge)switch(X){case 1:this.a=a.TernarySearchTree.forUris(()=>ie),this.a.fill(Y);break;case 0:this.b=a.TernarySearchTree.forUris(()=>ie),this.b.fill(Y);break;case 2:this.c=a.TernarySearchTree.forUris(()=>ie),this.c.fill(Y);break}}contains(J,...ie){return this.d(J,{includeChildren:!1},...ie)}affects(J,...ie){return this.d(J,{includeChildren:!0},...ie)}d(J,ie,...ge){if(!J)return!1;const X=ge.length>0;return!!((!X||ge.includes(1))&&(this.a?.get(J)||ie.includeChildren&&this.a?.findSuperstr(J))||(!X||ge.includes(0))&&(this.b?.get(J)||ie.includeChildren&&this.b?.findSuperstr(J))||(!X||ge.includes(2))&&(this.c?.findSubstr(J)||ie.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=E;function w(q,J,ie){return!q||!J||q===J||J.length>q.length?!1:(J.charAt(J.length-1)!==A.sep&&(J+=A.sep),ie?(0,l.startsWithIgnoreCase)(q,J):q.indexOf(J)===0)}e.isParent=w;class O extends Error{constructor(J,ie,ge){super(J),this.fileOperationResult=ie,this.options=ge}}e.FileOperationError=O;class V extends O{constructor(J,ie,ge,X){super(J,ie,X),this.fileOperationResult=ie,this.size=ge}}e.TooLargeFileOperationError=V;class j extends O{constructor(J,ie,ge){super(J,2,ge),this.stat=ie}}e.NotModifiedSinceFileOperationError=j;var F;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=N;async function U(q,J){if(!J.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(ie=>{const ge=J.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===q.scheme&&X.added&&(ge.dispose(),ie())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<$.KB?(0,P.localize)(1,null,J.toFixed(0)):J<$.MB?(0,P.localize)(2,null,(J/$.KB).toFixed(2)):J<$.GB?(0,P.localize)(3,null,(J/$.MB).toFixed(2)):J<$.TB?(0,P.localize)(4,null,(J/$.GB).toFixed(2)):(0,P.localize)(5,null,(J/$.TB).toFixed(2))}}$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB,e.ByteSize=$;var z;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function ae(q){return{maxFileSize:q===0?300*$.MB:16*$.GB,maxHeapSize:q===0?700*$.MB:2*700*$.MB}}e.getPlatformFileLimits=ae;function ee(q){const J=typeof q=="string"||q?.scheme===L.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===L.Schemas.file?1024*$.MB:J?10*$.MB:k.isWeb?50*$.MB:1024*$.MB}e.getLargeFileConfirmationLimit=ee}),define(De[91],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...l){this.a=new Map;for(const[R,C]of l)this.set(R,C)}set(l,R){const C=this.a.get(l);return this.a.set(l,R),C}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=a}),define(De[203],Ce([1,0,19,12,6,122,199,4,91,66]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class T extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new S.ServiceCollection,u=!1,g,b=L){this.f=d,this.g=u,this.h=g,this.i=b,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=b?g?._globalGraph??new C.Graph(D=>D):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...u){const g=y.traceInvocation(this.i,d);let b=!1;try{return d({get:p=>{if(b)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(p,g);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...u)}finally{b=!0,g.stop()}}createInstance(d,...u){let g,b;return d instanceof R.SyncDescriptor?(g=y.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(u),g)):(g=y.traceCreation(this.i,d),b=this.j(d,u,g)),g.stop(),b}j(d,u=[],g){const b=P._util.getServiceDependencies(d).sort((i,o)=>i.index-o.index),D=[];for(const i of b){const o=this.m(i.id,g);o||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),D.push(o)}const p=b.length>0?b[0].index:u.length;if(u.length!==p){console.trace(`[createInstance] First service dependency of ${d.name} at position ${p+1} conflicts with ${u.length} static arguments`);const i=p-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,p)}return Reflect.construct(d,u.concat(D))}k(d,u){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,u);else if(this.h)this.h.k(d,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const u=this.f.get(d);return!u&&this.h?this.h.l(d):u}m(d,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const g=this.l(d);return g instanceof R.SyncDescriptor?this.q(d,g,u.branch(d,!0)):(u.branch(d,!1),g)}q(d,u,g){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,u,g)}finally{this.o.delete(d)}}r(d,u,g){const b=new C.Graph(i=>i.id.toString());let D=0;const p=[{id:d,desc:u,_trace:g}];for(;p.length;){const i=p.pop();if(b.lookupOrInsertNode(i),D++>1e3)throw new T(b);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof R.SyncDescriptor){const c={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};b.insertEdge(i,c),p.push(c)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new T(b);break}for(const{data:o}of i){if(this.l(o.id)instanceof R.SyncDescriptor){const c=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,c)}b.removeNode(o)}}return this.l(d)}s(d,u,g=[],b,D){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,u,g,b,D);if(this.h)return this.h.s(d,u,g,b,D);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(d,u,g=[],b,D){if(b){const p=new v(void 0,this.g,this,this.i);p.c=String(d);const i=new Map,o=new a.IdleValue(()=>{const r=p.j(u,g,D);for(const[c,s]of i){const m=r[c];if(typeof m=="function")for(const n of s)m.apply(r,n)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let n=i.get(c);return n||(n=new k.LinkedList,i.set(c,n)),(f,E,w)=>{const O=n.push([f,E,w]);return(0,l.toDisposable)(O)}}if(c in r)return r[c];const s=o.value;let m=s[c];return typeof m!="function"||(m=m.bind(s),r[c]=m),m},set(r,c,s){return o.value[c]=s,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,g,D)}u(d,u){if(u&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var I;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(I||(I={}));class y{static traceInvocation(d,u){return d?new y(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(d,u){return d?new y(1,u.name):y.c}constructor(d,u){this.type=d,this.name=u,this.g=Date.now(),this.h=[]}branch(d,u){const g=new y(3,d.toString());return this.h.push([d,u,g]),g}stop(){const d=Date.now()-this.g;y.f+=d;let u=!1;function g(D,p){const i=[],o=new Array(D+1).join("	");for(const[r,c,s]of p.h)if(c&&s){u=!0,i.push(`${o}CREATES -> ${r}`);const m=g(D+1,s);m&&i.push(m)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(d>2||u)&&y.all.add(b.join(`
`))}}y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0,e.Trace=y}),define(De[13],Ce([1,0,45,3,6,28,10,9,2,4]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function L(){return new Date().toISOString()}function T(n){return(0,P.isNumber)(n)}e.isLogLevel=T;var v;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function I(n,t,f){switch(t){case v.Trace:n.trace(f);break;case v.Debug:n.debug(f);break;case v.Info:n.info(f);break;case v.Warning:n.warn(f);break;case v.Error:n.error(f);break;case v.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=I;function y(n){let t="";for(let f=0;f<n.length;f++){let E=n[f];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}t+=(f>0?" ":"")+E}return t}e.format=y;class h extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==v.Off&&this.b<=t}}e.AbstractLogger=h;class d extends h{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...f){this.f(v.Trace)&&this.g(v.Trace,y([t,...f]))}debug(t,...f){this.f(v.Debug)&&this.g(v.Debug,y([t,...f]))}info(t,...f){this.f(v.Info)&&this.g(v.Info,y([t,...f]))}warn(t,...f){this.f(v.Warning)&&this.g(v.Warning,y([t,...f]))}error(t,...f){if(this.f(v.Error))if(t instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=t.stack,this.g(v.Error,y(E))}else this.g(v.Error,y([t,...f]))}flush(){}}e.AbstractMessageLogger=d;class u extends h{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!C.isWindows}trace(t,...f){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...f):console.log(`[main ${L()}]`,t,...f))}debug(t,...f){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...f):console.log(`[main ${L()}]`,t,...f))}info(t,...f){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...f):console.log(`[main ${L()}]`,t,...f))}warn(t,...f){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${L()}]\x1B[0m`,t,...f):console.warn(`[main ${L()}]`,t,...f))}error(t,...f){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${L()}]\x1B[0m`,t,...f):console.error(`[main ${L()}]`,t,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class g extends h{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...f){this.f(v.Trace)&&console.log("%cTRACE","color: #888",t,...f)}debug(t,...f){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...f)}info(t,...f){this.f(v.Info)&&console.log("%c INFO","color: #33f",t,...f)}warn(t,...f){this.f(v.Warning)&&console.log("%c WARN","color: #993",t,...f)}error(t,...f){this.f(v.Error)&&console.log("%c  ERR","color: #f33",t,...f)}dispose(){}flush(){}}e.ConsoleLogger=g;class b extends h{constructor(t,f=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(f)}trace(t,...f){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(t),...f])}debug(t,...f){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(t),...f])}info(t,...f){this.f(v.Info)&&this.g.log(v.Info,[this.h(t),...f])}warn(t,...f){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(t),...f])}error(t,...f){this.f(v.Error)&&this.g.log(v.Error,[this.h(t),...f])}h(t){return typeof t=="string"?t:(0,a.toErrorMessage)(t,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class D extends h{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const f of this.g)f.setLevel(t);super.setLevel(t)}trace(t,...f){for(const E of this.g)E.trace(t,...f)}debug(t,...f){for(const E of this.g)E.debug(t,...f)}info(t,...f){for(const E of this.g)E.info(t,...f)}warn(t,...f){for(const E of this.g)E.warn(t,...f)}error(t,...f){for(const E of this.g)E.error(t,...f)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogger=D;class p extends l.Disposable{constructor(t,f){if(super(),this.j=t,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,f)for(const E of f)this.c.set(E.resource,E)}getLogger(t){return this.b.get(t)}createLogger(t,f){let E=this.b.get(t);const w=f?.logLevel==="always"?v.Trace:f?.logLevel;return E||(E=this.k(t,w??this.getLogLevel(t)??this.j,f),this.b.set(t,E)),this.registerLogger({resource:t,id:f?.id??t.toString(),logLevel:w,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId}),E}setLogLevel(t,f){if(S.URI.isUri(t)){const E=t,w=f,O=this.c.get(E);O&&w!==O.logLevel&&(O.logLevel=w===this.j?void 0:w,this.b.get(E)?.setLevel(w),this.c.set(O.resource,O),this.g.fire([E,w]))}else{this.j=t;for(const[E,w]of this.b.entries())this.c.get(E)?.logLevel===void 0&&w.setLevel(this.j);this.g.fire(this.j)}}setVisibility(t,f){const E=this.c.get(t);E&&f!==!E.hidden&&(E.hidden=!f,this.c.set(E.resource,E),this.h.fire([t,f]))}getLogLevel(t){let f;return t&&(f=this.c.get(t)?.logLevel),f??this.j}registerLogger(t){const f=this.c.get(t.resource);f?f.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this.c.set(t.resource,t),this.f.fire({added:[t],removed:[]}))}deregisterLogger(t){const f=this.c.get(t);if(f){this.c.delete(t);const E=this.b.get(t);E&&(this.b.delete(t),E.dispose()),this.f.fire({added:[],removed:[f]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(t){return this.c.get(t)}dispose(){this.b.forEach(t=>t.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...f){}debug(t,...f){}info(t,...f){}warn(t,...f){}error(t,...f){}critical(t,...f){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;class r extends p{constructor(){super(v.Info)}k(t,f,E){return new i}}e.NullLoggerService=r;function c(n){if(n.verbose)return v.Trace;if(typeof n.logLevel=="string"){const t=m(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function s(n){switch(n){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=s;function m(n){switch(n){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=m}),define(De[204],Ce([1,0,6,13]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends a.Disposable{constructor(C,P=[]){super(),this.a=new A.MultiplexLogger([C,...P]),this.B(C.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.LogService=l}),define(De[205],Ce([1,0,44,13]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(l||(l={}));async function R(k,L,T,v,I){try{const y=await new Promise((d,u)=>{ne(["spdlog"],d,u)});y.setFlushOn(l.Trace);const h=await y.createAsyncRotatingLogger(k,L,T,v);return I?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(y){console.error(y)}return null}function C(k,L,T){switch(L){case A.LogLevel.Trace:k.trace(T);break;case A.LogLevel.Debug:k.debug(T);break;case A.LogLevel.Info:k.info(T);break;case A.LogLevel.Warning:k.warn(T);break;case A.LogLevel.Error:k.error(T);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function P(k,L){switch(L){case A.LogLevel.Trace:k.setLevel(l.Trace);break;case A.LogLevel.Debug:k.setLevel(l.Debug);break;case A.LogLevel.Info:k.setLevel(l.Info);break;case A.LogLevel.Warning:k.setLevel(l.Warning);break;case A.LogLevel.Error:k.setLevel(l.Error);break;case A.LogLevel.Off:k.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class S extends A.AbstractMessageLogger{constructor(L,T,v,I,y){super(),this.k=[],this.setLevel(y),this.l=this.n(L,T,v,I),this.B(this.onDidChangeLogLevel(h=>{this.m&&P(this.m,h)}))}async n(L,T,v,I){const y=v?6:1,h=30/y*a.ByteSize.MB,d=await R(L,T,h,y,I);if(d){this.m=d,P(this.m,this.getLevel());for(const{level:u,message:g}of this.k)C(this.m,u,g);this.k=[]}}g(L,T){this.m?C(this.m,L,T):this.getLevel()<=L&&this.k.push({level:L,message:T})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(De[124],Ce([1,0,37,174,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(y,h){return h-y}S.compare=k;const L=Object.create(null);L[S.Error]=(0,A.localize)(0,null),L[S.Warning]=(0,A.localize)(1,null),L[S.Info]=(0,A.localize)(2,null);function T(y){return L[y]||""}S.toString=T;function v(y){switch(y){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=v;function I(y){switch(y){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=I}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const k="";function L(v){return T(v,!0)}S.makeKey=L;function T(v,I){const y=[k];return v.source?y.push(v.source.replace("\xA6","\\\xA6")):y.push(k),v.code?typeof v.code=="string"?y.push(v.code.replace("\xA6","\\\xA6")):y.push(v.code.value.replace("\xA6","\\\xA6")):y.push(k),v.severity!==void 0&&v.severity!==null?y.push(C.toString(v.severity)):y.push(k),v.message&&I?y.push(v.message.replace("\xA6","\\\xA6")):y.push(k),v.startLineNumber!==void 0&&v.startLineNumber!==null?y.push(v.startLineNumber.toString()):y.push(k),v.startColumn!==void 0&&v.startColumn!==null?y.push(v.startColumn.toString()):y.push(k),v.endLineNumber!==void 0&&v.endLineNumber!==null?y.push(v.endLineNumber.toString()):y.push(k),v.endColumn!==void 0&&v.endColumn!==null?y.push(v.endColumn.toString()):y.push(k),y.push(k),y.join("\xA6")}S.makeKeyOptionalMessage=T})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(De[206],Ce([1,0,3,37,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,l.createDecorator)("notificationService");var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(De[125],Ce([1,0,8,2,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function R(k,L){return A.URI.isUri(k)?(0,a.equalsIgnoreCase)(k.scheme,L):(0,a.startsWithIgnoreCase)(k,L+":")}e.matchesScheme=R;function C(k,...L){return L.some(T=>R(k,T))}e.matchesSomeScheme=C;function P(k,L){return k.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=P;function S(k){let L;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return T&&(L={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},k=k.with({fragment:""})),{selection:L,uri:k}}e.extractSelection=S}),define(De[207],Ce([1,0,10,36]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const R=a.globals.vscode.context.configuration();if(R)l=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:R.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(De[208],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ne,e){return function(a,A){e(a,A,ne)}};define(De[126],Ce([1,0,19,21,6,4]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this.a}constructor(T){this.b=T}report(T){this.a=T,this.b(this.a)}}P.None=Object.freeze({report(){}}),e.Progress=P;let S=class extends l.Disposable{constructor(T,v){super(),this.a=new a.DeferredPromise,v.withProgress(T,I=>(this.b=I,this.c&&I.report(this.c),this.a.p)),this.B((0,l.toDisposable)(()=>this.a.complete()))}report(T){this.b?this.b.report(T):this.c=T}};S=xe([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends l.Disposable{constructor(T){super(),this.g=T,this.a=0,this.b=this.B(new l.DisposableStore)}start(T){this.stop();const v=++this.a,I=new A.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},T),this.b.add((0,l.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,l.toDisposable)(()=>I.cancel())),this.b.add((0,l.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:I.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(T){this.a===T&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(De[39],Ce([1,0,50,9]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(C,P){a.ok(A.isString(C)),a.ok(A.isObject(P)),a.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new l}),define(De[92],Ce([1,0,3,39]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[l(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;A.Registry.add(e.Extensions.JSONContribution,C)}),define(De[127],Ce([1,0,15,3,9,169,53,92,39]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=S.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.n(i,o,r),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.o(i,o),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.o(o,r),this.n(i,!1,r),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const r=[];for(const{overrides:c,source:s}of i)for(const m in c)if(o.add(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const n=this.a.get(m),t=n?.valuesSources??new Map;if(s)for(const O of Object.keys(c[m]))t.set(O,s);const f={...n?.value||{},...c[m]};this.a.set(m,{source:s,value:f,valuesSources:t});const E=(0,C.getLanguageTagSettingPlainKey)(m),w={type:"object",default:f,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:l.isString(s)?void 0:s,defaultValueSource:s};r.push(...h(m)),this.d[m]=w,this.b.properties[m]=w}else{this.a.set(m,{value:c[m],source:s});const n=this.d[m];n&&(this.w(m,n),this.r(m,n))}this.m(r)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:r,source:c}of i)for(const s in r){const m=this.a.get(s),n=l.isString(c)?c:c?.id,t=l.isString(m?.source)?m?.source:m?.source?.id;if(n===t)if(o.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const f=this.d[s];f&&(this.w(s,f),this.r(s,f))}}this.u()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,r){i.forEach(c=>{this.p(c,o,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(i,o){const r=c=>{if(c.properties)for(const s in c.properties){o.add(s);const m=this.d[s];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[s],this.s(s,c.properties[s])}c.allOf?.forEach(s=>r(s))};for(const c of i){r(c);const s=this.c.indexOf(c);s!==-1&&this.c.splice(s,1)}}p(i,o=!0,r,c,s=3,m){s=l.isUndefinedOrNull(i.scope)?s:i.scope;const n=i.properties;if(n)for(const f in n){const E=n[f];if(o&&b(f,E)){delete n[f];continue}if(E.source=r,E.defaultDefaultValue=n[f].default,this.w(f,E),e.OVERRIDE_PROPERTY_REGEX.test(f)?E.scope=void 0:(E.scope=l.isUndefinedOrNull(E.scope)?s:E.scope,E.restricted=l.isUndefinedOrNull(E.restricted)?!!c?.includes(f):E.restricted),n[f].hasOwnProperty("included")&&!n[f].included){this.f[f]=n[f],delete n[f];continue}else this.d[f]=n[f],n[f].policy?.name&&this.e.set(n[f].policy.name,f);!n[f].deprecationMessage&&n[f].markdownDeprecationMessage&&(n[f].deprecationMessage=n[f].markdownDeprecationMessage),m.add(f)}const t=i.allOf;if(t)for(const f of t)this.p(f,o,r,c,s,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=r=>{const c=r.properties;if(c)for(const m in c)this.r(m,c[m]);r.allOf?.forEach(o)};o(i)}r(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,r),e.allSettings.properties[o]=r,e.applicationSettings.properties[o]=r,e.machineSettings.properties[o]=r,e.machineOverridableSettings.properties[o]=r,e.windowSettings.properties[o]=r,e.resourceSettings.properties[o]=r}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,o){const r=this.a.get(i);let c=r?.value,s=r?.source;l.isUndefined(c)&&(c=o.defaultDefaultValue,s=void 0),l.isUndefined(c)&&(c=u(o.type)),o.default=c,o.defaultValueSource=s}}const I="\\[([^\\]]+)\\]",y=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let o=y.exec(p);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=y.exec(p)}}return(0,a.distinct)(i)}e.overrideIdentifiersFromKey=h;function d(p){return p.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function u(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new v;S.Registry.add(e.Extensions.Configuration,g);function b(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):g.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,p,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function D(){const p=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))p.push([o,i[o].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=D}),define(De[209],Ce([1,0,15,3,146,6,28,23,9,2,53,127,39]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function I(o){return Object.isFrozen(o)?o:P.deepFreeze(o)}class y{constructor(r={},c=[],s=[],m){this.b=r,this.c=c,this.d=s,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof y)return c;const s=new h("");return s.parseRaw(c),s.configurationModel});this.f=r.reduce((c,s)=>s===c?s:c.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const s=this.rawConfiguration.getValue(r),m=c?this.rawConfiguration.getOverrideValue(r,c):void 0,n=c?this.rawConfiguration.override(c).getValue(r):s;return{value:s,override:m,merged:n}}getOverrideValue(r,c){const s=this.i(c);return s?r?(0,L.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const s of this.overrides)s.identifiers.includes(r)&&c.push(...s.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return a.distinct(r)}override(r){let c=this.a.get(r);return c||(c=this.g(r),this.a.set(r,c)),c}merge(...r){const c=P.deepClone(this.contents),s=P.deepClone(this.overrides),m=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const t of r)if(n.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.h(c,t.contents);for(const f of t.overrides){const[E]=s.filter(w=>a.equals(w.identifiers,f.identifiers));E?(this.h(E.contents,f.contents),E.keys.push(...f.keys),E.keys=a.distinct(E.keys)):s.push(P.deepClone(f))}for(const f of t.keys)m.indexOf(f)===-1&&m.push(f)}return new y(c,m,s,n.every(t=>t instanceof y)?void 0:n)}g(r){const c=this.i(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const s={};for(const m of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let n=this.contents[m];const t=c[m];t&&(typeof n=="object"&&typeof t=="object"?(n=P.deepClone(n),this.h(n,t)):n=t),s[m]=n}return new y(s,this.keys,this.overrides)}h(r,c){for(const s of Object.keys(c)){if(s in r&&S.isObject(r[s])&&S.isObject(c[s])){this.h(r[s],c[s]);continue}r[s]=P.deepClone(c[s])}}i(r){let c=null,s=null;const m=n=>{n&&(s?this.h(s,n):s=P.deepClone(n))};for(const n of this.overrides)a.equals(n.identifiers,[r])?c=n.contents:n.identifiers.includes(r)&&m(n.contents);return m(c),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.j(r,c,!0)}setValue(r,c){this.j(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,L.removeFromValueTree)(this.contents,r),T.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>a.equals(s.identifiers,(0,T.overrideIdentifiersFromKey)(r))),1))}j(r,c,s){(0,L.addToValueTree)(this.contents,r,c,m=>console.error(m)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),T.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,T.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,L.toValuesTree)(this.contents[r],m=>console.error(m))})}}e.ConfigurationModel=y;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!S.isUndefinedOrNull(r)){const s=this.g(r);this.parseRaw(s,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:s,keys:m,overrides:n,restricted:t,hasExcludedProperties:f}=this.h(r,c);this.b=new y(s,m,n,f?[r]:void 0),this.c=t||[]}g(r){let c={},s=null,m=[];const n=[],t=[];function f(w){Array.isArray(m)?m.push(w):s!==null&&(m[s]=w)}const E={onObjectBegin:()=>{const w={};f(w),n.push(m),m=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{m=n.pop()},onArrayBegin:()=>{const w=[];f(w),n.push(m),m=w,s=null},onArrayEnd:()=>{m=n.pop()},onLiteralValue:f,onError:(w,O,V)=>{t.push({error:w,offset:O,length:V})}};if(r)try{l.visit(r,E),c=m[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return c}h(r,c){const s=v.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),m=this.i(r,s,!0,c);r=m.raw;const n=(0,L.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),t=Object.keys(r),f=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:n,keys:t,overrides:f,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(r,c,s,m){let n=!1;if(!m?.scopes&&!m?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:n};const t={},f=[];for(const E in r)if(T.OVERRIDE_PROPERTY_REGEX.test(E)&&s){const w=this.i(r[E],c,!1,m);t[E]=w.raw,n=n||w.hasExcludedProperties,f.push(...w.restricted)}else{const w=c[E],O=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&f.push(E),(O===void 0||m.scopes===void 0||m.scopes.includes(O))&&!(m.skipRestricted&&w?.restricted)?t[E]=r[E]:n=!0}return{raw:t,restricted:f,hasExcludedProperties:n}}j(r,c){const s=[];for(const m of Object.keys(r))if(T.OVERRIDE_PROPERTY_REGEX.test(m)){const n={};for(const t in r[m])n[t]=r[m][t];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(m),keys:Object.keys(n),contents:(0,L.toValuesTree)(n,c)})}return s}}e.ConfigurationModelParser=h;class d extends R.Disposable{constructor(r,c,s,m){super(),this.f=r,this.g=c,this.h=m,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,n=>n.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&s.isEqual(n.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class u{constructor(r,c,s,m,n,t,f,E,w,O,V,j,F){this.a=r,this.b=c,this.c=s,this.overrideIdentifiers=m,this.d=n,this.f=t,this.g=f,this.h=E,this.i=w,this.j=O,this.k=V,this.l=j,this.m=F}get value(){return I(this.c)}n(r,c,s){const m=r.inspect(c,s);return{get value(){return I(m.value)},get override(){return I(m.override)},get merged(){return I(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(r,c,s,m,n=new y,t=new y,f=new C.ResourceMap,E=new y,w=new C.ResourceMap){this.c=r,this.d=c,this.f=s,this.g=m,this.h=n,this.i=t,this.j=f,this.l=E,this.m=w,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(r,c,s){return this.q(r,c,s).getValue(r)}updateValue(r,c,s={}){let m;s.resource?(m=this.m.get(s.resource),m||(m=new y,this.m.set(s.resource,m))):m=this.l,c===void 0?m.removeValue(r):m.setValue(r,c),s.resource||(this.a=null)}inspect(r,c,s){const m=this.q(r,c,s),n=this.u(c.resource,s),t=c.resource?this.m.get(c.resource)||this.l:this.l,f=new Set;for(const E of m.overrides)for(const w of E.identifiers)m.getOverrideValue(r,w)!==void 0&&f.add(w);return new u(r,c,m.getValue(r),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,n||void 0,t)}keys(r){const c=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,c){this.j.set(r,c),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const s=[];if(!c){const{added:m,updated:n,removed:t}=p(this.c,r);c=[...m,...n,...t]}for(const m of c)for(const n of(0,T.overrideIdentifiersFromKey)(m)){const t=this.c.getKeysForOverrideIdentifier(n),f=r.getKeysForOverrideIdentifier(n),E=[...f.filter(w=>t.indexOf(w)===-1),...t.filter(w=>f.indexOf(w)===-1),...t.filter(w=>!P.equals(this.c.override(n).getValue(w),r.override(n).getValue(w)))];s.push([n,E])}return this.updateDefaultConfiguration(r),{keys:c,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:s,removed:m}=p(this.d,r),n=[...c,...s,...m];return n.length&&this.updatePolicyConfiguration(r),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:s,removed:m,overrides:n}=p(this.applicationConfiguration,r),t=[...c,...s,...m];return t.length&&this.updateApplicationConfiguration(r),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:s,removed:m,overrides:n}=p(this.localUserConfiguration,r),t=[...c,...s,...m];return t.length&&this.updateLocalUserConfiguration(r),{keys:t,overrides:n}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:s,removed:m,overrides:n}=p(this.remoteUserConfiguration,r),t=[...c,...s,...m];return t.length&&this.updateRemoteUserConfiguration(r),{keys:t,overrides:n}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:s,removed:m,overrides:n}=p(this.workspaceConfiguration,r),t=[...c,...s,...m];return t.length&&this.updateWorkspaceConfiguration(r),{keys:t,overrides:n}}compareAndUpdateFolderConfiguration(r,c){const s=this.p.get(r),{added:m,updated:n,removed:t,overrides:f}=p(s,c),E=[...m,...n,...t];return(E.length||!s)&&this.updateFolderConfiguration(r,c),{keys:E,overrides:f}}compareAndDeleteFolderConfiguration(r){const c=this.p.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:m,removed:n,overrides:t}=p(c,void 0);return{keys:[...s,...m,...n],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,c,s){let m=this.r(c,s);return c.overrideIdentifier&&(m=m.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(m=m.merge(this.d)),m}r({resource:r},c){let s=this.s();if(c&&r){const m=c.getFolder(r);m&&(s=this.t(m.uri)||s);const n=this.m.get(r);n&&(s=s.merge(n))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let c=this.b.get(r);if(!c){const s=this.s(),m=this.j.get(r);m?(c=s.merge(m),this.b.set(r,c)):c=s}return c}u(r,c){if(c&&r){const s=c.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,c)=>{const{contents:s,overrides:m,keys:n}=this.j.get(c);return r.push([c,{contents:s,overrides:m,keys:n}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.i.keys.forEach(c=>r.add(c)),this.j.forEach(c=>c.keys.forEach(s=>r.add(s))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}w(r){const c=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m))),[...c.values()]}static parse(r){const c=this.x(r.defaults),s=this.x(r.policy),m=this.x(r.application),n=this.x(r.user),t=this.x(r.workspace),f=r.folders.reduce((E,w)=>(E.set(k.URI.revive(w[0]),this.x(w[1])),E),new C.ResourceMap);return new g(c,s,m,n,new y,t,f,new y,new C.ResourceMap)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.Configuration=g;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,c=new Map;for(const m of o)m.keys.forEach(n=>r.add(n)),m.overrides.forEach(([n,t])=>{const f=(0,C.getOrSet)(c,n,new Set);t.forEach(E=>f.add(E))});const s=[];return c.forEach((m,n)=>s.push([n,[...m.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=b;class D{constructor(r,c,s,m){this.change=r,this.f=c,this.g=s,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const n of r.keys)this.affectedKeys.add(n);for(const[,n]of r.overrides)for(const t of n)this.affectedKeys.add(t);this.d=this.a;for(const n of this.affectedKeys)this.d+=n+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(r,c){const s=this.a+r,m=this.d.indexOf(s);if(m<0)return!1;const n=m+s.length;if(n>=this.d.length)return!1;const t=this.d.charCodeAt(n);if(t!==this.b&&t!==this.c)return!1;if(c){const f=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,E=this.g.getValue(r,c,this.h);return!P.equals(f,E)}return!0}}e.ConfigurationChangeEvent=D;function p(o,r){const{added:c,removed:s,updated:m}=i(r?.rawConfiguration,o?.rawConfiguration),n=[],t=o?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const E=f.filter(w=>!t.includes(w));for(const w of E)n.push([w,r.getKeysForOverrideIdentifier(w)])}if(o){const E=t.filter(w=>!f.includes(w));for(const w of E)n.push([w,o.getKeysForOverrideIdentifier(w)])}if(r&&o){for(const E of t)if(f.includes(E)){const w=i({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});n.push([E,[...w.added,...w.removed,...w.updated]])}}return{added:c,removed:s,updated:m,overrides:n}}function i(o,r){const c=o?r?o.keys.filter(n=>r.keys.indexOf(n)===-1):[...o.keys]:[],s=r?o?r.keys.filter(n=>o.keys.indexOf(n)===-1):[...r.keys]:[],m=[];if(o&&r){for(const n of r.keys)if(o.keys.indexOf(n)!==-1){const t=(0,L.getConfigurationValue)(r.contents,n),f=(0,L.getConfigurationValue)(o.contents,n);P.equals(t,f)||m.push(n)}}return{added:c,removed:s,updated:m}}}),define(De[128],Ce([1,0,12,4]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends a.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof R&&S._code===l.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof R&&S._code===l.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof R&&S._code===l.NoResolverFound}static isHandled(S){return S instanceof R&&S.isHandled}constructor(S,k=l.Unknown,L){super(S),this._message=S,this._code=k,this._detail=L,this.isHandled=k===l.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function C(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.getRemoteAuthorityPrefix=C}),define(De[72],Ce([1,0,16]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(k){return k.scheme===a.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=A;function l(k){if(!k)return;const L=k.indexOf("+");return L<0?k:k.substr(0,L)}e.getRemoteName=l;function R(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=R;function C(k){const{host:L,port:T}=S(k);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:T}}e.parseAuthorityWithPort=C;function P(k,L){let{host:T,port:v}=S(k);return typeof v>"u"&&(v=L),{host:T,port:v}}e.parseAuthorityWithOptionalPort=P;function S(k){const L=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const T=k.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const v=k.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:k,port:void 0}}}),define(De[26],Ce([1,0,8,4,72]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var P;(function(I){I.WIN32_X64="win32-x64",I.WIN32_IA32="win32-ia32",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,h){if(typeof y>"u"||y===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof y=="string"||typeof h=="string"){const d=typeof y=="string"?y:y.value,u=typeof h=="string"?h:h.value;return a.equalsIgnoreCase(d,u)}return y.c===h.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=S;function k(I){return L(I)}e.isApplicationScopedExtension=k;function L(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function T(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function v(I,y){if(y){const h=`onResolveRemoteAuthority:${(0,l.getRemoteName)(y)}`;return I.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[210],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((l,R)=>ne(["vsda"],l,R))}async createNewMessage(l){try{const R=await this.c(),C=new R.validator;if(C){const P=String(a.a++);return this.b.set(P,C),{id:P,data:C.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,R){if(!l.id)return!0;const C=this.b.get(l.id);if(!C)return!1;this.b.delete(l.id);try{return C.validate(R)==="ok"}catch{return!1}}async sign(l){try{const R=await this.c(),C=new R.signer;if(C)return C.sign(l)}catch{}return l}}a.a=1,e.SignService=a}),define(De[211],Ce([1,0,10,36,2,30]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(a.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function P(k,L,T,v,I,y,h,d,u,g){const b=Object.create(null);b["common.machineId"]=h,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=I,b.version=y,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,a.PlatformToString)(a.platform),b["common.nodePlatform"]=A.platform,b["common.nodeArch"]=v,b["common.product"]=g||"desktop",d&&(b["common.msftInternal"]=d);let D=0;const p=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),a.isLinuxSnap&&(b["common.snap"]="true");const i=C(T);i&&(b["common.platformDetail"]=i);try{const o=await k.readFile(l.URI.file(u));b["common.source"]=o.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=P;function S(k){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const T=L.toLowerCase();return k.some(v=>T===v)}e.verifyMicrosoftInternalDomain=S}),define(De[212],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[73],Ce([1,0,23,9,3,53,72,211,212]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(n){this.value=n}}e.TelemetryTrustedValue=k;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,t){return Promise.resolve(void 0)}publicLog2(n,t){return this.publicLog(n,t)}publicLogError(n,t){return Promise.resolve(void 0)}publicLogError2(n,t){return this.publicLogError(n,t)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class T{async publicLog(n,t,f){}async publicLogError(n,t,f){}}e.NullEndpointTelemetryService=T,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(m,n){return l.Event.debounce(n.onDidChangeConfiguration,(f,E)=>{const w=f?new Set([...f.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:w}},1e3,!0)(f=>{f.source!==7&&m.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(f.source),configurationKeys:D(f.affectedKeys)})})}e.configurationTelemetry=v;function I(m,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!m.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=I;function y(m,n){return!(n.isBuilt||n.disableTelemetry||m.enableTelemetry&&m.aiConfig?.ariaKey)}e.isLoggingOnly=y;function h(m){const n=m.getValue(S.TELEMETRY_SETTING_ID),t=m.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(m.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=h;function d(m){const n={},t={},f={};b(m,f);for(let E in f){E=E.length>150?E.substr(E.length-149):E;const w=f[E];typeof w=="number"?t[E]=w:typeof w=="boolean"?t[E]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${w.length}`),n[E]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(n[E]=w)}return{properties:n,measurements:t}}e.validateTelemetryData=d;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(m){if(!m)return"none";const n=(0,C.getRemoteName)(m);return u.has(n)?n:"other"}e.cleanRemoteAuthority=g;function b(m,n,t=0,f){if(!!m)for(const E of Object.getOwnPropertyNames(m)){const w=m[E],O=f?f+E:E;Array.isArray(w)?n[O]=(0,a.safeStringify)(w):w instanceof Date?n[O]=w.toISOString():(0,A.isObject)(w)?t<2?b(w,n,t+1,O+"."):n[O]=(0,a.safeStringify)(w):n[O]=w}}function D(m){if(!m)return[];const n=[];return p(n,"",m),n}function p(m,n,t){t&&typeof t=="object"&&!Array.isArray(t)?Object.keys(t).forEach(f=>p(m,n?`${n}.${f}`:f,t[f])):m.push(n)}function i(m,n){const t=m.msftInternalDomains||[],f=n.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(t)||f}e.isInternalTelemetry=i;function o(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=o;function r(m,n){if(!m||!m.includes("/")&&!m.includes("\\"))return m;let t=m;const f=[];for(const V of n)for(;;){const j=V.exec(m);if(!j)break;f.push([j.index,V.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let O=0;for(t="";;){const V=w.exec(m);if(!V)break;const j=f.some(([F,B])=>V.index<B&&F<w.lastIndex);!E.test(V[0])&&!j&&(t+=m.substring(O,V.index)+"<REDACTED: user-file-path>",O=w.lastIndex)}return O<m.length&&(t+=m.substr(O)),t}function c(m){if(!m)return m;const n=m.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of t)if(f.regex.test(n))return`<REDACTED: ${f.label}>`;return m}function s(m,n){return(0,a.cloneAndChange)(m,t=>{if(t instanceof k)return t.value;if(typeof t=="string"){let f=t.replaceAll("%20"," ");f=r(f,n);for(const E of n)f=f.replace(E,"");return f=c(f),f}})}e.cleanData=s}),define(De[213],Ce([1,0,8,123,26,10,2,12,36,73]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,a.compareIgnoreCase)(r.id,c.id)===0}e.areSameExtensions=L;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(c){const s=c.manifest?c.manifest.version:c.version,m=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new v(c.identifier,s,m)}static parse(c){const s=T.exec(c);return s&&s[1]&&s[2]?new v({id:s[1]},s[2],s[4]||void 0):null}constructor(c,s,m="undefined"){this.version=s,this.targetPlatform=m,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof v?L(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=v;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const c=I.exec(r);return c&&c[1]?[d(c[1]),c[2]]:[d(r),void 0]}e.getIdAndVersion=y;function h(r,c){return`${r}.${c}`}e.getExtensionId=h;function d(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function u(r,c){return d(h(r,c))}e.getGalleryExtensionId=u;function g(r,c){const s=[],m=n=>{for(const t of s)if(t.some(f=>L(c(f),c(n))))return t;return null};for(const n of r){const t=m(n);t?t.push(n):s.push([n])}return s}e.groupByExtension=g;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function D(r){return{id:new k.TelemetryTrustedValue(r.identifier.id),name:new k.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(r,c){const s=[],m=c.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const n=m.shift();if(n&&s.every(t=>!L(t.identifier,{id:n}))){const t=r.filter(f=>L(f.identifier,{id:n}));t.length===1&&(s.push(t[0]),m.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=p;async function i(r,c){if(!R.isLinux)return!1;let s;try{s=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){c.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(n))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,c){const s=await i(r,c),m=(0,A.getTargetPlatform)(s?"alpine":R.platform,S.arch);return c.debug("ComputeTargetPlatform:",m),m}e.computeTargetPlatform=o}),define(De[214],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=a;function A(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=A;function l(C){return Array.from(C.entries()).map(P=>[P[0],a(P[1].map)])}e.serializeEnvironmentVariableCollections=l;function R(C){return new Map(C.map(P=>[P[0],{map:A(P[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(De[215],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,R,C=5){const P=R(S=>{const k=typeof S=="string"?S:S.data;let L=this.a.get(l);if(L){L.data.push(k);return}const T=setTimeout(()=>this.flushBuffer(l),C);L={data:[k],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(l),P.dispose()}},this.a.set(l,L)});return P}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const R=this.a.get(l);R&&(this.a.delete(l),this.b(l,R.data.join("")))}}e.TerminalDataBufferer=a}),define(De[216],Ce([1,0,19,67,51,3,9,2,175,92,39]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var T;(function(D){function p(i,o){let r=i.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const c=y.getIcon(r.id);if(!c)return;r=c.defaults}return r}D.getDefinition=p})(T=e.IconContribution||(e.IconContribution={}));var v;(function(D){function p(o){return{weight:o.weight,style:o.style,src:o.src.map(r=>({format:r.format,location:r.location.toString()}))}}D.toJSONObject=p;function i(o){const r=c=>(0,C.isString)(c)?c:void 0;if(o&&Array.isArray(o.src)&&o.src.every(c=>(0,C.isString)(c.format)&&(0,C.isString)(c.location)))return{weight:r(o.weight),style:r(o.style),src:o.src.map(c=>({format:c.format,location:P.URI.parse(c.location)}))}}D.fromJSONObject=i})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class I{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,i,o,r){const c=this.b[p];if(c){if(o&&!c.description){c.description=o,this.d.properties[p].markdownDescription=`${o} $(${p})`;const n=this.e.enum.indexOf(p);n!==-1&&(this.e.enumDescriptions[n]=o),this.a.fire()}return c}const s={id:p,description:o,defaults:i,deprecationMessage:r};this.b[p]=s;const m={$ref:"#/definitions/icons"};return r&&(m.deprecationMessage=r),o&&(m.markdownDescription=`${o}: $(${p})`),this.d.properties[p]=m,this.e.enum.push(p),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,i){const o=this.f[p];return o||(this.f[p]=i,this.a.fire(),i)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,s)=>c.id.localeCompare(s.id),i=c=>{for(;l.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(c=>this.b[c]);for(const c of r.filter(s=>!!s.description).sort(p))o.push(`|<i class="${i(c)}"></i>|${c.id}|${l.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const c of r.filter(s=>!l.ThemeIcon.isThemeIcon(s.defaults)).sort(p))o.push(`|<i class="${i(c)}"></i>|${c.id}|`);return o.join(`
`)}}const y=new I;L.Registry.add(e.Extensions.IconContribution,y);function h(D,p,i,o){return y.registerIcon(D,p,i,o)}e.registerIcon=h;function d(){return y}e.getIconRegistry=d;function u(){const D=(0,A.getCodiconFontCharacters)();for(const p in D){const i="\\"+D[p].toString(16);y.registerIcon(p,{fontCharacter:i})}}u(),e.iconsSchemaId="vscode://schemas/icons";const g=L.Registry.as(k.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,y.getIconSchema());const b=new a.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);y.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=h("widget-close",A.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=h("goto-previous-location",A.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=h("goto-next-location",A.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=l.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(De[129],Ce([1,0,3,53,4,13]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var C;(function(h){h.Http="http",h.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=T;function v(h,d,u,g){if(u===1)return!1;if(u===2&&T(d)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(b?.length===4&&parseInt(b[1])>=18)return!1}return h<1024}e.isPortPrivileged=v;class I{constructor(d,u,g){this.remoteAddress=d,this.localAddress=u,this.b=g,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=I;let y=class{constructor(d,u){this.i=d,this.j=u,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],u=Array.from(this.d.values());for(const g of u){const b=Array.from(g.values());for(const D of b){const p=await D.value;p&&d.push(p)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:u}of d.values())await u.then(g=>g?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,u,g,b,D){this.o(d,u,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:u,localAddress:g,privacy:b,protocol:D,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,u){(T(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const g=this.q(d,u);if(g)return++g.refcount,g.value}openTunnel(d,u,g,b,D,p=!1,i,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${D}.`),!d)return;if(u||(u="localhost"),b||(b=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(d,u,g,b,D,p,i,o);return r?r.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(c);return(c.tunnelRemoteHost!==u||c.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const u=this.d.get(d.tunnelRemoteHost);if(u){const g=u.get(d.tunnelRemotePort);g&&(g.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async n(d,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${u}.`);const b=g.value.then(async D=>{D&&(await D.dispose(!0),this.b.fire({host:D.tunnelRemoteHost,port:D.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(u),b}}async closeTunnel(d,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${u} `);const g=this.d.get(d);if(g&&g.has(u)){const b=g.get(u);b.refcount=0,await this.n(d,u,b)}}o(d,u,g){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(u,{refcount:1,value:g})}async p(d,u){const g=this.d.get(d);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(d))}q(d,u){const g=[d];L(d)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):T(d)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const b=g.map(D=>this.d.get(D));for(const D of b){const p=D?.get(u);if(p)return p}}canTunnel(d){return!!k(d)}s(d,u,g,b,D,p,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${b}.`);const o=g;this.h.add(o);const r=b===void 0?g:b,c={elevationRequired:D?this.isPortPrivileged(r):!1},s={remoteAddress:{host:u,port:g},localAddressPort:b,privacy:p,public:p?p!==P.Private:void 0,protocol:i},m=d.forwardPort(s,c);return m?(this.o(u,g,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),m}};y=xe([We(0,R.ILogService),We(1,A.IConfigurationService)],y),e.AbstractTunnelService=y}),define(De[217],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var A;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[218],Ce([1,0,16]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(S){return S.scheme!==a.Schemas.file&&S.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=A;function l(S){if(S.folders.length)return S.folders.every(k=>A(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&A(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=l;function R(S){return l(S)?.scheme}e.getVirtualWorkspaceScheme=R;function C(S){return l(S)?.authority}e.getVirtualWorkspaceAuthority=C;function P(S){return l(S)!==void 0}e.isVirtualWorkspace=P}),define(De[47],Ce([1,0,176,11,68,24,2,4,16]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function k(r){const c=r;return typeof c?.id=="string"&&C.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=k;function L(r){return typeof r?.id=="string"&&!k(r)&&!v(r)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function T(r,c){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,A.basename)(r)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=r;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=T;function v(r){const c=r;return typeof c?.id=="string"&&C.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=v;function I(r){const c=r;if(c?.uri)return{id:c.id,uri:C.URI.revive(c.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:C.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=I;var y;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function h(r){const c=r;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=h;function d(r){const c=r;return!!(c&&typeof c=="object"&&C.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=d;class u{constructor(c,s,m,n,t){this.h=c,this.j=m,this.k=n,this.l=t,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(c,s){this.raw=s,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function b(r){return new g({uri:r,index:0,name:(0,R.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(r,c){return R.extUriBiasedIgnorePathCase.isEqualOrParent(r,c.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function p(r){let c;return C.URI.isUri(r)?c=r:c=r.configuration,c?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=p;function i(r,c){return!D(r,c)&&!p(r)}e.isSavedWorkspace=i;function o(r){return(typeof r=="string"?(0,A.extname)(r):(0,R.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(De[74],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const R=this.c++;return this.b.set(R,l),this.e(),R}get(l,R){return this.b.has(l)?this.b.get(l)[R]:void 0}delete(l){this.b.delete(l),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}a.a=!1,e.Cache=a}),define(De[48],Ce([1,0,16,24,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(P=>{const S=this.b.get(P.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(P,S){S===null?this.b.delete(P.scheme):this.b.set(P.scheme,S)}isFreeScheme(P){return!this.b.has(P)&&!this.a.has(P)}getCapabilities(P){return this.b.get(P)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(De[25],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(De[219],Ce([1,0,13,204,25]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends A.LogService{constructor(P,S){super(P.createLogger(S.logFile,{name:S.logName}))}};R=xe([We(0,a.ILoggerService),We(1,l.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(De[220],Ce([1,0,19]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(C,P,S){this.h=new Map,this.a=C,this.b=P,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new a.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of k.values())L.complete()}catch(L){for(const T of k.values())T.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,P){let S=this.f[C];return typeof S>"u"&&(S=P),S}update(C,P){this.f[C]=P;const S=this.h.get(C);if(S!==void 0)return S.p;const k=new a.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class l extends A{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,P){super(C.identifier.value,!0,P),this.j=C}}e.ExtensionGlobalMemento=l}),define(De[221],Ce([1,0,3,2]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(C){this.c=C,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,P,S,k){const T=this.c.getNotebookDocument(A.URI.revive(C)).acceptModelChanged(P.value,S,k);this.b.fire(T)}$acceptDirtyStateChanged(C,P){this.c.getNotebookDocument(A.URI.revive(C)).acceptDirty(P)}$acceptModelSaved(C){const P=this.c.getNotebookDocument(A.URI.revive(C));this.a.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(De[20],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[222],Ce([1,0,26,3]),function(ne,e,a,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(P,S){l.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(P.identifier),Ze(this,l,S,"f"),Be(this,l,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(P){return Be(this,l,"f").get(this.a,P)}store(P,S){return Be(this,l,"f").store(this.a,P,S)}delete(P){return Be(this,l,"f").delete(this.a,P)}}e.ExtensionSecrets=R,l=new WeakMap}),define(De[55],Ce([1,0,4,129,3,20]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function k(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:T.protocol}}S.fromApiTunnel=k;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==A.TunnelPrivacyId.ConstantPrivate&&T.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}S.fromServiceTunnel=L})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let P=class{constructor(k){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,L){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,L){return{dispose:()=>{}}}async $providePortAttributes(k,L,T,v,I){return[]}async $forwardPort(k,L){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=xe([We(0,R.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(De[56],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=A}),define(De[223],Ce([1,0,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function l(P,S){if(S.serializeBuffersForPostMessage){const k=new A,L=(I,y)=>{if(y instanceof ArrayBuffer){const h=k.add(y);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(y)){const h=R(y);if(h){const d=k.add(y.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:h,byteLength:y.byteLength,byteOffset:y.byteOffset}}}}return y},T=JSON.stringify(P,L),v=k.buffers.map(I=>{const y=new Uint8Array(I);return a.VSBuffer.wrap(y)});return{message:T,buffers:v}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=l;function R(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(P,S){const k=S.map(v=>{const I=new ArrayBuffer(v.byteLength);return new Uint8Array(I).set(v.buffer),I}),L=S.length?(v,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const y=I,{index:h}=y,d=k[h];if(y.view)switch(y.view.type){case 1:return new Int8Array(d,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return I}:void 0;return{message:JSON.parse(P,L),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(De[224],Ce([1,0,114]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:R,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function l(R){return new a.URITransformer(A(R))}e.createURITransformer=l}),define(De[130],Ce([1,0,187,9,2,6,4,39,44,16,45,161,37]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var y;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(y=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function h(X){const Y=X;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.isEditorPaneWithSelection=h;function d(X,Y,Z){for(const fe of Z.visibleEditorPanes)if(fe.group.id===Y&&X.matches(fe.input))return fe.getViewState()}e.findViewStateForEditor=d;function u(X){if(t(X))return!1;const Y=X;return l.URI.isUri(Y?.resource)}e.isResourceEditorInput=u;function g(X){if(t(X))return!1;const Y=X;return Y?.original!==void 0&&Y.modified!==void 0}e.isResourceDiffEditorInput=g;function b(X){if(t(X)||g(X))return!1;const Y=X;return Y?.primary!==void 0&&Y.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function D(X){if(t(X))return!1;const Y=X;return Y?Y.resource===void 0||Y.resource.scheme===k.Schemas.untitled||Y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;const p=/Untitled-\d+/;function i(X){return X.scheme===k.Schemas.untitled&&X.path.length>1&&!p.test(X.path)}e.isUntitledWithAssociatedResource=i;function o(X){if(t(X))return!1;const Y=X;return l.URI.isUri(Y?.base?.resource)&&l.URI.isUri(Y?.input1?.resource)&&l.URI.isUri(Y?.input2?.resource)&&l.URI.isUri(Y?.result?.resource)}e.isResourceMergeEditorInput=o;var r;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var c;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.a=new Map}registerSource(Y,Z){let fe=this.a.get(Y);return fe||(fe={source:Y,label:Z},this.a.set(Y,fe)),fe.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.SaveSourceRegistry=new s;var m;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends R.Disposable{}e.AbstractEditorInput=n;function t(X){return X instanceof n}e.isEditorInput=t;function f(X){const Y=X;return l.URI.isUri(Y?.preferredResource)}function E(X){const Y=X;return t(Y?.primary)&&t(Y?.secondary)}e.isSideBySideEditorInput=E;function w(X){const Y=X;return t(Y?.modified)&&t(Y?.original)}e.isDiffEditorInput=w;function O(X,Y,Z,fe,ve){return ge(fe,[(0,T.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const ke={...Z,limits:{size:Number.MAX_VALUE}};X.openEditor(Y,ke)}}),(0,T.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=O;function V(X){return t(X?.editor)}e.isEditorInputWithOptions=V;function j(X){const Y=X;return V(X)&&Y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=j;function F(X){const Y=X;return typeof Y?.groupId=="number"&&t(Y.editor)}e.isEditorIdentifier=F;var B;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var N;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(N=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(Y,Z){if(!Y)return;if(o(Y))return e.EditorResourceAccessor.getOriginalUri(Y.result,Z);if(Z?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(Y);if(ve&&ke){if(Z?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===U.ANY)return this.getOriginalUri(ve,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:Z.filterByScheme});Y=Z.supportSideBySide===U.PRIMARY?ve:ke}}if(g(Y)||b(Y)||o(Y))return;const fe=f(Y)?Y.preferredResource:Y.resource;return!fe||!Z||!Z.filterByScheme?fe:this.b(fe,Z.filterByScheme)}a(Y){return E(Y)||b(Y)?{primary:Y.primary,secondary:Y.secondary}:w(Y)||g(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,Z){if(!Y)return;if(o(Y))return e.EditorResourceAccessor.getCanonicalUri(Y.result,Z);if(Z?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(Y);if(ve&&ke){if(Z?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===U.ANY)return this.getCanonicalUri(ve,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:Z.filterByScheme});Y=Z.supportSideBySide===U.PRIMARY?ve:ke}}if(g(Y)||b(Y)||o(Y))return;const fe=Y.resource;return!fe||!Z||!Z.filterByScheme?fe:this.b(fe,Z.filterByScheme)}b(Y,Z){if(Array.isArray(Z)){if(Z.some(fe=>Y.scheme===fe))return Y}else if(Z===Y.scheme)return Y}}e.EditorResourceAccessor=new $;var z;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ae{constructor(){this.c=new Map,this.d=new Map}start(Y){const Z=this.a=Y.get(C.IInstantiationService);for(const[fe,ve]of this.c)this.e(fe,ve,Z);this.c.clear()}e(Y,Z,fe){const ve=fe.createInstance(Z);this.d.set(Y,ve)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(Y,Z){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,Z,this.a):this.c.set(Y,Z),(0,R.toDisposable)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new ae);async function ee(X,Y,Z){return!X||!X.length?[]:await Promise.all(X.map(async fe=>{const ve=l.URI.revive(fe.fileUri);if(!ve){Z.info("Cannot resolve the path because it is not valid.",fe);return}if(!await Y.canHandleResource(ve)){Z.info("Cannot resolve the path because it cannot be handled",fe);return}let Oe=fe.exists,oe=fe.type;if(typeof Oe!="boolean"||typeof oe!="number")try{oe=(await Y.stat(ve)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Oe=!0}catch(ue){Z.error(ue),Oe=!1}if(!Oe&&fe.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",fe);return}if(oe===S.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",fe);return}const le={...fe.options,pinned:!0};return Oe?{resource:ve,options:le}:{resource:ve,options:le,forceUntitled:!0}}))}e.pathsToEditors=ee;var q;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function J(X){const Y=X;if(!Y)return!1;const Z=Y;if(Z.modified)return J(Z.modified);const fe=Y;return!!(fe.contributionsState&&fe.viewState&&Array.isArray(fe.cursorState))}e.isTextEditorViewState=J;function ie(X){return(0,L.isErrorWithActions)(X)}e.isEditorOpenError=ie;function ge(X,Y,Z){const fe=(0,L.createErrorWithActions)(X,Y);return fe.forceMessage=Z?.forceMessage,fe.forceSeverity=Z?.forceSeverity,fe.allowDialog=Z?.allowDialog,fe}e.createEditorOpenError=ge}),define(De[225],Ce([1,0,3,188,4,6,28,39,15,61,23,67,216]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",T.Codicon.window,(0,A.localize)(0,null));var I;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(I=e.Extensions||(e.Extensions={}));var y;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(y=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function h(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=h;class d extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(c,s,m){const n=this.get(c.id);if(n)return n;const t=c;return t.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,C.getOrSet)(this.g,s,[]).push(t),m?.isDefault&&this.h.push(t),this.c.fire({viewContainer:t,viewContainerLocation:s}),t}deregisterViewContainer(c){for(const s of this.g.keys()){const m=this.g.get(s),n=m?.indexOf(c);if(n!==-1){m?.splice(n,1),m.length===0&&this.g.delete(s),this.f.fire({viewContainer:c,viewContainerLocation:s});return}}}get(c){return this.all.filter(s=>s.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(s=>this.getViewContainers(s).filter(m=>m?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(s=>this.getViewContainerLocation(s)===c)}}P.Registry.add(I.ViewContainersRegistry,new d);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function g(r,c){const s=r.group??u.More,m=c.group??u.More;return s!==m?s.localeCompare(m):(r.order??5)-(c.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(c,s){this.registerViews2([{views:c,viewContainer:s}])}registerViews2(c){c.forEach(({views:s,viewContainer:m})=>this.l(s,m)),this.c.fire(c)}deregisterViews(c,s){const m=this.m(c,s);m.length&&this.f.fire({views:m,viewContainer:s})}moveViews(c,s){for(const m of this.j.keys())if(m!==s){const n=this.m(c,m);n.length&&(this.l(n,s),this.g.fire({views:n,from:m,to:s}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const s of this.i){const m=(this.j.get(s)||[]).filter(n=>n.id===c)[0];if(m)return m}return null}getViewContainer(c){for(const s of this.i)if((this.j.get(s)||[]).filter(n=>n.id===c)[0])return s;return null}registerViewWelcomeContent(c,s){return this.k.add(c,s),this.h.fire(c),(0,R.toDisposable)(()=>{this.k.delete(c,s),this.h.fire(c)})}registerViewWelcomeContent2(c,s){const m=new Map;for(const[n,t]of s)this.k.add(c,t),m.set(n,(0,R.toDisposable)(()=>{this.k.delete(c,t),this.h.fire(c)}));return this.h.fire(c),m}getViewWelcomeContent(c){const s=[];return this.k.forEach(c,m=>s.push(m)),s.sort(g)}l(c,s){let m=this.j.get(s);m||(m=[],this.j.set(s,m),this.i.push(s));for(const n of c){if(this.getView(n.id)!==null)throw new Error((0,A.localize)(1,null,n.id));m.push(n)}}m(c,s){const m=this.j.get(s);if(!m)return[];const n=[],t=[];for(const f of m)c.includes(f)?n.push(f):t.push(f);return n.length&&(t.length?this.j.set(s,t):(this.j.delete(s),this.i.splice(this.i.indexOf(s),1))),n}}P.Registry.add(I.ViewsRegistry,new b),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var D;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(D=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,s){this.c=!1,this.d=!1,(0,L.mixin)(this,c),this.d=!!s,this.resolve=async m=>{if(s&&!this.c){const n=await s(m);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class o extends Error{constructor(c){super((0,A.localize)(2,null,c))}}e.NoTreeViewError=o}),define(De[131],Ce([1,0,3,19,189]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(P){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=P}onEvent(P){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=P}onRequest(P){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=P}sendResponse(P){P.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.s("response",P)}sendRequest(P,S,k,L){const T={command:P};if(S&&Object.keys(S).length>0&&(T.arguments=S),this.s("request",T),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const I=this.f.get(T.seq);if(I){this.f.delete(T.seq);const y={type:"response",seq:0,request_seq:T.seq,success:!1,command:P,message:(0,l.localize)(0,null,L,P)};I(y)}},L)}return k&&this.f.set(T.seq,k),T.seq}acceptMessage(P){this.j?this.j(P):(this.k.push(P),this.k.length===1&&this.q())}o(P,S){return P.type!=="event"||S.type!=="event"}async q(){let P;for(;this.k.length;){if((!P||this.o(this.k[0],P))&&await(0,A.timeout)(0),P=this.k.shift(),!P)return;switch(P.type){case"event":this.i?.(P);break;case"request":this.g?.(P);break;case"response":{const S=P,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(P,S){S.type=P,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const P=new Map;this.f.forEach((S,k)=>P.set(k,S)),await(0,A.timeout)(500),P.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(De[226],Ce([1,0,190,54,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const R=v=>a.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var C;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(C=e.State||(e.State={}));function P(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var S;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,l.createDecorator)("debugService");var T;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[227],Ce([1,0,8,2,11,23,16,32,21,15]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function T(n,t,f){return n.replace(L,function(E,w){return t&&w.length>0&&w[0]!=="_"?E:f&&f.hasOwnProperty(w)?f[w]:E})}e.formatPII=T;function v(n){const t={};for(const f of Object.keys(n))f.startsWith("!")||(t[f]=n[f]);return t}e.filterExceptionsFromTelemetry=v;function I(n){return n.configuration.request==="attach"&&!y(n)&&(!n.parentSession||I(n.parentSession))}e.isSessionAttach=I;function y(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(t,"extensionhost")||(0,a.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?y(n.parentSession):void 0}e.getExtensionHostDebugSession=y;function h(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=h;function d(n,t,f){let E,w=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=O.exec(n);){const j=V.index+1,F=j+V[0].length;if(j<=t&&F>=f){E=V[0],w=j;break}}if(E){const j=/\w+/g;let F=null;for(;(F=j.exec(E))&&!(F.index+1+w+F[0].length>=f););F&&(E=E.substring(0,j.lastIndex))}return E?{start:w,end:w+E.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;async function u(n,t,f,E){if(n.evaluatableExpressionProvider.has(t)){const w=n.evaluatableExpressionProvider.ordered(t),O=(0,k.coalesce)(await Promise.all(w.map(async V=>{try{return await V.provideEvaluatableExpression(t,f,E??S.CancellationToken.None)}catch{return}})));if(O.length>0){let V=O[0].expression;const j=O[0].range;return V||(V=t.getLineContent(f.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:V}}}else{const w=t.getLineContent(f.lineNumber),{start:O,end:V}=d(w,f.column,f.column),j=w.substring(O-1,V);return{matchingExpression:j,range:new P.Range(f.lineNumber,O,f.lineNumber,O+j.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(n){return!!(n&&n.match(g))}e.isUri=b;function D(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(b(n.path))return A.URI.parse(n.path);if((0,l.isAbsolute)(n.path))return A.URI.file(n.path)}return n.path}function p(n){if(typeof n.path=="object"){const t=A.URI.revive(n.path);if(t)return t.scheme===C.Schemas.file?t.fsPath:t.toString()}return n.path}function i(n,t){const f=t?D:p,E=(0,R.deepClone)(n);return r(E,(w,O)=>{w&&O&&(O.path=f(O))}),E}e.convertToDAPaths=i;function o(n,t){const f=t?D:p,E=(0,R.deepClone)(n);return r(E,(w,O)=>{!w&&O&&(O.path=f(O))}),E}e.convertToVSCPaths=o;function r(n,t){switch(n.type){case"event":{const f=n;switch(f.event){case"output":t(!1,f.body.source);break;case"loadedSource":t(!1,f.body.source);break;case"breakpoint":t(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=n;switch(f.command){case"setBreakpoints":t(!0,f.arguments.source);break;case"breakpointLocations":t(!0,f.arguments.source);break;case"source":t(!0,f.arguments.source);break;case"gotoTargets":t(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(E=>t(!1,E));break;default:break}break}case"response":{const f=n;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(E=>t(!1,E.source));break;case"loadedSources":f.body.sources.forEach(E=>t(!1,E));break;case"scopes":f.body.scopes.forEach(E=>t(!1,E.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(E=>t(!1,E.source));break;case"setBreakpoints":f.body.breakpoints.forEach(E=>t(!1,E.source));break;case"disassemble":f.body?.instructions.forEach(w=>t(!1,w.location));break;default:break}break}}}function c(n){return n.filter(t=>!t.presentation?.hidden).sort((t,f)=>t.presentation?f.presentation?t.presentation.group?f.presentation.group?t.presentation.group!==f.presentation.group?t.presentation.group.localeCompare(f.presentation.group):s(t.presentation.order,f.presentation.order):-1:f.presentation.group?1:s(t.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=c;function s(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function m(n,t){const f=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(f!=="none"&&(await t.saveAll(),f==="allEditorsInActiveGroup")){const E=t.activeEditorPane;E&&E.input.resource?.scheme===C.Schemas.untitled&&await t.save({editor:E.input,groupId:E.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=m}),define(De[228],Ce([1,0,46,229,23,11,10,8,29,191,131]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class T extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(u,g){this.p=g,this.r=Buffer.allocUnsafe(0),this.t=-1,u.on("data",b=>this.w(b))}sendMessage(u){if(this.p){const g=JSON.stringify(u);this.p.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${T.a}${g}`,"utf8")}}w(u){for(this.r=Buffer.concat([this.r,u]);;){if(this.t>=0){if(this.r.length>=this.t){const g=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(b){this.m.fire(new Error((b.message||b)+`
`+g))}continue}}else{const g=this.r.indexOf(T.a);if(g!==-1){const D=this.r.toString("utf8",0,g).split(T.b);for(const p of D){const i=p.split(T.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(g+T.a.length);continue}}break}}}T.a=`\r
\r
`,T.b=/\r?\n/,T.l=/: */,e.StreamDebugAdapter=T;class v extends T{startSession(){return new Promise((u,g)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),u(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",D=>{b?this.m.fire(D):g(D)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class I extends v{constructor(u){super(),this.z=u}y(u){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",u)}}e.SocketDebugAdapter=I;class y extends v{constructor(u){super(),this.z=u}y(u){return A.createConnection(this.z.path,u)}}e.NamedPipeDebugAdapter=y;class h extends T{constructor(u,g){super(),this.y=u,this.z=g}async startSession(){const u=this.y.command,g=this.y.args,b=this.y.options||{};try{if(u)if(R.isAbsolute(u)){if(!await S.Promises.exists(u))throw new Error(k.localize(0,null,u))}else u.indexOf("/")<0&&u.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let D=process.env;if(b.env&&Object.keys(b.env).length>0&&(D=l.mixin(l.deepClone(process.env),b.env)),u==="node")if(Array.isArray(g)&&g.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:D,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(i.cwd=b.cwd);const o=a.fork(g[0],g.slice(1),i);if(!o.pid)throw new Error(k.localize(2,null,g[0]));this.x=o}else throw new Error(k.localize(3,null));else{const p={env:D};b.cwd&&(p.cwd=b.cwd),this.x=a.spawn(u,g,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,i)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(D){this.m.fire(D)}}async stopSession(){return this.x?(await this.u(),C.isWindows?new Promise((u,g)=>{const b=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(D,p,i){if(D)return g(D)});b.on("exit",u),b.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(u,g){if(!u)return;const b=Object.create(null);u.runtime&&(u.runtime.indexOf("./")===0?b.runtime=R.join(g,u.runtime):b.runtime=u.runtime),u.runtimeArgs&&(b.runtimeArgs=u.runtimeArgs),u.program&&(R.isAbsolute(u.program)?b.program=u.program:b.program=R.join(g,u.program)),u.args&&(b.args=u.args);const D=u;return D.win&&(b.win=h.A(D.win,g)),D.winx86&&(b.winx86=h.A(D.winx86,g)),D.windows&&(b.windows=h.A(D.windows,g)),D.osx&&(b.osx=h.A(D.osx,g)),D.linux&&(b.linux=h.A(D.linux,g)),b}static platformAdapterExecutable(u,g){let b=Object.create(null);g=g.toLowerCase();for(const c of u)if(c.contributes){const s=c.contributes.debuggers;s&&s.length>0&&s.filter(m=>typeof m.type=="string"&&P.equalsIgnoreCase(m.type,g)).forEach(m=>{const n=h.A(m,c.extensionLocation.fsPath);b=l.mixin(b,n,c.isBuiltin)})}let D;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?D=b.winx86||b.win||b.windows:C.isWindows?D=b.win||b.windows:C.isMacintosh?D=b.osx:C.isLinux&&(D=b.linux),D=D||b;const p=D.program||b.program,i=D.args||b.args,o=D.runtime||b.runtime,r=D.runtimeArgs||b.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(i||[])};if(p)return{type:"executable",command:p,args:i||[]}}}e.ExecutableDebugAdapter=h}),define(De[230],Ce([1,0,46,33,10]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(k,L){return new Promise((T,v)=>{let I="";const y=a.spawn(k,L);y.pid&&y.stdout.on("data",h=>{I+=h.toString()}),y.on("error",h=>{v(h)}),y.on("close",h=>{T(I)})})}async function C(k){if(k)if(l.isWindows){const L=await new Promise((T,v)=>{ne(["windows-process-tree"],T,v)});return new Promise(T=>{L.getProcessTree(k,v=>{T(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(k)]).then(L=>{const T=L.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var P;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(P||(P={}));function S(k,L,T,v,I){k=k.trim().toLowerCase();let y;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?y=1:k.indexOf("cmd.exe")>=0?y=0:k.indexOf("bash")>=0?y=2:l.isWindows?y=0:y=2;let h,d=" ";switch(y){case 1:if(h=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),v){const u=(0,A.getDriveLetter)(v);u&&(d+=`${u}:; `),d+=`cd ${h(v)}; `}if(I)for(const u in I){const g=I[u];g===null?d+=`Remove-Item env:${u}; `:d+=`\${env:${u}}='${g}'; `}if(L.length>0){const u=L.shift(),g=T?u:h(u);d+=g[0]==="'"?`& ${g} `:`${g} `;for(const b of L)d+=b==="<"||b===">"||T?b:h(b),d+=" "}break;case 0:if(h=u=>(u=u.replace(/\"/g,'""'),u=u.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>u.includes(g))||u.length===0?`"${u}"`:u),v){const u=(0,A.getDriveLetter)(v);u&&(d+=`${u}: && `),d+=`cd ${h(v)} && `}if(I){d+='cmd /C "';for(const u in I){let g=I[u];g===null?d+=`set "${u}=" && `:(g=g.replace(/[&^|<>]/g,b=>`^${b}`),d+=`set "${u}=${g}" && `)}}for(const u of L)d+=u==="<"||u===">"||T?u:h(u),d+=" ";I&&(d+='"');break;case 2:{h=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const u=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(v&&(d+=`cd ${h(v)} ; `),I){d+="/usr/bin/env";for(const g in I){const b=I[g];b===null?d+=` -u ${u(g)}`:d+=` ${u(`${g}=${b}`)}`}d+=" "}for(const g of L)d+=g==="<"||g===">"||T?g:h(g),d+=" ";break}}return d}e.prepareCommand=S}),define(De[93],Ce([1,0,22,38,64,87,16,11,10,54]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var y;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(y=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var g;(function(U){U.scheme=C.Schemas.vscodeNotebookCell;const $=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${$.join("")}]+`),ae=7;function ee(Y,Z){const fe=Z.toString(ae),ke=`${fe.length<$.length?$[fe.length-1]:"z"}${fe}s${(0,a.encodeBase64)(a.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:U.scheme,fragment:ke})}U.generate=ee;function q(Y){if(Y.scheme!==U.scheme)return;const Z=Y.fragment.indexOf("s");if(Z<0)return;const fe=parseInt(Y.fragment.substring(0,Z).replace(z,""),ae),ve=(0,a.decodeBase64)(Y.fragment.substring(Z+1)).toString();if(!isNaN(fe))return{handle:fe,notebook:Y.with({scheme:ve,fragment:null})}}U.parse=q;function J(Y,Z){return Y.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${Y.scheme!==C.Schemas.file?Y.scheme:""}`})}U.generateCellOutputUri=J;function ie(Y){if(Y.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!Z)return;const fe=Z[1]&&Z[1]!==""?Z[1]:void 0,ve=Z[2];return{outputId:fe,notebook:Y.with({scheme:ve||C.Schemas.file,fragment:null})}}U.parseCellOutputUri=ie;function ge(Y,Z,fe){return U.generate(Y,Z).with({scheme:fe})}U.generateCellPropertyUri=ge;function X(Y,Z){if(Y.scheme===Z)return U.parse(Y.with({scheme:U.scheme}))}U.parseCellPropertyUri=X})(g=e.CellUri||(e.CellUri={}));const b=U=>S.isWindows?U.replace(/\//g,"\\"):U;class D{constructor($=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.e=z,this.d=[...new Set($)].map(ae=>({pattern:ae,matches:A.parse(b(ae))}))}sort($){const z=new Map(l.Iterable.map($,ee=>[ee,b(ee)]));let ae=[];for(const{matches:ee}of this.d)for(const[q,J]of z)if(ee(J)){ae.push(q),z.delete(q);break}return z.size&&(ae=ae.concat([...z.keys()].sort((ee,q)=>this.e.indexOf(ee)-this.e.indexOf(q)))),ae}prioritize($,z){const ae=this.f($);if(ae===-1){this.d.unshift({pattern:$,matches:A.parse(b($))});return}const ee=new Set(z.map(J=>this.f(J,ae)));ee.delete(-1);const q=Array.from(ee).sort();this.d.splice(ae+1,0,...q.map(J=>this.d[J]));for(let J=q.length-1;J>=0;J--)this.d.splice(q[J],1)}toArray(){return this.d.map($=>$.pattern)}f($,z=this.d.length){const ae=b($);for(let ee=0;ee<z;ee++)if(this.d[ee].matches(ae))return ee;return-1}}e.MimeTypeDisplayOrder=D;function p(U,$,z,ae=(ee,q)=>ee===q){const ee=[];function q(ge,X,Y){if(X===0&&Y.length===0)return;const Z=ee[ee.length-1];Z&&Z.start+Z.deleteCount===ge?(Z.deleteCount+=X,Z.toInsert.push(...Y)):ee.push({start:ge,deleteCount:X,toInsert:Y})}let J=0,ie=0;for(;;){if(J===U.length){q(J,0,$.slice(ie));break}if(ie===$.length){q(J,U.length-J,[]);break}const ge=U[J],X=$[ie];if(ae(ge,X)){J+=1,ie+=1;continue}z(X)?(q(J,1,[]),J+=1):(q(J,0,[X]),ie+=1)}return ee}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(U){const $=U;return!!((typeof $.include=="string"||A.isRelativePattern($.include))&&(typeof $.exclude=="string"||A.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=o;function r(U,$,z){if(Array.isArray(U.viewType)&&U.viewType.indexOf($)>=0||U.viewType===$)return!0;if(U.filenamePattern){const ae=o(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,ee=o(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(A.match(ae,(0,P.basename)(z.fsPath).toLowerCase()))return!(ee&&A.match(ee,(0,P.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var c;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create($){return`${s.d}${$}`}static parse($){if($.startsWith(s.d))return $.substring(s.d.length)}}s.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=s;function m(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=m;const n=new TextDecoder;function t(U){const $=[];let z=!1;for(const ae of U)($.length===0||z)&&($.push(ae),z=!0);return O($),N(a.VSBuffer.concat($.map(ae=>a.VSBuffer.wrap(ae))))}e.compressOutputItemStreams=t;const f=`${String.fromCharCode(27)}[A`,E=f.split("").map(U=>U.charCodeAt(0)),w=10;function O(U){U.forEach(($,z)=>{if(z===0||$.length<f.length)return;const ae=U[z-1],ee=$.subarray(0,f.length);if(ee[0]===E[0]&&ee[1]===E[1]&&ee[2]===E[2]){const q=ae.lastIndexOf(w);if(q===-1)return;U[z-1]=ae.subarray(0,q),U[z]=$.subarray(f.length)}})}function V(U){let $=U;do U=$,$=U.replace(/[^\n]\x08/gm,"");while($.length<U.length);return U}function j(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const $=U.match(/^(.*)\r+/m)[1];let z=U.match(/\r+(.*)$/m)[1];z=z+$.slice(z.length,$.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return U}const F="\b".charCodeAt(0),B="\r".charCodeAt(0);function N(U){return!U.buffer.includes(F)&&!U.buffer.includes(B)?U:a.VSBuffer.fromString(j(V(n.decode(U.buffer))))}}),define(De[231],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(De[57],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(R){R.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(C,P,S=C.parent){if(C._isRoot)return new l([P]);const k=[C.id];for(let L=S;L&&L.id!==P;L=L.parent)k.push(L.id);return k.push(P),new l(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const P=C.indexOf("\0");return P===-1?C:C.slice(0,P)}static fromString(C){return new l(C.split("\0"))}static join(C,P){return new l([...C.path,P])}static joinToString(C,P){return C.toString()+"\0"+P}static parentId(C){const P=C.lastIndexOf("\0");return P===-1?void 0:C.slice(0,P)}static localId(C){const P=C.lastIndexOf("\0");return P===-1?C:C.slice(P+1)}static compare(C,P){return C===P?0:P.startsWith(C+"\0")?2:C.startsWith(P+"\0")?3:1}constructor(C,P=C.length){if(this.path=C,this.d=P,C.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new l(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new l(this.path,C)}compare(C){if(typeof C=="string")return l.compare(this.toString(),C);for(let P=0;P<C.d&&P<this.d;P++)if(C.path[P]!==this.path[P])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=l}),define(De[75],Ce([1,0,2,32,57]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var C;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=n=>"runId"in n;e.isStartControllerTests=P;var S;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:A.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var k;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var L;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.deserialize(t.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const T=(n,t)=>`${t?"s":"e"}${n}`;e.getMarkId=T;var v;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.deserialize(t.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var I;(function(n){n.serialize=t=>t.type===0?L.serialize(t):v.serialize(t),n.deserialize=t=>t.type===0?L.deserialize(t):v.deserialize(t)})(I=e.ITestMessage||(e.ITestMessage={}));var y;(function(n){n.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(I.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(I.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const h="\0",d=(n,t)=>n+h+t;e.namespaceTestTag=d;const u=n=>{const t=n.indexOf(h);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=u;var g;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?A.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(g=e.ITestItem||(e.ITestItem={}));var b;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(n){n.serialize=t=>({expand:t.expand,item:g.serialize(t.item)}),n.deserialize=t=>({controllerId:l.TestId.root(t.item.extId),expand:t.expand,item:g.deserialize(t.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(n){n.serialize=t=>{let f;return t.item&&(f={},t.item.label!==void 0&&(f.label=t.item.label),t.item.tags!==void 0&&(f.tags=t.item.tags),t.item.busy!==void 0&&(f.busy=t.item.busy),t.item.uri!==void 0&&(f.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(f.range=t.item.range?.toJSON()),t.item.description!==void 0&&(f.description=t.item.description),t.item.error!==void 0&&(f.error=t.item.error),t.item.sortText!==void 0&&(f.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:f}},n.deserialize=t=>{let f;return t.item&&(f={},t.item.label!==void 0&&(f.label=t.item.label),t.item.tags!==void 0&&(f.tags=t.item.tags),t.item.busy!==void 0&&(f.busy=t.item.busy),t.item.range!==void 0&&(f.range=t.item.range?A.Range.lift(t.item.range):null),t.item.description!==void 0&&(f.description=t.item.description),t.item.error!==void 0&&(f.error=t.item.error),t.item.sortText!==void 0&&(f.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:f}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=i;var o;(function(n){n.serializeWithoutMessages=t=>({...D.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serializeWithoutMessages),retired:t.retired}),n.serialize=t=>({...D.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serialize),retired:t.retired}),n.deserialize=t=>({...D.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var r;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var c;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var s;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:D.deserialize(t.item)}:t.op===1?{op:t.op,item:p.deserialize(t.item)}:t.op===2?{op:t.op,uri:a.URI.revive(t.uri),docv:t.docv}:t,n.serialize=t=>t.op===0?{op:t.op,item:D.serialize(t.item)}:t.op===1?{op:t.op,item:p.serialize(t.item)}:t})(s=e.TestsDiffOp||(e.TestsDiffOp={}));class m{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const f=this.o();for(const E of t)switch(E.op){case 0:this.j(D.deserialize(E.item),f);break;case 1:this.k(p.deserialize(E.item),f);break;case 3:this.l(E.itemId,f);break;case 5:this.m(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this.c.set(E.tag.id,E.tag);break;case 7:this.c.delete(E.id);break}f.complete?.()}j(t,f){const E=l.TestId.parentId(t.item.extId)?.toString();let w;if(!E)w=this.p(t),this.f.add(w),this.d.set(t.item.extId,w);else if(this.d.has(E)){const O=this.d.get(E);O.children.add(t.item.extId),w=this.p(t,O),this.d.set(t.item.extId,w)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return f.add?.(w),t.expand===2&&this.g++,w}k(t,f){const E=this.d.get(t.extId);if(!!E)return t.expand!==void 0&&(E.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(E,t),f.update?.(E),E}l(t,f){const E=this.d.get(t);if(!E)return;const w=l.TestId.parentId(E.item.extId)?.toString();w?this.d.get(w).children.delete(E.item.extId):this.f.delete(E);const O=[[t]];for(;O.length;)for(const V of O.pop()){const j=this.d.get(V);j&&(O.push(j.children),this.d.delete(V),f.remove?.(j,j!==E),j.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=m}),define(De[94],Ce([1,0,19,3,6,50,75,57]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(g,b)=>g===b,T=Object.entries({range:(g,b)=>g===b?!0:!g||!b?!1:g.equalsRange(b),busy:k,label:k,description:k,error:k,sortText:k,tags:(g,b)=>!(g.length!==b.length||g.some(D=>!b.includes(D)))}),v=(g,b)=>{let D;for(const[p,i]of T)i(g[p],b[p])||(D?D[p]=b[p]:D={[p]:b[p]});return D};class I extends l.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const D of this.tree.values())this.G(D)}get resolveHandler(){return this.h}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===b.uri){D.docv=b.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(D.item,b.item);return}if(D.op===0&&D.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(D.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,D){const p=this.tree.get(b);if(!!p){if((p.expandLevels===void 0||D>p.expandLevels)&&(p.expandLevels=D),p.expand===1){const i=this.I(p);return i.isOpen()?this.H(p,D-1):i.wait().then(()=>this.H(p,D-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,D-1)):this.H(p,D-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,D){switch(D.op){case 3:this.L(P.TestId.joinToString(b.fullId,D.id));break;case 0:this.u(D.item,b);break;case 5:for(const p of D.ops)this.p(b,p);break;case 1:this.w(D.new,D.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:D.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(D)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,D){const p=P.TestId.fromExtHostTestItem(b,this.root.id,D?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==D?.actual&&this.m.getChildren(i.parent).delete(b.id);let o=this.tree.get(p.toString());if(!o){o={fullId:p,actual:b,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(b,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(b)}}),this.F(b,o,D);return}if(o.actual===b){this.D(b,o,D);return}if(o.actual.uri?.toString()!==b.uri?.toString())return this.L(p.toString()),this.u(b,D);const r=this.m.getChildren(o.actual),c=o.actual,s=v(this.m.toITestItem(c),this.m.toITestItem(b));this.m.getApiFor(c).listener=void 0,o.actual=b,o.expand=0,s&&(s.hasOwnProperty("tags")&&(this.w(b.tags,c.tags,p.toString()),delete s.tags),this.p(o,{op:4,update:s})),this.F(b,o,D);for(const[m,n]of r)this.m.getChildren(b).get(n.id)||this.L(P.TestId.joinToString(p,n.id));this.s(o.actual.uri)}w(b,D,p){const i=new Set(D.map(o=>o.id));for(const o of b)i.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:p,item:{tags:b.map(o=>(0,C.namespaceTestTag)(this.m.controllerId,o.id))}}}),i.forEach(this.z,this)}y(b){const D=this.j.get(b.id);D?D.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const D=this.j.get(b);D&&!--D.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,b)}))}C(b,D){this.m.getApiFor(b).parent=D&&D.actual!==this.root?D.actual:void 0}D(b,D,p){this.C(b,p);const i=this.m.getApiFor(b);i.parent=p?.actual,i.listener=o=>this.p(D,o),this.G(D)}F(b,D,p){this.D(b,D,p);for(const[i,o]of this.m.getChildren(b))this.u(o,D)}G(b){let D;this.h?b.resolveBarrier?D=b.resolveBarrier.isOpen()?3:2:D=b.actual.canResolveChildren?1:0:D=0,D!==b.expand&&(b.expand=D,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:D}}),D===1&&b.expandLevels!==void 0&&this.I(b))}H(b,D){if(D<0)return;const p=[];for(const[i,o]of this.m.getChildren(b.actual)){const r=this.expand(P.TestId.joinToString(b.fullId,o.id),D);(0,a.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const o=new a.Barrier;return o.open(),o}b.expand=2,this.J(b);const D=b.resolveBarrier=new a.Barrier,p=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(o){p(o)}return(0,a.isThenable)(i)?i.catch(p).then(()=>{D.open(),this.G(b)}):(D.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const D=this.tree.get(b);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const p=[D];for(;p.length;){const i=p.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const o of i.actual.tags)this.z(o.id);this.tree.delete(i.fullId.toString());for(const[o,r]of this.m.getChildren(i.actual))p.push(this.tree.get(P.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=I;class y extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=y;class h extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class d extends Error{constructor(b,D,p){super(`TestItem with ID "${b}" is from controller "${D}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=d;const u=(g,b,D)=>{let p=new Map;return{get size(){return p.size},forEach(i,o){for(const r of p.values())i.call(o,r,this)},[Symbol.iterator](){return p.entries()},replace(i){const o=new Map,r=new Set(p.keys()),c={op:5,ops:[]};for(const s of i){if(!(s instanceof D))throw new h(s.id);const m=b(s).controllerId;if(m!==g.controllerId)throw new d(s.id,m,g.controllerId);if(o.has(s.id))throw new y(s.id);o.set(s.id,s),r.delete(s.id),c.ops.push({op:0,item:s})}for(const s of r.keys())c.ops.push({op:3,id:s});g.listener?.(c),p=o},add(i){if(!(i instanceof D))throw new h(i.id);p.set(i.id,i),g.listener?.({op:0,item:i})},delete(i){p.delete(i)&&g.listener?.({op:3,id:i})},get(i){return p.get(i)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=u}),define(De[132],Ce([1,0,94]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,l=(C,P)=>{const S={controllerId:P};return A.set(C,S),S};e.createPrivateApiFor=l;const R=C=>{const P=A.get(C);if(!P)throw new a.InvalidTestItemError(C?.id||"<unknown>");return P};e.getPrivateApiFor=R}),define(De[95],Ce([1,0,16,2]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(P,S){return P.scheme===a.Schemas.http||P.scheme===a.Schemas.https?P:(S&&S.authority&&S.isRemote&&P.scheme===a.Schemas.file&&(P=A.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:P.path})),A.URI.from({scheme:a.Schemas.https,authority:`${P.scheme}+${R(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=l;function R(P){return P.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function C(P){return P.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(De[232],Ce([1,0,3,6,95]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(P,S,k){this.d=P,this.e=S,this.f=k,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const T of this.c.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this.c.forEach(P=>P.inset.dispose()),this.b.dispose()}createWebviewEditorInset(P,S,k,L,T){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===P){v=b;break}if(!v)throw new Error("not a visible editor");const I=this,y=this.a++,h=new a.Emitter,d=new a.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,l.asWebviewUri)(b,I.f)}get cspSource(){return l.webviewGenericCspSource}set options(b){this.b=b,I.d.$setOptions(y,b)}get options(){return this.b}set html(b){this.a=b,I.d.$setHtml(y,b)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(b){return I.d.$postMessage(y,b)}},g=new class{constructor(){this.editor=P,this.line=S,this.height=k,this.webview=u,this.onDidDispose=d.event}dispose(){I.c.has(y)&&(I.c.delete(y),I.d.$disposeEditorInset(y),d.fire(),d.dispose(),h.dispose())}};return this.d.$createEditorInset(y,v.id,v.value.document.uri,S+1,k,L||{},T.identifier,T.extensionLocation),this.c.set(y,{editor:P,inset:g,onDidReceiveMessage:h}),g}$onDidDispose(P){const S=this.c.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){this.c.get(P)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=R}),define(De[233],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(C,P){super(P),this.variable=C}}e.VariableError=l}),define(De[234],Ce([1,0,11,36,9,23,10,113,194,233,8]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(I,y,h,d){this.g=new Map,this.a=I,this.b=y,this.d=h,d&&(this.c=d.then(u=>this.h(u)))}h(I){if(C.isWindows){const y=Object.create(null);return Object.keys(I).forEach(h=>{y[h.toLowerCase()]=I[h]}),y}return I}resolveWithEnvironment(I,y,h){return this.j({env:this.h(I),userHome:void 0},y?y.uri:void 0,h)}async resolveAsync(I,y){const h={env:await this.c,userHome:await this.d};return this.j(h,I?I.uri:void 0,y)}async i(I,y,h,d){const u=R.deepClone(y);C.isWindows&&u.windows?Object.keys(u.windows).forEach(b=>u[b]=u.windows[b]):C.isMacintosh&&u.osx?Object.keys(u.osx).forEach(b=>u[b]=u.osx[b]):C.isLinux&&u.linux&&Object.keys(u.linux).forEach(b=>u[b]=u.linux[b]),delete u.windows,delete u.osx,delete u.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,I?I.uri:void 0,u,h,d)}async resolveAnyAsync(I,y,h){return this.i(I,y,h)}async resolveAnyMap(I,y,h){const d=new Map;return{newConfig:await this.i(I,y,h,d),resolvedVariables:d}}resolveWithInteractionReplace(I,y,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,y,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,y){if(this.g.has(I))throw new Error("Variable "+I+" is contributed twice.");this.g.set(I,y)}async j(I,y,h,d,u){if(l.isString(h))return this.l(I,y,h,d,u);if(Array.isArray(h))return Promise.all(h.map(g=>this.j(I,y,g,d,u)));if(l.isObject(h)){const g=Object.create(null),b=await Promise.all(Object.keys(h).map(async D=>[await this.l(I,y,D,d,u),await this.j(I,y,h[D],d,u)]));for(const[D,p]of b)g[D]=p;return g}return h}l(I,y,h,d,u){return(0,L.replaceAsync)(h,T.VARIABLE_REGEXP,async(g,b)=>{if(b.includes(T.VARIABLE_LHS))return g;let D=await this.n(I,g,b,y,d);return u?.set(b,D),D!==g&&l.isString(D)&&D.match(T.VARIABLE_REGEXP)&&(D=await this.l(I,y,D,d,u)),D})}m(I){return this.b?this.b.getUriLabel(I,{noPrefix:!0}):I.fsPath}async n(I,y,h,d,u){let g;const b=h.split(":");b.length>1&&(h=b[0],g=b[1]);const D=o=>{const r=this.a.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new k.VariableError(o,(0,S.localize)(0,null,y))},p=o=>{const r=D(o);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,P.normalizeDriveLetter)(c)}throw new k.VariableError(o,(0,S.localize)(1,null,y,a.basename(r)))},i=o=>{if(g){const r=this.a.getFolderUri(g);if(r)return r;throw new k.VariableError(o,(0,S.localize)(2,null,y,g))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(o,(0,S.localize)(3,null,y)):new k.VariableError(o,(0,S.localize)(4,null,y))};switch(h){case"env":if(g){if(I.env){const o=I.env[C.isWindows?g.toLowerCase():g];if(l.isString(o))return o}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,y));case"config":if(g){const o=this.a.getConfigurationValue(d,g);if(l.isUndefinedOrNull(o))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,y,g));if(l.isObject(o))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,y,g));return o}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,y));case"command":return this.o(k.VariableKind.Command,y,g,u,"command");case"input":return this.o(k.VariableKind.Input,y,g,u,"input");case"extensionInstallFolder":if(g){const o=await this.a.getExtension(g);if(!o)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,y,g));return this.m(o.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,y));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(i(k.VariableKind.WorkspaceFolder)));case"cwd":return d||g?(0,P.normalizeDriveLetter)(this.m(i(k.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(a.basename(this.m(i(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(I.userHome)return I.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,y))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,y))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,y))}case"file":return D(k.VariableKind.File);case"fileWorkspaceFolder":return p(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||g?a.relative(this.m(i(k.VariableKind.RelativeFile)),D(k.VariableKind.RelativeFile)):D(k.VariableKind.RelativeFile);case"relativeFileDirname":{const o=a.dirname(D(k.VariableKind.RelativeFileDirname));if(d||g){const r=a.relative(this.m(i(k.VariableKind.RelativeFileDirname)),o);return r.length===0?".":r}return o}case"fileDirname":return a.dirname(D(k.VariableKind.FileDirname));case"fileExtname":return a.extname(D(k.VariableKind.FileExtname));case"fileBasename":return a.basename(D(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=a.basename(D(k.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-a.extname(o).length)}case"fileDirnameBasename":return a.basename(a.dirname(D(k.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||y}case"execInstallFolder":{const o=this.a.getAppRoot();return o||y}case"pathSeparator":return a.sep;default:try{const o=g?`${h}:${g}`:h;return this.o(k.VariableKind.Unknown,y,o,u,void 0)}catch{return y}}}}o(I,y,h,d,u){if(h&&d){const g=u===void 0?d[h]:d[u+":"+h];if(typeof g=="string")return g;throw new k.VariableError(I,(0,S.localize)(14,null,y))}return y}}T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=T}),define(De[133],Ce([1,0,4,130]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var l;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var R;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var P;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EVEN=1]="EVEN",y[y.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(y){const h=y;return(0,A.isEditorInput)(h?.editor)&&(0,A.isEditorInput)(h?.replacement)}e.isEditorReplacement=k;var L;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function v(y){const h=y;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=v;function I(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(De[235],Ce([1,0,4,133]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(R){const C=R;return typeof R=="number"||(0,A.isEditorGroup)(C)}e.isPreferredGroup=l}),define(De[236],Ce([1,0,4,200]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(A.IEnvironmentService)}),define(De[134],Ce([1,0,26,3,11]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=R;class C{static isHostExtension(T,v,I){if(v.getExtensionDescription(T))return!1;const y=I.getExtensionDescription(T);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(T){this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=T,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const T of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(T.identifier),T),this.f.push(T),Array.isArray(T.activationEvents))for(let v of T.activationEvents)v==="onUri"&&(v=`onUri:${a.ExtensionIdentifier.toKey(T.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(T)}}set(T){this.d=T,this.h(),this.c.fire(void 0)}deltaExtensions(T,v){this.d=k(this.d,v),this.d=this.d.concat(T);const I=C.j(this.d);return this.d=k(this.d,I.map(y=>y.identifier)),this.h(),this.c.fire(void 0),new R(I)}static j(T){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,g){this.addNode(u),this.addNode(g),this.c.has(u)?this.c.get(u).push(g):this.c.set(u,[g])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,g){const b=v.getArcs(u);for(let D=0;D<b.length;D++)if(!g.has(b[D]))return!1;return!0}getNodes(){return this.e}},I=new Map;for(const u of T){const g=a.ExtensionIdentifier.toKey(u.identifier);if(I.set(g,u),u.extensionDependencies)for(const b of u.extensionDependencies){const D=a.ExtensionIdentifier.toKey(b);v.addArc(g,D)}}const y=new Set;v.getNodes().filter(u=>v.getArcs(u).length===0).forEach(u=>y.add(u));const h=v.getNodes().filter(u=>!y.has(u));let d;do{d=!1;for(let u=0;u<h.length;u++){const g=h[u];v.hasOnlyGoodArcs(g,y)&&(h.splice(u,1),u--,y.add(g),d=!0)}}while(d);return h.map(u=>I.get(u))}containsActivationEvent(T){return this.g.has(T)}containsExtension(T){return this.e.has(a.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const v=this.g.get(T);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(T){const v=this.e.get(a.ExtensionIdentifier.toKey(T));return v||void 0}getExtensionDescriptionByUUID(T){for(const v of this.f)if(v.uuid===T)return v}getExtensionDescriptionByIdOrUUID(T,v){return this.getExtensionDescription(T)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=C;var P;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(P||(P={}));function S(L,T){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,I=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(v!==I)return v-I;const y=l.posix.basename(L.extensionLocation.path),h=l.posix.basename(T.extensionLocation.path);return y<h?-1:y>h?1:0}function k(L,T){const v=new Set;return T.forEach(I=>v.add(a.ExtensionIdentifier.toKey(I))),L.filter(I=>!v.has(a.ExtensionIdentifier.toKey(I.identifier)))}}),define(De[237],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class l{constructor(){this.type=2}serialize(T){T[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class R{constructor(){this.type=3}serialize(T){T[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function C(L){delete L[A.ENV_KEY],delete L[l.ENV_KEY],delete L[R.ENV_KEY]}function P(L,T){C(T),L.serialize(T)}e.writeExtHostConnection=P;function S(L){if(L[A.ENV_KEY])return k(L,new A(L[A.ENV_KEY]));if(L[l.ENV_KEY])return k(L,new l);if(L[R.ENV_KEY])return k(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function k(L,T){return C(L),T}}),define(De[96],Ce([1,0,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var l;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function C(k){const L=a.VSBuffer.alloc(1);switch(k){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=C;function P(k,L){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=P;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[76],Ce([1,0,4,3,13,25,96,72,73,23,2,6,181]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class extends T.Disposable{constructor(u,g){super(),this.m=u,this.n=g,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(b=>{(0,l.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,g,b){const D=this.getTelemetryDetails(),p=new y(g,b,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled});return this.l.set(u.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(u,g,b){this.f=u,this.g=g,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(u){const g={};switch(g["common.extname"]=`${u.publisher}.${u.name}`,g["common.extversion"]=u.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=h(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case C.UIKind.Web:g["common.uikind"]="web";break;case C.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const g=this.getTelemetryDetails();this.l.forEach(b=>{b.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(u,g){const b=this.l.get(u.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(g),!0)}};I=xe([We(0,R.IExtHostInitDataService),We(1,l.ILoggerService)],I),e.ExtHostTelemetry=I;class y{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,g,b,D,p,i,o){this.g=b,this.h=D,this.i=p,this.j=i,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(u,g){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let g=u.properties??u;return g=(0,S.cleanData)(g,[]),this.c&&(g=(0,k.mixin)(g,this.c)),this.b||(g=(0,k.mixin)(g,this.j)),u.properties?u.properties=g:u=g,u}k(u,g){!this.f||(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(u,g),this.h.trace(u,g))}logUsage(u,g){!this.d.isUsageEnabled||this.k(u,g)}logError(u,g){!this.d.isErrorsEnabled||!this.f||(typeof u=="string"?this.k(u,g):this.f.sendErrorData(u,g))}get apiTelemetryLogger(){if(!this.e){const u=this,g={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(g)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=y;function h(d){const u=Date.now()-new Date(d).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=h,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(De[27],Ce([1,0,3,2,4,26,213]),function(ne,e,a,A,l,R,C){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class S{constructor(m){this.affinity=m,this.kind=1}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(m){this.affinity=m,this.kind=2}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class L{constructor(){this.kind=3,this.affinity=0}equals(m){return this.kind===m.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class T{constructor(m){this.dependency=m}}e.MissingExtensionDependency=T;var v;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class y{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(m,n){const t=[],f=[],E=[],w=[],O=u(this.c),V=u(m),j=(U,$)=>U.extensionLocation.toString()===$.extensionLocation.toString()||U.isBuiltin===$.isBuiltin||U.isUserBuiltin===$.isUserBuiltin||U.isUnderDevelopment===$.isUnderDevelopment;for(const U of this.c){const $=V.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){t.push(U.identifier),O.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!j(U,$)){t.push(U.identifier),O.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of m){const $=O.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){f.push(U);continue}if(!j($,U)){t.push($.identifier),O.delete(R.ExtensionIdentifier.toKey($.identifier));continue}}const F=d(this.d),B=d(n);for(const U of this.d)B.has(R.ExtensionIdentifier.toKey(U))||E.push(U);for(const U of n)F.has(R.ExtensionIdentifier.toKey(U))||w.push(U);const N={toRemove:t,toAdd:f,myToRemove:E,myToAdd:w};return this.delta(N),N}delta(m){const{toRemove:n,toAdd:t,myToRemove:f,myToAdd:E}=m,w=d(n),O=d(f);for(let V=0;V<this.c.length;V++)w.has(R.ExtensionIdentifier.toKey(this.c[V].identifier))&&(this.c.splice(V,1),V--);for(let V=0;V<this.d.length;V++)O.has(R.ExtensionIdentifier.toKey(this.d[V]))&&(this.d.splice(V,1),V--);for(const V of t)this.c.push(V);for(const V of E)this.d.push(V)}containsExtension(m){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,m))return!0;return!1}}e.ExtensionHostExtensions=y;class h{constructor(m){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,m)for(const n of m)this.add(n)}get size(){return this.c.size}add(m){return this.c.set(this.d(m),m),this}clear(){this.c.clear()}delete(m){return this.c.delete(this.d(m))}has(m){return this.c.has(this.d(m))}forEach(m,n){this.c.forEach(t=>m.call(n,t,t,this))}*entries(){for(const[m,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=h;function d(s){const m=new Set;for(const n of s)m.add(R.ExtensionIdentifier.toKey(n));return m}e.extensionIdentifiersArrayToSet=d;function u(s){const m=new Map;for(const n of s)m.set(R.ExtensionIdentifier.toKey(n.identifier),n);return m}function g(s,m){return s.enabledApiProposals?s.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=g;function b(s,m){if(!g(s,m))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=b;class D{constructor(m,n,t,f){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=t,this.activationReason=f}}e.ActivationTimes=D;class p{constructor(m,n){this.description=m,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var i;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function r(s,m){return{identifier:new R.ExtensionIdentifier((0,C.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!m,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=r;class c{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m,n){return Promise.resolve(0)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(De[238],Ce([1,0,12,134,26,27,13,19]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(u,g,b,D){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=D}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class k{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,g){return u===-1||g===-1?-1:g-u}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class L{constructor(u,g,b,D,p,i){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=b,this.module=D,this.exports=p,this.subscriptions=i}}e.ActivatedExtension=L;class T extends L{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class v extends L{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class I extends L{constructor(u){super(!0,u,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(u,g,b,D){this.g=D,this.a=u,this.b=g,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[u,g]of this.d)g.dispose()}isActivated(u){const g=this.d.get(l.ExtensionIdentifier.toKey(u));return Boolean(g&&g.value)}getActivatedExtension(u){const g=this.d.get(l.ExtensionIdentifier.toKey(u));if(!g||!g.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return g.value}async activateByEvent(u,g){if(this.f[u])return;const b=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(b.map(D=>({id:D.identifier,reason:{startup:g,extensionId:D.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,g){const b=this.a.getExtensionDescription(u);if(!b)throw new Error(`Extension '${u}' is not known`);return this.h([{id:b.identifier,reason:g}])}async h(u){const g=u.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(g.map(b=>b.wait()))}j(u){if(this.d.has(l.ExtensionIdentifier.toKey(u.id)))return this.d.get(l.ExtensionIdentifier.toKey(u.id));if(this.l(u.id))return this.k(u,null,[],null);const g=this.a.getExtensionDescription(u.id);if(!g){const p=new Error(`Cannot activate unknown extension '${u.id.value}'`),i=this.k(u,null,[],new I(p));return this.c.onExtensionActivationError(u.id,p,new R.MissingExtensionDependency(u.id.value)),i}const b=[],D=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const p of D){if(this.m(p))continue;const i=this.d.get(l.ExtensionIdentifier.toKey(p));if(i){b.push(i);continue}if(this.l(p)){b.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:u.reason}));continue}const o=this.a.getExtensionDescription(p);if(o){if(!o.main&&!o.browser)continue;b.push(this.j({id:o.identifier,reason:u.reason}));continue}const r=g.displayName||g.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),s=this.k(u,g.displayName,[],new I(c));return this.c.onExtensionActivationError(g.identifier,c,new R.MissingExtensionDependency(p)),s}return this.k(u,g.displayName,b,null)}k(u,g,b,D){const p=new h(u.id,g,u.reason,b,D,this.c,this.g);return this.d.set(l.ExtensionIdentifier.toKey(u.id),p),p}l(u){return A.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const g=this.b.getExtensionDescription(u);return g?!g.main&&!g.browser:!1}};y=xe([We(3,C.ILogService)],y),e.ExtensionsActivator=y;let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,g,b,D,p,i,o){this.c=u,this.d=g,this.f=b,this.g=D,this.h=p,this.j=i,this.k=o,this.a=new P.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const g=this.g[u];if(g.value&&!g.value.activationFailed){this.g.splice(u,1),u--;continue}if(g.value&&g.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);b.detail=g.value.activationFailedError,this.h=new I(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const g=new Error;if(u&&u.name&&(g.name=u.name),u&&u.message?g.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(g.stack=u.stack),this.h=new I(g),this.b&&a.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};h=xe([We(6,C.ILogService)],h)});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[7],Ce([1,0,15,12,112,28,87,8,9,2,30,44,128,93,27]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y){"use strict";var h,d,u,g,b,D,p,i,o,r,c,s,m,n,t,f,E,w,O,V,j,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function N(x){return Object.assign(x,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(x,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[he,...Pe]=arguments;return Reflect.construct(x,Pe,he.constructor)}}})}var U;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var $;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})($=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let z=D=class{static from(...H){let he=H;return new D(function(){if(he){for(const Pe of he)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();he=void 0}})}constructor(H){h.set(this,void 0),Ze(this,h,H,"f")}dispose(){typeof Be(this,h,"f")=="function"&&(Be(this,h,"f").call(this),Ze(this,h,void 0,"f"))}};h=new WeakMap,z=D=xe([N],z),e.Disposable=z;let ae=p=class{static Min(...H){if(H.length===0)throw new TypeError;let he=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ke=H[Pe];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...H){if(H.length===0)throw new TypeError;let he=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ke=H[Pe];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(H){if(!H)return!1;if(H instanceof p)return!0;const{line:he,character:Pe}=H;return typeof he=="number"&&typeof Pe=="number"}static of(H){if(H instanceof p)return H;if(this.isPosition(H))return new p(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,he){if(H<0)throw(0,A.illegalArgument)("line must be non-negative");if(he<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=H,this.e=he}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,he=0){if(H===null||he===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,he=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&he===0?this:new p(this.line+Pe,this.character+he)}with(H,he=this.character){if(H===null||he===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,he=typeof H.character=="number"?H.character:this.character),Pe===this.line&&he===this.character?this:new p(Pe,he)}toJSON(){return{line:this.line,character:this.character}}};ae=p=xe([N],ae),e.Position=ae;let ee=i=class{static isRange(H){return H instanceof i?!0:H?ae.isPosition(H.start)&&ae.isPosition(H.end):!1}static of(H){if(H instanceof i)return H;if(this.isRange(H))return new i(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,he,Pe,Ke){let _e,lt;if(typeof H=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ke=="number"?(_e=new ae(H,he),lt=new ae(Pe,Ke)):ae.isPosition(H)&&ae.isPosition(he)&&(_e=ae.of(H),lt=ae.of(he)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(H){return i.isRange(H)?this.contains(H.start)&&this.contains(H.end):ae.isPosition(H)?!(ae.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const he=ae.Max(H.start,this.c),Pe=ae.Min(H.end,this.e);if(!he.isAfter(Pe))return new i(he,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const he=ae.Min(H.start,this.c),Pe=ae.Max(H.end,this.end);return new i(he,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,he=this.end){if(H===null||he===null)throw(0,A.illegalArgument)();let Pe;return H?ae.isPosition(H)?Pe=H:(Pe=H.start||this.start,he=H.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&he.isEqual(this.end)?this:new i(Pe,he)}toJSON(){return[this.start,this.end]}};ee=i=xe([N],ee),e.Range=ee;let q=o=class extends ee{static isSelection(H){return H instanceof o?!0:H?ee.isRange(H)&&ae.isPosition(H.anchor)&&ae.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,he,Pe,Ke){let _e,lt;if(typeof H=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ke=="number"?(_e=new ae(H,he),lt=new ae(Pe,Ke)):ae.isPosition(H)&&ae.isPosition(he)&&(_e=ae.of(H),lt=ae.of(he)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=o=xe([N],q),e.Selection=q;class J{constructor(H,he,Pe){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,A.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z_\-]+$/.test(Pe)))throw(0,A.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(he),this.connectionToken=Pe}}e.ResolvedAuthority=J;class ie extends Error{static NotAvailable(H,he){return new ie(H,v.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(H){return new ie(H,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,he=v.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H),this._message=H,this._code=he,this._detail=Pe,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var ge;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var X;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=r=class{static isTextEdit(H){return H instanceof r?!0:H?ee.isRange(H)&&typeof H.newText=="string":!1}static replace(H,he){return new r(H,he)}static insert(H,he){return r.replace(new ee(H,H),he)}static delete(H){return r.replace(H,"")}static setEndOfLine(H){const he=new r(new ee(new ae(0,0),new ae(0,0)),"");return he.newEol=H,he}get range(){return this.c}set range(H){if(H&&!ee.isRange(H))throw(0,A.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,A.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,A.illegalArgument)("newEol");this.f=H}constructor(H,he){this.c=H,this.e=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Y=r=xe([N],Y),e.TextEdit=Y;let Z=c=class{static isNotebookCellEdit(H){return H instanceof c?!0:H?xt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,he){return new c(H,he)}static insertCells(H,he){return new c(new xt(H,H),he)}static deleteCells(H){return new c(H,[])}static updateCellMetadata(H,he){const Pe=new c(new xt(H,H),[]);return Pe.newCellMetadata=he,Pe}static updateNotebookMetadata(H){const he=new c(new xt(0,0),[]);return he.newNotebookMetadata=H,he}constructor(H,he){this.range=H,this.newCells=he}};Z=c=xe([N],Z),e.NotebookEdit=Z;class fe{static isSnippetTextEdit(H){return H instanceof fe?!0:H?ee.isRange(H.range)&&Oe.isSnippetString(H.snippet):!1}static replace(H,he){return new fe(H,he)}static insert(H,he){return fe.replace(new ee(H,H),he)}constructor(H,he){this.range=H,this.snippet=he}}e.SnippetTextEdit=fe;var ve;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let ke=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,he,Pe,Ke){this.c.push({_type:1,from:H,to:he,options:Pe,metadata:Ke})}createFile(H,he,Pe){this.c.push({_type:1,from:void 0,to:H,options:he,metadata:Pe})}deleteFile(H,he,Pe){this.c.push({_type:1,from:H,to:void 0,options:he,metadata:Pe})}e(H,he,Pe){this.c.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:he},notebookMetadata:he})}f(H,he,Pe,Ke){const _e=he.start,lt=he.end;(_e!==lt||Pe.length>0)&&this.c.push({_type:5,uri:H,index:_e,count:lt-_e,cells:Pe,metadata:Ke})}g(H,he,Pe,Ke){this.c.push({_type:3,metadata:Ke,uri:H,edit:{editType:8,index:he,metadata:Pe}})}replace(H,he,Pe,Ke){this.c.push({_type:2,uri:H,edit:new Y(he,Pe),metadata:Ke})}insert(H,he,Pe,Ke){this.replace(H,new ee(he,he),Pe,Ke)}delete(H,he,Pe){this.replace(H,he,"",Pe)}has(H){return this.c.some(he=>he._type===2&&he.uri.toString()===H.toString())}set(H,he){if(he)for(const Pe of he){if(!Pe)continue;let Ke,_e;Array.isArray(Pe)?(Ke=Pe[0],_e=Pe[1]):Ke=Pe,Z.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(H,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(H,Ke.newNotebookMetadata,_e):this.f(H,Ke.range,Ke.newCells,_e):fe.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:H,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:H,edit:Ke,metadata:_e})}else{for(let Pe=0;Pe<this.c.length;Pe++){const Ke=this.c[Pe];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===H.toString()&&(this.c[Pe]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(H){const he=[];for(const Pe of this.c)Pe._type===2&&Pe.uri.toString()===H.toString()&&he.push(Pe.edit);return he}entries(){const H=new R.ResourceMap;for(const he of this.c)if(he._type===2){let Pe=H.get(he.uri);Pe||(Pe=[he.uri,[]],H.set(he.uri,Pe)),Pe[1].push(he.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ke=xe([N],ke),e.WorkspaceEdit=ke;let Oe=s=class{static isSnippetString(H){return H instanceof s?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=s.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,he=this.e++){if(typeof H=="function"){const Pe=new s;Pe.e=this.e,H(Pe),this.e=Pe.e,H=Pe.value}else H=s.c(H);return this.value+="${",this.value+=he,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,he=this.e++){const Pe=H.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,he){if(typeof he=="function"){const Pe=new s;Pe.e=this.e,he(Pe),this.e=Pe.e,he=Pe.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,he&&(this.value+=":",this.value+=he),this.value+="}",this}};Oe=s=xe([N],Oe),e.SnippetString=Oe;var oe;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=m=class{static isLocation(H){return H instanceof m?!0:H?ee.isRange(H.range)&&k.URI.isUri(H.uri):!1}constructor(H,he){if(this.uri=H,he)if(ee.isRange(he))this.range=ee.of(he);else if(ae.isPosition(he))this.range=new ee(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ue=m=xe([N],ue),e.Location=ue;let te=class{static is(H){return H?typeof H.message=="string"&&H.location&&ee.isRange(H.location.range)&&k.URI.isUri(H.location.uri):!1}constructor(H,he){this.location=H,this.message=he}static isEqual(H,he){return H===he?!0:!H||!he?!1:H.message===he.message&&H.location.range.isEqual(he.location.range)&&H.location.uri.toString()===he.location.uri.toString()}};te=xe([N],te),e.DiagnosticRelatedInformation=te;let ce=class{constructor(H,he,Pe=le.Error){if(!ee.isRange(H))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=H,this.message=he,this.severity=Pe}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,he){return H===he?!0:!H||!he?!1:H.message===he.message&&H.severity===he.severity&&H.code===he.code&&H.severity===he.severity&&H.source===he.source&&H.range.isEqual(he.range)&&(0,a.equals)(H.tags,he.tags)&&(0,a.equals)(H.relatedInformation,he.relatedInformation,te.isEqual)}};ce=xe([N],ce),e.Diagnostic=ce;let se=class{constructor(H,he){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=he}};se=xe([N],se),e.Hover=se;var M;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(M=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let W=class{constructor(H,he=M.Text){this.range=H,this.kind=he}toJSON(){return{range:this.range,kind:M[this.kind]}}};W=xe([N],W),e.DocumentHighlight=W;var G;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(G=e.SymbolKind||(e.SymbolKind={}));var _;(function(x){x[x.Deprecated=1]="Deprecated"})(_=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,he,Pe,Ke,_e){this.name=H,this.kind=he,this.containerName=_e,typeof Pe=="string"&&(this.containerName=Pe),Ke instanceof ue?this.location=Ke:Pe instanceof ee&&(this.location=new ue(Ke,Pe)),n.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};de=n=xe([N],de),e.SymbolInformation=de;let we=t=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(t.validate)}constructor(H,he,Pe,Ke,_e){this.name=H,this.detail=he,this.kind=Pe,this.range=Ke,this.selectionRange=_e,this.children=[],t.validate(this)}};we=t=xe([N],we),e.DocumentSymbol=we;var Ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(H,he){this.title=H,this.kind=he}};be=xe([N],be),e.CodeAction=be;let Ie=f=class{constructor(H){this.value=H}append(H){return new f(this.value?this.value+f.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+f.c)}};Ie.c=".",Ie=f=xe([N],Ie),e.CodeActionKind=Ie,Ie.Empty=new Ie(""),Ie.QuickFix=Ie.Empty.append("quickfix"),Ie.Refactor=Ie.Empty.append("refactor"),Ie.RefactorExtract=Ie.Refactor.append("extract"),Ie.RefactorInline=Ie.Refactor.append("inline"),Ie.RefactorMove=Ie.Refactor.append("move"),Ie.RefactorRewrite=Ie.Refactor.append("rewrite"),Ie.Source=Ie.Empty.append("source"),Ie.SourceOrganizeImports=Ie.Source.append("organizeImports"),Ie.SourceFixAll=Ie.Source.append("fixAll");let Te=class{constructor(H,he){if(this.range=H,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Te=xe([N],Te),e.SelectionRange=Te;class Ve{constructor(H,he,Pe,Ke,_e,lt){this.kind=H,this.name=he,this.detail=Pe,this.uri=Ke,this.range=_e,this.selectionRange=lt}}e.CallHierarchyItem=Ve;class Ge{constructor(H,he){this.fromRanges=he,this.from=H}}e.CallHierarchyIncomingCall=Ge;class nt{constructor(H,he){this.fromRanges=he,this.to=H}}e.CallHierarchyOutgoingCall=nt;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(H,he){this.range=H,this.command=he}get isResolved(){return!!this.command}};it=xe([N],it),e.CodeLens=it;let rt=E=class{static isMarkdownString(H){return H instanceof E?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,he=!1){d.set(this,void 0),Ze(this,d,new l.MarkdownString(H,{supportThemeIcons:he}),"f")}get value(){return Be(this,d,"f").value}set value(H){Be(this,d,"f").value=H}get isTrusted(){return Be(this,d,"f").isTrusted}set isTrusted(H){Be(this,d,"f").isTrusted=H}get supportThemeIcons(){return Be(this,d,"f").supportThemeIcons}set supportThemeIcons(H){Be(this,d,"f").supportThemeIcons=H}get supportHtml(){return Be(this,d,"f").supportHtml}set supportHtml(H){Be(this,d,"f").supportHtml=H}get baseUri(){return Be(this,d,"f").baseUri}set baseUri(H){Be(this,d,"f").baseUri=H}appendText(H){return Be(this,d,"f").appendText(H),this}appendMarkdown(H){return Be(this,d,"f").appendMarkdown(H),this}appendCodeblock(H,he){return Be(this,d,"f").appendCodeblock(he??"",H),this}};d=new WeakMap,rt=E=xe([N],rt),e.MarkdownString=rt;let ct=class{constructor(H,he){this.label=H,this.documentation=he}};ct=xe([N],ct),e.ParameterInformation=ct;let Me=class{constructor(H,he){this.label=H,this.documentation=he,this.parameters=[]}};Me=xe([N],Me),e.SignatureInformation=Me;let Ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ee=xe([N],Ee),e.SignatureHelp=Ee;var K;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(K=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(H){this.value=H}};pe=xe([N],pe),e.InlayHintLabelPart=pe;let Le=class{constructor(H,he,Pe){this.position=H,this.label=he,this.kind=Pe}};Le=xe([N],Le),e.InlayHint=Le;var $e;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(x){x[x.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let et=class{constructor(H,he){this.label=H,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};et=xe([N],et),e.CompletionItem=et;let ot=class{constructor(H=[],he=!1){this.items=H,this.isIncomplete=he}};ot=xe([N],ot),e.CompletionList=ot;let ft=class{constructor(H,he,Pe){this.insertText=H,this.range=he,this.command=Pe}};ft=xe([N],ft),e.InlineSuggestion=ft;let bt=class{constructor(H){this.commands=void 0,this.items=H}};bt=xe([N],bt),e.InlineSuggestionList=bt;var Lt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Lt=e.ViewColumn||(e.ViewColumn={}));var st;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(st=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Kt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var mt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function H(he){switch(he){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=H}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(H,he){if(he&&!k.URI.isUri(he))throw(0,A.illegalArgument)("target");if(!ee.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.target=he}};$t=xe([N],$t),e.DocumentLink=$t;let Ot=class{constructor(H,he,Pe,Ke){this.red=H,this.green=he,this.blue=Pe,this.alpha=Ke}};Ot=xe([N],Ot),e.Color=Ot;let Xe=class{constructor(H,he){if(he&&!(he instanceof Ot))throw(0,A.illegalArgument)("color");if(!ee.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.color=he}};Xe=xe([N],Xe),e.ColorInformation=Xe;let Mt=class{constructor(H){if(!H||typeof H!="string")throw(0,A.illegalArgument)("label");this.label=H}};Mt=xe([N],Mt),e.ColorPresentation=Mt;var Ut;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var Wt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var gt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(gt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(H,he,Pe){if(this.startIndex=H,this.length=he,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,A.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,A.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Ne{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=Ne;class ye{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=ye;var re;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(H){if(this.options=H,typeof H!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Fe;var He;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(He=e.TaskRevealKind||(e.TaskRevealKind={}));var Je;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Je=e.TaskPanelKind||(e.TaskPanelKind={}));let qe=w=class{static from(H){switch(H){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(H,he){if(this.label=he,typeof H!="string"||typeof he!="string")throw(0,A.illegalArgument)("name");this.c=H}get id(){return this.c}};qe.Clean=new w("clean","Clean"),qe.Build=new w("build","Build"),qe.Rebuild=new w("rebuild","Rebuild"),qe.Test=new w("test","Test"),qe=w=xe([N],qe),e.TaskGroup=qe;function tt(x){let H="";for(let he=0;he<x.length;he++)H+=x[he].replace(/,/g,",,")+",";return H}let ut=class{constructor(H,he,Pe){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=H,he!==void 0&&(Array.isArray(he)?(this.e=he,this.f=Pe):this.f=he)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const he of this.e)H.push(he);return tt(H)}};ut=xe([N],ut),e.ProcessExecution=ut;let Tt=class{constructor(H,he,Pe){if(this.f=[],Array.isArray(he)){if(!H)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H,this.f=he,this.g=Pe}else{if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H,this.g=he}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const he of this.f)H.push(typeof he=="string"?he:he.value);return tt(H)}};Tt=xe([N],Tt),e.ShellExecution=Tt;var Et;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class It{constructor(H){this.c=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=It;let yt=O=class{constructor(H,he,Pe,Ke,_e,lt){this.j=!1,this.k=this.definition=H;let ht;typeof he=="string"?(this.m=this.name=he,this.t=this.source=Pe,this.execution=Ke,ht=_e,this.j=!0):he===St.Global||he===St.Workspace?(this.target=he,this.m=this.name=Pe,this.t=this.source=Ke,this.execution=_e,ht=lt):(this.target=he,this.m=this.name=Pe,this.t=this.source=Ke,this.execution=_e,ht=lt),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ut?this.k={type:O.e,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:O.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:O.c,id:this.n.computeId()}:this.k={type:O.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const he=this.k.type;(O.g===he||O.e===he||O.f===he||O.c===he)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};yt.c="customExecution",yt.e="process",yt.f="shell",yt.g="$empty",yt=O=xe([N],yt),e.Task=yt;var Dt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Dt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(x){function H(he){const Pe=he;return(0,S.isNumber)(Pe.value)?Pe.tooltip&&!(0,S.isString)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}x.isViewBadge=H})(qt=e.ViewBadge||(e.ViewBadge={}));let _t=V=class{static isTreeItem(H,he){const Pe=H;if(Pe.checkboxState!==void 0){(0,y.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(Pe.checkboxState)?Pe.checkboxState:(0,S.isObject)(Pe.checkboxState)&&(0,S.isNumber)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,_e=!(0,S.isNumber)(Pe.checkboxState)&&(0,S.isObject)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==si.Checked&&Ke!==si.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}if(H instanceof V)return!0;if(Pe.label!==void 0&&!(0,S.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,S.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,S.isString)(Pe.iconPath)&&!k.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,S.isString)(Pe.iconPath.id))){const Ke=Pe.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,S.isString)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!k.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,S.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof rt)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<wt.None&&Pe.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,S.isString)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):!0}constructor(H,he=wt.None){this.collapsibleState=he,k.URI.isUri(H)?this.resourceUri=H:this.label=H}};_t=V=xe([N],_t),e.TreeItem=_t;var wt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,he){this.value=H,this.id=he??(0,L.generateUuid)()}};oi=xe([N],oi),e.DataTransferItem=oi;let Zt=class{constructor(H){u.set(this,new Map);for(const[he,Pe]of H??[]){const Ke=Be(this,u,"f").get(he);Ke?Ke.push(Pe):Be(this,u,"f").set(he,[Pe])}}get(H){return Be(this,u,"f").get(H)?.[0]}set(H,he){Be(this,u,"f").set(H,[he])}forEach(H,he){for(const[Pe,Ke]of Be(this,u,"f"))for(const _e of Ke)H.call(he,_e,Pe,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[H,he]of Be(this,u,"f"))for(const Pe of he)yield[H,Pe]}};Zt=xe([N],Zt),e.DataTransfer=Zt;let bi=class{constructor(H){this.insertText=H}};bi=xe([N],bi),e.DocumentDropEdit=bi;let At=class{constructor(H){this.insertText=H}};At=xe([N],At),e.DocumentPasteEdit=At;let Ht=class{constructor(H,he){this.id=H,this.color=he}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};Ht=xe([N],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let vi=class{constructor(H){this.id=H}};vi=xe([N],vi),e.ThemeColor=vi;var ai;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(H){this.c=H,this.e=k.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,he){if(typeof H!="string"&&(!H||!k.URI.isUri(H)&&!k.URI.isUri(H.uri)))throw(0,A.illegalArgument)("base");if(typeof he!="string")throw(0,A.illegalArgument)("pattern");typeof H=="string"?this.baseUri=k.URI.file(H):k.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=xe([N],ei),e.RelativePattern=ei;const dt=new WeakMap;function Bi(x,H){dt.set(x,H)}e.setBreakpointId=Bi;let Bt=class{constructor(H,he,Pe,Ke){this.enabled=typeof H=="boolean"?H:!0,typeof he=="string"&&(this.condition=he),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=dt.get(this)??(0,L.generateUuid)()),this.c}};Bt=xe([N],Bt),e.Breakpoint=Bt;let Qt=class extends Bt{constructor(H,he,Pe,Ke,_e){if(super(he,Pe,Ke,_e),H===null)throw(0,A.illegalArgument)("location");this.location=H}};Qt=xe([N],Qt),e.SourceBreakpoint=Qt;let ci=class extends Bt{constructor(H,he,Pe,Ke,_e){super(he,Pe,Ke,_e),this.functionName=H}};ci=xe([N],ci),e.FunctionBreakpoint=ci;let wi=class extends Bt{constructor(H,he,Pe,Ke,_e,lt,ht){if(super(Ke,_e,lt,ht),!he)throw(0,A.illegalArgument)("dataId");this.label=H,this.dataId=he,this.canPersist=Pe}};wi=xe([N],wi),e.DataBreakpoint=wi;let Ei=class{constructor(H,he,Pe){this.command=H,this.args=he||[],this.options=Pe}};Ei=xe([N],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(H,he){this.port=H,this.host=he}};li=xe([N],li),e.DebugAdapterServer=li;let Si=class{constructor(H){this.path=H}};Si=xe([N],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(H){this.implementation=H}};ui=xe([N],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(H,he){this.range=H,this.expression=he}};ti=xe([N],ti),e.EvaluatableExpression=ti;var $i;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(H,he){this.range=H,this.text=he}};ii=xe([N],ii),e.InlineValueText=ii;let ni=class{constructor(H,he,Pe=!0){this.range=H,this.variableName=he,this.caseSensitiveLookup=Pe}};ni=xe([N],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(H,he){this.range=H,this.expression=he}};yi=xe([N],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(H,he){this.frameId=H,this.stoppedLocation=he}};Di=xe([N],Di),e.InlineValueContext=Di;var ri;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ci=j=class extends Error{static FileExists(H){return new j(H,T.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(H){return new j(H,T.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(H){return new j(H,T.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(H){return new j(H,T.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(H){return new j(H,T.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(H){return new j(H,T.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(H,he=T.FileSystemProviderErrorCode.Unknown,Pe){super(k.URI.isUri(H)?H.toString(!0):H),this.code=Pe?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,he),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};Ci=j=xe([N],Ci),e.FileSystemError=Ci;let Ii=class{constructor(H,he,Pe){this.start=H,this.end=he,this.kind=Pe}};Ii=xe([N],Ii),e.FoldingRange=Ii;var zi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(H,he=[]){this.tokenTypes=H,this.tokenModifiers=he}}e.SemanticTokensLegend=Ri;function Li(x){return typeof x>"u"||(0,S.isStringArray)(x)}class ze{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let he=0,Pe=H.tokenTypes.length;he<Pe;he++)this.j.set(H.tokenTypes[he],he);for(let he=0,Pe=H.tokenModifiers.length;he<Pe;he++)this.k.set(H.tokenModifiers[he],he)}}push(H,he,Pe,Ke,_e){if(typeof H=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(H,he,Pe,Ke,_e);if(ee.isRange(H)&&typeof he=="string"&&Li(Pe))return this.m(H,he,Pe);throw(0,A.illegalArgument)()}m(H,he,Pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=H.start.line,_e=H.start.character,lt=H.end.character-H.start.character,ht=this.j.get(he);let Nt=0;if(Pe)for(const Vt of Pe){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Nt|=1<<Gt>>>0}this.n(Ke,_e,lt,ht,Nt)}n(H,he,Pe,Ke,_e){if(this.f&&(H<this.c||H===this.c&&he<this.e)){this.f=!1;const Nt=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Nt;Xt++){let Yt=this.g[5*Xt],Pi=this.g[5*Xt+1];Yt===0?(Yt=Vt,Pi+=Gt):Yt+=Vt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pi,Vt=Yt,Gt=Pi}}let lt=H,ht=he;this.f&&this.h>0&&(lt-=this.c,lt===0&&(ht-=this.e)),this.g[this.h++]=lt,this.g[this.h++]=ht,this.g[this.h++]=Pe,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=H,this.e=he}static o(H){const he=[],Pe=H.length/5|0;for(let ht=0;ht<Pe;ht++)he[ht]=ht;he.sort((ht,Nt)=>{const Vt=H[5*ht],Gt=H[5*Nt];if(Vt===Gt){const Xt=H[5*ht+1],Yt=H[5*Nt+1];return Xt-Yt}return Vt-Gt});const Ke=new Uint32Array(H.length);let _e=0,lt=0;for(let ht=0;ht<Pe;ht++){const Nt=5*he[ht],Vt=H[Nt+0],Gt=H[Nt+1],Xt=H[Nt+2],Yt=H[Nt+3],Pi=H[Nt+4],sn=Vt-_e,Rn=sn===0?Gt-lt:Gt,Ai=5*ht;Ke[Ai+0]=sn,Ke[Ai+1]=Rn,Ke[Ai+2]=Xt,Ke[Ai+3]=Yt,Ke[Ai+4]=Pi,_e=Vt,lt=Gt}return Ke}build(H){return this.f?new jt(new Uint32Array(this.g),H):new jt(ze.o(this.g),H)}}e.SemanticTokensBuilder=ze;class jt{constructor(H,he){this.resultId=he,this.data=H}}e.SemanticTokens=jt;class Oi{constructor(H,he,Pe){this.start=H,this.deleteCount=he,this.data=Pe}}e.SemanticTokensEdit=Oi;class vt{constructor(H,he){this.resultId=he,this.edits=H}}e.SemanticTokensEdits=vt;var ji;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Ht("arrow-left")},di=xe([N],di),e.QuickInputButtons=di;var Ni;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(H){if(typeof H.badge=="string"){let he=(0,P.nextCharLength)(H.badge,0);if(he<H.badge.length&&(he+=(0,P.nextCharLength)(H.badge,he)),H.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Ht.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,he,Pe){this.badge=H,this.tooltip=he,this.color=Pe}}e.FileDecoration=qi;let Ti=class{constructor(H){this.kind=H}};Ti=xe([N],Ti),e.ColorTheme=Ti;var xi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(H){return H instanceof xt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,he){if(H<0)throw(0,A.illegalArgument)("start must be positive");if(he<0)throw(0,A.illegalArgument)("end must be positive");H<=he?(this.c=H,this.e=he):(this.c=he,this.e=H)}with(H){let he=this.c,Pe=this.e;return H.start!==void 0&&(he=H.start),H.end!==void 0&&(Pe=H.end),he===this.c&&Pe===this.e?this:new xt(he,Pe)}}e.NotebookRange=xt;class fi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(he=>fi.isNotebookCellData(he))}static isNotebookCellData(H){return!0}constructor(H,he,Pe,Ke,_e,lt,ht){this.kind=H,this.value=he,this.languageId=Pe,this.mime=Ke,this.outputs=_e??[],this.metadata=lt,this.executionSummary=ht,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(H){this.cells=H}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(H){return H instanceof zt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const he={name:H.name,message:H.message,stack:H.stack};return zt.json(he,"application/vnd.code.notebook.error")}static stdout(H){return zt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return zt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,he="application/octet-stream"){return new zt(H,he)}static text(H,he=C.Mimes.text){const Pe=Be(zt,g,"f",b).encode(String(H));return new zt(Pe,he)}static json(H,he="text/x-json"){const Pe=JSON.stringify(H,void 0,"	");return zt.text(Pe,he)}constructor(H,he){this.data=H,this.mime=he;const Pe=(0,C.normalizeMimeType)(he,!0);if(!Pe)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}g=zt,b={value:new TextEncoder},e.NotebookCellOutputItem=zt;class mi{static isNotebookCellOutput(H){return H instanceof mi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,he=!1){const Pe=new Set,Ke=new Set;for(let _e=0;_e<H.length;_e++){const lt=H[_e],ht=(0,C.normalizeMimeType)(lt.mime);if(!Pe.has(ht)||(0,I.isTextStreamMime)(ht)){Pe.add(ht);continue}Ke.add(_e),he&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?H:H.filter((_e,lt)=>!Ke.has(lt))}constructor(H,he,Pe){this.items=mi.ensureUniqueMimeTypes(H,!0),typeof he=="string"?(this.id=he,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=he??Pe)}}e.NotebookCellOutput=mi;var Ki;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var me;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Se;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Se=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ue{constructor(H,he){this.text=H,this.alignment=he}}e.NotebookCellStatusBarItem=Ue;var at;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(at=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Ct;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(Ct=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(H,he=[]){this.uri=H,this.provides=(0,a.asArray)(he)}}e.NotebookRendererScript=Rt;class ln{constructor(H){this.label=H}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(H,he){this.label=H,this.timestamp=he}};Qi=xe([N],Qi),e.TimelineItem=Qi;var un;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(H,he){this.ranges=H,this.wordPattern=he}}e.LinkedEditingRanges=fn;class mn{constructor(H,he){this.c=H,this.e=he}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(H=void 0,he=void 0,Pe=void 0){this.include=H,this.exclude=he,this.profile=Pe}};Fi=xe([N],Fi),e.TestRunRequest=Fi;let Yi=class extends Fi{constructor(H=void 0,he=void 0,Pe=void 0,Ke=!1){super(H,he,Pe),this.continuous=Ke}};Yi=xe([N],Yi),e.TestRunRequest2=Yi;let Ji=F=class{static diff(H,he,Pe){const Ke=new F(H);return Ke.expectedOutput=he,Ke.actualOutput=Pe,Ke}constructor(H){this.message=H}};Ji=F=xe([N],Ji),e.TestMessage=Ji;let _i=class{constructor(H){this.id=H}};_i=xe([N],_i),e.TestTag=_i;let gi=class{constructor(H,he){this.covered=H,this.total=he}};gi=xe([N],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(H,he){const Pe=new gi(0,0),Ke=new gi(0,0),_e=new gi(0,0);for(const ht of he)if("branches"in ht){Pe.total+=1,Pe.covered+=ht.executionCount>0?1:0;for(const Nt of ht.branches)Ke.total+=1,Ke.covered+=Nt.executionCount>0?1:0}else _e.total+=1,_e.covered+=ht.executionCount>0?1:0;const lt=new B(H,Pe,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=he,lt}constructor(H,he,Pe,Ke){this.uri=H,this.statementCoverage=he,this.branchCoverage=Pe,this.functionCoverage=Ke}};Zi=B=xe([N],Zi),e.FileCoverage=Zi;let en=class{constructor(H,he,Pe=[]){this.executionCount=H,this.location=he,this.branches=Pe}};en=xe([N],en),e.StatementCoverage=en;let tn=class{constructor(H,he){this.executionCount=H,this.location=he}};tn=xe([N],tn),e.BranchCoverage=tn;let nn=class{constructor(H,he){this.executionCount=H,this.location=he}};nn=xe([N],nn),e.FunctionCoverage=nn;var bn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(H,he,Pe,Ke,_e,lt){this.kind=H,this.name=he,this.detail=Pe,this.uri=Ke,this.range=_e,this.selectionRange=lt}}e.TypeHierarchyItem=En;class Sn{constructor(H){this.uri=H}}e.TextTabInput=Sn;class yn{constructor(H,he){this.original=H,this.modified=he}}e.TextDiffTabInput=yn;class Dn{constructor(H,he,Pe,Ke){this.base=H,this.input1=he,this.input2=Pe,this.result=Ke}}e.TextMergeTabInput=Dn;class Cn{constructor(H,he){this.uri=H,this.viewType=he}}e.CustomEditorTabInput=Cn;class In{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=In;class kn{constructor(H,he){this.uri=H,this.notebookType=he}}e.NotebookEditorTabInput=kn;class Tn{constructor(H,he,Pe){this.original=H,this.modified=he,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(H,he){this.uri=H,this.inputBoxUri=he}}e.InteractiveWindowInput=An}),define(De[135],Ce([1,0,50,16,8,165,106,7,15]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function L(y,h){h?k.set(y,h):k.delete(y)}e.setWordDefinitionFor=L;function T(y){return k.get(y)}class v extends R.MirrorTextModel{constructor(h,d,u,g,b,D,p,i){super(d,u,g,b),this.m=h,this.p=D,this.q=p,this.notebook=i,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,S.equals)(this.d,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.c},get fileName(){return h.c.fsPath},get isUntitled(){return h.c.scheme===A.Schemas.untitled},get languageId(){return h.p},get version(){return h.g},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(d){return d?h.s(d):h.getText()},get eol(){return h.f===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return h.d.length},lineAt(d){return h.t(d)},offsetAt(d){return h.u(d)},positionAt(d){return h.v(d)},validateRange(d){return h.w(d)},validatePosition(d){return h.x(d)},getWordRangeAtPosition(d,u){return h.y(d,u)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,a.ok)(!this.b),this.p=h}_acceptIsDirty(h){(0,a.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(h){const d=this.w(h);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const u=this.f,g=d.start.line,b=d.end.line,D=[];D.push(this.d[g].substring(d.start.character));for(let p=g+1;p<b;p++)D.push(this.d[p]);return D.push(this.d[b].substring(0,d.end.character)),D.join(u)}t(h){let d;if(h instanceof P.Position?d=h.line:typeof h=="number"&&(d=h),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new I(d,this.d[d],d===this.d.length-1)}u(h){return h=this.x(h),this.k(),this.h.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.k();const d=this.h.getIndexOf(h),u=this.d[d.index].length;return new P.Position(d.index,Math.min(d.remainder,u))}w(h){if(!(h instanceof P.Range))throw new Error("Invalid argument");const d=this.x(h.start),u=this.x(h.end);return d===h.start&&u===h.end?h:new P.Range(d.line,d.character,u.line,u.character)}x(h){if(!(h instanceof P.Position))throw new Error("Invalid argument");if(this.d.length===0)return h.with(0,0);let{line:d,character:u}=h,g=!1;if(d<0)d=0,u=0,g=!0;else if(d>=this.d.length)d=this.d.length-1,u=this.d[d].length,g=!0;else{const b=this.d[d].length;u<0?(u=0,g=!0):u>b&&(u=b,g=!0)}return g?new P.Position(d,u):h}y(h,d){const u=this.x(h);if(!d)d=T(this.p);else if((0,l.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const g=(0,C.getWordAtText)(u.character+1,(0,C.ensureValidWordDefinition)(d),this.d[u.line],0);if(g)return new P.Range(u.line,g.startColumn-1,u.line,g.endColumn-1)}}e.ExtHostDocumentData=v;class I{constructor(h,d,u){this.a=h,this.b=d,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new P.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new P.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=I}),define(De[239],Ce([1,0,7,20,3]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(P){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new l.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(P){let S;switch(P){case"light":S=a.ColorThemeKind.Light;break;case"hcDark":S=a.ColorThemeKind.HighContrast;break;case"hcLight":S=a.ColorThemeKind.HighContrastLight;break;default:S=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=xe([We(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(De[14],Ce([1,0,15,22,149,63,112,28,147,69,87,23,9,2,32,71,124,132,130,93,57,75,235,7]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Re){function Ne(re){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:Je,positionColumn:qe}=re,tt=new o.Position(Fe-1,He-1),ut=new o.Position(Je-1,qe-1);return new o.Selection(tt,ut)}Re.to=Ne;function ye(re){const{anchor:Fe,active:He}=re;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=ye})(r=e.Selection||(e.Selection={}));var c;(function(Re){function Ne(re){if(!re)return;const{start:Fe,end:He}=re;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Ne;function ye(re){if(!re)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:Je,endColumn:qe}=re;return new o.Range(Fe-1,He-1,Je-1,qe-1)}Re.to=ye})(c=e.Range||(e.Range={}));var s;(function(Re){function Ne(ye){switch(ye){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Ne})(s=e.TokenType||(e.TokenType={}));var m;(function(Re){function Ne(re){return new o.Position(re.lineNumber-1,re.column-1)}Re.to=Ne;function ye(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=ye})(m=e.Position||(e.Position={}));var n;(function(Re){function Ne(Fe,He){return(0,a.coalesce)((0,a.asArray)(Fe).map(Je=>ye(Je,He)))}Re.from=Ne;function ye(Fe,He){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:re(Fe.scheme,He),pattern:Q.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function re(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Re){function Ne(re){switch(re){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Ne;function ye(re){switch(re){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=ye})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Re){function Ne(re){let Fe;return re.code&&((0,v.isString)(re.code)||(0,v.isNumber)(re.code)?Fe=String(re.code):Fe={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Fe,severity:w.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,a.coalesce)(re.tags.map(t.from)):void 0}}Re.from=Ne;function ye(re){const Fe=new o.Diagnostic(c.to(re),re.message,w.to(re.severity));return Fe.source=re.source,Fe.code=(0,v.isString)(re.code)?re.code:re.code?.value,Fe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Fe.tags=re.tags&&(0,a.coalesce)(re.tags.map(t.to)),Fe}Re.to=ye})(f=e.Diagnostic||(e.Diagnostic={}));var E;(function(Re){function Ne(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Ne;function ye(re){return new o.DiagnosticRelatedInformation(new o.Location(re.resource,c.to(re)),re.message)}Re.to=ye})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(Re){function Ne(re){switch(re){case o.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Ne;function ye(re){switch(re){case d.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=ye})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Re){function Ne(re){return typeof re=="number"&&re>=o.ViewColumn.One?re-1:re===o.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Ne;function ye(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=ye})(O=e.ViewColumn||(e.ViewColumn={}));function V(Re){return typeof Re.range<"u"}function j(Re){return Re.length===0?!0:!!V(Re[0])}e.isDecorationOptionsArr=j;var F;(function(Re){function Ne(qe){return qe.map(Re.from)}Re.fromMany=Ne;function ye(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function re(qe){let tt;if(ye(qe)){const{language:St,value:It}=qe;tt={value:"```"+St+`
`+It+"\n```\n"}}else o.MarkdownString.isMarkdownString(qe)?tt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?tt={value:qe}:tt={value:""};const ut=Object.create(null);tt.uris=ut;const Tt=St=>{try{let It=I.URI.parse(St,!0);It=It.with({query:Fe(It.query,ut)}),ut[St]=It}catch{}return""},Et=new S.marked.Renderer;return Et.link=Tt,Et.image=St=>typeof St=="string"?Tt(C.parseHrefAndDimensions(St).href):"",(0,S.marked)(tt.value,{renderer:Et}),tt}Re.from=re;function Fe(qe,tt){if(!qe)return qe;let ut;try{ut=(0,k.parse)(qe)}catch{}if(!ut)return qe;let Tt=!1;return ut=(0,T.cloneAndChange)(ut,Et=>{if(I.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[St]=Et,Tt=!0,St}else return}),Tt?JSON.stringify(ut):qe}function He(qe){const tt=new o.MarkdownString(qe.value,qe.supportThemeIcons);return tt.isTrusted=qe.isTrusted,tt.supportHtml=qe.supportHtml,tt.baseUri=qe.baseUri?I.URI.from(qe.baseUri):void 0,tt}Re.to=He;function Je(qe){if(!!qe)return typeof qe=="string"?qe:Re.from(qe)}Re.fromStrict=Je})(F=e.MarkdownString||(e.MarkdownString={}));function B(Re){return j(Re)?Re.map(Ne=>({range:c.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?F.fromMany(Ne.hoverMessage):Ne.hoverMessage?F.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Re.map(Ne=>({range:c.from(Ne)}))}e.fromRangeOrRangeWithMessage=B;function N(Re){return typeof Re>"u"?Re:typeof Re=="string"?I.URI.file(Re):Re}e.pathOrURIToURI=N;var U;(function(Re){function Ne(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?N(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Re.from=Ne})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var $;(function(Re){function Ne(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?N(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?U.from(ye.before):void 0,after:ye.after?U.from(ye.after):void 0}}Re.from=Ne})($=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Re){function Ne(ye){if(typeof ye>"u")return ye;switch(ye){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Ne})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ae;(function(Re){function Ne(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?z.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?$.from(ye.light):void 0,dark:ye.dark?$.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?N(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?U.from(ye.before):void 0,after:ye.after?U.from(ye.after):void 0}}Re.from=Ne})(ae=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(Re){function Ne(re){return{text:re.newText,eol:re.newEol&&rt.from(re.newEol),range:c.from(re.range)}}Re.from=Ne;function ye(re){const Fe=new o.TextEdit(c.to(re.range),re.text);return Fe.newEol=typeof re.eol>"u"?void 0:rt.to(re.eol),Fe}Re.to=ye})(ee=e.TextEdit||(e.TextEdit={}));var q;(function(Re){function Ne(re,Fe){const He={edits:[]};if(re instanceof o.WorkspaceEdit){const Je=new P.ResourceSet;for(const qe of re._allEntries())qe._type===1&&I.URI.isUri(qe.to)&&qe.from===void 0&&Je.add(qe.to);for(const qe of re._allEntries())qe._type===1?He.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contentsBase64:qe.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(qe.options.contents))},metadata:qe.metadata}):qe._type===2?He.edits.push({resource:qe.uri,textEdit:ee.from(qe.edit),versionId:Je.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?He.edits.push({resource:qe.uri,textEdit:{range:c.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Je.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?He.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&He.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ot.from)}})}return He}Re.from=Ne;function ye(re){const Fe=new o.WorkspaceEdit;for(const He of re.edits)He.textEdit?Fe.replace(I.URI.revive(He.resource),c.to(He.textEdit.range),He.textEdit.text):Fe.renameFile(I.URI.revive(He.oldResource),I.URI.revive(He.newResource),He.options);return Fe}Re.to=ye})(q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Ne=Object.create(null);Ne[o.SymbolKind.File]=0,Ne[o.SymbolKind.Module]=1,Ne[o.SymbolKind.Namespace]=2,Ne[o.SymbolKind.Package]=3,Ne[o.SymbolKind.Class]=4,Ne[o.SymbolKind.Method]=5,Ne[o.SymbolKind.Property]=6,Ne[o.SymbolKind.Field]=7,Ne[o.SymbolKind.Constructor]=8,Ne[o.SymbolKind.Enum]=9,Ne[o.SymbolKind.Interface]=10,Ne[o.SymbolKind.Function]=11,Ne[o.SymbolKind.Variable]=12,Ne[o.SymbolKind.Constant]=13,Ne[o.SymbolKind.String]=14,Ne[o.SymbolKind.Number]=15,Ne[o.SymbolKind.Boolean]=16,Ne[o.SymbolKind.Array]=17,Ne[o.SymbolKind.Object]=18,Ne[o.SymbolKind.Key]=19,Ne[o.SymbolKind.Null]=20,Ne[o.SymbolKind.EnumMember]=21,Ne[o.SymbolKind.Struct]=22,Ne[o.SymbolKind.Event]=23,Ne[o.SymbolKind.Operator]=24,Ne[o.SymbolKind.TypeParameter]=25;function ye(Fe){return typeof Ne[Fe]=="number"?Ne[Fe]:6}Re.from=ye;function re(Fe){for(const He in Ne)if(Ne[He]===Fe)return Number(He);return o.SymbolKind.Property}Re.to=re})(J=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Re){function Ne(re){switch(re){case o.SymbolTag.Deprecated:return 1}}Re.from=Ne;function ye(re){switch(re){case 1:return o.SymbolTag.Deprecated}}Re.to=ye})(ie=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Re){function Ne(re){return{name:re.name,kind:J.from(re.kind),tags:re.tags&&re.tags.map(ie.from),containerName:re.containerName,location:ve.from(re.location)}}Re.from=Ne;function ye(re){const Fe=new o.SymbolInformation(re.name,J.to(re.kind),re.containerName,ve.to(re.location));return Fe.tags=re.tags&&re.tags.map(ie.to),Fe}Re.to=ye})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Re){function Ne(re){const Fe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:J.from(re.kind),tags:re.tags?.map(ie.from)??[]};return re.children&&(Fe.children=re.children.map(Ne)),Fe}Re.from=Ne;function ye(re){const Fe=new o.DocumentSymbol(re.name,re.detail,J.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,a.isNonEmptyArray)(re.tags)&&(Fe.tags=re.tags.map(ie.to)),re.children&&(Fe.children=re.children.map(ye)),Fe}Re.to=ye})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(Re){function Ne(re){const Fe=new o.CallHierarchyItem(J.to(re.kind),re.name,re.detail||"",I.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Re.to=Ne;function ye(re,Fe,He){if(Fe=Fe??re._sessionId,He=He??re._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:re.name,detail:re.detail,kind:J.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Re.from=ye})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(Re){function Ne(ye){return new o.CallHierarchyIncomingCall(Y.to(ye.from),ye.fromRanges.map(re=>c.to(re)))}Re.to=Ne})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var fe;(function(Re){function Ne(ye){return new o.CallHierarchyOutgoingCall(Y.to(ye.to),ye.fromRanges.map(re=>c.to(re)))}Re.to=Ne})(fe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Re){function Ne(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Re.from=Ne;function ye(re){return new o.Location(I.URI.revive(re.uri),c.to(re.range))}Re.to=ye})(ve=e.location||(e.location={}));var ke;(function(Re){function Ne(re){const Fe=re,He=re;return{originSelectionRange:Fe.originSelectionRange?c.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:c.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?c.from(Fe.targetSelectionRange):void 0}}Re.from=Ne;function ye(re){return{targetUri:I.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Re.to=ye})(ke=e.DefinitionLink||(e.DefinitionLink={}));var Oe;(function(Re){function Ne(re){return{range:c.from(re.range),contents:F.fromMany(re.contents)}}Re.from=Ne;function ye(re){return new o.Hover(re.contents.map(F.to),c.to(re.range))}Re.to=ye})(Oe=e.Hover||(e.Hover={}));var oe;(function(Re){function Ne(re){return{range:c.from(re.range),expression:re.expression}}Re.from=Ne;function ye(re){return new o.EvaluatableExpression(c.to(re.range),re.expression)}Re.to=ye})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Re){function Ne(re){if(re instanceof o.InlineValueText)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof o.InlineValueVariableLookup)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Ne;function ye(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Re.to=ye})(le=e.InlineValue||(e.InlineValue={}));var ue;(function(Re){function Ne(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Re.from=Ne;function ye(re){return new o.InlineValueContext(re.frameId,c.to(re.stoppedLocation))}Re.to=ye})(ue=e.InlineValueContext||(e.InlineValueContext={}));var te;(function(Re){function Ne(re){return{range:c.from(re.range),kind:re.kind}}Re.from=Ne;function ye(re){return new o.DocumentHighlight(c.to(re.range),re.kind)}Re.to=ye})(te=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Ne(ye){switch(ye){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Ne})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(Re){function Ne(ye){return{triggerKind:ce.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Re.to=Ne})(se=e.CompletionContext||(e.CompletionContext={}));var M;(function(Re){function Ne(re){switch(re){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Ne;function ye(re){switch(re){case 1:return o.CompletionItemTag.Deprecated}}Re.to=ye})(M=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Re){const Ne=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ye(He){return Ne.get(He)??9}Re.from=ye;const re=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(He){return re.get(He)??o.CompletionItemKind.Property}Re.to=Fe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(Re){function Ne(ye,re){const Fe=new o.CompletionItem(ye.label);return Fe.insertText=ye.insertText,Fe.kind=W.to(ye.kind),Fe.tags=ye.tags?.map(M.to),Fe.detail=ye.detail,Fe.documentation=C.isMarkdownString(ye.documentation)?F.to(ye.documentation):ye.documentation,Fe.sortText=ye.sortText,Fe.filterText=ye.filterText,Fe.preselect=ye.preselect,Fe.commitCharacters=ye.commitCharacters,y.Range.isIRange(ye.range)?Fe.range=c.to(ye.range):typeof ye.range=="object"&&(Fe.range={inserting:c.to(ye.range.insert),replacing:c.to(ye.range.replace)}),Fe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:Boolean(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Fe.insertText=new o.SnippetString(ye.insertText):(Fe.insertText=ye.insertText,Fe.textEdit=Fe.range instanceof o.Range?new o.TextEdit(Fe.range,Fe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ye.additionalTextEdits.map(He=>ee.to(He))),Fe.command=re&&ye.command?re.fromInternal(ye.command):void 0,Fe}Re.to=Ne})(G=e.CompletionItem||(e.CompletionItem={}));var _;(function(Re){function Ne(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:F.fromStrict(re.documentation)}}Re.from=Ne;function ye(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation}}Re.to=ye})(_=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Re){function Ne(re){return{label:re.label,documentation:F.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(_.from):[],activeParameter:re.activeParameter}}Re.from=Ne;function ye(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(_.to):[],activeParameter:re.activeParameter}}Re.to=ye})(de=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Ne(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.from):[]}}Re.from=Ne;function ye(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.to):[]}}Re.to=ye})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Ne(ye,re){const Fe=new o.InlayHint(m.to(re.position),typeof re.label=="string"?re.label:re.label.map(be.to.bind(void 0,ye)),re.kind&&Ie.to(re.kind));return Fe.textEdits=re.textEdits&&re.textEdits.map(ee.to),Fe.tooltip=C.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,Fe.paddingLeft=re.paddingLeft,Fe.paddingRight=re.paddingRight,Fe}Re.to=Ne})(Ae=e.InlayHint||(e.InlayHint={}));var be;(function(Re){function Ne(ye,re){const Fe=new o.InlayHintLabelPart(re.label);return Fe.tooltip=C.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,h.Command.is(re.command)&&(Fe.command=ye.fromInternal(re.command)),re.location&&(Fe.location=ve.to(re.location)),Fe}Re.to=Ne})(be=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ie;(function(Re){function Ne(re){return re}Re.from=Ne;function ye(re){return re}Re.to=ye})(Ie=e.InlayHintKind||(e.InlayHintKind={}));var Te;(function(Re){function Ne(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Ne;function ye(re){let Fe;if(re.url)try{Fe=typeof re.url=="string"?I.URI.parse(re.url,!0):I.URI.revive(re.url)}catch{}return new o.DocumentLink(c.to(re.range),Fe)}Re.to=ye})(Te=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(Re){function Ne(re){const Fe=new o.ColorPresentation(re.label);return re.textEdit&&(Fe.textEdit=ee.to(re.textEdit)),re.additionalTextEdits&&(Fe.additionalTextEdits=re.additionalTextEdits.map(He=>ee.to(He))),Fe}Re.to=Ne;function ye(re){return{label:re.label,textEdit:re.textEdit?ee.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Fe=>ee.from(Fe)):void 0}}Re.from=ye})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Ne(re){return new o.Color(re[0],re[1],re[2],re[3])}Re.to=Ne;function ye(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=ye})(Ge=e.Color||(e.Color={}));var nt;(function(Re){function Ne(re){return{range:c.from(re.range)}}Re.from=Ne;function ye(re){return new o.SelectionRange(c.to(re.range))}Re.to=ye})(nt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Ne(ye){switch(ye){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Ne})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(Re){function Ne(re){switch(re){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Ne;function ye(re){switch(re){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=ye})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Re){function Ne(re){if(re===o.EndOfLine.CRLF)return 1;if(re===o.EndOfLine.LF)return 0}Re.from=Ne;function ye(re){if(re===1)return o.EndOfLine.CRLF;if(re===0)return o.EndOfLine.LF}Re.to=ye})(rt=e.EndOfLine||(e.EndOfLine={}));var ct;(function(Re){function Ne(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Ne})(ct=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Re){function Ne(re){const Fe={start:re.start+1,end:re.end+1};return re.kind&&(Fe.kind=Ee.from(re.kind)),Fe}Re.from=Ne;function ye(re){const Fe={start:re.start-1,end:re.end-1};return re.kind&&(Fe.kind=Ee.to(re.kind)),Fe}Re.to=ye})(Me=e.FoldingRange||(e.FoldingRange={}));var Ee;(function(Re){function Ne(re){if(re)switch(re){case o.FoldingRangeKind.Comment:return h.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return h.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return h.FoldingRangeKind.Region}}Re.from=Ne;function ye(re){if(re)switch(re.value){case h.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Re.to=ye})(Ee=e.FoldingRangeKind||(e.FoldingRangeKind={}));var K;(function(Re){function Ne(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?c.from(ye.selection):void 0,override:typeof ye.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Ne})(K=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(Re){function Ne(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:ye(He)||re(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Ne;function ye(He){const Je=He;return Je?I.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function re(He){const Je=He;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new o.RelativePattern(I.URI.revive(He.baseUri),He.pattern)}Re.to=Fe})(Q=e.GlobPattern||(e.GlobPattern={}));var pe;(function(Re){function Ne(ye){if(ye){if(Array.isArray(ye))return ye.map(Ne);if(typeof ye=="string")return ye;{const re=ye;return{language:re.language,scheme:re.scheme,pattern:Q.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Ne})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Le;(function(Re){function Ne(re){return{start:re.start,end:re.end}}Re.from=Ne;function ye(re){return new o.NotebookRange(re.start,re.end)}Re.to=ye})(Le=e.NotebookRange||(e.NotebookRange={}));var $e;(function(Re){function Ne(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Ne;function ye(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=ye})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Re){function Ne(ye){if(ye===b.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(ye===b.NotebookCellExecutionState.Pending)return;if(ye===b.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Re.to=Ne})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(Re){function Ne(re){switch(re){case o.NotebookCellKind.Markup:return b.CellKind.Markup;case o.NotebookCellKind.Code:default:return b.CellKind.Code}}Re.from=Ne;function ye(re){switch(re){case b.CellKind.Markup:return o.NotebookCellKind.Markup;case b.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=ye})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var et;(function(Re){function Ne(re){const Fe={metadata:re.metadata??Object.create(null),cells:[]};for(const He of re.cells)o.NotebookCellData.validate(He),Fe.cells.push(ot.from(He));return Fe}Re.from=Ne;function ye(re){const Fe=new o.NotebookData(re.cells.map(ot.to));return(0,v.isEmptyObject)(re.metadata)||(Fe.metadata=re.metadata),Fe}Re.to=ye})(et=e.NotebookData||(e.NotebookData={}));var ot;(function(Re){function Ne(re){return{cellKind:Ye.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:$e.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(bt.from):[]}}Re.from=Ne;function ye(re){return new o.NotebookCellData(Ye.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(bt.to):void 0,re.metadata,re.internalMetadata?$e.to(re.internalMetadata):void 0)}Re.to=ye})(ot=e.NotebookCellData||(e.NotebookCellData={}));var ft;(function(Re){function Ne(re){return{mime:re.mime,valueBytes:A.VSBuffer.wrap(re.data)}}Re.from=Ne;function ye(re){return new o.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=ye})(ft=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var bt;(function(Re){function Ne(re){return{outputId:re.id,items:re.items.map(ft.from),metadata:re.metadata}}Re.from=Ne;function ye(re){const Fe=re.items.map(ft.to);return new o.NotebookCellOutput(Fe,re.outputId,re.metadata)}Re.to=ye})(bt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Lt;(function(Re){function Ne(Fe){return re(Fe)?{include:(0,v.withNullAsUndefined)(Q.from(Fe.include)),exclude:(0,v.withNullAsUndefined)(Q.from(Fe.exclude))}:(0,v.withNullAsUndefined)(Q.from(Fe))}Re.from=Ne;function ye(Fe){return re(Fe)?{include:Q.to(Fe.include),exclude:Q.to(Fe.exclude)}:Q.to(Fe)}Re.to=ye;function re(Fe){const He=Fe;return He?!(0,v.isUndefinedOrNull)(He.include)&&!(0,v.isUndefinedOrNull)(He.exclude):!1}})(Lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var st;(function(Re){function Ne(ye,re,Fe){const He=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(He,Fe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Re.from=Ne})(st=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var pt;(function(Re){function Ne(ye,re,Fe){const He=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:re.toInternal(He,Fe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Re.from=Ne})(pt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(Re){function Ne(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Re.from=Ne})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Kt;(function(Re){function Ne(re){return{uri:re.uri,provides:re.provides}}Re.from=Ne;function ye(re){return new o.NotebookRendererScript(I.URI.revive(re.uri),re.provides)}Re.to=ye})(Kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(Re){function Ne(re){return{message:F.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Re.from=Ne;function ye(re){const Fe=new o.TestMessage(typeof re.message=="string"?re.message:F.to(re.message));return Fe.actualOutput=re.actual,Fe.expectedOutput=re.expected,Fe.location=re.location?ve.to(re.location):void 0,Fe}Re.to=ye})(Pt=e.TestMessage||(e.TestMessage={}));var mt;(function(Re){Re.namespace=p.namespaceTestTag,Re.denamespace=p.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var kt;(function(Re){function Ne(re){const Fe=(0,u.getPrivateApiFor)(re).controllerId;return{extId:D.TestId.fromExtHostTestItem(re,Fe).toString(),label:re.label,uri:I.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(He=>mt.namespace(Fe,He.id)),range:y.Range.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&F.fromStrict(re.error)||null}}Re.from=Ne;function ye(re){return{parent:void 0,error:void 0,id:D.TestId.fromString(re.extId).localId,label:re.label,uri:I.URI.revive(re.uri),tags:(re.tags||[]).map(Fe=>{const{tagId:He}=mt.denamespace(Fe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=ye})(kt=e.TestItem||(e.TestItem={})),function(Re){function Ne(re){return{id:re.id}}Re.from=Ne;function ye(re){return new o.TestTag(re.id)}Re.to=ye}(mt=e.TestTag||(e.TestTag={}));var $t;(function(Re){const Ne=(re,Fe)=>{const He=[];for(const[qe,tt]of Fe)D.TestId.compare(tt.item.extId,qe)===2&&(Fe.delete(qe),He.push(tt));const Je={...kt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(tt=>tt.type===0).map(Pt.to)})),children:He.map(qe=>Ne(qe,Fe))};for(const qe of Je.children)qe.parent=Je;return Je};function ye(re){const Fe=[],He=new Map;for(const Je of re.items){He.set(Je.item.extId,Je);const qe=D.TestId.root(Je.item.extId);re.request.targets.some(tt=>tt.controllerId===qe&&tt.testIds.includes(Je.item.extId))&&Fe.push(Je)}return{completedAt:re.completedAt,results:Fe.map(Je=>Ne(Je,He))}}Re.to=ye})($t=e.TestResults||(e.TestResults={}));var Ot;(function(Re){function Ne(He){return{covered:He.covered,total:He.covered}}function ye(He){return"line"in He?m.from(He):c.from(He)}function re(He){return"branches"in He?{count:He.executionCount,location:ye(He.location),type:1,branches:He.branches.length?He.branches.map(Je=>({count:Je.executionCount,location:Je.location&&ye(Je.location)})):void 0}:{type:0,count:He.executionCount,location:ye(He.location)}}Re.fromDetailed=re;function Fe(He){return{uri:He.uri,statement:Ne(He.statementCoverage),branch:He.branchCoverage&&Ne(He.branchCoverage),function:He.functionCoverage&&Ne(He.functionCoverage),details:He.detailedCoverage?.map(re)}}Re.fromFile=Fe})(Ot=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Re){function Ne(ye){switch(ye){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Ne})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Re){function Ne(re){const Fe=new o.TypeHierarchyItem(J.to(re.kind),re.name,re.detail||"",I.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Re.to=Ne;function ye(re,Fe,He){if(Fe=Fe??re._sessionId,He=He??re._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:J.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Re.from=ye})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(Re){function Ne(ye){if(!!ye)return{value:ye.value,tooltip:ye.tooltip}}Re.from=Ne})(Ut=e.ViewBadge||(e.ViewBadge={}));var Wt;(function(Re){function Ne(He,Je,qe){const tt=Je.fileData;return tt?new class extends o.DataTransferItem{asFile(){return{name:tt.name,uri:I.URI.revive(tt.uri),data:(0,R.once)(()=>qe())}}}("",Je.id):He===L.Mimes.uriList&&Je.uriListData?new o.DataTransferItem(Fe(Je.uriListData)):new o.DataTransferItem(Je.asString)}Re.to=Ne;async function ye(He,Je){const qe=await Je.asString();if(He===L.Mimes.uriList)return{id:Je.id,asString:qe,fileData:void 0,uriListData:re(qe)};const tt=Je.asFile();return{id:Je.id,asString:qe,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Re.from=ye;function re(He){return l.UriList.split(He).map(Je=>{if(Je.startsWith("#"))return Je;try{return I.URI.parse(Je)}catch{}return Je})}function Fe(He){return l.UriList.create(He.map(Je=>typeof Je=="string"?Je:I.URI.revive(Je)))}})(Wt=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(Re){function Ne(re,Fe){const He=re.items.map(([Je,qe])=>[Je,Wt.to(Je,qe,()=>Fe(qe.id))]);return new o.DataTransfer(He)}Re.toDataTransfer=Ne;async function ye(re){const Fe={items:[]},He=[];return re.forEach((Je,qe)=>{He.push((async()=>{Fe.items.push([qe,await Wt.from(qe,Je)])})())}),await Promise.all(He),Fe}Re.toDataTransferDTO=ye})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(De[240],Ce([1,0,2,12,7,14,66]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,L,T,v={timeout:1500,errors:3}){this.c=k,this.d=L,this.f=T,this.g=v,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(L,T,v)=>{const y={dispose:this.a.push([L,T,k])};return Array.isArray(v)&&v.push(y),y}}async $participateInSave(k,L){const T=a.URI.revive(k);let v=!1;const I=setTimeout(()=>v=!0,this.g.timeout),y=[];try{for(const h of[...this.a]){if(v)break;const d=this.d.getDocument(T),u=await this.h(h,{document:d,reason:R.TextDocumentSaveReason.to(L)});y.push(u)}}finally{clearTimeout(I)}return y}h([k,L,T],v){const I=this.b.get(k);return typeof I=="number"&&I>this.g.errors?Promise.resolve(!1):this.i(T,k,L,v).then(()=>!0,y=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this.c.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const h=this.b.get(k);this.b.set(k,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,L,T,v){const I=[],y=Date.now(),{document:h,reason:d}=v,{version:u}=h,g=Object.freeze({document:h,reason:d,waitUntil(b){if(Object.isFrozen(I))throw(0,A.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(b))}});try{L.apply(T,[g])}catch(b){return Promise.reject(b)}return Object.freeze(I),new Promise((b,D)=>{const p=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(I).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(p),b(i)}).catch(i=>{clearTimeout(p),D(i)})}).then(b=>{const D={edits:[]};for(const p of b)if(Array.isArray(p)&&p.every(i=>i instanceof l.TextEdit))for(const{newText:i,newEol:o,range:r}of p)D.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:i,eol:o&&R.EndOfLine.from(o)}});if(D.edits.length!==0)return u===h.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(De[241],Ce([1,0,16,2,14,7,93]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(T,v,I,y){this.start=T,this.deletedCount=v,this.deletedItems=I,this.items=y}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(T,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,v,I){this.notebook=T,this.h=v,this.j=I,this.handle=I.handle,this.uri=A.URI.revive(I.uri),this.cellKind=I.cellKind,this.a=I.outputs.map(l.NotebookCellOutput.to),this.e=I.internalMetadata??{},this.b=Object.freeze(I.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const T=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return T.g},set mime(y){T.g=y},get outputs(){return T.a.slice(0)},get metadata(){return T.b},get executionSummary(){return T.d}};this.f=Object.freeze(I)}return this.f}setOutputs(T){this.a=T.map(l.NotebookCellOutput.to)}setOutputItems(T,v,I){const y=I.map(l.NotebookCellOutputItem.to),h=this.a.find(d=>d.id===T);if(h&&(v||(h.items.length=0),h.items.push(...y),h.items.length>1&&h.items.every(d=>C.isTextStreamMime(d.mime)))){const d=new Map,u=[];h.items.forEach(g=>{let b;d.has(g.mime)?b=d.get(g.mime):(b=[],d.set(g.mime,b),u.push(g.mime)),b.push(g.data)}),h.items.length=0,u.forEach(g=>{const b=C.compressOutputItemStreams(d.get(g));h.items.push({mime:g,data:b.buffer})})}}setMetadata(T){this.b=Object.freeze(T)}setInternalMetadata(T){this.e=T,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=S;class k{constructor(T,v,I,y,h){this.k=T,this.l=v,this.m=I,this.uri=y,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const T=this,v={get uri(){return T.uri},get version(){return T.g},get notebookType(){return T.d},get isDirty(){return T.h},get isUntitled(){return T.uri.scheme===a.Schemas.untitled},get isClosed(){return T.j},get metadata(){return T.f},get cellCount(){return T.b.length},cellAt(I){return I=T.n(I),T.b[I].apiCell},getCells(I){return(I?T.p(I):T.b).map(h=>h.apiCell)},save(){return T.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(T){T.metadata&&(this.f=Object.freeze({...this.f,...T.metadata}))}acceptDirty(T){this.h=T}acceptModelChanged(T,v,I){this.g=T.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:I});const y={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},h=[];for(const u of T.rawEvents)u.kind===C.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,y.contentChanges):u.kind===C.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,y.contentChanges):u.kind===C.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),h.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),h.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),h.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===C.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),h.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),h.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const d=new Map;for(let u=0;u<h.length;u++){const g=h[u],b=d.get(g.cell);if(b===void 0){const D=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});d.set(g.cell,D-1)}else y.cellChanges[b]={...y.cellChanges[b],...g}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}n(T){return T=T|0,T<0?0:T>=this.b.length?this.b.length-1:T}o(T){let v=T.start|0,I=T.end|0;return v<0&&(v=0),I>this.b.length&&(I=this.b.length),T.with({start:v,end:I})}p(T){T=this.o(T);const v=[];for(let I=T.start;I<T.end;I++)v.push(this.b[I]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(T,v,I){if(this.j)return;const y=[],h=[],d=[];if(T.reverse().forEach(u=>{const b=u[2].map(i=>{const o=new S(this,this.l,i);return v||h.push(S.asModelAddData(this.apiNotebook,i)),o}),D=new P(u[0],u[1],[],b),p=this.b.splice(u[0],u[1],...b);for(const i of p)d.push(i.uri),D.deletedItems.push(i.apiCell);y.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:d}),I)for(const u of y)I.push(u.asApiEvent())}s(T,v,I,y){const h=this.b.splice(T,v);this.b.splice(I,0,...h);const d=[new P(T,v,h.map(u=>u.apiCell),[]),new P(I,0,[],h)];for(const u of d)y.push(u.asApiEvent())}t(T,v){this.b[T].setOutputs(v)}u(T,v,I,y){this.b[T].setOutputItems(v,I,y)}v(T,v){const I=this.b[T];I.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(I.uri,v)}w(T,v){const I=this.b[T];I.apiCell.mime=v}x(T,v){this.b[T].setMetadata(v)}y(T,v){this.b[T].setInternalMetadata(v)}getCellFromApiCell(T){return this.b.find(v=>v.apiCell===T)}getCellFromIndex(T){return this.b[T]}getCell(T){return this.b.find(v=>v.handle===T)}getCellIndex(T){return this.b.indexOf(T)}}k.a=0,e.ExtHostNotebookDocument=k}),define(De[136],Ce([1,0,12,14,7]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(P,S,k,L,T,v){this.id=P,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=T,this.b=L,this.c=v}get apiEditor(){if(!this.e){const P=this;this.e={get notebook(){return P.notebookData.apiNotebook},get selection(){return P.a[0]},set selection(S){this.selections=[S]},get selections(){return P.a},set selections(S){if(!Array.isArray(S)||!S.every(l.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");P.a=S,P.g(S)},get visibleRanges(){return P.b},revealRange(S,k){P.f.$tryRevealRange(P.id,A.NotebookRange.from(S),k??l.NotebookEditorRevealType.Default)},get viewColumn(){return P.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(P){this.d=P}_acceptVisibleRanges(P){this.b=P}_acceptSelections(P){this.a=P}g(P){this.f.$trySetSelections(this.id,P.map(A.NotebookRange.from))}_acceptViewColumn(P){this.c=P}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(De[242],Ce([1,0,3,13,14]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(P,S){this.c=P,this.d=S,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(P,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,S);const k=this.d.getEditorById(P);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(l.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(l.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const S in P)this.d.getEditorById(S)._acceptViewColumn(l.ViewColumn.to(P[S]))}};R=xe([We(0,A.ILogService)],R),e.ExtHostNotebookEditors=R}),define(De[243],Ce([1,0,14,126,179,21,62,12]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,I,y){const h=this.b++,{title:d,location:u,cancellable:g}=I,b={label:(0,l.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(h,{location:a.ProgressLocation.from(u),title:d,source:b,cancellable:g},v.isUnderDevelopment?void 0:v.identifier.value).catch(P.onUnexpectedExternalError),this.d(h,y,!!g)}d(v,I,y){let h;y&&(h=new R.CancellationTokenSource,this.c.set(v,h));const d=g=>{this.a.$progressEnd(g),this.c.delete(g),h?.dispose()};let u;try{u=I(new L(this.a,v),y&&h?h.token:R.CancellationToken.None)}catch(g){throw d(v),g}return u.then(g=>d(v),g=>d(v)),u}$acceptProgressCanceled(v){const I=this.c.get(v);I&&(I.cancel(),this.c.delete(v))}}e.ExtHostProgress=S;function k(T,v){return T.message=v.message,typeof v.increment=="number"&&(typeof T.increment=="number"?T.increment+=v.increment:T.increment=v.increment),T}class L extends A.Progress{constructor(v,I){super(y=>this.throttledReport(y)),this.c=v,this.d=I}throttledReport(v){this.c.$progressReport(this.d,v)}}xe([(0,C.throttle)(100,(T,v)=>k(T,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[137],Ce([1,0,32,132,57,94,75,14,2]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,D,p,i)=>{let o=D;return{enumerable:!0,configurable:!1,get(){return o},set(r){if(!p(o,r)){const c=o;o=r,b.listener?.(i(r,c))}}}},L=(b,D)=>b===D,T={range:(b,D)=>b===D?!0:!b||!D?!1:b.isEqual(D),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,D)=>!(b.length!==D.length||b.some(p=>!D.find(i=>p.id===i.id)))},v=b=>D=>({op:4,update:b(D)}),I=(b,D)=>({range:(()=>{let p;const i=v(o=>({range:a.Range.lift(P.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return p},set(o){b.listener?.({op:6}),T.range(p,o)||(p=o,b.listener?.(i(o)))}}})(),label:k(b,D,T.label,v(p=>({label:p}))),description:k(b,void 0,T.description,v(p=>({description:p}))),sortText:k(b,void 0,T.sortText,v(p=>({sortText:p}))),canResolveChildren:k(b,!1,T.canResolveChildren,p=>({op:2,state:p})),busy:k(b,!1,T.busy,v(p=>({busy:p}))),error:k(b,void 0,T.error,v(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:k(b,[],T.tags,(p,i)=>({op:1,new:p.map(P.TestTag.from),old:i.map(P.TestTag.from)}))}),y=b=>{const D=l.TestId.fromString(b.extId),p=new d(D.controllerId,D.localId,b.label,S.URI.revive(b.uri)||void 0);return p.range=P.Range.to(b.range||void 0),p.description=b.description||void 0,p.sortText=b.sortText||void 0,p.tags=b.tags.map(i=>P.TestTag.to({id:(0,C.denamespaceTestTag)(i).tagId})),p},h=b=>{let D;for(const p of b.tests){const i=y(p.item);(0,A.getPrivateApiFor)(i).parent=D,D=i}return D};e.toItemFromContext=h;class d{constructor(D,p,i,o){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,A.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,R.createTestItemChildren)(r,A.getPrivateApiFor,d),enumerable:!0,writable:!1},...I(r,i)})}}e.TestItemImpl=d;class u extends d{constructor(D,p){super(D,D,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class g extends R.TestItemCollection{constructor(D,p,i){super({controllerId:D,getDocumentVersion:o=>o&&i.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new u(D,p),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(De[138],Ce([1,0,50,12,101,14,7]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(v,I,y){const h=P.c.nextId();v.$registerTextEditorDecorationType(I.identifier,h,R.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:h,dispose(){v.$removeTextEditorDecorationType(h)}})}}P.c=new l.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class S{constructor(v,I){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=I.undoStopBefore,this.f=I.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,I){this.k();let y=null;if(v instanceof C.Position)y=new C.Range(v,v);else if(v instanceof C.Range)y=v;else throw new Error("Unrecognized location");this.l(y,I,!1)}insert(v,I){this.k(),this.l(new C.Range(v,v),I,!0)}delete(v){this.k();let I=null;if(v instanceof C.Range)I=v;else throw new Error("Unrecognized location");this.l(I,null,!0)}l(v,I,y){const h=this.c.validateRange(v);this.g.push({range:h,text:I,forceMoveMarkers:y})}setEndOfLine(v){if(this.k(),v!==C.EndOfLine.LF&&v!==C.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=v}}class k{constructor(v,I,y,h){this.c=v,this.d=I,this._accept(y),this.e=h;const d=this;this.value={get tabSize(){return d.f},set tabSize(u){d.m(u)},get indentSize(){return d.g},set indentSize(u){d.o(u)},get insertSpaces(){return d.h},set insertSpaces(u){d.q(u)},get cursorStyle(){return d.j},set cursorStyle(u){d.s(u)},get lineNumbers(){return d.k},set lineNumbers(u){d.t(u)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const I=Math.floor(v);return I>0?I:null}if(typeof v=="string"){const I=parseInt(v,10);return isNaN(I)?null:I>0?I:null}return null}m(v){const I=this.l(v);if(I!==null){if(typeof I=="number"){if(this.f===I)return;this.f=I}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:I}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const I=Math.floor(v);return I>0?I:null}if(typeof v=="string"){const I=parseInt(v,10);return isNaN(I)?null:I>0?I:null}return null}o(v){const I=this.n(v);if(I!==null){if(typeof I=="number"){if(this.g===I)return;this.g=I}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:I}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const I=this.p(v);if(typeof I=="boolean"){if(this.h===I)return;this.h=I}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:I}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const I={};let y=!1;if(typeof v.tabSize<"u"){const h=this.l(v.tabSize);h==="auto"?(y=!0,I.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,y=!0,I.tabSize=h)}if(typeof v.indentSize<"u"){const h=this.n(v.indentSize);h==="tabSize"?(y=!0,I.indentSize=h):typeof h=="number"&&this.g!==h&&(this.g=h,y=!0,I.indentSize=h)}if(typeof v.insertSpaces<"u"){const h=this.p(v.insertSpaces);h==="auto"?(y=!0,I.insertSpaces=h):this.h!==h&&(this.h=h,y=!0,I.insertSpaces=h)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,y=!0,I.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,y=!0,I.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),y&&this.u("setOptions",this.c.$trySetOptions(this.d,I))}u(v,I){I.catch(y=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(y)})}}e.ExtHostTextEditorOptions=k;class L{constructor(v,I,y,h,d,u,g,b){this.id=v,this.j=I,this.k=y,this.g=!1,this.h=new Set,this.c=d,this.d=new k(this.j,this.id,u,y),this.e=g,this.f=b;const D=this;this.value=Object.freeze({get document(){return h.value},set document(p){throw(0,A.readonly)("document")},get selection(){return D.c&&D.c[0]},set selection(p){if(!(p instanceof C.Selection))throw(0,A.illegalArgument)("selection");D.c=[p],D.l()},get selections(){return D.c},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof C.Selection)))throw(0,A.illegalArgument)("selections");D.c=p,D.l()},get visibleRanges(){return D.e},set visibleRanges(p){throw(0,A.readonly)("visibleRanges")},get options(){return D.d.value},set options(p){D.g||D.d.assign(p)},get viewColumn(){return D.f},set viewColumn(p){throw(0,A.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(h.value,i);return p(o),D.m(o)},insertSnippet(p,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=D.c.map(c=>R.Range.from(c));else if(i instanceof C.Position){const{lineNumber:c,column:s}=R.Position.from(i);r=[{startLineNumber:c,startColumn:s,endLineNumber:c,endColumn:s}]}else if(i instanceof C.Range)r=[R.Range.from(i)];else{r=[];for(const c of i)if(c instanceof C.Range)r.push(R.Range.from(c));else{const{lineNumber:s,column:m}=R.Position.from(c);r.push({startLineNumber:s,startColumn:m,endLineNumber:s,endColumn:m})}}return I.$tryInsertSnippet(v,h.value.version,p.value,r,o)},setDecorations(p,i){const o=i.length===0;o&&!D.h.has(p.key)||(o?D.h.delete(p.key):D.h.add(p.key),D.n(()=>{if(R.isDecorationOptionsArr(i))return I.$trySetDecorations(v,p.key,R.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let c=0,s=i.length;c<s;c++){const m=i[c];r[4*c]=m.start.line+1,r[4*c+1]=m.start.character+1,r[4*c+2]=m.end.line+1,r[4*c+3]=m.end.character+1}return I.$trySetDecorationsFast(v,p.key,r)}}))},revealRange(p,i){D.n(()=>I.$tryRevealRange(v,R.Range.from(p),i||C.TextEditorRevealType.Default))},show(p){I.$tryShowEditor(v,R.ViewColumn.from(p))},hide(){I.$tryHideEditor(v)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,a.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,a.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,a.ok)(!this.g),this.f=v}_acceptSelections(v){(0,a.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const I=v.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const y=I.edits.map(d=>d.range);y.sort((d,u)=>d.end.line===u.end.line?d.end.character===u.end.character?d.start.line===u.start.line?d.start.character-u.start.character:d.start.line-u.start.line:d.end.character-u.end.character:d.end.line-u.end.line);for(let d=0,u=y.length-1;d<u;d++){const g=y[d].end;if(y[d+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=I.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,I.documentVersionId,h,{setEndOfLine:typeof I.setEndOfLine=="number"?R.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this.k.warn(I),null))}}e.ExtHostTextEditor=L}),define(De[244],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[245],Ce([1,0,195,12,37,123,92,39,26,244,208,197]),function(ne,e,a,A,l,R,C,P,S,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=P.Registry.as(C.Extensions.JSONContribution);class I{constructor(p,i,o){this.a=p,this.b=i,this.c=o}d(p,i){this.a({type:p,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(l.default.Error,p)}warn(p){this.d(l.default.Warning,p)}info(p){this.d(l.default.Info,p)}}e.ExtensionMessageCollector=I;class y{static a(p){const i=new Set;for(let o=0,r=p.length;o<r;o++)i.add(S.ExtensionIdentifier.toKey(p[o].description.identifier));return i}static compute(p,i){if(!p||!p.length)return new y(i,[]);if(!i||!i.length)return new y([],p);const o=this.a(p),r=this.a(i),c=i.filter(m=>!o.has(S.ExtensionIdentifier.toKey(m.description.identifier))),s=p.filter(m=>!r.has(S.ExtensionIdentifier.toKey(m.description.identifier)));return new y(c,s)}constructor(p,i){this.added=p,this.removed=i}}e.ExtensionPointUserDelta=y;class h{constructor(p,i){this.name=p,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=y.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,A.onUnexpectedError)(p)}}}e.ExtensionPoint=h;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const i=new h(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,i),p.activationEventsGenerator&&T.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,v.registerSchema(u,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const b={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(b.ExtensionsRegistry,new g),e.ExtensionsRegistry=P.Registry.as(b.ExtensionsRegistry),v.registerSchema(u,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(De[246],Ce([1,0,192,9,23,245,54,3]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var k;(function(v){function I(y,h,d){if(!y)return;const u=A.isString(y.type)?y.type:void 0;if(!u||u.length===0){d.error(a.localize(3,null));return}const g=[];if(Array.isArray(y.required))for(const b of y.required)A.isString(b)&&g.push(b);return{extensionId:h.value,taskType:u,required:g,properties:y.properties?l.deepClone(y.properties):{},when:y.when?C.ContextKeyExpr.deserialize(y.when):void 0}}v.from=I})(k||(k={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,I)=>{for(const y of v)y.type&&I.push(`onTaskType:${y.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:S}});class T{constructor(){this.d=new P.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((I,y)=>{L.setHandler((h,d)=>{this.c=void 0;try{for(const u of d.removed){const g=u.value;for(const b of g)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const u of d.added){const g=u.value;for(const b of g){const D=k.from(b,u.description.identifier,u.collector);D&&(this.a[D.taskType]=D)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}I(void 0)})})}onReady(){return this.b}get(I){return this.a[I]}all(){return Object.keys(this.a).map(I=>this.a[I])}getJsonSchema(){if(this.c===void 0){const I=[];for(const y of this.all()){const h={type:"object",additionalProperties:!1};y.required.length>0&&(h.required=y.required.slice(0)),y.properties!==void 0?h.properties=l.deepClone(y.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[y.taskType]},I.push(h)}this.c={oneOf:I}}return this.c}}e.TaskDefinitionRegistry=new T}),define(De[247],Ce([1,0,193,9,24,23,54,246]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var S;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function U($){if(!$)return N.Strong;switch($.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=U}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(N){function U($){switch($.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var T;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function U($){switch($.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=U}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(N){function U($){switch($.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=U}(v=e.PanelKind||(e.PanelKind={}));var I;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:T.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var y;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(y=e.RuntimeType||(e.RuntimeType={})),function(N){function U(z){switch(z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=U;function $(z){switch(z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=$}(y=e.RuntimeType||(e.RuntimeType={}));var h;(function(N){function U($){return A.isString($)?$:$.value}N.value=U})(h=e.CommandString||(e.CommandString={}));var d;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function U(z){return z===N.Clean._id||z===N.Build._id||z===N.Rebuild._id||z===N.Test._id}N.is=U;function $(z){if(z!==void 0)return A.isString(z)?U(z)?{_id:z,isDefault:!1}:void 0:z}N.from=$})(d=e.TaskGroup||(e.TaskGroup={}));var u;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var g;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function U($){switch($){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=U})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(N){N.parallel="parallel",N.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var D;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(D=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor(U,$,z,ae,ee,q){this._label="",this._id=U,$&&(this._label=$),z&&(this.type=z),this.runOptions=ae,this.configurationProperties=ee,this._source=q}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,$=!1){if(U===void 0)return!1;if(A.isString(U))return U===this._label||U===this.configurationProperties.identifier||$&&U===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class o extends i{constructor(U,$,z,ae,ee,q,J,ie){super(U,z,void 0,J,ie,$),this.command={},this._source=$,this.hasDefinedMatchers=q,ee&&(this.command=ee)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case y.Shell:$="shell";break;case y.Process:$="process";break;case y.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(U){return U instanceof o}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&($+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new o(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=o;class r extends i{constructor(U,$,z,ae,ee,q,J){super(U,z,ae,q,J,$),this._source=$,this.configures=ee}static is(U){return U instanceof r}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&($+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(z)}}e.ConfiguringTask=r;class c extends i{constructor(U,$,z,ae,ee,q,J,ie,ge){super(U,z,ae,ie,ge,$),this.defines=ee,this.hasDefinedMatchers=J,this.command=q,this.icon=ge.icon,this.hide=ge.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof c}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new c(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=c;class s extends i{constructor(U,$,z,ae,ee,q){super(U,z,ae,ee,q,$),this._source=$}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new s(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=s;var m;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(m=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(m=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(U){this.c=new Map;for(let $=0;$<U.length;$++)this.c.set(U[$].uri.toString(),$)}compare(U,$){const z=U.getWorkspaceFolder(),ae=$.getWorkspaceFolder();if(z&&ae){let ee=this.c.get(z.uri.toString());ee=ee===void 0?0:ee+1;let q=this.c.get(ae.uri.toString());return q=q===void 0?0:q+1,ee===q?U._label.localeCompare($._label):ee-q}else return!z&&ae?-1:z&&!ae?1:0}}e.TaskSorter=t;var f;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(N){N.SingleRun="singleRun",N.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var w;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(w=e.TaskRunSource||(e.TaskRunSource={}));var O;(function(N){function U($,z,ae,ee){if(z){const q={kind:$,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ae,__task:z};return $==="start"?q.resolvedVariables=ee:$==="processStarted"?q.processId=ee:$==="processEnded"&&(q.exitCode=ee),Object.freeze(q)}else return Object.freeze({kind:"changed"})}N.create=U})(O=e.TaskEvent||(e.TaskEvent={}));var V;(function(N){function U(z){const ae=Object.keys(z).sort();let ee="";for(const q of ae){let J=z[q];J instanceof Object?J=U(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),ee+=q+","+J+","}return ee}function $(z){const ee={_key:U(z),type:z.taskType};return Object.assign(ee,z),ee}N.create=$})(V=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var j;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(j=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(N){function U($,z){const ae=P.TaskDefinitionRegistry.get($.type);if(ae===void 0){const ie=R.deepClone($);return delete ie._key,V.create(ie)}const ee=Object.create(null);ee.type=ae.taskType;const q=new Set;ae.required.forEach(ie=>q.add(ie));const J=ae.properties;for(const ie of Object.keys(J)){const ge=$[ie];if(ge!=null)ee[ie]=ge;else if(q.has(ie)){const X=J[ie];if(X.default!==void 0)ee[ie]=R.deepClone(X.default);else switch(X.type){case"boolean":ee[ie]=!1;break;case"number":case"integer":ee[ie]=0;break;case"string":ee[ie]="";break;default:z.error(a.localize(2,null,JSON.stringify($,void 0,0),ie));return}}}return V.create(ee)}N.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[248],Ce([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,P)=>{this.b=C,this.d=P,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,a.onUnexpectedError)(C))}then(C,P){return this.j().then(C,P)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=A;class l extends A{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=l}),define(De[58],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const A=[];function l(P){const S=new a(P);return A[S.nid]=S,S}e.createProxyIdentifier=l;function R(P){return A[P].sid}e.getStringIdentifierForProxy=R;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(De[5],Ce([1,0,58]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var R;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(d){return d._id=T.a++,d}}T.a=0,e.IdObject=T;var v;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(De[77],Ce([1,0,4,13,5,20]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(l.MainContext.MainThreadTelemetry)}report(S,k,L){const T=this.d(S,k);this.a.has(T)||(this.a.add(T),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};C=xe([We(0,R.IExtHostRpcService),We(1,A.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,k){}})}),define(De[249],Ce([1,0,3,5,7,26]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,L,T={}){const v=R.ExtensionIdentifier.toKey(S.identifier),I=this.f.get(v)||[],y=[...L].sort().join(" ");let h=I.find(d=>d.providerId===k&&d.scopes===y);if(h)return h.result;{const d=this.g(S,v,k,L,T);h={providerId:k,scopes:y,result:d},I.push(h),this.f.set(v,I);try{await d}finally{const u=I.findIndex(g=>g.providerId===k&&g.scopes===y);u>-1&&(I.splice(u),this.f.set(v,I))}return d}}async g(S,k,L,T,v={}){await this.a.$ensureProvider(L);const I=S.displayName||S.name;return this.a.$getSession(L,T,k,I,v)}async removeSession(S,k){const L=this.b.get(S);return L?L.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,L,T){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:L,options:T??{supportsMultipleAccounts:!1}}),this.c.find(I=>I.id===S)||this.c.push({id:S,label:k});const v=L.onDidChangeSessions(I=>{this.a.$sendDidChangeSessions(S,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,T?.supportsMultipleAccounts??!1),new l.Disposable(()=>{v.dispose(),this.b.delete(S);const I=this.c.findIndex(y=>y.id===S);I>-1&&this.c.splice(I),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(De[250],Ce([1,0,5,20,14]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(P,S){this.a=P.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,S,k){const L=l.WorkspaceEdit.from(P,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,k?.isRefactoring??!1)}};R=xe([We(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(De[251],Ce([1,0,5]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const C=R.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(P){return C.$writeText(P)}})}}e.ExtHostClipboard=A});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[40],Ce([1,0,9,7,14,23,5,15,13,69,32,52,2,6,4,20,137,22,58,45,43,73,76]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p,i){"use strict";var o,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(w,O,V){o.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),c.set(this,void 0),Ze(this,o,w.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=O,Ze(this,c,V,"f"),Ze(this,r,w.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new m(this,j=>{const F=this.c.get(j);return F?.result===t.Void?F:void 0},O),this.f=[{processArgument(j){return(0,k.revive)(j)}},{processArgument(j){return(0,R.cloneAndChange)(j,function(F){if(L.Range.isIRange(F))return l.Range.to(F);if(T.Position.isIPosition(F))return l.Position.to(F);if(L.Range.isIRange(F.range)&&v.URI.isUri(F.uri))return l.location.to(F);if(F instanceof u.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const O=this.registerCommand(!1,w.id,async(...V)=>{const j=w.args.map((B,N)=>{if(!B.validate(V[N]))throw new Error(`Invalid argument '${B.name}' when running '${w.id}', received: ${V[N]}`);return B.convert(V[N])}),F=await this.executeCommand(w.internalId,...j);return w.result.convert(F,V,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new A.Disposable(()=>{O.dispose(),this.c.delete(w.id)})}registerCommand(w,O,V,j,F,B){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:V,thisArg:j,description:F,extension:B}),w&&Be(this,o,"f").$registerCommand(O),new A.Disposable(()=>{this.b.delete(O)&&w&&Be(this,o,"f").$unregisterCommand(O)})}executeCommand(w,...O){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,O,!0)}async g(w,O,V){if(this.b.has(w))return Be(this,o,"f").$fireCommandActivationEvent(w),this.h(w,O,!1);{let j=!1;const F=(0,R.cloneAndChange)(O,function(B){if(B instanceof A.Position)return l.Position.from(B);if(B instanceof A.Range)return l.Range.from(B);if(B instanceof A.Location)return l.location.from(B);if(A.NotebookRange.isNotebookRange(B))return l.NotebookRange.from(B);if(B instanceof ArrayBuffer)return j=!0,u.VSBuffer.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return j=!0,u.VSBuffer.wrap(B);if(B instanceof u.VSBuffer)return j=!0,B;if(!Array.isArray(B))return B});try{const B=await Be(this,o,"f").$executeCommand(w,j?new g.SerializableObjectWithBuffers(F):F,V);return(0,k.revive)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(w,O,!1);throw B}}}async h(w,O,V){const j=this.b.get(w);if(!j)throw new Error("Unknown command");const{callback:F,thisArg:B,description:N}=j;if(N)for(let $=0;$<N.args.length;$++)try{(0,a.validateConstraint)(O[$],N.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${N.args[$].name}' - ${N.args[$].description}`)}const U=D.StopWatch.create();try{return await F.apply(B,O)}catch($){if(w===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...O);z&&(w=z.command)}if(this.d.error($,w,j.extension?.identifier),!V)throw $;if(j.extension?.identifier){const z=Be(this,c,"f").onExtensionError(j.extension.identifier,$);this.d.trace("forwarded error to extension?",z,j.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)($)),this.id=w,this.source=j.extension?.displayName??j.extension?.name}}}finally{this.j(j,w,U.elapsed())}}j(w,O,V){!w.extension||Be(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new p.TelemetryTrustedValue(O),duration:V})}$executeContributedCommand(w,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const V=this.b.get(w);return V?(O=O.map(j=>this.f.reduce((F,B)=>B.processArgument(F,V.extension?.identifier),j)),this.h(w,O,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),Be(this,o,"f").$getCommands().then(O=>(w&&(O=O.filter(V=>V[0]!=="_")),O))}$getContributedCommandHandlerDescriptions(){const w=Object.create(null);for(const[O,V]of this.b){const{description:j}=V;j&&(w[O]=j)}return Promise.resolve(w)}};o=new WeakMap,r=new WeakMap,c=new WeakMap,s=xe([We(0,h.IExtHostRpcService),We(1,S.ILogService),We(2,i.IExtHostTelemetry)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,y.createDecorator)("IExtHostCommands");class m{constructor(w,O,V){this.d=w,this.f=O,this.g=V,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,O){if(!w)return;const V={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return V;const j=this.f(w.command);if(j)V.id=j.internalId,V.arguments=j.args.map((F,B)=>F.convert(w.arguments&&w.arguments[B]));else if((0,P.isNonEmptyArray)(w.arguments)){const F=`${w.command}/${++this.c}`;this.b.set(F,w),O.add((0,I.toDisposable)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),V.$ident=F,V.id=this.delegatingCommandId,V.arguments=[F],this.g.trace("CommandsConverter#CREATE",w.command,F)}return V}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const O=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.CommandsConverter=m;class n{constructor(w,O,V,j){this.name=w,this.description=O,this.validate=V,this.convert=j}optional(){return new n(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,O){return new n(w??this.name,O??this.description,this.validate,this.convert)}}n.Uri=new n("uri","Uri of a text document",E=>v.URI.isUri(E),E=>E),n.Position=new n("position","A position in a text document",E=>A.Position.isPosition(E),l.Position.from),n.Range=new n("range","A range in a text document",E=>A.Range.isRange(E),l.Range.from),n.Selection=new n("selection","A selection in a text document",E=>A.Selection.isSelection(E),l.Selection.from),n.Number=new n("number","",E=>typeof E=="number",E=>E),n.String=new n("string","",E=>typeof E=="string",E=>E),n.CallHierarchyItem=new n("item","A call hierarchy item",E=>E instanceof A.CallHierarchyItem,l.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",E=>E instanceof A.TypeHierarchyItem,l.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",E=>E instanceof d.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=n;class t{constructor(w,O){this.description=w,this.convert=O}}t.Void=new t("no result",E=>E),e.ApiCommandResult=t;class f{constructor(w,O,V,j,F){this.id=w,this.internalId=O,this.description=V,this.args=j,this.result=F}}e.ApiCommand=f}),define(De[252],Ce([1,0,2,14,7,71,40,15,120,125,16]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(A.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,d)=>{if((0,P.isFalsyOrEmpty)(h))return;class u extends l.SymbolInformation{static to(b){const D=new u(b.name,A.SymbolKind.to(b.kind),b.containerName||"",new l.Location(d[0],A.Range.to(b.range)));return D.detail=b.detail,D.range=D.location.range,D.selectionRange=A.Range.to(b.selectionRange),D.children=b.children?b.children.map(u.to):[],D}}return h.map(u.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(A.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(A.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(d=>l.Position.isPosition(d)),h=>h.map(A.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(d=>{let u;for(const g of d.reverse())u=new l.SelectionRange(A.Range.to(g),u);return u}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(A.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(A.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(A.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(A.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:A.Range.to(h.range),placeholder:h.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return A.WorkspaceEdit.to(h)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(A.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new l.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,S.decodeSemanticTokensDto)(h);if(d.type==="full")return new l.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new l.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,S.decodeSemanticTokensDto)(h);if(d.type==="full")return new l.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,d,u)=>{if(!h)return new l.CompletionList([]);const g=h.suggestions.map(b=>A.CompletionItem.to(b,u));return new l.CompletionList(g,h.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return A.SignatureHelp.to(h)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,d,u)=>I(g=>new l.CodeLens(A.Range.to(g.range),g.command&&u.fromInternal(g.command)))(h))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>l.Range.isRange(h),h=>l.Selection.isSelection(h)?A.Selection.from(h):A.Range.from(h)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,d,u)=>I(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const b=new l.CodeAction(g.title,g.kind?new l.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=A.WorkspaceEdit.to(g.edit)),g.command&&(b.command=u.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(h))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(d=>new l.ColorInformation(A.Range.to(d.range),A.Color.to(d.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",h=>h instanceof l.Color,A.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:A.Range.from(h.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(A.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,d,u)=>h.map(A.InlayHint.to.bind(void 0,u)))),new C.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(h,d)=>{if(h)return h.map(A.FoldingRange.to)})),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(d=>A.NotebookExclusiveDocumentPattern.to(d))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(A.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>a.URI.isUri(h)||typeof h=="string"&&(0,k.matchesSomeScheme)(h,L.Schemas.http,L.Schemas.https),h=>h),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[A.ViewColumn.from(h),void 0]:[A.ViewColumn.from(h.viewColumn),A.TextEditorOpenOptions.from(h)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[A.ViewColumn.from(h),void 0]:[A.ViewColumn.from(h.viewColumn),A.TextEditorOpenOptions.from(h)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[A.ViewColumn.from(h.viewColumn),A.TextEditorOpenOptions.from(h)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,h=>h)],C.ApiCommandResult.Void)];class v{static register(d){T.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function I(h){return d=>{if(Array.isArray(d))return d.map(h)}}function y(h){if(!Array.isArray(h))return;const d=[];for(const u of h)R.isLocationLink(u)?d.push(A.DefinitionLink.to(u)):d.push(A.location.to(u));return d}}),define(De[253],Ce([1,0,19,62,3,6,2,71,26,14,7,5]),function(ne,e,a,A,l,R,C,P,S,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(I,y,h){const d=I.getProxy(T.MainContext.MainThreadComments);class u{constructor(){this.b=new Map,this.c=new Map,y.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const m=this.b.get(s.handle);return m?m.value:s}else if(s&&s.$mid===7){const m=this.b.get(s.commentControlHandle);if(!m)return s;const n=m.getCommentThread(s.commentThreadHandle);return n?n.value:s}else if(s&&(s.$mid===9||s.$mid===8)){const m=this.b.get(s.thread.commentControlHandle);if(!m)return s;const n=m.getCommentThread(s.thread.commentThreadHandle);return n?s.$mid===8?n.value:{thread:n.value,text:s.text}:s}else if(s&&s.$mid===10){const m=this.b.get(s.thread.commentControlHandle);if(!m)return s;const n=m.getCommentThread(s.thread.commentThreadHandle);if(!n)return s;const t=s.commentUniqueId,f=n.getCommentByUniqueId(t);return f||s}else if(s&&s.$mid===11){const m=this.b.get(s.thread.commentControlHandle);if(!m)return s;const n=m.getCommentThread(s.thread.commentThreadHandle);if(!n)return s;const t=s.text,f=s.commentUniqueId,E=n.getCommentByUniqueId(f);return E?(typeof E.body=="string"?E.body=t:E.body=new L.MarkdownString(t),E):s}return s}})}createCommentController(s,m,n){const t=u.a++,f=new b(s,t,m,n);this.b.set(f.handle,f);const E=this.c.get(S.ExtensionIdentifier.toKey(s.identifier))||[];return E.push(f),this.c.set(S.ExtensionIdentifier.toKey(s.identifier),E),f.value}$createCommentThreadTemplate(s,m,n){const t=this.b.get(s);!t||t.$createCommentThreadTemplate(m,n)}async $updateCommentThreadTemplate(s,m,n){const t=this.b.get(s);!t||t.$updateCommentThreadTemplate(m,n)}$deleteCommentThread(s,m){this.b.get(s)?.$deleteCommentThread(m)}$provideCommentingRanges(s,m,n){const t=this.b.get(s);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const f=h.getDocument(C.URI.revive(m));return(0,a.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(f,n)).then(E=>E?E.map(w=>k.Range.from(w)):void 0)}$toggleReaction(s,m,n,t,f){const E=this.b.get(s);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const w=E.getCommentThread(m);if(w){const O=w.getCommentByUniqueId(t.uniqueIdInThread);if(E!==void 0&&O&&E.reactionHandler)return E.reactionHandler(O,i(f))}return Promise.resolve(void 0)})}dispose(){}}u.a=0;class g{set threadId(s){this.n=s}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(s){s.isEqual(this.p)||(this.p=s,this.b.range=s,this.c.fire())}get range(){return this.p}set canReply(s){this.d!==s&&(this.d=s,this.b.canReply=s,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(s){this.e=s,this.b.label=s,this.c.fire()}get contextValue(){return this.f}set contextValue(s){this.f=s,this.b.contextValue=s,this.c.fire()}get comments(){return this.q}set comments(s){this.q=s,this.b.comments=s,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(s){this.g=s,this.b.collapsibleState=s,this.c.fire()}get state(){return this.h}set state(s){this.h=s,this.b.state=s,this.c.fire()}get isDisposed(){return this.j}constructor(s,m,n,t,f,E,w,O){this.m=m,this.n=n,this.o=t,this.p=f,this.q=E,this.extensionDescription=w,this.r=O,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${s}.${this.handle}`),d.$createCommentThread(m,this.handle,this.n,this.o,k.Range.from(this.p),w.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{d.$deleteCommentThread(m,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(j){V.range=j},get comments(){return V.comments},set comments(j){V.comments=j},get collapsibleState(){return V.collapsibleState},set collapsibleState(j){V.collapsibleState=j},get canReply(){return V.canReply},set canReply(j){V.canReply=j},get contextValue(){return V.contextValue},set contextValue(j){V.contextValue=j},get label(){return V.label},set label(j){V.label=j},get state(){return V.state},set state(j){V.state=j},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const s=n=>Object.prototype.hasOwnProperty.call(this.b,n),m={};s("range")&&(m.range=k.Range.from(this.p)),s("label")&&(m.label=this.label),s("contextValue")&&(m.contextValue=this.contextValue??null),s("comments")&&(m.comments=this.q.map(n=>D(this,n,this.k))),s("collapsibleState")&&(m.collapseState=o(this.g)),s("canReply")&&(m.canReply=this.canReply),s("state")&&(m.state=r(this.h)),s("isTemplate")&&(m.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(s){for(const m of this.k){const n=m[0],t=m[1];if(s===t)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(s=>s.dispose())}}g.a=0,xe([(0,A.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(s){this.b=s,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(s){this.c=s,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this.d}set options(s){this.d=s,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(s,m,n,t){this.f=s,this.g=m,this.h=n,this.i=t,this.a=new Map,d.$registerCommentController(this.handle,n,t);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(E){f.options=E},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(E){f.commentingRangeProvider=E},get reactionHandler(){return f.reactionHandler},set reactionHandler(E){f.reactionHandler=E},createCommentThread(E,w,O){return f.createCommentThread(E,w,O).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(s,m,n,t){if(typeof s=="string"){const f=new g(this.id,this.handle,s,m,n,t,this.f,!1);return this.a.set(f.handle,f),f}else{const f=new g(this.id,this.handle,void 0,s,m,n,this.f,!1);return this.a.set(f.handle,f),f}}$createCommentThreadTemplate(s,m){const n=new g(this.id,this.handle,void 0,C.URI.revive(s),k.Range.to(m),[],this.f,!0);return n.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(s,m){const n=this.a.get(s);n&&(n.range=k.Range.to(m))}$deleteCommentThread(s){this.a.get(s)?.dispose(),this.a.delete(s)}getCommentThread(s){return this.a.get(s)}dispose(){this.a.forEach(s=>{s.dispose()}),this.e.forEach(s=>s.dispose())}}function D(c,s,m){let n=m.get(s);n||(n=++c.commentHandle,m.set(s,n));const t=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:n,body:typeof s.body=="string"?s.body:k.MarkdownString.from(s.body),userName:s.author.name,userIconPath:t,label:s.label,commentReactions:s.reactions?s.reactions.map(f=>p(f)):void 0,timestamp:s.timestamp?.toJSON()}}function p(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function i(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function o(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function r(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new u}e.createExtHostComments=v}),define(De[254],Ce([1,0,23,5,25,20]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(L,T){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=T.consoleForward.includeStack,this.c=T.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,T){const v=this,I=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,T,I,arguments)}})}e(L,T,v,I){this.a.$logExtensionHostMessage({type:"__$console",severity:T,arguments:S(I,this.b)}),this.c&&this.f(L,v,I)}};C=xe([We(0,R.IExtHostRpcService),We(1,l.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const P=1e5;function S(k,L){const T=[];if(k.length)for(let v=0;v<k.length;v++){let I=k[v];if(typeof I>"u")I="undefined";else if(I instanceof Error){const y=I;y.stack?I=y.stack:I=y.toString()}T.push(I)}if(L){const v=new Error().stack;v&&T.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,a.safeStringify)(T);return v.length>P?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(De[139],Ce([1,0,2,5,7,4,20,13,15,8,11,27]),function(ne,e,a,A,l,R,C,P,S,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(y,h){this.h=h,this.f=new Map,this.g=y.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(y,h){const d=Mi.c++;this.f.set(d,{provider:y,extensionDescription:h}),this.g.$registerDecorationProvider(d,h.identifier.value);const u=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(d,null);return}const b=(0,S.asArray)(g);if(b.length<=Mi.d){this.g.$onDidChange(d,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",h.identifier.value,b.length);const D=b.map(o=>({uri:o,rank:(0,k.count)(o.path,"/")})),p=(0,S.groupBy)(D,(o,r)=>o.rank-r.rank||(0,k.compare)(o.uri.path,r.uri.path)),i=[];e:for(const o of p){let r;for(const c of o){const s=(0,L.dirname)(c.uri.path);if(r!==s&&(r=s,i.push(c.uri)>=Mi.d))break e}}this.g.$onDidChange(d,i)});return new l.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(y,h,d){if(!this.f.has(y))return Object.create(null);const u=Object.create(null),{provider:g,extensionDescription:b}=this.f.get(y);return await Promise.all(h.map(async D=>{try{const{uri:p,id:i}=D,o=await Promise.resolve(g.provideFileDecoration(a.URI.revive(p),d));if(!o)return;try{l.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,T.checkProposedApiEnabled)(b,"codiconDecoration"),u[i]=[o.propagate,o.tooltip,o.badge,o.color]}catch(r){this.h.warn(`INVALID decoration from extension '${b}': ${r}`)}}catch(p){this.h.error(p)}})),u}};v.c=0,v.d=250,v=xe([We(0,C.IExtHostRpcService),We(1,P.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[255],Ce([1,0,177,124,2,5,7,14,3,13,28,48]),function(ne,e,a,A,l,R,C,P,S,k,L,T){"use strict";var v,I,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(g,b,D,p,i,o,r){this.d=g,this.e=b,this.f=D,this.g=p,v.set(this,void 0),I.set(this,void 0),y.set(this,void 0),this.c=!1,Ze(this,y,new L.ResourceMap(c=>i.getComparisonKey(c)),"f"),Ze(this,v,o,"f"),Ze(this,I,r,"f")}dispose(){this.c||(Be(this,I,"f").fire([...Be(this,y,"f").keys()]),Be(this,v,"f")?.$clear(this.e),Be(this,y,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,b){if(!g){this.clear();return}this.h();let D=[];if(l.URI.isUri(g)){if(!b){this.delete(g);return}Be(this,y,"f").set(g,b.slice()),D=[g]}else if(Array.isArray(g)){D=[];let i;g=[...g].sort(h.j);for(const o of g){const[r,c]=o;if((!i||r.toString()!==i.toString())&&(i&&Be(this,y,"f").get(i).length===0&&Be(this,y,"f").delete(i),i=r,D.push(r),Be(this,y,"f").set(r,[])),c)Be(this,y,"f").get(r)?.push(...c);else{const s=Be(this,y,"f").get(r);s&&(s.length=0)}}}if(Be(this,I,"f").fire(D),!Be(this,v,"f"))return;const p=[];for(const i of D){let o=[];const r=Be(this,y,"f").get(i);if(r)if(r.length>this.f){o=[];const c=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const m of r)if(m.severity===c[s]&&o.push({...P.Diagnostic.from(m),modelVersionId:this.g(i)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=r.map(c=>({...P.Diagnostic.from(c),modelVersionId:this.g(i)}));p.push([i,o])}Be(this,v,"f").$changeMany(this.e,p)}delete(g){this.h(),Be(this,I,"f").fire([g]),Be(this,y,"f").delete(g),Be(this,v,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Be(this,I,"f").fire([...Be(this,y,"f").keys()]),Be(this,y,"f").clear(),Be(this,v,"f")?.$clear(this.e)}forEach(g,b){this.h();for(const[D,p]of this)g.call(b,D,p,this)}*[(v=new WeakMap,I=new WeakMap,y=new WeakMap,Symbol.iterator)](){this.h();for(const g of Be(this,y,"f").keys())yield[g,this.get(g)]}get(g){this.h();const b=Be(this,y,"f").get(g);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(g){return this.h(),Array.isArray(Be(this,y,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,b){return g[0].toString()<b[0].toString()?-1:g[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=h;let d=class pi{static _mapper(g){const b=new L.ResourceMap;for(const D of g)b.set(D,D);return{uris:Object.freeze(Array.from(b.values()))}}constructor(g,b,D,p){this.h=b,this.j=D,this.k=p,this.f=new Map,this.g=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,b){const{f:D,e:p,g:i,h:o,j:r,k:c}=this,s=new class{$changeMany(t,f){p.$changeMany(t,f),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,t,f.length===0?"CLEARING":f)}$clear(t){p.$clear(t),o.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,t)}dispose(){p.dispose()}};let m;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,m=b;else if(!D.has(b))m=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do m=b+pi.c++;while(D.has(m))}return new class extends h{constructor(){super(b,m,pi.d,t=>c.getDocument(t)?.version,r.extUri,s,i),D.set(m,this)}dispose(){super.dispose(),D.delete(m)}}}getDiagnostics(g){if(g)return this.l(g);{const b=new Map,D=[];for(const p of this.f.values())p.forEach((i,o)=>{let r=b.get(i.toString());typeof r>"u"&&(r=D.length,b.set(i.toString(),r),D.push([i,[]])),D[r][1]=D[r][1].concat(...o)});return D}}l(g){let b=[];for(const D of this.f.values())D.has(g)&&(b=b.concat(D.get(g)));return b}$acceptMarkersChange(g){if(!this.m){const b="_generated_mirror",D=new h(b,b,pi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(b,D),this.m=D}for(const[b,D]of g)this.m.set(l.URI.revive(b),D.map(P.Diagnostic.to))}};d.c=0,d.d=1e3,d=xe([We(1,k.ILogService),We(2,T.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(De[256],Ce([1,0,2,5,27]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(P){this.a=P.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(P,S){return S?.allowUIResources&&(0,l.checkProposedApiEnabled)(P,"showLocal"),this.a.$showOpenDialog(S).then(k=>k?k.map(L=>a.URI.revive(L)):void 0)}showSaveDialog(P){return this.a.$showSaveDialog(P).then(S=>S?a.URI.revive(S):void 0)}}e.ExtHostDialogs=R}),define(De[257],Ce([1,0,12,2,7,5,16,21,8]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(T,v,I){this.d=v,this.e=I,this.b=new Map,this.c=T.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,v){if(Object.keys(C.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const I=k.a++;this.b.set(I,v),this.c.$registerTextContentProvider(I,T);let y;return typeof v.onDidChange=="function"&&(y=v.onDidChange(h=>{if(h.scheme!==T){this.e.warn(`Provider for scheme '${T}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this.d.getDocument(h)&&this.$provideTextDocumentContent(I,h).then(d=>{if(!d&&typeof d!="string")return;const u=this.d.getDocument(h);if(!u)return;const g=(0,S.splitLines)(d);if(!u.equalLines(g))return this.c.$onVirtualDocumentChange(h,d)},a.onUnexpectedError)})),new l.Disposable(()=>{this.b.delete(I)&&this.c.$unregisterTextContentProvider(I),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(T,v){const I=this.b.get(T);return I?Promise.resolve(I.provideTextDocumentContent(A.URI.revive(v),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}k.a=0,e.ExtHostDocumentContentProvider=k}),define(De[258],Ce([1,0,3,6,2,5,135,14,9,23,7]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(I,y){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=I.getProxy(R.MainContext.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(h=>{for(const d of h)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const d of h)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(I){if(!I)return;const y=this.g.getDocument(I);if(y)return y}getDocument(I){const y=this.getDocumentData(I);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return y.document}ensureDocumentData(I){const y=this.g.getDocument(I);if(y)return Promise.resolve(y);let h=this.h.get(I.toString());return h||(h=this.f.$tryOpenDocument(I).then(d=>{this.h.delete(I.toString());const u=l.URI.revive(d);return(0,S.assertIsDefined)(this.g.getDocument(u))},d=>(this.h.delete(I.toString()),Promise.reject(d))),this.h.set(I.toString(),h)),h}createDocumentData(I){return this.f.$tryCreateDocument(I).then(y=>l.URI.revive(y))}$acceptModelLanguageChanged(I,y){const h=l.URI.revive(I),d=this.g.getDocument(h);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(y),this.a.fire(d.document)}$acceptModelSaved(I){const y=l.URI.revive(I),h=this.g.getDocument(y);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(I,y){const h=l.URI.revive(I),d=this.g.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(y),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,y,h){const d=l.URI.revive(I),u=this.g.getDocument(d);if(!u)throw new Error("unknown document");u._acceptIsDirty(h),u.onEvents(y);let g;y.isUndoing?g=L.TextDocumentChangeReason.Undo:y.isRedoing&&(g=L.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:u.document,contentChanges:y.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:g}))}setWordDefinitionFor(I,y){(0,C.setWordDefinitionFor)(I,y)}}e.ExtHostDocuments=T}),define(De[59],Ce([1,0,50,3,6,2,4,5,135,20,138,14,13,28,16,64,65]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(D,p){this.h=D,this.i=p,this.a=null,this.b=new Map,this.c=new I.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const p=[],i=[],o=[];if(D.removedDocuments)for(const r of D.removedDocuments){const c=R.URI.revive(r),s=this.c.get(c);s?.unref()&&(this.c.delete(c),p.push(s.value))}if(D.addedDocuments)for(const r of D.addedDocuments){const c=R.URI.revive(r.uri);let s=this.c.get(c);if(s&&c.scheme!==y.Schemas.vscodeNotebookCell&&c.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);s||(s=new u(new S.ExtHostDocumentData(this.h.getProxy(P.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(c,s),i.push(s.value)),s.ref()}if(D.removedEditors)for(const r of D.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&o.push(c)}if(D.addedEditors)for(const r of D.addedEditors){const c=R.URI.revive(r.documentUri);a.ok(this.c.has(c),`document '${c}' does not exist`),a.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const s=this.c.get(c).value,m=new L.ExtHostTextEditor(r.id,this.h.getProxy(P.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>s.document),r.selections.map(T.Selection.to),r.options,r.visibleRanges.map(n=>T.Range.to(n)),typeof r.editorPosition=="number"?T.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,m)}D.newActiveEditor!==void 0&&(a.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(o),D.removedDocuments&&this.e.fire(p),D.addedDocuments&&this.d.fire(i),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return h.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const p=this.b.get(this.a);return D?p:p?.value}allEditors(){return[...this.b.values()]}};g=xe([We(0,k.IExtHostRpcService),We(1,v.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[60],Ce([1,0,14,5,2,3,4,7,20,9,61]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class T{constructor(d,u,g){this.e=g,this.d=u,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,u={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.TextTabInput(l.URI.revive(this.b.input.uri));case 2:return new P.TextDiffTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new P.TextMergeTabInput(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new P.CustomEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.WebviewEditorTabInput(this.b.input.viewType);case 4:return new P.NotebookEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,u){this.c=[],this.d="",this.b=d,this.e=u;for(const g of d.tabs)g.isActive&&(this.d=g.id),this.c.push(new T(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,u={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return a.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(g=>g.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(g=>g.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const g=new T(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,g),d.tabDto.isActive&&(this.d=g.tabId),g}else if(d.kind===1){const g=this.c.splice(d.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(d.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,g),g}const u=this.c.find(g=>g.tabId===d.tabDto.id);if(!u)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(d.tabDto),u}activeTabId(){return this.d}}let I=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,u={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(g=>g.apiObject))},get activeTabGroup(){const g=d.d;return(0,k.assertIsDefined)(d.e.find(D=>D.groupId===g)?.apiObject)},close:async(g,b)=>{const D=Array.isArray(g)?g:[g];return D.length?y(D[0])?this.j(D,b):this.i(D,b):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(d){const u=new Set(this.e.map(r=>r.groupId)),g=new Set(d.map(r=>r.groupId)),b=(0,L.diffSets)(u,g),D=this.e.filter(r=>b.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],i=[];this.e=d.map(r=>{const c=new v(r,()=>this.d);return b.added.includes(c.groupId)?p.push(c.apiObject):i.push(c.apiObject),c});const o=(0,k.assertIsDefined)(d.find(r=>r.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:p,closed:D,changed:i}))}$acceptTabGroupUpdate(d){const u=this.e.find(g=>g.groupId===d.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const u=this.e.find(b=>b.groupId===d.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const g=u.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(d){for(const u of this.e)for(const g of u.tabs)if(g.apiObject===d)return g}h(d){return this.e.find(u=>u.apiObject===d)}async i(d,u){const g=[];for(const b of d){const D=this.g(b);if(!D)throw new Error("Tab close: Invalid tab not found!");g.push(D.tabId)}return this.a.$closeTab(g,u)}async j(d,u){const g=[];for(const b of d){const D=this.h(b);if(!D)throw new Error("Group close: Invalid group not found!");g.push(D.groupId)}return this.a.$closeGroup(g,u)}};I=xe([We(0,S.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function y(h){return h.tabs!==void 0}}),define(De[259],Ce([1,0,2,5,6,7,14,154,8,22,27]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this.a=[]}add(y){this.b=void 0,this.a.push(y)}delete(y){const h=this.a.indexOf(y);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const y=this.a.sort(),h=[];let d,u,g=14,b=14;for(const D of y){let p=d?(0,S.commonPrefixLength)(d,D):0;for(p===0?u=1:u=b;p<D.length;p++)p+1===D.length?(g=b,b=9):b+=1,h.push([u,D.toUpperCase().charCodeAt(p),b]),h.push([u,D.toLowerCase().charCodeAt(p),b]),u=b;d=D,b=g}h.push([9,58,10]),h.push([10,47,12]),this.b=new P.StateMachine(h)}}provideDocumentLinks(y){this.c();const h=[],d=P.LinkComputer.computeLinks({getLineContent(u){return y.lineAt(u-1).text},getLineCount(){return y.lineCount}},this.b);for(const u of d){const g=C.DocumentLink.to(u);g.target&&h.push(g)}return h}}class v{constructor(y,h){this.i=h,this.b=new T,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=y.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(y,h,d,u={}){if(this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(y,"*",this.b));const g=this.h++;this.b.add(h),this.d.add(h),this.c.set(g,d);let b=2;u.isCaseSensitive&&(b+=1024),u.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(y,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(g,h,b).catch(p=>{console.error(`FAILED to register filesystem provider of ${y.identifier.value}-extension for the scheme ${h}`),console.error(p)});const D=d.onDidChangeFile(p=>{const i=[];for(const o of p){const{uri:r,type:c}=o;if(r.scheme!==h)continue;let s;switch(c){case R.FileChangeType.Changed:s=0;break;case R.FileChangeType.Created:s=1;break;case R.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:s})}this.a.$onFileSystemChange(g,i)});return(0,l.toDisposable)(()=>{D.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(y){const{type:h,ctime:d,mtime:u,size:g,permissions:b}=y;return{type:h,ctime:d,mtime:u,size:g,permissions:b}}$stat(y,h){return Promise.resolve(this.k(y).stat(a.URI.revive(h))).then(d=>v.j(d))}$readdir(y,h){return Promise.resolve(this.k(y).readDirectory(a.URI.revive(h)))}$readFile(y,h){return Promise.resolve(this.k(y).readFile(a.URI.revive(h))).then(d=>k.VSBuffer.wrap(d))}$writeFile(y,h,d,u){return Promise.resolve(this.k(y).writeFile(a.URI.revive(h),d.buffer,u))}$delete(y,h,d){return Promise.resolve(this.k(y).delete(a.URI.revive(h),d))}$rename(y,h,d,u){return Promise.resolve(this.k(y).rename(a.URI.revive(h),a.URI.revive(d),u))}$copy(y,h,d,u){const g=this.k(y);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(a.URI.revive(h),a.URI.revive(d),u))}$mkdir(y,h){return Promise.resolve(this.k(y).createDirectory(a.URI.revive(h)))}$watch(y,h,d,u){const g=this.k(y).watch(a.URI.revive(d),u);this.f.set(h,g)}$unwatch(y,h){const d=this.f.get(h);d&&(d.dispose(),this.f.delete(h))}$open(y,h,d){const u=this.k(y);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(a.URI.revive(h),d))}$close(y,h){const d=this.k(y);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(h))}$read(y,h,d,u){const g=this.k(y);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(u);return Promise.resolve(g.read(h,d,b.buffer,0,u)).then(D=>b.slice(0,D))}$write(y,h,d,u){const g=this.k(y);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(h,d,u.buffer,0,u.byteLength))}k(y){const h=this.c.get(y);if(!h){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return h}}e.ExtHostFileSystem=v}),define(De[78],Ce([1,0,5,44,7,22,4,20,48,6]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Jt{constructor(v,I){this.b=new Map,this.a=v.getProxy(a.MainContext.MainThreadFileSystem);const y=this;this.value=Object.freeze({async stat(h){try{const d=y.b.get(h.scheme);if(!d)return await y.a.$stat(h);await y.a.$ensureActivation(h.scheme);const u=await d.stat(h);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(d){Jt.c(d)}},async readDirectory(h){try{const d=y.b.get(h.scheme);return d?(await y.a.$ensureActivation(h.scheme),(await d.readDirectory(h)).slice()):await y.a.$readdir(h)}catch(d){return Jt.c(d)}},async createDirectory(h){try{return await y.a.$mkdir(h)}catch(d){return Jt.c(d)}},async readFile(h){try{const d=y.b.get(h.scheme);return d?(await y.a.$ensureActivation(h.scheme),(await d.readFile(h)).slice()):(await y.a.$readFile(h)).buffer}catch(d){return Jt.c(d)}},async writeFile(h,d){try{return await y.a.$writeFile(h,R.VSBuffer.wrap(d))}catch(u){return Jt.c(u)}},async delete(h,d){try{const u=y.b.get(h.scheme);return u?(await y.a.$ensureActivation(h.scheme),await u.delete(h,{recursive:!1,...d})):await y.a.$delete(h,{recursive:!1,useTrash:!1,...d})}catch(u){return Jt.c(u)}},async rename(h,d,u){try{return await y.a.$rename(h,d,{overwrite:!1,...u})}catch(g){return Jt.c(g)}},async copy(h,d,u){try{return await y.a.$copy(h,d,{overwrite:!1,...u})}catch(g){return Jt.c(g)}},isWritableFileSystem(h){const d=I.getCapabilities(h);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof l.FileSystemError)throw v;if(!(v instanceof Error))throw new l.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(v.message);switch(v.name){case A.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(v.message);case A.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(v.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(v.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(v.message);case A.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(v.message);case A.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(v.message);default:throw new l.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,I){return this.b.set(v,I),(0,k.toDisposable)(()=>this.b.delete(v))}};L=xe([We(0,P.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(De[260],Ce([1,0,3,38,2,5,14,7]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(T,v,I,y,h,d,u,g){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const b=this.h(T,I,h);this.g=0,d&&(this.g+=1),u&&(this.g+=2),g&&(this.g+=4);const D=(0,A.parse)(h),p=typeof h=="string",i=y(o=>{if(!d)for(const r of o.created){const c=l.URI.revive(r);D(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.a.fire(c)}if(!u)for(const r of o.changed){const c=l.URI.revive(r);D(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.b.fire(c)}if(!g)for(const r of o.deleted){const c=l.URI.revive(r);D(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=P.Disposable.from(b,this.a,this.b,this.c,i)}h(T,v,I){const y=P.Disposable.from();if(typeof I=="string")return y;const h=T.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(I.pattern.includes(A.GLOBSTAR)||I.pattern.includes(A.GLOB_SPLIT))&&(d=!0);const u=Math.random();return h.$watch(v.identifier.value,u,I.baseUri,{recursive:d,excludes:[]}),P.Disposable.from({dispose:()=>h.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(T,v,I){this.j=T,this.k=v,this.l=I,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(T,v,I,y,h,d){return new S(this.j,T,v,this.a.event,C.GlobPattern.from(I),y,h,d)}$onFileEvent(T){this.a.fire(T)}$onDidRunFileOperation(T,v){switch(T){case 2:this.b.fire(Object.freeze({files:v.map(I=>({oldUri:l.URI.revive(I.source),newUri:l.URI.revive(I.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(I=>l.URI.revive(I.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(I=>l.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(T){return this.m(T,this.g)}getOnWillCreateFileEvent(T){return this.m(T,this.h)}getOnWillDeleteFileEvent(T){return this.m(T,this.i)}m(T,v){return(I,y,h)=>{const d=function(g){I.call(y,g)};return d.extension=T,v.event(d,void 0,h)}}async $onWillRunFileOperation(T,v,I,y){switch(T){case 2:return await this.n(this.g,{files:v.map(h=>({oldUri:l.URI.revive(h.source),newUri:l.URI.revive(h.target)}))},I,y);case 1:return await this.n(this.i,{files:v.map(h=>l.URI.revive(h.target))},I,y);case 0:case 3:return await this.n(this.h,{files:v.map(h=>l.URI.revive(h.target))},I,y)}}async n(T,v,I,y){const h=new Set,d=[];if(await T.fireAsync(v,y,async(g,b)=>{const D=Date.now(),p=await Promise.resolve(g);p instanceof P.WorkspaceEdit&&(d.push([b.extension,p]),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-D>I&&this.k.warn("SLOW file-participant",b.extension.identifier)}),y.isCancellationRequested||d.length===0)return;const u={edits:[]};for(const[,g]of d){const{edits:b}=C.WorkspaceEdit.from(g,{getTextDocumentVersion:D=>this.l.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(b)}return{edit:u,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=k}),define(De[261],Ce([1,0,2,40]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(C,P,S,k,L){this.a=P,this.b=S,this.c=k;const T=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new A.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new A.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new A.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new A.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const I=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri),notebookEditor:I.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri)}}));this.c.registerApiCommand(T)}$willAddInteractiveDocument(C,P,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,P){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=l}),define(De[262],Ce([1,0,6,5]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(C){this.b=0,this.a=C.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const P=this.b++;return this.a.$registerResourceLabelFormatter(P,C),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=l}),define(De[263],Ce([1,0,2,23,14,7,71,5,8,32,15,9,150,21,6,120,101,74,43,12,19,27]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(M,W){this.d=M,this.e=W}async provideDocumentSymbols(M,W){const G=this.d.getDocument(M),_=await this.e.provideDocumentSymbols(G,W);if(!(0,L.isFalsyOrEmpty)(_))return _[0]instanceof R.DocumentSymbol?_.map(l.DocumentSymbol.from):i.f(_)}static f(M){M=M.slice(0).sort((_,de)=>{let we=_.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(_.location.range.end)),we});const W=[],G=[];for(const _ of M){const de={name:_.name||"!!MISSING: name!!",kind:l.SymbolKind.from(_.kind),tags:_.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:l.Range.from(_.location.range),selectionRange:l.Range.from(_.location.range),children:[]};for(;;){if(G.length===0){G.push(de),W.push(de);break}const we=G[G.length-1];if(k.Range.containsRange(we.range,de.range)&&!k.Range.equalsRange(we.range,de.range)){we.children?.push(de),G.push(de);break}G.pop()}}return W}}class o{constructor(M,W,G){this.g=M,this.h=W,this.j=G,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(M,W){const G=this.g.getDocument(M),_=await this.j.provideCodeLenses(G,W);if(!_||W.isCancellationRequested)return;const de=this.e.add(_),we=new y.DisposableStore;this.f.set(de,we);const Ae={cacheId:de,lenses:[]};for(let be=0;be<_.length;be++)Ae.lenses.push({cacheId:[de,be],range:l.Range.from(_[be].range),command:this.h.toInternal(_[be].command,we)});return Ae}async resolveCodeLens(M,W){const G=M.cacheId&&this.e.get(...M.cacheId);if(!G)return;let _;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?_=G:_=await this.j.resolveCodeLens(G,W),_||(_=G),W.isCancellationRequested)return;const de=M.cacheId&&this.f.get(M.cacheId[0]);if(!!de)return M.command=this.h.toInternal(_.command??o.d,de),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}o.d={command:"missing",title:"!!MISSING: command!!"};function r(se){return Array.isArray(se)?se.map(l.DefinitionLink.from):se?[l.DefinitionLink.from(se)]:[]}class c{constructor(M,W){this.d=M,this.e=W}async provideDefinition(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideDefinition(_,de,G);return r(we)}}class s{constructor(M,W){this.d=M,this.e=W}async provideDeclaration(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideDeclaration(_,de,G);return r(we)}}class m{constructor(M,W){this.d=M,this.e=W}async provideImplementation(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideImplementation(_,de,G);return r(we)}}class n{constructor(M,W){this.d=M,this.e=W}async provideTypeDefinition(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideTypeDefinition(_,de,G);return r(we)}}class t{constructor(M,W){this.d=M,this.e=W}async provideHover(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideHover(_,de,G);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=_.getWordRangeAtPosition(de)),we.range||(we.range=new R.Range(de,de)),l.Hover.from(we)}}class f{constructor(M,W){this.d=M,this.e=W}async provideEvaluatableExpression(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideEvaluatableExpression(_,de,G);if(we)return l.EvaluatableExpression.from(we)}}class E{constructor(M,W){this.d=M,this.e=W}async provideInlineValues(M,W,G,_){const de=this.d.getDocument(M),we=await this.e.provideInlineValues(de,l.Range.to(W),l.InlineValueContext.to(G),_);if(Array.isArray(we))return we.map(Ae=>l.InlineValue.from(Ae))}}class w{constructor(M,W){this.d=M,this.e=W}async provideDocumentHighlights(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideDocumentHighlights(_,de,G);if(Array.isArray(we))return we.map(l.DocumentHighlight.from)}}class O{constructor(M,W){this.d=M,this.e=W}async provideLinkedEditingRanges(M,W,G){const _=this.d.getDocument(M),de=l.Position.to(W),we=await this.e.provideLinkedEditingRanges(_,de,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(l.Range.from)),wordPattern:we.wordPattern}}}class V{constructor(M,W){this.d=M,this.e=W}async provideReferences(M,W,G,_){const de=this.d.getDocument(M),we=l.Position.to(W),Ae=await this.e.provideReferences(de,we,G,_);if(Array.isArray(Ae))return Ae.map(l.location.from)}}class j{constructor(M,W,G,_,de,we,Ae){this.g=M,this.h=W,this.j=G,this.k=_,this.l=de,this.m=we,this.n=Ae,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(M,W,G,_){const de=this.g.getDocument(M),we=v.Selection.isISelection(W)?l.Selection.to(W):l.Range.to(W),Ae=[];for(const nt of this.j.getDiagnostics(M))if(we.intersection(nt.range)&&Ae.push(nt)>j.d)break;const be={diagnostics:Ae,only:G.only?new R.CodeActionKind(G.only):void 0,triggerKind:l.CodeActionTriggerKind.to(G.trigger)},Ie=await this.k.provideCodeActions(de,we,be,_);if(!(0,L.isNonEmptyArray)(Ie)||_.isCancellationRequested)return;const Te=this.e.add(Ie),Ve=new y.DisposableStore;this.f.set(Te,Ve);const Ge=[];for(let nt=0;nt<Ie.length;nt++){const Qe=Ie[nt];!Qe||(j.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,Ve)})):(be.only&&(Qe.kind?be.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[Te,nt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,Ve),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(l.Diagnostic.from),edit:Qe.edit&&l.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:Te,actions:Ge}}async resolveCodeAction(M,W){const[G,_]=M,de=this.e.get(G,_);if(!de||j.o(de)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(de,W)??de;return we?.edit?l.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static o(M){return typeof M.command=="string"&&typeof M.title=="string"}}j.d=1e3;class F{constructor(M,W,G,_){this.d=M,this.e=W,this.f=G,this.g=_}async prepareDocumentPaste(M,W,G,_){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(M),we=W.map(be=>l.Range.to(be)),Ae=l.DataTransfer.toDataTransfer(G,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(de,we,Ae,_),l.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(M,W,G,_,de){const we=this.e.getDocument(W),Ae=G.map(Te=>l.Range.to(Te)),be=l.DataTransfer.toDataTransfer(_,async Te=>(await this.d.$resolvePasteFileData(this.g,M,Te)).buffer),Ie=await this.f.provideDocumentPasteEdits(we,Ae,be,de);if(!!Ie)return{insertText:typeof Ie.insertText=="string"?Ie.insertText:{snippet:Ie.insertText.value},additionalEdit:Ie.additionalEdit?l.WorkspaceEdit.from(Ie.additionalEdit,void 0):void 0}}}class B{constructor(M,W){this.d=M,this.e=W}async provideDocumentFormattingEdits(M,W,G){const _=this.d.getDocument(M),de=await this.e.provideDocumentFormattingEdits(_,W,G);if(Array.isArray(de))return de.map(l.TextEdit.from)}}class N{constructor(M,W){this.d=M,this.e=W}async provideDocumentRangeFormattingEdits(M,W,G,_){const de=this.d.getDocument(M),we=l.Range.to(W),Ae=await this.e.provideDocumentRangeFormattingEdits(de,we,G,_);if(Array.isArray(Ae))return Ae.map(l.TextEdit.from)}}class U{constructor(M,W){this.d=M,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,W,G,_,de){const we=this.d.getDocument(M),Ae=l.Position.to(W),be=await this.e.provideOnTypeFormattingEdits(we,Ae,G,_,de);if(Array.isArray(be))return be.map(l.TextEdit.from)}}class ${constructor(M,W){this.e=M,this.f=W,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,W){const G=await this.e.provideWorkspaceSymbols(M,W);if(!(0,L.isNonEmptyArray)(G))return{symbols:[]};const _=this.d.add(G),de={cacheId:_,symbols:[]};for(let we=0;we<G.length;we++){const Ae=G[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}de.symbols.push({...l.WorkspaceSymbol.from(Ae),cacheId:[_,we]})}return de}async resolveWorkspaceSymbol(M,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this.d.get(...M.cacheId);if(G){const _=await this.e.resolveWorkspaceSymbol(G,W);return _&&(0,A.mixin)(M,l.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class z{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,W,G){this.d=M,this.e=W,this.f=G}async provideRenameEdits(M,W,G,_){const de=this.d.getDocument(M),we=l.Position.to(W);try{const Ae=await this.e.provideRenameEdits(de,we,G,_);return Ae?l.WorkspaceEdit.from(Ae):void 0}catch(Ae){const be=z.g(Ae);return be?{rejectReason:be,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(M,W,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(M),de=l.Position.to(W);try{const we=await this.e.prepareRename(_,de,G);let Ae,be;if(R.Range.isRange(we)?(Ae=we,be=_.getText(we)):(0,T.isObject)(we)&&(Ae=we.range,be=we.placeholder),!Ae||!be)return;if(Ae.start.line>de.line||Ae.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(Ae),text:be}}catch(we){const Ae=z.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class ae{constructor(M,W){this.resultId=M,this.tokens=W}}class ee{constructor(M,W){this.f=M,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,W,G){const _=this.f.getDocument(M),de=W!==0?this.d.get(W):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,de.resultId,G):await this.g.provideDocumentSemanticTokens(_,G);return de&&this.d.delete(W),we?(we=ee.h(we),this.o(ee.n(de,we),we)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return ee.j(M)?ee.k(M)?M:new R.SemanticTokens(new Uint32Array(M.data),M.resultId):ee.l(M)?ee.m(M)?M:new R.SemanticTokensEdits(M.edits.map(W=>new R.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const W of M.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(M,W){if(!ee.j(W)||!M||!M.tokens)return W;const G=M.tokens,_=G.length,de=W.data,we=de.length;let Ae=0;const be=Math.min(_,we);for(;Ae<be&&G[Ae]===de[Ae];)Ae++;if(Ae===_&&Ae===we)return new R.SemanticTokensEdits([],W.resultId);let Ie=0;const Te=be-Ae;for(;Ie<Te&&G[_-Ie-1]===de[we-Ie-1];)Ie++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:_-Ae-Ie,data:de.subarray(Ae,we-Ie)}],W.resultId)}o(M,W){if(ee.j(M)){const G=this.e++;return this.d.set(G,new ae(M.resultId,M.data)),(0,h.encodeSemanticTokensDto)({id:G,type:"full",data:M.data})}if(ee.l(M)){const G=this.e++;return ee.j(W)?this.d.set(G,new ae(W.resultId,W.data)):this.d.set(G,new ae(M.resultId)),(0,h.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(M.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class q{constructor(M,W){this.d=M,this.e=W}async provideDocumentRangeSemanticTokens(M,W,G){const _=this.d.getDocument(M),de=await this.e.provideDocumentRangeSemanticTokens(_,l.Range.to(W),G);return de?this.f(de):null}f(M){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}class J{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,W,G,_,de){this.f=M,this.g=W,this.h=G,this.j=_,this.k=de,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(M,W,G,_){const de=this.f.getDocument(M),we=l.Position.to(W),Ae=de.getWordRangeAtPosition(we)||new R.Range(we,we),be=Ae.with({end:we}),Ie=new g.StopWatch(!0),Te=await this.h.provideCompletionItems(de,we,_,l.CompletionContext.to(G));if(!Te||_.isCancellationRequested)return;const Ve=Array.isArray(Te)?new R.CompletionList(Te):Te,Ge=J.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),nt=new y.DisposableStore;this.e.set(Ge,nt);const Qe=[],it={x:Ge,b:Qe,a:{replace:l.Range.from(Ae),insert:l.Range.from(be)},c:Ve.isIncomplete||void 0,d:Ie.elapsed()};for(let rt=0;rt<Ve.items.length;rt++){const ct=Ve.items[rt],Me=this.l(ct,[Ge,rt],be,Ae);Qe.push(Me)}return it}async resolveCompletionItem(M,W){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...M);if(!G)return;const _=await this.h.resolveCompletionItem(G,W);if(!!_)return this.l(_,M)}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,W,G,_){const de=this.e.get(W[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(M.command,de),Ae={x:W,a:M.label,b:M.kind!==void 0?l.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(l.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:l.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(l.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=M.textEdit.newText):typeof M.insertText=="string"?Ae.h=M.insertText:M.insertText instanceof R.SnippetString&&(Ae.h=M.insertText.value,Ae.i|=4);let be;return M.textEdit?be=M.textEdit.range:M.range&&(be=M.range),R.Range.isRange(be)?Ae.j=l.Range.from(be):be&&(!G?.isEqual(be.inserting)||!_?.isEqual(be.replacing))&&(Ae.j={insert:l.Range.from(be.inserting),replace:l.Range.from(be.replacing)}),Ae}}class ie{async provideInlineCompletions(M,W,G,_){}disposeCompletions(M){}handleDidShowCompletionItem(M,W){}handlePartialAccept(M,W,G){}}class ge extends ie{constructor(M,W,G,_){super(),this.f=M,this.g=W,this.h=G,this.j=_,this.d=new X,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,W,G,_){const de=this.g.getDocument(M),we=l.Position.to(W),Ae=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:l.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},_);if(!Ae||_.isCancellationRequested)return;const be=Array.isArray(Ae)?Ae:Ae.items,Ie=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let Te;return{pid:this.d.createReferenceId({dispose(){Te?.dispose()},items:be}),items:be.map((Ge,nt)=>{let Qe;Ge.command&&(Te||(Te=new y.DisposableStore),Qe=this.j.toInternal(Ge.command,Te));const it=Ge.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:Ge.filterText,range:Ge.range?l.Range.from(Ge.range):void 0,command:Qe,idx:nt,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ie.map(Ge=>(Te||(Te=new y.DisposableStore),this.j.toInternal(Ge,Te)))}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,W){const G=this.d.get(M)?.items[W];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G)}handlePartialAccept(M,W,G){const _=this.d.get(M)?.items[W];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(_,G)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const W=this.e++;return this.d.set(W,M),W}disposeReferenceId(M){const W=this.d.get(M);return this.d.delete(M),W}get(M){return this.d.get(M)}}class Y{constructor(M,W){this.e=M,this.f=W,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(M,W,G,_){const de=this.e.getDocument(M),we=l.Position.to(W),Ae=this.g(G),be=await this.f.provideSignatureHelp(de,we,_,Ae);if(be){const Ie=this.d.add([be]);return{...l.SignatureHelp.from(be),id:Ie}}}g(M){let W;if(M.activeSignatureHelp){const G=l.SignatureHelp.to(M.activeSignatureHelp),_=this.d.get(M.activeSignatureHelp.id,0);_?(W=_,W.activeSignature=G.activeSignature,W.activeParameter=G.activeParameter):W=G}return{...M,activeSignatureHelp:W}}releaseSignatureHelp(M){this.d.delete(M)}}class Z{constructor(M,W,G,_,de){this.f=M,this.g=W,this.h=G,this.j=_,this.k=de,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(M,W,G){const _=this.f.getDocument(M),de=l.Range.to(W),we=await this.h.provideInlayHints(_,de,G);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(G.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new y.DisposableStore);const be={hints:[],cacheId:Ae};for(let Ie=0;Ie<we.length;Ie++)this.l(we[Ie],de)&&be.hints.push(this.m(we[Ie],[Ae,Ie]));return this.j.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),be}async resolveInlayHint(M,W){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...M);if(!G)return;const _=await this.h.resolveInlayHint(G,W);if(!!_&&!!this.l(_))return this.m(_,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,W){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(W&&!W.contains(M.position))}m(M,W){const G=this.e.get(W[0]);if(!G)throw Error("DisposableStore is missing...");const _={label:"",cacheId:W,tooltip:l.MarkdownString.fromStrict(M.tooltip),position:l.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(l.TextEdit.from),kind:M.kind&&l.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?_.label=M.label:_.label=M.label.map(de=>{const we={label:de.value};return we.tooltip=l.MarkdownString.fromStrict(de.tooltip),R.Location.isLocation(de.location)&&(we.location=l.location.from(de.location)),de.command&&(we.command=this.g.toInternal(de.command,G)),we}),_}}class fe{constructor(M,W){this.e=M,this.f=W,this.d=new u.Cache("DocumentLink")}async provideLinks(M,W){const G=this.e.getDocument(M),_=await this.f.provideDocumentLinks(G,W);if(!(!Array.isArray(_)||_.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(fe.g).map(l.DocumentLink.from)};{const de=this.d.add(_),we={links:[],cacheId:de};for(let Ae=0;Ae<_.length;Ae++){if(!fe.g(_[Ae]))continue;const be=l.DocumentLink.from(_[Ae]);be.cacheId=[de,Ae],we.links.push(be)}return we}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,W){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...M);if(!G)return;const _=await this.f.resolveDocumentLink(G,W);if(!(!_||!fe.g(_)))return l.DocumentLink.from(_)}releaseLinks(M){this.d.delete(M)}}class ve{constructor(M,W){this.d=M,this.e=W}async provideColors(M,W){const G=this.d.getDocument(M),_=await this.e.provideDocumentColors(G,W);return Array.isArray(_)?_.map(we=>({color:l.Color.from(we.color),range:l.Range.from(we.range)})):[]}async provideColorPresentations(M,W,G){const _=this.d.getDocument(M),de=l.Range.to(W.range),we=l.Color.to(W.color),Ae=await this.e.provideColorPresentations(we,{document:_,range:de},G);if(!!Array.isArray(Ae))return Ae.map(l.ColorPresentation.from)}}class ke{constructor(M,W){this.d=M,this.e=W}async provideFoldingRanges(M,W,G){const _=this.d.getDocument(M),de=await this.e.provideFoldingRanges(_,W,G);if(!!Array.isArray(de))return de.map(l.FoldingRange.from)}}class Oe{constructor(M,W,G){this.d=M,this.e=W,this.f=G}async provideSelectionRanges(M,W,G){const _=this.d.getDocument(M),de=W.map(l.Position.to),we=await this.e.provideSelectionRanges(_,de,G);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let be=0;be<de.length;be++){const Ie=[];Ae.push(Ie);let Te=de[be],Ve=we[be];for(;;){if(!Ve.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ie.push(l.SelectionRange.from(Ve)),!Ve.parent)break;Te=Ve.range,Ve=Ve.parent}}return Ae}}class oe{constructor(M,W){this.f=M,this.g=W,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(M,W,G){const _=this.f.getDocument(M),de=l.Position.to(W),we=await this.g.prepareCallHierarchy(_,de,G);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideCallsTo(M,W,G){const _=this.j(M,W);if(!_)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(_,G);if(!!de)return de.map(we=>({from:this.h(M,we.from),fromRanges:we.fromRanges.map(Ae=>l.Range.from(Ae))}))}async provideCallsFrom(M,W,G){const _=this.j(M,W);if(!_)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(_,G);if(!!de)return de.map(we=>({to:this.h(M,we.to),fromRanges:we.fromRanges.map(Ae=>l.Range.from(Ae))}))}releaseSession(M){this.e.delete(M)}h(M,W){const G=this.e.get(M),_=l.CallHierarchyItem.from(W,M,G.size.toString(36));return G.set(_._itemId,W),_}j(M,W){return this.e.get(M)?.get(W)}}class le{constructor(M,W){this.f=M,this.g=W,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(M,W,G){const _=this.f.getDocument(M),de=l.Position.to(W),we=await this.g.prepareTypeHierarchy(_,de,G);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideSupertypes(M,W,G){const _=this.j(M,W);if(!_)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(_,G);if(!!de)return de.map(we=>this.h(M,we))}async provideSubtypes(M,W,G){const _=this.j(M,W);if(!_)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(_,G);if(!!de)return de.map(we=>this.h(M,we))}releaseSession(M){this.e.delete(M)}h(M,W){const G=this.e.get(M),_=l.TypeHierarchyItem.from(W,M,G.size.toString(36));return G.set(_._itemId,W),_}j(M,W){return this.e.get(M)?.get(W)}}class ue{constructor(M,W,G,_){this.d=M,this.e=W,this.f=G,this.g=_}async provideDocumentOnDropEdits(M,W,G,_,de){const we=this.e.getDocument(W),Ae=l.Position.to(G),be=l.DataTransfer.toDataTransfer(_,async Te=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,Te)).buffer),Ie=await this.f.provideDocumentDropEdits(we,Ae,be,de);if(!!Ie)return{insertText:typeof Ie.insertText=="string"?Ie.insertText:{snippet:Ie.insertText.value},additionalEdit:Ie.additionalEdit?l.WorkspaceEdit.from(Ie.additionalEdit,void 0):void 0}}}class te{constructor(M,W){this.adapter=M,this.extension=W}}class ce{constructor(M,W,G,_,de,we,Ae,be){this.g=W,this.h=G,this.j=_,this.k=de,this.l=we,this.m=Ae,this.n=be,this.f=new Map,this.e=M.getProxy(P.MainContext.MainThreadLanguageFeatures)}o(M){return l.DocumentSelector.from(M,this.g)}p(M){return new R.Disposable(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return ce.d++}async s(M,W,G,_,de,we=!1){const Ae=this.f.get(M);if(!Ae||!(Ae.adapter instanceof W))return _;const be=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ie=G(Ae.adapter,Ae.extension);return Promise.resolve(Ie).catch(Te=>{(0,b.isCancellationError)(Te)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Te),this.n.onExtensionError(Ae.extension.identifier,Te))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),I.CancellationToken.isCancellationToken(de)?(0,D.raceCancellationError)(Ie,de):Ie}t(M,W){const G=this.q();return this.f.set(G,new te(M,W)),G}static u(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,W,G,_){const de=this.t(new i(this.h,G),M),we=_&&_.label||ce.u(M);return this.e.$registerDocumentSymbolProvider(de,this.o(W),we),this.p(de)}$provideDocumentSymbols(M,W,G){return this.s(M,i,_=>_.provideDocumentSymbols(a.URI.revive(W),G),void 0,G)}registerCodeLensProvider(M,W,G){const _=this.q(),de=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new te(new o(this.h,this.j.converter,G),M)),this.e.$registerCodeLensSupport(_,this.o(W),de);let we=this.p(_);if(de!==void 0){const Ae=G.onDidChangeCodeLenses(be=>this.e.$emitCodeLensEvent(de));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(M,W,G){return this.s(M,o,_=>_.provideCodeLenses(a.URI.revive(W),G),void 0,G)}$resolveCodeLens(M,W,G){return this.s(M,o,_=>_.resolveCodeLens(W,G),void 0,void 0)}$releaseCodeLenses(M,W){this.s(M,o,G=>Promise.resolve(G.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(M,W,G){const _=this.t(new c(this.h,G),M);return this.e.$registerDefinitionSupport(_,this.o(W)),this.p(_)}$provideDefinition(M,W,G,_){return this.s(M,c,de=>de.provideDefinition(a.URI.revive(W),G,_),[],_)}registerDeclarationProvider(M,W,G){const _=this.t(new s(this.h,G),M);return this.e.$registerDeclarationSupport(_,this.o(W)),this.p(_)}$provideDeclaration(M,W,G,_){return this.s(M,s,de=>de.provideDeclaration(a.URI.revive(W),G,_),[],_)}registerImplementationProvider(M,W,G){const _=this.t(new m(this.h,G),M);return this.e.$registerImplementationSupport(_,this.o(W)),this.p(_)}$provideImplementation(M,W,G,_){return this.s(M,m,de=>de.provideImplementation(a.URI.revive(W),G,_),[],_)}registerTypeDefinitionProvider(M,W,G){const _=this.t(new n(this.h,G),M);return this.e.$registerTypeDefinitionSupport(_,this.o(W)),this.p(_)}$provideTypeDefinition(M,W,G,_){return this.s(M,n,de=>de.provideTypeDefinition(a.URI.revive(W),G,_),[],_)}registerHoverProvider(M,W,G,_){const de=this.t(new t(this.h,G),M);return this.e.$registerHoverProvider(de,this.o(W)),this.p(de)}$provideHover(M,W,G,_){return this.s(M,t,de=>de.provideHover(a.URI.revive(W),G,_),void 0,_)}registerEvaluatableExpressionProvider(M,W,G,_){const de=this.t(new f(this.h,G),M);return this.e.$registerEvaluatableExpressionProvider(de,this.o(W)),this.p(de)}$provideEvaluatableExpression(M,W,G,_){return this.s(M,f,de=>de.provideEvaluatableExpression(a.URI.revive(W),G,_),void 0,_)}registerInlineValuesProvider(M,W,G,_){const de=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,G),M);this.e.$registerInlineValuesProvider(we,this.o(W),de);let Ae=this.p(we);if(de!==void 0){const be=G.onDidChangeInlineValues(Ie=>this.e.$emitInlineValuesEvent(de));Ae=R.Disposable.from(Ae,be)}return Ae}$provideInlineValues(M,W,G,_,de){return this.s(M,E,we=>we.provideInlineValues(a.URI.revive(W),G,_,de),void 0,de)}registerDocumentHighlightProvider(M,W,G){const _=this.t(new w(this.h,G),M);return this.e.$registerDocumentHighlightProvider(_,this.o(W)),this.p(_)}$provideDocumentHighlights(M,W,G,_){return this.s(M,w,de=>de.provideDocumentHighlights(a.URI.revive(W),G,_),void 0,_)}registerLinkedEditingRangeProvider(M,W,G){const _=this.t(new O(this.h,G),M);return this.e.$registerLinkedEditingRangeProvider(_,this.o(W)),this.p(_)}$provideLinkedEditingRanges(M,W,G,_){return this.s(M,O,async de=>{const we=await de.provideLinkedEditingRanges(a.URI.revive(W),G,_);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ce.w(we.wordPattern):void 0}},void 0,_)}registerReferenceProvider(M,W,G){const _=this.t(new V(this.h,G),M);return this.e.$registerReferenceSupport(_,this.o(W)),this.p(_)}$provideReferences(M,W,G,_,de){return this.s(M,V,we=>we.provideReferences(a.URI.revive(W),G,_,de),void 0,de)}registerCodeActionProvider(M,W,G,_){const de=new y.DisposableStore,we=this.t(new j(this.h,this.j.converter,this.k,G,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(we,this.o(W),{providedKinds:_?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:_?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,de)}))},ce.u(M),Boolean(G.resolveCodeAction)),de.add(this.p(we)),de}$provideCodeActions(M,W,G,_,de){return this.s(M,j,we=>we.provideCodeActions(a.URI.revive(W),G,_,de),void 0,de)}$resolveCodeAction(M,W,G){return this.s(M,j,_=>_.resolveCodeAction(W,G),void 0,void 0)}$releaseCodeActions(M,W){this.s(M,j,G=>Promise.resolve(G.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(M,W,G){const _=this.t(new B(this.h,G),M);return this.e.$registerDocumentFormattingSupport(_,this.o(W),M.identifier,M.displayName||M.name),this.p(_)}$provideDocumentFormattingEdits(M,W,G,_){return this.s(M,B,de=>de.provideDocumentFormattingEdits(a.URI.revive(W),G,_),void 0,_)}registerDocumentRangeFormattingEditProvider(M,W,G){const _=this.t(new N(this.h,G),M);return this.e.$registerRangeFormattingSupport(_,this.o(W),M.identifier,M.displayName||M.name),this.p(_)}$provideDocumentRangeFormattingEdits(M,W,G,_,de){return this.s(M,N,we=>we.provideDocumentRangeFormattingEdits(a.URI.revive(W),G,_,de),void 0,de)}registerOnTypeFormattingEditProvider(M,W,G,_){const de=this.t(new U(this.h,G),M);return this.e.$registerOnTypeFormattingSupport(de,this.o(W),_,M.identifier),this.p(de)}$provideOnTypeFormattingEdits(M,W,G,_,de,we){return this.s(M,U,Ae=>Ae.provideOnTypeFormattingEdits(a.URI.revive(W),G,_,de,we),void 0,we)}registerWorkspaceSymbolProvider(M,W){const G=this.t(new $(W,this.l),M);return this.e.$registerNavigateTypeSupport(G,typeof W.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(M,W,G){return this.s(M,$,_=>_.provideWorkspaceSymbols(W,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,W,G){return this.s(M,$,_=>_.resolveWorkspaceSymbol(W,G),void 0,void 0)}$releaseWorkspaceSymbols(M,W){this.s(M,$,G=>G.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(M,W,G){const _=this.t(new z(this.h,G,this.l),M);return this.e.$registerRenameSupport(_,this.o(W),z.supportsResolving(G)),this.p(_)}$provideRenameEdits(M,W,G,_,de){return this.s(M,z,we=>we.provideRenameEdits(a.URI.revive(W),G,_,de),void 0,de)}$resolveRenameLocation(M,W,G,_){return this.s(M,z,de=>de.resolveRenameLocation(a.URI.revive(W),G,_),void 0,_)}registerDocumentSemanticTokensProvider(M,W,G,_){const de=this.t(new ee(this.h,G),M),we=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(W),_,we);let Ae=this.p(de);if(we){const be=G.onDidChangeSemanticTokens(Ie=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,be)}return Ae}$provideDocumentSemanticTokens(M,W,G,_){return this.s(M,ee,de=>de.provideDocumentSemanticTokens(a.URI.revive(W),G,_),null,_)}$releaseDocumentSemanticTokens(M,W){this.s(M,ee,G=>G.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,W,G,_){const de=this.t(new q(this.h,G),M);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(W),_),this.p(de)}$provideDocumentRangeSemanticTokens(M,W,G,_){return this.s(M,q,de=>de.provideDocumentRangeSemanticTokens(a.URI.revive(W),G,_),null,_)}registerCompletionItemProvider(M,W,G,_){const de=this.t(new J(this.h,this.j.converter,G,this.m,M),M);return this.e.$registerCompletionsProvider(de,this.o(W),_,J.supportsResolving(G),`${M.identifier.value}(${_.join("")})`),this.p(de)}$provideCompletionItems(M,W,G,_,de){return this.s(M,J,we=>we.provideCompletionItems(a.URI.revive(W),G,_,de),void 0,de)}$resolveCompletionItem(M,W,G){return this.s(M,J,_=>_.resolveCompletionItem(W,G),void 0,G)}$releaseCompletionItems(M,W){this.s(M,J,G=>G.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(M,W,G){const _=new ge(M,this.h,G,this.j.converter),de=this.t(_,M);return this.e.$registerInlineCompletionsSupport(de,this.o(W),_.supportsHandleEvents),this.p(de)}$provideInlineCompletions(M,W,G,_,de){return this.s(M,ie,we=>we.provideInlineCompletions(a.URI.revive(W),G,_,de),void 0,de)}$handleInlineCompletionDidShow(M,W,G){this.s(M,ie,async _=>{_.handleDidShowCompletionItem(W,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,W,G,_){this.s(M,ie,async de=>{de.handlePartialAccept(W,G,_)},void 0,void 0)}$freeInlineCompletionsList(M,W){this.s(M,ie,async G=>{G.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(M,W,G,_){const de=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,we=this.t(new Y(this.h,G),M);return this.e.$registerSignatureHelpProvider(we,this.o(W),de),this.p(we)}$provideSignatureHelp(M,W,G,_,de){return this.s(M,Y,we=>we.provideSignatureHelp(a.URI.revive(W),G,_,de),void 0,de)}$releaseSignatureHelp(M,W){this.s(M,Y,G=>G.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(M,W,G){const _=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new Z(this.h,this.j.converter,G,this.l,M),M);this.e.$registerInlayHintsProvider(de,this.o(W),typeof G.resolveInlayHint=="function",_,ce.u(M));let we=this.p(de);if(_!==void 0){const Ae=G.onDidChangeInlayHints(be=>this.e.$emitInlayHintsEvent(_));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(M,W,G,_){return this.s(M,Z,de=>de.provideInlayHints(a.URI.revive(W),G,_),void 0,_)}$resolveInlayHint(M,W,G){return this.s(M,Z,_=>_.resolveInlayHint(W,G),void 0,G)}$releaseInlayHints(M,W){this.s(M,Z,G=>G.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(M,W,G){const _=this.t(new fe(this.h,G),M);return this.e.$registerDocumentLinkProvider(_,this.o(W),typeof G.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(M,W,G){return this.s(M,fe,_=>_.provideLinks(a.URI.revive(W),G),void 0,G,W.scheme==="output")}$resolveDocumentLink(M,W,G){return this.s(M,fe,_=>_.resolveLink(W,G),void 0,void 0,!0)}$releaseDocumentLinks(M,W){this.s(M,fe,G=>G.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(M,W,G){const _=this.t(new ve(this.h,G),M);return this.e.$registerDocumentColorProvider(_,this.o(W)),this.p(_)}$provideDocumentColors(M,W,G){return this.s(M,ve,_=>_.provideColors(a.URI.revive(W),G),[],G)}$provideColorPresentations(M,W,G,_){return this.s(M,ve,de=>de.provideColorPresentations(a.URI.revive(W),G,_),void 0,_)}registerFoldingRangeProvider(M,W,G){const _=this.q(),de=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new te(new ke(this.h,G),M)),this.e.$registerFoldingRangeProvider(_,this.o(W),M.identifier,de);let we=this.p(_);if(de!==void 0){const Ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(M,W,G,_){return this.s(M,ke,de=>de.provideFoldingRanges(a.URI.revive(W),G,_),void 0,_)}registerSelectionRangeProvider(M,W,G){const _=this.t(new Oe(this.h,G,this.l),M);return this.e.$registerSelectionRangeProvider(_,this.o(W)),this.p(_)}$provideSelectionRanges(M,W,G,_){return this.s(M,Oe,de=>de.provideSelectionRanges(a.URI.revive(W),G,_),[],_)}registerCallHierarchyProvider(M,W,G){const _=this.t(new oe(this.h,G),M);return this.e.$registerCallHierarchyProvider(_,this.o(W)),this.p(_)}$prepareCallHierarchy(M,W,G,_){return this.s(M,oe,de=>Promise.resolve(de.prepareSession(a.URI.revive(W),G,_)),void 0,_)}$provideCallHierarchyIncomingCalls(M,W,G,_){return this.s(M,oe,de=>de.provideCallsTo(W,G,_),void 0,_)}$provideCallHierarchyOutgoingCalls(M,W,G,_){return this.s(M,oe,de=>de.provideCallsFrom(W,G,_),void 0,_)}$releaseCallHierarchy(M,W){this.s(M,oe,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(M,W,G){const _=this.t(new le(this.h,G),M);return this.e.$registerTypeHierarchyProvider(_,this.o(W)),this.p(_)}$prepareTypeHierarchy(M,W,G,_){return this.s(M,le,de=>Promise.resolve(de.prepareSession(a.URI.revive(W),G,_)),void 0,_)}$provideTypeHierarchySupertypes(M,W,G,_){return this.s(M,le,de=>de.provideSupertypes(W,G,_),void 0,_)}$provideTypeHierarchySubtypes(M,W,G,_){return this.s(M,le,de=>de.provideSubtypes(W,G,_),void 0,_)}$releaseTypeHierarchy(M,W){this.s(M,le,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(M,W,G){const _=this.q();return this.f.set(_,new te(new ue(this.e,this.h,G,_),M)),this.e.$registerDocumentOnDropEditProvider(_,this.o(W)),this.p(_)}$provideDocumentOnDropEdits(M,W,G,_,de,we){return this.s(M,ue,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(W,a.URI.revive(G),_,de,we)),void 0,void 0)}registerDocumentPasteEditProvider(M,W,G,_){const de=this.q();return this.f.set(de,new te(new F(this.e,this.h,G,de),M)),this.e.$registerPasteEditProvider(de,this.o(W),!!G.prepareDocumentPaste,_.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(M,W,G,_,de){return this.s(M,F,we=>we.prepareDocumentPaste(a.URI.revive(W),G,_,de),void 0,de)}$providePasteEdits(M,W,G,_,de,we){return this.s(M,F,Ae=>Ae.providePasteEdits(W,a.URI.revive(G),_,de,we),void 0,we)}static w(M){return{pattern:M.source,flags:(0,S.regExpFlags)(M)}}static y(M){return{decreaseIndentPattern:ce.w(M.decreaseIndentPattern),increaseIndentPattern:ce.w(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ce.w(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ce.w(M.unIndentedLinePattern):void 0}}static z(M){return{beforeText:ce.w(M.beforeText),afterText:M.afterText?ce.w(M.afterText):void 0,previousLineText:M.previousLineText?ce.w(M.previousLineText):void 0,action:M.action}}static B(M){return M.map(ce.z)}setLanguageConfiguration(M,W,G){const{wordPattern:_}=G;if(_&&(0,S.regExpLeadsToEndlessLoop)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(W,_):this.h.setWordDefinitionFor(W,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const de=this.q(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ce.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ce.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ce.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this.e.$setLanguageConfiguration(de,W,we),this.p(de)}$setWordDefinitions(M){for(const W of M)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(De[264],Ce([1,0,5,14,7,37,19,6]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,T,v,I){this.c=T,this.d=v,this.e=I,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,T){await this.a.$changeLanguage(L,T);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,T){const v=L.version,I=A.Position.from(T),y=await this.a.$tokensAtPosition(L.uri,I),h={type:l.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new l.Range(T.line,T.character,T.line,T.character)};if(!y)return h;const d={range:A.Range.to(y.range),type:A.TokenType.to(y.type)};return!d.range.contains(T)||v!==L.version?h:d}createLanguageStatusItem(L,T,v){const I=this.f++,y=this.a,h=this.g,d=`${L.identifier.value}/${T}`;if(h.has(d))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);h.add(d);const u={selector:v,id:T,name:L.displayName??L.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const b=new P.DisposableStore,D=()=>{g?.dispose(),g=(0,C.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(I,{id:d,name:u.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===l.LanguageStatusSeverity.Error?R.default.Error:u.severity===l.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:u.command&&this.d.toInternal(u.command,b),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},p={dispose(){b.dispose(),g?.dispose(),y.$removeLanguageStatus(I),h.delete(d)},get id(){return u.id},get name(){return u.name},set name(i){u.name=i,D()},get selector(){return u.selector},set selector(i){u.selector=i,D()},get text(){return u.text},set text(i){u.text=i,D()},get detail(){return u.detail},set detail(i){u.detail=i,D()},get severity(){return u.severity},set severity(i){u.severity=i,D()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(i){u.accessibilityInformation=i,D()},get command(){return u.command},set command(i){u.command=i,D()},get busy(){return u.busy},set busy(i){u.busy=i,D()}};return D(),p}}e.ExtHostLanguages=S}),define(De[97],Ce([1,0,10,8,2,4,13,5,25,20]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,I,y){this.f=y,this.d=new Map,this.a=I.getProxy(P.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(v,I){const{message:y,args:h,comment:d}=I;if(this.c)return(0,A.format2)(y,h??{});let u=y;d&&d.length>0&&(u+=`/${Array.isArray(d)?d.join(""):d}`);const g=this.d.get(v)?.contents[u];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,A.format2)(g??y,h??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let I;const y=await this.g(v);if(!y){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(y),d=JSON.parse(h);I=v.isBuiltin?d.contents?.bundle:d}catch(h){this.f.error(`Failed to load translations for ${v.identifier.value} from ${y}: ${h.message}`);return}I&&this.d.set(v.identifier.value,{contents:I,uri:y})}async g(v){if(v.isBuiltin){const I=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return l.URI.revive(I)}return v.l10n?l.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=xe([We(0,S.IExtHostInitDataService),We(1,k.IExtHostRpcService),We(2,C.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(De[140],Ce([1,0,13,5,25,20,2,69]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends a.AbstractLoggerService{constructor(T,v){super(v.logLevel,v.loggers.map(I=>(0,P.revive)(I))),this.l=T.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(T,v){v?this.setLogLevel(C.URI.revive(v),T):this.setLogLevel(T)}setVisibility(T,v){super.setVisibility(T,v),this.l.$setVisibility(T,v)}k(T,v,I){return new k(this.l,T,v,I)}};S=xe([We(0,R.IExtHostRpcService),We(1,l.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class k extends a.AbstractMessageLogger{constructor(T,v,I,y){super(y?.logLevel==="always"),this.m=T,this.n=v,this.k=!1,this.l=[],this.setLevel(I),this.m.$createLogger(v,y).then(()=>{this.r(this.l),this.k=!0})}g(T,v){const I=[[T,v]];this.k?this.r(I):this.l.push(...I)}r(T){this.m.$log(this.n,T)}}}),define(De[265],Ce([1,0,5,13,27]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(P){return P&&P.title}let C=class{constructor(S,k){this.b=k,this.a=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,k,L,T,v){const I={source:{identifier:S.identifier,label:S.displayName||S.name}};let y;typeof T=="string"||R(T)?y=[T,...v]:(I.modal=T?.modal,I.useCustom=T?.useCustom,I.detail=T?.detail,y=v),I.useCustom&&(0,l.checkProposedApiEnabled)(S,"resolvers");const h=[];for(let d=0;d<y.length;d++){const u=y[d];if(typeof u=="string")h.push({title:u,handle:d,isCloseAffordance:!1});else if(typeof u=="object"){const{title:g,isCloseAffordance:b}=u;h.push({title:g,isCloseAffordance:!!b,handle:d})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(k,L,I,h).then(d=>{if(typeof d=="number")return y[d]})}};C=xe([We(1,A.ILogService)],C),e.ExtHostMessageService=C}),define(De[266],Ce([1,0,22,3,6,28,8,9,2,74,5,40,14,7,58,241,136]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,D,p,i){this.q=p,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(L.MainContext.MainThreadNotebook),this.c=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const r=o.notebookEditor?.notebookUri,c=o.cell.handle,m=this.g.get(r)?.getCell(c);if(m)return m.apiCell}if(o&&o.$mid===14){const r=o.uri,c=this.g.get(r);if(c)return c.apiNotebook}return o}}),u.x(D)}getEditorById(b){const D=this.h.get(b);if(!D)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(b){for(const[D,p]of this.h)if(p.apiEditor===b)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,D){const p=this.g.get(b);if(!p&&!D)throw new Error(`NO notebook document for '${b}'`);return p}static s(b,D){if(!D)return;const p=D.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(D.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:D.displayName,filenamePattern:p,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,D,p){const i=u.a++,o=typeof p.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(i,p),this.b.$registerNotebookCellStatusBarItemProvider(i,o,D);let r;return o!==void 0&&(r=p.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(o))),new I.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,o),r?.dispose()})}async createNotebookDocument(b){const D=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return S.URI.revive(D)}async openNotebookDocument(b){const D=this.g.get(b);if(D)return D.apiNotebook;const p=await this.c.$tryOpenNotebook(b),i=this.g.get(S.URI.revive(p));return(0,P.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,D){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let p;typeof D=="object"?p={position:v.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(v.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,p),o=i&&this.h.get(i)?.apiEditor;if(o)return o;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,D,p,i){const o=this.f.get(b),r=S.URI.revive(D),c=this.g.get(r);if(!c||!o)return;const s=c.getCellFromIndex(p);if(!s)return;const m=await o.provideCellStatusBarItems(s.apiCell,i);if(!m)return;const n=new l.DisposableStore,t=this.p.add([n]),E=(Array.isArray(m)?m:[m]).map(w=>v.NotebookStatusBarItem.from(w,this.i,n));return{cacheId:t,items:E}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,D,p,i,o){if((0,C.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,p),this.b.$registerNotebookSerializer(r,{id:b.identifier,location:b.extensionLocation},D,v.NotebookDocumentContentOptions.from(i),u.s(b,o)),(0,l.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(b,D,p){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const o=await i.deserializeNotebook(D.buffer,p);return new y.SerializableObjectWithBuffers(v.NotebookData.from(o))}async $notebookToData(b,D,p){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const o=await i.serializeNotebook(v.NotebookData.to(D.value),p);return a.VSBuffer.wrap(o)}w(b,D,p){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const i=new d.ExtHostNotebookEditor(D,this.d,b,p.visibleRanges.map(v.NotebookRange.to),p.selections.map(v.NotebookRange.to),typeof p.viewColumn=="number"?v.ViewColumn.to(p.viewColumn):void 0);this.h.set(D,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const p of b.value.removedDocuments){const i=S.URI.revive(p),o=this.g.get(i);o&&(o.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(o.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===i.toString()&&this.h.delete(r.id)}if(b.value.addedDocuments){const p=[];for(const i of b.value.addedDocuments){const o=S.URI.revive(i.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const r=new h.ExtHostNotebookDocument(this.c,this.q,this.r,o,i);p.push(...i.cells.map(c=>h.ExtHostCell.asModelAddData(r.apiNotebook,c))),this.g.get(o)?.dispose(),this.g.set(o,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(r.apiNotebook)}}if(b.value.addedEditors)for(const p of b.value.addedEditors){if(this.h.has(p.id))return;const i=S.URI.revive(p.documentUri),o=this.g.get(i);o&&this.w(o,p.id,p)}const D=[];if(b.value.removedEditors)for(const p of b.value.removedEditors){const i=this.h.get(p);i&&(this.h.delete(p),this.k?.id===i.id&&(this.k=void 0),D.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const p=new Set;this.l.forEach(i=>p.add(i.id));for(const i of this.h.values()){const o=p.has(i.id);i._acceptVisibility(o)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const D=T.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new T.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>a.VSBuffer.wrap(o))],new T.ApiCommandResult("Notebook Data",o=>v.NotebookData.to(o.value))),i=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new y.SerializableObjectWithBuffers(v.NotebookData.from(o)))],new T.ApiCommandResult("Bytes",o=>o.buffer));b.registerApiCommand(p),b.registerApiCommand(i)}}u.a=0,e.ExtHostNotebookController=u}),define(De[267],Ce([1,0,15,19,21,3,6,28,2,26,13,74,5,40,14,7,95,231,27,58]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let D=class{constructor(s,m,n,t,f){this.k=m,this.l=n,this.m=t,this.n=f,this.b=new P.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new T.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=s.getProxy(v.MainContext.MainThreadNotebookKernels);const E=new I.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new I.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const O=this.l.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:O}}else if(w&&"notebookEditor"in w){const O=this.l.getIdByEditor(w.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return w})],I.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(s,m,n,t,f,E){for(const ie of this.h.values())if(ie.controller.id===m&&k.ExtensionIdentifier.equals(s.identifier,ie.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const w=this.i++,O=this;this.n.trace(`NotebookController[${w}], CREATED by ${s.identifier.value}, ${m}`);const V=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${s.identifier}'`);let j=!1;const F=new C.DisposableStore,B=new R.Emitter,N=new R.Emitter,U={id:r(s.identifier,m),notebookType:n,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:t||s.identifier.value,preloads:E?E.map(y.NotebookRendererScript.from):[]};let $=f??V,z;this.a.$addKernel(w,U).catch(ie=>{console.log(ie),j=!0});let ae=0;const ee=()=>{if(j)return;const ie=++ae;Promise.resolve().then(()=>{ie===ae&&this.a.$updateKernel(w,U)})},q=new P.ResourceMap,J={get id(){return m},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(ie){U.label=ie??s.displayName??s.name,ee()},get detail(){return U.detail??""},set detail(ie){U.detail=ie,ee()},get description(){return U.description??""},set description(ie){U.description=ie,ee()},get kind(){return(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),U.kind??""},set kind(ie){(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),U.kind=ie,ee()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ie){U.supportedLanguages=ie,ee()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){U.supportsExecutionOrder=ie,ee()},get rendererScripts(){return U.preloads?U.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return $},set executeHandler(ie){$=ie??V},get interruptHandler(){return z},set interruptHandler(ie){z=ie,U.supportsInterrupt=Boolean(ie),ee()},createNotebookCellExecution(ie){if(j)throw new Error("notebook controller is DISPOSED");if(!q.has(ie.notebook.uri))throw O.n.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return O._createNotebookCellExecution(ie,r(s.identifier,this.id))},dispose:()=>{j||(this.n.trace(`NotebookController[${w}], DISPOSED`),j=!0,this.h.delete(w),F.dispose(),B.dispose(),N.dispose(),this.a.$removeKernel(w))},updateNotebookAffinity(ie,ge){ge===h.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(s,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(w,ie.uri,ge)},onDidReceiveMessage:N.event,postMessage(ie,ge){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),O.a.$postMessage(w,ge&&O.l.getIdByEditor(ge),ie)},asWebviewUri(ie){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),(0,d.asWebviewUri)(ie,O.k.remote)}};return this.h.set(w,{extensionId:s.identifier,controller:J,onDidReceiveMessage:N,onDidChangeSelection:B,associatedNotebooks:q}),J}getIdByController(s){for(const[m,n]of this.h)if(n.controller===s)return r(n.extensionId,s.id);return null}createNotebookControllerDetectionTask(s,m){const n=this.d++,t=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${s.identifier.value}`),this.a.$addKernelDetectionTask(n,m);const f={dispose:()=>{this.c.delete(n),t.a.$removeKernelDetectionTask(n)}};return this.c.set(n,f),f}registerKernelSourceActionProvider(s,m,n){const t=this.f++,f=typeof n.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,E=this;this.e.set(t,n),this.n.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${s.identifier.value}`),this.a.$addKernelSourceActionProvider(t,t,m);let w;return f!==void 0&&(w=n.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.e.delete(t),E.a.$removeKernelSourceActionProvider(t,t),w?.dispose()}}}async $provideKernelSourceActions(s,m){const n=this.e.get(s);if(n){const t=new C.DisposableStore;return this.g.add([t]),(await n.provideNotebookKernelSourceActions(m)??[]).map(E=>y.NotebookKernelSourceAction.from(E,this.m.converter,t))}return[]}$acceptNotebookAssociation(s,m,n){const t=this.h.get(s);if(t){const f=this.l.getNotebookDocument(S.URI.revive(m));n?t.associatedNotebooks.set(f.uri,!0):t.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${s}] ASSOCIATE notebook`,f.uri.toString(),n),t.onDidChangeSelection.fire({selected:n,notebook:f.apiNotebook})}}async $executeCells(s,m,n){const t=this.h.get(s);if(!t)return;const f=this.l.getNotebookDocument(S.URI.revive(m)),E=[];for(const w of n){const O=f.getCell(w);O&&E.push(O.apiCell)}try{this.n.trace(`NotebookController[${s}] EXECUTE cells`,f.uri.toString(),E.length),await t.controller.executeHandler.call(t.controller,E,f.apiNotebook,t.controller)}catch(w){this.n.error(`NotebookController[${s}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(s,m,n){const t=this.h.get(s);if(!t)return;const f=this.l.getNotebookDocument(S.URI.revive(m));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,f.apiNotebook);else for(const E of n){const w=f.getCell(E);w&&this.b.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,m,n){const t=this.h.get(s);if(!t)return;const f=this.l.getEditorById(m);t.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:n}))}$cellExecutionChanged(s,m,n){const f=this.l.getNotebookDocument(S.URI.revive(s)).getCell(m);if(f){const E=n?y.NotebookCellExecutionState.to(n):h.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:f.apiCell,state:E})}}_createNotebookCellExecution(s,m){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this.l.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!t)throw new Error("invalid cell");if(this.b.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const f=new i(m,t,this.a);this.b.set(t.uri,f);const E=f.onDidChangeState(()=>{f.state===p.Resolved&&(f.dispose(),E.dispose(),this.b.delete(t.uri))});return f.asApiObject()}};D=xe([We(4,L.ILogService)],D),e.ExtHostNotebookKernels=D;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class i extends C.Disposable{get state(){return this.f}constructor(s,m,n){super(),this.j=m,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new l.CancellationTokenSource),this.h=new o(10,t=>this.m(t)),this.i=m.internalMetadata.executionOrder,this.k.$createExecution(this.b,s,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(s){await this.h.addItem(s)}async m(s){const m=Array.isArray(s)?s:[s];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(m))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(s){let m=this.j;if(s&&(m=this.j.notebook.getCellFromApiCell(s)),!m)throw new Error("INVALID cell");return m.handle}s(s){return s.map(m=>{const n=h.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return n===m.items?y.NotebookCellOutput.from(m):y.NotebookCellOutput.from({items:n,id:m.id,metadata:m.metadata})})}async t(s,m,n){const t=this.r(m),f=this.s((0,a.asArray)(s));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:t,append:n,outputs:f})}async w(s,m,n){return s=h.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(s),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:s.map(y.NotebookCellOutputItem.from),outputId:m.id,append:n})}asApiObject(){const s=this;return Object.freeze({get token(){return s.g.token},get cell(){return s.j.apiCell},get executionOrder(){return s.i},set executionOrder(n){s.i=n,s.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:s.i}])},start(n){if(s.f===p.Resolved||s.f===p.Started)throw new Error("Cannot call start again");s.f=p.Started,s.c.fire(),s.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,t){if(s.f===p.Resolved)throw new Error("Cannot call resolve twice");s.f=p.Resolved,s.c.fire(),s.h.flush(),s.k.$completeExecution(s.b,new b.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:n}))},clearOutput(n){return s.n(),s.t([],n,!1)},appendOutput(n,t){return s.n(),s.t(n,t,!0)},replaceOutput(n,t){return s.n(),s.t(n,t,!1)},appendOutputItems(n,t){return s.n(),s.w(n,t,!0)},replaceOutputItems(n,t){return s.n(),s.w(n,t,!1)}})}}i.a=0;class o{constructor(s,m){this.d=s,this.e=m,this.a=[],this.b=Date.now()}addItem(s){return this.a.push(s),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const s=this.c;this.c=void 0;const m=this.a;return this.a=[],this.e(m).finally(()=>s.complete())}}function r(c,s){return`${c.value}/${s}`}e.createKernelId=r}),define(De[268],Ce([1,0,3,5,136]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(P,S){this.c=S,this.a=new Map,this.b=P.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,k){const L=this.c.getEditorById(P);this.a.get(S)?.fire({editor:L.apiEditor,message:k})}createRendererMessaging(P,S){if(!P.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,T,v)=>this.d(S).event(L,T,v),postMessage:(L,T)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,T]=[T,L]);const v=T&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.b.$postMessage(v?.id,S,L)}}}d(P){let S=this.a.get(P);return S||(S=new a.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(P)}}),this.a.set(P,S),S)}}e.ExtHostNotebookRenderers=R}),define(De[269],Ce([1,0,6,9,2,27,5]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(k){this.b=new Map,this.a=k.getProxy(C.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,L,T){if((0,R.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,T),this.a.$registerProfileContentHandler(L,T.name,T.description,k.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(k,L,T,v){const I=this.b.get(k);if(!I)throw new Error(`Unknown handler with id: ${k}`);return I.saveProfile(L,T,v)}async $readProfile(k,L,T){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.readProfile((0,A.isString)(L)?L:l.URI.revive(L),T)}}e.ExtHostProfileContentHandlers=P}),define(De[270],Ce([1,0,2,5,19,14]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class C{constructor(S,k){this.d=k,this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,k,L){const T=a.URI.revive(k),v=this.c.get(S);return v?(0,l.asPromise)(()=>v.provideOriginalResource(T,L)).then(I=>I||null):Promise.resolve(null)}registerQuickDiffProvider(S,k,L,T){const v=C.a++;return this.c.set(v,k),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(S,this.d),L,T),{dispose:()=>this.c.delete(v)}}}C.a=0,e.ExtHostQuickDiff=C}),define(De[271],Ce([1,0,21,3,6,5,2,7,12,15,37,51]),function(ne,e,a,A,l,R,C,P,S,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(I,y,h){const d=I.getProxy(R.MainContext.MainThreadQuickOpen);class u{constructor(s,m){this.e=new Map,this.f=0,this.a=s,this.b=m}showQuickPick(s,m,n=a.CancellationToken.None){this.c=void 0;const t=Promise.resolve(s),f=++this.f,E=d.$show(f,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},n),w={},O=E.then(()=>w);return Promise.race([O,t]).then(V=>{if(V!==w)return t.then(j=>{const F=[];for(let B=0;B<j.length;B++){const N=j[B];typeof N=="string"?F.push({label:N,handle:B}):N.kind===P.QuickPickItemKind.Separator?F.push({type:"separator",label:N.label}):F.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:B})}return m&&typeof m.onDidSelectItem=="function"&&(this.c=B=>{m.onDidSelectItem(j[B])}),d.$setItems(f,F),E.then(B=>{if(typeof B=="number")return j[B];if(Array.isArray(B))return B.map(N=>j[N])})})}).then(void 0,V=>{if(!(0,S.isCancellationError)(V))return d.$setError(f,V),Promise.reject(V)})}$onItemSelected(s){this.c?.(s)}showInput(s,m=a.CancellationToken.None){return this.d=s?.validateInput,d.$input(s,typeof this.d=="function",m).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(s){if(!this.d)return;const m=await this.d(s);if(!m||typeof m=="string")return m;let n;switch(m.severity){case P.InputBoxValidationSeverity.Info:n=L.default.Info;break;case P.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case P.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=m.message?L.default.Error:L.default.Ignore;break}return{content:m.message,severity:n}}async showWorkspaceFolderPick(s,m=a.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!n)return;const t=await this.a.getWorkspaceFolders2();if(!!t)return t.find(f=>f.uri.toString()===n.uri.toString())}createQuickPick(s){const m=new o(s,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}createInputBox(s){const m=new r(s,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}$onDidChangeValue(s,m){this.e.get(s)?._fireDidChangeValue(m)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,m){const n=this.e.get(s);n instanceof o&&n._fireDidChangeActive(m)}$onDidChangeSelection(s,m){const n=this.e.get(s);n instanceof o&&n._fireDidChangeSelection(m)}$onDidTriggerButton(s,m){this.e.get(s)?._fireDidTriggerButton(m)}$onDidTriggerItemButton(s,m,n){const t=this.e.get(s);t instanceof o&&t._fireDidTriggerItemButton(m,n)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class g{constructor(s,m){this.x=s,this.y=m,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((m,n)=>{const t=m===P.QuickInputButtons.Back?-1:n;this.o.set(t,m)}),this.z({buttons:s.map((m,n)=>({...i(m),tooltip:m.tooltip,handle:m===P.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const m=this.o.get(s);m&&this.r.fire(m)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(s){if(!this.v){for(const m of Object.keys(s)){const n=s[m];this.u[m]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function b(c){if(c instanceof P.ThemeIcon)return{id:c.id};const s=p(c),m=D(c);return{dark:typeof s=="string"?C.URI.file(s):s,light:typeof m=="string"?C.URI.file(m):m}}function D(c){return typeof c=="object"&&"light"in c?c.light:c}function p(c){return typeof c=="object"&&"dark"in c?c.dark:c}function i(c){const s=b(c.iconPath);let m,n;return"id"in s?n=T.ThemeIcon.asClassName(s):m=s,{iconPath:m,iconClass:n}}class o extends g{constructor(s,m){super(s.identifier,m),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((n,t)=>{this.C.set(t,n),this.D.set(n,t)});const m=[];for(let n=0;n<s.length;n++){const t=s[n];t.kind===P.QuickPickItemKind.Separator?m.push({type:"separator",label:t.label}):m.push({handle:n,label:t.label,description:t.description,detail:t.detail,picked:t.picked,alwaysShow:t.alwaysShow,buttons:t.buttons?.map((f,E)=>({...i(f),tooltip:f.tooltip,handle:E}))})}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(m=>this.D.has(m)),this.z({activeItems:this.J.map(m=>this.D.get(m))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(m=>this.D.has(m)),this.z({selectedItems:this.L.map(m=>this.D.get(m))})}_fireDidChangeActive(s){const m=(0,k.coalesce)(s.map(n=>this.C.get(n)));this.J=m,this.K.fire(m)}_fireDidChangeSelection(s){const m=(0,k.coalesce)(s.map(n=>this.C.get(n)));this.L=m,this.M.fire(m)}_fireDidTriggerItemButton(s,m){const n=this.C.get(s);if(!n||!n.buttons||!n.buttons.length)return;const t=n.buttons[m];t&&this.N.fire({button:t,item:n})}}class r extends g{constructor(s,m){super(s.identifier,m),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:L.default.Error}):this.z({validationMessage:s.message,severity:s.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new u(y,h)}e.createExtHostQuickOpen=v});var Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)},Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a};define(De[272],Ce([1,0,2,3,62,6,19,5,15,108,13,26,51,14,27]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(t){if(t)return typeof t.iconPath=="string"?a.URI.file(t.iconPath):a.URI.isUri(t.iconPath)||v.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function g(t,f){if(!t.iconPath&&!f.iconPath)return 0;if(t.iconPath){if(!f.iconPath)return 1}else return-1;const E=typeof t.iconPath=="string"?t.iconPath:a.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,w=typeof f.iconPath=="string"?f.iconPath:a.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,k.comparePaths)(E,w)}function b(t,f){let E=0;if(t.strikeThrough!==f.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==f.faded)return t.faded?1:-1;if(t.tooltip!==f.tooltip)return(t.tooltip||"").localeCompare(f.tooltip||"");if(E=g(t,f),E!==0)return E;if(t.light&&f.light)E=g(t.light,f.light);else{if(t.light)return 1;if(f.light)return-1}if(E!==0)return E;if(t.dark&&f.dark)E=g(t.dark,f.dark);else{if(t.dark)return 1;if(f.dark)return-1}return E}function D(t,f){if(t.command!==f.command)return t.command<f.command?-1:1;if(t.title!==f.title)return t.title<f.title?-1:1;if(t.tooltip!==f.tooltip){if(t.tooltip!==void 0&&f.tooltip!==void 0)return t.tooltip<f.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(t.arguments===f.arguments)return 0;if(t.arguments)if(f.arguments){if(t.arguments.length!==f.arguments.length)return t.arguments.length-f.arguments.length}else return 1;else return-1;for(let E=0;E<t.arguments.length;E++){const w=t.arguments[E],O=f.arguments[E];if(w!==O)return w<O?-1:1}return 0}function p(t,f){let E=(0,k.comparePaths)(t.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(E!==0)return E;if(t.command&&f.command)E=D(t.command,f.command);else{if(t.command)return 1;if(f.command)return-1}if(E!==0)return E;if(t.decorations&&f.decorations)E=b(t.decorations,f.decorations);else{if(t.decorations)return 1;if(f.decorations)return-1}return E}function i(t,f){for(let E=0;E<t.length;E++)if(t[E]!==f[E])return!1;return!0}function o(t,f){return t.command===f.command&&t.title===f.title&&t.tooltip===f.tooltip&&(t.arguments&&f.arguments?i(t.arguments,f.arguments):t.arguments===f.arguments)}function r(t,f){return(0,S.equals)(t,f,o)}class c{get value(){return this.d}set value(f){f=f??"",Be(this,h,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Be(this,h,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,y.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,y.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Be(this,h,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Be(this,h,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Be(this,h,"f").$setInputBoxVisibility(this.l,f))}constructor(f,E,w){this.k=f,this.l=w,h.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,Ze(this,h,E,"f")}showValidationMessage(f,E){(0,y.checkProposedApiEnabled)(this.k,"scmValidation"),Be(this,h,"f").$showValidationMessage(this.l,f,E)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=c,h=new WeakMap;class s{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,E,w,O,V){this.q=f,this.s=E,this.t=w,this.u=O,this.v=V,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,E){const w=this.h.get(f);return w?(0,C.asPromise)(()=>this.s.executeCommand(w.command,...w.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(p),w=(0,S.sortedDiff)(this.o,f,p).map(j=>{const F=j.toInsert.map(B=>{const N=this.e++;this.g.set(N,B);const U=B.resourceUri;let $;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const Z=new R.DisposableStore;$=this.s.converter.toInternal(B.command,Z),this.j.set(N,Z)}else this.h.set(N,B.command);const z=u(B.decorations),ae=B.decorations&&u(B.decorations.light)||z,ee=B.decorations&&u(B.decorations.dark)||z,q=[ae,ee],J=B.decorations&&B.decorations.tooltip||"",ie=B.decorations&&!!B.decorations.strikeThrough,ge=B.decorations&&!!B.decorations.faded,X=B.contextValue||"";return{rawResource:[N,U,q,J,ie,ge,X,$],handle:N}});return{start:j.start,deleteCount:j.deleteCount,toInsert:F}}),O=w.map(({start:j,deleteCount:F,toInsert:B})=>[j,F,B.map(N=>N.rawResource)]),V=w.reverse();for(const{start:j,deleteCount:F,toInsert:B}of V){const N=B.map($=>$.handle),U=this.n.splice(j,F,...N);for(const $ of U)this.g.delete($),this.h.delete($),this.j.get($)?.dispose(),this.j.delete($)}return this.o=f,O}dispose(){this.l=!0,this.m.fire()}}s.d=0;class m{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Be(this,d,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,Be(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Be(this,d,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new R.DisposableStore,this.l=f;const E=this.v.converter.toInternal(f,this.k.value);Be(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,y.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,y.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=f;const E=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(w=>w.map(O=>this.v.converter.toInternal(O,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Be(this,d,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&r(this.p,f))return;this.o.value=new R.DisposableStore,this.p=f;const E=(f||[]).map(w=>this.v.converter.toInternal(w,this.o.value));Be(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(f,E,w,O,V,j){this.u=f,this.v=w,this.w=O,this.x=V,this.y=j,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,Ze(this,d,E,"f"),this.f=new c(f,Be(this,d,"f"),this.t),Be(this,d,"f").$registerSourceControl(this.t,O,V,j)}createResourceGroup(f,E){const w=new s(Be(this,d,"f"),this.v,this.t,f,E),O=A.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,O),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const f=[],E=[];for(const[w,O]of this.z){O.dispose();const V=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});A.Event.once(w.onDidDispose)(()=>{this.A.delete(w),V.dispose(),this.e.delete(w.handle),Be(this,d,"f").$unregisterGroup(this.t,w.handle)}),f.push([w.handle,w.id,w.label,w.features]);const j=w._takeResourceStateSnapshot();j.length>0&&E.push([w.handle,j]),this.e.set(w.handle,w)}Be(this,d,"f").$registerGroups(this.t,f,E),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(E=>{const w=E._takeResourceStateSnapshot();w.length!==0&&f.push([E.handle,w])}),f.length>0&&Be(this,d,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Be(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,m.d=0,xe([(0,l.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),xe([(0,l.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(f,E,w){this.l=E,this.m=w,this.g=new Map,this.h=new Map,this.j=new A.Emitter,this.e=f.getProxy(P.MainContext.MainThreadSCM),this.f=f.getProxy(P.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const V=this.g.get(O.sourceControlHandle);if(!V)return O;const j=V.getResourceGroup(O.groupHandle);return j?j.getResourceState(O.handle):O}else if(O&&O.$mid===4){const V=this.g.get(O.sourceControlHandle);return V?V.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const V=this.g.get(O.handle);return V||O}return O}})}createSourceControl(f,E,w,O){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,E,w,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const V=on.d++,j=new m(f,this.e,this.l,E,w,O);this.g.set(V,j);const F=this.h.get(T.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(j),this.h.set(T.ExtensionIdentifier.toKey(f.identifier),F),j}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const E=this.h.get(T.ExtensionIdentifier.toKey(f.identifier)),w=E&&E[E.length-1];return w&&w.inputBox}$provideOriginalResource(f,E,w){const O=a.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",f,O.toString());const V=this.g.get(f);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>V.quickDiffProvider.provideOriginalResource(O,w)).then(j=>j||null)}$onInputBoxValueChange(f,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const w=this.g.get(f);return w&&w.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(f,E,w,O){this.m.trace("ExtHostSCM#$executeResourceCommand",f,E,w);const V=this.g.get(f);if(!V)return Promise.resolve(void 0);const j=V.getResourceGroup(E);return j?j.$executeResourceCommand(w,O):Promise.resolve(void 0)}$validateInput(f,E,w){this.m.trace("ExtHostSCM#$validateInput",f);const O=this.g.get(f);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>O.inputBox.validateInput(E,w)).then(V=>{if(!V)return Promise.resolve(void 0);const j=I.MarkdownString.fromStrict(V.message);return j?Promise.resolve([j,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};n.d=0,n=xe([We(2,L.ILogService)],n),e.ExtHostSCM=n}),define(De[98],Ce([1,0,5,3,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(P){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=P.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this.b.fire(P)}get(P,S){return this.a.$getPassword(P,S)}store(P,S,k){return this.a.$setPassword(P,S,k)}delete(P,S){return this.a.$deletePassword(P,S)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[273],Ce([1,0,7,5,180,6,14,9]),function(ne,e,a,A,l,R,C,P){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(y,h,d,u,g=a.StatusBarAlignment.Left,b){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Ze(this,S,y,"f"),Ze(this,k,h,"f"),this.c=L.a++,this.e=d,this.f=u,this.g=g,this.h=this.u(b)}u(y){if(!!(0,P.isNumber)(y))return y===Number.POSITIVE_INFINITY?Number.MAX_VALUE:y===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:y}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(y){this.k=y,this.v()}set name(y){this.m=y,this.v()}set tooltip(y){this.l=y,this.v()}set color(y){this.n=y,this.v()}set backgroundColor(y){y&&!L.b.has(y.id)&&(y=void 0),this.o=y,this.v()}set command(y){this.r?.fromApi!==y&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof y=="string"?this.r={fromApi:y,internal:Be(this,k,"f").toInternal({title:"",command:y},this.p)}:y?this.r={fromApi:y,internal:Be(this,k,"f").toInternal(y,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(y){this.t=y,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let y;this.e?this.f?y=`${this.e.identifier.value}.${this.f}`:y=this.e.identifier.value:y=this.f;let h;this.m?h=this.m:h=(0,l.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const u=C.MarkdownString.fromStrict(this.l);Be(this,S,"f").$setEntry(this.c,y,h,this.k,u,this.r?.internal,d,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,k=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class T{constructor(y){this.b=[],this.a=y.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(y){const h={message:y};return this.b.unshift(h),this.c(),new a.Disposable(()=>{const d=this.b.indexOf(h);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(y,h){this.a=y.getProxy(A.MainContext.MainThreadStatusBar),this.b=h,this.c=new T(this)}createStatusBarEntry(y,h,d,u){return new L(this.a,this.b,y,h,d,u)}setStatusBarMessage(y,h){const d=this.c.setMessage(y);let u;return typeof h=="number"?u=setTimeout(()=>d.dispose(),h):typeof h<"u"&&h.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=v}),define(De[99],Ce([1,0,5,3,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(P,S){this.c=S,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=P.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this.a.$registerExtensionStorageKeysToSync(P,S)}async initializeExtensionStorage(P,S,k){const L=await this.a.$initializeExtensionStorage(P,S);let T;return L&&(T=this.d(P,S,L)),T||k}setValue(P,S,k){return this.a.$setValue(P,S,k)}$acceptValue(P,S,k){const L=this.d(P,S,k);L&&this.b.fire({shared:P,key:S,value:L})}d(P,S,k){try{return JSON.parse(k)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${P}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(De[79],Ce([1,0,4,25,13,78,2]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,L,T){this.d=L,this.f=T,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,L=await this.g(k);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(T){this.d.error("[ExtHostStorage]",T);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=xe([We(0,A.IExtHostInitDataService),We(1,l.ILogService),We(2,R.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(De[41],Ce([1,0,3,5,4,2,20,6,7,182,12,214,21,30,215,51,9,19,14]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class b{constructor(n,t,f,E){this.k=n,this._id=t,this.l=f,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(O=>this.f=O);const w=this;this.value={get name(){return w.m||""},get processId(){return w.b},get creationOptions(){return w.l},get exitStatus(){return w.h},get state(){return w.j},sendText(O,V=!0){w.o(),w.k.$sendText(w._id,O,V)},show(O){w.o(),w.k.$show(w._id,O)},hide(){w.o(),w.k.$hide(w._id)},dispose(){w.a||(w.a=!0,w.k.$dispose(w._id))},get dimensions(){if(!(w.d===void 0||w.g===void 0))return{columns:w.d,rows:w.g}}}}async create(n,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,d.withNullAsUndefined)(n.shellPath),shellArgs:(0,d.withNullAsUndefined)(n.shellArgs),cwd:(0,d.withNullAsUndefined)(n.cwd),env:(0,d.withNullAsUndefined)(n.env),icon:(0,d.withNullAsUndefined)(c(n.iconPath)),color:h.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,d.withNullAsUndefined)(n.message),strictEnv:(0,d.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this.n(n.location,t?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,t,f,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:h.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(n,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,t){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in n?{viewColumn:g.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,t){this.h=Object.freeze({code:n,reason:t})}setDimensions(n,t){return n===this.d&&t===this.g||n===0||t===0?!1:(this.d=n,this.g=t,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(t=>{t!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=b;class D{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${t}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,t){this.g.setDimensions?.({columns:n,rows:t})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(t=>this.a.fire(t)),this.g.onDidClose?.((t=void 0)=>{this.f.fire(t===void 0?void 0:t)}),this.g.onDidOverrideDimensions?.(t=>{t&&this.d.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this.g.onDidChangeName?.(t=>{this.d.fire({type:"title",value:t})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let p=1,i=class extends P.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,t){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=t.getProxy(A.MainContext.MainThreadTerminalService),this.s=new y.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[f,E]of this.g)E.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,t){const f=new b(this.a,(0,I.generateUuid)(),n,n.name),E=new D(n.pty);return f.createExtensionTerminal(n.location,this.L(n,t).resolvedExtHostIdentifier,c(n.iconPath),s(n.color)).then(w=>{const O=this.M(w,E);this.h[w]=O}),this.f.push(f),f.value}L(n,t){if(t=t||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const f=n.location.parentTerminal;if(f){const E=this.f.find(w=>w.value===f);E&&(t.resolvedExtHostIdentifier=E._id)}}else n.location&&typeof n.location!="object"?t.location=n.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(n,t){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const E=new D(t),w=this.M(n,E);this.h[n]=w}async $acceptActiveTerminalChanged(n){const t=this.b;if(n===null){this.b=void 0,t!==this.b&&this.F.fire(this.b);return}const f=this.O(n);f&&(this.b=f,t!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,t){const f=this.O(n);f&&this.I.fire({terminal:f.value,data:t})}async $acceptTerminalDimensions(n,t,f){const E=this.O(n);E&&E.setDimensions(t,f)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(n,t,f){this.g.get(n)?.resize(t,f)}async $acceptTerminalTitleChange(n,t){const f=this.O(n);f&&(f.name=t)}async $acceptTerminalClosed(n,t,f){const E=this.Q(this.f,n);if(E!==null){const w=this.f.splice(E,1)[0];w.setExitStatus(t,f),this.C.fire(w.value)}}$acceptTerminalOpened(n,t,f,E){if(t){const V=this.Q(this.f,t);if(V!==null){this.f[V]._id=n,this.D.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const w={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},O=new b(this.a,n,w,f);this.f.push(O),this.D.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(n,t){this.O(n)?._setProcessId(t)}async $startExtensionTerminal(n,t){const f=this.O(n);if(!f)return{message:(0,k.localize)(0,null,n)};f.isOpen||await new Promise(w=>{const O=this.onDidOpenTerminal(async V=>{V===f.value&&(O.dispose(),w())})});const E=this.g.get(n);E?E.startSendingEvents(t):this.j[n]={initialDimensions:t}}M(n,t){const f=new P.DisposableStore;f.add(t.onProcessReady(w=>this.a.$sendProcessReady(n,w.pid,w.cwd))),f.add(t.onDidChangeProperty(w=>this.a.$sendProcessProperty(n,w))),this.s.startBuffering(n,t.onProcessData),f.add(t.onProcessExit(w=>this.N(n,w))),this.g.set(n,t);const E=this.j[n];return E&&t instanceof D&&(t.startSendingEvents(E.initialDimensions),delete this.j[n]),f}$acceptProcessAckDataEvent(n,t){this.g.get(n)?.acknowledgeDataEvent(t)}$acceptProcessInput(n,t){this.g.get(n)?.input(t)}$acceptTerminalInteraction(n){const t=this.O(n);t?.setInteractedWith()&&this.H.fire(t.value)}$acceptProcessResize(n,t,f){try{this.g.get(n)?.resize(t,f)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(n,t){this.g.get(n)?.shutdown(t)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(t=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(t=>this.a.$sendProcessProperty(n,{type:"cwd",value:t}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,t,f){if(this.v.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this.v.set(t,f),this.a.$registerProfileProvider(t,n.identifier.value),new S.Disposable(()=>{this.v.delete(t),this.a.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(n,t,f){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,f),this.a.$registerQuickFixProvider(n,t),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,t){const f=new v.CancellationTokenSource().token;if(f.isCancellationRequested)return;const E=this.w.get(n);if(!E)return;const w=await E.provideTerminalQuickFixes(t,f);if(w!==null)return w}async $createContributedProfileTerminal(n,t){const f=new v.CancellationTokenSource().token;let E=await this.v.get(n)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,t);return}this.createTerminalFromOptions(E.options,t)}}async $provideLinks(n,t){const f=this.O(n);if(!f)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const w=new v.CancellationTokenSource;this.z.set(n,w);const O=[],V={terminal:f.value,line:t},j=[];for(const N of this.u)j.push(u.Promises.withAsyncBody(async U=>{w.token.onCancellationRequested(()=>U({provider:N,links:[]}));const $=await N.provideTerminalLinks(V,w.token)||[];w.token.isCancellationRequested||U({provider:N,links:$})}));const F=await Promise.all(j);if(w.token.isCancellationRequested)return[];const B=new Map;for(const N of F)N&&N.links.length>0&&O.push(...N.links.map(U=>{const $={id:p++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set($.id,{provider:N.provider,link:U}),$}));return this.y.set(n,B),O}$activateLink(n,t){const f=this.y.get(n)?.get(t);!f||f.provider.handleTerminalLink(f.link)}N(n,t){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const f=this.h[n];f&&(f.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,t)}O(n){return this.P(this.f,n)}P(n,t){const f=this.Q(n,t);return f!==null?n[f]:null}Q(n,t){let f=null;return n.some((E,w)=>E._id===t?(f=w,!0):!1),f}getEnvironmentVariableCollection(n){let t=this.l.get(n.identifier.value);return t||(t=new o,this.S(n.identifier.value,t)),t}R(n,t){const f=(0,T.serializeEnvironmentVariableCollection)(t.map);this.a.$setEnvironmentVariableCollection(n,t.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(n){n.forEach(t=>{const f=t[0],E=new o(t[1]);this.S(f,E)})}$acceptDefaultProfile(n,t){const f=this.m;this.m=n,this.n=t,f?.path!==n.path&&this.J.fire(n.path)}S(n,t){this.l.set(n,t),t.onDidChangeCollection(()=>{this.R(n,t)})}};i=xe([We(1,C.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Replace})}append(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,t){const f=this.map.get(n);(!f||f.value!==t.value||f.type!==t.type)&&(this.map.set(n,t),this.b.fire())}get(n){return this.map.get(n)}forEach(n,t){this.map.forEach((f,E)=>n.call(t,E,f,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends i{constructor(n){super(!1,n)}createTerminal(n,t,f){throw new L.NotSupportedError}createTerminalFromOptions(n,t){throw new L.NotSupportedError}};r=xe([We(0,C.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function c(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function s(m){return h.ThemeColor.isThemeColor(m)?m:void 0}});var Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)},Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a};define(De[274],Ce([1,0,15,19,22,21,3,63,88,6,23,9,30,5,20,137,14,7,57,94,75,27]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(N,U,$){this.j=$,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=N.getProxy(I.MainContext.MainThreadTesting),this.h=new V(this.f),this.g=new n(this.f),U.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const ae=z,ee=ae.tests[ae.tests.length-1].item.extId;return this.d.get(g.TestId.root(ee))?.collection.tree.get(ee)?.actual??(0,h.toItemFromContext)(z)}})}createTestController(N,U,$,z){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const ae=new k.DisposableStore,ee=ae.add(new h.ExtHostTestItemCollection(U,$,this.j));ee.root.label=$;const q=new Map,J=this.f,ie={items:ee.root.children,get label(){return $},set label(X){$=X,ee.root.label=X,J.$updateController(U,{label:$})},get refreshHandler(){return z},set refreshHandler(X){z=X,J.$updateController(U,{canRefresh:!!X})},get id(){return U},createRunProfile:(X,Y,Z,fe,ve,ke)=>{let Oe=(0,S.hash)(X);for(;q.has(Oe);)Oe++;return ke!==void 0&&(0,p.checkProposedApiEnabled)(N,"testContinuousRun"),new j(this.f,q,U,Oe,X,Y,Z,fe,ve,ke)},createTestItem(X,Y,Z){return new h.TestItemImpl(U,X,Y,Z)},createTestRun:(X,Y,Z=!0)=>this.g.createTestRun(U,ee,X,Y,Z),set resolveHandler(X){ee.resolveHandler=X},get resolveHandler(){return ee.resolveHandler},dispose:()=>{ae.dispose()}};J.$registerTestController(U,$,!!z),ae.add((0,k.toDisposable)(()=>J.$unregisterTestController(U)));const ge={controller:ie,collection:ee,profiles:q};return this.d.set(U,ge),ae.add((0,k.toDisposable)(()=>this.d.delete(U))),ae.add(ee.onDidGenerateDiff(X=>J.$publishDiff(U,X.map(D.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(N,U=R.CancellationToken.None){const $=t(N);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get($.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(ae=>g.TestId.fromExtHostTestItem(ae,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:F[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:N.exclude?.map(ae=>ae.id)},U)}$syncTests(){for(const{collection:N}of this.d.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,U,$){return(0,a.mapFind)(this.g.trackers,ae=>ae.id===N?ae.getCoverage(U):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(N,U,$,z){return(0,a.mapFind)(this.g.trackers,ee=>ee.id===N?ee.getCoverage(U):void 0)?.resolveFileCoverage($,z)??Promise.resolve([])}$configureRunProfile(N,U){this.d.get(N)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(N,U){await this.d.get(N)?.controller.refreshHandler?.(U)}$publishTestResults(N){this.results=Object.freeze(N.map(U=>(0,L.deepFreeze)(d.TestResults.to(U))).concat(this.results).sort((U,$)=>$.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(N,U){const $=this.d.get(g.TestId.fromString(N).controllerId)?.collection;$&&(await $.expand(N,U<0?1/0:U),$.flushDiff())}$acceptDiff(N){this.h.applyDiff(N.map(D.TestsDiffOp.deserialize))}async $runControllerTests(N,U){return Promise.all(N.map($=>this.k($,!1,U)))}async $startContinuousRun(N,U){const $=new R.CancellationTokenSource(U),z=await Promise.all(N.map(ae=>this.k(ae,!0,$.token)));return!U.isCancellationRequested&&!z.some(ae=>ae.error)&&await new Promise(ae=>U.onCancellationRequested(ae)),$.dispose(!0),z}async k(N,U,$){const z=this.d.get(N.controllerId);if(!z)return{};const{collection:ae,profiles:ee}=z,q=ee.get(N.profileId);if(!q)return{};const J=N.testIds.map(Y=>ae.tree.get(Y)).filter(T.isDefined),ie=N.excludeExtIds.map(Y=>z.collection.tree.get(Y)).filter(T.isDefined).filter(Y=>J.some(Z=>Z.fullId.compare(Y.fullId)===2));if(!J.length)return{};const ge=new u.TestRunRequest2(J.some(Y=>Y.actual instanceof h.TestItemRootImpl)?void 0:J.map(Y=>Y.actual),ie.map(Y=>Y.actual),q,U),X=(0,D.isStartControllerTests)(N)&&this.g.prepareForMainThreadTestRun(ge,f.fromInternal(N,z.collection),$);try{return await q.runHandler(ge,$),{}}catch(Y){return{error:String(Y)}}finally{X&&(X.hasRunningTasks&&!$.isCancellationRequested&&await C.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.g.cancelAllRuns():this.g.cancelRunById(N)}};r=xe([We(0,y.IExtHostRpcService)],r),e.ExtHostTesting=r;const c=1e4;var s;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(s||(s={}));class m extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(N,U,$){super(),this.k=N,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource($));const z=this.B(new A.RunOnceScheduler(()=>this.m(),c));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const U=this.k.id,$=this.k.controllerId,z=(0,v.generateUuid)(),ae=new E(this.l,U,z),ee=ge=>(X,...Y)=>{if(J){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),ge(X,...Y))},q=(ge,X)=>{const Y=X instanceof Array?X.map(d.TestMessage.from):[d.TestMessage.from(X)];if(ge.uri&&ge.range){const Z={range:d.Range.from(ge.range),uri:ge.uri};for(const fe of Y)fe.location=fe.location||Z}this.l.$appendTestMessagesInRun(U,z,g.TestId.fromExtHostTestItem(ge,$).toString(),Y)};let J=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:N,get coverageProvider(){return ae.coverageProvider},set coverageProvider(ge){ae.coverageProvider=ge},enqueued:ee(ge=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(ge,$).toString(),1)}),skipped:ee(ge=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(ge,$).toString(),5)}),started:ee(ge=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(ge,$).toString(),2)}),errored:ee((ge,X,Y)=>{q(ge,X),this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(ge,$).toString(),6,Y)}),failed:ee((ge,X,Y)=>{q(ge,X),this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(ge,$).toString(),4,Y)}),passed:ee((ge,X)=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(ge,this.k.controllerId).toString(),3,X)}),appendOutput:(ge,X,Y)=>{J||(Y&&(this.k.isIncluded(Y)?this.s(Y):Y=void 0),this.l.$appendOutputToRun(U,z,l.VSBuffer.fromString(ge),X&&d.location.from(X),Y&&g.TestId.fromExtHostTestItem(Y,$).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(U,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:ie,coverage:ae}),this.l.$startedTestRunTask(U,{id:z,name:N,running:!0}),ie}m(){for(const{run:N}of this.f.values())N.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(N){if(!(N instanceof h.TestItemImpl))throw new b.InvalidTestItemError(N.id);if(this.g.has(g.TestId.fromExtHostTestItem(N,this.k.controllerId).toString()))return;const U=[],$=this.k.colllection.root;for(;;){const z=d.TestItem.from(N);if(U.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),N===$))break;N=N.parent||$}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class n{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,U,$){return this.f(N,U,$)}cancelRunById(N){for(const U of this.c.values())if(U.id===N){U.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,U,$,z,ae){const ee=this.c.get($);if(ee)return ee.createRun(z);const q=f.fromPublic(N,U,$,ae),J=t($);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!$.continuous,profile:J&&{group:F[J.kind],id:J.profileId},exclude:$.exclude?.map(ge=>g.TestId.fromExtHostTestItem(ge,U.root.id).toString())??[],id:q.id,include:$.include?.map(ge=>g.TestId.fromExtHostTestItem(ge,U.root.id).toString())??[U.root.id],persist:ae});const ie=this.f($,q);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(q.id),ie.dispose()}),ie.createRun(z)}f(N,U,$){const z=new m(U,this.d,$);return this.c.set(N,z),z.onEnd(()=>this.c.delete(N)),z}}e.TestRunCoordinator=n;const t=B=>{if(!!B.profile){if(!(B.profile instanceof j))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class f{static fromPublic(N,U,$,z){return new f(N,(0,v.generateUuid)(),$.include?.map(ae=>g.TestId.fromExtHostTestItem(ae,N).toString())??[N],$.exclude?.map(ae=>g.TestId.fromExtHostTestItem(ae,N).toString())??[],z,U)}static fromInternal(N,U){return new f(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,U)}constructor(N,U,$,z,ae,ee){this.controllerId=N,this.id=U,this.isPersisted=ae,this.colllection=ee,this.c=$.map(q=>q+"\0"),this.d=z.map(q=>q+"\0")}isIncluded(N){const U=g.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const $ of this.d)if(U===$||U.startsWith($))return!1;for(const $ of this.c)if(U===$||U.startsWith($))return!0;return!1}}e.TestRunDto=f;class E{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!N||(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,U,$){this.f=N,this.g=U,this.h=$}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(N,U){const $=await this.d;let z=$?.[N];return!this.c||!$||!z?[]:(z.detailedCoverage||(z=$[N]=await this.c.resolveFileCoverage?.(z,U)??z),z.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class w{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,d.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const U=g.TestId.parentId(N.item.extId);if(U&&this.g.has(U.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:U,f:$}=this;return{get added(){return[...N].map(z=>z.revived)},get updated(){return[...U].map(z=>z.revived)},get removed(){return[...$].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class O extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,U){return{...N,revived:d.TestItem.toPlain(N.item),depth:U?U.depth+1:0,children:new Set}}o(){return new w(this.q)}}class V{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(U=>U.revived)},dispose:(0,P.once)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new O;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class j{get label(){return this.d}set label(N){N!==this.d&&(this.d=N,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?d.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,U,$,z,ae,ee,q,J=!1,ie=void 0,ge=!1){this.controllerId=$,this.profileId=z,this.d=ae,this.kind=ee,this.runHandler=q,this.f=J,this._tag=ie,this.g=ge,i.set(this,void 0),o.set(this,void 0),Ze(this,i,N,"f"),Ze(this,o,U,"f"),U.set(z,this);const X=F[ee];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${ee}`);Be(this,i,"f").$publishTestRunProfile({profileId:z,controllerId:$,tag:ie?d.TestTag.namespace(this.controllerId,ie.id):null,label:ae,group:X,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ge})}dispose(){Be(this,o,"f")?.delete(this.profileId)&&(Ze(this,o,void 0,"f"),Be(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=j,i=new WeakMap,o=new WeakMap;const F={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(De[275],Ce([1,0,15,3,5,138,14,7]),function(ne,e,a,A,l,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,T){this.i=T,this.a=new A.Emitter,this.b=new A.Emitter,this.c=new A.Emitter,this.d=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(l.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const T=this.i.allEditors();return L?T:T.map(v=>v.value)}async showTextDocument(L,T,v){let I;typeof T=="number"?I={position:C.ViewColumn.from(T),preserveFocus:v}:typeof T=="object"?I={position:C.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?C.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:I={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(L.uri,I),h=y&&this.i.getEditor(y);if(h)return h.value;throw y?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,T){return new R.TextEditorDecorationType(this.h,L,T).value}$acceptEditorPropertiesChanged(L,T){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(T.options&&v._acceptOptions(T.options),T.selections){const I=T.selections.selections.map(C.Selection.to);v._acceptSelections(I)}if(T.visibleRanges){const I=a.coalesce(T.visibleRanges.map(C.Range.to));v._acceptVisibleRanges(I)}if(T.options&&this.b.fire({textEditor:v.value,options:{...T.options,lineNumbers:C.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const I=P.TextEditorSelectionChangeKind.fromValue(T.selections.source),y=T.selections.selections.map(C.Selection.to);this.a.fire({textEditor:v.value,selections:y,kind:I})}if(T.visibleRanges){const I=a.coalesce(T.visibleRanges.map(C.Range.to));this.c.fire({textEditor:v.value,visibleRanges:I})}}$acceptEditorPositionData(L){for(const T in L){const v=this.i.getEditor(T);if(!v)throw new Error("Unknown text editor");const I=C.ViewColumn.to(L[T]);v.value.viewColumn!==I&&(v._acceptViewColumn(I),this.d.fire({textEditor:v.value,viewColumn:I}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(De[276],Ce([1,0,2,4,5,6,7,14,26,9]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(I,y){this.b=new Map,this.c=new Map,this.a=I.getProxy(l.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(h,d)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&S.ExtensionIdentifier.equals(d,this.b.get(h.source)?.extension)){const u=h.uri===void 0?void 0:a.URI.revive(h.uri);return this.c.get(h.source)?.get(T(u))?.get(h.handle)}else return;return h}})}async $getTimeline(I,y,h,d){return this.b.get(I)?.provider.provideTimeline(a.URI.revive(y),h,d)}registerTimelineProvider(I,y,h,d){const u=new R.DisposableStore,g=this.d(y.id,d,u).bind(this);let b;y.onDidChange&&(b=y.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:y.id}),this));const D=this.c;return this.f({...y,scheme:I,onDidChange:void 0,async provideTimeline(p,i,o){i?.resetCache&&(u.clear(),D.get(y.id)?.clear());const r=await y.provideTimeline(p,i,o);if(r==null)return;const c=g(p,i);return{...r,source:y.id,items:r.items.map(c)}},dispose(){for(const p of D.values())p.get(y.id)?.clear();b?.dispose(),u.dispose()}},h)}d(I,y,h){return(d,u)=>{let g;if(u?.cacheResults){let b=this.c.get(I);b===void 0&&(b=new Map,this.c.set(I,b));const D=T(d);g=b.get(D),g===void 0&&(g=new Map,b.set(D,g))}return b=>{const{iconPath:D,...p}=b,i=`${I}|${b.id??b.timestamp}`;g?.set(i,b);let o,r,c;b.iconPath&&(D instanceof C.ThemeIcon?c={id:D.id,color:D.color}:a.URI.isUri(D)?(o=D,r=D):{light:o,dark:r}=D);let s;return C.MarkdownString.isMarkdownString(p.tooltip)?s=P.MarkdownString.from(p.tooltip):(0,k.isString)(p.tooltip)?s=p.tooltip:C.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=P.MarkdownString.from(p.detail)):(0,k.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=p.detail),{...p,id:p.id??void 0,handle:i,source:I,command:b.command?y.toInternal(b.command,h):void 0,icon:o,iconDark:r,themeIcon:c,tooltip:s,accessibilityInformation:b.accessibilityInformation}}}}f(I,y){if(this.b.get(I.id))throw new Error(`Timeline Provider ${I.id} already exists.`);return this.a.$registerTimelineProvider({id:I.id,label:I.label,scheme:I.scheme}),this.b.set(I.id,{provider:I,extension:y}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(I.id)?.clear();this.b.delete(I.id),this.a.$unregisterTimelineProvider(I.id),I.dispose()})}}e.ExtHostTimeline=L;function T(v){return v?.toString()}}),define(De[277],Ce([1,0,6,16,2,5]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,L,T){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const v=T.schemes.find(I=>!C.a.has(I));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(k,L),this.b.$registerUriOpener(k,T.schemes,S,T.label),(0,a.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,L){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener with id: ${S}`);const v=l.URI.revive(k);return T.canOpenExternalUri(v,L)}async $openUri(S,k,L){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener id: '${S}'`);return T.openExternalUri(l.URI.revive(k.resolvedUri),{sourceUri:l.URI.revive(k.sourceUri)},L)}}C.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=C}),define(De[278],Ce([1,0,5,2,6,12,26]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(k,L){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const T=P.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(T,L),this.b.$registerUriHandler(T,k),(0,l.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(T),this.b.$unregisterUriHandler(T)})}$handleExternalUri(k,L){const T=this.d.get(k);if(!T)return Promise.resolve(void 0);try{T.handleUri(A.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(k){return A.URI.revive(await this.b.$createAppUri(k))}}P.a=0,e.ExtHostUrls=P});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[80],Ce([1,0,3,16,23,2,198,223,95,5]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";var L,T,v,I,y,h,d,u,g,b,D,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(w,O,V,j,F,B,N){L.set(this,void 0),T.set(this,void 0),v.set(this,void 0),I.set(this,void 0),y.set(this,void 0),h.set(this,void 0),d.set(this,""),u.set(this,void 0),g.set(this,!1),b.set(this,!1),D.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new a.Emitter),this._onDidDispose=Be(this,i,"f").event,Ze(this,L,w,"f"),Ze(this,T,O,"f"),Ze(this,u,V,"f"),Ze(this,I,j,"f"),Ze(this,y,F,"f"),Ze(this,h,B,"f"),Ze(this,D,r(B),"f"),Ze(this,p,c(B),"f"),Ze(this,v,N,"f")}dispose(){Ze(this,g,!0,"f"),Be(this,i,"f").fire(),Be(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return Ze(this,b,!0,"f"),(0,S.asWebviewUri)(w,Be(this,I,"f"))}get cspSource(){const w=Be(this,h,"f").extensionLocation;if(w.scheme===A.Schemas.https||w.scheme===A.Schemas.http){let O=w.toString();return O.endsWith("/")||(O+="/"),O+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Be(this,d,"f")}set html(w){this.a(),Be(this,d,"f")!==w&&(Ze(this,d,w,"f"),Be(this,p,"f")&&!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(Ze(this,b,!0,"f"),Be(this,v,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,T,"f").$setHtml(Be(this,L,"f"),this.b(w)))}get options(){return this.a(),Be(this,u,"f")}set options(w){this.a(),l.equals(Be(this,u,"f"),w)||Be(this,T,"f").$setOptions(Be(this,L,"f"),n(Be(this,h,"f"),Be(this,y,"f"),w)),Ze(this,u,w,"f")}async postMessage(w){if(Be(this,g,"f"))return!1;const O=(0,P.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Be(this,D,"f")});return Be(this,T,"f").$postMessage(Be(this,L,"f"),O.message,...O.buffers)}a(){if(Be(this,g,"f"))throw new Error("Webview is disposed")}b(w){if(!Be(this,p,"f"))return w;const O=Be(this,h,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,V=Be(this,h,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Be(this,h,"f").extensionLocation.authority:void 0;return w.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,F,B,N,U,$)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(U)}),ae=(0,S.asWebviewUri)(z,{isRemote:O,authority:V}).toString();return`${F}${ae}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,F,B,N,U,$)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(U)}),ae=(0,S.asWebviewUri)(z,{isRemote:O,authority:V}).toString();return`${F}${ae}${$}`})}}e.ExtHostWebview=o,L=new WeakMap,T=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,D=new WeakMap,p=new WeakMap,i=new WeakMap;function r(E){try{const w=(0,C.normalizeVersion)((0,C.parseVersion)(E.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function c(E){try{const w=(0,C.normalizeVersion)((0,C.parseVersion)(E.engines.vscode));return w?w.majorBase<1||w.majorBase===1&&w.minorBase<60:!1}catch{return!1}}class s{constructor(w,O,V,j,F){this.c=O,this.d=V,this.e=j,this.f=F,this.b=new Map,this.a=w.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(w,O,V){const j=this.g(w);if(j){const{message:F}=(0,P.deserializeWebviewMessage)(O,V.value);j._onMessageEmitter.fire(F)}}$onMissingCsp(w,O){this.e.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,O,V){const j=new o(w,this.a,t(O),this.c,this.d,V,this.f);return this.b.set(w,j),j._onDidDispose(()=>{this.b.delete(w)}),j}deleteWebview(w){this.b.delete(w)}g(w){return this.b.get(w)}}e.ExtHostWebviews=s;function m(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=m;function n(E,w,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||f(E,w)}}e.serializeWebviewOptions=n;function t(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(w=>R.URI.from(w))}}function f(E,w){return[...(w?.getWorkspaceFolders()||[]).map(O=>O.uri),E.extensionLocation]}}),define(De[279],Ce([1,0,21,88,6,16,24,2,14,80,74,5,7]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(o,r){this.document=o,this.b=r,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,r){await this.f(o).undo(),r||this.disposeBackup()}async redo(o,r){await this.f(o).redo(),r||this.disposeBackup()}disposeEdits(o){for(const r of o)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=p(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const r=this.c.get(o,0);if(!r)throw new Error("No edit found");return r}}class y{constructor(){this.a=new Map}get(o,r){return this.a.get(this.b(o,r))}add(o,r,c){const s=this.b(o,r.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${o} resource:${r.uri}`);const m=new I(r,c);return this.a.set(s,m),m}delete(o,r){const c=this.b(o,r.uri);this.a.delete(c)}b(o,r){return`${o}@@@${r}`}}var h;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(h||(h={}));class d{constructor(){this.a=new Map}addTextProvider(o,r,c){return this.b(0,o,r,c)}addCustomProvider(o,r,c){return this.b(1,o,r,c)}get(o){return this.a.get(o)}b(o,r,c,s){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:o,extension:c,provider:s}),new v.Disposable(()=>this.a.delete(r))}}class u{constructor(o,r,c,s,m){this.d=r,this.f=c,this.g=s,this.h=m,this.b=new d,this.c=new y,this.a=o.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,r,c,s){const m=new l.DisposableStore;return b(c)?(m.add(this.b.addTextProvider(r,o,c)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(o),r,s.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(o))):(m.add(this.b.addCustomProvider(r,o,c)),g(c)&&m.add(c.onDidChangeCustomDocument(n=>{const t=this.i(r,n.document.uri);if(D(n)){const f=t.addEdit(n);this.a.$onDidEdit(n.document.uri,r,f,n.label)}else this.a.$onContentChange(n.document.uri,r)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(o),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(o))),v.Disposable.from(m,new v.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(o,r,c,s,m){const n=this.b.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${r}'`);const t=P.URI.revive(o),f=await n.provider.openCustomDocument(t,{backupId:c,untitledDocumentData:s?.buffer},m);let E;return g(n.provider)&&this.f&&(E=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(r,f,E),{editable:g(n.provider)}}async $disposeCustomDocument(o,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=P.URI.revive(o),{document:m}=this.i(r,s);this.c.delete(r,m),m.dispose()}async $resolveCustomEditor(o,r,c,s,m,n){const t=this.b.get(c);if(!t)throw new Error(`No provider found for '${c}'`);const f=S.ViewColumn.to(m),E=this.g.createNewWebview(r,s.contentOptions,t.extension),w=this.h.createNewWebviewPanel(r,c,s.title,f,s.options,E,!0),O=P.URI.revive(o);switch(t.type){case 1:{const{document:V}=this.i(c,O);return t.provider.resolveCustomEditor(V,w,n)}case 0:{const V=this.d.getDocument(O);return t.provider.resolveCustomTextEditor(V,w,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,r,c){this.i(r,o).disposeEdits(c)}async $onMoveCustomEditor(o,r,c){const s=this.b.get(c);if(!s)throw new Error(`No provider found for '${c}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const m=this.h.getWebviewPanel(o);if(!m)throw new Error("No webview found");const n=P.URI.revive(r),t=this.d.getDocument(n);await s.provider.moveCustomTextEditor(t,m,a.CancellationToken.None)}async $undo(o,r,c,s){return this.i(r,o).undo(c,s)}async $redo(o,r,c,s){return this.i(r,o).redo(c,s)}async $revert(o,r,c){const s=this.i(r,o);await this.j(r).revertCustomDocument(s.document,c),s.disposeBackup()}async $onSave(o,r,c){const s=this.i(r,o);await this.j(r).saveCustomDocument(s.document,c),s.disposeBackup()}async $onSaveAs(o,r,c,s){const m=this.i(r,o);return this.j(r).saveCustomDocumentAs(m.document,P.URI.revive(c),s)}async $backup(o,r,c){const s=this.i(r,o),n=await this.j(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},c);return s.updateBackup(n),n.id}i(o,r){const c=this.c.get(o,P.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(o){const c=this.b.get(o)?.provider;if(!c||!g(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=u;function g(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function D(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const o=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,A.hash)(o)+""}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[280],Ce([1,0,3,6,2,30,14,80,5,7]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";var L,T,v,I,y,h,d,u,g,b,D,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(m,n,t,f){super(),L.set(this,void 0),T.set(this,void 0),v.set(this,void 0),I.set(this,void 0),y.set(this,void 0),h.set(this,void 0),d.set(this,void 0),u.set(this,void 0),g.set(this,!0),b.set(this,void 0),D.set(this,!1),p.set(this,this.B(new a.Emitter)),this.onDidDispose=Be(this,p,"f").event,i.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Be(this,i,"f").event,Ze(this,L,m,"f"),Ze(this,T,n,"f"),Ze(this,I,t,"f"),Ze(this,v,f.viewType,"f"),Ze(this,y,f.panelOptions,"f"),Ze(this,u,f.viewColumn,"f"),Ze(this,h,f.title,"f"),Ze(this,b,f.active,"f")}dispose(){Be(this,D,"f")||(Ze(this,D,!0,"f"),Be(this,p,"f").fire(),Be(this,T,"f").$disposeWebview(Be(this,L,"f")),Be(this,I,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,I,"f")}get viewType(){return this.c(),Be(this,v,"f")}get title(){return this.c(),Be(this,h,"f")}set title(m){this.c(),Be(this,h,"f")!==m&&(Ze(this,h,m,"f"),Be(this,T,"f").$setTitle(Be(this,L,"f"),m))}get iconPath(){return this.c(),Be(this,d,"f")}set iconPath(m){this.c(),Be(this,d,"f")!==m&&(Ze(this,d,m,"f"),Be(this,T,"f").$setIconPath(Be(this,L,"f"),l.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Be(this,y,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,u,"f")=="number"&&Be(this,u,"f")<0))return Be(this,u,"f")}get active(){return this.c(),Be(this,b,"f")}get visible(){return this.c(),Be(this,g,"f")}_updateViewState(m){Be(this,D,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Ze(this,b,m.active,"f"),Ze(this,g,m.visible,"f"),Ze(this,u,m.viewColumn,"f"),Be(this,i,"f").fire({webviewPanel:this}))}reveal(m,n){this.c(),Be(this,T,"f").$reveal(Be(this,L,"f"),{viewColumn:typeof m>"u"?void 0:C.ViewColumn.from(m),preserveFocus:!!n})}c(){if(Be(this,D,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,D=new WeakMap,p=new WeakMap,i=new WeakMap;class r{static c(){return(0,R.generateUuid)()}constructor(m,n,t){this.g=n,this.h=t,this.e=new Map,this.f=new Map,this.d=m.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(m,n,t,f,E={}){const w=typeof f=="object"?f.viewColumn:f,O={viewColumn:C.ViewColumn.from(w),preserveFocus:typeof f=="object"&&!!f.preserveFocus},V=(0,P.shouldSerializeBuffersForPostMessage)(m),j=r.c();this.d.$createWebviewPanel((0,P.toExtensionData)(m),j,n,{title:t,panelOptions:c(E),webviewOptions:(0,P.serializeWebviewOptions)(m,this.h,E),serializeBuffersForPostMessage:V},O);const F=this.g.createNewWebview(j,E,m);return this.createNewWebviewPanel(j,n,t,w,E,F,!0)}$onDidChangeWebviewPanelViewStates(m){const n=Object.keys(m);n.sort((t,f)=>{const E=m[t],w=m[f];return E.active?1:w.active?-1:+E.visible-+w.visible});for(const t of n){const f=this.getWebviewPanel(t);if(!f)continue;const E=m[t];f._updateViewState({active:E.active,visible:E.visible,viewColumn:C.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.e.delete(m),this.g.deleteWebview(m)}registerWebviewPanelSerializer(m,n,t){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:t,extension:m}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(m)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(m,n,t,f){const E=this.f.get(n);if(!E)throw new Error(`No serializer found for '${n}'`);const{serializer:w,extension:O}=E,V=this.g.createNewWebview(m,t.webviewOptions,O),j=this.createNewWebviewPanel(m,n,t.title,f,t.panelOptions,V,t.active);await w.deserializeWebviewPanel(j,t.state)}createNewWebviewPanel(m,n,t,f,E,w,O){const V=new o(m,this.d,w,{viewType:n,title:t,viewColumn:f,panelOptions:E,active:O});return this.e.set(m,V),V}getWebviewPanel(m){return this.e.get(m)}}e.ExtHostWebviewPanels=r;function c(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[281],Ce([1,0,3,6,80,14,5,7]),function(ne,e,a,A,l,R,C,P){"use strict";var S,k,L,T,v,I,y,h,d,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends A.Disposable{constructor(i,o,r,c,s,m){super(),S.set(this,void 0),k.set(this,void 0),L.set(this,void 0),T.set(this,void 0),v.set(this,!1),I.set(this,void 0),y.set(this,void 0),h.set(this,void 0),d.set(this,void 0),u.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Be(this,u,"f").event,g.set(this,this.B(new a.Emitter)),this.onDidDispose=Be(this,g,"f").event,Ze(this,L,r,"f"),Ze(this,y,c,"f"),Ze(this,S,i,"f"),Ze(this,k,o,"f"),Ze(this,T,s,"f"),Ze(this,I,m,"f")}dispose(){Be(this,v,"f")||(Ze(this,v,!0,"f"),Be(this,g,"f").fire(),Be(this,T,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,y,"f")}set title(i){this.a(),Be(this,y,"f")!==i&&(Ze(this,y,i,"f"),Be(this,k,"f").$setWebviewViewTitle(Be(this,S,"f"),i))}get description(){return this.a(),Be(this,h,"f")}set description(i){this.a(),Be(this,h,"f")!==i&&(Ze(this,h,i,"f"),Be(this,k,"f").$setWebviewViewDescription(Be(this,S,"f"),i))}get visible(){return Be(this,I,"f")}get webview(){return Be(this,T,"f")}get viewType(){return Be(this,L,"f")}_setVisible(i){i===Be(this,I,"f")||Be(this,v,"f")||(Ze(this,I,i,"f"),Be(this,u,"f").fire())}get badge(){return this.a(),Be(this,d,"f")}set badge(i){this.a(),!(i?.value===Be(this,d,"f")?.value&&i?.tooltip===Be(this,d,"f")?.tooltip)&&(Ze(this,d,R.ViewBadge.from(i),"f"),Be(this,k,"f").$setWebviewViewBadge(Be(this,S,"f"),i))}show(i){this.a(),Be(this,k,"f").$show(Be(this,S,"f"),!!i)}a(){if(Be(this,v,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,L=new WeakMap,T=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,g=new WeakMap;class D{constructor(i,o){this.d=o,this.b=new Map,this.c=new Map,this.a=i.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,r,c){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:r,extension:i}),this.a.$registerWebviewViewProvider((0,l.toExtensionData)(i),o,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(i)}),new P.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,r,c,s){const m=this.b.get(o);if(!m)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:t}=m,f=this.d.createNewWebview(i,{},t),E=new b(i,this.a,o,r,f,!0);this.c.set(i,E),await n.resolveWebviewView(E,{state:c},s)}async $onDidChangeWebviewViewVisibility(i,o){this.e(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.e(i);this.c.delete(i),o.dispose(),this.d.deleteWebview(i)}e(i){const o=this.c.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=D}),define(De[141],Ce([1,0,3,5,2,16,8,4,20]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class an{get state(){return this.d}constructor(T){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=T.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(T){T!==this.d.focused&&(this.d={...this.d,focused:T},this.c.fire(this.d))}openUri(T,v){let I;if(typeof T=="string"){I=T;try{T=l.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,C.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this.b.$openUri(T,I,v)}async asExternalUri(T,v){if((0,C.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this.b.$asExternalUri(T,v);return l.URI.from(I)}};k.a={focused:!0},k=xe([We(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(De[282],Ce([1,0,119,283,70,40,2,13,47]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(v,I,y){this.b=v,this.c=I,this.f=y,this.a=A.createServer((h,d)=>this.h(h,d)),this.g().catch(h=>(I.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,I){const y=(d,u)=>{I.writeHead(d,{"content-type":"application/json"}),I.end(JSON.stringify(u||null),g=>g&&this.c.error(g))},h=[];v.setEncoding("utf8"),v.on("data",d=>h.push(d)),v.on("end",async()=>{try{const d=JSON.parse(h.join(""));let u;switch(d.type){case"open":u=await this.i(d);break;case"openExternal":u=await this.j(d);break;case"status":u=await this.l(d);break;case"extensionManagement":u=await this.k(d);break;default:y(404,`Unknown message type: ${d.type}`);break}y(200,u)}catch(d){const u=d instanceof Error?d.message:JSON.stringify(d);y(500,u),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:I,folderURIs:y,forceNewWindow:h,diffMode:d,mergeMode:u,addMode:g,forceReuseWindow:b,gotoLineMode:D,waitMarkerFilePath:p,remoteAuthority:i}=v,o=[];if(Array.isArray(y))for(const m of y)try{o.push({folderUri:C.URI.parse(m)})}catch{}if(Array.isArray(I))for(const m of I)try{(0,S.hasWorkspaceFileExtension)(m)?o.push({workspaceUri:C.URI.parse(m)}):o.push({fileUri:C.URI.parse(m)})}catch{}const r=p?C.URI.file(p):void 0,s={forceNewWindow:h,diffMode:d,mergeMode:u,addMode:g,gotoLineMode:D,forceReuseWindow:b,preferNewWindow:!b&&!r&&!g,waitMarkerFileURI:r,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",o,s),""}async j(v){for(const I of v.uris){const y=C.URI.parse(I),h=y.scheme==="file"?y:I;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(v){const I=h=>h?.map(d=>/\.vsix$/i.test(d)?C.URI.parse(d):d),y={list:v.list,install:I(v.install),uninstall:I(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",y)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=k;let L=class extends k{constructor(v,I){super(v,I,(0,a.createRandomIPCHandle)())}};L=xe([We(0,R.IExtHostCommands),We(1,P.ILogService)],L),e.CLIServer=L}),define(De[284],Ce([1,0,254,25,20]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let C=class extends a.AbstractExtHostConsoleForwarder{constructor(S,k){super(S,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,k,L){const T=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,T.write(`
START_NATIVE_LOG
`),k.apply(console,L),T.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,k){const L=process[S],T=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(I,y,h)=>{if(!this.g){v+=I.toString(y);const d=v.length>R?v.length:v.lastIndexOf(`
`);d!==-1&&(console[k](v.slice(0,d)),v=v.slice(d+1))}T.call(L,I,y,h)}})}};C=xe([We(0,l.IExtHostRpcService),We(1,A.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(De[285],Ce([1,0,11,89,30,40,6,5,2,20]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(v,I){super();const y=v.getProxy(P.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async h=>{const d=S.URI.file((0,a.join)((0,A.tmpdir)(),(0,l.generateUuid)()));return await y.$download(h,d),d})}};L=xe([We(0,k.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(De[286],Ce([1,0,140,16,205,30]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends a.ExtHostLoggerService{k(S,k,L){return S.scheme===A.Schemas.file?new l.SpdLogLogger(L?.name||(0,R.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,k):super.k(S,k,L)}registerLogger(S){super.registerLogger(S),this.l.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this.l.$deregisterLogger(S)}}e.ExtHostLoggerService=C}),define(De[287],Ce([1,0,70,11,2,79,6,16,19,29]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const o=await super.g(i);if(o.scheme!==P.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const r=o.fsPath;let c=0;do{let s;c===0?s=r:s=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await T(s);const m=A.join(s,"vscode.lock"),n=await h(this.d,m,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),l.URI.file(s);c++}while(c<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(p){try{await k.Promises.stat(p);return}catch{}try{await k.Promises.mkdir(p,{recursive:!0})}catch{}}const v=1e3,I=10*60*1e3;class y extends C.Disposable{constructor(i,o){super(),this.b=i,this.c=o,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await d(i,o);(!r||r.pid!==process.pid)&&(i.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(o,new Date,new Date)}catch(c){i.error(c),i.info(`Lock '${o}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+i};await k.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function h(p,i,o){try{const c={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(i,JSON.stringify(c),{flag:"wx"})}catch(c){p.error(c)}const r=await d(p,i);return!r||r.pid!==process.pid?o?(p.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),b(p,i)):(p.info(`Lock '${i}': Lock acquired.`),new y(p,i))}async function d(p,i){let o;try{o=await k.Promises.readFile(i)}catch(r){return p.error(r),null}try{return JSON.parse(String(o))}catch(r){return p.error(r),null}}async function u(p,i){let o;try{o=await k.Promises.stat(i)}catch(r){return p.error(r),0}return o.mtime.getTime()}function g(p){try{return process.kill(p,0),!0}catch{return!1}}async function b(p,i){const o=await d(p,i);if(!o)return p.info(`Lock '${i}': Could not read pid of lock holder.`),D(p,i);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?p.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):p.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await u(p,i)===0)return D(p,i);n=o.willReleaseAt-Date.now()}return D(p,i)}}if(!g(o.pid))return p.info(`Lock '${i}': The pid ${o.pid} appears to be gone.`),D(p,i);const r=await u(p,i),c=Date.now()-r;if(c<=I)return p.info(`Lock '${i}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;p.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const s=await u(p,i),m=Date.now()-s;return m<=I?(p.info(`Lock '${i}': The lock does not look stale, elapsed: ${m} ms, giving up.`),null):(p.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),D(p,i))}async function D(p,i){p.info(`Lock '${i}': Deleting a stale lock.`);try{await k.Promises.unlink(i)}catch{}return h(p,i,!0)}}),define(De[288],Ce([1,0,30,20,41]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends l.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,S,k){return this.createTerminalFromOptions({name:P,shellPath:S,shellArgs:k})}createTerminalFromOptions(P,S){const k=new l.ExtHostTerminal(this.a,(0,a.generateUuid)(),P,P.name);return this.f.push(k),k.create(P,this.L(P,S)),k.value}};R=xe([We(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(De[289],Ce([1,0,5,20,186,6,25,2,46,24,29,7,10,55,3,129,102,13]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class g extends h.DisposableTunnel{}function b(n){const t=n.trim().split(`
`),f=[];return t.forEach(w=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);O&&O.length>=3&&f.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),f.reduce((w,O)=>(w[O.socket]=O,w),{})}e.getSockets=b;function D(...n){const t=[].concat(...n.map(i));return[...new Map(t.filter(f=>f.st==="0A").map(f=>{const E=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:p(E[0]),port:parseInt(E[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=D;function p(n){let t="";if(n.length===8)for(let f=n.length-2;f>=0;f-=2)t+=parseInt(n.substr(f,2),16),f!==0&&(t+=".");else for(let f=n.length-4;f>=0;f-=4)t+=parseInt(n.substr(f,4),16).toString(16),f!==0&&(t+=":");return t}function i(n){const t=n.trim().split(`
`),f=t.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return t.map(w=>w.trim().split(/\s+/).reduce((O,V,j)=>(O[f[j]||j]=V,O),{}))}e.loadConnectionTable=i;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function r(n){const t=n.trim().split(`
`),f=[];return t.forEach(E=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);w&&w.length>=4&&f.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),f}e.getRootProcesses=r;async function c(n,t,f){const E=f.reduce((O,V)=>(O[V.pid]=V,O),{}),w=[];return n.forEach(({socket:O,ip:V,port:j})=>{const F=t[O]?t[O].pid:void 0,B=F?E[F]?.cmd:void 0;F&&B&&!o(B)&&w.push({host:V,port:j,detail:B,pid:F})}),w}e.findPorts=c;function s(n,t,f){const E=new Map,w=r(t);for(const O of n){const V=f.get(O.port);if(V){E.set(O.port,V);continue}const j=w.find(F=>F.cmd.includes(`${O.port}`));if(j){let F=j,B;do B=w.find(N=>N.ppid===F.pid),B&&(F=B);while(B);E.set(O.port,{host:O.ip,port:O.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=s;let m=class extends R.Disposable{constructor(t,f,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new y.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=t.getProxy(a.MainContext.MainThreadTunnelService),v.isLinux&&f.remote.isRemote&&f.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(t,f){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const E=await this.a.$openTunnel(f,t.displayName);if(E){const w=new g(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(w),w}}async getTunnels(){return this.a.$getTunnels()}p(t){return Math.max(t*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(t,f){const E=this.r();return this.l.set(E,{selector:t,provider:f}),this.a.$registerPortsAttributesProvider(t,E),new T.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(t,f,E,w,O){const V=[];for(const F of t){const B=this.l.get(F);if(!B)return[];V.push(...await Promise.all(f.map(async N=>B.provider.providePortAttributes(N,E,w,O))))}const j=V.filter(F=>!!F);return j.length>0?j.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(t){if(t&&this.h)return;this.h=t;const f=new d.MovingAverage;let E;for(;this.h;){const w=new Date().getTime(),O=(await this.findCandidatePorts()).filter(j=>(0,h.isLocalhost)(j.host)||(0,h.isAllInterfaces)(j.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(j=>j.port).join(", ")}`);const V=new Date().getTime()-w;f.update(V),(!E||JSON.stringify(E)!==JSON.stringify(O))&&(E=O,await this.a.$onFoundNewCandidates(E)),await new Promise(j=>setTimeout(()=>j(),this.p(f.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.c=t.showCandidatePort,this.a.$setCandidateFilter()),t.tunnelFactory){this.b=t.tunnelFactory;let f=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const E=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:f}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(t,f){if(this.f.has(t.host)){const E=this.f.get(t.host);E.has(t.port)&&(f&&E.get(t.port).disposeListener.dispose(),await E.get(t.port).tunnel.dispose(),E.delete(t.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(t,f){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(t,f);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const w=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(t.remoteAddress.host)||this.f.set(t.remoteAddress.host,new Map);const O=this.B(w.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(w.remoteAddress))));return this.f.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:w,disposeListener:O}),I.TunnelDtoConverter.fromApiTunnel(w)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const f=await Promise.all(t.map(w=>this.c(w.host,w.port,w.detail??""))),E=t.filter((w,O)=>f[O]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(w=>w.port).join(", ")} to ${E.map(w=>w.port).join(", ")}`),E}async findCandidatePorts(){let t="",f="";try{t=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=D(t,f),w=await new Promise($=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,ae,ee)=>{$(ae)})}),O=b(w),V=await L.Promises.readdir("/proc"),j=[];for(const $ of V)try{const z=Number($),ae=k.joinPath(P.URI.file("/proc"),$);if((await L.Promises.stat(ae.fsPath)).isDirectory()&&!isNaN(z)){const q=await L.Promises.readlink(k.joinPath(ae,"cwd").fsPath),J=await L.Promises.readFile(k.joinPath(ae,"cmdline").fsPath,"utf8");j.push({pid:z,cwd:q,cmd:J})}}catch{}const F=[],B=E.filter($=>{const z=O[$.socket];return z||F.push($),z}),N=c(B,O,j);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const $=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(ae,ee,q)=>{z(ee)})});this.j=s(F,$,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(z=>z.port).join(", ")}`)}return N.then($=>U?$.concat(U):$)}};m=xe([We(0,A.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,u.ILogService)],m),e.ExtHostTunnelService=m}),define(De[290],Ce([1,0,19,22,21,12,3,6,114,248,58]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(E,w){try{return JSON.stringify(E,w)}catch{return"null"}}const I="$$ref$$",y={[I]:-1};class h{constructor(w,O){this.jsonString=w,this.referencedBuffers=O}}function d(E,w=null,O=!1){const V=[];return{jsonString:(O?v:JSON.stringify)(E,(F,B)=>{if(typeof B>"u")return y;if(typeof B=="object"){if(B instanceof A.VSBuffer){const N=V.push(B)-1;return{[I]:N}}if(w)return w(F,B)}return B}),referencedBuffers:V}}e.stringifyJsonWithBufferRefs=d;function u(E,w,O){return JSON.parse(E,(V,j)=>{if(j){const F=j[I];if(typeof F=="number")return w[F];if(O&&j.$mid===1)return O.transformIncoming(j)}return j})}e.parseJsonAndRestoreBufferRefs=u;function g(E,w){return JSON.stringify(E,w)}function b(E){return E?(w,O)=>O&&O.$mid===1?E.transformOutgoing(O):O:null}var D;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},o=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends P.Disposable{constructor(w,O=null,V=null){super(),this[T]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=O,this.g=V,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let j=0,F=L.ProxyIdentifier.count;j<F;j++)this.k[j]=null,this.l[j]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(j=>this.G(j))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+c.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+c.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,S.transformIncomingURIs)(w,this.g):w}getProxy(w){const{nid:O,sid:V}=w;return this.l[O]||(this.l[O]=this.F(O,V)),this.l[O]}F(w,O){const V={get:(j,F)=>(typeof F=="string"&&!j[F]&&F.charCodeAt(0)===36&&(j[F]=(...B)=>this.O(w,F,B)),F===r?O:j[F])};return new Proxy(Object.create(null),V)}set(w,O){return this.k[w.nid]=O,O}assertRegistered(w){for(let O=0,V=w.length;O<V;O++){const j=w[O];if(!this.k[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}G(w){if(this.j)return;const O=w.byteLength,V=s.read(w,0),j=V.readUInt8(),F=V.readUInt32();switch(j){case 1:case 2:{let{rpcId:B,method:N,args:U}=n.deserializeRequestJSONArgs(V);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(O,F,B,N,U,j===2);break}case 3:case 4:{let{rpcId:B,method:N,args:U}=n.deserializeRequestMixedArgs(V);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(O,F,B,N,U,j===4);break}case 5:{this.f?.logIncoming(O,F,0,"ack"),this.z(F);break}case 6:{this.I(O,F);break}case 7:{this.J(O,F,void 0);break}case 9:{let B=n.deserializeReplyOKJSON(V);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.J(O,F,B);break}case 10:{const B=n.deserializeReplyOKJSONWithBuffers(V,this.g);this.J(O,F,B);break}case 8:{const B=n.deserializeReplyOKVSBuffer(V);this.J(O,F,B);break}case 11:{let B=n.deserializeReplyErrError(V);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.L(O,F,B);break}case 12:{this.L(O,F,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,O,V,j,F,B){this.f?.logIncoming(w,O,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(V)}.${j}(`,F);const N=String(O);let U,$;if(B){const ae=new l.CancellationTokenSource;F.push(ae.token),U=this.M(V,j,F),$=()=>ae.cancel()}else U=this.M(V,j,F),$=i;this.p[N]=$;const z=n.serializeAcknowledged(O);this.f?.logOutgoing(z.byteLength,O,1,"ack"),this.c.send(z),U.then(ae=>{delete this.p[N];const ee=n.serializeReplyOK(O,ae,this.h);this.f?.logOutgoing(ee.byteLength,O,1,"reply:",ae),this.c.send(ee)},ae=>{delete this.p[N];const ee=n.serializeReplyErr(O,ae);this.f?.logOutgoing(ee.byteLength,O,1,"replyErr:",ae),this.c.send(ee)})}I(w,O){this.f?.logIncoming(w,O,1,"receiveCancel");const V=String(O);this.p[V]?.()}J(w,O,V){this.f?.logIncoming(w,O,0,"receiveReply:",V);const j=String(O);if(!this.s.hasOwnProperty(j))return;const F=this.s[j];delete this.s[j],F.resolveOk(V)}L(w,O,V){this.f?.logIncoming(w,O,0,"receiveReplyErr:",V);const j=String(O);if(!this.s.hasOwnProperty(j))return;const F=this.s[j];delete this.s[j];let B;V&&(V.$isError?(B=new Error,B.name=V.name,B.message=V.message,B.stack=V.stack):B=V),F.resolveErr(B)}M(w,O,V){try{return Promise.resolve(this.N(w,O,V))}catch(j){return Promise.reject(j)}}N(w,O,V){const j=this.k[w];if(!j)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(w));const F=j[O];if(typeof F!="function")throw new Error("Unknown method "+O+" on actor "+(0,L.getStringIdentifierForProxy)(w));return F.apply(j,V)}O(w,O,V){if(this.j)return new k.CanceledLazyPromise;let j=null;if(V.length>0&&l.CancellationToken.isCancellationToken(V[V.length-1])&&(j=V.pop()),j&&j.isCancellationRequested)return Promise.reject(R.canceled());const F=n.serializeRequestArguments(V,this.h),B=++this.m,N=String(B),U=new k.LazyPromise;j&&j.onCancellationRequested(()=>{const z=n.serializeCancel(B);this.f?.logOutgoing(z.byteLength,B,0,"cancel"),this.c.send(n.serializeCancel(B))}),this.s[N]=U,this.y(B);const $=n.serializeRequest(B,w,O,F,!!j);return this.f?.logOutgoing($.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(w)}.${O}(`,V),this.c.send($),U}}T=o,c.a=3*1e3,e.RPCProtocol=c;class s{static alloc(w,O,V){const j=new s(A.VSBuffer.alloc(V+1+4),0);return j.writeUInt8(w),j.writeUInt32(O),j}static read(w,O){return new s(w,O)}get buffer(){return this.a}constructor(w,O){this.a=w,this.b=O}static sizeUInt8(){return 1}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+w).toString();return this.b+=w,V}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+w).toString();return this.b+=w,V}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+w);return this.b+=w,O}static sizeMixedArray(w){let O=0;O+=1;for(let V=0,j=w.length;V<j;V++){const F=w[V];switch(O+=1,F.type){case 1:O+=this.sizeLongString(F.value);break;case 2:O+=this.sizeVSBuffer(F.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(F.value);for(let B=0;B<F.buffers.length;++B)O+=this.sizeVSBuffer(F.buffers[B]);break;case 4:break}}return O}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let O=0,V=w.length;O<V;O++){const j=w[O];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let F=0;F<j.buffers.length;++F)this.writeBuffer(j.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const O=new Array(w);for(let V=0;V<w;V++)switch(this.readUInt8()){case 1:O[V]=this.readLongString();break;case 2:O[V]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),B=this.readLongString(),N=[];for(let U=0;U<F;++U)N.push(this.readVSBuffer());O[V]=new L.SerializableObjectWithBuffers(u(B,N,null));break}case 4:O[V]=void 0;break}return O}}s.sizeUInt32=4;var m;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(m||(m={}));class n{static a(w){for(let O=0,V=w.length;O<V;O++)if(w[O]instanceof A.VSBuffer||w[O]instanceof L.SerializableObjectWithBuffers||typeof w[O]>"u")return!0;return!1}static serializeRequestArguments(w,O){if(this.a(w)){const V=[];for(let j=0,F=w.length;j<F;j++){const B=w[j];if(B instanceof A.VSBuffer)V[j]={type:2,value:B};else if(typeof B>"u")V[j]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:U}=d(B.value,O);V[j]={type:3,value:A.VSBuffer.fromString(N),buffers:U}}else V[j]={type:1,value:A.VSBuffer.fromString(g(B,O))}}return{type:1,args:V}}return{type:0,args:g(w,O)}}static serializeRequest(w,O,V,j,F){switch(j.type){case 0:return this.b(w,O,V,j.args,F);case 1:return this.c(w,O,V,j.args,F)}}static b(w,O,V,j,F){const B=A.VSBuffer.fromString(V),N=A.VSBuffer.fromString(j);let U=0;U+=s.sizeUInt8(),U+=s.sizeShortString(B),U+=s.sizeLongString(N);const $=s.alloc(F?2:1,w,U);return $.writeUInt8(O),$.writeShortString(B),$.writeLongString(N),$.buffer}static deserializeRequestJSONArgs(w){const O=w.readUInt8(),V=w.readShortString(),j=w.readLongString();return{rpcId:O,method:V,args:JSON.parse(j)}}static c(w,O,V,j,F){const B=A.VSBuffer.fromString(V);let N=0;N+=s.sizeUInt8(),N+=s.sizeShortString(B),N+=s.sizeMixedArray(j);const U=s.alloc(F?4:3,w,N);return U.writeUInt8(O),U.writeShortString(B),U.writeMixedArray(j),U.buffer}static deserializeRequestMixedArgs(w){const O=w.readUInt8(),V=w.readShortString(),j=w.readMixedArray(),F=new Array(j.length);for(let B=0,N=j.length;B<N;B++){const U=j[B];typeof U=="string"?F[B]=JSON.parse(U):F[B]=U}return{rpcId:O,method:V,args:F}}static serializeAcknowledged(w){return s.alloc(5,w,0).buffer}static serializeCancel(w){return s.alloc(6,w,0).buffer}static serializeReplyOK(w,O,V){if(typeof O>"u")return this.d(w);if(O instanceof A.VSBuffer)return this.e(w,O);if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:F}=d(O.value,V,!0);return this.g(w,j,F)}else return this.f(w,v(O,V))}static d(w){return s.alloc(7,w,0).buffer}static e(w,O){let V=0;V+=s.sizeVSBuffer(O);const j=s.alloc(8,w,V);return j.writeVSBuffer(O),j.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,O){const V=A.VSBuffer.fromString(O);let j=0;j+=s.sizeLongString(V);const F=s.alloc(9,w,j);return F.writeLongString(V),F.buffer}static g(w,O,V){const j=A.VSBuffer.fromString(O);let F=0;F+=s.sizeUInt32,F+=s.sizeLongString(j);for(const N of V)F+=s.sizeVSBuffer(N);const B=s.alloc(10,w,F);B.writeUInt32(V.length),B.writeLongString(j);for(const N of V)B.writeBuffer(N);return B.buffer}static deserializeReplyOKJSON(w){const O=w.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(w,O){const V=w.readUInt32(),j=w.readLongString(),F=[];for(let B=0;B<V;++B)F.push(w.readVSBuffer());return new L.SerializableObjectWithBuffers(u(j,F,O))}static serializeReplyErr(w,O){const V=O?v(R.transformErrorForSerialization(O),null):void 0;if(typeof V!="string")return this.h(w);const j=A.VSBuffer.fromString(V);let F=0;F+=s.sizeLongString(j);const B=s.alloc(11,w,F);return B.writeLongString(j),B.buffer}static deserializeReplyErrError(w){const O=w.readLongString();return JSON.parse(O)}static h(w){return s.alloc(12,w,0).buffer}}var t;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var f;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(f||(f={}))}),define(De[291],Ce([1,0,3,39,54,4]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var C;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(L=>k.push(L)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}A.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(De[142],Ce([1,0,5,4,20,26,13,291,78,25,48,158,22,9,44,3,6]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(p,i,o,r,c){super(),this.id=p,this.name=i,this.m=o,this.n=r,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Clear,p)}replace(p){const i=this.k;this.info(p),this.n.$update(this.id,P.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(p,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:i))}hide(){this.n.$close(this.id)}g(p,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,C.log)(this.m,p,i),this.visible&&(this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends u{appendLine(p){this.append(p)}}let b=class{constructor(p,i,o,r,c,s){this.i=i,this.j=o,this.k=r,this.l=c,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[i,o]of this.g)o.visible=i===this.h}createOutputChannel(p,i,o){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof i=="object"&&i.log,c=(0,I.isString)(i)?i:void 0;if((0,I.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const m=this.i.environment.extensionLogLevel?.find(([t])=>R.ExtensionIdentifier.equals(o.identifier,t))?.[1];m&&(s=(0,C.parseLogLevel)(m));const n=r?this.o(p,s,o):this.n(p,c,o);return n.then(t=>{this.g.set(t.id,t),t.visible=t.id===this.h}),r?this.r(p,s??this.m.getLevel(),n):this.q(p,n)}async n(p,i,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(p,c,i,o.identifier.value);return new u(m,p,s,this.a,o)}async o(p,i,o){const r=await this.p(o),c=this.k.extUri.joinPath(r,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=c.toString(),m=this.l.createLogger(c,{id:s,name:p,logLevel:i,extensionId:o.identifier.value});return new g(s,p,m,this.a,o)}p(p){let i=this.d.get(p.identifier.value);if(!i){const o=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(o)}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileExists)throw r}return o})())}return i}q(p,i){let o=!1;const r=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return p},append(c){r(),i.then(s=>s.append(c))},appendLine(c){r(),i.then(s=>s.appendLine(c))},clear(){r(),i.then(c=>c.clear())},replace(c){r(),i.then(s=>s.replace(c))},show(c,s){r(),i.then(m=>m.show(c,s))},hide(){r(),i.then(c=>c.hide())},dispose(){o=!0,i.then(c=>c.dispose())}}}r(p,i,o){const r=new d.DisposableStore,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},s=r.add(new h.Emitter);function m(n){i=n,s.fire(n)}return o.then(n=>{r.add(n),n.logLevel!==i&&m(n.logLevel),r.add(n.onDidChangeLogLevel(t=>m(t)))}),{...this.q(p,o),get logLevel(){return i},onDidChangeLogLevel:s.event,trace(n,...t){c(),o.then(f=>f.trace(n,...t))},debug(n,...t){c(),o.then(f=>f.debug(n,...t))},info(n,...t){c(),o.then(f=>f.info(n,...t))},warn(n,...t){c(),o.then(f=>f.warn(n,...t))},error(n,...t){c(),o.then(f=>f.error(n,...t))},dispose(){r.dispose()}}}};b=xe([We(0,l.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,C.ILoggerService),We(5,C.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(De[292],Ce([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(De[293],Ce([1,0,33,16,11,10,24,2,4,218,47,236,292]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let I=class cn{constructor(h,d,u,g){this.d=h,this.e=d,this.f=u,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??h})()}hasValidBasename(h,d,u){return typeof d=="string"||typeof d>"u"?this.a.then(g=>this.h(h,g,d)):this.h(h,d,u)}h(h,d,u){return h.scheme===A.Schemas.file||h.scheme===A.Schemas.vscodeRemote?(0,a.isValidBasename)(u??(0,C.basename)(h),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return A.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(d.getWorkspace());if(u)return u;const g=d.getWorkspace().folders[0];if(g)return g.uri.scheme;const b=d.getWorkspace().configuration;return b?b.scheme:A.Schemas.file}userHome(h){return h?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(h=>h===1?l.win32:l.posix)}async fileURI(h){let d="";if(await this.a===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const g=h.indexOf("/",2);g===-1?(d=h.substring(2),h="/"):(d=h.substring(2,g),h=h.substring(g)||"/")}return P.URI.from({scheme:A.Schemas.file,authority:d,path:h,query:"",fragment:""})}};I=xe([We(1,v.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(De[81],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(C,P){this.line=C,this.character=P}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,P){return new a(0,0)}with(C){return new a(0,0)}}e.Position=a;class A{constructor(C,P,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(C,P),this.end=new a(S,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new A(0,0,0,0)}with(C){return new A(0,0,0,0)}}e.Range=A;var l;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(l=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[31],Ce([1,0,15,38,23,33,8,4,11,12,81,19]),function(ne,e,a,A,l,R,C,P,S,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",I=" characters skipped \u27EB",y=(v.length+I.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var h;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function u(J){return!!J.preview}e.resultIsMatch=u;function g(J){return!!J.resource}e.isFileMatch=g;function b(J){return!!J.message}e.isProgressMessage=b;var D;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(D=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=p;class i{constructor(ie,ge,X){this.ranges=ge;const Y=Array.isArray(ge)?ge:[ge];if(X&&X.matchLines===1&&o(Y)){ie=(0,C.getNLines)(ie,X.matchLines);let Z="",fe=0,ve=0;const ke=Math.floor(X.charsPerLine/5),Oe=[];for(const oe of Y){const le=Math.max(oe.startColumn-ke,0),ue=oe.startColumn+X.charsPerLine;if(le>ve+ke+y){const te=v+(le-ve)+I;Z+=te+ie.slice(le,ue),fe+=le-(ve+te.length)}else Z+=ie.slice(ve,ue);Oe.push(new c(0,oe.startColumn-fe,oe.endColumn-fe)),ve=ue}this.preview={text:Z,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const Z=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:ie,matches:(0,a.mapArrayOrNot)(ge,fe=>new r(fe.startLineNumber-Z,fe.startColumn,fe.endLineNumber-Z,fe.endColumn))}}}}e.TextSearchMatch=i;function o(J){const ie=J[0].startLineNumber;for(const ge of J)if(ge.startLineNumber!==ie||ge.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,ge,X,Y){this.startLineNumber=ie,this.startColumn=ge,this.endLineNumber=X,this.endColumn=Y}}e.SearchRange=r;class c extends r{constructor(ie,ge,X){super(ie,ge,ie,X)}}e.OneLineRange=c;var s;(function(J){J.List="list",J.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var m;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function n(J,ie=!0){const ge=J&&J.files&&J.files.exclude,X=ie&&J&&J.search&&J.search.exclude;if(!ge&&!X)return;if(!ge||!X)return ge||X;let Y=Object.create(null);return Y=l.mixin(Y,l.deepClone(ge)),Y=l.mixin(Y,l.deepClone(X),!0),Y}e.getExcludes=n;function t(J,ie){return J.excludePattern&&A.match(J.excludePattern,ie)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&A.match(J.includePattern,ie)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ge=>{const X=ge.folder.fsPath;if(R.isEqualOrParent(ie,X)){const Y=S.relative(X,ie);return!ge.includePattern||!!A.match(ge.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var f;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(ie,ge){super(ie),this.code=ge}}e.SearchError=E;function w(J){const ie=J.message;if((0,k.isCancellationError)(J))return new E(ie,f.canceled);try{const ge=JSON.parse(ie);return new E(ge.message,ge.code)}catch{return new E(ie,f.other)}}e.deserializeSearchError=w;function O(J){const ie={message:J.message,code:J.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=O;function V(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=V;function j(J){return J.type==="success"}e.isSerializedSearchSuccess=j;function F(J){return!!J.path}e.isSerializedFileMatch=F;function B(J,ie){const ge=J.searchPath?J.searchPath:J.relativePath;return(0,C.fuzzyContains)(ge,ie)}e.isFilePatternMatch=B;class N{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function U(J,ie){const ge={...J||{},...ie||{}};return Object.keys(ge).filter(X=>{const Y=ge[X];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=U;class ${constructor(ie,ge){this.c=null,this.a={...ie.excludePattern||{},...ge.excludePattern||{}},this.b=A.parse(this.a);let X=ie.includePattern;ge.includePattern&&(X?X={...X,...ge.includePattern}:X=ge.includePattern),X&&(this.c=A.parse(X))}matchesExcludesSync(ie,ge,X){return!!(this.b&&this.b(ie,ge,X))}includedInQuerySync(ie,ge,X){return!(this.b&&this.b(ie,ge,X)||this.c&&!this.c(ie,ge,X))}includedInQuery(ie,ge,X){const Y=this.b(ie,ge,X),Z=()=>this.c?!!this.c(ie,ge,X):!0;return(0,T.isThenable)(Y)?Y.then(fe=>fe?!1:Z()):Z()}hasSiblingExcludeClauses(){return z(this.a)}}e.QueryGlobTester=$;function z(J){for(const ie in J)if(typeof J[ie]!="boolean")return!0;return!1}function ae(J){if(!J)return;let ie;return ge=>(ie||(ie=(J()||Promise.resolve([])).then(X=>X?q(X):{})),ie.then(X=>!!X[ge]))}e.hasSiblingPromiseFn=ae;function ee(J){if(!J)return;let ie;return ge=>{if(!ie){const X=J();ie=X?q(X):{}}return!!ie[ge]}}e.hasSiblingFn=ee;function q(J){const ie={};for(const ge of J)ie[ge]=!0;return ie}}),define(De[34],Ce([1,0,15,19,21,3,6,68,16,102,24,8,9,2,184,4,13,206,47,48,25,20,14,7,56,31,5]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p,i,o,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function m(j,F,B){return new L.ExtUri(N=>E(N,B)).isEqual(j,F)}function n(j,F,B){return m(j.uri,F.uri,B)?0:(0,T.compare)(j.uri.toString(),F.uri.toString())}function t(j,F,B){return j.index!==F.index?j.index<F.index?-1:1:m(j.uri,F.uri,B)?(0,T.compare)(j.name,F.name):(0,T.compare)(j.uri.toString(),F.uri.toString())}function f(j,F,B,N){const U=j.slice(0).sort((z,ae)=>B(z,ae,N)),$=F.slice(0).sort((z,ae)=>B(z,ae,N));return(0,a.delta)(U,$,(z,ae)=>B(z,ae,N))}function E(j,F){const B=F.getCapabilities(j.scheme);return!(B&&B&1024)}class w extends g.Workspace{static toExtHostWorkspace(F,B,N,U){if(!F)return{workspace:null,added:[],removed:[]};const{id:$,name:z,folders:ae,configuration:ee,transient:q,isUntitled:J}=F,ie=[],ge=B;B?ae.forEach((fe,ve)=>{const ke=I.URI.revive(fe.uri),Oe=w.o(N||B,ke,U);Oe?(Oe.name=fe.name,Oe.index=fe.index,ie.push(Oe)):ie.push({uri:ke,name:fe.name,index:ve})}):ie.push(...ae.map(({uri:fe,name:ve,index:ke})=>({uri:I.URI.revive(fe),name:ve,index:ke}))),ie.sort((fe,ve)=>fe.index<ve.index?-1:1);const X=new w($,z,ie,!!q,ee?I.URI.revive(ee):null,!!J,fe=>E(fe,U)),{added:Y,removed:Z}=f(ge?ge.workspaceFolders:[],X.workspaceFolders,n,U);return{workspace:X,added:Y,removed:Z}}static o(F,B,N){for(let U=0;U<F.folders.length;U++){const $=F.workspaceFolders[U];if(m($.uri,B,N))return $}}constructor(F,B,N,U,$,z,ae){super(F,N.map(ee=>new g.WorkspaceFolder(ee)),U,$,ae),this.t=B,this.u=z,this.q=[],this.s=P.TernarySearchTree.forUris(ae),N.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,B){return B&&this.s.get(F)&&(F=(0,L.dirname)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let O=class{constructor(F,B,N,U,$){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=U,this.s=N,this.t=$,this.j=new k.Counter,this.k=new A.Barrier,this.o=F.getProxy(s.MainContext.MainThreadWorkspace),this.q=F.getProxy(s.MainContext.MainThreadMessageService);const z=B.workspace;this.l=z?new w(z.id,z.name,[],!!z.transient,z.configuration?I.URI.revive(z.configuration):null,!!z.isUntitled,ae=>E(ae,N)):void 0}$initializeWorkspace(F,B){this.v=B,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?I.URI.from({scheme:S.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,B,N,...U){const $=[];if(Array.isArray(U)&&U.forEach(J=>{I.URI.isUri(J.uri)&&!$.some(ie=>m(ie.uri,J.uri,this.s))&&$.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.n||[B,N].some(J=>typeof J!="number"||J<0)||N===0&&$.length===0)return!1;const z=this.x?this.x.workspaceFolders:[];if(B+N>z.length)return!1;const ae=z.slice(0);ae.splice(B,N,...$.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<ae.length;J++){const ie=ae[J];if(ae.some((ge,X)=>X!==J&&m(ie.uri,ge.uri,this.s)))return!1}ae.forEach((J,ie)=>J.index=ie);const{added:ee,removed:q}=f(z,ae,t,this.s);if(ee.length===0&&q.length===0)return!1;if(this.o){const J=F.displayName||F.name;this.o.$updateWorkspaceFolders(J,B,N,$).then(void 0,ie=>{this.n=void 0;const ge={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(u.Severity.Error,(0,y.localize)(0,null,J,ie.toString()),ge,[])})}return this.y(ae),!0}getWorkspaceFolder(F,B){if(!!this.x)return this.x.getWorkspaceFolder(F,B)}async getWorkspaceFolder2(F,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,B)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,B){let N,U="";if(typeof F=="string"?(N=I.URI.file(F),U=F):typeof F<"u"&&(N=F,U=F.fsPath),!N)return U;const $=this.getWorkspaceFolder(N,!0);if(!$)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let z=(0,L.relativePath)($.uri,N);return B&&$.name&&(z=`${$.name}/${z}`),z}y(F){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:B,added:N,removed:U}=w.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:U}))}findFiles(F,B,N,U,$=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let z;if(B===null?z=!1:B&&(typeof B=="string"?z=B:z=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:ae,folder:ee}=V(i.GlobPattern.from(F));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(ae),(0,v.withUndefinedAsNull)(ee),(0,v.withUndefinedAsNull)(z),(0,v.withUndefinedAsNull)(N),$).then(q=>Array.isArray(q)?q.map(J=>I.URI.revive(J)):[])}async findTextInFiles(F,B,N,U,$=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const z=this.j.getNext(),ae=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ee,folder:q}=V(i.GlobPattern.from(B.include)),J=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ie={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ae,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ee,excludePattern:J},ge=!1;if(this.u[z]=X=>{if(ge)return;const Y=I.URI.revive(X.resource);X.results.forEach(Z=>{(0,c.resultIsMatch)(Z)?N({uri:Y,preview:{text:Z.preview.text,matches:(0,a.mapArrayOrNot)(Z.preview.matches,fe=>new o.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,a.mapArrayOrNot)(Z.ranges,fe=>new o.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):N({uri:Y,text:Z.text,lineNumber:Z.lineNumber})})},$.isCancellationRequested)return{};try{const X=await this.o.$startTextSearch(F,(0,v.withUndefinedAsNull)(q),ie,z,$);return delete this.u[z],X||{}}catch(X){throw delete this.u[z],X}}$handleTextSearchResult(F,B){this.u[B]?.(F)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,B){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,B);const N=this.t.transformOutgoingScheme(F),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,N),(0,C.toDisposable)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(F,B){this.h.info("Getting edit session identifier for workspaceFolder",F);const N=await this.resolveWorkspaceFolder(I.URI.revive(F));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const U=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!U),!U)return;const $=await U.provideEditSessionIdentity(N,B);if(this.h.info("Provider returned edit session identifier: ",$),!!$)return $}async $provideEditSessionIdentityMatch(F,B,N,U){this.h.info("Getting edit session identifier for workspaceFolder",F);const $=await this.resolveWorkspaceFolder(I.URI.revive(F));if(!$){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const z=this.w.get($.uri.scheme);if(this.h.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!z),!z)return;const ae=await z.provideEditSessionIdentityMatch?.(B,N,U);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(F){return(B,N,U)=>{const $=function(ae){B.call(N,ae)};return $.extension=F,this.A.event($,void 0,U)}}async $onWillCreateEditSessionIdentity(F,B,N){const U=await this.resolveWorkspaceFolder(I.URI.revive(F));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async($,z)=>{const ae=Date.now();await Promise.resolve($),Date.now()-ae>N&&this.h.warn("SLOW edit session create-participant",z.extension.identifier)}),B.isCancellationRequested}};O=xe([We(0,p.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,r.IURITransformerService)],O),e.ExtHostWorkspace=O,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function V(j){let F,B;return j&&(typeof j=="string"?F=j:(F=j.pattern,B=I.URI.revive(j.baseUri))),{includePattern:F,folder:B}}}),define(De[35],Ce([1,0,23,3,34,5,7,209,127,9,19,4,20,13,2]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(o,r){if(r){const c=r.split(".");let s=o;for(let m=0;s&&m<c.length;m++)s=s[c[m]];return s}}function d(o){return o instanceof y.URI}function u(o){return o&&o.uri instanceof y.URI&&o.languageId&&typeof o.languageId=="string"}function g(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&o.uri instanceof y.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function D(o){if(d(o))return{resource:o};if(u(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(g(o))return{overrideIdentifier:o.languageId};if(b(o))return{resource:o.uri};if(o===null)return{resource:null}}let p=class{constructor(r,c,s){this.a=r.getProxy(R.MainContext.MainThreadConfiguration),this.c=c,this.b=s,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new i(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,c))}};p=xe([We(0,v.IExtHostRpcService),We(1,l.IExtHostWorkspace),We(2,I.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(r,c,s,m){this.a=new A.Emitter,this.b=r,this.f=m,this.c=c,this.e=P.Configuration.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=P.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,s))}getConfiguration(r,c,s){const m=D(c)||{},n=this.g(r?h(this.e.getValue(void 0,m,this.c.workspace),r):this.e.getValue(void 0,m,this.c.workspace));r&&this.h(r,m,s?.identifier);function t(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(E){return typeof h(n,E)<"u"},get:(E,w)=>{this.h(r?`${r}.${E}`:E,m,s?.identifier);let O=h(n,E);if(typeof O>"u")O=w;else{let V;const j=(F,B)=>{let N;const U=()=>{V=V||(0,a.deepClone)(n),N=N||h(V,B)};return(0,k.isObject)(F)?new Proxy(F,{get:($,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return U(),()=>N;if(V)return N=N||h(V,B),N[z];const ae=$[z];return typeof z=="string"?j(ae,`${B}.${z}`):ae},set:($,z,ae)=>(U(),N&&(N[z]=ae),!0),deleteProperty:($,z)=>(U(),N&&delete N[z],!0),defineProperty:($,z,ae)=>(U(),N&&Object.defineProperty(N,z,ae),!0)}):F};O=j(O,E)}return O},update:(E,w,O,V)=>{E=r?`${r}.${E}`:E;const j=t(O);return w!==void 0?this.b.$updateConfigurationOption(j,E,w,m,V):this.b.$removeConfigurationOption(j,E,m,V)},inspect:E=>{E=r?`${r}.${E}`:E;const w=this.e.inspect(E,m,this.c.workspace);if(w)return{key:E,defaultValue:(0,a.deepClone)(w.policy?.value??w.default?.value),globalValue:(0,a.deepClone)(w.user?.value??w.application?.value),workspaceValue:(0,a.deepClone)(w.workspace?.value),workspaceFolderValue:(0,a.deepClone)(w.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(w.default?.override),globalLanguageValue:(0,a.deepClone)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,a.deepClone)(w.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(w.workspaceFolder?.override),languageIds:(0,a.deepClone)(w.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(f,n,!1),Object.freeze(f)}g(r){const c=s=>(0,k.isObject)(s)?new Proxy(s,{get:(m,n)=>c(m[n]),set:(m,n,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(m,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(m,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return c(r)}h(r,c,s){const m=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),n=s?`[${s.value}] `:"";if(m===4){typeof c?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){c?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const s=new P.ConfigurationChangeEvent(r,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,n)=>s.affectsConfiguration(m,D(n))})}k(r){return r.reduce((c,s)=>(c.set(s[0],s[1]),c),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[82],Ce([1,0,2,19,3,5,7,34,59,35,21,41,20,25,4,16,10,13,77,247,12]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(F){function B(U){if(U!=null)return U}F.from=B;function N(U){if(U!=null)return U}F.to=N})(i||(i={}));var o;(function(F){function B(U){if(U!=null)return U}F.from=B;function N(U){if(U!=null)return U}F.to=N})(o||(o={}));var r;(function(F){function B(U){if(U!=null)return U}F.from=B;function N(U){if(U!=null)return U}F.to=N})(r||(r={}));var c;(function(F){function B($){if($){const z=$;return z&&!!z.process}else return!1}F.is=B;function N($){if($==null)return;const z={process:$.process,args:$.args};return $.options&&(z.options=r.from($.options)),z}F.from=N;function U($){if($!=null)return new C.ProcessExecution($.process,$.args,$.options)}F.to=U})(c||(c={}));var s;(function(F){function B(U){if(U!=null)return U}F.from=B;function N(U){if(U!=null)return U}F.to=N})(s||(s={}));var m;(function(F){function B($){if($){const z=$;return z&&(!!z.commandLine||!!z.command)}else return!1}F.is=B;function N($){if($==null)return;const z={};return $.commandLine!==void 0?z.commandLine=$.commandLine:(z.command=$.command,z.args=$.args),$.options&&(z.options=s.from($.options)),z}F.from=N;function U($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new C.ShellExecution($.commandLine,$.options):new C.ShellExecution($.command,$.args?$.args:[],$.options)}F.to=U})(m||(m={}));var n;(function(F){function B($){if($){const z=$;return z&&z.customExecution==="customExecution"}else return!1}F.is=B;function N($){return{customExecution:"customExecution"}}F.from=N;function U($,z){return z.get($)}F.to=U})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(F){function B(N,U){let $;return N.scope!==void 0&&typeof N.scope!="number"?$=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===C.TaskScope.Workspace&&U&&U.workspaceFile?$=U.workspaceFile:$=b.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:$}}F.from=B})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(F){function B(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}F.from=B})(f||(f={}));var E;(function(F){function B($,z){if($==null)return[];const ae=[];for(const ee of $){const q=N(ee,z);q&&ae.push(q)}return ae}F.fromMany=B;function N($,z){if($==null)return;let ae;$.execution instanceof C.ProcessExecution?ae=c.from($.execution):$.execution instanceof C.ShellExecution?ae=m.from($.execution):$.execution&&$.execution instanceof C.CustomExecution&&(ae=n.from($.execution));const ee=i.from($.definition);let q;return $.scope?typeof $.scope=="number"?q=$.scope:q=$.scope.uri:q=C.TaskScope.Workspace,!ee||!q?void 0:{_id:$._id,definition:ee,name:$.name,source:{extensionId:z.identifier.value,label:$.source,scope:q},execution:ae,isBackground:$.isBackground,group:f.from($.group),presentationOptions:o.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}F.from=N;async function U($,z,ae){if($==null)return;let ee;c.is($.execution)?ee=c.to($.execution):m.is($.execution)?ee=m.to($.execution):n.is($.execution)&&(ee=n.to($._id,ae));const q=i.to($.definition);let J;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?J=$.source.scope:J=await z.resolveWorkspaceFolder(a.URI.revive($.source.scope)):J=C.TaskScope.Workspace),!q||!J)return;const ie=new C.Task(q,J,$.name,$.source.label,ee,$.problemMatchers);return $.isBackground!==void 0&&(ie.isBackground=$.isBackground),$.group!==void 0&&(ie.group=C.TaskGroup.from($.group._id),ie.group&&$.group.isDefault&&(ie.group=new C.TaskGroup(ie.group.id,ie.group.label),$.group.isDefault===!0&&(ie.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ie.presentationOptions=o.to($.presentationOptions)),$._id&&(ie._id=$._id),$.detail&&(ie.detail=$.detail),ie}F.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var w;(function(F){function B(U){return U}F.from=B;function N(U){if(!!U)return Object.assign(Object.create(null),U)}F.to=N})(w||(w={}));class O{constructor(B,N,U){this._id=N,this.a=U,p.set(this,void 0),Ze(this,p,B,"f")}get task(){return this.a}terminate(){Be(this,p,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}p=new WeakMap;let V=class{constructor(B,N,U,$,z,ae,ee,q){this.q=new l.Emitter,this.r=new l.Emitter,this.s=new l.Emitter,this.t=new l.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=$,this.d=z,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,N,U){if(!U)return new C.Disposable(()=>{});const $=this.w();return this.j.set($,{type:N,provider:U,extension:B}),this.a.$registerTaskProvider($,N),new C.Disposable(()=>{this.j.delete($),this.a.$unregisterTaskProvider($)})}registerTaskSystem(B,N){this.a.$registerTaskSystem(B,N)}fetchTasks(B){return this.a.$fetchTasks(w.from(B)).then(async N=>{const U=[];for(const $ of N){const z=await E.to($,this.b,this.m);z&&U.push(z)}return U})}get taskExecutions(){const B=[];return this.k.forEach(N=>B.push(N)),B}terminateTask(B){if(!(B instanceof O))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,N,U){const $=this.m.get(B.id);$&&(this.o.set(B.id,$),this.e.attachPtyToTerminal(N,await $.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const N=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const N=await this.y(B.id);this.s.fire({execution:N,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const N=await this.y(B.id);this.t.fire({execution:N,exitCode:B.exitCode})}$provideTasks(B,N){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const $=[],z=(0,A.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(ae=>this.u(N,$,U,ae));return new Promise(ae=>{z.then(ee=>{Promise.all($).then(()=>{ae(ee)})})})}async $resolveTask(B,N){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(N.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${U.type}].`);const $=await E.to(N,this.b,this.m);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const z=await U.provider.resolveTask($,L.CancellationToken.None);if(!z)return;this.z(z,U);const ae=E.from(z,U.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(ae.execution)&&await this.x(ae,z,!0),await this.v(ae)}w(){return this.h++}async x(B,N,U){const $=await this.a.$createTaskId(B);!U&&!this.m.has($)&&(this.n.add($),this.o.set($,N.execution)),this.m.set($,N.execution)}async y(B,N){if(typeof B=="string"){const z=this.l.get(B);if(!z)throw new D.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const U=this.l.get(B.id);if(U)return U;const $=new Promise((z,ae)=>{function ee(q,J,ie){ie?z(new O(q,J.id,ie)):ae("Unexpected: Task does not exist.")}N?ee(this,B,N):E.to(B.task,this.b,this.m).then(q=>ee(this,B,q))});return this.l.set(B.id,$),$.then(z=>(this.k.set(B.id,z),z),z=>Promise.reject(z))}z(B,N){B._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let $=U.next();for(;!$.done;)!this.o.has($.value)&&this.p!==$.value&&(this.m.delete($.value),this.n.delete($.value)),$=U.next()}};V=xe([We(0,v.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,u.ILogService),We(7,g.IExtHostApiDeprecationService)],V),e.ExtHostTaskBase=V;let j=class extends V{constructor(B,N,U,$,z,ae,ee,q){super(B,N,U,$,z,ae,ee,q),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(B,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(N,B);if(U===void 0)throw new Error("Task is not valid");if(n.is(U.execution))await this.x(U,N,!1);else throw new D.NotSupportedError;const $=await this.y(await this.a.$getTaskExecution(U),N);return this.a.$executeTask(U).catch(z=>{throw new Error(z)}),$}u(B,N,U,$){const z=[];if($)for(const ae of $){this.z(ae,U),(!ae.definition||!B[ae.definition.type])&&this.f.warn(`The task [${ae.source}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`);const ee=E.from(ae,U.extension);ee&&n.is(ee.execution)?(z.push(ee),N.push(this.x(ee,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:U.extension}}async v(B){if(n.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,N,U){}};j=xe([We(0,v.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,u.ILogService),We(7,g.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,y.createDecorator)("IExtHostTask")}),define(De[294],Ce([1,0,11,21,45,38,24,43,31]),function(ne,e,a,A,l,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(v,I,y){this.k=v,this.l=I,this.o=y,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const I=this.k.folderQueries||[];return new Promise((y,h)=>{const d=u=>{this.f++,v(u)};if(this.g)return y({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const g=u.toString(),b=a.basename(g);this.j&&this.j(g,b)||this.v(d,{base:u,basename:b})}),Promise.all(I.map(u=>this.p(u,d))).then(u=>{y({limitHit:this.e,stats:u[0]||void 0})},u=>{h(new Error((0,l.toErrorMessage)(u)))})})}async p(v,I){const y=new A.CancellationTokenSource,h=this.q(v),d=this.r(),u=new S.QueryGlobTester(this.k,v),g=!u.hasSiblingExcludeClauses();let b;try{this.h.add(y),b=P.StopWatch.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,y.token),p=b.elapsed(),i=P.StopWatch.create();return this.g&&!this.e||(D&&D.forEach(o=>{const r=a.posix.relative(v.folder.path,o.path);if(g){const c=a.basename(o.path);this.v(I,{base:v.folder,relativePath:r,basename:c});return}this.s(d,v.folder,r,I)}),this.g&&!this.e)?null:(this.u(d,u,I),{providerTime:p,postProcessTime:i.elapsed()})}finally{y.dispose(),this.h.delete(y)}}q(v){const I=(0,S.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),y=(0,S.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:y,includes:I,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},I,y,h){if(y===this.a){const u=a.basename(this.a);this.v(h,{base:I,relativePath:this.a,basename:u})}function d(u){const g=a.basename(u),b=a.dirname(u);let D=v[b];D||(D=v[b]=[],d(b)),D.push({base:I,relativePath:u,basename:g})}d(y)}u({rootEntries:v,pathToEntries:I},y,h){const d=this,u=this.a;function g(b){const D=(0,S.hasSiblingFn)(()=>b.map(p=>p.basename));for(let p=0,i=b.length;p<i;p++){const o=b[p],{relativePath:r,basename:c}=o;if(y.matchesExcludesSync(r,c,u!==c?D:void 0))continue;const s=I[r];if(s)g(s);else{if(r===u)continue;d.v(h,o)}if(d.e)break}}g(v)}v(v,I){(!this.b||I.relativePath&&this.b(I.relativePath,I.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(I))}}class L{constructor(){this.b=new Map}fileSearch(v,I,y,h){const d=this.c(v.cacheKey),u=new k(v,I,d&&d.token);let g=0;const b=D=>{g+=D.length,y(D.map(p=>this.d(p)))};return this.e(u,L.a,b,h).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:D.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new A.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:C.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,I,y,h){h.onCancellationRequested(()=>{v.cancel()});const d=g=>{g&&(u.push(g),I>0&&u.length>=I&&(y(u),u=[]))};let u=[];return v.search(d).then(g=>(u.length&&y(u),g),g=>(u.length&&y(u),Promise.reject(g)))}}L.a=512,e.FileSearchManager=L}),define(De[295],Ce([1,0,15,61,38,113,28,16,11,24,8,9,2,166,196,53,13,47,133,293,31]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(E,w,O,V,j){this.a=E,this.b=w,this.c=O,this.d=V,this.e=j}text(E,w,O={}){E=this.f(E,O);const V=this.a.getValue(),j=w&&w.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(w?.map(u.toWorkspaceFolder),O),type:2,contentPattern:E,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:V.search.usePCRE2||j||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(E,w){const O=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const V={...E,wordSeparators:O.editor.wordSeparators};return this.j(E,w)&&(V.isCaseSensitive=!0),this.k(E)&&(V.isMultiline=!0),V}file(E,w={}){return{...this.h(E,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(E,w){return E?(E=Array.isArray(E)?E.map(s):s(E),w?this.parseSearchPaths(E):{pattern:o(...Array.isArray(E)?E:[E])}):{}}h(E=[],w={}){const O=this.g(w.includePattern,w.expandPatterns),V=this.g(w.excludePattern,w.expandPatterns),j=E.length>1,F=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(U=>this.q(U,w,V)):E.map(U=>this.r(U,w,V,j))).filter(U=>!!U),B={_reason:w._reason,folderQueries:F,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:V.pattern,includePattern:O.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const U=a.coalesce(a.flatten(this.c.groups.map(ae=>ae.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const $=U.filter(ae=>(0,D.pathIncludedInQuery)(B,ae.fsPath)),z=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...B,...z}}const N=w.extraFileResources&&w.extraFileResources.filter(U=>(0,D.pathIncludedInQuery)(B,U.fsPath));return B.extraFileResources=N&&N.length?N:void 0,B}i(E){const w=[],O=new C.ResourceMap,V={};let j=!1;return E.forEach(F=>{if(F.scheme===P.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(F)){const N=this.b.getWorkspaceFolder(F)?.uri??F.with({path:S.dirname(F.fsPath)});let U=O.get(N);U||(j=!0,U={folder:N,includePattern:{}},w.push(U),O.set(N,U));const $=S.relative(N.fsPath,F.fsPath);(0,T.assertIsDefined)(U.includePattern)[$.replace(/\\/g,"/")]=!0}else F.fsPath&&(j=!0,V[F.fsPath]=!0)}),{folderQueries:w,includePattern:V,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(E,w){if(w.isSmartCase){if(E.isRegExp){if(L.containsUppercaseCharacter(E.pattern,!0))return!0}else if(L.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,I.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const w=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),V=(Array.isArray(E)?E:r(E)).map(z=>{const ae=this.e.resolvedUserHome;return ae?(0,R.untildify)(z,ae.scheme===P.Schemas.file?ae.fsPath:ae.path):z}),j=A.groupBy(V,z=>w(z)?"searchPaths":"exprSegments"),F=(j.exprSegments||[]).map(z=>L.rtrim(z,"/")).map(z=>L.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),c(z))),B={},N=this.m(j.searchPaths||[]);N&&N.length&&(B.searchPaths=N);const U=a.flatten(F),$=o(...U);return $&&(B.pattern=$),B}l(E,w){return w.disregardExcludeSettings?void 0:(0,D.getExcludes)(E,!w.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const w=E.flatMap(V=>{let{pathPortion:j,globPortion:F}=i(V);return F&&(F=m(F)),this.n(j).flatMap(N=>this.o(N,F))}),O=new Map;return w.forEach(V=>{const j=V.searchPath.toString(),F=O.get(j);F?V.pattern&&(F.pattern=F.pattern||{},F.pattern[V.pattern]=!0):O.set(j,{searchPath:V.searchPath,pattern:V.pattern?o(V.pattern):void 0})}),Array.from(O.values())}n(E){if(S.isAbsolute(E)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==P.Schemas.file?[{searchPath:w[0].uri.with({path:E})}]:[{searchPath:v.URI.file(S.normalize(E))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(E=s(E),E.startsWith("../")||E===".."){const V=S.posix.resolve(w.path,E);return[{searchPath:w.with({path:V})}]}const O=m(E);return[{searchPath:w,pattern:O}]}else{if(E==="./"||E===".\\")return[];{const w=E.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(j=>{const F=w.match(new RegExp(`^${L.escapeRegExpCharacters(j.name)}(?:/(.*)|$)`));return F?{match:F,folder:j}:null}).filter(T.isDefined);if(V.length)return V.map(j=>{const F=j.match[1];return{searchPath:j.folder.uri,pattern:F&&m(F)}});{const j=E.match(/\.[\/\\](.+)[\/\\]?/),F=j?j[1]:E,B=y.localize(0,null,F);throw new Error(B)}}}}o(E,w){const O=E.pattern&&w?`${E.pattern}/${w}`:E.pattern||w,V=[{searchPath:E.searchPath,pattern:O}];return O&&!O.endsWith("**")&&V.push({searchPath:E.searchPath,pattern:O+"/**"}),V}q(E,w,O){const V=this.r((0,u.toWorkspaceFolder)(E.searchPath),w,O,!1);return V?{...V,includePattern:E.pattern}:null}r(E,w,O,V){let j;const F=v.URI.isUri(E)?E:E.uri;if(O.searchPaths){const z=O.searchPaths.filter(ae=>(0,k.isEqual)(ae.searchPath,F))[0];if(z&&!z.pattern)return null;z&&(j=z.pattern)}const B=this.a.getValue({resource:F}),U={...this.l(B,w)||{},...j||{}},$=v.URI.isUri(E)?(0,k.basename)(E):E.name;return{folder:F,folderName:V?$:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!B.search.followSymlinks}}};p=xe([We(0,h.IConfigurationService),We(1,u.IWorkspaceContextService),We(2,g.IEditorGroupsService),We(3,d.ILogService),We(4,b.IPathService)],p),e.QueryBuilder=p;function i(f){const E=f.match(/[\*\{\}\(\)\[\]\?]/);if(E){const w=E.index,O=f.substr(0,w).match(/[/|\\][^/\\]*$/);if(O){let V=f.substr(0,O.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:f.substr((O.index||0)+1)}}}return{pathPortion:f}}function o(...f){return f.length?f.reduce((E,w)=>(E[w]=!0,E),Object.create(null)):void 0}function r(f){return l.splitGlobAware(f,",").map(E=>E.trim()).filter(E=>!!E.length)}function c(f){return[`**/${f}/**`,`**/${f}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function s(f){return f.replace(/\\/g,"/")}function m(f){return s(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(f){return f.replace(/([?*[\]])/g,"[$1]")}function t(f,E){f=a.distinct(f,V=>V.toString());const w=[],O=E.getWorkspace();return f&&f.forEach(V=>{let j;if(E.getWorkbenchState()===2)j=(0,k.relativePath)(O.folders[0].uri,V),j&&j!=="."&&(j="./"+j);else{const F=E.getWorkspaceFolder(V);if(F){const B=F.name;if(O.folders.filter(U=>U.name===B).length===1){const U=(0,k.relativePath)(F.uri,V);U===""?j=`./${F.name}`:j=`./${F.name}/${U}`}else j=V.fsPath}}j&&w.push(n(j))}),w}e.resolveResourcesForSearchIncludes=t}),define(De[296],Ce([1,0,24,2,21,12,4,295,31,47]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(h,d){const u=d.activationEvents;if(!u)return Promise.resolve(void 0);const g=[],b=[];for(const c of u)if(/^workspaceContains:/.test(c)){const s=c.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||h.forceUsingSearch?b.push(s):g.push(s)}if(g.length===0&&b.length===0)return Promise.resolve(void 0);let D;const p=new Promise((c,s)=>{D=c}),i=c=>D({activationEvent:c}),o=Promise.all(g.map(c=>v(h,c,i))).then(()=>{}),r=I(h,d.identifier,b,i);return Promise.all([o,r]).then(()=>{D(void 0)}),p}e.checkActivateWorkspaceContainsExtension=T;async function v(h,d,u){for(const g of h.folders)if(await h.exists(a.joinPath(A.URI.revive(g),d))){u(`workspaceContains:${d}`);return}}async function I(h,d,u,g){if(u.length===0)return Promise.resolve(void 0);const b=new l.CancellationTokenSource,D=h.checkExists(h.folders,u,b.token),p=setTimeout(async()=>{b.cancel(),h.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},L);let i=!1;try{i=await D}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}b.dispose(),clearTimeout(p),i&&g(`workspaceContains:${u.join(",")}`)}function y(h,d,u,g){const b=h.get(C.IInstantiationService),D=h.get(S.ISearchService),i=b.createInstance(P.QueryBuilder).file(d.map(o=>(0,k.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:u,exists:!0});return D.fileSearch(i,g).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=y});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(De[42],Ce([1,0,178,11,83,24,19,6,68,2,13,5,35,238,99,34,27,134,12,26,22,220,7,128,4,25,79,20,91,55,41,3,296,98,222,16,97,43,10]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p,i,o,r,c,s,m,n,t,f,E,w,O,V,j,F,B,N){"use strict";var U,$,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let ae=class Ui extends P.Disposable{constructor(X,Y,Z,fe,ve,ke,Oe,oe,le,ue,te){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=Y,this.g=Z,this.f=Oe,this.j=fe,this.k=ve,this.l=ke,this.m=le,this.p=ue,this.s=te,this.t=this.g.getProxy(T.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(T.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(T.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const ce=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new u.ExtensionDescriptionRegistry(J(this.F,ce)),this.G=new y.ExtHostStorage(this.g,this.l),this.H=new O.ExtHostSecretState(this.g),this.I=oe,this.h=X.createChild(new n.ServiceCollection([y.IExtHostStorage,this.G],[O.IExtHostSecretState,this.H])),this.J=this.B(new I.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(se,M,W)=>{this.v.$onExtensionActivationError(se,g.transformErrorForSerialization(M),W)},actualActivateExtension:async(se,M)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(se,this.D,this.F))return await this.v.$activateExtension(se,M),new I.HostExtension;const W=this.D.getExtensionDescription(se);return this.Y(W,M)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.lb()}catch(X){g.onUnexpectedError(X)}}async Q(){this.I.onWillDeactivateAll();let X=[];try{X=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(X)}terminate(X,Y=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${X}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(fe=>{this.l.error(fe)}),this.g.dispose();const Z=this.Q();Promise.race([(0,C.timeout)(5e3),Z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Y}`):this.l.info(`Extension host exiting with code ${Y}`),this.l.flush(),this.l.dispose(),this.c.exit(Y)})}isActivated(X){return this.z.isOpen()?this.J.isActivated(X):!1}async getExtension(X){const Y=await this.v.$getExtension(X);let Z;if(Y?.browserNlsBundleUris){Z={};for(const fe of Object.keys(Y.browserNlsBundleUris))Z[fe]=k.URI.revive(Y.browserNlsBundleUris[fe])}return Y&&{...Y,identifier:new b.ExtensionIdentifier(Y.identifier.value),extensionLocation:k.URI.revive(Y.extensionLocation),browserNlsBundleUris:Z}}R(X,Y){return this.J.activateByEvent(X,Y)}S(X,Y){return this.J.activateById(X,Y)}activateByIdWithErrors(X,Y){return this.S(X,Y).then(()=>{const Z=this.J.getActivatedExtension(X);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(X=>this.D)}getExtensionExports(X){return this.z.isOpen()?this.J.getActivatedExtension(X).exports:null}async U(X){if(X.scheme!==j.Schemas.file)return X;const Y=await this.c.realpath(X.fsPath);return k.URI.file(Y)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(X=>new ie(X))),this.L}async W(X){const Y=S.TernarySearchTree.forUris(Z=>R.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(X.map(async Z=>{if(this.pb(Z)){const fe=await this.U(Z.extensionLocation);Y.set(fe,Z)}})),Y}X(X){let Y=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(X))return Y;const Z=this.J.getActivatedExtension(X);if(!Z)return Y;try{typeof Z.module.deactivate=="function"&&(Y=Promise.resolve(Z.module.deactivate()).then(void 0,fe=>(this.l.error(fe),Promise.resolve(void 0))))}catch(fe){this.l.error(`An error occurred when deactivating the extension '${X.value}':`),this.l.error(fe)}try{(0,P.dispose)(Z.subscriptions)}catch(fe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.l.error(fe)}return Y}async Y(X,Y){return this.f.remote.isRemote?this.v.$onWillActivateExtension(X.identifier):await this.v.$onWillActivateExtension(X.identifier),this.ab(X,Y).then(Z=>{const fe=Z.activationTimes;return this.v.$onDidActivateExtension(X.identifier,fe.codeLoadingTime,fe.activateCallTime,fe.activateResolvedTime,Y),this.Z(X,Y,"success",fe),Z},Z=>{throw this.Z(X,Y,"failure"),Z})}Z(X,Y,Z,fe){const ve=ee(X,Y);this.u.$publicLog2("extensionActivationTimes",{...ve,...fe||{},outcome:Z})}ab(X,Y){const Z=ee(X,Y);this.u.$publicLog2("activatePlugin",Z);const fe=this.pb(X);if(!fe)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${X.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this.l.flush();const ve=new I.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this.qb(X,(0,R.joinPath)(X.extensionLocation,fe),ve),this.bb(X)]).then(ke=>(l.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Ui.cb(this.l,X.identifier,ke[0],ke[1],ve))).then(ke=>(l.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),ke))}bb(X){const Y=new p.ExtensionGlobalMemento(X,this.G),Z=new p.ExtensionMemento(X.identifier.value,!1,this.G),fe=new V.ExtensionSecrets(X,this.H),ve=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ke=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([Y.whenReady,Z.whenReady,this.I.whenReady]).then(()=>{const Oe=this;let oe,le;const ue=(0,d.isProposedApiEnabled)(X,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:Y,workspaceState:Z,secrets:fe,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(te){return A.join(X.extensionLocation.fsPath,te)},get storagePath(){return Oe.I.workspaceValue(X)?.fsPath},get globalStoragePath(){return Oe.I.globalValue(X).fsPath},get logPath(){return A.join(Oe.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return k.URI.joinPath(Oe.f.logsLocation,X.identifier.value)},get storageUri(){return Oe.I.workspaceValue(X)},get globalStorageUri(){return Oe.I.globalValue(X)},get extensionMode(){return ve},get extension(){return oe===void 0&&(oe=new q(Oe,X.identifier,X,ke,!1)),oe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(X,"extensionRuntime"),Oe.extensionRuntime},get environmentVariableCollection(){return Oe.p.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!le){if(!ue)return;const te=E.Event.buffer(E.Event.fromDOMEventEmitter(ue,"message",ce=>ce.data));ue.start(),le={onDidReceiveMessage:te,postMessage:ue.postMessage.bind(ue)}}return le}})})}static cb(X,Y,Z,fe,ve){return Z=Z||{activate:void 0,deactivate:void 0},this.db(X,Y,Z,fe,ve).then(ke=>new I.ActivatedExtension(!1,null,ve.build(),Z,ke,fe.subscriptions))}static db(X,Y,Z,fe,ve){if(typeof Z.activate=="function")try{ve.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const ke=typeof global=="object"?global:self,Oe=Z.activate.apply(ke,[fe]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Oe).then(oe=>(ve.activateResolveStop(),oe))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Z)}eb(X,Y){this.S(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:Y}).then(void 0,Z=>{this.l.error(Z)})}fb(X,Y=0){const fe=Date.now();(0,N.setTimeout0)(()=>{for(let ve=Y;ve<X.length;ve+=1){const ke=X[ve];for(const Oe of ke.activationEvents??[])if(Oe==="onStartupFinished")if(Date.now()-fe>50){this.fb(X,ve);break}else this.eb(ke,Oe)}})}gb(){this.v.$setPerformanceMarks(l.getMarks()),this.k.getConfigProvider().then(X=>{const Y=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.D.getAllExtensionDescriptions();if(Y)this.fb(Z);else for(const fe of Z)if(fe.activationEvents)for(const ve of fe.activationEvents)ve==="onStartupFinished"&&this.eb(fe,ve)})}hb(){const X=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.ib(ve.added)));const Y=this.j.workspace?this.j.workspace.folders:[],Z=this.ib(Y),fe=Promise.all([X,Z]).then(()=>{});return Promise.race([fe,(0,C.timeout)(1e4)]).then(()=>{this.gb()}),fe}ib(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(Y=>this.jb(X,Y))).then(()=>{})}async jb(X,Y){if(this.isActivated(Y.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,fe={logService:this.l,folders:X.map(ke=>ke.uri),forceUsingSearch:Z,exists:ke=>this.c.exists(ke.fsPath),checkExists:(ke,Oe,oe)=>this.t.$checkExists(ke,Oe,oe)},ve=await(0,w.checkActivateWorkspaceContainsExtension)(fe,Y);if(!!ve)return this.S(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:ve.activationEvent}).then(void 0,ke=>this.l.error(ke))}async $extensionTestsExecute(){await this.C.wait();try{return await this.kb()}catch(X){throw console.error(X),X}}async kb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:Y}=this.f.environment;if(!X||!Y)throw new Error(a.localize(0,null));const Z=await this.qb(null,Y,new I.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(a.localize(1,null,Y.toString()));return new Promise((fe,ve)=>{const ke=(le,ue)=>{le?ve(le):fe(typeof ue=="number"&&ue>0?1:0)},Oe=(0,R.originalFSPath)(Y),oe=Z.run(Oe,ke);oe&&oe.then&&oe.then(()=>{fe(0)}).catch(le=>{ve(le instanceof Error&&le.stack?le.stack:String(le))})})}lb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.hb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,Y){return this.M[X]=Y,(0,P.toDisposable)(()=>{delete this.M[X]})}async mb(X){const Y=X.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const Z=X.substr(0,Y);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.M[Z]}}async $resolveAuthority(X,Y){const Z=B.StopWatch.create(!1),fe=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(X)},${Y})][${Z.elapsed()}ms] `,ve=ue=>this.l.info(`${fe()}${ue}`),ke=(ue,te=void 0)=>this.l.error(`${fe()}${ue}`,te);ve("activating resolver...");const{authorityPrefix:Oe,resolver:oe}=await this.mb(X);if(!oe)return ke("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Oe}.`,detail:void 0}};const le=new C.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(oe)),le.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${Oe}`);const ue=await oe.resolve(X,{resolveAttempt:Y});l.mark(`code/extHost/didResolveAuthorityOK/${Oe}`),le.dispose(),ve(`returned ${ue.host}:${ue.port}`);const te={authority:X,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ce={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:te,options:ce,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(l.mark(`code/extHost/didResolveAuthorityError/${Oe}`),le.dispose(),ke("returned an error",ue),ue instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(X,Y){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(X)})`);const{resolver:Z}=await this.mb(X);if(!Z)return null;const fe=k.URI.revive(Y);if(typeof Z.getCanonicalURI>"u")return fe;const ve=await(0,C.asPromise)(()=>Z.getCanonicalURI(fe));return ve||fe}static nb(X,Y,Z){const fe=new u.ExtensionDescriptionRegistry(X.getAllExtensionDescriptions());fe.deltaExtensions(Z.toAdd,Z.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(Y.getAllExtensionDescriptions().map(Oe=>Oe.identifier));for(const Oe of Z.myToRemove)ve.delete(b.ExtensionIdentifier.toKey(Oe));for(const Oe of Z.myToAdd)ve.add(b.ExtensionIdentifier.toKey(Oe));const ke=J(fe,ve);return{globalRegistry:fe,myExtensions:ke}}$startExtensionHost(X){X.toAdd.forEach(fe=>fe.extensionLocation=k.URI.revive(fe.extensionLocation));const{globalRegistry:Y,myExtensions:Z}=Ui.nb(this.F,this.D,X);return this.F.set(Y.getAllExtensionDescriptions()),this.D.set(Z),this.lb()}$activateByEvent(X,Y){return Y===1?this.R(X,!1):this.z.wait().then(Z=>this.R(X,!1))}async $activate(X,Y){return await this.z.wait(),this.D.getExtensionDescription(X)?(await this.S(X,Y),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(ke=>ke.extensionLocation=k.URI.revive(ke.extensionLocation));const{globalRegistry:Y,myExtensions:Z}=Ui.nb(this.F,this.D,X),fe=await this.W(Z);return(await this.getExtensionPathIndex()).setSearchTree(fe),this.F.set(Y.getAllExtensionDescriptions()),this.D.set(Z),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const Y=D.VSBuffer.alloc(X),Z=Math.random()%256;for(let fe=0;fe<X;fe++)Y.writeUInt8(Z,fe);return Y}async $updateRemoteConnectionData(X){this.P=X,this.a.fire()}};ae=xe([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,m.IExtHostRpcService),We(3,h.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,c.IExtHostInitDataService),We(7,s.IExtensionStoragePaths),We(8,t.IExtHostTunnelService),We(9,f.IExtHostTerminalService),We(10,F.IExtHostLocalizationService)],ae),e.AbstractExtHostExtensionService=ae;function ee(ge,X){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class q{constructor(X,Y,Z,fe,ve){U.set(this,void 0),$.set(this,void 0),z.set(this,void 0),Ze(this,U,X,"f"),Ze(this,$,Y,"f"),Ze(this,z,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=fe,this.isFromDifferentExtensionHost=ve}get isActive(){return Be(this,U,"f").isActivated(Be(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,U,"f").getExtensionExports(Be(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,U,"f").activateByIdWithErrors(Be(this,z,"f"),{startup:!1,extensionId:Be(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=q,U=new WeakMap,$=new WeakMap,z=new WeakMap;function J(ge,X){return ge.getAllExtensionDescriptions().filter(Y=>X.has(b.ExtensionIdentifier.toKey(Y.identifier)))}class ie{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.ExtensionPaths=ie}),define(De[297],Ce([1,0,83,2,5,35,27,26,20,25,4,42,36,13,8]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(p,i,o,r,c,s,m){this.c=p,this.d=i,this.e=o,this.f=r,this.g=c,this.h=s,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new u(this.c,i,this.d,p,this.i)),this.register(this.e.createInstance(g,i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this.a.set(i,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(i=>p.alternativeModuleName(i))}};h=xe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,T.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,I.ILogService)],h),e.RequireInterceptor=h;let d=class rn{constructor(p){if(p.environment.appRoot&&rn.a.size){const i=(0,y.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),o="[a-z0-9_.-]",r=`@${o}+\\/${o}+|${o}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const i=this.b.exec(this.c(p));if(!i)return;const[,o,r,c]=i,s=rn.a.get(r);if(s!==void 0)return console.warn(`${r} as been renamed to ${s}, please update your imports`),o+s+c}c(p){return p.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=xe([We(0,k.IExtHostInitDataService)],d);class u{constructor(p,i,o,r,c){this.c=p,this.d=i,this.e=o,this.f=r,this.g=c,this.nodeModuleName="vscode",this.a=new Map}load(p,i){const o=this.d.findSubstr(i);if(o){let r=this.a.get(P.ExtensionIdentifier.toKey(o.identifier));return r||(r=this.c(o,this.e,this.f),this.a.set(P.ExtensionIdentifier.toKey(o.identifier),r)),r}if(!this.b){let r="";this.d.forEach((c,s)=>r+=`	${s} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(p,i,o){this.d=p,this.nodeModuleName="keytar",this.a=i.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=o,c=i.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let s=r.appRoot.fsPath;v.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.b=new Set,this.b.add(`${s}/node_modules.asar/keytar`),this.b.add(`${s}/node_modules/keytar`)}this.c={getPassword:(s,m)=>c.$getPassword(s,m),setPassword:(s,m,n)=>c.$setPassword(s,m,n),deletePassword:(s,m)=>c.$deletePassword(s,m),findPassword:s=>c.$findPassword(s),findCredentials(s){return c.$findCredentials(s)}}}load(p,i){const o=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const i=p.length;if(i<=7||!this.b)return;const o=i-7;if((p.charAt(o)==="/"||p.charAt(o)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};g=xe([We(1,S.IExtHostRpcService),We(2,k.IExtHostInitDataService)],g);let b=class{constructor(p,i,o){this.e=p,this.f=i,this.nodeModuleName=["open","opn"],this.d=o.getProxy(l.MainContext.MainThreadTelemetry);const r=o.getProxy(l.MainContext.MainThreadWindow);this.c=(c,s)=>{const m=A.URI.parse(c);return s?this.g(c,s):m.scheme==="http"||m.scheme==="https"?r.$openUri(m,c,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?r.$openUri(m,c,{}):this.g(c,s)}}load(p,i,o){const r=this.e.findSubstr(i);return r&&(this.a=r.identifier.value,this.h()),this.b=o(p),this.c}g(p,i){return this.i(),this.b(p,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=xe([We(2,S.IExtHostRpcService)],b)}),define(De[49],Ce([1,0,65,6,11,36,4,59,60,42,7,34,234,35]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class y extends v.AbstractVariableResolverService{constructor(u,g,b,D,p,i,o){function r(){if(b){const c=b.activeEditor();if(c)return c.document.uri;const s=D.tabGroups.all.find(m=>m.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof L.TextDiffTabInput||s.input instanceof L.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof L.TextTabInput||s.input instanceof L.NotebookEditorTabInput||s.input instanceof L.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:c=>{const s=i.folders.filter(m=>m.name===c);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(c,s)=>p.getConfiguration(void 0,c).get(s),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return l.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const c=r();if(c){const s=g.getWorkspaceFolder(c);if(s)return l.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(b){const c=b.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(b){const c=b.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>u.getExtension(c)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let h=class extends A.Disposable{constructor(u,g,b,D,p){super(),this.b=u,this.c=g,this.g=b,this.h=D,this.i=p,this.a=new a.Lazy(async()=>{const i=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new y(this.b,this.c,this.g,this.i,i,r,this.j())})}getResolver(){return this.a.value}j(){}};h=xe([We(0,k.IExtHostExtensionService),We(1,T.IExtHostWorkspace),We(2,P.IExtHostDocumentsAndEditors),We(3,I.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(De[84],Ce([1,0,19,3,9,2,4,5,60,42,20,7,34,131,227,35,49]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,c,s,m,n,t){this.D=c,this.E=s,this.F=m,this.G=n,this.H=t,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=r.getProxy(P.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(E=>{this.I(f)}),this.I(f)})}asDebugSourceUri(r,c){const s=r;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let m=`debug:${encodeURIComponent(s.path||"")}`,n="?";return c&&(m+=`${n}session=${encodeURIComponent(c.id)}`,n="&"),m+=`${n}ref=${s.sourceReference}`,R.URI.parse(m)}else{if(s.path)return R.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const c=[];for(const s of r.getAllExtensionDescriptions())if(s.contributes){const m=s.contributes.debuggers;if(m&&m.length>0)for(const n of m)(0,y.isDebuggerMainContribution)(n)&&c.push(n.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(c=>r.push(c)),r}addBreakpoints(r){this.T();const c=r.filter(n=>{const t=n.id;return this.w.has(t)?!1:(this.w.set(t,n),!0)});this.U(c,[],[]);const s=[],m=new Map;for(const n of c)if(n instanceof T.SourceBreakpoint){let t=m.get(n.location.uri.toString());t||(t={type:"sourceMulti",uri:n.location.uri,lines:[]},m.set(n.location.uri.toString(),t),s.push(t)),t.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof T.FunctionBreakpoint&&s.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(s)}removeBreakpoints(r){this.T();const c=r.filter(t=>this.w.delete(t.id));this.U([],c,[]);const s=c.filter(t=>t instanceof T.SourceBreakpoint).map(t=>t.id),m=c.filter(t=>t instanceof T.FunctionBreakpoint).map(t=>t.id),n=c.filter(t=>t instanceof T.DataBreakpoint).map(t=>t.id);return this.k.$unregisterBreakpoints(s,m,n)}startDebugging(r,c,s){return this.k.$startDebugging(r?r.uri:void 0,c,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,c,s){if(!c)return new T.Disposable(()=>{});const m=this.d++;return this.f.push({type:r,handle:m,provider:c}),this.k.$registerDebugConfigurationProvider(r,s,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,m),new T.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==c),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(r,c,s){if(!s)return new T.Disposable(()=>{});if(!this.P(r,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:c,handle:m,factory:s}),this.k.$registerDebugAdapterDescriptorFactory(c,m),new T.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==s),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(r,c){if(!c)return new T.Disposable(()=>{});const s=this.i++;return this.j.push({type:r,handle:s,factory:c}),new T.Disposable(()=>{this.j=this.j.filter(m=>m.factory!==c)})}async $runInTerminal(r,c){return Promise.resolve(void 0)}async $substituteVariables(r,c){let s;const m=await this.W(r);return m&&(s={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(s,c)}J(r,c){if(r.type==="implementation")return new p(r.implementation)}K(){}async $startDASession(r,c){const s=this,m=await this.V(c);return this.R(this.M(m.type),m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const t=this.L(n),f=this.J(t,m);if(!f)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const E=f;return this.A.set(r,E),this.Q(m).then(w=>(w&&this.B.set(r,w),E.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const V=O,j={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(V.arguments.value);j.body={signature:F},E.sendResponse(j)}else throw new Error("no signer")}catch(F){j.success=!1,j.message=F.message,E.sendResponse(j)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(O),O=(0,y.convertToVSCPaths)(O,!0),s.k.$acceptDAMessage(r,O)}),E.onError(O=>{w&&w.onError&&w.onError(O),this.k.$acceptDAError(r,O.name,O.message,O.stack)}),E.onExit(O=>{w&&w.onExit&&w.onExit((0,l.withNullAsUndefined)(O),void 0),this.k.$acceptDAExit(r,(0,l.withNullAsUndefined)(O),void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),E.startSession()))})}$sendDAMessage(r,c){c=(0,y.convertToDAPaths)(c,!1);const s=this.B.get(r);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(c),this.A.get(r)?.sendMessage(c)}$stopDASession(r){const c=this.B.get(r);this.B.delete(r),c&&c.onWillStopSession&&c.onWillStopSession();const s=this.A.get(r);return this.A.delete(r),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const c=[],s=[],m=[];if(r.added)for(const n of r.added){const t=n.id;if(t&&!this.w.has(t)){let f;if(n.type==="function")f=new T.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")f=new T.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const E=R.URI.revive(n.uri);f=new T.SourceBreakpoint(new T.Location(E,new T.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,T.setBreakpointId)(f,t),this.w.set(t,f),c.push(f)}}if(r.removed)for(const n of r.removed){const t=this.w.get(n);t&&(this.w.delete(n),s.push(t))}if(r.changed){for(const n of r.changed)if(n.id){const t=this.w.get(n.id);if(t){if(t instanceof T.FunctionBreakpoint&&n.type==="function"){const f=t;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.functionName=n.functionName}else if(t instanceof T.SourceBreakpoint&&n.type==="source"){const f=t;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.location=new T.Location(R.URI.revive(n.uri),new T.Position(n.line,n.character))}m.push(t)}}}this.U(c,s,m)}$provideDebugConfigurations(r,c,s){return(0,a.asPromise)(async()=>{const m=this.O(r);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(c);return m.provideDebugConfigurations(n,s)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(r,c,s,m){return(0,a.asPromise)(async()=>{const n=this.O(r);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.W(c);return n.resolveDebugConfiguration(t,s,m)})}$resolveDebugConfigurationWithSubstitutedVariables(r,c,s,m){return(0,a.asPromise)(async()=>{const n=this.O(r);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.W(c);return n.resolveDebugConfigurationWithSubstitutedVariables(t,s,m)})}async $provideDebugAdapter(r,c){const s=this.N(r);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(c);return this.R(s,m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(r){const c=await this.V(r);this.m.fire(c)}async $acceptDebugSessionTerminated(r){const c=await this.V(r);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,c){(await this.V(r))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(r,c){const m={session:await this.V(r),event:c.event,body:c.body};this.u.fire(m)}L(r){if(r instanceof T.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof T.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const c=this.h.filter(s=>s.type===r);if(c.length>0)return c[0].factory}N(r){const c=this.h.filter(s=>s.handle===r);if(c.length>0)return c[0].factory}O(r){const c=this.f.filter(s=>s.handle===r);if(c.length>0)return c[0].provider}P(r,c){if(r.contributes){const s=r.contributes.debuggers;if(s&&s.length>0){for(const m of s)if(m.label&&m.type&&m.type===c)return!0}}return!1}Q(r){const s=r.configuration.type,m=this.j.filter(n=>n.type===s||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(r)).then(t=>t,t=>null));return Promise.race([Promise.all(m).then(n=>{const t=n.filter(f=>!!f);if(t.length>0)return new D(t)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(r,c){const s=c.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new T.DebugAdapterServer(s));if(r){const n=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>r.createDebugAdapterDescriptor(c,this.S(c,n))).then(t=>{if(t)return t})}const m=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,m))}S(r,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,c,s){(r.length>0||c.length>0||s.length>0)&&this.z.fire(Object.freeze({added:r,removed:c,changed:s}))}async V(r){if(r)if(typeof r=="string"){const c=this.l.get(r);if(c)return c}else{let c=this.l.get(r.id);if(!c){const s=await this.W(r.folderUri),m=r.parent?this.l.get(r.parent):void 0;c=new g(this.k,r.id,r.type,r.name,s,r.configuration,m),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(r){if(r){const c=R.URI.revive(r);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};u=xe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class g{constructor(r,c,s,m,n,t,f){this.d=r,this.f=c,this.g=s,this.h=m,this.i=n,this.j=t,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,c){return this.d.$customDebugAdapterRequest(this.f,r,c)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=g;class b{constructor(r){this.value=Object.freeze({append(c){r.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=b;class D{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(c=>c.onError?c.onError(r):void 0)}onExit(r,c){this.d.forEach(s=>s.onExit?s.onExit(r,c):void 0)}}class p extends I.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends u{constructor(r,c,s,m,n,t){super(r,c,s,m,n,t)}};i=xe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(De[298],Ce([1,0,12,83,2,5,290,13,90,91,25,203,20,56,42,76]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(b){const D=b.get(P.ILogService),i=b.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(o=>{D.error(o);const r=a.transformErrorForSerialization(o);i.$onUnexpectedError(r)})}static async installFullHandler(b){const D=b.get(P.ILogService),p=b.get(v.IExtHostRpcService),i=b.get(y.IExtHostExtensionService),o=b.get(h.IExtHostTelemetry),r=p.getProxy(R.MainContext.MainThreadExtensionService),c=p.getProxy(R.MainContext.MainThreadErrors),s=await i.getExtensionPathIndex(),m=new WeakMap;Error.prepareStackTrace=(n,t)=>{let f="",E,w;for(const O of t)f+=`
	at ${O.toString()}`,w=O.getFileName(),!E&&w&&(E=s.findSubstr(l.URI.file(w)));return m.set(n,E?.identifier),`${n.name||"Error"}: ${n.message||""}${f}`},a.setUnexpectedErrorHandler(n=>{D.error(n);const t=a.transformErrorForSerialization(n),f=m.get(n);if(!f){c.$onUnexpectedError(t);return}r.$onExtensionRuntimeError(f,t);const E=o.onExtensionError(f,n);D.trace("forwarded error to extension?",E,f)})}}Error.stackTraceLimit=100;class u{constructor(b,D,p,i,o){this.a=p,this.b=new C.RPCProtocol(b,null,i),D=u.e(D,this.b);const r=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:o}),r.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),r.set(I.IURITransformerService,new I.URITransformerService(i)),r.set(y.IHostUtils,p);const c=new T.InstantiationService(r,!0);c.invokeFunction(d.installEarlyHandler),this.d=c.invokeFunction(s=>s.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=c.invokeFunction(s=>s.get(y.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(d.installFullHandler)}async asBrowserUri(b){const D=this.b.getProxy(R.MainContext.MainThreadExtensionService);return l.URI.revive(await D.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,D){b.allExtensions.forEach(i=>{i.extensionLocation=l.URI.revive(D.transformIncomingURIs(i.extensionLocation));const o={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(r=>o[r]=l.URI.revive(D.transformIncomingURIs(i.browserNlsBundleUris[r]))),i.browserNlsBundleUris=o)}),b.environment.appRoot=l.URI.revive(D.transformIncomingURIs(b.environment.appRoot));const p=b.environment.extensionDevelopmentLocationURI;return p&&(b.environment.extensionDevelopmentLocationURI=p.map(i=>l.URI.revive(D.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=l.URI.revive(D.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=l.URI.revive(D.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=l.URI.revive(D.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=l.URI.revive(D.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=l.URI.revive(D.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=l.URI.revive(D.transformIncomingURIs(b.logsLocation)),b.logFile=l.URI.revive(D.transformIncomingURIs(b.logFile)),b.workspace=D.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=u}),define(De[299],Ce([1,0,19,10,185,202,210,84,60,42,20,41,7,49,34,228,230,35]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let g=class extends P.ExtHostDebugServiceBase{constructor(o,r,c,s,m,n,t){super(o,r,c,s,n,t),this.Z=m,this.X=new p}J(o,r){switch(o.type){case"server":return new h.SocketDebugAdapter(o);case"pipeServer":return new h.NamedPipeDebugAdapter(o);case"executable":return new h.ExecutableDebugAdapter(o,r.type)}return super.J(o,r)}S(o,r){const c=h.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),o.type);if(c)return new v.DebugAdapterExecutable(c.command,c.args,c.options)}K(){return new C.SignService}async $runInTerminal(o,r){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const c=await this.F.getConfigProvider(),s=this.Z.getDefaultShell(!0),m=this.Z.getDefaultShellArgs(!0),n=o.title||l.localize(0,null),t=JSON.stringify({shell:s,shellArgs:m});let f=await this.X.checkout(t,n),E,w=!1;if(f)E=o.cwd;else{const F={shellPath:s,shellArgs:m,cwd:o.cwd,name:n,iconPath:new v.ThemeIcon("debug")};w=!0,f=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(f,t)}f.show(!0);const O=await f.processId;w?await new Promise(F=>setTimeout(F,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?f.sendText("cls"):s.indexOf("bash")>=0?f.sendText("clear"):A.isWindows?f.sendText("cls"):f.sendText("clear"));const V=(0,d.prepareCommand)(s,o.args,!!o.argsCanBeInterpretedByShell,E,o.env);f.sendText(V);const j=this.onDidTerminateDebugSession(F=>{F.id===r&&(this.X.free(f),j.dispose())});return O}else if(o.kind==="external")return D(o,await this.F.getConfigProvider());return super.$runInTerminal(o,r)}};g=xe([We(0,L.IExtHostRpcService),We(1,y.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,u.IExtHostConfiguration),We(4,T.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,I.IExtHostVariableResolverProvider)],g),e.ExtHostDebugService=g;let b;function D(i,o){if(!b)if(A.isWindows)b=new R.WindowsExternalTerminalService;else if(A.isMacintosh)b=new R.MacExternalTerminalService;else if(A.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=o.getConfiguration("terminal");return b.runInTerminal(i.title,i.cwd,i.args,i.env||{},r.external||{})}class p{constructor(){this.b=new Map}async checkout(o,r){const s=[...this.b.entries()].map(([m,n])=>(0,a.createCancelablePromise)(async t=>{if(m.name!==r||n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await m.processId))return null;const f=Date.now();return n.lastUsedAt+p.a>f||t.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=f,m)}));return await(0,a.firstParallel)(s,m=>!!m)}insert(o,r){this.b.set(o,{lastUsedAt:Date.now(),config:r})}free(o){const r=this.b.get(o);r&&(r.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}p.a=1e3}),define(De[300],Ce([1,0,11,2,116,34,59,35,47,41,20,25,82,16,13,77,24,89,49]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(p,i,o,r,c,s,m,n,t){super(p,i,o,r,c,s,m,n),this.B=o,this.C=t,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,i){const o=i;if(!i.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const r=v.TaskHandleDTO.from(o,this.B),c=await this.a.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.y(c,i);return this.a.$executeTask(r).catch(()=>{}),s}else{const r=v.TaskDTO.from(i,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(r.execution)&&await this.x(r,i,!1);const c=await this.y(await this.a.$getTaskExecution(r),i);return this.a.$executeTask(r).catch(()=>{}),c}}u(p,i,o,r){const c=[];if(r)for(const s of r){this.z(s,o),(!s.definition||!p[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const m=v.TaskDTO.from(s,o.extension);m&&(c.push(m),v.CustomExecutionDTO.is(m.execution)&&i.push(this.x(m,s,!0)))}return{tasks:c,extension:o.extension}}async v(p){return p}async F(p){let i=p&&p.length>0?p[0]:void 0;if(!i){const o=A.URI.file((0,u.homedir)());i=new S.WorkspaceFolder({uri:o,name:d.basename(o),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,i){const o=A.URI.revive(p),r={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(o),s=await this.b.getWorkspaceFolders2()??[],m=await this.C.getResolver(),n=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(s);for(const t of i.variables)r.variables[t]=await m.resolveAsync(n,t);if(i.process!==void 0){let t;if(i.process.path!==void 0){t=i.process.path.split(a.delimiter);for(let f=0;f<t.length;f++)t[f]=await m.resolveAsync(n,t[f])}r.process=await l.win32.findExecutable(await m.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await m.resolveAsync(n,i.process.cwd):void 0,t)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,i,o){return l.win32.findExecutable(p,i,o)}};b=xe([We(0,L.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,y.ILogService),We(7,h.IExtHostApiDeprecationService),We(8,g.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(De[301],Ce([1,0,89,49]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends A.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(De[143],Ce([1,0,15,19,21,45,16,11,24,2,31]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(g,b,D,p){this.d=g,this.e=b,this.f=D,this.g=p,this.a=null,this.b=!1,this.c=0}search(g,b){const D=this.d.folderQueries||[],p=new l.CancellationTokenSource;return b.onCancellationRequested(()=>p.cancel()),new Promise((i,o)=>{this.a=new I(g);let r=!1;const c=(s,m)=>{if(!r&&!this.b){const n=this.h(s);h(s)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,r=!0,p.cancel(),s=this.j(s,this.d.maxResults-this.c));const t=this.h(s);this.c+=t,(t>0||!h(s))&&this.a.add(s,m)}};Promise.all(D.map((s,m)=>this.k(s,n=>c(n,m),p.token))).then(s=>{p.dispose(),this.a.flush();const m=s.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||m,messages:(0,a.flatten)(s.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},s=>{p.dispose();const m=(0,R.toErrorMessage)(s);o(new Error(m))})})}h(g){return h(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,b){const D=Array.isArray(g.ranges)?g.ranges:[g.ranges],p=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:D.slice(0,b),preview:{matches:p.slice(0,b),text:g.preview.text},uri:g.uri}}async k(g,b,D){const p=new L.QueryGlobTester(this.d,g),i=[],o={report:s=>{if(!this.l(s))return;const m=g.folder.scheme===C.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(s.uri))):void 0,n=S.relativePath(g.folder,s.uri);if(n){const t=p.includedInQuery(n,P.basename(n),m);(0,A.isThenable)(t)?i.push(t.then(f=>{f&&b(s)})):t&&b(s)}}},r=this.n(g),c=await this.e.provideTextSearchResults(v(this.d.contentPattern),r,o,D);return i.length&&await Promise.all(i),c}l(g){if(h(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const b=(0,L.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),D=(0,L.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),p={folder:k.URI.from(g.folder),excludes:D,includes:b,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=T;function v(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class I{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new d(512,b=>this.g(b))}add(g,b){this.d&&(this.b!==b||!S.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:g.uri,results:[]}),this.d.results.push(y(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=I;function y(u){return h(u)?{preview:{matches:(0,a.mapArrayOrNot)(u.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:u.preview.text},ranges:(0,a.mapArrayOrNot)(u.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function h(u){return!!u.preview}e.extensionResultIsMatch=h;class d{constructor(g,b){this.g=g,this.h=b,this.c=0,this.d=[],this.e=0}addItem(g,b){!g||this.j(g,b)}addItems(g,b){!g||this.k(g,b)}j(g,b){this.d.push(g),this.e+=b,this.l()}k(g,b){this.d=this.d.concat(g),this.e+=b,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}d.a=4e3,d.b=50,e.BatchedCollector=d}),define(De[85],Ce([1,0,6,5,4,294,20,56,13,2,143]),function(ne,e,a,A,l,R,C,P,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let T=class{constructor(h,d,u){this.k=h,this.l=d,this.n=u,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(h){return this.l.transformOutgoingScheme(h)}registerTextSearchProvider(h,d){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const u=this.d++;return this.e.set(u,d),this.c.$registerTextSearchProvider(u,this.o(h)),(0,a.toDisposable)(()=>{this.g.delete(h),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(h,d){if(this.i.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.i.add(h);const u=this.d++;return this.h.set(u,d),this.c.$registerFileSearchProvider(u,this.o(h)),(0,a.toDisposable)(()=>{this.i.delete(h),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(h,d,u,g){const b=v(u),D=this.h.get(h);if(D)return this.j.fileSearch(b,D,p=>{this.c.$handleFileMatch(h,d,p.map(i=>i.resource))},g);throw new Error("unknown provider: "+h)}$clearCache(h){return this.j.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,d,u,g){const b=this.e.get(h);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const D=v(u);return this.q(D,b).search(i=>this.c.$handleTextMatch(h,d,i),g)}$enableExtensionHostSearch(){}q(h,d){return new L.TextSearchManager(h,d,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};T=xe([We(0,C.IExtHostRpcService),We(1,P.IURITransformerService),We(2,S.ILogService)],T),e.ExtHostSearch=T;function v(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(I),extraFileResources:y.extraFileResources&&y.extraFileResources.map(h=>k.URI.revive(h))}}e.reviveQuery=v;function I(y){return{...y,folder:k.URI.revive(y.folder)}}}),define(De[302],Ce([1,0,90,142,34,139,35,40,59,41,82,84,85,99,55,77,141,78,48,98,76,60,140,13,219,49,97]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p,i,o,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,a.registerSingleton)(o.ILoggerService,i.ExtHostLoggerService,1),(0,a.registerSingleton)(o.ILogService,r.ExtHostLogService,1),(0,a.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,a.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,a.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,a.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,a.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,a.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,0),(0,a.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,a.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(y.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,a.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,a.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,a.registerSingleton)(D.IExtHostTelemetry,D.ExtHostTelemetry,0),(0,a.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,a.registerSingleton)(c.IExtHostVariableResolverProvider,c.ExtHostVariableResolverProviderService,0)}),define(De[100],Ce([1,0,15,13,31,81]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=C;function P(T,v,I,y){const h=(0,a.mapArrayOrNot)(I,S),d=new l.TextSearchMatch(v,h,y),u=d.preview.matches;return{ranges:(0,a.mapArrayOrNot)(h,k),uri:T,preview:{text:d.preview.text,matches:(0,a.mapArrayOrNot)(u,k)}}}e.createTextSearchResult=P;function S(T){return new l.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function k(T){return new R.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(v,I){this.a=v,this.b=I}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=xe([We(1,A.ILogService)],L),e.OutputChannel=L}),define(De[303],Ce([1,0,46,11,86,33,10,8,100,304]),function(ne,e,a,A,l,R,C,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(b,D,p,i){const o=v(b,D,p,i),r=D.folder.fsPath;return{cmd:a.spawn(L,o.args,{cwd:r}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:r}}e.spawnRipgrepCmd=T;function v(b,D,p,i){const o=["--files","--hidden","--case-sensitive"];y([D],p,!1).forEach(c=>{const s=(0,S.anchorGlob)(c);if(o.push("-g",s),C.isMacintosh){const m=(0,l.normalizeNFD)(s);m!==s&&o.push("-g",m)}});const r=I([D],i,void 0,!1);return r.globArgs.forEach(c=>{const s=`!${(0,S.anchorGlob)(c)}`;if(o.push("-g",s),C.isMacintosh){const m=(0,l.normalizeNFD)(s);m!==s&&o.push("-g",m)}}),D.disregardIgnoreFiles!==!1?o.push("--no-ignore"):D.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),D.ignoreSymlinks||o.push("--follow"),b.exists&&o.push("--quiet"),o.push("--no-config"),D.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:r.siblingClauses}}function I(b,D,p,i=!0){const o=[];let r={};return b.forEach(c=>{const s=Object.assign({},c.excludePattern||{},D||{}),m=h(s,i?c.folder.fsPath:void 0,p);o.push(...m.globArgs),m.siblingClauses&&(r=Object.assign(r,m.siblingClauses))}),{globArgs:o,siblingClauses:r}}function y(b,D,p=!0){const i=[];return b.forEach(o=>{const r=Object.assign({},D||{},o.includePattern||{}),c=h(r,p?o.folder.fsPath:void 0);i.push(...c.globArgs)}),i}function h(b,D,p){const i=[],o={};return Object.keys(b).forEach(r=>{if(p&&p.has(r)||!r)return;const c=b[r];r=u(D?d(D,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),i.push(g(r))):c&&c.when&&(o[r]=c)}),{globArgs:i,siblingClauses:o}}function d(b,D){return A.isAbsolute(D)?D:A.join(b,D)}e.getAbsoluteGlob=d;function u(b){return b=P.rtrim(b,"\\"),P.rtrim(b,"/")}function g(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=g}),define(De[305],Ce([1,0,46,70,11,306,15,45,38,86,33,10,43,8,9,29,31,303,111]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(r=>r())});class D{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&S.parse(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,g.prepareQuery)(this.b).normalizedLowercase),this.u=c.excludePattern&&S.parse(c.excludePattern),this.t=new Map,c.folderQueries.forEach(s=>{const m=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),n=s.folder.fsPath;c.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==n).forEach(t=>{(0,L.isEqualOrParent)(t,n)&&(m[l.relative(n,t)]=!0)}),this.t.set(n,new i(m,n))})}cancel(){this.l=!0,b.forEach(c=>c())}walk(c,s,m,n,t){if(this.m=v.StopWatch.create(!1),this.l)return t(null,this.j);s.forEach(f=>{const E=l.basename(f.fsPath);this.u&&this.u(f.fsPath,E)||this.J(m,{relativePath:f.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(c,(f,E)=>{this.x(this.y,this,f,m,n,w=>{if(w){const O=(0,P.toErrorMessage)(w);console.error(O),this.q.push(O),E(w,void 0)}else E(null,void 0)})},(f,E)=>{this.m.stop();const w=f?C.coalesce(f)[0]:null;t(w,this.j)})}w(c,s,m){const n=new Array(c.length),t=new Array(c.length);let f=!1,E=0;if(c.length===0)return m(null,[]);c.forEach((w,O)=>{s(w,(V,j)=>{if(V?(f=!0,n[O]=null,t[O]=V):(n[O]=j,t[O]=null),++E===c.length)return m(f?t:null,n)})})}x(c,s,...m){try{c.apply(s,m)}catch(n){m[m.length-1](n)}}y(c,s,m,n){const t=c.folder.fsPath,f=T.isMacintosh,E=()=>F&&F.kill();b.add(E);let w=$=>{b.delete(E),w=()=>{},n($)},O="";const V=this.D(),j=(0,u.spawnRipgrepCmd)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),F=j.cmd,B=!Object.keys(j.siblingClauses).length,N=j.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let U=`${j.rgDiskPath} ${N}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),m({message:U}),this.s=0,this.z(F,"utf8",m,($,z,ae)=>{if($){w($);return}if(this.j){w();return}const q=(O+(f?k.normalizeNFC(z||""):z)).split(`
`);if(ae){const J=q.length;q[J-1]=q[J-1].trim(),q[J-1]||q.pop()}else O=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=q.length,B){for(const J of q)if(this.J(s,{base:t,relativePath:J,searchPath:this.N(c,J)}),this.j){E();break}(ae||this.j)&&w();return}this.G(c,V,t,q,s),ae&&(this.H(V,t,s),w())})}spawnFindCmd(c){const s=this.t.get(c.folder.fsPath),m=s.getBasenameTerms(),n=s.getPathTerms(),t=["-L","."];if(m.length||n.length){t.push("-not","(","(");for(const f of m)t.push("-name",f),t.push("-o");for(const f of n)t.push("-path",f),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),a.spawn("find",t,{cwd:c.folder.fsPath})}readStdout(c,s,m){let n="";this.z(c,s,()=>{},(t,f,E)=>{if(t){m(t);return}n+=f,E&&m(null,n)})}z(c,s,m,n){let t=(w,O,V)=>{(w||V)&&(t=()=>{},this.r?.stop()),n(w,O,V)},f=!1;c.stdout?(this.A(c.stdout,s,t),c.stdout.once("data",()=>f=!0)):m({message:"stdout is null"});let E;c.stderr?E=this.B(c.stderr):m({message:"stderr is null"}),c.on("error",w=>{t(w)}),c.on("close",w=>{let O;!f&&(O=this.C(E,s))&&o(O)?t(new Error(`command failed with error code ${w}: ${this.C(E,s)}`)):(this.g&&w===0&&(this.j=!0),t(null,"",!0))})}A(c,s,m){const n=new R.StringDecoder(s);return c.on("data",t=>{m(null,n.write(t))}),n}B(c){const s=[];return c.on("data",m=>{s.push(m)}),s}C(c,s){const m=new R.StringDecoder(s);return c.map(n=>m.write(n)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:s},m,n,t){n.indexOf(this.b)!==-1&&this.J(t,{base:m,relativePath:this.b,searchPath:this.N(c,this.b)});const f=E=>{const w=l.basename(E),O=l.dirname(E);let V=s[O];V||(V=s[O]=[],f(O)),V.push({base:m,relativePath:E,basename:w,searchPath:this.N(c,E)})};n.forEach(f)}H({rootEntries:c,pathToEntries:s},m,n){const t=this,f=this.t.get(m),E=this.b;function w(O){t.o++;const V=(0,d.hasSiblingFn)(()=>O.map(j=>j.basename));for(let j=0,F=O.length;j<F;j++){const B=O[j],{relativePath:N,basename:U}=B;if(f.test(N,U,E!==U?V:void 0))continue;const $=s[N];if($)w($);else{if(t.p++,N===E)continue;t.J(n,B)}if(t.j)break}}w(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,s,m,n,t){const f=c.folder,E=(0,d.hasSiblingFn)(()=>m);this.w(m,(w,O)=>{if(this.l||this.j)return O(null);const V=s?[s,w].join(l.sep):w;if(this.t.get(c.folder.fsPath).test(V,w,this.a.filePattern!==w?E:void 0))return O(null);const j=[f.fsPath,V].join(l.sep);A.lstat(j,(F,B)=>{if(F||this.l||this.j)return O(null);this.L(j,B,(N,U)=>N||this.l||this.j?O(null):U.isDirectory()?(this.o++,this.M(j,B,($,z)=>$||this.l||this.j||(z=z||"",this.v[z])?O(null):(this.v[z]=!0,h.Promises.readdir(j).then(ae=>{if(this.l||this.j)return O(null);this.I(c,V,ae,n,ee=>O(ee||null))},ae=>{O(null)})))):(this.p++,V===this.b||this.h&&y.isNumber(U.size)&&U.size>this.h||this.J(n,{base:f.fsPath,relativePath:V,searchPath:this.N(c,V)}),O(null,void 0)))})},w=>{const O=w&&C.coalesce(w);return t(O&&O.length>0?O[0]:void 0)})}J(c,s){this.K(s)&&(!this.d||this.d(s.relativePath,l.basename(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(s))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(c,this.c)}return!0}L(c,s,m){return s.isSymbolicLink()?A.stat(c,m):m(null,s)}M(c,s,m){return s.isSymbolicLink()?A.realpath(c,(n,t)=>n?m(n):m(null,t)):m(null,c)}N(c,s){return c.folderName?l.join(c.folderName,s):s}}e.FileWalker=D;class p{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new D(c)}search(c,s,m){this.c.walk(this.a,this.b,c,s,(n,t)=>{m(n,{limitHit:t,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class i{constructor(c,s){this.expression=c,this.c=s,this.d(c)}d(c){let s,m;Object.keys(c).filter(n=>c[n]).forEach(n=>{l.isAbsolute(n)?(s=s||S.getEmptyExpression(),s[n]=c[n]):(m=m||S.getEmptyExpression(),m[n]=c[n])}),this.a=s&&S.parse(s,{trimForExclusions:!0}),this.b=m&&S.parse(m,{trimForExclusions:!0})}test(c,s,m){return this.b&&this.b(c,s,m)||this.a&&this.a(l.join(this.c,c),s,m)}getBasenameTerms(){const c=[];return this.a&&c.push(...S.getBasenameTerms(this.a)),this.b&&c.push(...S.getBasenameTerms(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...S.getPathTerms(this.a)),this.b&&c.push(...S.getPathTerms(this.b)),c}}function o(r){const c=r.trim().split(`
`),s=c[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return I.uppercaseFirstLetter(c[c.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(De[307],Ce([1,0,103,22]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(c=>c===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,C=512,P=512*8,S=512*128;var k;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(c,s){super(c),this.decodeStreamErrorKind=s}}e.DecodeStreamError=L;class T{static async create(c){let s;if(c!==e.UTF8)s=(await new Promise((n,t)=>{ne(["@vscode/iconv-lite-umd"],n,t)})).getDecoder(h(c));else{const m=new TextDecoder;s={write(n){return m.decode(n,{stream:!0})},end(){return m.decode()}}}return new T(s)}constructor(c){this.a=c}write(c){return this.a.write(c)}end(){return this.a.end()}}function v(r,c){const s=c.minBytesRequiredForDetection??c.guessEncoding?P:C;return new Promise((m,n)=>{const t=(0,a.newWriteableStream)(j=>j.join("")),f=[];let E=0,w;const O=async()=>{try{const j=await o({buffer:A.VSBuffer.concat(f),bytesRead:E},c.guessEncoding);if(j.seemsBinary&&c.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);j.encoding=await c.overwriteEncoding(j.encoding),w=await T.create(j.encoding);const F=w.write(A.VSBuffer.concat(f).buffer);t.write(F),f.length=0,E=0,m({stream:t,detected:j})}catch(j){V?.dispose(),t.destroy(),n(j)}},V=(0,a.listenStream)(r,{onData:async j=>{w?t.write(w.write(j.buffer)):(f.push(j),E+=j.byteLength,E>=s&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:j=>t.error(j),onEnd:async()=>{w||await O(),t.end(w?.end())}})})}e.toDecodeStream=v;async function I(r,c,s){const n=(await new Promise((E,w)=>{ne(["@vscode/iconv-lite-umd"],E,w)})).getEncoder(h(c),s);let t=!1,f=!1;return{read(){if(f)return null;const E=r.read();if(typeof E!="string"){if(f=!0,!t&&s?.addBOM)switch(c){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const w=n.end();return w&&w.length>0?(t=!0,A.VSBuffer.wrap(w)):null}return t=!0,A.VSBuffer.wrap(n.write(E))}}}e.toEncodeReadable=I;async function y(r){return(await new Promise((s,m)=>{ne(["@vscode/iconv-lite-umd"],s,m)})).encodingExists(h(r))}e.encodingExists=y;function h(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=h;function d(r,c){if(!r||c<e.UTF16be_BOM.length)return null;const s=r.readUInt8(0),m=r.readUInt8(1);if(s===e.UTF16be_BOM[0]&&m===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&m===e.UTF16le_BOM[1])return e.UTF16le;if(c<e.UTF8_BOM.length)return null;const n=r.readUInt8(2);return s===e.UTF8_BOM[0]&&m===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const u=["ascii","utf-16","utf-32"];async function g(r){const c=await new Promise((f,E)=>{ne(["jschardet"],f,E)}),s=r.slice(0,S),m=p(s.buffer),n=c.detect(m);if(!n||!n.encoding)return null;const t=n.encoding.toLowerCase();return 0<=u.indexOf(t)?null:D(n.encoding)}const b={ibm866:"cp866",big5:"cp950"};function D(r){const c=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[c]||c}function p(r){let c="";for(let s=0;s<r.length;s++)c+=String.fromCharCode(r[s]);return c}function i(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=r.match(/windows(\d+)/);return c?"windows-"+c[1]:r}}}e.toCanonicalName=i;function o({buffer:r,bytesRead:c},s){let m=d(r,c),n=!1;if(m!==e.UTF16be&&m!==e.UTF16le&&r){let t=!0,f=!0,E=!1;for(let w=0;w<c&&w<R;w++){const O=w%2===1,V=r.readUInt8(w)===0;if(V&&(E=!0),t&&(O&&!V||!O&&V)&&(t=!1),f&&(O&&V||!O&&!V)&&(f=!1),V&&!t&&!f)break}E&&(t?m=e.UTF16le:f?m=e.UTF16be:n=!0)}return s&&!n&&!m&&r?g(r.slice(0,c)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:n,encoding:m}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[144],Ce([1,0,307,29,143]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends l.TextSearchManager{constructor(P,S,k=A,L="searchProcess"){super(P,S,{readdir:T=>k.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,a.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=R}),define(De[308],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(l){if(l&&this.a.has(l)){const R=this.a.get(l);return this.a.delete(l),R}}addDragOperationTransfer(l,R){this.a.set(l,R)}getRenderedTreeElement(l){if(this.b.has(l))return this.b.get(l)}addRenderedTreeItemElement(l,R){this.b.set(l,R)}removeRenderedTreeItemElement(l){this.b.has(l)&&this.b.delete(l)}}e.TreeviewsService=a}),define(De[309],Ce([1,0,183,7,24,2,3,6,225,19,7,9,15,14,21,308,27]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(D,p){if((0,T.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let i;return Array.isArray(D.highlights)&&(i=D.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),i=i.length?i:void 0),{label:D.label,highlights:i}}}class g{constructor(p,i,o){this.d=p,this.e=i,this.f=o,this.a=new Map,this.b=new h.TreeviewsService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:c=>r(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(s=>r(s)?this.i(s):s):c})}registerTreeDataProvider(p,i,o){const r=this.createTreeView(p,{treeDataProvider:i},o);return{dispose:()=>r.dispose()}}createTreeView(p,i,o){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=i.dragAndDropController?.dropMimeTypes??[],c=i.dragAndDropController?.dragMimeTypes??[],s=!!i.dragAndDropController?.handleDrag,m=!!i.dragAndDropController?.handleDrop,n=this.h(p,i,o),t=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:s,hasHandleDrop:m});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(o,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(f){n.message=f},get title(){return n.title},set title(f){n.title=f},get description(){return n.description},set description(f){n.description=f},get badge(){return n.badge},set badge(f){f!==void 0&&L.ViewBadge.isViewBadge(f)?n.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(n.badge=void 0)},reveal:(f,E)=>n.reveal(f,E),dispose:async()=>{await t,this.a.delete(p),n.dispose()}}}$getChildren(p,i){const o=this.a.get(p);return o?o.getChildren(i):Promise.reject(new S.NoTreeViewError(p))}async $handleDrop(p,i,o,r,c,s,m,n){const t=this.a.get(p);if(!t)return Promise.reject(new S.NoTreeViewError(p));const f=I.DataTransfer.toDataTransfer(o,async E=>(await this.d.$resolveDropFileData(p,i,E)).buffer);return m===p&&n&&await this.g(f,t,n,c,s),t.onDrop(f,r,c)}async g(p,i,o,r,c){const s=this.b.removeDragOperationTransfer(c);if(s)(await s)?.forEach((m,n)=>{m&&p.set(n,m)});else if(c&&i.handleDrag){const m=i.handleDrag(o,p,r);this.b.addDragOperationTransfer(c,m),await m}return p}async $handleDrag(p,i,o,r){const c=this.a.get(p);if(!c)return Promise.reject(new S.NoTreeViewError(p));const s=await this.g(new A.DataTransfer,c,i,r,o);if(!!s)return I.DataTransfer.toDataTransferDTO(s)}async $hasResolve(p){const i=this.a.get(p);if(!i)throw new S.NoTreeViewError(p);return i.hasResolve}$resolve(p,i,o){const r=this.a.get(p);if(!r)throw new S.NoTreeViewError(p);return r.resolveTreeItem(i,o)}$setExpanded(p,i,o){const r=this.a.get(p);if(!r)throw new S.NoTreeViewError(p);r.setExpanded(i,o)}$setSelection(p,i){const o=this.a.get(p);if(!o)throw new S.NoTreeViewError(p);o.setSelection(i)}$setFocus(p,i){const o=this.a.get(p);if(!o)throw new S.NoTreeViewError(p);o.setFocus(i)}$setVisible(p,i){const o=this.a.get(p);if(!o)throw new S.NoTreeViewError(p);o.setVisible(i)}$changeCheckboxState(p,i){const o=this.a.get(p);if(!o)throw new S.NoTreeViewError(p);o.setCheckboxState(i)}h(p,i,o){const r=new b(p,i,this.d,this.e.converter,this.f,o);return this.a.set(p,r),r}i(p){const i=this.a.get(p.$treeViewId);return i&&"$treeItemHandle"in p?i.getExtensionElement(p.$treeItemHandle):i&&"$focusedTreeItem"in p&&p.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=g;class b extends P.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,T.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,i,o,r,c,s){if(super(),this.C=p,this.D=o,this.F=r,this.G=c,this.H=s,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new y.CancellationTokenSource,s.contributes&&s.contributes.views)for(const t in s.contributes.views)for(const f of s.contributes.views[t])f.id===p&&(this.J=f.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let m,n;this.B(C.Event.debounce(this.w.event,(t,f)=>(t||(t={message:!1,elements:[]}),f.element!==!1&&(m||(m=new Promise(E=>n=E),this.y=this.y.then(()=>m)),Array.isArray(f.element)?t.elements.push(...f.element):t.elements.push(f.element)),f.message&&(t.message=!0),t),200,!0)(({message:t,elements:f})=>{f.length&&(this.z=this.z.then(()=>{const E=n;return m=null,this.U(f).then(()=>E())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const i=p?this.getExtensionElement(p):void 0;if(p&&!i)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let o=this.Q(p);return o||(o=await this.R(i)),o?o.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,i){i=i||{select:!0,focus:!1};const o=(0,T.isUndefinedOrNull)(i.select)?!0:i.select,r=(0,T.isUndefinedOrNull)(i.focus)?!1:i.focus,c=(0,T.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(s=>this.P(p,s[s.length-1]).then(m=>this.D.$reveal(this.C,{item:m.item,parentChain:s.map(n=>n.item)},{select:o,focus:r,expand:c})),s=>this.G.error(s)):this.D.$reveal(this.C,void 0,{select:o,focus:r,expand:c})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=I.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,i){const o=this.getExtensionElement(p);o&&(i?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelection(p){(0,v.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const i=(await Promise.all(p.map(async o=>{const r=this.getExtensionElement(o.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);i.forEach(o=>{o.treeItem.checkboxState=o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(o=>[o.extensionItem,o.newState])})}async handleDrag(p,i,o){const r=[];for(const c of p){const s=this.getExtensionElement(c);s&&r.push(s)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,i,o),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,i,o){const r=i?this.getExtensionElement(i):void 0;if(!(!r&&i||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,i){if(!this.f.resolveTreeItem)return;const o=this.i.get(p);if(o){const r=this.j.get(o);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,o,i)??r.extensionItem;return this.db(c),r.item.tooltip=this.ab(c.tooltip),r.item.command=this.bb(r.disposableStore,c.command),r.item}}}N(p){return this.O(p).then(i=>i?this.N(i).then(o=>this.P(i,o[o.length-1]).then(r=>(o.push(r),o))):Promise.resolve([]))}O(p){const i=this.j.get(p);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(p))}P(p,i){const o=this.j.get(p);return o?Promise.resolve(o):(0,k.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,i,!0)).then(r=>this.getChildren(i?i.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const s=this.j.get(c);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let i;if(typeof p=="string"){const o=this.getExtensionElement(p);i=o?this.j.get(o):void 0}else i=p;return i&&i.children||void 0}return this.h}async R(p){this.nb(p);const i=new y.CancellationTokenSource(this.S.token);try{const o=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(i.token.isCancellationRequested)return;const c=await Promise.all((0,v.coalesce)(r||[]).map(async s=>{const m=await this.f.getTreeItem(s);return m&&!i.token.isCancellationRequested?this.Z(s,m,o):null}));return i.token.isCancellationRequested?void 0:(0,v.coalesce)(c)}finally{i.dispose()}}U(p){if(p.some(o=>!o))return this.S.dispose(!0),this.S=new y.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const o=this.W(p);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(p){const i=new Set,o=p.map(c=>this.j.get(c));for(const c of o)if(c&&!i.has(c.item.handle)){let s=c;for(;s&&s.parent&&o.findIndex(m=>s&&s.parent&&m&&m.item.handle===s.parent.item.handle)===-1;){const m=this.i.get(s.parent.item.handle);s=m?this.j.get(m):void 0}s&&!s.parent&&i.add(c.item.handle)}const r=[];return i.forEach(c=>{const s=this.i.get(c);if(s){const m=this.j.get(s);m&&(!m.parent||!i.has(m.parent.item.handle))&&r.push(c)}}),r}X(p){const i={};return Promise.all(p.map(o=>this.Y(o).then(r=>{r&&(i[o]=r.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(p){const i=this.getExtensionElement(p);if(i){const o=this.j.get(i);if(o)return this.nb(i),(0,k.asPromise)(()=>this.f.getTreeItem(i)).then(r=>{if(r){const c=this.eb(i,r,o.parent);return this.lb(i,c,o,o.parent),o.dispose(),c}return null})}return Promise.resolve(null)}Z(p,i,o){const r=this.eb(p,i,o);if(i.id&&this.i.has(r.item.handle))throw new Error((0,a.localize)(0,null,i.id));return this.kb(p,r),this.mb(r,o),r}ab(p){return L.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}bb(p,i){return i?{...this.F.toInternal(i,p),originalId:i.command}:void 0}cb(p){if(!p.checkboxState)return;let i,o;return typeof p.checkboxState=="number"?i=p.checkboxState:(i=p.checkboxState.state,o=p.checkboxState.tooltip),{isChecked:i===L.TreeItemCheckboxState.Checked,tooltip:o}}db(p){if(!L.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,i,o){this.db(i);const r=new P.DisposableStore,c=this.gb(p,i,o),s=this.hb(i);return{item:{handle:c,parentHandle:o?o.item.handle:void 0,label:u(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(r,i.command),contextValue:i.contextValue,icon:s,iconDark:this.ib(i)||s,themeIcon:this.fb(i),collapsibleState:(0,T.isUndefinedOrNull)(i.collapsibleState)?L.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:o,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof L.ThemeIcon?p.iconPath:void 0}gb(p,{id:i,label:o,resourceUri:r},c,s){if(i)return`${b.b}/${i}`;const m=u(o,this.H),n=c?c.item.handle:b.a;let t=m?m.label:r?(0,l.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const f=this.j.has(p)?this.j.get(p).item.handle:void 0,E=this.Q(c)||[];let w,O=0;do{if(w=`${n}/${O}:${t}`,s||!this.i.has(w)||f===w)break;O++}while(O<=E.length);return w}hb(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,i){this.i.set(i.item.handle,p),this.j.set(p,i)}lb(p,i,o,r){this.i.delete(i.item.handle),this.j.delete(p),i.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(p,i);const c=this.Q(r)||[],s=c.filter(m=>m.item.handle===o.item.handle)[0];s&&c.splice(c.indexOf(s),1,i)}mb(p,i){i?(i.children||(i.children=[]),i.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const i=this.j.get(p);if(i){if(i.children)for(const o of i.children){const r=this.i.get(o.item.handle);r&&this.ob(r)}i.children=void 0}}else this.pb()}ob(p){const i=this.j.get(p);if(i){if(i.children)for(const o of i.children){const r=this.i.get(o.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(De[310],Ce([1,0,21,12,3,37,2,121,107,153,164,44,5,96,252,251,40,253,35,255,256,257,240,258,59,42,259,260,263,264,265,142,243,271,272,273,99,41,275,309,14,7,73,278,80,141,34,232,262,72,139,82,84,85,13,56,20,25,266,239,55,77,249,276,79,78,281,279,280,250,48,274,277,98,60,76,267,81,268,16,125,242,221,261,6,27,226,97,217,269,270]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D,p,i,o,r,c,s,m,n,t,f,E,w,O,V,j,F,B,N,U,$,z,ae,ee,q,J,ie,ge,X,Y,Z,fe,ve,ke,Oe,oe,le,ue,te,ce,se,M,W,G,_,de,we,Ae,be,Ie,Te,Ve,Ge,nt,Qe,it,rt,ct,Me,Ee,K,Q,pe,Le,$e,je,Ye,et,ot,ft,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Lt(st){const pt=st.get(ue.IExtHostInitDataService),Ft=st.get(Te.IExtHostFileSystemInfo),Kt=st.get(de.IExtHostConsumerFileSystem),Pt=st.get(c.IExtHostExtensionService),mt=st.get(ie.IExtHostWorkspace),kt=st.get(it.IExtHostTelemetry),$t=st.get(g.IExtHostConfiguration),Ot=st.get(oe.IURITransformerService),Xe=st.get(le.IExtHostRpcService),Mt=st.get(F.IExtHostStorage),Ut=st.get(_.IExtensionStoragePaths),Wt=st.get(Oe.ILoggerService),gt=st.get(Oe.ILogService),Re=st.get(se.IExtHostTunnelService),Ne=st.get(M.IExtHostApiDeprecationService),ye=st.get(J.IExtHostWindow),re=st.get(nt.IExtHostSecretState),Fe=st.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,Ft),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Xe.set(v.ExtHostContext.ExtHostWorkspace,mt),Xe.set(v.ExtHostContext.ExtHostConfiguration,$t),Xe.set(v.ExtHostContext.ExtHostExtensionService,Pt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Re),Xe.set(v.ExtHostContext.ExtHostWindow,ye),Xe.set(v.ExtHostContext.ExtHostSecretState,re),Xe.set(v.ExtHostContext.ExtHostTelemetry,kt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Fe);const He=Xe.set(v.ExtHostContext.ExtHostDecorations,st.get(Z.IExtHostDecorations)),Je=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,st.get(r.IExtHostDocumentsAndEditors)),qe=Xe.set(v.ExtHostContext.ExtHostCommands,st.get(d.IExtHostCommands)),tt=Xe.set(v.ExtHostContext.ExtHostTerminalService,st.get(B.IExtHostTerminalService)),ut=Xe.set(v.ExtHostContext.ExtHostDebugService,st.get(ve.IExtHostDebugService)),Tt=Xe.set(v.ExtHostContext.ExtHostSearch,st.get(ke.IExtHostSearch)),Et=Xe.set(v.ExtHostContext.ExtHostTask,st.get(fe.IExtHostTask)),St=Xe.set(v.ExtHostContext.ExtHostOutputService,st.get(E.IExtHostOutputService)),It=Xe.set(v.ExtHostContext.ExtHostLocalization,st.get(et.IExtHostLocalizationService)),yt=Xe.set(v.ExtHostContext.ExtHostUrls,new ee.ExtHostUrls(Xe)),Dt=Xe.set(v.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Xe,Je)),qt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Xe,Je,gt)),_t=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(gt,Dt,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),wt=Xe.set(v.ExtHostContext.ExtHostNotebook,new te.ExtHostNotebookController(Xe,qe,Je,Dt)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(wt)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(gt,wt)),Zt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new rt.ExtHostNotebookKernels(Xe,pt,wt,qe,gt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(Xe,wt)),At=Xe.set(v.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Xe,Je)),Ht=Xe.set(v.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),qe,gt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),At,pt.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Xe,gt,Ft,Je)),ei=Xe.set(v.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Xe,Dt,qe.converter,Ot)),dt=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Ot,Dt,qe,ai,gt,Ne,kt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Xe,dt)),Bt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Xe,gt,Je)),Qt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Xe,mt,qe)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new V.ExtHostSCM(Xe,qe,gt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new bt.ExtHostQuickDiff(Xe,Ot)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Xe,qe,Dt)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Xe)),ti=Xe.set(v.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new G.ExtHostTimeline(Xe,qe)),ii=Xe.set(v.ExtHostContext.ExtHostWebviews,new q.ExtHostWebviews(Xe,pt.remote,mt,gt,Ne)),ni=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,ii,mt)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(Xe,Dt,Ut,ii,ni)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,ii)),ri=Xe.set(v.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(Xe,qe,Je)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Le.ExtHostInteractive(Xe,wt,Je,qe,gt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ie.ExtHostBulkEdits(Xe,Je),Hi=new h.ExtHostClipboard(Xe),ki=new f.ExtHostMessageService(Xe,gt),Ri=new D.ExtHostDialogs(Xe),Li=new j.ExtHostStatusBar(Xe,qe.converter);return y.ExtHostApiCommands.register(qe),function(ze,jt,Oi){const vt=function(){let me=!ze.isUnderDevelopment;function Se(){me||(gt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")Se();else{const Ct=at;typeof Ct.scheme>"u"&&Se(),typeof Ct.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return at}}(),ji={getSession(me,Se,Ue){return ti.getSession(ze,me,Se,Ue)},async hasSession(me,Se){return(0,je.checkProposedApiEnabled)(ze,"authSession"),!!await ti.getSession(ze,me,Se,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(me,Se,Ue,at){return ti.registerAuthenticationProvider(me,Se,Ue,at)}},di={registerCommand(me,Se,Ue){return qe.registerCommand(!0,me,Se,Ue,void 0,ze)},registerTextEditorCommand(me,Se,Ue){return qe.registerCommand(!0,me,(...at)=>{const Ct=At.getActiveTextEditor();if(!Ct){gt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Ct.edit(Rt=>{Se.apply(Ue,[Ct,Rt,...at])}).then(Rt=>{Rt||gt.warn("Edits from command "+me+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+me,Rt)})},void 0,void 0,ze)},registerDiffInformationCommand:(me,Se,Ue)=>((0,je.checkProposedApiEnabled)(ze,"diffCommand"),qe.registerCommand(!0,me,async(...at)=>{const Ct=Je.activeEditor(!0);if(!Ct){gt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Ct.id);Se.apply(Ue,[Rt,...at])},void 0,void 0,ze)),executeCommand(me,...Se){return qe.executeCommand(me,...Se)},getCommands(me=!1){return qe.getCommands(me)}},Ni={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return tt.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(ze,"envShellEvent"),tt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(ze,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(ze,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,it.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return it.ExtHostTelemetryLogger.validateSender(me),kt.instantiateLogger(ze,me)},openExternal(me,Se){return ye.openUri(me,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===pt.environment.appUriScheme)return yt.createAppUri(me);try{return await ye.asExternalUri(me,{allowTunneling:!!pt.remote.authority})}catch(Se){if((0,K.matchesScheme)(me,Ee.Schemas.http)||(0,K.matchesScheme)(me,Ee.Schemas.https))return me;throw Se}},get remoteName(){return(0,Y.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(ze,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel}};pt.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(me,Se,Ue){return ri.createTestController(ze,me,Se,Ue)},createTestObserver(){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ri.createTestObserver()},runTests(me){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ri.runTests(me)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ri.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ri.results}},hi=pt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,qi={getExtension(me,Se){(0,je.isProposedApiEnabled)(ze,"extensionsAny")||(Se=!1);const Ue=jt.mine.getExtensionDescription(me);if(Ue)return new c.Extension(Pt,ze.identifier,Ue,hi,!1);if(Se){const at=jt.all.getExtensionDescription(me);if(at)return new c.Extension(Pt,ze.identifier,at,hi,!0)}},get all(){const me=[];for(const Se of jt.mine.getAllExtensionDescriptions())me.push(new c.Extension(Pt,ze.identifier,Se,hi,!1));return me},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(ze,"extensionsAny");const me=new je.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of jt.all.getAllExtensionDescriptions()){const at=!me.has(Ue.identifier);Se.push(new c.Extension(Pt,ze.identifier,Ue,hi,at))}return Se},get onDidChange(){return(0,je.isProposedApiEnabled)(ze,"extensionsAny")?l.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Ti={createDiagnosticCollection(me){return ai.createDiagnosticCollection(ze.identifier,me)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:me=>ai.getDiagnostics(me),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(me,Se){return ei.changeLanguage(me.uri,Se)},match(me,Se){const Ue=Dt.getDocumentData(Se.uri)?.notebook;return(0,L.score)($.LanguageSelector.from(me),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,Se,Ue){return dt.registerCodeActionProvider(ze,vt(me),Se,Ue)},registerDocumentPasteEditProvider(me,Se,Ue){return(0,je.checkProposedApiEnabled)(ze,"documentPaste"),dt.registerDocumentPasteEditProvider(ze,vt(me),Se,Ue)},registerCodeLensProvider(me,Se){return dt.registerCodeLensProvider(ze,vt(me),Se)},registerDefinitionProvider(me,Se){return dt.registerDefinitionProvider(ze,vt(me),Se)},registerDeclarationProvider(me,Se){return dt.registerDeclarationProvider(ze,vt(me),Se)},registerImplementationProvider(me,Se){return dt.registerImplementationProvider(ze,vt(me),Se)},registerTypeDefinitionProvider(me,Se){return dt.registerTypeDefinitionProvider(ze,vt(me),Se)},registerHoverProvider(me,Se){return dt.registerHoverProvider(ze,vt(me),Se,ze.identifier)},registerEvaluatableExpressionProvider(me,Se){return dt.registerEvaluatableExpressionProvider(ze,vt(me),Se,ze.identifier)},registerInlineValuesProvider(me,Se){return dt.registerInlineValuesProvider(ze,vt(me),Se,ze.identifier)},registerDocumentHighlightProvider(me,Se){return dt.registerDocumentHighlightProvider(ze,vt(me),Se)},registerLinkedEditingRangeProvider(me,Se){return dt.registerLinkedEditingRangeProvider(ze,vt(me),Se)},registerReferenceProvider(me,Se){return dt.registerReferenceProvider(ze,vt(me),Se)},registerRenameProvider(me,Se){return dt.registerRenameProvider(ze,vt(me),Se)},registerDocumentSymbolProvider(me,Se,Ue){return dt.registerDocumentSymbolProvider(ze,vt(me),Se,Ue)},registerWorkspaceSymbolProvider(me){return dt.registerWorkspaceSymbolProvider(ze,me)},registerDocumentFormattingEditProvider(me,Se){return dt.registerDocumentFormattingEditProvider(ze,vt(me),Se)},registerDocumentRangeFormattingEditProvider(me,Se){return dt.registerDocumentRangeFormattingEditProvider(ze,vt(me),Se)},registerOnTypeFormattingEditProvider(me,Se,Ue,...at){return dt.registerOnTypeFormattingEditProvider(ze,vt(me),Se,[Ue].concat(at))},registerDocumentSemanticTokensProvider(me,Se,Ue){return dt.registerDocumentSemanticTokensProvider(ze,vt(me),Se,Ue)},registerDocumentRangeSemanticTokensProvider(me,Se,Ue){return dt.registerDocumentRangeSemanticTokensProvider(ze,vt(me),Se,Ue)},registerSignatureHelpProvider(me,Se,Ue,...at){return typeof Ue=="object"?dt.registerSignatureHelpProvider(ze,vt(me),Se,Ue):dt.registerSignatureHelpProvider(ze,vt(me),Se,typeof Ue>"u"?[]:[Ue,...at])},registerCompletionItemProvider(me,Se,...Ue){return dt.registerCompletionItemProvider(ze,vt(me),Se,Ue)},registerInlineCompletionItemProvider(me,Se){return Se.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,je.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(ze,vt(me),Se)},registerDocumentLinkProvider(me,Se){return dt.registerDocumentLinkProvider(ze,vt(me),Se)},registerColorProvider(me,Se){return dt.registerColorProvider(ze,vt(me),Se)},registerFoldingRangeProvider(me,Se){return dt.registerFoldingRangeProvider(ze,vt(me),Se)},registerSelectionRangeProvider(me,Se){return dt.registerSelectionRangeProvider(ze,me,Se)},registerCallHierarchyProvider(me,Se){return dt.registerCallHierarchyProvider(ze,me,Se)},registerTypeHierarchyProvider(me,Se){return dt.registerTypeHierarchyProvider(ze,me,Se)},setLanguageConfiguration:(me,Se)=>dt.setLanguageConfiguration(ze,me,Se),getTokenInformationAtPosition(me,Se){return(0,je.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(me,Se)},registerInlayHintsProvider(me,Se){return dt.registerInlayHintsProvider(ze,me,Se)},createLanguageStatusItem(me,Se){return ei.createLanguageStatusItem(ze,me,Se)},registerDocumentDropEditProvider(me,Se){return dt.registerDocumentOnDropEditProvider(ze,me,Se)}},xi={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return tt.activeTerminal},get terminals(){return tt.terminals},async showTextDocument(me,Se,Ue){const at=await(C.URI.isUri(me)?Promise.resolve(xt.openTextDocument(me)):Promise.resolve(me));return At.showTextDocument(at,Se,Ue)},createTextEditorDecorationType(me){return At.createTextEditorDecorationType(ze,me)},onDidChangeActiveTextEditor(me,Se,Ue){return At.onDidChangeActiveTextEditor(me,Se,Ue)},onDidChangeVisibleTextEditors(me,Se,Ue){return At.onDidChangeVisibleTextEditors(me,Se,Ue)},onDidChangeTextEditorSelection(me,Se,Ue){return At.onDidChangeTextEditorSelection(me,Se,Ue)},onDidChangeTextEditorOptions(me,Se,Ue){return At.onDidChangeTextEditorOptions(me,Se,Ue)},onDidChangeTextEditorVisibleRanges(me,Se,Ue){return At.onDidChangeTextEditorVisibleRanges(me,Se,Ue)},onDidChangeTextEditorViewColumn(me,Se,Ue){return At.onDidChangeTextEditorViewColumn(me,Se,Ue)},onDidCloseTerminal(me,Se,Ue){return tt.onDidCloseTerminal(me,Se,Ue)},onDidOpenTerminal(me,Se,Ue){return tt.onDidOpenTerminal(me,Se,Ue)},onDidChangeActiveTerminal(me,Se,Ue){return tt.onDidChangeActiveTerminal(me,Se,Ue)},onDidChangeTerminalDimensions(me,Se,Ue){return(0,je.checkProposedApiEnabled)(ze,"terminalDimensions"),tt.onDidChangeTerminalDimensions(me,Se,Ue)},onDidChangeTerminalState(me,Se,Ue){return tt.onDidChangeTerminalState(me,Se,Ue)},onDidWriteTerminalData(me,Se,Ue){return(0,je.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),tt.onDidWriteTerminalData(me,Se,Ue)},get state(){return ye.state},onDidChangeWindowState(me,Se,Ue){return ye.onDidChangeWindowState(me,Se,Ue)},showInformationMessage(me,...Se){return ki.showMessage(ze,R.default.Info,me,Se[0],Se.slice(1))},showWarningMessage(me,...Se){return ki.showMessage(ze,R.default.Warning,me,Se[0],Se.slice(1))},showErrorMessage(me,...Se){return ki.showMessage(ze,R.default.Error,me,Se[0],Se.slice(1))},showQuickPick(me,Se,Ue){return Qt.showQuickPick(me,Se,Ue)},showWorkspaceFolderPick(me){return Qt.showWorkspaceFolderPick(me)},showInputBox(me,Se){return Qt.showInput(me,Se)},showOpenDialog(me){return Ri.showOpenDialog(ze,me)},showSaveDialog(me){return Ri.showSaveDialog(me)},createStatusBarItem(me,Se,Ue){let at,Ct,Rt;return typeof me=="string"?(at=me,Ct=Se,Rt=Ue):(Ct=me,Rt=Se),Li.createStatusBarEntry(ze,at,Ct,Rt)},setStatusBarMessage(me,Se){return Li.setStatusBarMessage(me,Se)},withScmProgress(me){return Ne.report("window.withScmProgress",ze,"Use 'withProgress' instead."),li.withProgress(ze,{location:z.ProgressLocation.SourceControl},(Se,Ue)=>me({report(at){}}))},withProgress(me,Se){return li.withProgress(ze,me,Se)},createOutputChannel(me,Se){return St.createOutputChannel(me,Se,ze)},createWebviewPanel(me,Se,Ue,at){return ni.createWebviewPanel(ze,me,Se,Ue,at)},createWebviewTextEditorInset(me,Se,Ue,at){return(0,je.checkProposedApiEnabled)(ze,"editorInsets"),vi.createWebviewEditorInset(me,Se,Ue,at,ze)},createTerminal(me,Se,Ue){return typeof me=="object"?"pty"in me?tt.createExtensionTerminal(me):tt.createTerminalFromOptions(me):tt.createTerminal(me,Se,Ue)},registerTerminalLinkProvider(me){return tt.registerLinkProvider(me)},registerTerminalProfileProvider(me,Se){return tt.registerProfileProvider(ze,me,Se)},registerTerminalQuickFixProvider(me,Se){return(0,je.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),tt.registerTerminalQuickFixProvider(me,ze.identifier.value,Se)},registerTreeDataProvider(me,Se){return Ht.registerTreeDataProvider(me,Se,ze)},createTreeView(me,Se){return Ht.createTreeView(me,Se,ze)},registerWebviewPanelSerializer:(me,Se)=>ni.registerWebviewPanelSerializer(ze,me,Se),registerCustomEditorProvider:(me,Se,Ue={})=>yi.registerCustomEditorProvider(ze,me,Se,Ue),registerFileDecorationProvider(me){return He.registerFileDecorationProvider(me,ze)},registerUriHandler(me){return yt.registerUriHandler(ze.identifier,me)},createQuickPick(){return Qt.createQuickPick(ze)},createInputBox(){return Qt.createInputBox(ze)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(me,Se,Ue){return ui.onDidChangeActiveColorTheme(me,Se,Ue)},registerWebviewViewProvider(me,Se,Ue){return Di.registerWebviewViewProvider(ze,me,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,Se,Ue){return wt.onDidChangeActiveNotebookEditor(me,Se,Ue)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,Se,Ue){return oi.onDidChangeNotebookEditorSelection(me,Se,Ue)},onDidChangeNotebookEditorVisibleRanges(me,Se,Ue){return oi.onDidChangeNotebookEditorVisibleRanges(me,Se,Ue)},showNotebookDocument(me,Se){return wt.showNotebookDocument(me,Se)},registerExternalUriOpener(me,Se,Ue){return(0,je.checkProposedApiEnabled)(ze,"externalUriOpener"),Ci.registerExternalUriOpener(ze.identifier,me,Se,Ue)},registerProfileContentHandler(me,Se){return(0,je.checkProposedApiEnabled)(ze,"profileContentHandlers"),Ii.registrProfileContentHandler(ze,me,Se)},registerQuickDiffProvider(me,Se,Ue,at){return(0,je.checkProposedApiEnabled)(ze,"quickDiffProvider"),wi.registerQuickDiffProvider(vt(me),Se,Ue,at)},get tabGroups(){return Fe.tabGroups}},xt={get rootPath(){return Ne.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(me){throw A.readonly()},getWorkspaceFolder(me){return mt.getWorkspaceFolder(me)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(me){throw A.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(me){throw A.readonly()},updateWorkspaceFolders:(me,Se,...Ue)=>mt.updateWorkspaceFolders(ze,me,Se||0,...Ue),onDidChangeWorkspaceFolders:function(me,Se,Ue){return mt.onDidChangeWorkspace(me,Se,Ue)},asRelativePath:(me,Se)=>mt.getRelativePath(me,Se),findFiles:(me,Se,Ue,at)=>mt.findFiles(me,Se,Ue,ze.identifier,at),findTextInFiles:(me,Se,Ue,at)=>{(0,je.checkProposedApiEnabled)(ze,"findTextInFiles");let Ct,Rt;return typeof Se=="object"?(Ct=Se,Rt=Ue):(Ct={},Rt=Se,at=Ue),mt.findTextInFiles(me,Ct||{},Rt,ze.identifier,at)},saveAll:me=>mt.saveAll(me),applyEdit(me,Se){return Wi.applyWorkspaceEdit(me,ze,Se)},createFileSystemWatcher:(me,Se,Ue,at)=>Bt.createFileSystemWatcher(mt,ze,me,Se,Ue,at),get textDocuments(){return Dt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw A.readonly()},openTextDocument(me){let Se;const Ue=me;if(typeof me=="string")Se=Promise.resolve(C.URI.file(me));else if(C.URI.isUri(me))Se=Promise.resolve(me);else if(!Ue||typeof Ue=="object")Se=Dt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(at=>Dt.ensureDocumentData(at).then(Ct=>Ct.document))},onDidOpenTextDocument:(me,Se,Ue)=>Dt.onDidAddDocument(me,Se,Ue),onDidCloseTextDocument:(me,Se,Ue)=>Dt.onDidRemoveDocument(me,Se,Ue),onDidChangeTextDocument:(me,Se,Ue)=>Dt.onDidChangeDocument(me,Se,Ue),onDidSaveTextDocument:(me,Se,Ue)=>Dt.onDidSaveDocument(me,Se,Ue),onWillSaveTextDocument:(me,Se,Ue)=>_t.getOnWillSaveTextDocumentEvent(ze)(me,Se,Ue),get notebookDocuments(){return wt.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,Se){let Ue;if(C.URI.isUri(me))Ue=me,await wt.openNotebookDocument(me);else if(typeof me=="string")Ue=C.URI.revive(await wt.createNotebookDocument({viewType:me,content:Se}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,Se,Ue){return si.onDidSaveNotebookDocument(me,Se,Ue)},onDidChangeNotebookDocument(me,Se,Ue){return si.onDidChangeNotebookDocument(me,Se,Ue)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(me,Se,Ue,at){return wt.registerNotebookSerializer(ze,me,Se,Ue,(0,je.isProposedApiEnabled)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,Se,Ue)=>Oi.onDidChangeConfiguration(me,Se,Ue),getConfiguration(me,Se){return Se=arguments.length===1?void 0:Se,Oi.getConfiguration(me,Se,ze)},registerTextDocumentContentProvider(me,Se){return qt.registerTextDocumentContentProvider(me,Se)},registerTaskProvider:(me,Se)=>(Ne.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(ze,me,Se)),registerFileSystemProvider(me,Se,Ue){return(0,$e.combinedDisposable)(Bi.registerFileSystemProvider(ze,me,Se,Ue),Kt.addFileSystemProvider(me,Se))},get fs(){return Kt.value},registerFileSearchProvider:(me,Se)=>((0,je.checkProposedApiEnabled)(ze,"fileSearchProvider"),Tt.registerFileSearchProvider(me,Se)),registerTextSearchProvider:(me,Se)=>((0,je.checkProposedApiEnabled)(ze,"textSearchProvider"),Tt.registerTextSearchProvider(me,Se)),registerRemoteAuthorityResolver:(me,Se)=>((0,je.checkProposedApiEnabled)(ze,"resolvers"),Pt.registerRemoteAuthorityResolver(me,Se)),registerResourceLabelFormatter:me=>((0,je.checkProposedApiEnabled)(ze,"resolvers"),Si.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,Se,Ue)=>Bt.onDidCreateFile(me,Se,Ue),onDidDeleteFiles:(me,Se,Ue)=>Bt.onDidDeleteFile(me,Se,Ue),onDidRenameFiles:(me,Se,Ue)=>Bt.onDidRenameFile(me,Se,Ue),onWillCreateFiles:(me,Se,Ue)=>Bt.getOnWillCreateFileEvent(ze)(me,Se,Ue),onWillDeleteFiles:(me,Se,Ue)=>Bt.getOnWillDeleteFileEvent(ze)(me,Se,Ue),onWillRenameFiles:(me,Se,Ue)=>Bt.getOnWillRenameFileEvent(ze)(me,Se,Ue),openTunnel:me=>((0,je.checkProposedApiEnabled)(ze,"tunnels"),Re.openTunnel(ze,me).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,je.checkProposedApiEnabled)(ze,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(me,Se,Ue)=>((0,je.checkProposedApiEnabled)(ze,"tunnels"),Re.onDidChangeTunnels(me,Se,Ue)),registerPortAttributesProvider:(me,Se)=>((0,je.checkProposedApiEnabled)(ze,"portsAttributes"),Re.registerPortsAttributesProvider(me,Se)),registerTimelineProvider:(me,Se)=>((0,je.checkProposedApiEnabled)(ze,"timeline"),$i.registerTimelineProvider(me,Se,ze.identifier,qe.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:me=>((0,je.checkProposedApiEnabled)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,Se,Ue)=>mt.onDidGrantWorkspaceTrust(me,Se,Ue),registerEditSessionIdentityProvider:(me,Se)=>((0,je.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(me,Se)),onWillCreateEditSessionIdentity:(me,Se,Ue)=>((0,je.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(ze)(me,Se,Ue))},fi={get inputBox(){return Ne.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(ze)},createSourceControl(me,Se,Ue){return ci.createSourceControl(ze,me,Se,Ue)}},Gi={createCommentController(me,Se){return Ei.createCommentController(ze,me,Se)}},zt={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(me,Se,Ue){return ut.onDidStartDebugSession(me,Se,Ue)},onDidTerminateDebugSession(me,Se,Ue){return ut.onDidTerminateDebugSession(me,Se,Ue)},onDidChangeActiveDebugSession(me,Se,Ue){return ut.onDidChangeActiveDebugSession(me,Se,Ue)},onDidReceiveDebugSessionCustomEvent(me,Se,Ue){return ut.onDidReceiveDebugSessionCustomEvent(me,Se,Ue)},onDidChangeBreakpoints(me,Se,Ue){return ut.onDidChangeBreakpoints(me,Se,Ue)},registerDebugConfigurationProvider(me,Se,Ue){return ut.registerDebugConfigurationProvider(me,Se,Ue||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,Se){return ut.registerDebugAdapterDescriptorFactory(ze,me,Se)},registerDebugAdapterTrackerFactory(me,Se){return ut.registerDebugAdapterTrackerFactory(me,Se)},startDebugging(me,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?ut.startDebugging(me,Se,{parentSession:Ue}):ut.startDebugging(me,Se,Ue||{})},stopDebugging(me){return ut.stopDebugging(me)},addBreakpoints(me){return ut.addBreakpoints(me)},removeBreakpoints(me){return ut.removeBreakpoints(me)},asDebugSourceUri(me,Se){return ut.asDebugSourceUri(me,Se)}},mi={registerTaskProvider:(me,Se)=>Et.registerTaskProvider(ze,me,Se),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(ze,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,Se,Ue)=>Et.onDidStartTask(me,Se,Ue),onDidEndTask:(me,Se,Ue)=>Et.onDidEndTask(me,Se,Ue),onDidStartTaskProcess:(me,Se,Ue)=>Et.onDidStartTaskProcess(me,Se,Ue),onDidEndTaskProcess:(me,Se,Ue)=>Et.onDidEndTaskProcess(me,Se,Ue)},Ki={createNotebookController(me,Se,Ue,at,Ct){return Zt.createNotebookController(ze,me,Se,Ue,at,(0,je.isProposedApiEnabled)(ze,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(me,Se)=>wt.registerNotebookCellStatusBarItemProvider(ze,me,Se),createRendererMessaging(me){return bi.createRendererMessaging(ze,me)},createNotebookControllerDetectionTask(me){return(0,je.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(ze,me)},registerKernelSourceActionProvider(me,Se){return(0,je.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(ze,me,Se)},onDidChangeNotebookCellExecutionState(me,Se,Ue){return(0,je.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(me,Se,Ue)}},Xi={t(...me){if(typeof me[0]=="string"){const Se=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return It.getMessage(ze.identifier.value,{message:Se,args:Ue})}return It.getMessage(ze.identifier.value,me[0])},get bundle(){return It.getBundle(ze.identifier.value)},get uri(){return It.getBundleUri(ze.identifier.value)}};return{version:pt.version,authentication:ji,commands:di,comments:Gi,debug:zt,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:xi,workspace:xt,Breakpoint:z.Breakpoint,TerminalOutputAnchor:z.TerminalOutputAnchor,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileDecoration2:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:k.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalQuickFixCommand:z.TerminalQuickFixCommand,TerminalQuickFixOpener:z.TerminalQuickFixOpener,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TerminalExitReason:z.TerminalExitReason,TerminalQuickFixType:z.TerminalQuickFixType,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:I.UIKind,Uri:C.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,NotebookKernelSourceAction:z.NotebookKernelSourceAction,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestRunRequest2:z.TestRunRequest2,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:ct.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TelemetryTrustedValue:ae.TelemetryTrustedValue,LogLevel:Oe.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Lt}),define(De[311],Ce([1,0,283,320,321,2,322]),function(ne,e,a,A,l,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(T,v,I,y,h,d){const u=d.environment.useHostProxy,g=typeof u=="boolean"?u:!d.remote.isRemote,b=(0,C.createProxyResolver)({resolveProxy:p=>T.resolveProxy(p),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(p,i,...o)=>{switch(p){case C.LogLevel.Trace:y.trace(i,...o);break;case C.LogLevel.Debug:y.debug(i,...o);break;case C.LogLevel.Info:y.info(i,...o);break;case C.LogLevel.Warning:y.warn(i,...o);break;case C.LogLevel.Error:y.error(i,...o);break;case C.LogLevel.Critical:y.error(i,...o);break;case C.LogLevel.Off:break;default:r(p,i,o);break}function r(c,s,...m){y.error("Unknown log level",c),y.error(s,...m)}},getLogLevel:()=>y.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:g,env:process.env}),D=S(v,b);return L(I,D)}e.connectProxyResolver=P;function S(T,v){const I={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(h=>{I.config=T.getConfiguration("http").get("proxySupport")||"off"});const y={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(h=>{y.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,C.createHttpPatch)(a,v,{config:"off"},y,!0)),on:Object.assign({},a,(0,C.createHttpPatch)(a,v,{config:"on"},y,!0)),override:Object.assign({},a,(0,C.createHttpPatch)(a,v,{config:"override"},y,!0)),onRequest:Object.assign({},a,(0,C.createHttpPatch)(a,v,I,y,!0)),default:Object.assign(a,(0,C.createHttpPatch)(a,v,I,y,!1))},https:{off:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"off"},y,!0)),on:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"on"},y,!0)),override:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"override"},y,!0)),onRequest:Object.assign({},A,(0,C.createHttpPatch)(A,v,I,y,!0)),default:Object.assign(A,(0,C.createHttpPatch)(A,v,I,y,!1))},tls:Object.assign(l,(0,C.createTlsPatch)(l))}}const k=new Map;function L(T,v){return T.getExtensionPathIndex().then(I=>{const y=globalThis._VSCODE_NODE_MODULES.module,h=y._load;y._load=function(u,g,b){if(u==="tls")return v.tls;if(u!=="http"&&u!=="https")return h.apply(this,arguments);const D=v[u],p=I.findSubstr(R.URI.file(g.filename));let i=k.get(p);if(i||k.set(p,i={}),!i[u]){const o=D.default;i[u]={...o}}return i[u]}})}}),define(De[312],Ce([1,0,83,310,297,311,42,285,2,16,7,282,115,284]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends l.RequireInterceptor{j(){const u=this,g=globalThis._VSCODE_NODE_MODULES.module,b=g._load;g._load=function(o,r,c){return o=p(o),u.a.has(o)?u.a.get(o).load(o,S.URI.file((0,v.realpathSync)(r.filename)),s=>b.apply(this,[s,r,c])):b.apply(this,arguments)};const D=g._resolveLookupPaths;g._resolveLookupPaths=(i,o)=>D.call(this,p(i),o);const p=i=>{for(const o of u.b){const r=o(i);if(r){i=r;break}}return i}}}class h extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async ob(){this.h.createInstance(I.ExtHostConsoleForwarder);const u=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(P.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const D=this.h.createInstance(T.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=D.ipcHandlePath}await this.h.createInstance(y,u,{mine:this.D,all:this.F}).install(),a.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}pb(u){return u.main}async qb(u,g,b){if(g.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let D=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this.l.flush();const p=u?.identifier.value;u&&await this.s.initializeLocalizedMessages(u);try{p&&a.mark(`code/extHost/willLoadExtensionCode/${p}`),D=ne.__$__nodeRequire(g.fsPath)}finally{p&&a.mark(`code/extHost/didLoadExtensionCode/${p}`),b.codeLoadingStop()}return D}async $setRemoteEnvironment(u){if(!!this.f.remote.isRemote)for(const g in u){const b=u[g];b===null?delete process.env[g]:process.env[g]=b}}}e.ExtHostExtensionService=h}),define(De[145],Ce([1,0,46,323,306,15,61,38,11,8,2,31,81,324,304,100]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class u{constructor(w){this.a=w}provideTextSearchResults(w,O,V,j){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...O,folder:O.folder.toString()})}`),new Promise((F,B)=>{j.onCancellationRequested(()=>J());const N=o(w,O),U=O.folder.fsPath,$=N.map(Z=>Z.match(/^-/)?Z:`'${Z}'`).join(" ");this.a.appendLine(`${d} ${$}
 - cwd: ${U}`);let z=a.spawn(d,N,{cwd:U});z.on("error",Z=>{console.error(Z),this.a.appendLine("Error: "+(Z&&Z.message)),B((0,T.serializeSearchError)(new T.SearchError(Z&&Z.message,T.SearchErrorCode.rgProcessError)))});let ae=!1;const ee=new D(O.maxResults,U,O.previewOptions);ee.on("result",Z=>{ae=!0,ge="",V.report(Z)});let q=!1;const J=()=>{q=!0,z?.kill(),ee?.cancel()};let ie=!1;ee.on("hitLimit",()=>{ie=!0,J()});let ge="";z.stdout.on("data",Z=>{ee.handleData(Z),ae||(ge+=Z)});let X=!1;z.stdout.once("data",()=>X=!0);let Y="";z.stderr.on("data",Z=>{const fe=Z.toString();this.a.appendLine(fe),Y.length+fe.length<1e6&&(Y+=fe)}),z.on("close",()=>{if(this.a.appendLine(X?"Got data from stdout":"No data from stdout"),this.a.appendLine(ae?"Got result from parser":"No result from parser"),ge&&this.a.appendLine(`Got data without result: ${ge}`),this.a.appendLine(""),q)F({limitHit:ie});else{ee.flush(),z=null;let Z;Y&&!X&&(Z=g(Y))?B((0,T.serializeSearchError)(new T.SearchError(Z.message,Z.code))):F({limitHit:ie})}})})}}e.RipgrepTextSearchEngine=u;function g(E){const w=E.split(`
`),O=w[0].trim();if(w.some(j=>j.startsWith("regex parse error")))return new T.SearchError(b(w),T.SearchErrorCode.regexParseError);const V=O.match(/grep config error: unknown encoding: (.*)/);if(V)return new T.SearchError(`Unknown encoding: ${V[1]}`,T.SearchErrorCode.unknownEncoding);if(O.startsWith("error parsing glob"))return new T.SearchError(O.charAt(0).toUpperCase()+O.substr(1),T.SearchErrorCode.globParseError);if(O.startsWith("the literal"))return new T.SearchError(O.charAt(0).toUpperCase()+O.substr(1),T.SearchErrorCode.invalidLiteral);if(O.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(O,T.SearchErrorCode.regexParseError)}function b(E){const w=["Regex parse error"],O=E.filter(V=>V.startsWith("PCRE2:"));if(O.length>=1){const V=O[0].replace("PCRE2:","");if(V.indexOf(":")!==-1&&V.split(":").length>=2){const j=V.split(":")[1];w.push(":"+j)}}return w.join("")}class D extends A.EventEmitter{constructor(w,O,V){super(),this.g=w,this.h=O,this.j=V,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,O){return super.on(w,O),this}handleData(w){if(this.b)return;const O=typeof w=="string"?w:this.d.write(w);this.k(O)}k(w){let O=w.indexOf(`
`);const V=this.a+w;if(O>=0)O+=this.a.length;else{this.a=V;return}let j=0;for(;O>=0;)this.m(V.substring(j,O).trim()),j=O+1,O=V.indexOf(`
`,j);this.a=V.substring(j)}m(w){if(this.b||!w)return;let O;try{O=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(O.type==="match"){const V=p(O.data.path),j=L.URI.file(S.join(this.h,V)),F=this.n(O.data,j);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(O.type==="context"){const V=p(O.data.path),j=L.URI.file(S.join(this.h,V));this.o(O.data,j).forEach(B=>this.p(B))}}n(w,O){const V=w.line_number-1,j=p(w.lines),F=Buffer.from(j);let B=0,N=0,U=V;w.submatches.length===0&&w.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const $=(0,R.coalesce)(w.submatches.map((z,ae)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=p(z.match),q=F.slice(B,z.start).toString(),J=i(q),ie=J.numLines>0?J.lastLineLength:J.lastLineLength+N,ge=i(ee),X=J.numLines+U,Y=ge.numLines+X,Z=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+ie;return B=z.end,N=Z,U=Y,new v.Range(X,ie,Y,Z)}));return(0,h.createTextSearchResult)(O,j,$,this.j)}o(w,O){const V=p(w.lines),j=w.line_number;return V.replace(/\r?\n$/,"").split(`
`).map((F,B)=>({text:F,uri:O,lineNumber:j+B}))}p(w){this.emit("result",w)}}e.RipgrepParser=D;function p(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function i(E){const w=/\n/g;let O=0,V=-1,j;for(;j=w.exec(E);)O++,V=j.index;const F=V>=0?E.length-V-1:E.length;return{numLines:O,lastLineLength:F}}function o(E,w){const O=["--hidden"];O.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:V,otherIncludes:j}=(0,C.groupBy)(w.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const B=new Set;j.forEach(N=>{B.add(N)}),O.push("-g","!*"),B.forEach(N=>{r(N).map(h.anchorGlob).forEach(U=>{O.push("-g",U)})})}V&&V.length&&V.forEach(B=>{O.push("-g",B)}),w.excludes.map(h.anchorGlob).forEach(B=>O.push("-g",`!${B}`)),w.maxFileSize&&O.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||O.push("--no-ignore-parent"):O.push("--no-ignore"),w.followSymlinks&&O.push("--follow"),w.encoding&&w.encoding!=="utf8"&&O.push("--encoding",w.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,k.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),w.usePCRE2&&O.push("--pcre2"),O.push("--crlf"),E.isRegExp&&(E.pattern=c(E.pattern),O.push("--engine","auto"));let F;if(E.isWordMatch){const N=(0,k.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");O.push("--regexp",N)}else if(E.isRegExp){let B=m(E.pattern);B=n(B),O.push("--regexp",B)}else F=E.pattern,O.push("--fixed-strings");return O.push("--no-config"),w.useGlobalIgnoreFiles||O.push("--no-ignore-global"),O.push("--json"),E.isMultiline&&O.push("--multiline"),w.beforeContext&&O.push("--before-context",w.beforeContext+""),w.afterContext&&O.push("--after-context",w.afterContext+""),O.push("--"),F&&O.push(F),O.push("."),O}e.getRgArgs=o;function r(E){return f(E).flatMap(O=>{const V=(0,P.splitGlobAware)(O,"/");return V.map((j,F)=>V.slice(0,F+1).join("/"))})}function c(E){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(w);)E=E.replace(w,"$1\\x{$2}");const O=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(O);)E=E.replace(O,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=c;const s=E=>E.type==="Assertion"&&E.kind==="lookbehind";function m(E){let w;try{w=new I.RegExpParser().parsePattern(E)}catch{return E}let O="",V=0;const j=(N,U,$)=>{O+=E.slice(V,N)+$,V=U},F=[];return new I.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const U=F[0];if(!U)j(N.start,N.end,"\\r?\\n");else if(!F.some(s))if(U.type==="CharacterClass")if(U.negate){const $=E.slice(U.start+2,N.start)+E.slice(N.end,U.end-1);U.parent?.type==="Quantifier"?j(U.start,U.end,$?`[^${$}]`:"."):j(U.start,U.end,"(?!\\r?\\n"+($?`|[${$}]`:"")+")")}else{const $=E.slice(U.start+1,N.start)+E.slice(N.end,U.end-1);j(U.start,U.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else U.type==="Quantifier"&&j(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){F.unshift(N)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(N){F.unshift(N)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(N){F.unshift(N)},onCharacterClassLeave(){F.shift()},onAssertionEnter(N){s(N)&&F.push(N)},onAssertionLeave(N){F[0]===N&&F.shift()}}).visit(w),O+=E.slice(V),O}e.fixRegexNewline=m;function n(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=n;function t(E){let w=!1,O=!1,V="",j="";for(let F=0;F<E.length;F++){const B=E[F];switch(B){case"\\":O?(w?j+="\\"+B:V+="\\"+B,O=!1):O=!0;break;case"{":if(O)w?j+=B:V+=B,O=!1;else{if(w)return{strInBraces:V+"{"+j+"{"+E.substring(F+1)};w=!0}break;case"}":if(O)w?j+=B:V+=B,O=!1;else{if(w)return{fixedStart:V,strInBraces:j,fixedEnd:E.substring(F+1)};V+=B}break;default:w?j+=(O?"\\":"")+B:V+=(O?"\\":"")+B,O=!1;break}}return{strInBraces:V+(w?"{"+j:"")}}function f(E){const{fixedStart:w,strInBraces:O,fixedEnd:V}=t(E);if(w===void 0||V===void 0)return[O];let j=(0,P.splitGlobAware)(O,",");j.length||(j=[""]);const F=f(V);return j.flatMap(B=>{const N=w+B;return F.map(U=>N+U)})}e.performBraceExpansionForRipgrep=f}),define(De[313],Ce([1,0,21,145,126,16]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,L,T,v){const I=new A.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const y={...L,folder:L.folder.with({scheme:R.Schemas.file})},h=new l.Progress(d=>T.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(v,d=>I.provideTextSearchResults(k,y,h,d))}else return this.c(v,y=>I.provideTextSearchResults(k,L,T,y))}async c(k,L){const T=P(k);this.a.add(T);const v=await L(T.token);return this.a.delete(T),v}d(){this.a.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=C;function P(S){const k=new a.CancellationTokenSource;return S.onCancellationRequested(()=>k.cancel()),k}}),define(De[314],Ce([1,0,29,145,144]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(S){this.a=S}search(S,k,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(I){L({message:I})}},v=new l.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(T),a);return new Promise((I,y)=>v.search(h=>{k(h.map(C))},S).then(h=>I({limitHit:h.limitHit,type:"success",stats:h.stats}),y))}}e.TextSearchEngineAdapter=R;function C(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((S,k)=>{if(k.ranges){const L=k;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(De[315],Ce([1,0,15,19,12,3,111,11,43,2,44,31,305,314]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class y{constructor(D="searchProcess"){this.d=D,this.b=Object.create(null)}fileSearch(D){let p;const i=u(D),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.doFileSearchWithEngine(v.Engine,i,c=>o.fire(c),r)),p.then(r=>o.fire(r),r=>o.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}textSearch(D){let p;const i=u(D),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.f(i,c=>o.fire(c),r)),p.then(r=>o.fire(r),r=>o.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}f(D,p,i){return D.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(D).search(i,p,p)}doFileSearch(D,p,i){return this.doFileSearchWithEngine(v.Engine,D,p,i)}doFileSearchWithEngine(D,p,i,o,r=y.a){let c=0;const s=n=>{Array.isArray(n)?(c+=n.length,i(n.map(t=>this.g(t)))):n.relativePath?(c++,i(this.g(n))):i(n)};if(p.sortByScore){let n=this.k(p,s,o);if(!n){const t=p.maxResults?Object.assign({},p,{maxResults:null}):p,f=new D(t);n=this.h(f,p,i,s,o)}return new Promise((t,f)=>{n.then(([E,w])=>{const O=w.map(V=>this.g(V));this.n(O,i,r),t(E)},f)})}const m=new D(p);return this.q(m,s,r,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}g(D){return{path:D.base?(0,P.join)(D.base,D.relativePath):D.relativePath}}h(D,p,i,o,r){const c=new R.Emitter;let s=(0,A.createCancelablePromise)(n=>{let t=[];const f=E=>{Array.isArray(E)?t=E:(o(E),c.fire(E))};return this.q(D,f,-1,n).then(E=>[E,t])}),m;if(p.cacheKey){m=this.j(p.cacheKey);const n={promise:s,event:c.event,resolved:!1};m.resultsToSearchCache[p.filePattern||""]=n,s.then(()=>{n.resolved=!0},t=>{delete m.resultsToSearchCache[p.filePattern||""]}),s=this.r(s)}return s.then(([n,t])=>{const f=m?m.scorerCache:Object.create(null),E=(typeof p.maxResults!="number"||p.maxResults>0)&&S.StopWatch.create(!1);return this.l(p,t,f,r).then(w=>{const O=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:O,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:w.length},messages:n.messages,limitHit:n.limitHit||typeof p.maxResults=="number"&&t.length>p.maxResults},w]})})}j(D){const p=this.b[D];return p||(this.b[D]=new h)}k(D,p,i){const o=D.cacheKey&&this.b[D.cacheKey];if(!o)return;const r=this.o(o,D.filePattern||"",p,i);if(r)return r.then(([c,s,m])=>{const n=S.StopWatch.create(!1);return this.l(D,s,o.scorerCache,i).then(t=>{const f=n.elapsed(),E={fromCache:!0,detailStats:m,type:this.d,resultCount:s.length,sortingTime:f};return[{type:"success",limitHit:c.limitHit||typeof D.maxResults=="number"&&s.length>D.maxResults,stats:E},t]})})}l(D,p,i,o){const r=(0,C.prepareQuery)(D.filePattern||""),c=(m,n)=>(0,C.compareItemsByFuzzyScore)(m,n,r,!0,d,i),s=typeof D.maxResults=="number"?D.maxResults:Number.MAX_VALUE;return a.topAsync(p,c,s,1e4,o)}n(D,p,i){if(i&&i>0)for(let o=0;o<D.length;o+=i)p(D.slice(o,o+i));else p(D)}o(D,p,i,o){const r=S.StopWatch.create(!1),c=p.indexOf(P.sep)>=0;let s;for(const f in D.resultsToSearchCache)if(p.startsWith(f)){if(c&&f.indexOf(P.sep)<0&&f!=="")continue;const E=D.resultsToSearchCache[f];s={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!s)return null;const m=r.elapsed(),n=S.StopWatch.create(!1),t=s.event(i);return o&&o.onCancellationRequested(()=>{t.dispose()}),s.promise.then(([f,E])=>{if(o&&o.isCancellationRequested)throw(0,l.canceled)();const w=[],O=(0,C.prepareQuery)(p).normalizedLowercase;for(const V of E)!(0,T.isFilePatternMatch)(V,O)||w.push(V);return[f,w,{cacheWasResolved:s.resolved,cacheLookupTime:m,cacheFilterTime:n.elapsed(),cacheEntryCount:E.length}]})}q(D,p,i,o){return new Promise((r,c)=>{let s=[];o?.onCancellationRequested(()=>D.cancel()),D.search(m=>{m&&(i?(s.push(m),i>0&&s.length>=i&&(p(s),s=[])):p(m))},m=>{p(m)},(m,n)=>{s.length&&p(s),m?c(m):r(n)})})}clearCache(D){return delete this.b[D],Promise.resolve(void 0)}r(D){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,i){return D.then(p,i)}catch(p){return this.then(void 0,p)}finally(p){return D.finally(p)}}}}y.a=512,e.SearchService=y;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(b){return(0,P.basename)(b.relativePath)}getItemDescription(b){return(0,P.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function u(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(g),extraFileResources:b.extraFileResources&&b.extraFileResources.map(D=>k.URI.revive(D))}}function g(b){return{...b,folder:k.URI.revive(b.folder)}}}),define(De[316],Ce([1,0,6,16,2,29,13,25,20,85,56,31,315,313,100,144]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends k.ExtHostSearch{constructor(g,b,D,p){super(g,D,p),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new y.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new I.RipgrepSearchProvider(i)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const g=new y.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new I.RipgrepSearchProvider(g)),this.y(A.Schemas.file,new v.SearchService("fileSearchProvider"))}y(g,b){const D=this.d++;return this.v=b,this.t=D,this.c.$registerFileSearchProvider(D,this.o(g)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(D)})}$provideFileSearchResults(g,b,D,p){const i=(0,k.reviveQuery)(D);return g===this.t?this.z(g,b,i,p):super.$provideFileSearchResults(g,b,D,p)}z(g,b,D,p){const i=o=>{if((0,T.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(g,b,o.map(r=>l.URI.file(r.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(D,i,p)}$clearCache(g){return this.v?.clearCache(g),super.$clearCache(g)}q(g,b){return new h.NativeTextSearchManager(g,b,void 0,"textSearchProvider")}};d=xe([We(0,S.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,C.ILogService)],d),e.NativeExtHostSearch=d}),define(De[317],Ce([1,0,90,288,300,299,316,312,289,84,42,85,82,41,55,79,287,286,13,301,49]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u,g,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(L.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,a.registerSingleton)(g.ILoggerService,u.ExtHostLoggerService,1),(0,a.registerSingleton)(h.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,a.registerSingleton)(k.IExtHostDebugService,R.ExtHostDebugService,0),(0,a.registerSingleton)(T.IExtHostSearch,C.NativeExtHostSearch,0),(0,a.registerSingleton)(v.IExtHostTask,l.ExtHostTask,0),(0,a.registerSingleton)(I.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,a.registerSingleton)(y.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,a.registerSingleton)(D.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(De[325],Ce([1,0,229,326,83,12,118,119,207,96,298,22,29,115,19,121,224,237,302,317]),function(ne,e,a,A,l,R,C,P,S,k,L,T,v,I,y,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const g=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=globalThis._VSCODE_NODE_MODULES.module,m=s._load;s._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const b=process.exit.bind(process);function D(s){process.exit=function(m){if(s)b(m);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(s){b()};function i(){const s=(0,u.readExtHostConnection)(process.env);if(s.type===3)return new Promise((m,n)=>{const t=f=>{const E=f[0],w=new C.BufferedEmitter;E.on("message",O=>w.fire(T.VSBuffer.wrap(O.data))),E.on("close",()=>{p("renderer closed the MessagePort")}),E.start(),m({onMessage:w.event,send:O=>E.postMessage(O.buffer)})};process.parentPort.on("message",f=>t(f.ports))});if(s.type===2)return new Promise((m,n)=>{let t=null;const f=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,w=3e5,O=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),E),V=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),w);process.on("message",(F,B)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const N=T.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let U;if(F.skipWebSocketFrames)U=new P.NodeSocket(B,"extHost-socket");else{const $=T.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));U=new P.WebSocketNodeSocket(new P.NodeSocket(B,"extHost-socket"),F.permessageDeflate,$,!1)}t?(O.cancel(),V.cancel(),t.beginAcceptReconnection(U,N),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(f),t=new C.PersistentProtocol({socket:U,initialChunk:N}),t.sendResume(),t.onDidDispose(()=>p("renderer disconnected")),m(t),t.onSocketClose(()=>{O.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(V.isScheduled())return;O.isScheduled()&&V.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const m=s.pipeName;return new Promise((n,t)=>{const f=a.createConnection(m,()=>{f.removeListener("error",t);const E=new C.PersistentProtocol({socket:new P.NodeSocket(f,"extHost-renderer")});E.sendResume(),n(E)});f.once("error",t),f.on("close",()=>{p("renderer closed the socket")})})}}async function o(){const s=await i();return new class{constructor(){this.a=new C.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,s.onMessage(m=>{(0,k.isMessageOfType)(m,2)?(this.b=!0,p("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||s.send(m)}async drain(){if(s.drain)return s.drain()}}}function r(s){return new Promise(m=>{const n=s.onMessage(t=>{n.dispose();const f=JSON.parse(t.toString()),E=f.commit,w=S.default.commit;if(E&&w&&E!==w&&b(55),f.parentPid){let O=0;setInterval(function(){try{process.kill(f.parentPid,0),O=0}catch(j){j&&j.code==="EPERM"?(O++,O>=3&&p(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):p(`parent process ${f.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let V;try{V=globalThis._VSCODE_NODE_MODULES["native-watchdog"],V.start(f.parentPid)}catch(j){(0,R.onUnexpectedError)(j)}}s.send((0,k.createMessageOfType)(0)),m({protocol:s,initData:f})});s.send((0,k.createMessageOfType)(1))})}async function c(){const s=[];process.on("unhandledRejection",(O,V)=>{s.push(V),setTimeout(()=>{const j=s.indexOf(V);j>=0&&V.catch(F=>{s.splice(j,1),(0,R.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),O&&(0,R.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const V=s.indexOf(O);V>=0&&s.splice(V,1)}),process.on("uncaughtException",function(O){(0,R.isSigPipeError)(O)||(0,R.onUnexpectedError)(O)}),l.mark("code/extHost/willConnectToRenderer");const m=await o();l.mark("code/extHost/didConnectToRenderer");const n=await r(m);l.mark("code/extHost/didWaitForInitData");const{initData:t}=n;D(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,h.boolean)(g.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(V){b(V)}exists(V){return v.Promises.exists(V)}realpath(V){return(0,I.realpath)(V)}};let E=null;t.remote.authority&&g.transformURIs&&(E=(0,d.createURITransformer)(t.remote.authority));const w=new L.ExtensionHostMain(n.protocol,t,f,E);p=O=>w.terminate(O)}c().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b2cc8c48b93222cd9727c4e70be3a269b132e5d8/core/vs/workbench/api/node/extensionHostProcess.js.map
