/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Te=function(te){for(var e=[],i=0,C=te.length;i<C;i++)e[i]=ke[te[i]];return e};define(ke[63],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(y,O){const S=Object.create(null);for(const k of y){const N=O(k);let w=S[N];w||(w=S[N]=[]),w.push(k)}return S}e.groupBy=i;function C(y,O){const S=[],k=[];for(const N of y)O.has(N)||S.push(N);for(const N of O)y.has(N)||k.push(N);return{removed:S,added:k}}e.diffSets=C;function D(y,O){const S=[],k=[];for(const[N,w]of y)O.has(N)||S.push(w);for(const[N,w]of O)y.has(N)||k.push(w);return{removed:S,added:k}}e.diffMaps=D;class M{constructor(){this.a=new Map}add(O,S){let k=this.a.get(O);k||(k=new Set,this.a.set(O,k)),k.add(S)}delete(O,S){const k=this.a.get(O);!k||(k.delete(S),k.size===0&&this.a.delete(O))}forEach(O,S){const k=this.a.get(O);!k||k.forEach(S)}}e.SetMap=M}),define(ke[64],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(y){return(O,S,k)=>{let N=null,w=null;if(typeof k.value=="function"?(N="value",w=k.value):typeof k.get=="function"&&(N="get",w=k.get),!w)throw new Error("not supported");k[N]=y(w,S)}}function C(y,O,S){let k=null,N=null;if(typeof S.value=="function"?(k="value",N=S.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",N=S.get),!N)throw new Error("not supported");const w=`$memoize$${O}`;S[k]=function(...h){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,h)}),this[w]}}e.memoize=C;function D(y,O,S){return i((k,N)=>{const w=`$debounce$${N}`,h=`$debounce$result$${N}`;return function(...b){this[h]||(this[h]=S?S():void 0),clearTimeout(this[w]),O&&(this[h]=O(this[h],...b),b=[this[h]]),this[w]=setTimeout(()=>{k.apply(this,b),this[h]=S?S():void 0},y)}})}e.debounce=D;function M(y,O,S){return i((k,N)=>{const w=`$throttle$timer$${N}`,h=`$throttle$result$${N}`,b=`$throttle$lastRun$${N}`,f=`$throttle$pending$${N}`;return function(...a){if(this[h]||(this[h]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),O&&(this[h]=O(this[h],...a)),this[f])return;const s=this[b]+y;s<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[h]]),this[h]=S?S():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),k.apply(this,[this[h]]),this[h]=S?S():void 0},s-Date.now()))}})}e.throttle=M}),define(ke[83],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(ke[111],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function y(t,d=!1){let r=0;const u=t.length;let n="",p=0,o=16,c=0;function m(U){let R=0,F=0;for(;R<U;){const H=t.charCodeAt(r);if(H>=48&&H<=57)F=F*16+H-48;else if(H>=65&&H<=70)F=F*16+H-65+10;else if(H>=97&&H<=102)F=F*16+H-97+10;else break;r++,R++}return R<U&&(F=-1),F}function P(U){r=U,n="",p=0,o=16,c=0}function T(){const U=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&k(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&k(t.charCodeAt(r)))for(r++;r<t.length&&k(t.charCodeAt(r));)r++;else return c=3,t.substring(U,r);let R=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&k(t.charCodeAt(r))){for(r++;r<t.length&&k(t.charCodeAt(r));)r++;R=r}else c=3;return t.substring(U,R)}function V(){let U="",R=r;for(;;){if(r>=u){U+=t.substring(R,r),c=2;break}const F=t.charCodeAt(r);if(F===34){U+=t.substring(R,r),r++;break}if(F===92){if(U+=t.substring(R,r),r++,r>=u){c=2;break}switch(t.charCodeAt(r++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const j=m(4);j>=0?U+=String.fromCharCode(j):c=4;break}default:c=5}R=r;continue}if(F>=0&&F<=31)if(S(F)){U+=t.substring(R,r),c=2;break}else c=6;r++}return U}function _(){if(n="",c=0,p=r,r>=u)return p=u,o=17;let U=t.charCodeAt(r);if(O(U)){do r++,n+=String.fromCharCode(U),U=t.charCodeAt(r);while(O(U));return o=15}if(S(U))return r++,n+=String.fromCharCode(U),U===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),o=14;switch(U){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,n=V(),o=10;case 47:{const R=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<u&&!S(t.charCodeAt(r));)r++;return n=t.substring(R,r),o=12}if(t.charCodeAt(r+1)===42){r+=2;const F=u-1;let H=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,c=1),n=t.substring(R,r),o=13}return n+=String.fromCharCode(U),r++,o=16}case 45:if(n+=String.fromCharCode(U),r++,r===u||!k(t.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=T(),o=11;default:for(;r<u&&K(U);)r++,U=t.charCodeAt(r);if(p!==r){switch(n=t.substring(p,r),n){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return n+=String.fromCharCode(U),r++,o=16}}function K(U){if(O(U)||S(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let U;do U=_();while(U>=12&&U<=15);return U}return{setPosition:P,getPosition:()=>r,scan:d?A:_,getToken:()=>o,getTokenValue:()=>n,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>c}}e.createScanner=y;function O(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function w(t,d){const r=[],u=new Object;let n;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function c(m,P,T,V){p.value=m,p.offset=P,p.length=T,p.type=V,p.colonOffset=void 0,n=p}try{E(t,{onObjectBegin:(m,P)=>{if(d<=m)throw u;n=void 0,o=d>m,r.push("")},onObjectProperty:(m,P,T)=>{if(d<P||(c(m,P,T,"property"),r[r.length-1]=m,d<=P+T))throw u},onObjectEnd:(m,P)=>{if(d<=m)throw u;n=void 0,r.pop()},onArrayBegin:(m,P)=>{if(d<=m)throw u;n=void 0,r.push(0)},onArrayEnd:(m,P)=>{if(d<=m)throw u;n=void 0,r.pop()},onLiteralValue:(m,P,T)=>{if(d<P||(c(m,P,T,v(m)),d<=P+T))throw u},onSeparator:(m,P,T)=>{if(d<=P)throw u;if(m===":"&&n&&n.type==="property")n.colonOffset=P,o=!1,n=void 0;else if(m===","){const V=r[r.length-1];typeof V=="number"?r[r.length-1]=V+1:(o=!0,r[r.length-1]=""),n=void 0}}})}catch(m){if(m!==u)throw m}return{path:r,previousNode:n,isAtPropertyKey:o,matches:m=>{let P=0;for(let T=0;P<m.length&&T<r.length;T++)if(m[P]===r[T]||m[P]==="*")P++;else if(m[P]!=="**")return!1;return P===m.length}}}e.getLocation=w;function h(t,d=[],r=M.DEFAULT){let u=null,n=[];const p=[];function o(m){Array.isArray(n)?n.push(m):u!==null&&(n[u]=m)}return E(t,{onObjectBegin:()=>{const m={};o(m),p.push(n),n=m,u=null},onObjectProperty:m=>{u=m},onObjectEnd:()=>{n=p.pop()},onArrayBegin:()=>{const m=[];o(m),p.push(n),n=m,u=null},onArrayEnd:()=>{n=p.pop()},onLiteralValue:o,onError:(m,P,T)=>{d.push({error:m,offset:P,length:T})}},r),n[0]}e.parse=h;function b(t,d=[],r=M.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(m){u.type==="property"&&(u.length=m-u.offset,u=u.parent)}function p(m){return u.children.push(m),m}E(t,{onObjectBegin:m=>{u=p({type:"object",offset:m,length:-1,parent:u,children:[]})},onObjectProperty:(m,P,T)=>{u=p({type:"property",offset:P,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:m,offset:P,length:T,parent:u})},onObjectEnd:(m,P)=>{u.length=m+P-u.offset,u=u.parent,n(m+P)},onArrayBegin:(m,P)=>{u=p({type:"array",offset:m,length:-1,parent:u,children:[]})},onArrayEnd:(m,P)=>{u.length=m+P-u.offset,u=u.parent,n(m+P)},onLiteralValue:(m,P,T)=>{p({type:v(m),offset:P,length:T,parent:u,value:m}),n(P+T)},onSeparator:(m,P,T)=>{u.type==="property"&&(m===":"?u.colonOffset=P:m===","&&n(P))},onError:(m,P,T)=>{d.push({error:m,offset:P,length:T})}},r);const c=u.children[0];return c&&delete c.parent,c}e.parseTree=b;function f(t,d){if(!t)return;let r=t;for(const u of d)if(typeof u=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===u){r=p.children[1],n=!0;break}if(!n)return}else{const n=u;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=f;function a(t){if(!t.parent||!t.parent.children)return[];const d=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;d.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&d.push(r)}return d}e.getNodePath=a;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const d=Object.create(null);for(const r of t.children){const u=r.children[1];u&&(d[r.children[0].value]=s(u))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function l(t,d,r=!1){return d>=t.offset&&d<t.offset+t.length||r&&d===t.offset+t.length}e.contains=l;function g(t,d,r=!1){if(l(t,d,r)){const u=t.children;if(Array.isArray(u))for(let n=0;n<u.length&&u[n].offset<=d;n++){const p=g(u[n],d,r);if(p)return p}return t}}e.findNodeAtOffset=g;function E(t,d,r=M.DEFAULT){const u=y(t,!1);function n(Se){return Se?()=>Se(u.getTokenOffset(),u.getTokenLength()):()=>!0}function p(Se){return Se?x=>Se(x,u.getTokenOffset(),u.getTokenLength()):()=>!0}const o=n(d.onObjectBegin),c=p(d.onObjectProperty),m=n(d.onObjectEnd),P=n(d.onArrayBegin),T=n(d.onArrayEnd),V=p(d.onLiteralValue),_=p(d.onSeparator),K=n(d.onComment),A=p(d.onError),U=r&&r.disallowComments,R=r&&r.allowTrailingComma;function F(){for(;;){const Se=u.scan();switch(u.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:U||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(Se){case 12:case 13:U?H(10):K();break;case 16:H(1);break;case 15:case 14:break;default:return Se}}}function H(Se,x=[],X=[]){if(A(Se),x.length+X.length>0){let J=u.getToken();for(;J!==17;){if(x.indexOf(J)!==-1){F();break}else if(X.indexOf(J)!==-1)break;J=F()}}}function j(Se){const x=u.getTokenValue();return Se?V(x):c(x),F(),!0}function le(){switch(u.getToken()){case 11:{let Se=0;try{Se=JSON.parse(u.getTokenValue()),typeof Se!="number"&&(H(2),Se=0)}catch{H(2)}V(Se);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return F(),!0}function ge(){return u.getToken()!==10?(H(3,[],[2,5]),!1):(j(!1),u.getToken()===6?(_(":"),F(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function re(){o(),F();let Se=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(Se||H(4,[],[]),_(","),F(),u.getToken()===2&&R)break}else Se&&H(6,[],[]);ge()||H(4,[],[2,5]),Se=!0}return m(),u.getToken()!==2?H(7,[2],[]):F(),!0}function ae(){P(),F();let Se=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(Se||H(4,[],[]),_(","),F(),u.getToken()===4&&R)break}else Se&&H(6,[],[]);ce()||H(4,[],[4,5]),Se=!0}return T(),u.getToken()!==4?H(8,[4],[]):F(),!0}function ce(){switch(u.getToken()){case 3:return ae();case 1:return re();case 10:return j(!0);default:return le()}}return F(),u.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(u.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=E;function L(t,d){const r=y(t),u=[];let n,p=0,o;do switch(o=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:p!==o&&u.push(t.substring(p,o)),d!==void 0&&u.push(r.getTokenValue().replace(/[^\r\n]/g,d)),p=r.getPosition();break}while(n!==17);return u.join("")}e.stripComments=L;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(ke[28],Te([1,0]),function(te,e){"use strict";var i,C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(f,a,s){let l=f.get(a);return l===void 0&&(l=s,f.set(a,l)),l}e.getOrSet=M;function y(f){const a=[];return f.forEach((s,l)=>{a.push(`${l} => ${s}`)}),`Map(${f.size}) {${a.join(", ")}}`}e.mapToString=y;function O(f){const a=[];return f.forEach(s=>{a.push(s)}),`Set(${f.size}) {${a.join(", ")}}`}e.setToString=O;class S{constructor(a,s){this.uri=a,this.value=s}}class k{constructor(a,s){this[i]="ResourceMap",a instanceof k?(this.b=new Map(a.b),this.c=s??k.a):(this.b=new Map,this.c=a??k.a)}set(a,s){return this.b.set(this.c(a),new S(a,s)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,s){typeof s<"u"&&(a=a.bind(s));for(const[l,g]of this.b)a(g.value,g.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}k.a=f=>f.toString(),e.ResourceMap=k;class N{constructor(a,s){this[C]="ResourceSet",!a||typeof a=="function"?this.a=new k(a):(this.a=new k(s),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,s){this.a.forEach((l,g)=>a.call(s,g,g,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class h{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,s=0){const l=this.a.get(a);if(!!l)return s!==0&&this.j(l,s),l.value}set(a,s,l=0){let g=this.a.get(a);if(g)g.value=s,l!==0&&this.j(g,l);else{switch(g={key:a,value:s,next:void 0,previous:void 0},l){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(a,g),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const s=this.a.get(a);if(!!s)return this.a.delete(a),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,s){const l=this.e;let g=this.b;for(;g;){if(s?a.bind(s)(g.value,g.key,this):a(g.value,g.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const a=this,s=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}values(){const a=this,s=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}entries(){const a=this,s=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let s=this.b,l=this.size;for(;s&&l>a;)this.a.delete(s.key),s=s.next,l--;this.b=s,this.d=l,s&&(s.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const s=a.next,l=a.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}a.next=void 0,a.previous=void 0,this.e++}j(a,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(a===this.b)return;const l=a.next,g=a.previous;a===this.c?(g.next=void 0,this.c=g):(l.previous=g,g.next=l),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(s===2){if(a===this.c)return;const l=a.next,g=a.previous;a===this.b?(l.previous=void 0,this.b=l):(l.previous=g,g.next=l),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((s,l)=>{a.push([l,s])}),a}fromJSON(a){this.clear();for(const[s,l]of a)this.set(s,l)}}e.LinkedMap=h;class b extends h{constructor(a,s=1){super(),this.k=a,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,s=2){return super.get(a,s)}peek(a){return super.get(a,0)}set(a,s){return super.set(a,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ke[112],Te([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Pe,Ce){for(var we=0;we<Ce.length;we++){var se=Ce[we];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Pe,se.key,se)}}function i(Pe,Ce,we){return Ce&&e(Pe.prototype,Ce),we&&e(Pe,we),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function C(Pe,Ce){if(!!Pe){if(typeof Pe=="string")return D(Pe,Ce);var we=Object.prototype.toString.call(Pe).slice(8,-1);if(we==="Object"&&Pe.constructor&&(we=Pe.constructor.name),we==="Map"||we==="Set")return Array.from(Pe);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return D(Pe,Ce)}}function D(Pe,Ce){(Ce==null||Ce>Pe.length)&&(Ce=Pe.length);for(var we=0,se=new Array(Ce);we<Ce;we++)se[we]=Pe[we];return se}function M(Pe,Ce){var we=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(we)return(we=we.call(Pe)).next.bind(we);if(Array.isArray(Pe)||(we=C(Pe))||Ce&&Pe&&typeof Pe.length=="number"){we&&(Pe=we);var se=0;return function(){return se>=Pe.length?{done:!0}:{done:!1,value:Pe[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=y();function O(Pe){te.defaults=Pe}var S=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ce){return h[Ce]};function f(Pe,Ce){if(Ce){if(S.test(Pe))return Pe.replace(k,b)}else if(N.test(Pe))return Pe.replace(w,b);return Pe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Pe){return Pe.replace(a,function(Ce,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var l=/(^|[^\[])\^/g;function g(Pe,Ce){Pe=typeof Pe=="string"?Pe:Pe.source,Ce=Ce||"";var we={replace:function(ue,Z){return Z=Z.source||Z,Z=Z.replace(l,"$1"),Pe=Pe.replace(ue,Z),we},getRegex:function(){return new RegExp(Pe,Ce)}};return we}var E=/[^\w:]/g,L=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Pe,Ce,we){if(Pe){var se;try{se=decodeURIComponent(s(we)).replace(E,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ce&&!L.test(we)&&(we=n(Ce,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var t={},d=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Pe,Ce){t[" "+Pe]||(d.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=m(Pe,"/",!0)),Pe=t[" "+Pe];var we=Pe.indexOf(":")===-1;return Ce.substring(0,2)==="//"?we?Ce:Pe.replace(r,"$1")+Ce:Ce.charAt(0)==="/"?we?Ce:Pe.replace(u,"$1")+Ce:Pe+Ce}var p={exec:function(){}};function o(Pe){for(var Ce=1,we,se;Ce<arguments.length;Ce++){we=arguments[Ce];for(se in we)Object.prototype.hasOwnProperty.call(we,se)&&(Pe[se]=we[se])}return Pe}function c(Pe,Ce){var we=Pe.replace(/\|/g,function(Z,I,$){for(var W=!1,q=I;--q>=0&&$[q]==="\\";)W=!W;return W?"|":" |"}),se=we.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Ce)se.splice(Ce);else for(;se.length<Ce;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function m(Pe,Ce,we){var se=Pe.length;if(se===0)return"";for(var ue=0;ue<se;){var Z=Pe.charAt(se-ue-1);if(Z===Ce&&!we)ue++;else if(Z!==Ce&&we)ue++;else break}return Pe.slice(0,se-ue)}function P(Pe,Ce){if(Pe.indexOf(Ce[1])===-1)return-1;for(var we=Pe.length,se=0,ue=0;ue<we;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===Ce[0])se++;else if(Pe[ue]===Ce[1]&&(se--,se<0))return ue;return-1}function T(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(Pe,Ce){if(Ce<1)return"";for(var we="";Ce>1;)Ce&1&&(we+=Pe),Ce>>=1,Pe+=Pe;return we+Pe}function _(Pe,Ce,we,se){var ue=Ce.href,Z=Ce.title?f(Ce.title):null,I=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){se.state.inLink=!0;var $={type:"link",raw:we,href:ue,title:Z,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,$}return{type:"image",raw:we,href:ue,title:Z,text:f(I)}}function K(Pe,Ce){var we=Pe.match(/^(\s+)(?:```)/);if(we===null)return Ce;var se=we[1];return Ce.split(`
`).map(function(ue){var Z=ue.match(/^\s+/);if(Z===null)return ue;var I=Z[0];return I.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var A=function(){function Pe(we){this.options=we||te.defaults}var Ce=Pe.prototype;return Ce.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},Ce.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var Z=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:m(Z,`
`)}}},Ce.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var Z=ue[0],I=K(Z,ue[3]||"");return{type:"code",raw:Z,lang:ue[2]?ue[2].trim():ue[2],text:I}}},Ce.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var Z=ue[2].trim();if(/#$/.test(Z)){var I=m(Z,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Z=I.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:Z,tokens:this.lexer.inline(Z)}}},Ce.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},Ce.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var Z=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},Ce.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var Z,I,$,W,q,ee,fe,De,oe,ve,be,He,qe=ue[1].trim(),tt=qe.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+qe.slice(0,-1):"",loose:!1,items:[]};qe=tt?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=tt?qe:"[*+-]");for(var et=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(He=!1,!(!(ue=et.exec(se))||this.rules.block.hr.test(se)));){if(Z=ue[0],se=se.substring(Z.length),De=ue[2].split(`
`,1)[0],oe=se.split(`
`,1)[0],this.options.pedantic?(W=2,be=De.trimLeft()):(W=ue[2].search(/[^ ]/),W=W>4?1:W,be=De.slice(W),W+=ue[1].length),ee=!1,!De&&/^ *$/.test(oe)&&(Z+=oe+`
`,se=se.substring(oe.length+1),He=!0),!He)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(ve=se.split(`
`,1)[0],De=ve,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(De)||ot.test(De)||it.test(De)||dt.test(se)));){if(De.search(/[^ ]/)>=W||!De.trim())be+=`
`+De.slice(W);else if(!ee)be+=`
`+De;else break;!ee&&!De.trim()&&(ee=!0),Z+=ve+`
`,se=se.substring(ve.length+1)}Xe.loose||(fe?Xe.loose=!0:/\n *\n *$/.test(Z)&&(fe=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(be),I&&($=I[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!I,checked:$,loose:!1,text:be}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=be.trimRight(),Xe.raw=Xe.raw.trimRight();var Y=Xe.items.length;for(q=0;q<Y;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var Q=Xe.items[q].tokens.filter(function(Me){return Me.type==="space"}),pe=Q.every(function(Me){for(var ze=Me.raw.split(""),Ve=0,Ye=M(ze),nt;!(nt=Ye()).done;){var vt=nt.value;if(vt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&Q.length&&pe&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},Ce.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var Z={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]);Z.type="paragraph",Z.text=I,Z.tokens=this.lexer.inline(I)}return Z}},Ce.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Z=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:ue[0],href:ue[2],title:ue[3]}}},Ce.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var Z={type:"table",header:c(ue[1]).map(function(fe){return{text:fe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=ue[0];var I=Z.align.length,$,W,q,ee;for($=0;$<I;$++)/^ *-+: *$/.test(Z.align[$])?Z.align[$]="right":/^ *:-+: *$/.test(Z.align[$])?Z.align[$]="center":/^ *:-+ *$/.test(Z.align[$])?Z.align[$]="left":Z.align[$]=null;for(I=Z.rows.length,$=0;$<I;$++)Z.rows[$]=c(Z.rows[$],Z.header.length).map(function(fe){return{text:fe}});for(I=Z.header.length,W=0;W<I;W++)Z.header[W].tokens=this.lexer.inline(Z.header[W].text);for(I=Z.rows.length,W=0;W<I;W++)for(ee=Z.rows[W],q=0;q<ee.length;q++)ee[q].tokens=this.lexer.inline(ee[q].text);return Z}}},Ce.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},Ce.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var Z=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:Z,tokens:this.lexer.inline(Z)}}},Ce.text=function(se){var ue=this.rules.block.text.exec(se);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},Ce.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:f(ue[1])}},Ce.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]):ue[0]}},Ce.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var Z=ue[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var I=m(Z.slice(0,-1),"\\");if((Z.length-I.length)%2===0)return}else{var $=P(ue[2],"()");if($>-1){var W=ue[0].indexOf("!")===0?5:4,q=W+ue[1].length+$;ue[2]=ue[2].substring(0,$),ue[0]=ue[0].substring(0,q).trim(),ue[3]=""}}var ee=ue[2],fe="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);De&&(ee=De[1],fe=De[3])}else fe=ue[3]?ue[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(Z)?ee=ee.slice(1):ee=ee.slice(1,-1)),_(ue,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Ce.reflink=function(se,ue){var Z;if((Z=this.rules.inline.reflink.exec(se))||(Z=this.rules.inline.nolink.exec(se))){var I=(Z[2]||Z[1]).replace(/\s+/g," ");if(I=ue[I.toLowerCase()],!I||!I.href){var $=Z[0].charAt(0);return{type:"text",raw:$,text:$}}return _(Z,I,Z[0],this.lexer)}},Ce.emStrong=function(se,ue,Z){Z===void 0&&(Z="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Z===""||this.rules.inline.punctuation.exec(Z))){var W=I[0].length-1,q,ee,fe=W,De=0,oe=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,ue=ue.slice(-1*se.length+W);(I=oe.exec(ue))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(ee=q.length,I[3]||I[4]){fe+=ee;continue}else if((I[5]||I[6])&&W%3&&!((W+ee)%3)){De+=ee;continue}if(fe-=ee,!(fe>0)){if(ee=Math.min(ee,ee+fe+De),Math.min(W,ee)%2){var ve=se.slice(1,W+I.index+ee);return{type:"em",raw:se.slice(0,W+I.index+ee+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=se.slice(2,W+I.index+ee-1);return{type:"strong",raw:se.slice(0,W+I.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},Ce.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var Z=ue[2].replace(/\n/g," "),I=/[^ ]/.test(Z),$=/^ /.test(Z)&&/ $/.test(Z);return I&&$&&(Z=Z.substring(1,Z.length-1)),Z=f(Z,!0),{type:"codespan",raw:ue[0],text:Z}}},Ce.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},Ce.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},Ce.autolink=function(se,ue){var Z=this.rules.inline.autolink.exec(se);if(Z){var I,$;return Z[2]==="@"?(I=f(this.options.mangle?ue(Z[1]):Z[1]),$="mailto:"+I):(I=f(Z[1]),$=I),{type:"link",raw:Z[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Ce.url=function(se,ue){var Z;if(Z=this.rules.inline.url.exec(se)){var I,$;if(Z[2]==="@")I=f(this.options.mangle?ue(Z[0]):Z[0]),$="mailto:"+I;else{var W;do W=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(W!==Z[0]);I=f(Z[0]),Z[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Z[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Ce.inlineText=function(se,ue){var Z=this.rules.inline.text.exec(se);if(Z){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):f(Z[0]):Z[0]:I=f(this.options.smartypants?ue(Z[0]):Z[0]),{type:"text",raw:Z[0],text:I}}},Pe}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=g(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=g(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=g(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=g(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=g(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=g(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=o({},U),U.gfm=o({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=g(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=g(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=o({},U.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:g(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=g(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=g(U._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=g(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=g(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=g(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=g(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=g(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=g(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=g(R.reflink).replace("label",R._label).replace("ref",U._label).getRegex(),R.nolink=g(R.nolink).replace("ref",U._label).getRegex(),R.reflinkSearch=g(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=o({},R),R.pedantic=o({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=o({},R.normal,{escape:g(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=g(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=o({},R.gfm,{br:g(R.br).replace("{2,}","*").getRegex(),text:g(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Pe){var Ce="",we,se,ue=Pe.length;for(we=0;we<ue;we++)se=Pe.charCodeAt(we),Math.random()>.5&&(se="x"+se.toString(16)),Ce+="&#"+se+";";return Ce}var j=function(){function Pe(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||te.defaults,this.options.tokenizer=this.options.tokenizer||new A,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:U.normal,inline:R.normal};this.options.pedantic?(se.block=U.pedantic,se.inline=R.pedantic):this.options.gfm&&(se.block=U.gfm,this.options.breaks?se.inline=R.breaks:se.inline=R.gfm),this.tokenizer.rules=se}Pe.lex=function(se,ue){var Z=new Pe(ue);return Z.lex(se)},Pe.lexInline=function(se,ue){var Z=new Pe(ue);return Z.inlineTokens(se)};var Ce=Pe.prototype;return Ce.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Ce.blockTokens=function(se,ue){var Z=this;ue===void 0&&(ue=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(fe,De,oe){return De+"    ".repeat(oe.length)});for(var I,$,W,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(I=fe.call({lexer:Z},se,ue))?(se=se.substring(I.raw.length),ue.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),$=ue[ue.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ue.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),$=ue[ue.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,De=se.slice(1),oe=void 0;Z.options.extensions.startBlock.forEach(function(ve){oe=ve.call({lexer:this},De),typeof oe=="number"&&oe>=0&&(fe=Math.min(fe,oe))}),fe<1/0&&fe>=0&&(W=se.substring(0,fe+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){$=ue[ue.length-1],q&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ue.push(I),q=W.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),$=ue[ue.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ue.push(I);continue}if(se){var ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ue},Ce.inline=function(se,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:se,tokens:ue}),ue},Ce.inlineTokens=function(se,ue){var Z=this;ue===void 0&&(ue=[]);var I,$,W,q=se,ee,fe,De;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)oe.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,ee.index)+"["+V("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,ee.index)+"["+V("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,ee.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(fe||(De=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(I=be.call({lexer:Z},se,ue))?(se=se.substring(I.raw.length),ue.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),$=ue[ue.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ue.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),$=ue[ue.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ue.push(I);continue}if(I=this.tokenizer.emStrong(se,q,De)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.autolink(se,H)){se=se.substring(I.raw.length),ue.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,H))){se=se.substring(I.raw.length),ue.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,He=se.slice(1),qe=void 0;Z.options.extensions.startInline.forEach(function(tt){qe=tt.call({lexer:this},He),typeof qe=="number"&&qe>=0&&(be=Math.min(be,qe))}),be<1/0&&be>=0&&(W=se.substring(0,be+1))}(),I=this.tokenizer.inlineText(W,F)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(De=I.raw.slice(-1)),fe=!0,$=ue[ue.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ue.push(I);continue}if(se){var ve="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},i(Pe,null,[{key:"rules",get:function(){return{block:U,inline:R}}}]),Pe}(),le=function(){function Pe(we){this.options=we||te.defaults}var Ce=Pe.prototype;return Ce.code=function(se,ue,Z){var I=(ue||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(se,I);$!=null&&$!==se&&(Z=!0,se=$)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+f(I,!0)+'">'+(Z?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(Z?se:f(se,!0))+`</code></pre>
`},Ce.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ce.html=function(se){return se},Ce.heading=function(se,ue,Z,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Z);return"<h"+ue+' id="'+$+'">'+se+"</h"+ue+`>
`}return"<h"+ue+">"+se+"</h"+ue+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(se,ue,Z){var I=ue?"ol":"ul",$=ue&&Z!==1?' start="'+Z+'"':"";return"<"+I+$+`>
`+se+"</"+I+`>
`},Ce.listitem=function(se){return"<li>"+se+`</li>
`},Ce.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(se){return"<p>"+se+`</p>
`},Ce.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},Ce.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ce.tablecell=function(se,ue){var Z=ue.header?"th":"td",I=ue.align?"<"+Z+' align="'+ue.align+'">':"<"+Z+">";return I+se+("</"+Z+`>
`)},Ce.strong=function(se){return"<strong>"+se+"</strong>"},Ce.em=function(se){return"<em>"+se+"</em>"},Ce.codespan=function(se){return"<code>"+se+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(se){return"<del>"+se+"</del>"},Ce.link=function(se,ue,Z){if(se=v(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<a href="'+f(se)+'"';return ue&&(I+=' title="'+ue+'"'),I+=">"+Z+"</a>",I},Ce.image=function(se,ue,Z){if(se=v(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<img src="'+se+'" alt="'+Z+'"';return ue&&(I+=' title="'+ue+'"'),I+=this.options.xhtml?"/>":">",I},Ce.text=function(se){return se},Pe}(),ge=function(){function Pe(){}var Ce=Pe.prototype;return Ce.strong=function(se){return se},Ce.em=function(se){return se},Ce.codespan=function(se){return se},Ce.del=function(se){return se},Ce.html=function(se){return se},Ce.text=function(se){return se},Ce.link=function(se,ue,Z){return""+Z},Ce.image=function(se,ue,Z){return""+Z},Ce.br=function(){return""},Pe}(),re=function(){function Pe(){this.seen={}}var Ce=Pe.prototype;return Ce.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(se,ue){var Z=se,I=0;if(this.seen.hasOwnProperty(Z)){I=this.seen[se];do I++,Z=se+"-"+I;while(this.seen.hasOwnProperty(Z))}return ue||(this.seen[se]=I,this.seen[Z]=0),Z},Ce.slug=function(se,ue){ue===void 0&&(ue={});var Z=this.serialize(se);return this.getNextSafeSlug(Z,ue.dryrun)},Pe}(),ae=function(){function Pe(we){this.options=we||te.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new re}Pe.parse=function(se,ue){var Z=new Pe(ue);return Z.parse(se)},Pe.parseInline=function(se,ue){var Z=new Pe(ue);return Z.parseInline(se)};var Ce=Pe.prototype;return Ce.parse=function(se,ue){ue===void 0&&(ue=!0);var Z="",I,$,W,q,ee,fe,De,oe,ve,be,He,qe,tt,Xe,et,it,dt,Fe,ot,Y=se.length;for(I=0;I<Y;I++){if(be=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(ot=this.options.extensions.renderers[be.type].call({parser:this},be),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){Z+=ot||"";continue}switch(be.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(be.tokens),be.depth,s(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(oe="",De="",q=be.header.length,$=0;$<q;$++)De+=this.renderer.tablecell(this.parseInline(be.header[$].tokens),{header:!0,align:be.align[$]});for(oe+=this.renderer.tablerow(De),ve="",q=be.rows.length,$=0;$<q;$++){for(fe=be.rows[$],De="",ee=fe.length,W=0;W<ee;W++)De+=this.renderer.tablecell(this.parseInline(fe[W].tokens),{header:!1,align:be.align[W]});ve+=this.renderer.tablerow(De)}Z+=this.renderer.table(oe,ve);continue}case"blockquote":{ve=this.parse(be.tokens),Z+=this.renderer.blockquote(ve);continue}case"list":{for(He=be.ordered,qe=be.start,tt=be.loose,q=be.items.length,ve="",$=0;$<q;$++)et=be.items[$],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(Xe,dt,it);Z+=this.renderer.list(ve,He,qe);continue}case"html":{Z+=this.renderer.html(be.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;I+1<Y&&se[I+1].type==="text";)be=se[++I],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);Z+=ue?this.renderer.paragraph(ve):ve;continue}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return Z},Ce.parseInline=function(se,ue){ue=ue||this.renderer;var Z="",I,$,W,q=se.length;for(I=0;I<q;I++){if($=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(W=this.options.extensions.renderers[$.type].call({parser:this},$),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Z+=W||"";continue}switch($.type){case"escape":{Z+=ue.text($.text);break}case"html":{Z+=ue.html($.text);break}case"link":{Z+=ue.link($.href,$.title,this.parseInline($.tokens,ue));break}case"image":{Z+=ue.image($.href,$.title,$.text);break}case"strong":{Z+=ue.strong(this.parseInline($.tokens,ue));break}case"em":{Z+=ue.em(this.parseInline($.tokens,ue));break}case"codespan":{Z+=ue.codespan($.text);break}case"br":{Z+=ue.br();break}case"del":{Z+=ue.del(this.parseInline($.tokens,ue));break}case"text":{Z+=ue.text($.text);break}default:{var ee='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return Z},Pe}();function ce(Pe,Ce,we){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Ce=="function"&&(we=Ce,Ce=null),Ce=o({},ce.defaults,Ce||{}),T(Ce),we){var se=Ce.highlight,ue;try{ue=j.lex(Pe,Ce)}catch(q){return we(q)}var Z=function(ee){var fe;if(!ee)try{Ce.walkTokens&&ce.walkTokens(ue,Ce.walkTokens),fe=ae.parse(ue,Ce)}catch(De){ee=De}return Ce.highlight=se,ee?we(ee):we(null,fe)};if(!se||se.length<3||(delete Ce.highlight,!ue.length))return Z();var I=0;ce.walkTokens(ue,function(q){q.type==="code"&&(I++,setTimeout(function(){se(q.text,q.lang,function(ee,fe){if(ee)return Z(ee);fe!=null&&fe!==q.text&&(q.text=fe,q.escaped=!0),I--,I===0&&Z()})},0))}),I===0&&Z();return}function $(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+f(q.message+"",!0)+"</pre>";throw q}try{var W=j.lex(Pe,Ce);if(Ce.walkTokens){if(Ce.async)return Promise.all(ce.walkTokens(W,Ce.walkTokens)).then(function(){return ae.parse(W,Ce)}).catch($);ce.walkTokens(W,Ce.walkTokens)}return ae.parse(W,Ce)}catch(q){$(q)}}ce.options=ce.setOptions=function(Pe){return o(ce.defaults,Pe),O(ce.defaults),ce},ce.getDefaults=y,ce.defaults=te.defaults,ce.use=function(){for(var Pe=arguments.length,Ce=new Array(Pe),we=0;we<Pe;we++)Ce[we]=arguments[we];var se=o.apply(void 0,[{}].concat(Ce)),ue=ce.defaults.extensions||{renderers:{},childTokens:{}},Z;Ce.forEach(function(I){if(I.extensions&&(Z=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var q=ue.renderers?ue.renderers[W.name]:null;q?ue.renderers[W.name]=function(){for(var ee=arguments.length,fe=new Array(ee),De=0;De<ee;De++)fe[De]=arguments[De];var oe=W.renderer.apply(this,fe);return oe===!1&&(oe=q.apply(this,fe)),oe}:ue.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[W.level]?ue[W.level].unshift(W.tokenizer):ue[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ue.startBlock?ue.startBlock.push(W.start):ue.startBlock=[W.start]:W.level==="inline"&&(ue.startInline?ue.startInline.push(W.start):ue.startInline=[W.start]))}W.childTokens&&(ue.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=ce.defaults.renderer||new le,q=function(De){var oe=W[De];W[De]=function(){for(var ve=arguments.length,be=new Array(ve),He=0;He<ve;He++)be[He]=arguments[He];var qe=I.renderer[De].apply(W,be);return qe===!1&&(qe=oe.apply(W,be)),qe}};for(var ee in I.renderer)q(ee);se.renderer=W}(),I.tokenizer&&function(){var W=ce.defaults.tokenizer||new A,q=function(De){var oe=W[De];W[De]=function(){for(var ve=arguments.length,be=new Array(ve),He=0;He<ve;He++)be[He]=arguments[He];var qe=I.tokenizer[De].apply(W,be);return qe===!1&&(qe=oe.apply(W,be)),qe}};for(var ee in I.tokenizer)q(ee);se.tokenizer=W}(),I.walkTokens){var $=ce.defaults.walkTokens;se.walkTokens=function(W){var q=[];return q.push(I.walkTokens.call(this,W)),$&&(q=q.concat($.call(this,W))),q}}Z&&(se.extensions=ue),ce.setOptions(se)})},ce.walkTokens=function(Pe,Ce){for(var we=[],se=function(){var $=Z.value;switch(we=we.concat(Ce.call(ce,$)),$.type){case"table":{for(var W=M($.header),q;!(q=W()).done;){var ee=q.value;we=we.concat(ce.walkTokens(ee.tokens,Ce))}for(var fe=M($.rows),De;!(De=fe()).done;)for(var oe=De.value,ve=M(oe),be;!(be=ve()).done;){var He=be.value;we=we.concat(ce.walkTokens(He.tokens,Ce))}break}case"list":{we=we.concat(ce.walkTokens($.items,Ce));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[$.type]?ce.defaults.extensions.childTokens[$.type].forEach(function(qe){we=we.concat(ce.walkTokens($[qe],Ce))}):$.tokens&&(we=we.concat(ce.walkTokens($.tokens,Ce)))}},ue=M(Pe),Z;!(Z=ue()).done;)se();return we},ce.parseInline=function(Pe,Ce){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Ce=o({},ce.defaults,Ce||{}),T(Ce);try{var we=j.lexInline(Pe,Ce);return Ce.walkTokens&&ce.walkTokens(we,Ce.walkTokens),ae.parseInline(we,Ce)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},ce.Parser=ae,ce.parser=ae.parse,ce.Renderer=le,ce.TextRenderer=ge,ce.Lexer=j,ce.lexer=j.lex,ce.Tokenizer=A,ce.Slugger=re,ce.parse=ce;var Se=ce.options,x=ce.setOptions,X=ce.use,J=ce.walkTokens,de=ce.parseInline,ye=ce,Ne=ae.parse,We=j.lex;te.Lexer=j,te.Parser=ae,te.Renderer=le,te.Slugger=re,te.TextRenderer=ge,te.Tokenizer=A,te.getDefaults=y,te.lexer=We,te.marked=ce,te.options=Se,te.parse=ye,te.parseInline=de,te.parser=Ne,te.setOptions=x,te.use=X,te.walkTokens=J,Object.defineProperty(te,"__esModule",{value:!0})}),define(ke[113],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(O,S,k){return Math.min(Math.max(O,S),k)}e.clamp=i;function C(O,S){return(S+O%S)%S}e.rot=C;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class M{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class y{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=y}),function(){function te(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function y(S){M.push(S,Date.now())}function O(){const S=[];for(let k=0;k<M.length;k+=2)S.push({name:M[k],startTime:M[k+1]});return S}return{mark:y,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const y of performance.getEntriesByType("mark"))M.push({name:y.name,startTime:Math.round(D+y.startTime)});return M}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function i(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=i(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var C in i)(typeof exports=="object"?exports:te)[C]=i[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function i(C){if(e[C])return e[C].exports;var D=e[C]={i:C,l:!1,exports:{}};return te[C].call(D.exports,D,D.exports,i),D.l=!0,D.exports}return i.m=te,i.c=e,i.d=function(C,D,M){i.o(C,D)||Object.defineProperty(C,D,{enumerable:!0,get:M})},i.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},i.t=function(C,D){if(1&D&&(C=i(C)),8&D||4&D&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(i.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&D&&typeof C!="string")for(var y in C)i.d(M,y,function(O){return C[O]}.bind(null,y));return M},i.n=function(C){var D=C&&C.__esModule?function(){return C.default}:function(){return C};return i.d(D,"a",D),D},i.o=function(C,D){return Object.prototype.hasOwnProperty.call(C,D)},i.p="",i(i.s=0)}([function(te,e,i){(function(C){var D;e=te.exports=X,D=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],S=e.src=[],k=0,N=k++;S[N]="0|[1-9]\\d*";var w=k++;S[w]="[0-9]+";var h=k++;S[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;S[b]="("+S[N]+")\\.("+S[N]+")\\.("+S[N]+")";var f=k++;S[f]="("+S[w]+")\\.("+S[w]+")\\.("+S[w]+")";var a=k++;S[a]="(?:"+S[N]+"|"+S[h]+")";var s=k++;S[s]="(?:"+S[w]+"|"+S[h]+")";var l=k++;S[l]="(?:-("+S[a]+"(?:\\."+S[a]+")*))";var g=k++;S[g]="(?:-?("+S[s]+"(?:\\."+S[s]+")*))";var E=k++;S[E]="[0-9A-Za-z-]+";var L=k++;S[L]="(?:\\+("+S[E]+"(?:\\."+S[E]+")*))";var v=k++,t="v?"+S[b]+S[l]+"?"+S[L]+"?";S[v]="^"+t+"$";var d="[v=\\s]*"+S[f]+S[g]+"?"+S[L]+"?",r=k++;S[r]="^"+d+"$";var u=k++;S[u]="((?:<|>)?=?)";var n=k++;S[n]=S[w]+"|x|X|\\*";var p=k++;S[p]=S[N]+"|x|X|\\*";var o=k++;S[o]="[v=\\s]*("+S[p]+")(?:\\.("+S[p]+")(?:\\.("+S[p]+")(?:"+S[l]+")?"+S[L]+"?)?)?";var c=k++;S[c]="[v=\\s]*("+S[n]+")(?:\\.("+S[n]+")(?:\\.("+S[n]+")(?:"+S[g]+")?"+S[L]+"?)?)?";var m=k++;S[m]="^"+S[u]+"\\s*"+S[o]+"$";var P=k++;S[P]="^"+S[u]+"\\s*"+S[c]+"$";var T=k++;S[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=k++;S[V]="(?:~>?)";var _=k++;S[_]="(\\s*)"+S[V]+"\\s+",O[_]=new RegExp(S[_],"g");var K=k++;S[K]="^"+S[V]+S[o]+"$";var A=k++;S[A]="^"+S[V]+S[c]+"$";var U=k++;S[U]="(?:\\^)";var R=k++;S[R]="(\\s*)"+S[U]+"\\s+",O[R]=new RegExp(S[R],"g");var F=k++;S[F]="^"+S[U]+S[o]+"$";var H=k++;S[H]="^"+S[U]+S[c]+"$";var j=k++;S[j]="^"+S[u]+"\\s*("+d+")$|^$";var le=k++;S[le]="^"+S[u]+"\\s*("+t+")$|^$";var ge=k++;S[ge]="(\\s*)"+S[u]+"\\s*("+d+"|"+S[o]+")",O[ge]=new RegExp(S[ge],"g");var re=k++;S[re]="^\\s*("+S[o]+")\\s+-\\s+("+S[o]+")\\s*$";var ae=k++;S[ae]="^\\s*("+S[c]+")\\s+-\\s+("+S[c]+")\\s*$";var ce=k++;S[ce]="(<|>)?=?\\s*\\*";for(var Se=0;Se<35;Se++)D(Se,S[Se]),O[Se]||(O[Se]=new RegExp(S[Se]));function x(oe,ve){if(oe instanceof X)return oe;if(typeof oe!="string"||oe.length>M||!(ve?O[r]:O[v]).test(oe))return null;try{return new X(oe,ve)}catch{return null}}function X(oe,ve){if(oe instanceof X){if(oe.loose===ve)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof X))return new X(oe,ve);D("SemVer",oe,ve),this.loose=ve;var be=oe.trim().match(ve?O[r]:O[v]);if(!be)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var qe=+He;if(qe>=0&&qe<y)return qe}return He}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=x,e.valid=function(oe,ve){var be=x(oe,ve);return be?be.version:null},e.clean=function(oe,ve){var be=x(oe.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(oe){return D("SemVer.compare",this.version,this.loose,oe),oe instanceof X||(oe=new X(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},X.prototype.compareMain=function(oe){return oe instanceof X||(oe=new X(oe,this.loose)),de(this.major,oe.major)||de(this.minor,oe.minor)||de(this.patch,oe.patch)},X.prototype.comparePre=function(oe){if(oe instanceof X||(oe=new X(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],He=oe.prerelease[ve];if(D("prerelease compare",ve,be,He),be===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(be===void 0)return-1;if(be!==He)return de(be,He)}while(++ve)},X.prototype.inc=function(oe,ve){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,ve,be,He){typeof be=="string"&&(He=be,be=void 0);try{return new X(oe,be).inc(ve,He).version}catch{return null}},e.diff=function(oe,ve){if(Pe(oe,ve))return null;var be=x(oe),He=x(ve);if(be.prerelease.length||He.prerelease.length){for(var qe in be)if((qe==="major"||qe==="minor"||qe==="patch")&&be[qe]!==He[qe])return"pre"+qe;return"prerelease"}for(var qe in be)if((qe==="major"||qe==="minor"||qe==="patch")&&be[qe]!==He[qe])return qe},e.compareIdentifiers=de;var J=/^[0-9]+$/;function de(oe,ve){var be=J.test(oe),He=J.test(ve);return be&&He&&(oe=+oe,ve=+ve),be&&!He?-1:He&&!be?1:oe<ve?-1:oe>ve?1:0}function ye(oe,ve,be){return new X(oe,be).compare(new X(ve,be))}function Ne(oe,ve,be){return ye(oe,ve,be)>0}function We(oe,ve,be){return ye(oe,ve,be)<0}function Pe(oe,ve,be){return ye(oe,ve,be)===0}function Ce(oe,ve,be){return ye(oe,ve,be)!==0}function we(oe,ve,be){return ye(oe,ve,be)>=0}function se(oe,ve,be){return ye(oe,ve,be)<=0}function ue(oe,ve,be,He){var qe;switch(ve){case"===":typeof oe=="object"&&(oe=oe.version),typeof be=="object"&&(be=be.version),qe=oe===be;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof be=="object"&&(be=be.version),qe=oe!==be;break;case"":case"=":case"==":qe=Pe(oe,be,He);break;case"!=":qe=Ce(oe,be,He);break;case">":qe=Ne(oe,be,He);break;case">=":qe=we(oe,be,He);break;case"<":qe=We(oe,be,He);break;case"<=":qe=se(oe,be,He);break;default:throw new TypeError("Invalid operator: "+ve)}return qe}function Z(oe,ve){if(oe instanceof Z){if(oe.loose===ve)return oe;oe=oe.value}if(!(this instanceof Z))return new Z(oe,ve);D("comparator",oe,ve),this.loose=ve,this.parse(oe),this.semver===I?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(oe,ve){return de(ve,oe)},e.major=function(oe,ve){return new X(oe,ve).major},e.minor=function(oe,ve){return new X(oe,ve).minor},e.patch=function(oe,ve){return new X(oe,ve).patch},e.compare=ye,e.compareLoose=function(oe,ve){return ye(oe,ve,!0)},e.rcompare=function(oe,ve,be){return ye(ve,oe,be)},e.sort=function(oe,ve){return oe.sort(function(be,He){return e.compare(be,He,ve)})},e.rsort=function(oe,ve){return oe.sort(function(be,He){return e.rcompare(be,He,ve)})},e.gt=Ne,e.lt=We,e.eq=Pe,e.neq=Ce,e.gte=we,e.lte=se,e.cmp=ue,e.Comparator=Z;var I={};function $(oe,ve){if(oe instanceof $)return oe.loose===ve?oe:new $(oe.raw,ve);if(oe instanceof Z)return new $(oe.value,ve);if(!(this instanceof $))return new $(oe,ve);if(this.loose=ve,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function W(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function q(oe,ve,be,He,qe,tt,Xe,et,it,dt,Fe,ot,Y){return((ve=W(be)?"":W(He)?">="+be+".0.0":W(qe)?">="+be+"."+He+".0":">="+ve)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":ot?"<="+it+"."+dt+"."+Fe+"-"+ot:"<="+et)).trim()}function ee(oe,ve){for(var be=0;be<oe.length;be++)if(!oe[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<oe.length;be++)if(D(oe[be].semver),oe[be].semver!==I&&oe[be].semver.prerelease.length>0){var He=oe[be].semver;if(He.major===ve.major&&He.minor===ve.minor&&He.patch===ve.patch)return!0}return!1}return!0}function fe(oe,ve,be){try{ve=new $(ve,be)}catch{return!1}return ve.test(oe)}function De(oe,ve,be,He){var qe,tt,Xe,et,it;switch(oe=new X(oe,He),ve=new $(ve,He),be){case">":qe=Ne,tt=se,Xe=We,et=">",it=">=";break;case"<":qe=We,tt=we,Xe=Ne,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(oe,ve,He))return!1;for(var dt=0;dt<ve.set.length;++dt){var Fe=ve.set[dt],ot=null,Y=null;if(Fe.forEach(function(Q){Q.semver===I&&(Q=new Z(">=0.0.0")),ot=ot||Q,Y=Y||Q,qe(Q.semver,ot.semver,He)?ot=Q:Xe(Q.semver,Y.semver,He)&&(Y=Q)}),ot.operator===et||ot.operator===it||(!Y.operator||Y.operator===et)&&tt(oe,Y.semver)||Y.operator===it&&Xe(oe,Y.semver))return!1}return!0}Z.prototype.parse=function(oe){var ve=this.loose?O[j]:O[le],be=oe.match(ve);if(!be)throw new TypeError("Invalid comparator: "+oe);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new X(be[2],this.loose):this.semver=I},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(oe){return D("Comparator.test",oe,this.loose),this.semver===I||(typeof oe=="string"&&(oe=new X(oe,this.loose)),ue(oe,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(oe,ve){if(!(oe instanceof Z))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new $(oe.value,ve),fe(this.value,be,ve);if(oe.operator==="")return be=new $(this.value,ve),fe(oe.semver,be,ve);var He=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),tt=this.semver.version===oe.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),et=ue(this.semver,"<",oe.semver,ve)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),it=ue(this.semver,">",oe.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return He||qe||tt&&Xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(oe){var ve=this.loose;oe=oe.trim(),D("range",oe,ve);var be=ve?O[ae]:O[re];oe=oe.replace(be,q),D("hyphen replace",oe),oe=oe.replace(O[ge],"$1$2$3"),D("comparator trim",oe,O[ge]),oe=(oe=(oe=oe.replace(O[_],"$1~")).replace(O[R],"$1^")).split(/\s+/).join(" ");var He=ve?O[j]:O[le],qe=oe.split(" ").map(function(tt){return function(Xe,et){return D("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Y){D("caret",ot,Y);var Q=Y?O[H]:O[F];return ot.replace(Q,function(pe,Me,ze,Ve,Ye){var nt;return D("caret",ot,pe,Me,ze,Ve,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=Me==="0"?">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+".0 <"+(+Me+1)+".0.0":Ye?(D("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+Ye+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+Ye+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+Ye+" <"+(+Me+1)+".0.0"):(D("no pr"),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+" <"+(+Me+1)+".0.0"),D("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Y){var Q=Y?O[A]:O[K];return ot.replace(Q,function(pe,Me,ze,Ve,Ye){var nt;return D("tilde",ot,pe,Me,ze,Ve,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":Ye?(D("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=">="+Me+"."+ze+"."+Ve+Ye+" <"+Me+"."+(+ze+1)+".0"):nt=">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0",D("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("tildes",Xe),Xe=function(it,dt){return D("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(ot,Y){ot=ot.trim();var Q=Y?O[P]:O[m];return ot.replace(Q,function(pe,Me,ze,Ve,Ye,nt){D("xRange",ot,pe,Me,ze,Ve,Ye,nt);var vt=W(ze),wt=vt||W(Ve),Ct=wt||W(Ye);return Me==="="&&Ct&&(Me=""),vt?pe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(wt&&(Ve=0),Ct&&(Ye=0),Me===">"?(Me=">=",wt?(ze=+ze+1,Ve=0,Ye=0):Ct&&(Ve=+Ve+1,Ye=0)):Me==="<="&&(Me="<",wt?ze=+ze+1:Ve=+Ve+1),pe=Me+ze+"."+Ve+"."+Ye):wt?pe=">="+ze+".0.0 <"+(+ze+1)+".0.0":Ct&&(pe=">="+ze+"."+Ve+".0 <"+ze+"."+(+Ve+1)+".0"),D("xRange return",pe),pe})}(Fe,dt)}).join(" ")}(Xe,et),D("xrange",Xe),Xe=function(it,dt){return D("replaceStars",it,dt),it.trim().replace(O[ce],"")}(Xe,et),D("stars",Xe),Xe}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(tt){return!!tt.match(He)})),qe=qe.map(function(tt){return new Z(tt,ve)})},$.prototype.intersects=function(oe,ve){if(!(oe instanceof $))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(He){return oe.set.some(function(qe){return qe.every(function(tt){return He.intersects(tt,ve)})})})})},e.toComparators=function(oe,ve){return new $(oe,ve).set.map(function(be){return be.map(function(He){return He.value}).join(" ").trim().split(" ")})},$.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new X(oe,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ee(this.set[ve],oe))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(oe,ve,be){var He=null,qe=null;try{var tt=new $(ve,be)}catch{return null}return oe.forEach(function(Xe){tt.test(Xe)&&(He&&qe.compare(Xe)!==-1||(qe=new X(He=Xe,be)))}),He},e.minSatisfying=function(oe,ve,be){var He=null,qe=null;try{var tt=new $(ve,be)}catch{return null}return oe.forEach(function(Xe){tt.test(Xe)&&(He&&qe.compare(Xe)!==1||(qe=new X(He=Xe,be)))}),He},e.validRange=function(oe,ve){try{return new $(oe,ve).range||"*"}catch{return null}},e.ltr=function(oe,ve,be){return De(oe,ve,"<",be)},e.gtr=function(oe,ve,be){return De(oe,ve,">",be)},e.outside=De,e.prerelease=function(oe,ve){var be=x(oe,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(oe,ve,be){return oe=new $(oe,be),ve=new $(ve,be),oe.intersects(ve)},e.coerce=function(oe){if(oe instanceof X)return oe;if(typeof oe!="string")return null;var ve=oe.match(O[T]);return ve==null?null:x((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,i(1))},function(te,e){var i,C,D=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function O(s){if(i===setTimeout)return setTimeout(s,0);if((i===M||!i)&&setTimeout)return i=setTimeout,setTimeout(s,0);try{return i(s,0)}catch{try{return i.call(null,s,0)}catch{return i.call(this,s,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:M}catch{i=M}try{C=typeof clearTimeout=="function"?clearTimeout:y}catch{C=y}})();var S,k=[],N=!1,w=-1;function h(){N&&S&&(N=!1,S.length?k=S.concat(k):w=-1,k.length&&b())}function b(){if(!N){var s=O(h);N=!0;for(var l=k.length;l;){for(S=k,k=[];++w<l;)S&&S[w].run();w=-1,l=k.length}S=null,N=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===y||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(s)}}function f(s,l){this.fun=s,this.array=l}function a(){}D.nextTick=function(s){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];k.push(new f(s,l)),k.length!==1||N||O(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=a,D.addListener=a,D.once=a,D.off=a,D.removeListener=a,D.removeAllListeners=a,D.emit=a,D.prependListener=a,D.prependOnceListener=a,D.listeners=function(s){return[]},D.binding=function(s){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(s){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ke[114],Te([1,0,12,6]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(L){const v=L;return v?typeof v.read=="function":!1}e.isReadable=D;function M(L){const v=L;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function y(L){const v=L;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=y;function O(L,v){return new S(L,v)}e.newWriteableStream=O;class S{constructor(v,t){this.e=v,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(t=>t(v))}h(v){this.c.error.length===0?(0,i.onUnexpectedError)(v):this.c.error.slice(0).forEach(t=>t(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,t){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(v,t){if(this.a.destroyed)return;let d;switch(v){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const r=d.indexOf(t);r>=0&&d.splice(r,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(L,v){const t=[];let d;for(;(d=L.read())!==null;)t.push(d);return v(t)}e.consumeReadable=k;function N(L,v,t){const d=[];let r;for(;(r=L.read())!==null&&d.length<t;)d.push(r);return r===null&&d.length>0?v(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r<"u"){const u=r;return r=void 0,u}return L.read()}}}e.peekReadable=N;function w(L,v){return new Promise((t,d)=>{const r=[];h(L,{onData:u=>{v&&r.push(u)},onError:u=>{v?d(u):t(void 0)},onEnd:()=>{t(v?v(r):void 0)}})})}e.consumeStream=w;function h(L,v){let t=!1;return L.on("error",d=>{t||v.onError(d)}),L.on("end",()=>{t||v.onEnd()}),L.on("data",d=>{t||v.onData(d)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=h;function b(L,v){return new Promise((t,d)=>{const r=new C.DisposableStore,u=[],n=c=>{if(u.push(c),u.length>v)return r.dispose(),L.pause(),t({stream:L,buffer:u,ended:!1})},p=c=>d(c),o=()=>t({stream:L,buffer:u,ended:!0});r.add((0,C.toDisposable)(()=>L.removeListener("error",p))),L.on("error",p),r.add((0,C.toDisposable)(()=>L.removeListener("end",o))),L.on("end",o),r.add((0,C.toDisposable)(()=>L.removeListener("data",n))),L.on("data",n)})}e.peekStream=b;function f(L,v){const t=O(v);return t.end(L),t}e.toStream=f;function a(){const L=O(()=>{throw new Error("not supported")});return L.end(),L}e.emptyStream=a;function s(L){let v=!1;return{read:()=>v?null:(v=!0,L)}}e.toReadable=s;function l(L,v,t){const d=O(t);return h(L,{onData:r=>d.write(v.data(r)),onError:r=>d.error(v.error?v.error(r):r),onEnd:()=>d.end()}),d}e.transform=l;function g(L,v,t){let d=!1;return{read:()=>{const r=v.read();return d?r:(d=!0,r!==null?t([L,r]):L)}}}e.prefixedReadable=g;function E(L,v,t){let d=!1;const r=O(t);return h(v,{onData:u=>d?r.write(u):(d=!0,r.write(t([L,u]))),onError:u=>r.error(u),onEnd:()=>{d||(d=!0,r.write(L)),r.end()}}),r}e.prefixedStream=E}),define(ke[23],Te([1,0,114]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let D,M;class y{static alloc(c){return C?new y(Buffer.allocUnsafe(c)):new y(new Uint8Array(c))}static wrap(c){return C&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new y(c)}static fromString(c,m){return!(m?.dontUseNodeBuffer||!1)&&C?new y(Buffer.from(c)):(D||(D=new TextEncoder),new y(D.encode(c)))}static fromByteArray(c){const m=y.alloc(c.length);for(let P=0,T=c.length;P<T;P++)m.buffer[P]=c[P];return m}static concat(c,m){if(typeof m>"u"){m=0;for(let V=0,_=c.length;V<_;V++)m+=c[V].byteLength}const P=y.alloc(m);let T=0;for(let V=0,_=c.length;V<_;V++){const K=c[V];P.set(K,T),T+=K.byteLength}return P}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=y.alloc(this.byteLength);return c.set(this),c}toString(){return C?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(c,m){return new y(this.buffer.subarray(c,m))}set(c,m){if(c instanceof y)this.buffer.set(c.buffer,m);else if(c instanceof Uint8Array)this.buffer.set(c,m);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),m);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return k(this.buffer,c)}writeUInt32BE(c,m){N(this.buffer,c,m)}readUInt32LE(c){return w(this.buffer,c)}writeUInt32LE(c,m){h(this.buffer,c,m)}readUInt8(c){return b(this.buffer,c)}writeUInt8(c,m){f(this.buffer,c,m)}}e.VSBuffer=y;function O(o,c){return o[c+0]<<0>>>0|o[c+1]<<8>>>0}e.readUInt16LE=O;function S(o,c,m){o[m+0]=c&255,c=c>>>8,o[m+1]=c&255}e.writeUInt16LE=S;function k(o,c){return o[c]*2**24+o[c+1]*2**16+o[c+2]*2**8+o[c+3]}e.readUInt32BE=k;function N(o,c,m){o[m+3]=c,c=c>>>8,o[m+2]=c,c=c>>>8,o[m+1]=c,c=c>>>8,o[m]=c}e.writeUInt32BE=N;function w(o,c){return o[c+0]<<0>>>0|o[c+1]<<8>>>0|o[c+2]<<16>>>0|o[c+3]<<24>>>0}e.readUInt32LE=w;function h(o,c,m){o[m+0]=c&255,c=c>>>8,o[m+1]=c&255,c=c>>>8,o[m+2]=c&255,c=c>>>8,o[m+3]=c&255}e.writeUInt32LE=h;function b(o,c){return o[c]}e.readUInt8=b;function f(o,c,m){o[m]=c}e.writeUInt8=f;function a(o){return i.consumeReadable(o,c=>y.concat(c))}e.readableToBuffer=a;function s(o){return i.toReadable(o)}e.bufferToReadable=s;function l(o){return i.consumeStream(o,c=>y.concat(c))}e.streamToBuffer=l;async function g(o){return o.ended?y.concat(o.buffer):y.concat([...o.buffer,await l(o.stream)])}e.bufferedStreamToBuffer=g;function E(o){return i.toStream(o,c=>y.concat(c))}e.bufferToStream=E;function L(o){return i.transform(o,{data:c=>typeof c=="string"?y.fromString(c):y.wrap(c)},c=>y.concat(c))}e.streamToBufferReadableStream=L;function v(o){return i.newWriteableStream(c=>y.concat(c),o)}e.newWriteableBufferStream=v;function t(o,c){return i.prefixedReadable(o,c,m=>y.concat(m))}e.prefixedBufferReadable=t;function d(o,c){return i.prefixedStream(o,c,m=>y.concat(m))}e.prefixedBufferStream=d;function r(o){let c=0,m=0,P=0;const T=new Uint8Array(Math.floor(o.length/4*3)),V=K=>{switch(m){case 3:T[P++]=c|K,m=0;break;case 2:T[P++]=c|K>>>2,c=K<<6,m=3;break;case 1:T[P++]=c|K>>>4,c=K<<4,m=2;break;default:c=K<<2,m=1}};for(let K=0;K<o.length;K++){const A=o.charCodeAt(K);if(A>=65&&A<=90)V(A-65);else if(A>=97&&A<=122)V(A-97+26);else if(A>=48&&A<=57)V(A-48+52);else if(A===43||A===45)V(62);else if(A===47||A===95)V(63);else{if(A===61)break;throw new SyntaxError(`Unexpected base64 character ${o[K]}`)}}const _=P;for(;m>0;)V(0);return y.wrap(T).slice(0,_)}e.decodeBase64=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:o},c=!0,m=!1){const P=m?n:u;let T="";const V=o.byteLength%3;let _=0;for(;_<o.byteLength-V;_+=3){const K=o[_+0],A=o[_+1],U=o[_+2];T+=P[K>>>2],T+=P[(K<<4|A>>>4)&63],T+=P[(A<<2|U>>>6)&63],T+=P[U&63]}if(V===1){const K=o[_+0];T+=P[K>>>2],T+=P[K<<4&63],c&&(T+="==")}else if(V===2){const K=o[_+0],A=o[_+1];T+=P[K>>>2],T+=P[(K<<4|A>>>4)&63],T+=P[A<<2&63],c&&(T+="=")}return T}e.encodeBase64=p}),define(ke[115],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ke[38],Te([1,0,84]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var C;(function(y){function O(S){return S&&typeof S=="object"&&typeof S.id=="string"}y.isThemeColor=O})(C=e.ThemeColor||(e.ThemeColor={}));function D(y){return{id:y}}e.themeColorFromId=D;var M;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function S(g){const E=O.exec(g.id);if(!E)return S(i.Codicon.error);const[,L,v]=E,t=["codicon","codicon-"+L];return v&&t.push("codicon-modifier-"+v.substring(1)),t}y.asClassNameArray=S;function k(g){return S(g).join(" ")}y.asClassName=k;function N(g){return"."+S(g).join(".")}y.asCSSSelector=N;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||C.isThemeColor(g.color))}y.isThemeIcon=w;const h=new RegExp(`^\\$\\((${y.iconNameExpression}(?:${y.iconModifierExpression})?)\\)$`);function b(g){const E=h.exec(g);if(!E)return;const[,L]=E;return{id:L}}y.fromString=b;function f(g){return{id:g}}y.fromId=f;function a(g,E){let L=g.id;const v=L.lastIndexOf("~");return v!==-1&&(L=L.substring(0,v)),E&&(L=`${L}~${E}`),{id:L}}y.modify=a;function s(g){const E=g.id.lastIndexOf("~");if(E!==-1)return g.id.substring(E+1)}y.getModifier=s;function l(g,E){return g.id===E.id&&g.color?.id===E.color?.id}y.isEqual=l})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(ke[34],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(D){return i.test(D)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(O){for(let S=0;S<O.length;S++)O[S]=Math.floor(Math.random()*256);return O};const M=new Uint8Array(16),y=[];for(let O=0;O<256;O++)y.push(O.toString(16).padStart(2,"0"));return function(){D(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let S=0,k="";return k+=y[M[S++]],k+=y[M[S++]],k+=y[M[S++]],k+=y[M[S++]],k+="-",k+=y[M[S++]],k+=y[M[S++]],k+="-",k+=y[M[S++]],k+=y[M[S++]],k+="-",k+=y[M[S++]],k+=y[M[S++]],k+="-",k+=y[M[S++]],k+=y[M[S++]],k+=y[M[S++]],k+=y[M[S++]],k+=y[M[S++]],k+=y[M[S++]],k}}()}),define(ke[116],Te([1,0,16,34]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(O){return{id:(0,C.generateUuid)(),asString:async()=>O,asFile:()=>{},value:typeof O=="string"?O:void 0}}e.createStringDataTransferItem=D;function M(O,S,k){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:O,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=M;class y{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const N=this.a.get(S);N?N.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const N of k)yield[S,N]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,N]of this.entries())S(N,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=y,e.UriList=Object.freeze({create:O=>(0,i.distinct)(O.map(S=>S.toString())).join(`\r
`),split:O=>O.split(`\r
`),parse:O=>e.UriList.split(O).filter(S=>!S.startsWith("#"))})}),define(ke[117],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[118],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class C{constructor(O){if(this.e=null,this.f=!1,this.open=O.open,this.close=O.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(O.notIn))for(let S=0,k=O.notIn.length;S<k;S++)switch(O.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(O){switch(O){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(O,S){if(O.getTokenCount()===0)return!0;const k=O.findTokenIndexAtOffset(S-2),N=O.getStandardTokenType(k);return this.isOK(N)}g(O,S){for(let k=O;k<=S;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=C;class D{constructor(O){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of O)M(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),M(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),M(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),M(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&M(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function M(y,O,S){y.has(O)?y.get(O).push(S):y.set(O,[S])}}),define(ke[119],Te([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ke[120],Te([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(ke[121],Te([1,0,120]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,D=C*60,M=D*24,y=M*7,O=M*30,S=M*365;function k(w,h,b,f){typeof w!="number"&&(w=w.getTime());const a=Math.round((new Date().getTime()-w)/1e3);if(a<-30)return(0,i.localize)(0,null,k(new Date().getTime()+a*1e3,!1));if(!f&&a<30)return(0,i.localize)(1,null);let s;return a<C?(s=a,h?s===1?b?(0,i.localize)(2,null,s):(0,i.localize)(3,null,s):b?(0,i.localize)(4,null,s):(0,i.localize)(5,null,s):s===1?b?(0,i.localize)(6,null,s):(0,i.localize)(7,null,s):b?(0,i.localize)(8,null,s):(0,i.localize)(9,null,s)):a<D?(s=Math.floor(a/C),h?s===1?b?(0,i.localize)(10,null,s):(0,i.localize)(11,null,s):b?(0,i.localize)(12,null,s):(0,i.localize)(13,null,s):s===1?b?(0,i.localize)(14,null,s):(0,i.localize)(15,null,s):b?(0,i.localize)(16,null,s):(0,i.localize)(17,null,s)):a<M?(s=Math.floor(a/D),h?s===1?b?(0,i.localize)(18,null,s):(0,i.localize)(19,null,s):b?(0,i.localize)(20,null,s):(0,i.localize)(21,null,s):s===1?b?(0,i.localize)(22,null,s):(0,i.localize)(23,null,s):b?(0,i.localize)(24,null,s):(0,i.localize)(25,null,s)):a<y?(s=Math.floor(a/M),h?s===1?(0,i.localize)(26,null,s):(0,i.localize)(27,null,s):s===1?(0,i.localize)(28,null,s):(0,i.localize)(29,null,s)):a<O?(s=Math.floor(a/y),h?s===1?b?(0,i.localize)(30,null,s):(0,i.localize)(31,null,s):b?(0,i.localize)(32,null,s):(0,i.localize)(33,null,s):s===1?b?(0,i.localize)(34,null,s):(0,i.localize)(35,null,s):b?(0,i.localize)(36,null,s):(0,i.localize)(37,null,s)):a<S?(s=Math.floor(a/O),h?s===1?b?(0,i.localize)(38,null,s):(0,i.localize)(39,null,s):b?(0,i.localize)(40,null,s):(0,i.localize)(41,null,s):s===1?b?(0,i.localize)(42,null,s):(0,i.localize)(43,null,s):b?(0,i.localize)(44,null,s):(0,i.localize)(45,null,s)):(s=Math.floor(a/S),h?s===1?b?(0,i.localize)(46,null,s):(0,i.localize)(47,null,s):b?(0,i.localize)(48,null,s):(0,i.localize)(49,null,s):s===1?b?(0,i.localize)(50,null,s):(0,i.localize)(51,null,s):b?(0,i.localize)(52,null,s):(0,i.localize)(53,null,s))}e.fromNow=k;function N(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(ke[122],Te([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ke[39],Te([1,0,16,9,122]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(w,h){return h&&(w.stack||w.stacktrace)?D.localize(0,null,O(w),y(w.stack)||y(w.stacktrace)):O(w)}function y(w){return Array.isArray(w)?w.join(`
`):w}function O(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function S(w=null,h=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const b=i.coalesce(w),f=S(b[0],h);return b.length>1?D.localize(4,null,f,b.length):f}if(C.isString(w))return w;if(w.detail){const b=w.detail;if(b.error)return M(b.error,h);if(b.exception)return M(b.exception,h)}return w.stack?M(w,h):w.message?w.message:D.localize(5,null)}e.toErrorMessage=S;function k(w){const h=w;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=k;function N(w,h){let b;return typeof w=="string"?b=new Error(w):b=w,b.actions=h,b}e.createErrorWithActions=N}),define(ke[123],Te([1,0,85,19]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new i.Lazy(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),M=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(c,m,P=!1){const T=c||"",V=m||"",_=D.value.collator.compare(T,V);return D.value.collatorIsNumeric&&_===0&&T!==V?T<V?-1:1:_}e.compareFileNames=O;function S(c,m){const P=M.value.collator;return c=c||"",m=m||"",L(P,c,m)}e.compareFileNamesDefault=S;function k(c,m){const P=M.value.collator;return c=c||"",m=m||"",r(c,m)||L(P,c,m)}e.compareFileNamesUpper=k;function N(c,m){const P=M.value.collator;return c=c||"",m=m||"",d(c,m)||L(P,c,m)}e.compareFileNamesLower=N;function w(c,m){return c=c||"",m=m||"",c===m?0:c<m?-1:1}e.compareFileNamesUnicode=w;function h(c,m){const[P,T]=g(c),[V,_]=g(m);let K=D.value.collator.compare(T,_);if(K===0){if(D.value.collatorIsNumeric&&T!==_)return T<_?-1:1;if(K=D.value.collator.compare(P,V),D.value.collatorIsNumeric&&K===0&&P!==V)return P<V?-1:1}return K}e.compareFileExtensions=h;function b(c,m){c=c||"",m=m||"";const P=E(c),T=E(m),V=M.value.collator,_=y.value.collator;return L(_,P,T)||L(V,c,m)}e.compareFileExtensionsDefault=b;function f(c,m){c=c||"",m=m||"";const P=E(c),T=E(m),V=M.value.collator,_=y.value.collator;return L(_,P,T)||r(c,m)||L(V,c,m)}e.compareFileExtensionsUpper=f;function a(c,m){c=c||"",m=m||"";const P=E(c),T=E(m),V=M.value.collator,_=y.value.collator;return L(_,P,T)||d(c,m)||L(V,c,m)}e.compareFileExtensionsLower=a;function s(c,m){c=c||"",m=m||"";const P=E(c).toLowerCase(),T=E(m).toLowerCase();return P!==T?P<T?-1:1:c!==m?c<m?-1:1:0}e.compareFileExtensionsUnicode=s;const l=/^(.*?)(\.([^.]*))?$/;function g(c,m=!1){const P=c?l.exec(c):[];let T=[P&&P[1]||"",P&&P[3]||""];return m&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function E(c){const m=c?l.exec(c):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function L(c,m,P){const T=c.compare(m,P);return T!==0?T:m.length!==P.length?m.length<P.length?-1:1:0}function v(c){const m=c.charAt(0);return m.toLocaleUpperCase()!==m}function t(c){const m=c.charAt(0);return m.toLocaleLowerCase()!==m}function d(c,m){return v(c)&&t(m)?-1:t(c)&&v(m)?1:0}function r(c,m){return t(c)&&v(m)?-1:v(c)&&t(m)?1:0}function u(c,m,P=!1){return P||(c=c&&c.toLowerCase(),m=m&&m.toLowerCase()),c===m?0:c<m?-1:1}function n(c,m,P=!1){const T=c.split(C.sep),V=m.split(C.sep),_=T.length-1,K=V.length-1;let A,U;for(let R=0;;R++){if(A=_===R,U=K===R,A&&U)return O(T[R],V[R],P);if(A)return-1;if(U)return 1;const F=u(T[R],V[R],P);if(F!==0)return F}}e.comparePaths=n;function p(c,m,P){const T=c.toLowerCase(),V=m.toLowerCase(),_=o(c,m,P);if(_)return _;const K=T.endsWith(P),A=V.endsWith(P);if(K!==A)return K?-1:1;const U=O(T,V);return U!==0?U:T.localeCompare(V)}e.compareAnything=p;function o(c,m,P){const T=c.toLowerCase(),V=m.toLowerCase(),_=T.startsWith(P),K=V.startsWith(P);if(_!==K)return _?-1:1;if(_&&K){if(T.length<V.length)return-1;if(T.length>V.length)return 1}return 0}e.compareByPrefix=o}),define(ke[65],Te([1,0,19]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(N){const w=(0,i.extname)(N),h=C[w.toLowerCase()];return h!==void 0?h:y(N)}e.getMediaOrTextMime=M;function y(N){const w=(0,i.extname)(N);return D[w.toLowerCase()]}e.getMediaMime=y;function O(N){for(const w in D)if(D[w]===N)return w}e.getExtensionForMimeType=O;const S=/^(.+)\/(.+?)(;.+)?$/;function k(N,w){const h=S.exec(N);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:w?void 0:N}e.normalizeMimeType=k}),define(ke[124],Te([1,0,4,6,119]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends C.Disposable{constructor(h,b="",f="",a=!0,s){super(),this.h=this.B(new i.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=b,this.u=f,this.w=a,this.C=s}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,b){this.C&&await this.C(h)}}e.Action=M;class y extends C.Disposable{constructor(){super(...arguments),this.f=this.B(new i.Emitter),this.onWillRun=this.f.event,this.h=this.B(new i.Emitter),this.onDidRun=this.h.event}async run(h,b){if(!h.enabled)return;this.f.fire({action:h});let f;try{await this.runAction(h,b)}catch(a){f=a}this.h.fire({action:h,error:f})}async runAction(h,b){await h.run(b)}}e.ActionRunner=y;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let b=[];for(const f of h)f.length&&(b.length?b=[...b,new O,...f]:b=f);return b}async run(){}}O.ID="vs.actions.separator",e.Separator=O;class S{get actions(){return this.a}constructor(h,b,f,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=b,this.class=a,this.a=f}async run(){}}e.SubmenuAction=S;class k extends M{constructor(){super(k.ID,D.localize(0,null),void 0,!1)}}k.ID="vs.actions.empty",e.EmptySubmenuAction=k;function N(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=N}),define(ke[40],Te([1,0,19,20,10,9]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function O(n){return n.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=O;function S(n){return n.indexOf("/")===-1&&(n=O(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function k(n,p=i.posix.sep){if(!n)return"";const o=n.length,c=n.charCodeAt(0);if(y(c)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let P=3;const T=P;for(;P<o&&!y(n.charCodeAt(P));P++);if(T!==P&&!y(n.charCodeAt(P+1))){for(P+=1;P<o;P++)if(y(n.charCodeAt(P)))return n.slice(0,P+1).replace(/[\\/]/g,p)}}return p}else if(l(c)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+p:n.slice(0,2);let m=n.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(y(n.charCodeAt(m)))return n.slice(0,m+1)}return""}e.getRoot=k;function N(n){if(!C.isWindows||!n||n.length<5)return!1;let p=n.charCodeAt(0);if(p!==92||(p=n.charCodeAt(1),p!==92))return!1;let o=2;const c=o;for(;o<n.length&&(p=n.charCodeAt(o),p!==92);o++);return!(c===o||(p=n.charCodeAt(o+1),isNaN(p)||p===92))}e.isUNC=N;const w=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,p=C.isWindows){const o=p?w:h;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||p&&b.test(n)||n==="."||n===".."||p&&n[n.length-1]==="."||p&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function a(n,p,o){const c=n===p;return!o||c?c:!n||!p?!1:(0,D.equalsIgnoreCase)(n,p)}e.isEqual=a;function s(n,p,o,c=i.sep){if(n===p)return!0;if(!n||!p||p.length>n.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(n,p))return!1;if(p.length===n.length)return!0;let P=p.length;return p.charAt(p.length-1)===c&&P--,n.charAt(P)===c}return p.charAt(p.length-1)!==c&&(p+=c),n.indexOf(p)===0}e.isEqualOrParent=s;function l(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=l;function g(n,p){return C.isWindows&&n.endsWith(":")&&(n+=i.sep),(0,i.isAbsolute)(n)||(n=(0,i.join)(p,n)),n=(0,i.normalize)(n),C.isWindows?(n=(0,D.rtrim)(n,i.sep),n.endsWith(":")&&(n+=i.sep)):(n=(0,D.rtrim)(n,i.sep),n||(n=i.sep)),n}e.sanitizeFilePath=g;function E(n){const p=(0,i.normalize)(n);return C.isWindows?n.length>3?!1:L(p)&&(n.length===2||p.charCodeAt(2)===92):p===i.posix.sep}e.isRootOrDriveLetter=E;function L(n,p=C.isWindows){return p?l(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=L;function v(n){return L(n)?n[0]:void 0}e.getDriveLetter=v;function t(n,p,o){return p.length>n.length?-1:n===p?0:(o&&(n=n.toLowerCase(),p=p.toLowerCase()),n.indexOf(p))}e.indexOfPath=t;function d(n){const p=n.split(":");let o,c,m;for(const P of p){const T=Number(P);(0,M.isNumber)(T)?c===void 0?c=T:m===void 0&&(m=T):o=o?[o,P].join(":"):P}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:c!==void 0?c:void 0,column:m!==void 0?m:c!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(n,p,o=8){let c="";for(let P=0;P<o;P++)c+=r.charAt(Math.floor(Math.random()*r.length));let m;return p?m=`${p}-${c}`:m=c,n?(0,i.join)(n,m):m}e.randomPath=u}),define(ke[125],Te([1,0,28,10]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Z){return function(I,$){for(let W=0,q=Z.length;W<q;W++){const ee=Z[W](I,$);if(ee)return ee}return null}}e.or=D,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,I,$){if(!$||$.length<I.length)return null;let W;return Z?W=C.startsWithIgnoreCase($,I):W=$.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function y(Z,I){const $=I.toLowerCase().indexOf(Z.toLowerCase());return $===-1?null:[{start:$,end:$+Z.length}]}e.matchesContiguousSubString=y;function O(Z,I){return S(Z.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=O;function S(Z,I,$,W){if($===Z.length)return[];if(W===I.length)return null;if(Z[$]===I[W]){let q=null;return(q=S(Z,I,$+1,W+1))?l({start:W,end:W+1},q):null}return S(Z,I,$,W+1)}function k(Z){return 97<=Z&&Z<=122}function N(Z){return 65<=Z&&Z<=90}e.isUpper=N;function w(Z){return 48<=Z&&Z<=57}function h(Z){return Z===32||Z===9||Z===10||Z===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>b.add(Z.charCodeAt(0)));function f(Z){return h(Z)||b.has(Z)}function a(Z,I){return Z===I||f(Z)&&f(I)}function s(Z){return k(Z)||N(Z)||w(Z)}function l(Z,I){return I.length===0?I=[Z]:Z.end===I[0].start?I[0].start=Z.start:I.unshift(Z),I}function g(Z,I){for(let $=I;$<Z.length;$++){const W=Z.charCodeAt($);if(N(W)||w(W)||$>0&&!s(Z.charCodeAt($-1)))return $}return Z.length}function E(Z,I,$,W){if($===Z.length)return[];if(W===I.length)return null;if(Z[$]!==I[W].toLowerCase())return null;{let q=null,ee=W+1;for(q=E(Z,I,$+1,W+1);!q&&(ee=g(I,ee))<I.length;)q=E(Z,I,$+1,ee),ee++;return q===null?null:l({start:W,end:W+1},q)}}function L(Z){let I=0,$=0,W=0,q=0,ee=0;for(let be=0;be<Z.length;be++)ee=Z.charCodeAt(be),N(ee)&&I++,k(ee)&&$++,s(ee)&&W++,w(ee)&&q++;const fe=I/Z.length,De=$/Z.length,oe=W/Z.length,ve=q/Z.length;return{upperPercent:fe,lowerPercent:De,alphaPercent:oe,numericPercent:ve}}function v(Z){const{upperPercent:I,lowerPercent:$}=Z;return $===0&&I>.6}function t(Z){const{upperPercent:I,lowerPercent:$,alphaPercent:W,numericPercent:q}=Z;return $>.2&&I<.8&&W>.6&&q<.2}function d(Z){let I=0,$=0,W=0,q=0;for(let ee=0;ee<Z.length;ee++)W=Z.charCodeAt(ee),N(W)&&I++,k(W)&&$++,h(W)&&q++;return(I===0||$===0)&&q===0?Z.length<=30:I<=5}function r(Z,I){if(!I||(I=I.trim(),I.length===0)||!d(Z)||I.length>60)return null;const $=L(I);if(!t($)){if(!v($))return null;I=I.toLowerCase()}let W=null,q=0;for(Z=Z.toLowerCase();q<I.length&&(W=E(Z,I,0,q))===null;)q=g(I,q+1);return W}e.matchesCamelCase=r;function u(Z,I,$=!1){if(!I||I.length===0)return null;let W=null,q=0;for(Z=Z.toLowerCase(),I=I.toLowerCase();q<I.length&&(W=n(Z,I,0,q,$))===null;)q=p(I,q+1);return W}e.matchesWords=u;function n(Z,I,$,W,q){if($===Z.length)return[];if(W===I.length)return null;if(a(Z.charCodeAt($),I.charCodeAt(W))){let ee=null,fe=W+1;if(ee=n(Z,I,$+1,W+1,q),!q)for(;!ee&&(fe=p(I,fe))<I.length;)ee=n(Z,I,$+1,fe,q),fe++;return ee?Z.charCodeAt($)!==I.charCodeAt(W)?ee:l({start:W,end:W+1},ee):null}else return null}function p(Z,I){for(let $=I;$<Z.length;$++)if(f(Z.charCodeAt($))||$>0&&f(Z.charCodeAt($-1)))return $;return Z.length}const o=D(e.matchesPrefix,r,y),c=D(e.matchesPrefix,r,O),m=new i.LRUCache(1e4);function P(Z,I,$=!1){if(typeof Z!="string"||typeof I!="string")return null;let W=m.get(Z);W||(W=new RegExp(C.convertSimple2RegExpPattern(Z),"i"),m.set(Z,W));const q=W.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:$?c(Z,I):o(Z,I)}e.matchesFuzzy=P;function T(Z,I){const $=Ne(Z,Z.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?_($):null}e.matchesFuzzy2=T;function V(Z,I,$,W,q,ee){const fe=Math.min(13,Z.length);for(;$<fe;$++){const De=Ne(Z,I,$,W,q,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ee]}e.anyScore=V;function _(Z){if(typeof Z>"u")return[];const I=[],$=Z[1];for(let W=Z.length-1;W>1;W--){const q=Z[W]+$,ee=I[I.length-1];ee&&ee.end===q?ee.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=_;const K=128;function A(){const Z=[],I=[];for(let $=0;$<=K;$++)I[$]=0;for(let $=0;$<=K;$++)Z.push(I.slice(0));return Z}function U(Z){const I=[];for(let $=0;$<=Z;$++)I[$]=0;return I}const R=U(2*K),F=U(2*K),H=A(),j=A(),le=A(),ge=!1;function re(Z,I,$,W,q){function ee(De,oe,ve=" "){for(;De.length<oe;)De=ve+De;return De}let fe=` |   |${W.split("").map(De=>ee(De,3)).join("|")}
`;for(let De=0;De<=$;De++)De===0?fe+=" |":fe+=`${I[De-1]}|`,fe+=Z[De].slice(0,q+1).map(oe=>ee(oe.toString(),3)).join("|")+`
`;return fe}function ae(Z,I,$,W){Z=Z.substr(I),$=$.substr(W),console.log(re(j,Z,Z.length,$,$.length)),console.log(re(le,Z,Z.length,$,$.length)),console.log(re(H,Z,Z.length,$,$.length))}function ce(Z,I){if(I<0||I>=Z.length)return!1;const $=Z.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise($)}}function Se(Z,I){if(I<0||I>=Z.length)return!1;switch(Z.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function x(Z,I,$){return I[Z]!==$[Z]}function X(Z,I,$,W,q,ee,fe=!1){for(;I<$&&q<ee;)Z[I]===W[q]&&(fe&&(R[I]=q),I+=1),q+=1;return I===$}e.isPatternInWord=X;var J;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(J||(J={}));var de;(function(Z){Z.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Z.isDefault=I})(de=e.FuzzyScore||(e.FuzzyScore={}));class ye{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}ye.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ye;function Ne(Z,I,$,W,q,ee,fe=ye.default){const De=Z.length>K?K:Z.length,oe=W.length>K?K:W.length;if($>=De||ee>=oe||De-$>oe-ee||!X(I,$,De,q,ee,oe,!0))return;We(De,oe,$,ee,I,q);let ve=1,be=1,He=$,qe=ee;const tt=[!1];for(ve=1,He=$;He<De;ve++,He++){const Fe=R[He],ot=F[He],Y=He+1<De?F[He+1]:oe;for(be=Fe-ee+1,qe=Fe;qe<Y;be++,qe++){let Q=Number.MIN_SAFE_INTEGER,pe=!1;qe<=ot&&(Q=Pe(Z,I,He,$,W,q,qe,oe,ee,H[ve-1][be-1]===0,tt));let Me=0;Q!==Number.MAX_SAFE_INTEGER&&(pe=!0,Me=Q+j[ve-1][be-1]);const ze=qe>Fe,Ve=ze?j[ve][be-1]+(H[ve][be-1]>0?-5:0):0,Ye=qe>Fe+1&&H[ve][be-1]>0,nt=Ye?j[ve][be-2]+(H[ve][be-2]>0?-5:0):0;if(Ye&&(!ze||nt>=Ve)&&(!pe||nt>=Me))j[ve][be]=nt,le[ve][be]=3,H[ve][be]=0;else if(ze&&(!pe||Ve>=Me))j[ve][be]=Ve,le[ve][be]=2,H[ve][be]=0;else if(pe)j[ve][be]=Me,le[ve][be]=1,H[ve][be]=H[ve-1][be-1]+1;else throw new Error("not possible")}}if(ge&&ae(Z,$,W,ee),!tt[0]&&!fe.firstMatchCanBeWeak)return;ve--,be--;const Xe=[j[ve][be],ee];let et=0,it=0;for(;ve>=1;){let Fe=be;do{const ot=le[ve][Fe];if(ot===3)Fe=Fe-2;else if(ot===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+ve-1]===q[ee+be-1]&&!x(Fe+ee-1,W,q)&&et+1>H[ve][Fe]&&(Fe=be),Fe===be?et++:et=1,it||(it=Fe),ve--,be=Fe-1,Xe.push(be)}oe===De&&fe.boostFullMatch&&(Xe[0]+=2);const dt=it-De;return Xe[0]-=dt,Xe}e.fuzzyScore=Ne;function We(Z,I,$,W,q,ee){let fe=Z-1,De=I-1;for(;fe>=$&&De>=W;)q[fe]===ee[De]&&(F[fe]=De,fe--),De--}function Pe(Z,I,$,W,q,ee,fe,De,oe,ve,be){if(I[$]!==ee[fe])return Number.MIN_SAFE_INTEGER;let He=1,qe=!1;return fe===$-W?He=Z[$]===q[fe]?7:5:x(fe,q,ee)&&(fe===0||!x(fe-1,q,ee))?(He=Z[$]===q[fe]?7:5,qe=!0):ce(ee,fe)&&(fe===0||!ce(ee,fe-1))?He=5:(ce(ee,fe-1)||Se(ee,fe-1))&&(He=5,qe=!0),He>1&&$===W&&(be[0]=!0),qe||(qe=x(fe,q,ee)||ce(ee,fe-1)||Se(ee,fe-1)),$===W?fe>oe&&(He-=qe?3:5):ve?He+=qe?2:0:He+=qe?0:1,fe+1===De&&(He-=qe?3:5),He}function Ce(Z,I,$,W,q,ee,fe){return se(Z,I,$,W,q,ee,!0,fe)}e.fuzzyScoreGracefulAggressive=Ce;function we(Z,I,$,W,q,ee,fe){return se(Z,I,$,W,q,ee,!1,fe)}e.fuzzyScoreGraceful=we;function se(Z,I,$,W,q,ee,fe,De){let oe=Ne(Z,I,$,W,q,ee,De);if(oe&&!fe)return oe;if(Z.length>=3){const ve=Math.min(7,Z.length-1);for(let be=$+1;be<ve;be++){const He=ue(Z,be);if(He){const qe=Ne(He,He.toLowerCase(),$,W,q,ee,De);qe&&(qe[0]-=3,(!oe||qe[0]>oe[0])&&(oe=qe))}}}return oe}function ue(Z,I){if(I+1>=Z.length)return;const $=Z[I],W=Z[I+1];if($!==W)return Z.slice(0,I)+W+$+Z.slice(I+2)}}),define(ke[126],Te([1,0,125,10,38]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",y=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${y.source}`,"g");function S(l){return l.replace(O,(g,E)=>E?g:`\\${g}`)}e.escapeIcons=S;const k=new RegExp(`\\\\${y.source}`,"g");function N(l){return l.replace(k,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=N;const w=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function h(l){return l.indexOf(M)===-1?l:l.replace(w,(g,E,L,v)=>L?g:E||v||"")}e.stripIcons=h;function b(l){return l?l.replace(/\$\((.*?)\)/g,(g,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=b;const f=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(l){f.lastIndex=0;let g="";const E=[];let L=0;for(;;){const v=f.lastIndex,t=f.exec(l),d=l.substring(v,t?.index);if(d.length>0){g+=d;for(let r=0;r<d.length;r++)E.push(L)}if(!t)break;L+=t[0].length}return{text:g,iconOffsets:E}}e.parseLabelWithIcons=a;function s(l,g,E=!1){const{text:L,iconOffsets:v}=g;if(!v||v.length===0)return(0,i.matchesFuzzy)(l,L,E);const t=(0,C.ltrim)(L," "),d=L.length-t.length,r=(0,i.matchesFuzzy)(l,t,E);if(r)for(const u of r){const n=v[u.start+d]+d;u.start+=n,u.end+=n}return r}e.matchesFuzzyIconAware=s}),define(ke[29],Te([1,0,10]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(C||(C={})),function(D){const M="error",y="warning",O="warn",S="info",k="ignore";function N(h){return h?i.equalsIgnoreCase(M,h)?D.Error:i.equalsIgnoreCase(y,h)||i.equalsIgnoreCase(O,h)?D.Warning:i.equalsIgnoreCase(S,h)?D.Info:D.Ignore:D.Ignore}D.fromValue=N;function w(h){switch(h){case D.Error:return M;case D.Warning:return y;case D.Info:return S;default:return k}}D.toString=w}(C||(C={})),e.default=C}),define(ke[48],Te([1,0,16,10]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),a=this.b.charCodeAt(this.c);return f-a}value(){return this.b[this.c]}}e.StringIterator=D;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,C.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class y{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const a=this.b.charCodeAt(f);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,C.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=y;var O;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(O||(O={}));class S{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,C.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,C.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,C.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,C.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(N||(N={}));class w{static forUris(b=()=>!1,f=()=>!1){return new w(new S(b,f))}static forPaths(b=!1){return new w(new y(void 0,!b))}static forStrings(){return new w(new D)}static forConfigKeys(){return new w(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const a=f.slice(0);(0,i.shuffle)(a);for(const s of a)this.set(s,b)}else{const a=b.slice(0);(0,i.shuffle)(a);for(const s of a)this.set(s[0],s[1])}}set(b,f){const a=this.b.reset(b);let s;this.c||(this.c=new k,this.c.segment=a.value());const l=[];for(s=this.c;;){const E=a.cmp(s.segment);if(E>0)s.left||(s.left=new k,s.left.segment=a.value()),l.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new k,s.right.segment=a.value()),l.push([1,s]),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new k,s.mid.segment=a.value()),l.push([0,s]),s=s.mid;else break}const g=s.value;s.value=f,s.key=b;for(let E=l.length-1;E>=0;E--){const L=l[E][1];L.updateHeight();const v=L.balanceFactor();if(v<-1||v>1){const t=l[E][0],d=l[E+1][0];if(t===1&&d===1)l[E][1]=L.rotateLeft();else if(t===-1&&d===-1)l[E][1]=L.rotateRight();else if(t===1&&d===-1)L.right=l[E+1][1]=l[E+1][1].rotateRight(),l[E][1]=L.rotateLeft();else if(t===-1&&d===1)L.left=l[E+1][1]=l[E+1][1].rotateLeft(),l[E][1]=L.rotateRight();else throw new Error;if(E>0)switch(l[E-1][0]){case-1:l[E-1][1].left=l[E][1];break;case 1:l[E-1][1].right=l[E][1];break;case 0:l[E-1][1].mid=l[E][1];break}else this.c=l[0][1]}}return g}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let a=this.c;for(;a;){const s=f.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(f.hasNext())f.next(),a=a.mid;else break}return a}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const a=this.b.reset(b),s=[];let l=this.c;for(;l;){const g=a.cmp(l.segment);if(g>0)s.push([-1,l]),l=l.left;else if(g<0)s.push([1,l]),l=l.right;else if(a.hasNext())a.next(),s.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const g=this.f(l.right);if(g.key){const{key:E,value:L,segment:v}=g;this.e(g.key,!1),l.key=E,l.value=L,l.segment=v}}else{const g=l.left??l.right;if(s.length>0){const[E,L]=s[s.length-1];switch(E){case-1:L.left=g;break;case 0:L.mid=g;break;case 1:L.right=g;break}}else this.c=g}for(let g=s.length-1;g>=0;g--){const E=s[g][1];E.updateHeight();const L=E.balanceFactor();if(L>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),s[g][1]=E.rotateLeft()):L<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),s[g][1]=E.rotateRight()),g>0)switch(s[g-1][0]){case-1:s[g-1][1].left=s[g][1];break;case 1:s[g-1][1].right=s[g][1];break;case 0:s[g-1][1].mid=s[g][1];break}else this.c=s[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let a=this.c,s;for(;a;){const l=f.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(f.hasNext())f.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr(b){return this.g(b,!1)}g(b,f){const a=this.b.reset(b);let s=this.c;for(;s;){const l=a.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this.h(s.mid):f?s.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,a]of this)b(a,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){!b||(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const a=f.balanceFactor();return a<-1||a>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.TernarySearchTree=w}),define(ke[66],Te([1,0,23,10,2]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(k){return JSON.stringify(k,O)}e.stringify=M;function y(k){let N=JSON.parse(k);return N=S(N),N}e.parse=y;function O(k,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,C.regExpFlags)(N)}:N}function S(k,N=0){if(!k||N>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let w=0;w<k.length;++w)k[w]=S(k[w],N+1);else for(const w in k)Object.hasOwnProperty.call(k,w)&&(k[w]=S(k[w],N+1))}return k}e.revive=S}),define(ke[15],Te([1,0,12,20,2]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(N){this.d=N}setDelegate(N){this.e=N}setServerRootPath(N){this.f=`${N}/${M.vscodeRemoteResource}`}set(N,w,h){this.a[N]=w,this.b[N]=h}setConnectionToken(N,w){this.c[N]=w}getPreferredWebSchema(){return this.d}rewrite(N){if(this.e)try{return this.e(N)}catch(s){return i.onUnexpectedError(s),N}const w=N.authority;let h=this.a[w];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const b=this.b[w],f=this.c[w];let a=`path=${encodeURIComponent(N.path)}`;return typeof f=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),D.URI.from({scheme:C.isWeb?this.d:M.vscodeRemoteResource,authority:`${h}:${b}`,path:this.f,query:a})}}e.RemoteAuthorities=new y,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class O{asBrowserUri(N){const w=this.b(N,te);return this.uriToBrowserUri(w)}uriToBrowserUri(N){return N.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===M.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${M.vscodeFileResource}://${O.a}`)?N.with({scheme:M.vscodeFileResource,authority:N.authority||O.a,query:null,fragment:null}):N}asFileUri(N){const w=this.b(N,te);return this.uriToFileUri(w)}uriToFileUri(N){return N.scheme===M.vscodeFileResource?N.with({scheme:M.file,authority:N.authority!==O.a?N.authority:null,query:null,fragment:null}):N}b(N,w){return D.URI.isUri(N)?N:D.URI.parse(w.toUrl(N))}}O.a="vscode-app",e.FileAccess=new O;var S;(function(k){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(N.get("3"));const w="vscode-coi";function h(f){let a;typeof f=="string"?a=new URL(f).searchParams:f instanceof URL?a=f.searchParams:D.URI.isUri(f)&&(a=new URL(f.toString(!0)).searchParams);const s=a?.get(w);if(!!s)return N.get(s)}k.getHeadersFromQuery=h;function b(f,a,s){if(!globalThis.crossOriginIsolated)return;const l=a&&s?"3":s?"2":"1";f instanceof URLSearchParams?f.set(w,l):f[w]=l}k.addSearchParam=b})(S=e.COI||(e.COI={}))}),define(ke[24],Te([1,0,40,15,19,20,10,2]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,O.uriToFsPath)(b,!0)}e.originalFSPath=S;class k{constructor(f){this.a=f}compare(f,a,s=!1){return f===a?0:(0,y.compare)(this.getComparisonKey(f,s),this.getComparisonKey(a,s))}isEqual(f,a,s=!1){return f===a?!0:!f||!a?!1:this.getComparisonKey(f,s)===this.getComparisonKey(a,s)}getComparisonKey(f,a=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,a,s=!1){if(f.scheme===a.scheme){if(f.scheme===C.Schemas.file)return i.isEqualOrParent(S(f),S(a),this.a(f))&&f.query===a.query&&(s||f.fragment===a.fragment);if((0,e.isEqualAuthority)(f.authority,a.authority))return i.isEqualOrParent(f.path,a.path,this.a(f),"/")&&f.query===a.query&&(s||f.fragment===a.fragment)}return!1}joinPath(f,...a){return O.URI.joinPath(f,...a)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let a;return f.scheme===C.Schemas.file?a=O.URI.file(D.dirname(S(f))).path:(a=D.posix.dirname(f.path),f.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),a="/")),f.with({path:a})}normalizePath(f){if(!f.path.length)return f;let a;return f.scheme===C.Schemas.file?a=O.URI.file(D.normalize(S(f))).path:a=D.posix.normalize(f.path),f.with({path:a})}relativePath(f,a){if(f.scheme!==a.scheme||!(0,e.isEqualAuthority)(f.authority,a.authority))return;if(f.scheme===C.Schemas.file){const g=D.relative(S(f),S(a));return M.isWindows?i.toSlashes(g):g}let s=f.path||"/";const l=a.path||"/";if(this.a(f)){let g=0;for(const E=Math.min(s.length,l.length);g<E&&!(s.charCodeAt(g)!==l.charCodeAt(g)&&s.charAt(g).toLowerCase()!==l.charAt(g).toLowerCase());g++);s=l.substr(0,g)+s.substr(g)}return D.posix.relative(s,l)}resolvePath(f,a){if(f.scheme===C.Schemas.file){const s=O.URI.file(D.resolve(S(f),a));return f.with({authority:s.authority,path:s.path})}return a=i.toPosixPath(a),f.with({path:D.posix.resolve(f.path,a)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,a){return f===a||f!==void 0&&a!==void 0&&(0,y.equalsIgnoreCase)(f,a)}hasTrailingPathSeparator(f,a=D.sep){if(f.scheme===C.Schemas.file){const s=S(f);return s.length>i.getRoot(s).length&&s[s.length-1]===a}else{const s=f.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,a=D.sep){return(0,e.hasTrailingPathSeparator)(f,a)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,a=D.sep){let s=!1;if(f.scheme===C.Schemas.file){const l=S(f);s=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===a}else{a="/";const l=f.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(f,a)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(b=>b.scheme===C.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new k(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(b,f){const a=[];for(let s=0;s<b.length;s++){const l=f(b[s]);b.some((g,E)=>E===s?!1:(0,e.isEqualOrParent)(l,f(g)))||a.push(b[s])}return a}e.distinctParents=N;var w;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(a){const s=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(E=>{const[L,v]=E.split(":");L&&v&&s.set(L,v)});const g=a.path.substring(0,a.path.indexOf(";"));return g&&s.set(b.META_DATA_MIME,g),s}b.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function h(b,f,a){if(f){let s=b.path;return s&&s[0]!==D.posix.sep&&(s=D.posix.sep+s),b.with({scheme:a,authority:f,path:s})}return b.with({scheme:a})}e.toLocalResource=h}),define(ke[17],Te([1,0,21,12,4,6,24,20,115]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(X){return!!X&&typeof X.then=="function"}e.isThenable=k;function N(X){const J=new i.CancellationTokenSource,de=X(J.token),ye=new Promise((Ne,We)=>{const Pe=J.token.onCancellationRequested(()=>{Pe.dispose(),J.dispose(),We(new C.CancellationError)});Promise.resolve(de).then(Ce=>{Pe.dispose(),J.dispose(),Ne(Ce)},Ce=>{Pe.dispose(),J.dispose(),We(Ce)})});return new class{cancel(){J.cancel()}then(Ne,We){return ye.then(Ne,We)}catch(Ne){return this.then(void 0,Ne)}finally(Ne){return ye.finally(Ne)}}}e.createCancelablePromise=N;function w(X,J,de){return new Promise((ye,Ne)=>{const We=J.onCancellationRequested(()=>{We.dispose(),ye(de)});X.then(ye,Ne).finally(()=>We.dispose())})}e.raceCancellation=w;function h(X,J){return new Promise((de,ye)=>{const Ne=J.onCancellationRequested(()=>{Ne.dispose(),ye(new C.CancellationError)});X.then(de,ye).finally(()=>Ne.dispose())})}e.raceCancellationError=h;async function b(X){let J=-1;const de=X.map((Ne,We)=>Ne.then(Pe=>(J=We,Pe))),ye=await Promise.race(de);return X.forEach((Ne,We)=>{We!==J&&Ne.cancel()}),ye}e.raceCancellablePromises=b;function f(X,J,de){let ye;const Ne=setTimeout(()=>{ye?.(void 0),de?.()},J);return Promise.race([X.finally(()=>clearTimeout(Ne)),new Promise(We=>ye=We)])}e.raceTimeout=f;function a(X){return new Promise((J,de)=>{const ye=X();k(ye)?ye.then(J,de):J(ye)})}e.asPromise=a;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(J){if(this.a){if(this.d=J,!this.b){const de=()=>{this.b=null;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(de,de).then(ye)})}return new Promise((de,ye)=>{this.b.then(de,ye)})}return this.a=J(),new Promise((de,ye)=>{this.a.then(Ne=>{this.a=null,de(Ne)},Ne=>{this.a=null,ye(Ne)})})}}e.Throttler=s;class l{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.Sequencer=l;class g{constructor(){this.a=new Map}queue(J,de){const Ne=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(J)===Ne&&this.a.delete(J)});return this.a.set(J,Ne),Ne}}e.SequencerByKey=g;const E=(X,J)=>{let de=!0;const ye=setTimeout(()=>{de=!1,J()},X);return{isTriggered:()=>de,dispose:()=>{clearTimeout(ye),de=!1}}},L=X=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,X())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class v{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,de=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((Ne,We)=>{this.d=Ne,this.f=We}).then(()=>{if(this.b=null,this.d=null,this.g){const Ne=this.g;return this.g=null,Ne()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=de===S.MicrotaskDelay?L(ye):E(de,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class t{constructor(J){this.a=new v(J),this.b=new s}trigger(J,de){return this.a.trigger(()=>this.b.queue(J),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class d{constructor(){this.a=!1,this.b=new Promise((J,de)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=d;class r extends d{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function u(X,J){return J?new Promise((de,ye)=>{const Ne=setTimeout(()=>{We.dispose(),de()},X),We=J.onCancellationRequested(()=>{clearTimeout(Ne),We.dispose(),ye(new C.CancellationError)})}):N(de=>u(X,de))}e.timeout=u;function n(X,J=0){const de=setTimeout(X,J);return(0,M.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=n;function p(X){const J=[];let de=0;const ye=X.length;function Ne(){return de<ye?X[de++]():null}function We(Pe){Pe!=null&&J.push(Pe);const Ce=Ne();return Ce?Ce.then(We):Promise.resolve(J)}return Promise.resolve(null).then(We)}e.sequence=p;function o(X,J=ye=>!!ye,de=null){let ye=0;const Ne=X.length,We=()=>{if(ye>=Ne)return Promise.resolve(de);const Pe=X[ye++];return Promise.resolve(Pe()).then(we=>J(we)?Promise.resolve(we):We())};return We()}e.first=o;function c(X,J=ye=>!!ye,de=null){if(X.length===0)return Promise.resolve(de);let ye=X.length;const Ne=()=>{ye=-1;for(const We of X)We.cancel?.()};return new Promise((We,Pe)=>{for(const Ce of X)Ce.then(we=>{--ye>=0&&J(we)?(Ne(),We(we)):ye===0&&We(de)}).catch(we=>{--ye>=0&&(Ne(),Pe(we))})})}e.firstParallel=c;class m{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((de,ye)=>{this.f.push({factory:J,c:de,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const de=J.factory();de.then(J.c,J.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class P extends m{constructor(){super(1)}}e.Queue=P;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const J=new ge;return this.b.add(J),J.p}d(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,de=y.extUri){const ye=de.getComparisonKey(J);let Ne=this.a.get(ye);return Ne||(Ne=new P,D.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(ye),this.f()}),this.a.set(ye,Ne)),Ne}f(){!this.d()||this.g()}g(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class V{constructor(J,de){this.a=-1,typeof J=="function"&&typeof de=="number"&&this.setIfNotSet(J,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},de)}setIfNotSet(J,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},de))}}e.TimeoutTimer=V;class _{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,de){this.cancel(),this.a=setInterval(()=>{J()},de)}}e.IntervalTimer=_;class K{constructor(J,de){this.b=-1,this.a=J,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class A{constructor(J,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=J,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=A;class U extends K{constructor(J,de){super(J,de),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=U;class R extends M.Disposable{constructor(J,de){super(),this.g=J,this.h=de,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of J)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,O.setTimeout0)(()=>{if(J)return;const de=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(X,J)=>{const de=requestIdleCallback(X,typeof J=="number"?{timeout:J}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(de))}}}}();class F{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function H(X,J,de){let ye;for(let Ne=0;Ne<de;Ne++)try{return await X()}catch(We){ye=We,await u(J)}throw ye}e.retry=H;class j{hasPending(J){return this.a?typeof J=="number"?this.a.taskId===J:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(J,de,ye){return this.a={taskId:J,cancel:()=>ye?.(),promise:de},de.then(()=>this.d(J),()=>this.d(J)),de}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this.b)this.b.run=J;else{let de,ye;const Ne=new Promise((We,Pe)=>{de=We,ye=Pe});this.b={run:J,promise:Ne,promiseResolve:de,promiseReject:ye}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class le{constructor(J,de=()=>Date.now()){this.d=J,this.f=de,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class ge{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((J,de)=>{this.a=J,this.b=de})}complete(J){return new Promise(de=>{this.a(J),this.f=!0,de()})}error(J){return new Promise(de=>{this.b(J),this.d=!0,de()})}cancel(){new Promise(J=>{this.b(new C.CancellationError),this.d=!0,J()})}}e.DeferredPromise=ge;var re;(function(X){async function J(ye){let Ne;const We=await Promise.all(ye.map(Pe=>Pe.then(Ce=>Ce,Ce=>{Ne||(Ne=Ce)})));if(typeof Ne<"u")throw Ne;return We}X.settled=J;function de(ye){return new Promise(async(Ne,We)=>{try{await ye(Ne,We)}catch(Pe){We(Pe)}})}X.withAsyncBody=de})(re=e.Promises||(e.Promises={}));var ae;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(ae||(ae={}));class ce{static fromArray(J){return new ce(de=>{de.emitMany(J)})}static fromPromise(J){return new ce(async de=>{de.emitMany(await J)})}static fromPromises(J){return new ce(async de=>{await Promise.all(J.map(async ye=>de.emitOne(await ye)))})}static merge(J){return new ce(async de=>{await Promise.all(J.map(async ye=>{for await(const Ne of ye)de.emitOne(Ne)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const de={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(J(de)),this.j()}catch(ye){this.k(ye)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(J,de){return new ce(async ye=>{for await(const Ne of J)ye.emitOne(de(Ne))})}map(J){return ce.map(this,J)}static filter(J,de){return new ce(async ye=>{for await(const Ne of J)de(Ne)&&ye.emitOne(Ne)})}filter(J){return ce.filter(this,J)}static coalesce(J){return ce.filter(J,de=>!!de)}coalesce(){return ce.coalesce(this)}static async toPromise(J){const de=[];for await(const ye of J)de.push(ye);return de}toPromise(){return ce.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}ce.EMPTY=ce.fromArray([]),e.AsyncIterableObject=ce;class Se extends ce{constructor(J,de){super(de),this.l=J}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Se;function x(X){const J=new i.CancellationTokenSource,de=X(J.token);return new Se(J,async ye=>{const Ne=J.token.onCancellationRequested(()=>{Ne.dispose(),J.dispose(),ye.reject(new C.CancellationError)});try{for await(const We of de){if(J.token.isCancellationRequested)return;ye.emitOne(We)}Ne.dispose(),J.dispose()}catch(We){Ne.dispose(),J.dispose(),ye.reject(We)}})}e.createCancelableAsyncIterable=x}),define(ke[35],Te([1,0,16,17,40,28,19,20,10]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",w="[^/\\\\]",h=/\//g;function b(le,ge){switch(le){case 0:return"";case 1:return`${w}*?`;default:return`(?:${N}|${w}+${N}${ge?`|${N}${w}+`:""})*?`}}function f(le,ge){if(!le)return[];const re=[];let ae=!1,ce=!1,Se="";for(const x of le){switch(x){case ge:if(!ae&&!ce){re.push(Se),Se="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}Se+=x}return Se&&re.push(Se),re}e.splitGlobAware=f;function a(le){if(!le)return"";let ge="";const re=f(le,e.GLOB_SPLIT);if(re.every(ae=>ae===e.GLOBSTAR))ge=".*";else{let ae=!1;re.forEach((ce,Se)=>{if(ce===e.GLOBSTAR){if(ae)return;ge+=b(2,Se===re.length-1)}else{let x=!1,X="",J=!1,de="";for(const ye of ce){if(ye!=="}"&&x){X+=ye;continue}if(J&&(ye!=="]"||!de)){let Ne;ye==="-"?Ne=ye:(ye==="^"||ye==="!")&&!de?Ne="^":ye===e.GLOB_SPLIT?Ne="":Ne=(0,S.escapeRegExpCharacters)(ye),de+=Ne;continue}switch(ye){case"{":x=!0;continue;case"[":J=!0;continue;case"}":{ge+=`(?:${f(X,",").map(Pe=>a(Pe)).join("|")})`,x=!1,X="";break}case"]":{ge+="["+de+"]",J=!1,de="";break}case"?":ge+=w;continue;case"*":ge+=b(1);continue;default:ge+=(0,S.escapeRegExpCharacters)(ye)}}Se<re.length-1&&(re[Se+1]!==e.GLOBSTAR||Se+2<re.length)&&(ge+=N)}ae=ce===e.GLOBSTAR})}return ge}const s=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,L=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),d=function(){return!1},r=function(){return null};function u(le,ge){if(!le)return r;let re;typeof le!="string"?re=le.pattern:re=le,re=re.trim();const ae=`${re}_${!!ge.trimForExclusions}`;let ce=t.get(ae);if(ce)return n(ce,le);let Se;return s.test(re)?ce=o(re.substr(4),re):(Se=l.exec(p(re,ge)))?ce=c(Se[1],re):(ge.trimForExclusions?E:g).test(re)?ce=m(re,ge):(Se=L.exec(p(re,ge)))?ce=P(Se[1].substr(1),re,!0):(Se=v.exec(p(re,ge)))?ce=P(Se[1],re,!1):ce=T(re),t.set(ae,ce),n(ce,le)}function n(le,ge){if(typeof ge=="string")return le;const re=function(ae,ce){return(0,D.isEqualOrParent)(ae,ge.base,!O.isLinux)?le((0,S.ltrim)(ae.substr(ge.base.length),y.sep),ce):null};return re.allBasenames=le.allBasenames,re.allPaths=le.allPaths,re.basenames=le.basenames,re.patterns=le.patterns,re}function p(le,ge){return ge.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function o(le,ge){return function(re,ae){return typeof re=="string"&&re.endsWith(le)?ge:null}}function c(le,ge){const re=`/${le}`,ae=`\\${le}`,ce=function(x,X){return typeof x!="string"?null:X?X===le?ge:null:x===le||x.endsWith(re)||x.endsWith(ae)?ge:null},Se=[le];return ce.basenames=Se,ce.patterns=[ge],ce.allBasenames=Se,ce}function m(le,ge){const re=H(le.slice(1,-1).split(",").map(X=>u(X,ge)).filter(X=>X!==r),le),ae=re.length;if(!ae)return r;if(ae===1)return re[0];const ce=function(X,J){for(let de=0,ye=re.length;de<ye;de++)if(re[de](X,J))return le;return null},Se=re.find(X=>!!X.allBasenames);Se&&(ce.allBasenames=Se.allBasenames);const x=re.reduce((X,J)=>J.allPaths?X.concat(J.allPaths):X,[]);return x.length&&(ce.allPaths=x),ce}function P(le,ge,re){const ae=y.sep===y.posix.sep,ce=ae?le:le.replace(h,y.sep),Se=y.sep+ce,x=y.posix.sep+le;let X;return re?X=function(J,de){return typeof J=="string"&&(J===ce||J.endsWith(Se)||!ae&&(J===le||J.endsWith(x)))?ge:null}:X=function(J,de){return typeof J=="string"&&(J===ce||!ae&&J===le)?ge:null},X.allPaths=[(re?"*/":"./")+le],X}function T(le){try{const ge=new RegExp(`^${a(le)}$`);return function(re){return ge.lastIndex=0,typeof re=="string"&&ge.test(re)?le:null}}catch{return r}}function V(le,ge,re){return!le||typeof ge!="string"?!1:_(le)(ge,void 0,re)}e.match=V;function _(le,ge={}){if(!le)return d;if(typeof le=="string"||K(le)){const re=u(le,ge);if(re===r)return d;const ae=function(ce,Se){return!!re(ce,Se)};return re.allBasenames&&(ae.allBasenames=re.allBasenames),re.allPaths&&(ae.allPaths=re.allPaths),ae}return R(le,ge)}e.parse=_;function K(le){const ge=le;return ge?typeof ge.base=="string"&&typeof ge.pattern=="string":!1}e.isRelativePattern=K;function A(le){return le.allBasenames||[]}e.getBasenameTerms=A;function U(le){return le.allPaths||[]}e.getPathTerms=U;function R(le,ge){const re=H(Object.getOwnPropertyNames(le).map(X=>F(X,le[X],ge)).filter(X=>X!==r)),ae=re.length;if(!ae)return r;if(!re.some(X=>!!X.requiresSiblings)){if(ae===1)return re[0];const X=function(ye,Ne){let We;for(let Pe=0,Ce=re.length;Pe<Ce;Pe++){const we=re[Pe](ye,Ne);if(typeof we=="string")return we;(0,C.isThenable)(we)&&(We||(We=[]),We.push(we))}return We?(async()=>{for(const Pe of We){const Ce=await Pe;if(typeof Ce=="string")return Ce}return null})():null},J=re.find(ye=>!!ye.allBasenames);J&&(X.allBasenames=J.allBasenames);const de=re.reduce((ye,Ne)=>Ne.allPaths?ye.concat(Ne.allPaths):ye,[]);return de.length&&(X.allPaths=de),X}const ce=function(X,J,de){let ye,Ne;for(let We=0,Pe=re.length;We<Pe;We++){const Ce=re[We];Ce.requiresSiblings&&de&&(J||(J=(0,y.basename)(X)),ye||(ye=J.substr(0,J.length-(0,y.extname)(X).length)));const we=Ce(X,J,ye,de);if(typeof we=="string")return we;(0,C.isThenable)(we)&&(Ne||(Ne=[]),Ne.push(we))}return Ne?(async()=>{for(const We of Ne){const Pe=await We;if(typeof Pe=="string")return Pe}return null})():null},Se=re.find(X=>!!X.allBasenames);Se&&(ce.allBasenames=Se.allBasenames);const x=re.reduce((X,J)=>J.allPaths?X.concat(J.allPaths):X,[]);return x.length&&(ce.allPaths=x),ce}function F(le,ge,re){if(ge===!1)return r;const ae=u(le,re);if(ae===r)return r;if(typeof ge=="boolean")return ae;if(ge){const ce=ge.when;if(typeof ce=="string"){const Se=(x,X,J,de)=>{if(!de||!ae(x,X))return null;const ye=ce.replace("$(basename)",()=>J),Ne=de(ye);return(0,C.isThenable)(Ne)?Ne.then(We=>We?le:null):Ne?le:null};return Se.requiresSiblings=!0,Se}}return ae}function H(le,ge){const re=le.filter(X=>!!X.basenames);if(re.length<2)return le;const ae=re.reduce((X,J)=>{const de=J.basenames;return de?X.concat(de):X},[]);let ce;if(ge){ce=[];for(let X=0,J=ae.length;X<J;X++)ce.push(ge)}else ce=re.reduce((X,J)=>{const de=J.patterns;return de?X.concat(de):X},[]);const Se=function(X,J){if(typeof X!="string")return null;if(!J){let ye;for(ye=X.length;ye>0;ye--){const Ne=X.charCodeAt(ye-1);if(Ne===47||Ne===92)break}J=X.substr(ye)}const de=ae.indexOf(J);return de!==-1?ce[de]:null};Se.basenames=ae,Se.patterns=ce,Se.allBasenames=ae;const x=le.filter(X=>!X.basenames);return x.push(Se),x}function j(le,ge){return(0,i.equals)(le,ge,(re,ae)=>typeof re=="string"&&typeof ae=="string"?re===ae:typeof re!="string"&&typeof ae!="string"?re.base===ae.base&&re.pattern===ae.pattern:!1)}e.patternsEquals=j}),define(ke[86],Te([1,0,12,126,24,10,2]),function(te,e,i,C,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var O;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(O=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(l="",g=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(l,g=0){return this.value+=h(this.supportThemeIcons?(0,C.escapeIcons)(l):l).replace(/([ \t]+)/g,(E,L)=>"&nbsp;".repeat(L.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,g){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(l,g,E){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(l),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(l,g){const E=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return l.replace(E,(L,v)=>l.charAt(v-1)!=="\\"?`\\${L}`:L)}}e.MarkdownString=S;function k(s){return N(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.isEmptyMarkdownString=k;function N(s){return s instanceof S?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function w(s,l){return s===l?!0:!s||!l?!1:s.value===l.value&&s.isTrusted===l.isTrusted&&s.supportThemeIcons===l.supportThemeIcons&&s.supportHtml===l.supportHtml&&(s.baseUri===l.baseUri||!!s.baseUri&&!!l.baseUri&&(0,D.isEqual)(y.URI.from(s.baseUri),y.URI.from(l.baseUri)))}e.markdownStringEqual=w;function h(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=h;function b(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function f(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function a(s){const l=[],g=s.split("|").map(L=>L.trim());s=g[0];const E=g[1];if(E){const L=/height=(\d+)/.exec(E),v=/width=(\d+)/.exec(E),t=L?L[1]:"",d=v?v[1]:"",r=isFinite(parseInt(d)),u=isFinite(parseInt(t));r&&l.push(`width="${d}"`),u&&l.push(`height="${t}"`)}return{href:s,dimensions:l}}e.parseHrefAndDimensions=a}),define(ke[87],Te([1,0,16,40,19,20,24,10]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,u){const{os:n,tildify:p,relative:o}=u;if(o){const P=k(r,o,n);if(typeof P=="string")return P}let c=r.fsPath;if(n===1&&!M.isWindows?c=c.replace(/\//g,"\\"):n!==1&&M.isWindows&&(c=c.replace(/\\/g,"/")),n!==1&&p?.userHome){const P=p.userHome.fsPath;let T;r.scheme!==p.userHome.scheme&&r.path.startsWith(D.posix.sep)?T=p.userHome.with({path:r.path}).fsPath:T=r.fsPath,c=h(T,P,n)}return(n===1?D.win32:D.posix).normalize(N(c,n===1))}e.getPathLabel=S;function k(r,u,n){const p=n===1?D.win32:D.posix,o=n===3?y.extUri:y.extUriIgnorePathCase,c=u.getWorkspace(),m=(0,i.firstOrDefault)(c.folders);if(!m)return;r.scheme!==m.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=m.uri.with({path:r.path}));const P=u.getWorkspaceFolder(r);if(!P)return;let T;if(o.isEqual(P.uri,r)?T="":T=o.relativePath(P.uri,r)??"",T&&(T=p.normalize(T)),c.folders.length>1&&!u.noPrefix){const V=P.name?P.name:o.basenameOrAuthority(P.uri);T=T?`${V} \u2022 ${T}`:V}return T}function N(r,u=M.isWindows){return(0,C.hasDriveLetter)(r,u)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=N;let w=Object.create(null);function h(r,u,n=M.OS){if(n===1||!r||!u)return r;let p=w.original===u?w.normalized:void 0;p||(p=u,M.isWindows&&(p=(0,C.toSlashes)(p)),p=`${(0,O.rtrim)(p,D.posix.sep)}${D.posix.sep}`,w={original:u,normalized:p});let o=r;return M.isWindows&&(o=(0,C.toSlashes)(o)),(n===3?o.startsWith(p):(0,O.startsWithIgnoreCase)(o,p))?`~/${o.substr(p.length)}`:r}e.tildify=h;function b(r,u){return r.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=b;const f="\u2026",a="\\\\",s="~";function l(r,u=D.sep){const n=new Array(r.length);let p=!1;for(let o=0;o<r.length;o++){const c=r[o];if(c===""){n[o]=`.${u}`;continue}if(!c){n[o]=c;continue}p=!0;let m="",P=c;P.indexOf(a)===0?(m=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length)):P.indexOf(u)===0?(m=P.substr(0,P.indexOf(u)+u.length),P=P.substr(P.indexOf(u)+u.length)):P.indexOf(s)===0&&(m=P.substr(0,P.indexOf(s)+s.length),P=P.substr(P.indexOf(s)+s.length));const T=P.split(u);for(let V=1;p&&V<=T.length;V++)for(let _=T.length-V;p&&_>=0;_--){p=!1;let K=T.slice(_,_+V).join(u);for(let A=0;!p&&A<r.length;A++)if(A!==o&&r[A]&&r[A].indexOf(K)>-1){const U=_+V===T.length,R=_>0&&r[A].indexOf(u)>-1?u+K:K,F=r[A].endsWith(R);p=!U||F}if(!p){let A="";(T[0].endsWith(":")||m!=="")&&(_===1&&(_=0,V++,K=T[0]+u+K),_>0&&(A=T[0]+u),A=m+A),_>0&&(A=A+f+u),A=A+K,_+V<T.length&&(A=A+u+f),n[o]=A}}p&&(n[o]=c)}return n}e.shorten=l;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(r,u=Object.create(null)){const n=[];let p=!1,o="";for(const c of r)if(c==="$"||p&&c==="{")o&&n.push({value:o,type:g.TEXT}),o="",p=!0;else if(c==="}"&&p){const m=u[o];if(typeof m=="string")m.length&&n.push({value:m,type:g.VARIABLE});else if(m){const P=n[n.length-1];(!P||P.type!==g.SEPARATOR)&&n.push({value:m.label,type:g.SEPARATOR})}o="",p=!1}else o+=c;return o&&!p&&n.push({value:o,type:g.TEXT}),n.filter((c,m)=>{if(c.type===g.SEPARATOR){const P=n[m-1],T=n[m+1];return[P,T].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=E;function L(r,u){return M.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,n=>n==="&"?"&&":"&")}e.mnemonicMenuLabel=L;function v(r,u){return M.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,n=>n==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(r){const u=r.indexOf("/")!==-1?D.posix:D.win32,n=u.basename(r),p=u.dirname(r);return n.length?{name:n,parentPath:p}:{name:p,parentPath:""}}e.splitName=d}),define(ke[127],Te([1,0,23,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(w){return w.toJSON()}class M{constructor(h){this.a=h}transformIncoming(h){const b=this.a.transformIncoming(h);return b===h?h:D(C.URI.from(b))}transformOutgoing(h){const b=this.a.transformOutgoing(h);return b===h?h:D(C.URI.from(b))}transformOutgoingURI(h){const b=this.a.transformOutgoing(h);return b===h?h:C.URI.from(b)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function y(w,h,b){if(!w||b>200)return null;if(typeof w=="object"){if(w instanceof C.URI)return h.transformOutgoing(w);for(const f in w)if(Object.hasOwnProperty.call(w,f)){const a=y(w[f],h,b+1);a!==null&&(w[f]=a)}}return null}function O(w,h){const b=y(w,h,0);return b===null?w:b}e.transformOutgoingURIs=O;function S(w,h,b,f){if(!w||f>200)return null;if(typeof w=="object"){if(w.$mid===1)return b?C.URI.revive(h.transformIncoming(w)):h.transformIncoming(w);if(w instanceof i.VSBuffer)return null;for(const a in w)if(Object.hasOwnProperty.call(w,a)){const s=S(w[a],h,b,f+1);s!==null&&(w[a]=s)}}return null}function k(w,h){const b=S(w,h,!1,0);return b===null?w:b}e.transformIncomingURIs=k;function N(w,h){const b=S(w,h,!0,0);return b===null?w:b}e.transformAndReviveIncomingURIs=N}),define(ke[128],Te([1,0,35,19]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(M,y,O,S,k,N){if(Array.isArray(M)){let w=0;for(const h of M){const b=D(h,y,O,S,k,N);if(b===10)return b;b>w&&(w=b)}return w}else{if(typeof M=="string")return S?M==="*"?5:M===O?10:0:0;if(M){const{language:w,pattern:h,scheme:b,hasAccessToAllModels:f,notebookType:a}=M;if(!S&&!f)return 0;a&&k&&(y=k);let s=0;if(b)if(b===y.scheme)s=10;else if(b==="*")s=5;else return 0;if(w)if(w===O)s=10;else if(w==="*")s=Math.max(s,5);else return 0;if(a)if(a===N)s=10;else if(a==="*"&&N!==void 0)s=Math.max(s,5);else return 0;if(h){let l;if(typeof h=="string"?l=h:l={...h,base:(0,C.normalize)(h.base)},l===y.fsPath||(0,i.match)(l,y.fsPath))s=10;else return 0}return s}else return 0}}e.score=D}),define(ke[88],Te([1,0,23,20]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(D||(D={}));function M(w){for(let h=0,b=w.length;h<b;h+=4){const f=w[h+0],a=w[h+1],s=w[h+2],l=w[h+3];w[h+0]=l,w[h+1]=s,w[h+2]=a,w[h+3]=f}}function y(w){const h=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||M(h),i.VSBuffer.wrap(h)}function O(w){const h=w.buffer;if(C.isLittleEndian()||M(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const b=new Uint8Array(h.byteLength);return b.set(h),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(w){const h=new Uint32Array(k(w));let b=0;if(h[b++]=w.id,w.type==="full")h[b++]=1,h[b++]=w.data.length,h.set(w.data,b),b+=w.data.length;else{h[b++]=2,h[b++]=w.deltas.length;for(const f of w.deltas)h[b++]=f.start,h[b++]=f.deleteCount,f.data?(h[b++]=f.data.length,h.set(f.data,b),b+=f.data.length):h[b++]=0}return y(h)}e.encodeSemanticTokensDto=S;function k(w){let h=0;if(h+=1+1,w.type==="full")h+=1+w.data.length;else{h+=1,h+=(1+1+1)*w.deltas.length;for(const b of w.deltas)b.data&&(h+=b.data.length)}return h}function N(w){const h=O(w);let b=0;const f=h[b++];if(h[b++]===1){const g=h[b++],E=h.subarray(b,b+g);return b+=g,{id:f,type:"full",data:E}}const s=h[b++],l=[];for(let g=0;g<s;g++){const E=h[b++],L=h[b++],v=h[b++];let t;v>0&&(t=h.subarray(b,b+v),b+=v),l[g]={start:E,deleteCount:L,data:t}}return{id:f,type:"delta",deltas:l}}e.decodeSemanticTokensDto=N}),define(ke[129],Te([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ke[130],Te([1,0,129,20,131,16,22,117]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class w{constructor(Q,pe,Me,ze){this.id=Q,this.name=pe,this.defaultValue=Me,this.schema=ze}applyUpdate(Q,pe){return b(Q,pe)}compute(Q,pe,Me){return Me}}class h{constructor(Q,pe){this.newValue=Q,this.didChange=pe}}e.ApplyUpdateResult=h;function b(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new h(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Me=Array.isArray(Y)&&Array.isArray(Q)&&M.equals(Y,Q);return new h(Q,!Me)}let pe=!1;for(const Me in Q)if(Q.hasOwnProperty(Me)){const ze=b(Y[Me],Q[Me]);ze.didChange&&(Y[Me]=ze.newValue,pe=!0)}return new h(Y,pe)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,pe){return b(Q,pe)}validate(Q){return this.defaultValue}}class a{constructor(Q,pe,Me,ze){this.id=Q,this.name=pe,this.defaultValue=Me,this.schema=ze}applyUpdate(Q,pe){return b(Q,pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,pe,Me){return Me}}function s(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:Boolean(Y)}e.boolean=s;class l extends a{constructor(Q,pe,Me,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Me),super(Q,pe,Me,ze)}validate(Q){return s(Q,this.defaultValue)}}function g(Y,Q,pe,Me){if(typeof Y>"u")return Q;let ze=parseInt(Y,10);return isNaN(ze)?Q:(ze=Math.max(pe,ze),ze=Math.min(Me,ze),ze|0)}e.clampedInt=g;class E extends a{static clampedInt(Q,pe,Me,ze){return g(Q,pe,Me,ze)}constructor(Q,pe,Me,ze,Ve,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Me,Ye.minimum=ze,Ye.maximum=Ve),super(Q,pe,Me,Ye),this.minimum=ze,this.maximum=Ve}validate(Q){return E.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class L extends a{static clamp(Q,pe,Me){return Q<pe?pe:Q>Me?Me:Q}static float(Q,pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return pe;const Me=parseFloat(Q);return isNaN(Me)?pe:Me}constructor(Q,pe,Me,ze,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Me),super(Q,pe,Me,Ve),this.validationFn=ze}validate(Q){return this.validationFn(L.float(Q,this.defaultValue))}}class v extends a{static string(Q,pe){return typeof Q!="string"?pe:Q}constructor(Q,pe,Me,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Me),super(Q,pe,Me,ze)}validate(Q){return v.string(Q,this.defaultValue)}}function t(Y,Q,pe){return typeof Y!="string"||pe.indexOf(Y)===-1?Q:Y}e.stringSet=t;class d extends a{constructor(Q,pe,Me,ze,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=ze,Ve.default=Me),super(Q,pe,Me,Ve),this.c=ze}validate(Q){return t(Q,this.defaultValue,this.c)}}class r extends w{constructor(Q,pe,Me,ze,Ve,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ve,nt.default=ze),super(Q,pe,Me,nt),this.c=Ve,this.d=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function u(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,pe,Me){return Me===0?Q.accessibilitySupport:Me}}class p extends w{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertSpace:s(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(Y){switch(Y){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function T(Y){switch(Y){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class V extends f{constructor(){super(135)}compute(Q,pe,Me){const ze=["monaco-editor"];return pe.get(36)&&ze.push(pe.get(36)),Q.extraEditorClassName&&ze.push(Q.extraEditorClassName),pe.get(70)==="default"?ze.push("mouse-default"):pe.get(70)==="copy"&&ze.push("mouse-copy"),pe.get(105)&&ze.push("showUnused"),pe.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class _ extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Q,pe,Me){return Me&&Q.emptySelectionClipboard}}class K extends w{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:i.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:i.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{cursorMoveOnType:s(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(pe.loop,this.defaultValue.loop)}}}class A extends w{constructor(){super(48,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?A.OFF:Q==="true"?A.ON:Q:Boolean(Q)?A.ON:A.OFF}}A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on',e.EditorFontLigatures=A;class U extends w{constructor(){super(51,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?U.OFF:Q==="true"?U.TRANSLATE:Q:Boolean(Q)?U.TRANSLATE:U.OFF}compute(Q,pe,Me){return Q.fontInfo.fontVariationSettings}}U.OFF="normal",U.TRANSLATE="translate",e.EditorFontVariations=U;class R extends f{constructor(){super(47)}compute(Q,pe,Me){return Q.fontInfo}}class F extends a{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(Q){const pe=L.float(Q,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:L.clamp(pe,6,100)}compute(Q,pe,Me){return Q.fontInfo.fontSize}}class H extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(E.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}H.c=["normal","bold","100","200","300","400","500","600","700","800","900"],H.d=1,H.e=1e3;class j extends w{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Me,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Me,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Me,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Me,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Me,description:i.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{multiple:t(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??t(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??t(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??t(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??t(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??t(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends w{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:i.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:s(pe.enabled,this.defaultValue.enabled),delay:E.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:s(pe.sticky,this.defaultValue.sticky),above:s(pe.above,this.defaultValue.above)}}}var ge;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ge=e.RenderMinimap||(e.RenderMinimap={}));class re extends f{constructor(){super(138)}compute(Q,pe,Me){return re.computeLayout(pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const pe=Q.height/Q.lineHeight,Me=Math.floor(Q.paddingTop/Q.lineHeight);let ze=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(ze=Math.max(ze,pe-1));const Ve=(Me+Q.viewLineCount+ze)/(Q.pixelRatio*Q.height),Ye=Math.floor(Q.viewLineCount/Ve);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:ze,desiredRatio:Ve,minimapLineCount:Ye}}static c(Q,pe){const Me=Q.outerWidth,ze=Q.outerHeight,Ve=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=pe.stableMinimapLayoutInput,nt=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.paddingTop===Ye.paddingTop&&Q.paddingBottom===Ye.paddingBottom&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,vt=Q.lineHeight,wt=Q.typicalHalfwidthCharacterWidth,Ct=Q.scrollBeyondLastLine,jt=Q.minimap.renderCharacters;let rt=Ve>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const mt=Q.minimap.maxColumn,Ft=Q.minimap.size,Gt=Q.minimap.side,Pt=Q.verticalScrollbarWidth,ht=Q.viewLineCount,kt=Q.remainingWidth,Bt=Q.isViewportWrapping,Ot=jt?2:3;let Ge=Math.floor(Ve*ze);const Nt=Ge/Ve;let Mt=!1,zt=!1,ft=Ot*rt,Ie=rt/Ve,Ae=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:Tt,desiredRatio:bt,minimapLineCount:Et}=re.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ct,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:ze,lineHeight:vt,pixelRatio:Ve});if(ht/Et>1)Mt=!0,zt=!0,rt=1,ft=1,Ie=rt/Ve;else{let St=!1,yt=rt+1;if(Ft==="fit"){const qt=Math.ceil((ct+ht+Tt)*ft);Bt&&nt&&kt<=pe.stableFitRemainingWidth?(St=!0,yt=pe.stableFitMaxMinimapScale):St=qt>Ge}if(Ft==="fill"||St){Mt=!0;const qt=rt;ft=Math.min(vt*Ve,Math.max(1,Math.floor(1/bt))),Bt&&nt&&kt<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(ft/Ot))),rt>qt&&(Ae=Math.min(2,rt/qt)),Ie=rt/Ve/Ae,Ge=Math.ceil(Math.max(Ze,ct+ht+Tt)*ft),Bt?(pe.stableMinimapLayoutInput=Q,pe.stableFitRemainingWidth=kt,pe.stableFitMaxMinimapScale=rt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const me=Math.floor(mt*Ie),G=Math.min(me,Math.max(0,Math.floor((kt-Pt-2)*Ie/(wt+Ie)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ve*G);const Be=Re/Ve;Re=Math.floor(Re*Ae);const Qe=jt?1:2,$e=Gt==="left"?0:Me-G-Pt;return{renderMinimap:Qe,minimapLeft:$e,minimapWidth:G,minimapHeightIsEditorHeight:Mt,minimapIsSampling:zt,minimapScale:rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Be,minimapCanvasOuterHeight:Nt}}static computeLayout(Q,pe){const Me=pe.outerWidth|0,ze=pe.outerHeight|0,Ve=pe.lineHeight|0,Ye=pe.lineNumbersDigitCount|0,nt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,wt=pe.pixelRatio,Ct=pe.viewLineCount,jt=Q.get(130),rt=jt==="inherit"?Q.get(129):jt,mt=rt==="inherit"?Q.get(125):rt,Ft=Q.get(128),Gt=pe.isDominatedByLongLines,Pt=Q.get(54),ht=Q.get(64).renderType!==0,kt=Q.get(65),Bt=Q.get(99),Ot=Q.get(80),Ge=Q.get(69),Nt=Q.get(97),Mt=Nt.verticalScrollbarSize,zt=Nt.verticalHasArrows,ft=Nt.arrowSize,Ie=Nt.horizontalScrollbarSize,Ae=Q.get(40),me=Q.get(104)!=="never";let G=Q.get(62);Ae&&me&&(G+=16);let Re=0;if(ht){const pt=Math.max(Ye,kt);Re=Math.round(pt*vt)}let Be=0;Pt&&(Be=Ve);let Qe=0,$e=Qe+Be,Ze=$e+Re,ct=Ze+G;const Tt=Me-Be-Re-G;let bt=!1,Et=!1,It=-1;rt==="inherit"&&Gt?(bt=!0,Et=!0):mt==="on"||mt==="bounded"?Et=!0:mt==="wordWrapColumn"&&(It=Ft);const St=re.c({outerWidth:Me,outerHeight:ze,lineHeight:Ve,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:Bt,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:Ge,verticalScrollbarWidth:Mt,viewLineCount:Ct,remainingWidth:Tt,isViewportWrapping:Et},pe.memory||new N);St.renderMinimap!==0&&St.minimapLeft===0&&(Qe+=St.minimapWidth,$e+=St.minimapWidth,Ze+=St.minimapWidth,ct+=St.minimapWidth);const yt=Tt-St.minimapWidth,qt=Math.max(1,Math.floor((yt-Mt-2)/nt)),Jt=zt?ft:0;return Et&&(It=Math.max(1,qt),mt==="bounded"&&(It=Math.min(It,Ft))),{width:Me,height:ze,glyphMarginLeft:Qe,glyphMarginWidth:Be,lineNumbersLeft:$e,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:G,contentLeft:ct,contentWidth:yt,minimap:St,viewportColumn:qt,isWordWrapMinified:bt,isViewportWrapping:Et,wrappingColumn:It,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:Ie,overviewRuler:{top:Jt,width:Mt,height:ze-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=re;class ae extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(Q){return t(Q,"simple",["simple","advanced"])}compute(Q,pe,Me){return pe.get(2)===2?"advanced":Me}}class ce extends w{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:i.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}class Se extends w{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:s(pe.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class x extends w{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:i.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:t(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(pe.fontFamily,this.defaultValue.fontFamily),padding:s(pe.padding,this.defaultValue.padding)}}}class X extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):E.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,pe,Me){return Me<0?E.clampedInt(-Me*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class J extends L{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>L.clamp(Q,0,150),{markdownDescription:i.localize(60,null)})}compute(Q,pe,Me){return Q.fontInfo.lineHeight}}class de extends w{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:Q.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:i.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:s(pe.enabled,this.defaultValue.enabled),autohide:s(pe.autohide,this.defaultValue.autohide),size:t(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(pe.side,this.defaultValue.side,["right","left"]),showSlider:t(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(pe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(pe.scale,1,1,3),maxColumn:E.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(Y){return Y==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ne extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{top:E.clampedInt(pe.top,0,0,1e3),bottom:E.clampedInt(pe.bottom,0,0,1e3)}}}class We extends w{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:i.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:s(pe.enabled,this.defaultValue.enabled),cycle:s(pe.cycle,this.defaultValue.cycle)}}}class Pe extends f{constructor(){super(136)}compute(Q,pe,Me){return Q.pixelRatio}}class Ce extends w{constructor(){const Q={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Q.strings,description:i.localize(79,null)},comments:{anyOf:pe,default:Q.comments,description:i.localize(80,null)},other:{anyOf:pe,default:Q.other,description:i.localize(81,null)}},default:Q,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const wt=Q?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:pe,comments:Me,strings:ze}=Q,Ve=["on","inline","off"];let Ye,nt,vt;return typeof pe=="boolean"?Ye=pe?"on":"off":Ye=t(pe,this.defaultValue.other,Ve),typeof Me=="boolean"?nt=Me?"on":"off":nt=t(Me,this.defaultValue.comments,Ve),typeof ze=="boolean"?vt=ze?"on":"off":vt=t(ze,this.defaultValue.strings,Ve),{other:Ye,comments:nt,strings:vt}}}var we;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(Q){let pe=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(pe=4,Me=Q):Q==="interval"?pe=3:Q==="relative"?pe=2:Q==="on"?pe=1:pe=0),{renderType:pe,renderFn:Me}}}function ue(Y){const Q=Y.get(92);return Q==="editable"?Y.get(86):Q!=="on"}e.filterValidationDecorations=ue;class Z extends w{constructor(){const Q=[],pe={type:"number",description:i.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:Q,description:i.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const pe=[];for(const Me of Q)if(typeof Me=="number")pe.push({column:E.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const ze=Me;pe.push({column:E.clampedInt(ze.column,0,0,1e4),color:ze.color})}return pe.sort((Me,ze)=>Me.column-ze.column),pe}return this.defaultValue}}function I(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends w{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:i.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q,Me=E.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=E.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(pe.vertical,this.defaultValue.vertical),horizontal:I(pe.horizontal,this.defaultValue.horizontal),useShadows:s(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:E.clampedInt(pe.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:E.clampedInt(pe.verticalSliderSize,ze,0,1e3),scrollByPage:s(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends w{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:i.localize(108,null)}})}applyUpdate(Q,pe){let Me=!1;pe.allowedCharacters&&Q&&(y.equals(Q.allowedCharacters,pe.allowedCharacters)||(Q={...Q,allowedCharacters:pe.allowedCharacters},Me=!0)),pe.allowedLocales&&Q&&(y.equals(Q.allowedLocales,pe.allowedLocales)||(Q={...Q,allowedLocales:pe.allowedLocales},Me=!0));const ze=super.applyUpdate(Q,pe);return Me?new h(ze.newValue,!0):ze}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{nonBasicASCII:De(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:De(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:De(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,pe){if(typeof Q!="object"||!Q)return pe;const Me={};for(const[ze,Ve]of Object.entries(Q))Ve===!0&&(Me[ze]=!0);return Me}}class q extends w{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:i.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[i.localize(110,null),i.localize(111,null)],description:i.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:s(pe.enabled,this.defaultValue.enabled),mode:t(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ee extends w{constructor(){const Q={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:i.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:s(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends w{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(115,null),i.localize(116,null),i.localize(117,null)],default:Q.bracketPairs,description:i.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(119,null),i.localize(120,null),i.localize(121,null)],default:Q.bracketPairsHorizontal,description:i.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:i.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:i.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(125,null),i.localize(126,null),i.localize(127,null)],default:Q.highlightActiveIndentation,description:i.localize(128,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{bracketPairs:De(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:De(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:De(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function De(Y,Q,pe){const Me=pe.indexOf(Y);return Me===-1?Q:pe[Me]}class oe extends w{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(129,null),i.localize(130,null)],default:Q.insertMode,description:i.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:i.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:i.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:i.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[i.localize(135,null),i.localize(136,null),i.localize(137,null),i.localize(138,null)],default:Q.selectionMode,markdownDescription:i.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:i.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:i.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:i.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:i.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:i.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(176,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertMode:t(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(pe.showIcons,this.defaultValue.showIcons),showStatusBar:s(pe.showStatusBar,this.defaultValue.showStatusBar),preview:s(pe.preview,this.defaultValue.preview),previewMode:t(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(pe.showMethods,this.defaultValue.showMethods),showFunctions:s(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:s(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(pe.showFields,this.defaultValue.showFields),showVariables:s(pe.showVariables,this.defaultValue.showVariables),showClasses:s(pe.showClasses,this.defaultValue.showClasses),showStructs:s(pe.showStructs,this.defaultValue.showStructs),showInterfaces:s(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:s(pe.showModules,this.defaultValue.showModules),showProperties:s(pe.showProperties,this.defaultValue.showProperties),showEvents:s(pe.showEvents,this.defaultValue.showEvents),showOperators:s(pe.showOperators,this.defaultValue.showOperators),showUnits:s(pe.showUnits,this.defaultValue.showUnits),showValues:s(pe.showValues,this.defaultValue.showValues),showConstants:s(pe.showConstants,this.defaultValue.showConstants),showEnums:s(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:s(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(pe.showKeywords,this.defaultValue.showKeywords),showWords:s(pe.showWords,this.defaultValue.showWords),showColors:s(pe.showColors,this.defaultValue.showColors),showFiles:s(pe.showFiles,this.defaultValue.showFiles),showReferences:s(pe.showReferences,this.defaultValue.showReferences),showFolders:s(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:s(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(pe.showSnippets,this.defaultValue.showSnippets),showUsers:s(pe.showUsers,this.defaultValue.showUsers),showIssues:s(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(177,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends f{constructor(){super(137)}compute(Q,pe,Me){return pe.get(86)?!0:Q.tabFocusMode}}var He;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(He=e.WrappingIndent||(e.WrappingIndent={}));class qe extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(178,null),i.localize(179,null),i.localize(180,null),i.localize(181,null)],description:i.localize(182,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,pe,Me){return pe.get(2)===2?0:Me}}class tt extends f{constructor(){super(139)}compute(Q,pe,Me){const ze=pe.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Xe extends w{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(183,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?it:C.isLinux?dt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ot;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.autoClosingBrackets=5]="autoClosingBrackets",Y[Y.autoClosingDelete=6]="autoClosingDelete",Y[Y.autoClosingOvertype=7]="autoClosingOvertype",Y[Y.autoClosingQuotes=8]="autoClosingQuotes",Y[Y.autoIndent=9]="autoIndent",Y[Y.automaticLayout=10]="automaticLayout",Y[Y.autoSurround=11]="autoSurround",Y[Y.bracketPairColorization=12]="bracketPairColorization",Y[Y.guides=13]="guides",Y[Y.codeLens=14]="codeLens",Y[Y.codeLensFontFamily=15]="codeLensFontFamily",Y[Y.codeLensFontSize=16]="codeLensFontSize",Y[Y.colorDecorators=17]="colorDecorators",Y[Y.colorDecoratorsLimit=18]="colorDecoratorsLimit",Y[Y.columnSelection=19]="columnSelection",Y[Y.comments=20]="comments",Y[Y.contextmenu=21]="contextmenu",Y[Y.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=23]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=25]="cursorStyle",Y[Y.cursorSurroundingLines=26]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=28]="cursorWidth",Y[Y.disableLayerHinting=29]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Y[Y.domReadOnly=31]="domReadOnly",Y[Y.dragAndDrop=32]="dragAndDrop",Y[Y.dropIntoEditor=33]="dropIntoEditor",Y[Y.emptySelectionClipboard=34]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=36]="extraEditorClassName",Y[Y.fastScrollSensitivity=37]="fastScrollSensitivity",Y[Y.find=38]="find",Y[Y.fixedOverflowWidgets=39]="fixedOverflowWidgets",Y[Y.folding=40]="folding",Y[Y.foldingStrategy=41]="foldingStrategy",Y[Y.foldingHighlight=42]="foldingHighlight",Y[Y.foldingImportsByDefault=43]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=44]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=46]="fontFamily",Y[Y.fontInfo=47]="fontInfo",Y[Y.fontLigatures=48]="fontLigatures",Y[Y.fontSize=49]="fontSize",Y[Y.fontWeight=50]="fontWeight",Y[Y.fontVariations=51]="fontVariations",Y[Y.formatOnPaste=52]="formatOnPaste",Y[Y.formatOnType=53]="formatOnType",Y[Y.glyphMargin=54]="glyphMargin",Y[Y.gotoLocation=55]="gotoLocation",Y[Y.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Y[Y.hover=57]="hover",Y[Y.inDiffEditor=58]="inDiffEditor",Y[Y.inlineSuggest=59]="inlineSuggest",Y[Y.letterSpacing=60]="letterSpacing",Y[Y.lightbulb=61]="lightbulb",Y[Y.lineDecorationsWidth=62]="lineDecorationsWidth",Y[Y.lineHeight=63]="lineHeight",Y[Y.lineNumbers=64]="lineNumbers",Y[Y.lineNumbersMinChars=65]="lineNumbersMinChars",Y[Y.linkedEditing=66]="linkedEditing",Y[Y.links=67]="links",Y[Y.matchBrackets=68]="matchBrackets",Y[Y.minimap=69]="minimap",Y[Y.mouseStyle=70]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=72]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=74]="multiCursorModifier",Y[Y.multiCursorPaste=75]="multiCursorPaste",Y[Y.multiCursorLimit=76]="multiCursorLimit",Y[Y.occurrencesHighlight=77]="occurrencesHighlight",Y[Y.overviewRulerBorder=78]="overviewRulerBorder",Y[Y.overviewRulerLanes=79]="overviewRulerLanes",Y[Y.padding=80]="padding",Y[Y.parameterHints=81]="parameterHints",Y[Y.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=84]="quickSuggestions",Y[Y.quickSuggestionsDelay=85]="quickSuggestionsDelay",Y[Y.readOnly=86]="readOnly",Y[Y.renameOnType=87]="renameOnType",Y[Y.renderControlCharacters=88]="renderControlCharacters",Y[Y.renderFinalNewline=89]="renderFinalNewline",Y[Y.renderLineHighlight=90]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=92]="renderValidationDecorations",Y[Y.renderWhitespace=93]="renderWhitespace",Y[Y.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Y[Y.roundedSelection=95]="roundedSelection",Y[Y.rulers=96]="rulers",Y[Y.scrollbar=97]="scrollbar",Y[Y.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=99]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=100]="scrollPredominantAxis",Y[Y.selectionClipboard=101]="selectionClipboard",Y[Y.selectionHighlight=102]="selectionHighlight",Y[Y.selectOnLineNumbers=103]="selectOnLineNumbers",Y[Y.showFoldingControls=104]="showFoldingControls",Y[Y.showUnused=105]="showUnused",Y[Y.snippetSuggestions=106]="snippetSuggestions",Y[Y.smartSelect=107]="smartSelect",Y[Y.smoothScrolling=108]="smoothScrolling",Y[Y.stickyScroll=109]="stickyScroll",Y[Y.stickyTabStops=110]="stickyTabStops",Y[Y.stopRenderingLineAfter=111]="stopRenderingLineAfter",Y[Y.suggest=112]="suggest",Y[Y.suggestFontSize=113]="suggestFontSize",Y[Y.suggestLineHeight=114]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Y[Y.suggestSelection=116]="suggestSelection",Y[Y.tabCompletion=117]="tabCompletion",Y[Y.tabIndex=118]="tabIndex",Y[Y.unicodeHighlighting=119]="unicodeHighlighting",Y[Y.unusualLineTerminators=120]="unusualLineTerminators",Y[Y.useShadowDOM=121]="useShadowDOM",Y[Y.useTabStops=122]="useTabStops",Y[Y.wordBreak=123]="wordBreak",Y[Y.wordSeparators=124]="wordSeparators",Y[Y.wordWrap=125]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=128]="wordWrapColumn",Y[Y.wordWrapOverride1=129]="wordWrapOverride1",Y[Y.wordWrapOverride2=130]="wordWrapOverride2",Y[Y.wrappingIndent=131]="wrappingIndent",Y[Y.wrappingStrategy=132]="wrappingStrategy",Y[Y.showDeprecated=133]="showDeprecated",Y[Y.inlayHints=134]="inlayHints",Y[Y.editorClassName=135]="editorClassName",Y[Y.pixelRatio=136]="pixelRatio",Y[Y.tabFocusMode=137]="tabFocusMode",Y[Y.layoutInfo=138]="layoutInfo",Y[Y.wrappingInfo=139]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(184,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(185,null),""],markdownDescription:i.localize(186,null)})),accessibilitySupport:Fe(new n),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(187,null),tags:["accessibility"]})),ariaLabel:Fe(new v(4,"ariaLabel",i.localize(188,null))),autoClosingBrackets:Fe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(189,null),i.localize(190,null),""],description:i.localize(191,null)})),autoClosingDelete:Fe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(192,null),""],description:i.localize(193,null)})),autoClosingOvertype:Fe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(194,null),""],description:i.localize(195,null)})),autoClosingQuotes:Fe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(196,null),i.localize(197,null),""],description:i.localize(198,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[i.localize(199,null),i.localize(200,null),i.localize(201,null),i.localize(202,null),i.localize(203,null)],description:i.localize(204,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(205,null),i.localize(206,null),i.localize(207,null),""],description:i.localize(208,null)})),bracketPairColorization:Fe(new ee),bracketPairGuides:Fe(new fe),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:i.localize(209,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:i.localize(210,null)})),codeLensFontFamily:Fe(new v(15,"codeLensFontFamily","",{description:i.localize(211,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(212,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:i.localize(213,null)})),colorDecoratorsLimit:Fe(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(214,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:i.localize(215,null)})),comments:Fe(new p),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(216,null)})),cursorBlinking:Fe(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:i.localize(217,null)})),cursorSmoothCaretAnimation:Fe(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(218,null),i.localize(219,null),i.localize(220,null)],description:i.localize(221,null)})),cursorStyle:Fe(new r(25,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:i.localize(222,null)})),cursorSurroundingLines:Fe(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(223,null)})),cursorSurroundingLinesStyle:Fe(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(224,null),i.localize(225,null)],description:i.localize(226,null)})),cursorWidth:Fe(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(227,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:i.localize(228,null)})),emptySelectionClipboard:Fe(new _),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new Se),experimentalWhitespaceRendering:Fe(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(229,null),i.localize(230,null),i.localize(231,null)],description:i.localize(232,null)})),extraEditorClassName:Fe(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new L(37,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:i.localize(233,null)})),find:Fe(new K),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:i.localize(234,null)})),foldingStrategy:Fe(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(235,null),i.localize(236,null)],description:i.localize(237,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:i.localize(238,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:i.localize(239,null)})),foldingMaximumRegions:Fe(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(240,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(241,null)})),fontFamily:Fe(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(242,null)})),fontInfo:Fe(new R),fontLigatures2:Fe(new A),fontSize:Fe(new F),fontWeight:Fe(new H),fontVariations:Fe(new U),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:i.localize(243,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:i.localize(244,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:i.localize(245,null)})),gotoLocation:Fe(new j),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:i.localize(246,null)})),hover:Fe(new le),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new L(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>L.clamp(Y,-5,20),{description:i.localize(247,null)})),lightbulb:Fe(new ce),lineDecorationsWidth:Fe(new X),lineHeight:Fe(new J),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:i.localize(248,null)})),links:Fe(new l(67,"links",!0,{description:i.localize(249,null)})),matchBrackets:Fe(new d(68,"matchBrackets","always",["always","near","never"],{description:i.localize(250,null)})),minimap:Fe(new de),mouseStyle:Fe(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new L(71,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:i.localize(251,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(252,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:i.localize(253,null)})),multiCursorModifier:Fe(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[i.localize(254,null),i.localize(255,null)],markdownDescription:i.localize(256,null)})),multiCursorPaste:Fe(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(257,null),i.localize(258,null)],markdownDescription:i.localize(259,null)})),multiCursorLimit:Fe(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(260,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:i.localize(261,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:i.localize(262,null)})),overviewRulerLanes:Fe(new E(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Ne),parameterHints:Fe(new We),peekWidgetDefaultFocus:Fe(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(263,null),i.localize(264,null)],description:i.localize(265,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:i.localize(266,null)})),quickSuggestions:Fe(new Ce),quickSuggestionsDelay:Fe(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(267,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:i.localize(268,null),markdownDeprecationMessage:i.localize(269,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:i.localize(270,null),restricted:!0})),renderFinalNewline:Fe(new d(89,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(271,null)})),renderLineHighlight:Fe(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(272,null)],description:i.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(274,null)})),renderValidationDecorations:Fe(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(275,null),i.localize(276,null),i.localize(277,null),""],description:i.localize(278,null)})),revealHorizontalRightPadding:Fe(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:i.localize(279,null)})),rulers:Fe(new Z),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(280,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:i.localize(281,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:i.localize(282,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:i.localize(283,null),included:C.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:i.localize(284,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(285,null),i.localize(286,null),i.localize(287,null)],description:i.localize(288,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:i.localize(289,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:i.localize(290,null)})),inlayHints:Fe(new x),snippetSuggestions:Fe(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(291,null),i.localize(292,null),i.localize(293,null),i.localize(294,null)],description:i.localize(295,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:i.localize(296,null)})),stopRenderingLineAfter:Fe(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new oe),inlineSuggest:Fe(new q),suggestFontSize:Fe(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:i.localize(299,null)})),suggestSelection:Fe(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(300,null),i.localize(301,null),i.localize(302,null)],description:i.localize(303,null)})),tabCompletion:Fe(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(304,null),i.localize(305,null),i.localize(306,null)],description:i.localize(307,null)})),tabIndex:Fe(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(308,null),i.localize(309,null),i.localize(310,null)],description:i.localize(311,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:i.localize(312,null)})),wordBreak:Fe(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(313,null),i.localize(314,null)],description:i.localize(315,null)})),wordSeparators:Fe(new v(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:i.localize(316,null)})),wordWrap:Fe(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(317,null),i.localize(318,null),i.localize(319,null),i.localize(320,null)],description:i.localize(321,null)})),wordWrapBreakAfterCharacters:Fe(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(322,null)})),wordWrapOverride1:Fe(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new V),pixelRatio:Fe(new Pe),tabFocusMode:Fe(new be),layoutInfo:Fe(new re),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new qe),wrappingStrategy:Fe(new ae)}}),define(ke[132],Te([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[133],Te([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[134],Te([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[135],Te([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ke[136],Te([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ke[137],Te([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[138],Te([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ke[139],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[140],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[141],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[142],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[143],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[144],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[145],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[146],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[147],Te([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ke[148],Te([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(ke[149],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[150],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[151],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[152],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[153],Te([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[154],Te([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[155],Te([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[156],Te([1,0,12]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map}register(M,y){this.a.set(M,y)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const y in M.contributes){const O=this.a.get(y);if(!O)continue;const S=M.contributes[y],k=Array.isArray(S)?S:[S];try{O(k,M.activationEvents)}catch(N){(0,i.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(ke[157],Te([1,0,24,29,134,257]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||y.test(l)}e.isValidVersionStr=S;function k(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(y);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function N(l){if(!l)return null;const g=l.majorBase,E=l.majorMustEqual,L=l.minorBase;let v=l.minorMustEqual;const t=l.patchBase;let d=l.patchMustEqual;l.hasCaret&&(g===0||(v=!1),d=!1);let r=0;if(l.preRelease){const u=O.exec(l.preRelease);if(u){const[,n,p,o]=u;r=Date.UTC(Number(n),Number(p)-1,Number(o))}}return{majorBase:g,majorMustEqual:E,minorBase:L,minorMustEqual:v,patchBase:t,patchMustEqual:d,isMinimum:l.hasGreaterEquals,notBefore:r}}e.normalizeVersion=N;function w(l,g,E){let L;typeof l=="string"?L=N(k(l)):L=l;let v;g instanceof Date?v=g.getTime():typeof g=="string"&&(v=new Date(g).getTime());let t;if(typeof E=="string"?t=N(k(E)):t=E,!L||!t)return!1;const d=L.majorBase,r=L.minorBase,u=L.patchBase;let n=t.majorBase,p=t.minorBase,o=t.patchBase;const c=t.notBefore;let m=t.majorMustEqual,P=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?d>n?!0:d<n?!1:r>p?!0:r<p||v&&v<c?!1:u>=o:(d===1&&n===0&&(!m||!P||!T)&&(n=1,p=0,o=0,m=!0,P=!1,T=!1),d<n?!1:d>n?!m:r<p?!1:r>p?!P:u<o?!1:u>o?!T:!(v&&v<c))}e.isValidVersion=w;function h(l,g,E,L,v){const t=[];if(typeof L.publisher<"u"&&typeof L.publisher!="string")return t.push([C.default.Error,D.localize(0,null)]),t;if(typeof L.name!="string")return t.push([C.default.Error,D.localize(1,null,"name")]),t;if(typeof L.version!="string")return t.push([C.default.Error,D.localize(2,null,"version")]),t;if(!L.engines)return t.push([C.default.Error,D.localize(3,null,"engines")]),t;if(typeof L.engines.vscode!="string")return t.push([C.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof L.extensionDependencies<"u"&&!s(L.extensionDependencies))return t.push([C.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof L.activationEvents<"u"){if(!s(L.activationEvents))return t.push([C.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof L.main>"u"&&typeof L.browser>"u")return t.push([C.default.Error,D.localize(7,null,"activationEvents","main")]),t}if(typeof L.extensionKind<"u"&&typeof L.main>"u"&&t.push([C.default.Warning,D.localize(8,null,"extensionKind")]),typeof L.main<"u"){if(typeof L.main!="string")return t.push([C.default.Error,D.localize(9,null,"main")]),t;{const u=(0,i.joinPath)(E,L.main);(0,i.isEqualOrParent)(u,E)||t.push([C.default.Warning,D.localize(10,null,u.path,E.path)])}if(typeof L.activationEvents>"u")return t.push([C.default.Error,D.localize(11,null,"activationEvents","main")]),t}if(typeof L.browser<"u"){if(typeof L.browser!="string")return t.push([C.default.Error,D.localize(12,null,"browser")]),t;{const u=(0,i.joinPath)(E,L.browser);(0,i.isEqualOrParent)(u,E)||t.push([C.default.Warning,D.localize(13,null,u.path,E.path)])}if(typeof L.activationEvents>"u")return t.push([C.default.Error,D.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(L.version))return t.push([C.default.Error,D.localize(15,null)]),t;const d=[];if(!b(l,g,L,v,d))for(const u of d)t.push([C.default.Error,u]);return t}e.validateExtensionManifest=h;function b(l,g,E,L,v){return L||typeof E.main>"u"&&typeof E.browser>"u"?!0:a(l,g,E.engines.vscode,v)}e.isValidExtensionVersion=b;function f(l,g,E){return l==="*"||a(g,E,l)}e.isEngineValid=f;function a(l,g,E,L=[]){const v=N(k(E));if(!v)return L.push(D.localize(16,null,E)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return L.push(D.localize(17,null,E)),!1}else if(!v.majorMustEqual)return L.push(D.localize(18,null,E)),!1;return w(l,g,v)?!0:(L.push(D.localize(19,null,l,E)),!1)}function s(l){if(!Array.isArray(l))return!1;for(let g=0,E=l.length;g<E;g++)if(typeof l[g]!="string")return!1;return!0}}),define(ke[89],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(D,M=[],y=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=i}),define(ke[67],Te([1,0,89]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var D;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function M(O,S,k){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],Boolean(k))),C.push([O,S])}e.registerSingleton=M;function y(){return C}e.getSingletonServiceDescriptors=y}),define(ke[158],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(M,y){this.key=M,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class C{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const y of this.a.values())y.outgoing.size===0&&M.push(y);return M}insertEdge(M,y){const O=this.lookupOrInsertNode(M),S=this.lookupOrInsertNode(y);O.outgoing.set(S.key,S),S.incoming.set(O.key,O)}removeNode(M){const y=this.b(M);this.a.delete(y);for(const O of this.a.values())O.outgoing.delete(y),O.incoming.delete(y)}lookupOrInsertNode(M){const y=this.b(M);let O=this.a.get(y);return O||(O=new i(y,M),this.a.set(y,O)),O}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[y,O]of this.a)M.push(`${y}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,y]of this.a){const O=new Set([M]),S=this.c(y,O);if(S)return S}}c(M,y){for(const[O,S]of M.outgoing){if(y.has(O))return[...y,O].join(" -> ");y.add(O);const k=this.c(S,y);if(k)return k;y.delete(O)}}}e.Graph=C}),define(ke[3],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function O(S){return S[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=O})(i=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function C(y,O,S){O[i.DI_TARGET]===O?O[i.DI_DEPENDENCIES].push({id:y,index:S}):(O[i.DI_DEPENDENCIES]=[{id:y,index:S}],O[i.DI_TARGET]=O)}function D(y){if(i.serviceIds.has(y))return i.serviceIds.get(y);const O=function(S,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(O,S,N)};return O.toString=()=>y,i.serviceIds.set(y,O),O}e.createDecorator=D;function M(y){return y}e.refineServiceDecorator=M}),define(ke[41],Te([1,0,9,2,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof C.URI)}e.isConfigurationOverrides=M;function y(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=y;var O;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(O=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(s,l){const g=Object.create(null);for(const E in s)N(g,E,s[E],l);return g}e.toValuesTree=k;function N(s,l,g,E){const L=l.split("."),v=L.pop();let t=s;for(let d=0;d<L.length;d++){const r=L[d];let u=t[r];switch(typeof u){case"undefined":u=t[r]=Object.create(null);break;case"object":break;default:E(`Ignoring ${l} as ${L.slice(0,d+1).join(".")} is ${JSON.stringify(u)}`);return}t=u}if(typeof t=="object"&&t!==null)try{t[v]=g}catch{E(`Ignoring ${l} as ${L.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${l} as ${L.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=N;function w(s,l){const g=l.split(".");h(s,g)}e.removeFromValueTree=w;function h(s,l){const g=l.shift();if(l.length===0){delete s[g];return}if(Object.keys(s).indexOf(g)!==-1){const E=s[g];typeof E=="object"&&!Array.isArray(E)&&(h(E,l),Object.keys(E).length===0&&delete s[g])}}function b(s,l,g){function E(t,d){let r=t;for(const u of d){if(typeof r!="object"||r===null)return;r=r[u]}return r}const L=l.split("."),v=E(s,L);return typeof v>"u"?g:v}e.getConfigurationValue=b;function f(s,l,g){Object.keys(l).forEach(E=>{E!=="__proto__"&&(E in s?i.isObject(s[E])&&i.isObject(l[E])?f(s[E],l[E],g):g&&(s[E]=l[E]):s[E]=l[E])})}e.merge=f;function a(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(ke[42],Te([1,0,20,10,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",i.isMacintosh),M.set("isLinux",i.isLinux),M.set("isWindows",i.isWindows),M.set("isWeb",i.isWeb),M.set("isMacNative",i.isMacintosh&&!i.isWeb),M.set("isEdge",i.isEdge),M.set("isFirefox",i.isFirefox),M.set("isChrome",i.isChrome),M.set("isSafari",i.isSafari);const y=Object.prototype.hasOwnProperty;var O;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(O=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return w.INSTANCE}static true(){return h.INSTANCE}static has(A){return b.create(A)}static equals(A,U){return f.create(A,U)}static notEquals(A,U){return l.create(A,U)}static regex(A,U){return r.create(A,U)}static in(A,U){return a.create(A,U)}static notIn(A,U){return s.create(A,U)}static not(A){return g.create(A)}static and(...A){return p.create(A,null,!0)}static or(...A){return o.create(A,null,!0)}static greater(A,U){return L.create(A,U)}static greaterEquals(A,U){return v.create(A,U)}static smaller(A,U){return t.create(A,U)}static smallerEquals(A,U){return d.create(A,U)}static deserialize(A){if(!!A)return this.c(A)}static c(A){const U=A.split("||");return o.create(U.map(R=>this.d(R)),null,!0)}static d(A){const U=A.split("&&");return p.create(U.map(R=>this.f(R)),null,!0)}static f(A){if(A=A.trim(),A.indexOf("!=")>=0){const U=A.split("!=");return l.create(U[0].trim(),this.g(U[1]))}if(A.indexOf("==")>=0){const U=A.split("==");return f.create(U[0].trim(),this.g(U[1]))}if(A.indexOf("=~")>=0){const U=A.split("=~");return r.create(U[0].trim(),this.h(U[1]))}if(A.indexOf(" not in ")>=0){const U=A.split(" not in ");return s.create(U[0].trim(),this.g(U[1]))}if(A.indexOf(" in ")>=0){const U=A.split(" in ");return a.create(U[0].trim(),this.g(U[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const U=A.split(">=");return v.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const U=A.split(">");return L.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const U=A.split("<=");return d.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const U=A.split("<");return t.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(A)?g.create(A.substr(1).trim()):b.create(A)}static g(A){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const U=/^'([^']*)'$/.exec(A);return U?U[1].trim():A}static h(A){if((0,C.isFalsyOrWhitespace)(A))return console.warn("missing regexp-value for =~-expression"),null;const U=A.indexOf("/"),R=A.lastIndexOf("/");if(U===R||U<0)return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null;const F=A.slice(U+1,R),H=A[R+1]==="i"?"i":"";try{return new RegExp(F,H)}catch(j){return console.warn(`bad regexp-value '${A}', parse error: ${j}`),null}}}e.ContextKeyExpr=S;function k(K,A){const U=K?K.substituteConstants():void 0,R=A?A.substituteConstants():void 0;return!U&&!R?!0:!U||!R?!1:U.equals(R)}e.expressionsAreEqualWithConstantSubstitution=k;function N(K,A){return K.cmp(A)}class w{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return h.INSTANCE}}w.INSTANCE=new w,e.ContextKeyFalseExpr=w;class h{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return w.INSTANCE}}h.INSTANCE=new h,e.ContextKeyTrueExpr=h;class b{static create(A,U=null){const R=M.get(A);return typeof R=="boolean"?R?h.INSTANCE:w.INSTANCE:new b(A,U)}constructor(A,U){this.key=A,this.c=U,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:m(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=M.get(this.key);return typeof A=="boolean"?A?h.INSTANCE:w.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class f{static create(A,U,R=null){if(typeof U=="boolean")return U?b.create(A,R):g.create(A,R);const F=M.get(A);return typeof F=="boolean"?U===(F?"true":"false")?h.INSTANCE:w.INSTANCE:new f(A,U,R)}constructor(A,U,R){this.c=A,this.d=U,this.f=R,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=M.get(this.c);if(typeof A=="boolean"){const U=A?"true":"false";return this.d===U?h.INSTANCE:w.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class a{static create(A,U){return new a(A,U)}constructor(A,U){this.d=A,this.f=U,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:P(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const U=A.getValue(this.f),R=A.getValue(this.d);return Array.isArray(U)?U.includes(R):typeof R=="string"&&typeof U=="object"&&U!==null?y.call(U,R):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=s.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=a;class s{static create(A,U){return new s(A,U)}constructor(A,U){this.d=A,this.f=U,this.type=11,this.c=a.create(A,U)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=s;class l{static create(A,U,R=null){if(typeof U=="boolean")return U?g.create(A,R):b.create(A,R);const F=M.get(A);return typeof F=="boolean"?U===(F?"true":"false")?w.INSTANCE:h.INSTANCE:new l(A,U,R)}constructor(A,U,R){this.c=A,this.d=U,this.f=R,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=M.get(this.c);if(typeof A=="boolean"){const U=A?"true":"false";return this.d===U?w.INSTANCE:h.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class g{static create(A,U=null){const R=M.get(A);return typeof R=="boolean"?R?w.INSTANCE:h.INSTANCE:new g(A,U)}constructor(A,U){this.c=A,this.d=U,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:m(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=M.get(this.c);return typeof A=="boolean"?A?w.INSTANCE:h.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function E(K,A){if(typeof K=="string"){const U=parseFloat(K);isNaN(U)||(K=U)}return typeof K=="string"||typeof K=="number"?A(K):w.INSTANCE}class L{static create(A,U,R=null){return E(U,F=>new L(A,F,R))}constructor(A,U,R){this.c=A,this.d=U,this.f=R,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=L;class v{static create(A,U,R=null){return E(U,F=>new v(A,F,R))}constructor(A,U,R){this.c=A,this.d=U,this.f=R,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=v;class t{static create(A,U,R=null){return E(U,F=>new t(A,F,R))}constructor(A,U,R){this.c=A,this.d=U,this.f=R,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class d{static create(A,U,R=null){return E(U,F=>new d(A,F,R))}constructor(A,U,R){this.c=A,this.d=U,this.f=R,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=d;class r{static create(A,U){return new r(A,U)}constructor(A,U){this.d=A,this.f=U,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const U=this.f?this.f.source:"",R=A.f?A.f.source:"";return U<R?-1:U>R?1:0}equals(A){if(A.type===this.type){const U=this.f?this.f.source:"",R=A.f?A.f.source:"";return this.d===A.d&&U===R}return!1}substituteConstants(){return this}evaluate(A){const U=A.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=r;class u{static create(A){return new u(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(A){return new u(this.c.map(A))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function n(K){let A=null;for(let U=0,R=K.length;U<R;U++){const F=K[U].substituteConstants();if(K[U]!==F&&A===null){A=[];for(let H=0;H<U;H++)A[H]=K[H]}A!==null&&(A[U]=F)}return A===null?K:A}class p{static create(A,U,R){return p.d(A,U,R)}constructor(A,U){this.expr=A,this.c=U,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let U=0,R=this.expr.length;U<R;U++){const F=N(this.expr[U],A.expr[U]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let U=0,R=this.expr.length;U<R;U++)if(!this.expr[U].equals(A.expr[U]))return!1;return!0}return!1}substituteConstants(){const A=n(this.expr);return A===this.expr?this:p.create(A,this.c,!1)}evaluate(A){for(let U=0,R=this.expr.length;U<R;U++)if(!this.expr[U].evaluate(A))return!1;return!0}static d(A,U,R){const F=[];let H=!1;for(const j of A)if(!!j){if(j.type===1){H=!0;continue}if(j.type===0)return w.INSTANCE;if(j.type===6){F.push(...j.expr);continue}F.push(j)}if(F.length===0&&H)return h.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(N);for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];for(;F.length>1;){const j=F[F.length-1];if(j.type!==9)break;F.pop();const le=F.pop(),ge=F.length===0,re=o.create(j.expr.map(ae=>p.create([ae,le],null,R)),null,ge);re&&(F.push(re),F.sort(N))}if(F.length===1)return F[0];if(R){for(let j=0;j<F.length;j++)for(let le=j+1;le<F.length;le++)if(F[j].negate().equals(F[le]))return w.INSTANCE;if(F.length===1)return F[0]}return new p(F,U)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const U of this.expr)A.push(...U.keys());return A}map(A){return new p(this.expr.map(U=>U.map(A)),null)}negate(){if(!this.c){const A=[];for(const U of this.expr)A.push(U.negate());this.c=o.create(A,this,!0)}return this.c}}class o{static create(A,U,R){return o.d(A,U,R)}constructor(A,U){this.expr=A,this.c=U,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let U=0,R=this.expr.length;U<R;U++){const F=N(this.expr[U],A.expr[U]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let U=0,R=this.expr.length;U<R;U++)if(!this.expr[U].equals(A.expr[U]))return!1;return!0}return!1}substituteConstants(){const A=n(this.expr);return A===this.expr?this:o.create(A,this.c,!1)}evaluate(A){for(let U=0,R=this.expr.length;U<R;U++)if(this.expr[U].evaluate(A))return!0;return!1}static d(A,U,R){let F=[],H=!1;if(A){for(let j=0,le=A.length;j<le;j++){const ge=A[j];if(!!ge){if(ge.type===0){H=!0;continue}if(ge.type===1)return h.INSTANCE;if(ge.type===9){F=F.concat(ge.expr);continue}F.push(ge)}}if(F.length===0&&H)return w.INSTANCE;F.sort(N)}if(F.length!==0){if(F.length===1)return F[0];for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];if(R){for(let j=0;j<F.length;j++)for(let le=j+1;le<F.length;le++)if(F[j].negate().equals(F[le]))return h.INSTANCE;if(F.length===1)return F[0]}return new o(F,U)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const U of this.expr)A.push(...U.keys());return A}map(A){return new o(this.expr.map(U=>U.map(A)),null)}negate(){if(!this.c){const A=[];for(const U of this.expr)A.push(U.negate());for(;A.length>1;){const U=A.shift(),R=A.shift(),F=[];for(const H of _(U))for(const j of _(R))F.push(p.create([H,j],null,!1));A.unshift(o.create(F,null,!1))}this.c=o.create(A,this,!0)}return this.c}}class c extends b{static all(){return c.d.values()}constructor(A,U,R){super(A,null),this.f=U,typeof R=="object"?c.d.push({...R,key:A}):R!==!0&&c.d.push({key:A,description:R,type:U!=null?typeof U:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return f.create(this.key,A)}notEqualsTo(A){return l.create(this.key,A)}}c.d=[],e.RawContextKey=c,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function m(K,A){return K<A?-1:K>A?1:0}function P(K,A,U,R){return K<U?-1:K>U?1:A<R?-1:A>R?1:0}function T(K,A){if(K.type===0||A.type===1)return!0;if(K.type===9)return A.type===9?V(K.expr,A.expr):!1;if(A.type===9){for(const U of A.expr)if(T(K,U))return!0;return!1}if(K.type===6){if(A.type===6)return V(A.expr,K.expr);for(const U of K.expr)if(T(U,A))return!0;return!1}return K.equals(A)}e.implies=T;function V(K,A){let U=0,R=0;for(;U<K.length&&R<A.length;){const F=K[U].cmp(A[R]);if(F<0)return!1;F===0&&U++,R++}return U===K.length}function _(K){return K.type===9?K.expr:[K]}}),define(ke[159],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(ke[90],Te([1,0,133,3]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function y(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function O(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=O;function S(l,g,E){return O(g,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:k(E).includes(l)}e.isTargetPlatformCompatible=S;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function N(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=N;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var h;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var b;(function(l){l.Install="install",l.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var a;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class s extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,i.localize)(1,null),original:"Preferences"}}),define(ke[43],Te([1,0,48,19,10,9,2,135,3,20,15]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function w(re){return re.create===!0}e.isFileOpenForWriteOptions=w;var h;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(h=e.FileType||(e.FileType={}));var b;(function(re){re[re.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var f;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function a(re){return!!(re.capabilities&2)}e.hasReadWriteCapability=a;function s(re){return!!(re.capabilities&8)}e.hasFileFolderCopyCapability=s;function l(re){return!!(re.capabilities&32768)}e.hasFileCloneCapability=l;function g(re){return!!(re.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(re){return!!(re.capabilities&16)}e.hasFileReadStreamCapability=E;function L(re){return a(re)?!!(re.capabilities&16384):!1}e.hasFileAtomicReadCapability=L;var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(ae,ce){const Se=new t(ae.toString(),ce);return u(Se,ce),Se}constructor(ae,ce){super(ae),this.code=ce}}e.FileSystemProviderError=t;function d(re,ae){return t.create(re,ae)}e.createFileSystemProviderError=d;function r(re){return re||d((0,O.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=r;function u(re,ae){return re.name=ae?`${ae} (FileSystemError)`:"FileSystemError",re}e.markAsFileSystemProviderError=u;function n(re){if(!re)return v.Unknown;if(re instanceof t)return re.code;const ae=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ae)return v.Unknown;switch(ae[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=n;function p(re){if(re instanceof V)return re.fileOperationResult;switch(n(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=p;var o;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(ae,ce,Se){this.resource=ae,this.operation=ce,this.target=Se}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=c;var m;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class P{constructor(ae,ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Se=new Map;for(const x of ae){const X=Se.get(x.type);switch(X?X.push([x.resource,x]):Se.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,X]of Se)switch(x){case 1:this.a=i.TernarySearchTree.forUris(()=>ce),this.a.fill(X);break;case 0:this.b=i.TernarySearchTree.forUris(()=>ce),this.b.fill(X);break;case 2:this.c=i.TernarySearchTree.forUris(()=>ce),this.c.fill(X);break}}contains(ae,...ce){return this.d(ae,{includeChildren:!1},...ce)}affects(ae,...ce){return this.d(ae,{includeChildren:!0},...ce)}d(ae,ce,...Se){if(!ae)return!1;const x=Se.length>0;return!!((!x||Se.includes(1))&&(this.a?.get(ae)||ce.includeChildren&&this.a?.findSuperstr(ae))||(!x||Se.includes(0))&&(this.b?.get(ae)||ce.includeChildren&&this.b?.findSuperstr(ae))||(!x||Se.includes(2))&&(this.c?.findSubstr(ae)||ce.includeChildren&&this.c?.findSuperstr(ae)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=P;function T(re,ae,ce){return!re||!ae||re===ae||ae.length>re.length?!1:(ae.charAt(ae.length-1)!==C.sep&&(ae+=C.sep),ce?(0,D.startsWithIgnoreCase)(re,ae):re.indexOf(ae)===0)}e.isParent=T;class V extends Error{constructor(ae,ce,Se){super(ae),this.fileOperationResult=ce,this.options=Se}}e.FileOperationError=V;class _ extends V{constructor(ae,ce,Se,x){super(ae,ce,x),this.fileOperationResult=ce,this.size=Se}}e.TooLargeFileOperationError=_;class K extends V{constructor(ae,ce,Se){super(ae,2,Se),this.stat=ce}}e.NotModifiedSinceFileOperationError=K;var A;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",re[re.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.etag=R;async function F(re,ae){if(!ae.hasProvider(y.URI.from({scheme:re.scheme})))return new Promise(ce=>{const Se=ae.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===re.scheme&&x.added&&(Se.dispose(),ce())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(ae){return(0,M.isNumber)(ae)||(ae=0),ae<H.KB?(0,O.localize)(1,null,ae.toFixed(0)):ae<H.MB?(0,O.localize)(2,null,(ae/H.KB).toFixed(2)):ae<H.GB?(0,O.localize)(3,null,(ae/H.MB).toFixed(2)):ae<H.TB?(0,O.localize)(4,null,(ae/H.GB).toFixed(2)):(0,O.localize)(5,null,(ae/H.TB).toFixed(2))}}H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB,e.ByteSize=H;var j;(function(re){re[re.IA32=0]="IA32",re[re.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function le(re){return{maxFileSize:re===0?300*H.MB:16*H.GB,maxHeapSize:re===0?700*H.MB:2*700*H.MB}}e.getPlatformFileLimits=le;function ge(re){const ae=typeof re=="string"||re?.scheme===N.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===N.Schemas.file?1024*H.MB:ae?10*H.MB:k.isWeb?50*H.MB:1024*H.MB}e.getLargeFileConfirmationLimit=ge}),define(ke[68],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...D){this.a=new Map;for(const[M,y]of D)this.set(M,y)}set(D,M){const y=this.a.get(D);return this.a.set(D,M),y}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=i}),define(ke[160],Te([1,0,17,12,6,89,158,3,68,161]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class w extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class h{constructor(s=new S.ServiceCollection,l=!1,g,E=N){this.f=s,this.g=l,this.h=g,this.i=E,this.o=new Set,this.f.set(O.IInstantiationService,this),this._globalGraph=E?g?._globalGraph??new y.Graph(L=>L):void 0}createChild(s){return new h(s,this.g,this,this.i)}invokeFunction(s,...l){const g=f.traceInvocation(this.i,s);let E=!1;try{return s({get:v=>{if(E)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(v,g);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...l)}finally{E=!0,g.stop()}}createInstance(s,...l){let g,E;return s instanceof M.SyncDescriptor?(g=f.traceCreation(this.i,s.ctor),E=this.j(s.ctor,s.staticArguments.concat(l),g)):(g=f.traceCreation(this.i,s),E=this.j(s,l,g)),g.stop(),E}j(s,l=[],g){const E=O._util.getServiceDependencies(s).sort((t,d)=>t.index-d.index),L=[];for(const t of E){const d=this.m(t.id,g);d||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),L.push(d)}const v=E.length>0?E[0].index:l.length;if(l.length!==v){console.trace(`[createInstance] First service dependency of ${s.name} at position ${v+1} conflicts with ${l.length} static arguments`);const t=v-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,v)}return Reflect.construct(s,l.concat(L))}k(s,l){if(this.f.get(s)instanceof M.SyncDescriptor)this.f.set(s,l);else if(this.h)this.h.k(s,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const l=this.f.get(s);return!l&&this.h?this.h.l(s):l}m(s,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const g=this.l(s);return g instanceof M.SyncDescriptor?this.q(s,g,l.branch(s,!0)):(l.branch(s,!1),g)}q(s,l,g){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,l,g)}finally{this.o.delete(s)}}r(s,l,g){const E=new y.Graph(t=>t.id.toString());let L=0;const v=[{id:s,desc:l,_trace:g}];for(;v.length;){const t=v.pop();if(E.lookupOrInsertNode(t),L++>1e3)throw new w(E);for(const d of O._util.getServiceDependencies(t.desc.ctor)){const r=this.l(d.id);if(r||this.u(`[createInstance] ${s} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),r instanceof M.SyncDescriptor){const u={id:d.id,desc:r,_trace:t._trace.branch(d.id,!0)};E.insertEdge(t,u),v.push(u)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:d}of t){if(this.l(d.id)instanceof M.SyncDescriptor){const u=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,u)}E.removeNode(d)}}return this.l(s)}s(s,l,g=[],E,L){if(this.f.get(s)instanceof M.SyncDescriptor)return this.t(s,l,g,E,L);if(this.h)return this.h.s(s,l,g,E,L);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(s,l,g=[],E,L){if(E){const v=new h(void 0,this.g,this,this.i);v.c=String(s);const t=new Map,d=new i.IdleValue(()=>{const r=v.j(l,g,L);for(const[u,n]of t){const p=r[u];if(typeof p=="function")for(const o of n)p.apply(r,o)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,u){if(!d.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let o=t.get(u);return o||(o=new k.LinkedList,t.set(u,o)),(m,P,T)=>{const V=o.push([m,P,T]);return(0,D.toDisposable)(V)}}if(u in r)return r[u];const n=d.value;let p=n[u];return typeof p!="function"||(p=p.bind(n),r[u]=p),p},set(r,u,n){return d.value[u]=n,!0},getPrototypeOf(r){return l.prototype}})}else return this.j(l,g,L)}u(s,l){if(l&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=h;var b;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(b||(b={}));class f{static traceInvocation(s,l){return s?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(s,l){return s?new f(1,l.name):f.c}constructor(s,l){this.type=s,this.name=l,this.g=Date.now(),this.h=[]}branch(s,l){const g=new f(3,s.toString());return this.h.push([s,l,g]),g}stop(){const s=Date.now()-this.g;f.f+=s;let l=!1;function g(L,v){const t=[],d=new Array(L+1).join("	");for(const[r,u,n]of v.h)if(u&&n){l=!0,t.push(`${d}CREATES -> ${r}`);const p=g(L+1,n);p&&t.push(p)}else t.push(`${d}uses -> ${r}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(s>2||l)&&f.all.add(E.join(`
`))}}f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0,e.Trace=f}),define(ke[11],Te([1,0,39,4,6,28,20,9,2,3]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function N(){return new Date().toISOString()}function w(o){return(0,O.isNumber)(o)}e.isLogLevel=w;var h;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function b(o,c,m){switch(c){case h.Trace:o.trace(m);break;case h.Debug:o.debug(m);break;case h.Info:o.info(m);break;case h.Warning:o.warn(m);break;case h.Error:o.error(m);break;case h.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=b;function f(o){let c="";for(let m=0;m<o.length;m++){let P=o[m];if(typeof P=="object")try{P=JSON.stringify(P)}catch{}c+=(m>0?" ":"")+P}return c}e.format=f;class a extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new C.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==h.Off&&this.b<=c}}e.AbstractLogger=a;class s extends a{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...m){this.f(h.Trace)&&this.g(h.Trace,f([c,...m]))}debug(c,...m){this.f(h.Debug)&&this.g(h.Debug,f([c,...m]))}info(c,...m){this.f(h.Info)&&this.g(h.Info,f([c,...m]))}warn(c,...m){this.f(h.Warning)&&this.g(h.Warning,f([c,...m]))}error(c,...m){if(this.f(h.Error))if(c instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=c.stack,this.g(h.Error,f(P))}else this.g(h.Error,f([c,...m]))}flush(){}}e.AbstractMessageLogger=s;class l extends a{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.g=!y.isWindows}trace(c,...m){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,c,...m):console.log(`[main ${N()}]`,c,...m))}debug(c,...m){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,c,...m):console.log(`[main ${N()}]`,c,...m))}info(c,...m){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,c,...m):console.log(`[main ${N()}]`,c,...m))}warn(c,...m){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${N()}]\x1B[0m`,c,...m):console.warn(`[main ${N()}]`,c,...m))}error(c,...m){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${N()}]\x1B[0m`,c,...m):console.error(`[main ${N()}]`,c,...m))}dispose(){}flush(){}}e.ConsoleMainLogger=l;class g extends a{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c)}trace(c,...m){this.f(h.Trace)&&console.log("%cTRACE","color: #888",c,...m)}debug(c,...m){this.f(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",c,...m)}info(c,...m){this.f(h.Info)&&console.log("%c INFO","color: #33f",c,...m)}warn(c,...m){this.f(h.Warning)&&console.log("%c WARN","color: #993",c,...m)}error(c,...m){this.f(h.Error)&&console.log("%c  ERR","color: #f33",c,...m)}dispose(){}flush(){}}e.ConsoleLogger=g;class E extends a{constructor(c,m=e.DEFAULT_LOG_LEVEL){super(),this.g=c,this.setLevel(m)}trace(c,...m){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(c),...m])}debug(c,...m){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(c),...m])}info(c,...m){this.f(h.Info)&&this.g.log(h.Info,[this.h(c),...m])}warn(c,...m){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(c),...m])}error(c,...m){this.f(h.Error)&&this.g.log(h.Error,[this.h(c),...m])}h(c){return typeof c=="string"?c:(0,i.toErrorMessage)(c,this.f(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=E;class L extends a{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const m of this.g)m.setLevel(c);super.setLevel(c)}trace(c,...m){for(const P of this.g)P.trace(c,...m)}debug(c,...m){for(const P of this.g)P.debug(c,...m)}info(c,...m){for(const P of this.g)P.info(c,...m)}warn(c,...m){for(const P of this.g)P.warn(c,...m)}error(c,...m){for(const P of this.g)P.error(c,...m)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.MultiplexLogger=L;class v extends D.Disposable{constructor(c,m){if(super(),this.j=c,this.b=new M.ResourceMap,this.c=new M.ResourceMap,this.f=this.B(new C.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new C.Emitter),this.onDidChangeVisibility=this.h.event,m)for(const P of m)this.c.set(P.resource,P)}getLogger(c){return this.b.get(c)}createLogger(c,m){let P=this.b.get(c);const T=m?.logLevel==="always"?h.Trace:m?.logLevel;return P||(P=this.k(c,T??this.getLogLevel(c)??this.j,m),this.b.set(c,P)),this.registerLogger({resource:c,id:m?.id??c.toString(),logLevel:T,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId}),P}setLogLevel(c,m){if(S.URI.isUri(c)){const P=c,T=m,V=this.c.get(P);V&&T!==V.logLevel&&(V.logLevel=T===this.j?void 0:T,this.b.get(P)?.setLevel(T),this.c.set(V.resource,V),this.g.fire([P,T]))}else{this.j=c;for(const[P,T]of this.b.entries())this.c.get(P)?.logLevel===void 0&&T.setLevel(this.j);this.g.fire(this.j)}}setVisibility(c,m){const P=this.c.get(c);P&&m!==!P.hidden&&(P.hidden=!m,this.c.set(P.resource,P),this.h.fire([c,m]))}getLogLevel(c){let m;return c&&(m=this.c.get(c)?.logLevel),m??this.j}registerLogger(c){const m=this.c.get(c.resource);m?m.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.c.set(c.resource,c),this.f.fire({added:[c],removed:[]}))}deregisterLogger(c){const m=this.c.get(c);if(m){this.c.delete(c);const P=this.b.get(c);P&&(this.b.delete(c),P.dispose()),this.f.fire({added:[],removed:[m]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(c){return this.c.get(c)}dispose(){this.b.forEach(c=>c.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=v;class t{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(c){}getLevel(){return h.Info}trace(c,...m){}debug(c,...m){}info(c,...m){}warn(c,...m){}error(c,...m){}critical(c,...m){}dispose(){}flush(){}}e.NullLogger=t;class d extends t{}e.NullLogService=d;class r extends v{constructor(){super(h.Info)}k(c,m,P){return new t}}e.NullLoggerService=r;function u(o){if(o.verbose)return h.Trace;if(typeof o.logLevel=="string"){const c=p(o.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function n(o){switch(o){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=n;function p(o){switch(o){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=p}),define(ke[162],Te([1,0,6,11]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends i.Disposable{constructor(y,O=[]){super(),this.a=new C.MultiplexLogger([y,...O]),this.B(y.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(y){this.a.setLevel(y)}getLevel(){return this.a.getLevel()}trace(y,...O){this.a.trace(y,...O)}debug(y,...O){this.a.debug(y,...O)}info(y,...O){this.a.info(y,...O)}warn(y,...O){this.a.warn(y,...O)}error(y,...O){this.a.error(y,...O)}flush(){this.a.flush()}}e.LogService=D}),define(ke[91],Te([1,0,29,136,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(f,a){return a-f}S.compare=k;const N=Object.create(null);N[S.Error]=(0,C.localize)(0,null),N[S.Warning]=(0,C.localize)(1,null),N[S.Info]=(0,C.localize)(2,null);function w(f){return N[f]||""}S.toString=w;function h(f){switch(f){case i.default.Error:return S.Error;case i.default.Warning:return S.Warning;case i.default.Info:return S.Info;case i.default.Ignore:return S.Hint}}S.fromSeverity=h;function b(f){switch(f){case S.Error:return i.default.Error;case S.Warning:return i.default.Warning;case S.Info:return i.default.Info;case S.Hint:return i.default.Ignore}}S.toSeverity=b}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var O;(function(S){const k="";function N(h){return w(h,!0)}S.makeKey=N;function w(h,b){const f=[k];return h.source?f.push(h.source.replace("\xA6","\\\xA6")):f.push(k),h.code?typeof h.code=="string"?f.push(h.code.replace("\xA6","\\\xA6")):f.push(h.code.value.replace("\xA6","\\\xA6")):f.push(k),h.severity!==void 0&&h.severity!==null?f.push(y.toString(h.severity)):f.push(k),h.message&&b?f.push(h.message.replace("\xA6","\\\xA6")):f.push(k),h.startLineNumber!==void 0&&h.startLineNumber!==null?f.push(h.startLineNumber.toString()):f.push(k),h.startColumn!==void 0&&h.startColumn!==null?f.push(h.startColumn.toString()):f.push(k),h.endLineNumber!==void 0&&h.endLineNumber!==null?f.push(h.endLineNumber.toString()):f.push(k),h.endColumn!==void 0&&h.endColumn!==null?f.push(h.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}S.makeKeyOptionalMessage=w})(O=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(ke[163],Te([1,0,4,29,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,D.createDecorator)("notificationService");var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class O{constructor(){this.progress=new S,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=O;class S{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=S}),define(ke[92],Te([1,0,10,2,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function M(k,N){return C.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,N):(0,i.startsWithIgnoreCase)(k,N+":")}e.matchesScheme=M;function y(k,...N){return N.some(w=>M(k,w))}e.matchesSomeScheme=y;function O(k,N){return k.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=O;function S(k){let N;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return w&&(N={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},k=k.with({fragment:""})),{selection:N,uri:k}}e.extractSelection=S}),define(ke[164],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(te,e,i,C){var D=arguments.length,M=D<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,i):C,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,i,C);else for(var O=te.length-1;O>=0;O--)(y=te[O])&&(M=(D<3?y(M):D>3?y(e,i,M):y(e,i))||M);return D>3&&M&&Object.defineProperty(e,i,M),M},je=this&&this.__param||function(te,e){return function(i,C){e(i,C,te)}};define(ke[165],Te([1,0,17,21,6,3]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var y;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class O{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}O.None=Object.freeze({report(){}}),e.Progress=O;let S=class extends D.Disposable{constructor(w,h){super(),this.a=new i.DeferredPromise,h.withProgress(w,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};S=Ke([je(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends D.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new D.DisposableStore)}start(w){this.stop();const h=++this.a,b=new C.CancellationTokenSource;return this.f=setTimeout(()=>{h===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>b.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:h,token:b.token,stop:()=>this.h(h),isCurrent:()=>this.a===h}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(ke[30],Te([1,0,49,9]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(y,O){i.ok(C.isString(y)),i.ok(C.isObject(O)),i.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,O)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}e.Registry=new D}),define(ke[69],Te([1,0,4,30]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class M{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[D(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const y=new M;C.Registry.add(e.Extensions.JSONContribution,y)}),define(ke[93],Te([1,0,16,4,9,132,41,69,30]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=S.Registry.as(O.Extensions.JSONContribution);class h{constructor(){this.h=new Set,this.i=new C.Emitter,this.onDidSchemaChange=this.i.event,this.j=new C.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const r=new Set;this.n(t,d,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const d=new Set;this.o(t,d),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const r=new Set;this.o(d,r),this.n(t,!1,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const r=[];for(const{overrides:u,source:n}of t)for(const p in u)if(d.add(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const o=this.a.get(p),c=o?.valuesSources??new Map;if(n)for(const V of Object.keys(u[p]))c.set(V,n);const m={...o?.value||{},...u[p]};this.a.set(p,{source:n,value:m,valuesSources:c});const P=(0,y.getLanguageTagSettingPlainKey)(p),T={type:"object",default:m,description:M.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:D.isString(n)?void 0:n,defaultValueSource:n};r.push(...a(p)),this.d[p]=T,this.b.properties[p]=T}else{this.a.set(p,{value:u[p],source:n});const o=this.d[p];o&&(this.w(p,o),this.r(p,o))}this.m(r)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:r,source:u}of t)for(const n in r){const p=this.a.get(n),o=D.isString(u)?u:u?.id,c=D.isString(p?.source)?p?.source:p?.source?.id;if(o===c)if(d.add(n),this.a.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.d[n],delete this.b.properties[n];else{const m=this.d[n];m&&(this.w(n,m),this.r(n,m))}}this.u()}deltaConfiguration(t){let d=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,r){t.forEach(u=>{this.p(u,d,u.extensionInfo,u.restrictedProperties,void 0,r),this.c.push(u),this.q(u)})}o(t,d){const r=u=>{if(u.properties)for(const n in u.properties){d.add(n);const p=this.d[n];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[n],this.s(n,u.properties[n])}u.allOf?.forEach(n=>r(n))};for(const u of t){r(u);const n=this.c.indexOf(u);n!==-1&&this.c.splice(n,1)}}p(t,d=!0,r,u,n=3,p){n=D.isUndefinedOrNull(t.scope)?n:t.scope;const o=t.properties;if(o)for(const m in o){const P=o[m];if(d&&E(m,P)){delete o[m];continue}if(P.source=r,P.defaultDefaultValue=o[m].default,this.w(m,P),e.OVERRIDE_PROPERTY_REGEX.test(m)?P.scope=void 0:(P.scope=D.isUndefinedOrNull(P.scope)?n:P.scope,P.restricted=D.isUndefinedOrNull(P.restricted)?!!u?.includes(m):P.restricted),o[m].hasOwnProperty("included")&&!o[m].included){this.f[m]=o[m],delete o[m];continue}else this.d[m]=o[m],o[m].policy?.name&&this.e.set(o[m].policy.name,m);!o[m].deprecationMessage&&o[m].markdownDeprecationMessage&&(o[m].deprecationMessage=o[m].markdownDeprecationMessage),p.add(m)}const c=t.allOf;if(c)for(const m of c)this.p(m,d,r,u,n,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=r=>{const u=r.properties;if(u)for(const p in u)this.r(p,u[p]);r.allOf?.forEach(d)};d(t)}r(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,d){const r=this.a.get(t);let u=r?.value,n=r?.source;D.isUndefined(u)&&(u=d.defaultDefaultValue,n=void 0),D.isUndefined(u)&&(u=l(d.type)),d.default=u,d.defaultValueSource=n}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let d=f.exec(v);for(;d?.length;){const r=d[1].trim();r&&t.push(r),d=f.exec(v)}}return(0,i.distinct)(t)}e.overrideIdentifiersFromKey=a;function s(v){return v.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=s;function l(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new h;S.Registry.add(e.Extensions.Configuration,g);function E(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):g.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,v,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=E;function L(){const v=[],t=g.getConfigurationProperties();for(const d of Object.keys(t))v.push([d,t[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=L}),define(ke[166],Te([1,0,16,4,111,6,28,22,9,2,41,93,30]),function(te,e,i,C,D,M,y,O,S,k,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(d){return Object.isFrozen(d)?d:O.deepFreeze(d)}class f{constructor(r={},u=[],n=[],p){this.b=r,this.c=u,this.d=n,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(u=>{if(u instanceof f)return u;const n=new a("");return n.parseRaw(u),n.configurationModel});this.f=r.reduce((u,n)=>n===u?n:u.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}inspect(r,u){const n=this.rawConfiguration.getValue(r),p=u?this.rawConfiguration.getOverrideValue(r,u):void 0,o=u?this.rawConfiguration.override(u).getValue(r):n;return{value:n,override:p,merged:o}}getOverrideValue(r,u){const n=this.i(u);return n?r?(0,N.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const u=[];for(const n of this.overrides)n.identifiers.includes(r)&&u.push(...n.keys);return i.distinct(u)}getAllOverrideIdentifiers(){const r=[];for(const u of this.overrides)r.push(...u.identifiers);return i.distinct(r)}override(r){let u=this.a.get(r);return u||(u=this.g(r),this.a.set(r,u)),u}merge(...r){const u=O.deepClone(this.contents),n=O.deepClone(this.overrides),p=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const c of r)if(o.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.h(u,c.contents);for(const m of c.overrides){const[P]=n.filter(T=>i.equals(T.identifiers,m.identifiers));P?(this.h(P.contents,m.contents),P.keys.push(...m.keys),P.keys=i.distinct(P.keys)):n.push(O.deepClone(m))}for(const m of c.keys)p.indexOf(m)===-1&&p.push(m)}return new f(u,p,n,o.every(c=>c instanceof f)?void 0:o)}g(r){const u=this.i(r);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const n={};for(const p of i.distinct([...Object.keys(this.contents),...Object.keys(u)])){let o=this.contents[p];const c=u[p];c&&(typeof o=="object"&&typeof c=="object"?(o=O.deepClone(o),this.h(o,c)):o=c),n[p]=o}return new f(n,this.keys,this.overrides)}h(r,u){for(const n of Object.keys(u)){if(n in r&&S.isObject(r[n])&&S.isObject(u[n])){this.h(r[n],u[n]);continue}r[n]=O.deepClone(u[n])}}i(r){let u=null,n=null;const p=o=>{o&&(n?this.h(n,o):n=O.deepClone(o))};for(const o of this.overrides)i.equals(o.identifiers,[r])?u=o.contents:o.identifiers.includes(r)&&p(o.contents);return p(u),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,u){this.j(r,u,!0)}setValue(r,u){this.j(r,u,!1)}removeValue(r){const u=this.keys.indexOf(r);u!==-1&&(this.keys.splice(u,1),(0,N.removeFromValueTree)(this.contents,r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>i.equals(n.identifiers,(0,w.overrideIdentifiersFromKey)(r))),1))}j(r,u,n){(0,N.addToValueTree)(this.contents,r,u,p=>console.error(p)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,N.toValuesTree)(this.contents[r],p=>console.error(p))})}}e.ConfigurationModel=f;class a{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,u){if(!S.isUndefinedOrNull(r)){const n=this.g(r);this.parseRaw(n,u)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,u){this.a=r;const{contents:n,keys:p,overrides:o,restricted:c,hasExcludedProperties:m}=this.h(r,u);this.b=new f(n,p,o,m?[r]:void 0),this.c=c||[]}g(r){let u={},n=null,p=[];const o=[],c=[];function m(T){Array.isArray(p)?p.push(T):n!==null&&(p[n]=T)}const P={onObjectBegin:()=>{const T={};m(T),o.push(p),p=T,n=null},onObjectProperty:T=>{n=T},onObjectEnd:()=>{p=o.pop()},onArrayBegin:()=>{const T=[];m(T),o.push(p),p=T,n=null},onArrayEnd:()=>{p=o.pop()},onLiteralValue:m,onError:(T,V,_)=>{c.push({error:T,offset:V,length:_})}};if(r)try{D.visit(r,P),u=p[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return u}h(r,u){const n=h.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),p=this.i(r,n,!0,u);r=p.raw;const o=(0,N.toValuesTree)(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`)),c=Object.keys(r),m=this.j(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:o,keys:c,overrides:m,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(r,u,n,p){let o=!1;if(!p?.scopes&&!p?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:o};const c={},m=[];for(const P in r)if(w.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const T=this.i(r[P],u,!1,p);c[P]=T.raw,o=o||T.hasExcludedProperties,m.push(...T.restricted)}else{const T=u[P],V=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&m.push(P),(V===void 0||p.scopes===void 0||p.scopes.includes(V))&&!(p.skipRestricted&&T?.restricted)?c[P]=r[P]:o=!0}return{raw:c,restricted:m,hasExcludedProperties:o}}j(r,u){const n=[];for(const p of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(p)){const o={};for(const c in r[p])o[c]=r[p][c];n.push({identifiers:(0,w.overrideIdentifiersFromKey)(p),keys:Object.keys(o),contents:(0,N.toValuesTree)(o,u)})}return n}}e.ConfigurationModelParser=a;class s extends M.Disposable{constructor(r,u,n,p){super(),this.f=r,this.g=u,this.h=p,this.c=this.B(new C.Emitter),this.onDidChange=this.c.event,this.a=new a(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(n.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&n.isEqual(o.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class l{constructor(r,u,n,p,o,c,m,P,T,V,_,K,A){this.a=r,this.b=u,this.c=n,this.overrideIdentifiers=p,this.d=o,this.f=c,this.g=m,this.h=P,this.i=T,this.j=V,this.k=_,this.l=K,this.m=A}get value(){return b(this.c)}n(r,u,n){const p=r.inspect(u,n);return{get value(){return b(p.value)},get override(){return b(p.override)},get merged(){return b(p.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(r,u,n,p,o=new f,c=new f,m=new y.ResourceMap,P=new f,T=new y.ResourceMap){this.c=r,this.d=u,this.f=n,this.g=p,this.h=o,this.i=c,this.j=m,this.l=P,this.m=T,this.a=null,this.b=new y.ResourceMap,this.n=null}getValue(r,u,n){return this.q(r,u,n).getValue(r)}updateValue(r,u,n={}){let p;n.resource?(p=this.m.get(n.resource),p||(p=new f,this.m.set(n.resource,p))):p=this.l,u===void 0?p.removeValue(r):p.setValue(r,u),n.resource||(this.a=null)}inspect(r,u,n){const p=this.q(r,u,n),o=this.u(u.resource,n),c=u.resource?this.m.get(u.resource)||this.l:this.l,m=new Set;for(const P of p.overrides)for(const T of P.identifiers)p.getOverrideValue(r,T)!==void 0&&m.add(T);return new l(r,u,p.getValue(r),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,o||void 0,c)}keys(r){const u=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,u){this.j.set(r,u),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,u){const n=[];if(!u){const{added:p,updated:o,removed:c}=v(this.c,r);u=[...p,...o,...c]}for(const p of u)for(const o of(0,w.overrideIdentifiersFromKey)(p)){const c=this.c.getKeysForOverrideIdentifier(o),m=r.getKeysForOverrideIdentifier(o),P=[...m.filter(T=>c.indexOf(T)===-1),...c.filter(T=>m.indexOf(T)===-1),...c.filter(T=>!O.equals(this.c.override(o).getValue(T),r.override(o).getValue(T)))];n.push([o,P])}return this.updateDefaultConfiguration(r),{keys:u,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:u,updated:n,removed:p}=v(this.d,r),o=[...u,...n,...p];return o.length&&this.updatePolicyConfiguration(r),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:u,updated:n,removed:p,overrides:o}=v(this.applicationConfiguration,r),c=[...u,...n,...p];return c.length&&this.updateApplicationConfiguration(r),{keys:c,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:u,updated:n,removed:p,overrides:o}=v(this.localUserConfiguration,r),c=[...u,...n,...p];return c.length&&this.updateLocalUserConfiguration(r),{keys:c,overrides:o}}compareAndUpdateRemoteUserConfiguration(r){const{added:u,updated:n,removed:p,overrides:o}=v(this.remoteUserConfiguration,r),c=[...u,...n,...p];return c.length&&this.updateRemoteUserConfiguration(r),{keys:c,overrides:o}}compareAndUpdateWorkspaceConfiguration(r){const{added:u,updated:n,removed:p,overrides:o}=v(this.workspaceConfiguration,r),c=[...u,...n,...p];return c.length&&this.updateWorkspaceConfiguration(r),{keys:c,overrides:o}}compareAndUpdateFolderConfiguration(r,u){const n=this.p.get(r),{added:p,updated:o,removed:c,overrides:m}=v(n,u),P=[...p,...o,...c];return(P.length||!n)&&this.updateFolderConfiguration(r,u),{keys:P,overrides:m}}compareAndDeleteFolderConfiguration(r){const u=this.p.get(r);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:p,removed:o,overrides:c}=v(u,void 0);return{keys:[...n,...p,...o],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,u,n){let p=this.r(u,n);return u.overrideIdentifier&&(p=p.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(p=p.merge(this.d)),p}r({resource:r},u){let n=this.s();if(u&&r){const p=u.getFolder(r);p&&(n=this.t(p.uri)||n);const o=this.m.get(r);o&&(n=n.merge(o))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let u=this.b.get(r);if(!u){const n=this.s(),p=this.j.get(r);p?(u=n.merge(p),this.b.set(r,u)):u=n}return u}u(r,u){if(u&&r){const n=u.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,u)=>{const{contents:n,overrides:p,keys:o}=this.j.get(u);return r.push([u,{contents:n,overrides:p,keys:o}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(u=>r.add(u)),this.userConfiguration.keys.forEach(u=>r.add(u)),this.i.keys.forEach(u=>r.add(u)),this.j.forEach(u=>u.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const u=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>u.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>u.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>u.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(p=>u.add(p))),[...u.values()]}static parse(r){const u=this.x(r.defaults),n=this.x(r.policy),p=this.x(r.application),o=this.x(r.user),c=this.x(r.workspace),m=r.folders.reduce((P,T)=>(P.set(k.URI.revive(T[0]),this.x(T[1])),P),new y.ResourceMap);return new g(u,n,p,o,new f,c,m,new f,new y.ResourceMap)}static x(r){return new f(r.contents,r.keys,r.overrides)}}e.Configuration=g;function E(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const r=new Set,u=new Map;for(const p of d)p.keys.forEach(o=>r.add(o)),p.overrides.forEach(([o,c])=>{const m=(0,y.getOrSet)(u,o,new Set);c.forEach(P=>m.add(P))});const n=[];return u.forEach((p,o)=>n.push([o,[...p.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=E;class L{constructor(r,u,n,p){this.change=r,this.f=u,this.g=n,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of r.keys)this.affectedKeys.add(o);for(const[,o]of r.overrides)for(const c of o)this.affectedKeys.add(c);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(r,u){const n=this.a+r,p=this.d.indexOf(n);if(p<0)return!1;const o=p+n.length;if(o>=this.d.length)return!1;const c=this.d.charCodeAt(o);if(c!==this.b&&c!==this.c)return!1;if(u){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,u,this.f?.workspace):void 0,P=this.g.getValue(r,u,this.h);return!O.equals(m,P)}return!0}}e.ConfigurationChangeEvent=L;function v(d,r){const{added:u,removed:n,updated:p}=t(r?.rawConfiguration,d?.rawConfiguration),o=[],c=d?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const P=m.filter(T=>!c.includes(T));for(const T of P)o.push([T,r.getKeysForOverrideIdentifier(T)])}if(d){const P=c.filter(T=>!m.includes(T));for(const T of P)o.push([T,d.getKeysForOverrideIdentifier(T)])}if(r&&d){for(const P of c)if(m.includes(P)){const T=t({contents:d.getOverrideValue(void 0,P)||{},keys:d.getKeysForOverrideIdentifier(P)},{contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)});o.push([P,[...T.added,...T.removed,...T.updated]])}}return{added:u,removed:n,updated:p,overrides:o}}function t(d,r){const u=d?r?d.keys.filter(o=>r.keys.indexOf(o)===-1):[...d.keys]:[],n=r?d?r.keys.filter(o=>d.keys.indexOf(o)===-1):[...r.keys]:[],p=[];if(d&&r){for(const o of r.keys)if(d.keys.indexOf(o)!==-1){const c=(0,N.getConfigurationValue)(r.contents,o),m=(0,N.getConfigurationValue)(d.contents,o);O.equals(c,m)||p.push(o)}}return{added:u,removed:n,updated:p}}}),define(ke[94],Te([1,0,12,3]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var D;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends i.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof M&&S._code===D.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof M&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof M&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof M&&S.isHandled}constructor(S,k=D.Unknown,N){super(S),this._message=S,this._code=k,this._detail=N,this.isHandled=k===D.NotAvailable&&N===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function y(O){const S=O.indexOf("+");return S===-1?O:O.substring(0,S)}e.getRemoteAuthorityPrefix=y}),define(ke[50],Te([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=C;function D(k){if(!k)return;const N=k.indexOf("+");return N<0?k:k.substr(0,N)}e.getRemoteName=D;function M(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=M;function y(k){const{host:N,port:w}=S(k);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:w}}e.parseAuthorityWithPort=y;function O(k,N){let{host:w,port:h}=S(k);return typeof h>"u"&&(h=N),{host:w,port:h}}e.parseAuthorityWithOptionalPort=O;function S(k){const N=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const w=k.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const h=k.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:k,port:void 0}}}),define(ke[25],Te([1,0,10,3,50]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var O;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(O=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(f){this.value=f,this.c=f.toLowerCase()}static equals(f,a){if(typeof f>"u"||f===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){const s=typeof f=="string"?f:f.value,l=typeof a=="string"?a:a.value;return i.equalsIgnoreCase(s,l)}return f.c===a.c}static toKey(f){return typeof f=="string"?f.toLowerCase():f.c}}e.ExtensionIdentifier=S;function k(b){return N(b)}e.isApplicationScopedExtension=k;function N(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=N;function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function h(b,f){if(f){const a=`onResolveRemoteAuthority:${(0,D.getRemoteName)(f)}`;return b.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(ke[167],Te([1,0,20,51,2,34]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function O(k,N,w,h,b,f,a,s,l,g){const E=Object.create(null);E["common.machineId"]=a,E.sessionID=(0,M.generateUuid)()+Date.now(),E.commitHash=b,E.version=f,E["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,i.PlatformToString)(i.platform),E["common.nodePlatform"]=C.platform,E["common.nodeArch"]=h,E["common.product"]=g||"desktop",s&&(E["common.msftInternal"]=s);let L=0;const v=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>L++,enumerable:!0}}),i.isLinuxSnap&&(E["common.snap"]="true");const t=y(w);t&&(E["common.platformDetail"]=t);try{const d=await k.readFile(D.URI.file(l));E["common.source"]=d.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=O;function S(k){const N=C.env.USERDNSDOMAIN;if(!N)return!1;const w=N.toLowerCase();return k.some(h=>w===h)}e.verifyMicrosoftInternalDomain=S}),define(ke[168],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ke[52],Te([1,0,22,9,4,41,50,167,168]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(o){this.value=o}}e.TelemetryTrustedValue=k;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,c){return Promise.resolve(void 0)}publicLog2(o,c){return this.publicLog(o,c)}publicLogError(o,c){return Promise.resolve(void 0)}publicLogError2(o,c){return this.publicLogError(o,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class w{async publicLog(o,c,m){}async publicLogError(o,c,m){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(p,o){return D.Event.debounce(o.onDidChangeConfiguration,(m,P)=>{const T=m?new Set([...m.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:T}},1e3,!0)(m=>{m.source!==7&&p.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(m.source),configurationKeys:L(m.affectedKeys)})})}e.configurationTelemetry=h;function b(p,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!p.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=b;function f(p,o){return!(o.isBuilt||o.disableTelemetry||p.enableTelemetry&&p.aiConfig?.ariaKey)}e.isLoggingOnly=f;function a(p){const o=p.getValue(S.TELEMETRY_SETTING_ID),c=p.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(p.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=a;function s(p){const o={},c={},m={};E(p,m);for(let P in m){P=P.length>150?P.substr(P.length-149):P;const T=m[P];typeof T=="number"?c[P]=T:typeof T=="boolean"?c[P]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${T.length}`),o[P]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(o[P]=T)}return{properties:o,measurements:c}}e.validateTelemetryData=s;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(p){if(!p)return"none";const o=(0,y.getRemoteName)(p);return l.has(o)?o:"other"}e.cleanRemoteAuthority=g;function E(p,o,c=0,m){if(!!p)for(const P of Object.getOwnPropertyNames(p)){const T=p[P],V=m?m+P:P;Array.isArray(T)?o[V]=(0,i.safeStringify)(T):T instanceof Date?o[V]=T.toISOString():(0,C.isObject)(T)?c<2?E(T,o,c+1,V+"."):o[V]=(0,i.safeStringify)(T):o[V]=T}}function L(p){if(!p)return[];const o=[];return v(o,"",p),o}function v(p,o,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(m=>v(p,o?`${o}.${m}`:m,c[m])):p.push(o)}function t(p,o){const c=p.msftInternalDomains||[],m=o.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(c)||m}e.isInternalTelemetry=t;function d(p){return[p.appRoot,p.extensionsPath,p.userHome.fsPath,p.tmpDir.fsPath,p.userDataPath]}e.getPiiPathsFromEnvironment=d;function r(p,o){if(!p||!p.includes("/")&&!p.includes("\\"))return p;let c=p;const m=[];for(const _ of o)for(;;){const K=_.exec(p);if(!K)break;m.push([K.index,_.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let V=0;for(c="";;){const _=T.exec(p);if(!_)break;const K=m.some(([A,U])=>_.index<U&&A<T.lastIndex);!P.test(_[0])&&!K&&(c+=p.substring(V,_.index)+"<REDACTED: user-file-path>",V=T.lastIndex)}return V<p.length&&(c+=p.substr(V)),c}function u(p){if(!p)return p;const o=p.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of c)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return p}function n(p,o){return(0,i.cloneAndChange)(p,c=>{if(c instanceof k)return c.value;if(typeof c=="string"){let m=c.replaceAll("%20"," ");m=r(m,o);for(const P of o)m=m.replace(P,"");return m=u(m),m}})}e.cleanData=n}),define(ke[169],Te([1,0,10,90,25,20,2,12,51,52]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(r,u){return r.uuid&&u.uuid?r.uuid===u.uuid:r.id===u.id?!0:(0,i.compareIgnoreCase)(r.id,u.id)===0}e.areSameExtensions=N;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(u){const n=u.manifest?u.manifest.version:u.version,p=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new h(u.identifier,n,p)}static parse(u){const n=w.exec(u);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(u,n,p="undefined"){this.version=n,this.targetPlatform=p,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof h?N(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=h;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(r){const u=b.exec(r);return u&&u[1]?[s(u[1]),u[2]]:[s(r),void 0]}e.getIdAndVersion=f;function a(r,u){return`${r}.${u}`}e.getExtensionId=a;function s(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=s;function l(r,u){return s(a(r,u))}e.getGalleryExtensionId=l;function g(r,u){const n=[],p=o=>{for(const c of n)if(c.some(m=>N(u(m),u(o))))return c;return null};for(const o of r){const c=p(o);c?c.push(o):n.push([o])}return n}e.groupByExtension=g;function E(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function L(r){return{id:new k.TelemetryTrustedValue(r.identifier.id),name:new k.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=L,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(r,u){const n=[],p=u.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const o=p.shift();if(o&&n.every(c=>!N(c.identifier,{id:o}))){const c=r.filter(m=>N(m.identifier,{id:o}));c.length===1&&(n.push(c[0]),p.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=v;async function t(r,u){if(!M.isLinux)return!1;let n;try{n=(await r.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){u.debug("Error while getting the os-release file.",(0,O.getErrorMessage)(o))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(r,u){const n=await t(r,u),p=(0,C.getTargetPlatform)(n?"alpine":M.platform,S.arch);return u.debug("ComputeTargetPlatform:",p),p}e.computeTargetPlatform=d}),define(ke[170],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=i;function C(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=C;function D(y){return Array.from(y.entries()).map(O=>[O[0],i(O[1].map)])}e.serializeEnvironmentVariableCollections=D;function M(y){return new Map(y.map(O=>[O[0],{map:C(O[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(ke[171],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,M,y=5){const O=M(S=>{const k=typeof S=="string"?S:S.data;let N=this.a.get(D);if(N){N.data.push(k);return}const w=setTimeout(()=>this.flushBuffer(D),y);N={data:[k],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(D),O.dispose()}},this.a.set(D,N)});return O}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const M=this.a.get(D);M&&(this.a.delete(D),this.b(D,M.data.join("")))}}e.TerminalDataBufferer=i}),define(ke[172],Te([1,0,17,84,38,4,9,2,137,69,30]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(L){function v(t,d){let r=t.defaults;for(;D.ThemeIcon.isThemeIcon(r);){const u=f.getIcon(r.id);if(!u)return;r=u.defaults}return r}L.getDefinition=v})(w=e.IconContribution||(e.IconContribution={}));var h;(function(L){function v(d){return{weight:d.weight,style:d.style,src:d.src.map(r=>({format:r.format,location:r.location.toString()}))}}L.toJSONObject=v;function t(d){const r=u=>(0,y.isString)(u)?u:void 0;if(d&&Array.isArray(d.src)&&d.src.every(u=>(0,y.isString)(u.format)&&(0,y.isString)(u.location)))return{weight:r(d.weight),style:r(d.style),src:d.src.map(u=>({format:u.format,location:O.URI.parse(u.location)}))}}L.fromJSONObject=t})(h=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,t,d,r){const u=this.b[v];if(u){if(d&&!u.description){u.description=d,this.d.properties[v].markdownDescription=`${d} $(${v})`;const o=this.e.enum.indexOf(v);o!==-1&&(this.e.enumDescriptions[o]=d),this.a.fire()}return u}const n={id:v,description:d,defaults:t,deprecationMessage:r};this.b[v]=n;const p={$ref:"#/definitions/icons"};return r&&(p.deprecationMessage=r),d&&(p.markdownDescription=`${d}: $(${v})`),this.d.properties[v]=p,this.e.enum.push(v),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const t=this.e.enum.indexOf(v);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,t){const d=this.f[v];return d||(this.f[v]=t,this.a.fire(),t)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(u,n)=>u.id.localeCompare(n.id),t=u=>{for(;D.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(u=>this.b[u]);for(const u of r.filter(n=>!!n.description).sort(v))d.push(`|<i class="${t(u)}"></i>|${u.id}|${D.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const u of r.filter(n=>!D.ThemeIcon.isThemeIcon(n.defaults)).sort(v))d.push(`|<i class="${t(u)}"></i>|${u.id}|`);return d.join(`
`)}}const f=new b;N.Registry.add(e.Extensions.IconContribution,f);function a(L,v,t,d){return f.registerIcon(L,v,t,d)}e.registerIcon=a;function s(){return f}e.getIconRegistry=s;function l(){const L=(0,C.getCodiconFontCharacters)();for(const v in L){const t="\\"+L[v].toString(16);f.registerIcon(v,{fontCharacter:t})}}l(),e.iconsSchemaId="vscode://schemas/icons";const g=N.Registry.as(k.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,f.getIconSchema());const E=new i.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);f.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=a("widget-close",C.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=a("goto-previous-location",C.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=a("goto-next-location",C.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=D.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(ke[173],Te([1,0,4,41,3,11]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var y;(function(a){a.Http="http",a.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var O;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(O=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=w;function h(a,s,l,g){if(l===1)return!1;if(l===2&&w(s)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(E?.length===4&&parseInt(E[1])>=18)return!1}return a<1024}e.isPortPrivileged=h;class b{constructor(s,l,g){this.remoteAddress=s,this.localAddress=l,this.b=g,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let f=class{constructor(s,l){this.i=s,this.j=l,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],l=Array.from(this.d.values());for(const g of l){const E=Array.from(g.values());for(const L of E){const v=await L.value;v&&s.push(v)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:l}of s.values())await l.then(g=>g?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,l,g,E,L){this.o(s,l,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:l,localAddress:g,privacy:E,protocol:L,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,l){(w(s)||N(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const g=this.q(s,l);if(g)return++g.refcount,g.value}openTunnel(s,l,g,E,L,v=!1,t,d){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${g} on local port ${L}.`),!s)return;if(l||(l="localhost"),E||(E=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(s,l,g,E,L,v,t,d);return r?r.then(u=>{if(!u){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.m(u);return(u.tunnelRemoteHost!==l||u.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(n),n}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const l=this.d.get(s.tunnelRemoteHost);if(l){const g=l.get(s.tunnelRemotePort);g&&(g.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,g))}}}}async n(s,l,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${l}.`);const E=g.value.then(async L=>{L&&(await L.dispose(!0),this.b.fire({host:L.tunnelRemoteHost,port:L.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(l),E}}async closeTunnel(s,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${l} `);const g=this.d.get(s);if(g&&g.has(l)){const E=g.get(l);E.refcount=0,await this.n(s,l,E)}}o(s,l,g){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(l,{refcount:1,value:g})}async p(s,l){const g=this.d.get(s);g&&(await g.get(l)||g.delete(l),g.size===0&&this.d.delete(s))}q(s,l){const g=[s];N(s)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(s)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(L=>this.d.get(L));for(const L of E){const v=L?.get(l);if(v)return v}}canTunnel(s){return!!k(s)}s(s,l,g,E,L,v,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${g} on local port ${E}.`);const d=g;this.h.add(d);const r=E===void 0?g:E,u={elevationRequired:L?this.isPortPrivileged(r):!1},n={remoteAddress:{host:l,port:g},localAddressPort:E,privacy:v,public:v?v!==O.Private:void 0,protocol:t},p=s.forwardPort(n,u);return p?(this.o(l,g,p),p.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),p}};f=Ke([je(0,M.ILogService),je(1,C.IConfigurationService)],f),e.AbstractTunnelService=f}),define(ke[174],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var C;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ke[175],Te([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(S){return S.scheme!==i.Schemas.file&&S.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=C;function D(S){if(S.folders.length)return S.folders.every(k=>C(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&C(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=D;function M(S){return D(S)?.scheme}e.getVirtualWorkspaceScheme=M;function y(S){return D(S)?.authority}e.getVirtualWorkspaceAuthority=y;function O(S){return D(S)!==void 0}e.isVirtualWorkspace=O}),define(ke[53],Te([1,0,138,19,48,24,2,3,15]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,O.createDecorator)("contextService");function k(r){const u=r;return typeof u?.id=="string"&&y.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=k;function N(r){return typeof r?.id=="string"&&!k(r)&&!h(r)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(r,u){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,C.basename)(r)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const n=r;return n.configuration?{id:n.id,configPath:n.configuration}:n.folders.length===1?{id:n.id,uri:n.folders[0].uri}:{id:n.id}}e.toWorkspaceIdentifier=w;function h(r){const u=r;return typeof u?.id=="string"&&y.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=h;function b(r){const u=r;if(u?.uri)return{id:u.id,uri:y.URI.revive(u.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:y.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=b;var f;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function a(r){const u=r;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=a;function s(r){const u=r;return!!(u&&typeof u=="object"&&y.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=s;class l{constructor(u,n,p,o,c){this.h=u,this.j=p,this.k=o,this.l=c,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=n}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class g{constructor(u,n){this.raw=n,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,M.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function E(r){return new g({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function L(r,u){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,u.untitledWorkspacesHome)}e.isUntitledWorkspace=L;function v(r){let u;return y.URI.isUri(r)?u=r:u=r.configuration,u?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=v;function t(r,u){return!L(r,u)&&!v(r)}e.isSavedWorkspace=t;function d(r){return(typeof r=="string"?(0,C.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=d}),define(ke[54],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const M=this.c++;return this.b.set(M,D),this.e(),M}get(D,M){return this.b.has(D)?this.b.get(D)[M]:void 0}delete(D){this.b.delete(D),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}i.a=!1,e.Cache=i}),define(ke[36],Te([1,0,15,24,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new C.ExtUri(O=>{const S=this.b.get(O.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(O,S){S===null?this.b.delete(O.scheme):this.b.set(O.scheme,S)}isFreeScheme(O){return!this.b.has(O)&&!this.a.has(O)}getCapabilities(O){return this.b.get(O)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(ke[27],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(ke[176],Te([1,0,11,162,27]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends C.LogService{constructor(O,S){super(O.createLogger(S.logFile,{name:S.logName}))}};M=Ke([je(0,i.ILoggerService),je(1,D.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(ke[177],Te([1,0,17]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(y,O,S){this.h=new Map,this.a=y,this.b=O,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const w of k.values())w.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this.d}get(y,O){let S=this.f[y];return typeof S>"u"&&(S=O),S}update(y,O){this.f[y]=O;const S=this.h.get(y);if(S!==void 0)return S.p;const k=new i.DeferredPromise;return this.h.set(y,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=C;class D extends C{setKeysForSync(y){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},y)}constructor(y,O){super(y.identifier.value,!0,O),this.j=y}}e.ExtensionGlobalMemento=D}),define(ke[178],Te([1,0,4,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(y){this.c=y,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(y,O,S,k){const w=this.c.getNotebookDocument(C.URI.revive(y)).acceptModelChanged(O.value,S,k);this.b.fire(w)}$acceptDirtyStateChanged(y,O){this.c.getNotebookDocument(C.URI.revive(y)).acceptDirty(O)}$acceptModelSaved(y){const O=this.c.getNotebookDocument(C.URI.revive(y));this.a.fire(O.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(ke[18],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[179],Te([1,0,25,4]),function(te,e,i,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(O,S){D.set(this,void 0),this.b=new C.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(O.identifier),Je(this,D,S,"f"),Le(this,D,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(O){return Le(this,D,"f").get(this.a,O)}store(O,S){return Le(this,D,"f").store(this.a,O,S)}delete(O){return Le(this,D,"f").delete(this.a,O)}}e.ExtensionSecrets=M,D=new WeakMap}),define(ke[70],Te([1,0,3,173,4,18]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(S){function k(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}S.fromApiTunnel=k;function N(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}S.fromServiceTunnel=N})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let O=class{constructor(k){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,N){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,N){return{dispose:()=>{}}}async $providePortAttributes(k,N,w,h,b){return[]}async $forwardPort(k,N){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};O=Ke([je(0,M.IExtHostRpcService)],O),e.ExtHostTunnelService=O}),define(ke[55],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=C}),define(ke[180],Te([1,0,23]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function D(O,S){if(S.serializeBuffersForPostMessage){const k=new C,N=(b,f)=>{if(f instanceof ArrayBuffer){const a=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(f)){const a=M(f);if(a){const s=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:s,view:{type:a,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},w=JSON.stringify(O,N),h=k.buffers.map(b=>{const f=new Uint8Array(b);return i.VSBuffer.wrap(f)});return{message:w,buffers:h}}else return{message:JSON.stringify(O),buffers:[]}}e.serializeWebviewMessage=D;function M(O){switch(O.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(O,S){const k=S.map(h=>{const b=new ArrayBuffer(h.byteLength);return new Uint8Array(b).set(h.buffer),b}),N=S.length?(h,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:a}=f,s=k[a];if(f.view)switch(f.view.type){case 1:return new Int8Array(s,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return b}:void 0;return{message:JSON.parse(O,N),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(ke[95],Te([1,0,147,9,2,6,3,30,43,15,39,124,29]),function(te,e,i,C,D,M,y,O,S,k,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function a(x){const X=x;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.isEditorPaneWithSelection=a;function s(x,X,J){for(const de of J.visibleEditorPanes)if(de.group.id===X&&x.matches(de.input))return de.getViewState()}e.findViewStateForEditor=s;function l(x){if(c(x))return!1;const X=x;return D.URI.isUri(X?.resource)}e.isResourceEditorInput=l;function g(x){if(c(x))return!1;const X=x;return X?.original!==void 0&&X.modified!==void 0}e.isResourceDiffEditorInput=g;function E(x){if(c(x)||g(x))return!1;const X=x;return X?.primary!==void 0&&X.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function L(x){if(c(x))return!1;const X=x;return X?X.resource===void 0||X.resource.scheme===k.Schemas.untitled||X.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=L;const v=/Untitled-\d+/;function t(x){return x.scheme===k.Schemas.untitled&&x.path.length>1&&!v.test(x.path)}e.isUntitledWithAssociatedResource=t;function d(x){if(c(x))return!1;const X=x;return D.URI.isUri(X?.base?.resource)&&D.URI.isUri(X?.input1?.resource)&&D.URI.isUri(X?.input2?.resource)&&D.URI.isUri(X?.result?.resource)}e.isResourceMergeEditorInput=d;var r;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var u;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u=e.SaveReason||(e.SaveReason={}));class n{constructor(){this.a=new Map}registerSource(X,J){let de=this.a.get(X);return de||(de={source:X,label:J},this.a.set(X,de)),de.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.SaveSourceRegistry=new n;var p;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(p=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends M.Disposable{}e.AbstractEditorInput=o;function c(x){return x instanceof o}e.isEditorInput=c;function m(x){const X=x;return D.URI.isUri(X?.preferredResource)}function P(x){const X=x;return c(X?.primary)&&c(X?.secondary)}e.isSideBySideEditorInput=P;function T(x){const X=x;return c(X?.modified)&&c(X?.original)}e.isDiffEditorInput=T;function V(x,X,J,de,ye){return Se(de,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const Ne={...J,limits:{size:Number.MAX_VALUE}};x.openEditor(X,Ne)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.createTooLargeFileError=V;function _(x){return c(x?.editor)}e.isEditorInputWithOptions=_;function K(x){const X=x;return _(x)&&X?.group!==void 0}e.isEditorInputWithOptionsAndGroup=K;function A(x){const X=x;return typeof X?.groupId=="number"&&c(X.editor)}e.isEditorIdentifier=A;var U;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var R;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(R=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class H{getOriginalUri(X,J){if(!X)return;if(d(X))return e.EditorResourceAccessor.getOriginalUri(X.result,J);if(J?.supportSideBySide){const{primary:ye,secondary:Ne}=this.a(X);if(ye&&Ne){if(J?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(Ne,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===F.ANY)return this.getOriginalUri(ye,{filterByScheme:J.filterByScheme})??this.getOriginalUri(Ne,{filterByScheme:J.filterByScheme});X=J.supportSideBySide===F.PRIMARY?ye:Ne}}if(g(X)||E(X)||d(X))return;const de=m(X)?X.preferredResource:X.resource;return!de||!J||!J.filterByScheme?de:this.b(de,J.filterByScheme)}a(X){return P(X)||E(X)?{primary:X.primary,secondary:X.secondary}:T(X)||g(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,J){if(!X)return;if(d(X))return e.EditorResourceAccessor.getCanonicalUri(X.result,J);if(J?.supportSideBySide){const{primary:ye,secondary:Ne}=this.a(X);if(ye&&Ne){if(J?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(Ne,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===F.ANY)return this.getCanonicalUri(ye,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(Ne,{filterByScheme:J.filterByScheme});X=J.supportSideBySide===F.PRIMARY?ye:Ne}}if(g(X)||E(X)||d(X))return;const de=X.resource;return!de||!J||!J.filterByScheme?de:this.b(de,J.filterByScheme)}b(X,J){if(Array.isArray(J)){if(J.some(de=>X.scheme===de))return X}else if(J===X.scheme)return X}}e.EditorResourceAccessor=new H;var j;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(X){const J=this.a=X.get(y.IInstantiationService);for(const[de,ye]of this.c)this.e(de,ye,J);this.c.clear()}e(X,J,de){const ye=de.createInstance(J);this.d.set(X,ye)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,C.assertIsDefined)(this.b)}registerEditorSerializer(X,J){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,J,this.a):this.c.set(X,J),(0,M.toDisposable)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}O.Registry.add(e.EditorExtensions.EditorFactory,new le);async function ge(x,X,J){return!x||!x.length?[]:await Promise.all(x.map(async de=>{const ye=D.URI.revive(de.fileUri);if(!ye){J.info("Cannot resolve the path because it is not valid.",de);return}if(!await X.canHandleResource(ye)){J.info("Cannot resolve the path because it cannot be handled",de);return}let We=de.exists,Pe=de.type;if(typeof We!="boolean"||typeof Pe!="number")try{Pe=(await X.stat(ye)).isDirectory?S.FileType.Directory:S.FileType.Unknown,We=!0}catch(we){J.error(we),We=!1}if(!We&&de.openOnlyIfExists){J.info("Cannot resolve the path because it does not exist",de);return}if(Pe===S.FileType.Directory){J.info("Cannot resolve the path because it is a directory",de);return}const Ce={...de.options,pinned:!0};return We?{resource:ye,options:Ce}:{resource:ye,options:Ce,forceUntitled:!0}}))}e.pathsToEditors=ge;var re;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(re=e.EditorsOrder||(e.EditorsOrder={}));function ae(x){const X=x;if(!X)return!1;const J=X;if(J.modified)return ae(J.modified);const de=X;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.isTextEditorViewState=ae;function ce(x){return(0,N.isErrorWithActions)(x)}e.isEditorOpenError=ce;function Se(x,X,J){const de=(0,N.createErrorWithActions)(x,X);return de.forceMessage=J?.forceMessage,de.forceSeverity=J?.forceSeverity,de.allowDialog=J?.allowDialog,de}e.createEditorOpenError=Se}),define(ke[181],Te([1,0,4,148,3,6,28,30,16,63,22,84,172]),function(te,e,i,C,D,M,y,O,S,k,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",w.Codicon.window,(0,C.localize)(0,null));var b;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var f;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function a(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=a;class s extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new i.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(u,n,p){const o=this.get(u.id);if(o)return o;const c=u;return c.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:c.openCommandActionDescriptor??{id:c.id},(0,y.getOrSet)(this.g,n,[]).push(c),p?.isDefault&&this.h.push(c),this.c.fire({viewContainer:c,viewContainerLocation:n}),c}deregisterViewContainer(u){for(const n of this.g.keys()){const p=this.g.get(n),o=p?.indexOf(u);if(o!==-1){p?.splice(o,1),p.length===0&&this.g.delete(n),this.f.fire({viewContainer:u,viewContainerLocation:n});return}}}get(u){return this.all.filter(n=>n.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(n=>this.getViewContainers(n).filter(p=>p?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(n=>this.getViewContainerLocation(n)===u)}}O.Registry.add(b.ViewContainersRegistry,new s);var l;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function g(r,u){const n=r.group??l.More,p=u.group??l.More;return n!==p?n.localeCompare(p):(r.order??5)-(u.order??5)}class E extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new i.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new i.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new i.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(u,n){this.registerViews2([{views:u,viewContainer:n}])}registerViews2(u){u.forEach(({views:n,viewContainer:p})=>this.l(n,p)),this.c.fire(u)}deregisterViews(u,n){const p=this.m(u,n);p.length&&this.f.fire({views:p,viewContainer:n})}moveViews(u,n){for(const p of this.j.keys())if(p!==n){const o=this.m(u,p);o.length&&(this.l(o,n),this.g.fire({views:o,from:p,to:n}))}}getViews(u){return this.j.get(u)||[]}getView(u){for(const n of this.i){const p=(this.j.get(n)||[]).filter(o=>o.id===u)[0];if(p)return p}return null}getViewContainer(u){for(const n of this.i)if((this.j.get(n)||[]).filter(o=>o.id===u)[0])return n;return null}registerViewWelcomeContent(u,n){return this.k.add(u,n),this.h.fire(u),(0,M.toDisposable)(()=>{this.k.delete(u,n),this.h.fire(u)})}registerViewWelcomeContent2(u,n){const p=new Map;for(const[o,c]of n)this.k.add(u,c),p.set(o,(0,M.toDisposable)(()=>{this.k.delete(u,c),this.h.fire(u)}));return this.h.fire(u),p}getViewWelcomeContent(u){const n=[];return this.k.forEach(u,p=>n.push(p)),n.sort(g)}l(u,n){let p=this.j.get(n);p||(p=[],this.j.set(n,p),this.i.push(n));for(const o of u){if(this.getView(o.id)!==null)throw new Error((0,C.localize)(1,null,o.id));p.push(o)}}m(u,n){const p=this.j.get(n);if(!p)return[];const o=[],c=[];for(const m of p)u.includes(m)?o.push(m):c.push(m);return o.length&&(c.length?this.j.set(n,c):(this.j.delete(n),this.i.splice(this.i.indexOf(n),1))),o}}O.Registry.add(b.ViewsRegistry,new E),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var L;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(L=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(u,n){this.c=!1,this.d=!1,(0,N.mixin)(this,u),this.d=!!n,this.resolve=async p=>{if(n&&!this.c){const o=await n(p);o&&(this.tooltip=this.tooltip??o.tooltip,this.command=this.command??o.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class d extends Error{constructor(u){super((0,C.localize)(2,null,u))}}e.NoTreeViewError=d}),define(ke[182],Te([1,0,4,17,149]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(O){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=O}onEvent(O){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=O}onRequest(O){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.s("response",O)}sendRequest(O,S,k,N){const w={command:O};if(S&&Object.keys(S).length>0&&(w.arguments=S),this.s("request",w),typeof N=="number"){const h=setTimeout(()=>{clearTimeout(h);const b=this.f.get(w.seq);if(b){this.f.delete(w.seq);const f={type:"response",seq:0,request_seq:w.seq,success:!1,command:O,message:(0,D.localize)(0,null,N,O)};b(f)}},N)}return k&&this.f.set(w.seq,k),w.seq}acceptMessage(O){this.j?this.j(O):(this.k.push(O),this.k.length===1&&this.q())}o(O,S){return O.type!=="event"||S.type!=="event"}async q(){let O;for(;this.k.length;){if((!O||this.o(this.k[0],O))&&await(0,C.timeout)(0),O=this.k.shift(),!O)return;switch(O.type){case"event":this.i?.(O);break;case"request":this.g?.(O);break;case"response":{const S=O,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(O,S){S.type=O,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((S,k)=>O.set(k,S)),await(0,C.timeout)(500),O.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(ke[183],Te([1,0,150,42,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const M=h=>i.localize(51,null,h);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var y;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(y=e.State||(e.State={}));function O(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=O;var S;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var w;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ke[184],Te([1,0,10,2,19,22,15,44,21,16]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const N=/{([^}]+)}/g;function w(o,c,m){return o.replace(N,function(P,T){return c&&T.length>0&&T[0]!=="_"?P:m&&m.hasOwnProperty(T)?m[T]:P})}e.formatPII=w;function h(o){const c={};for(const m of Object.keys(o))m.startsWith("!")||(c[m]=o[m]);return c}e.filterExceptionsFromTelemetry=h;function b(o){return o.configuration.request==="attach"&&!f(o)&&(!o.parentSession||b(o.parentSession))}e.isSessionAttach=b;function f(o){let c=o.configuration.type;if(!!c)return c==="vslsShare"&&(c=o.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(c,"extensionhost")||(0,i.equalsIgnoreCase)(c,"pwa-extensionhost")?o:o.parentSession?f(o.parentSession):void 0}e.getExtensionHostDebugSession=f;function a(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=a;function s(o,c,m){let P,T=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let _=null;for(;_=V.exec(o);){const K=_.index+1,A=K+_[0].length;if(K<=c&&A>=m){P=_[0],T=K;break}}if(P){const K=/\w+/g;let A=null;for(;(A=K.exec(P))&&!(A.index+1+T+A[0].length>=m););A&&(P=P.substring(0,K.lastIndex))}return P?{start:T,end:T+P.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=s;async function l(o,c,m,P){if(o.evaluatableExpressionProvider.has(c)){const T=o.evaluatableExpressionProvider.ordered(c),V=(0,k.coalesce)(await Promise.all(T.map(async _=>{try{return await _.provideEvaluatableExpression(c,m,P??S.CancellationToken.None)}catch{return}})));if(V.length>0){let _=V[0].expression;const K=V[0].range;return _||(_=c.getLineContent(m.lineNumber).substring(K.startColumn-1,K.endColumn-1)),{range:K,matchingExpression:_}}}else{const T=c.getLineContent(m.lineNumber),{start:V,end:_}=s(T,m.column,m.column),K=T.substring(V-1,_);return{matchingExpression:K,range:new O.Range(m.lineNumber,V,m.lineNumber,V+K.length)}}return null}e.getEvaluatableExpressionAtPosition=l;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function E(o){return!!(o&&o.match(g))}e.isUri=E;function L(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(E(o.path))return C.URI.parse(o.path);if((0,D.isAbsolute)(o.path))return C.URI.file(o.path)}return o.path}function v(o){if(typeof o.path=="object"){const c=C.URI.revive(o.path);if(c)return c.scheme===y.Schemas.file?c.fsPath:c.toString()}return o.path}function t(o,c){const m=c?L:v,P=(0,M.deepClone)(o);return r(P,(T,V)=>{T&&V&&(V.path=m(V))}),P}e.convertToDAPaths=t;function d(o,c){const m=c?L:v,P=(0,M.deepClone)(o);return r(P,(T,V)=>{!T&&V&&(V.path=m(V))}),P}e.convertToVSCPaths=d;function r(o,c){switch(o.type){case"event":{const m=o;switch(m.event){case"output":c(!1,m.body.source);break;case"loadedSource":c(!1,m.body.source);break;case"breakpoint":c(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=o;switch(m.command){case"setBreakpoints":c(!0,m.arguments.source);break;case"breakpointLocations":c(!0,m.arguments.source);break;case"source":c(!0,m.arguments.source);break;case"gotoTargets":c(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(P=>c(!1,P));break;default:break}break}case"response":{const m=o;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(P=>c(!1,P.source));break;case"loadedSources":m.body.sources.forEach(P=>c(!1,P));break;case"scopes":m.body.scopes.forEach(P=>c(!1,P.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(P=>c(!1,P.source));break;case"setBreakpoints":m.body.breakpoints.forEach(P=>c(!1,P.source));break;case"disassemble":m.body?.instructions.forEach(T=>c(!1,T.location));break;default:break}break}}}function u(o){return o.filter(c=>!c.presentation?.hidden).sort((c,m)=>c.presentation?m.presentation?c.presentation.group?m.presentation.group?c.presentation.group!==m.presentation.group?c.presentation.group.localeCompare(m.presentation.group):n(c.presentation.order,m.presentation.order):-1:m.presentation.group?1:n(c.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=u;function n(o,c){return typeof o!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:o-c}async function p(o,c){const m=o.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(m!=="none"&&(await c.saveAll(),m==="allEditorsInActiveGroup")){const P=c.activeEditorPane;P&&P.input.resource?.scheme===y.Schemas.untitled&&await c.save({editor:P.input,groupId:P.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(ke[71],Te([1,0,23,35,185,65,15,19,20,42]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var h;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(h=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var g;(function(F){F.scheme=y.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${H.join("")}]+`),le=7;function ge(X,J){const de=J.toString(le),Ne=`${de.length<H.length?H[de.length-1]:"z"}${de}s${(0,i.encodeBase64)(i.VSBuffer.fromString(X.scheme),!0,!0)}`;return X.with({scheme:F.scheme,fragment:Ne})}F.generate=ge;function re(X){if(X.scheme!==F.scheme)return;const J=X.fragment.indexOf("s");if(J<0)return;const de=parseInt(X.fragment.substring(0,J).replace(j,""),le),ye=(0,i.decodeBase64)(X.fragment.substring(J+1)).toString();if(!isNaN(de))return{handle:de,notebook:X.with({scheme:ye,fragment:null})}}F.parse=re;function ae(X,J){return X.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${J??""},${X.scheme!==y.Schemas.file?X.scheme:""}`})}F.generateCellOutputUri=ae;function ce(X){if(X.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const J=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(X.fragment);if(!J)return;const de=J[1]&&J[1]!==""?J[1]:void 0,ye=J[2];return{outputId:de,notebook:X.with({scheme:ye||y.Schemas.file,fragment:null})}}F.parseCellOutputUri=ce;function Se(X,J,de){return F.generate(X,J).with({scheme:de})}F.generateCellPropertyUri=Se;function x(X,J){if(X.scheme===J)return F.parse(X.with({scheme:F.scheme}))}F.parseCellPropertyUri=x})(g=e.CellUri||(e.CellUri={}));const E=F=>S.isWindows?F.replace(/\//g,"\\"):F;class L{constructor(H=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(H)].map(le=>({pattern:le,matches:C.parse(E(le))}))}sort(H){const j=new Map(D.Iterable.map(H,ge=>[ge,E(ge)]));let le=[];for(const{matches:ge}of this.d)for(const[re,ae]of j)if(ge(ae)){le.push(re),j.delete(re);break}return j.size&&(le=le.concat([...j.keys()].sort((ge,re)=>this.e.indexOf(ge)-this.e.indexOf(re)))),le}prioritize(H,j){const le=this.f(H);if(le===-1){this.d.unshift({pattern:H,matches:C.parse(E(H))});return}const ge=new Set(j.map(ae=>this.f(ae,le)));ge.delete(-1);const re=Array.from(ge).sort();this.d.splice(le+1,0,...re.map(ae=>this.d[ae]));for(let ae=re.length-1;ae>=0;ae--)this.d.splice(re[ae],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,j=this.d.length){const le=E(H);for(let ge=0;ge<j;ge++)if(this.d[ge].matches(le))return ge;return-1}}e.MimeTypeDisplayOrder=L;function v(F,H,j,le=(ge,re)=>ge===re){const ge=[];function re(Se,x,X){if(x===0&&X.length===0)return;const J=ge[ge.length-1];J&&J.start+J.deleteCount===Se?(J.deleteCount+=x,J.toInsert.push(...X)):ge.push({start:Se,deleteCount:x,toInsert:X})}let ae=0,ce=0;for(;;){if(ae===F.length){re(ae,0,H.slice(ce));break}if(ce===H.length){re(ae,F.length-ae,[]);break}const Se=F[ae],x=H[ce];if(le(Se,x)){ae+=1,ce+=1;continue}j(x)?(re(ae,1,[]),ae+=1):(re(ae,0,[x]),ce+=1)}return ge}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(F){F.default="default",F.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(F){const H=F;return!!((typeof H.include=="string"||C.isRelativePattern(H.include))&&(typeof H.exclude=="string"||C.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=d;function r(F,H,j){if(Array.isArray(F.viewType)&&F.viewType.indexOf(H)>=0||F.viewType===H)return!0;if(F.filenamePattern){const le=d(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,ge=d(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(C.match(le,(0,O.basename)(j.fsPath).toLowerCase()))return!(ge&&C.match(ge,(0,O.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var u;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class n{static create(H){return`${n.d}${H}`}static parse(H){if(H.startsWith(n.d))return H.substring(n.d.length)}}n.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=n;function p(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=p;const o=new TextDecoder;function c(F){const H=[];let j=!1;for(const le of F)(H.length===0||j)&&(H.push(le),j=!0);return V(H),R(i.VSBuffer.concat(H.map(le=>i.VSBuffer.wrap(le))))}e.compressOutputItemStreams=c;const m=`${String.fromCharCode(27)}[A`,P=m.split("").map(F=>F.charCodeAt(0)),T=10;function V(F){F.forEach((H,j)=>{if(j===0||H.length<m.length)return;const le=F[j-1],ge=H.subarray(0,m.length);if(ge[0]===P[0]&&ge[1]===P[1]&&ge[2]===P[2]){const re=le.lastIndexOf(T);if(re===-1)return;F[j-1]=le.subarray(0,re),F[j]=H.subarray(m.length)}})}function _(F){let H=F;do F=H,H=F.replace(/[^\n]\x08/gm,"");while(H.length<F.length);return F}function K(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const H=F.match(/^(.*)\r+/m)[1];let j=F.match(/\r+(.*)$/m)[1];j=j+H.slice(j.length,H.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return F}const A="\b".charCodeAt(0),U="\r".charCodeAt(0);function R(F){return!F.buffer.includes(A)&&!F.buffer.includes(U)?F:i.VSBuffer.fromString(K(_(o.decode(F.buffer))))}}),define(ke[186],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(ke[45],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(M){M.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(y,O,S=y.parent){if(y._isRoot)return new D([O]);const k=[y.id];for(let N=S;N&&N.id!==O;N=N.parent)k.push(N.id);return k.push(O),new D(k.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const O=y.indexOf("\0");return O===-1?y:y.slice(0,O)}static fromString(y){return new D(y.split("\0"))}static join(y,O){return new D([...y.path,O])}static joinToString(y,O){return y.toString()+"\0"+O}static parentId(y){const O=y.lastIndexOf("\0");return O===-1?void 0:y.slice(0,O)}static localId(y){const O=y.lastIndexOf("\0");return O===-1?y:y.slice(O+1)}static compare(y,O){return y===O?0:O.startsWith(y+"\0")?2:y.startsWith(O+"\0")?3:1}constructor(y,O=y.length){if(this.path=y,this.d=O,y.length===0||O<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let y=1;y<=this.d;y++)yield new D(this.path,y)}*idsToRoot(){for(let y=this.d;y>0;y--)yield new D(this.path,y)}compare(y){if(typeof y=="string")return D.compare(this.toString(),y);for(let O=0;O<y.d&&O<this.d;O++)if(y.path[O]!==this.path[O])return 1;return y.d>this.d?2:y.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let y=1;y<this.d;y++)this.c+="\0",this.c+=this.path[y]}return this.c}}e.TestId=D}),define(ke[56],Te([1,0,2,44,45]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(o){o[o.Unset=0]="Unset",o[o.Queued=1]="Queued",o[o.Running=2]="Running",o[o.Passed=3]="Passed",o[o.Failed=4]="Failed",o[o.Skipped=5]="Skipped",o[o.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var y;(function(o){o[o.Run=2]="Run",o[o.Debug=4]="Debug",o[o.Coverage=8]="Coverage",o[o.HasNonDefaultProfile=16]="HasNonDefaultProfile",o[o.HasConfigurable=32]="HasConfigurable",o[o.SupportsContinuousRun=64]="SupportsContinuousRun"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const O=o=>"runId"in o;e.isStartControllerTests=O;var S;(function(o){o.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),o.deserialize=c=>({range:C.Range.lift(c.range),uri:i.URI.revive(c.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var k;(function(o){o[o.Error=0]="Error",o[o.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var N;(function(o){o.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&S.serialize(c.location)}),o.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&S.deserialize(c.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(o,c)=>`${c?"s":"e"}${o}`;e.getMarkId=w;var h;(function(o){o.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&S.serialize(c.location)}),o.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&S.deserialize(c.location)})})(h=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(o){o.serialize=c=>c.type===0?N.serialize(c):h.serialize(c),o.deserialize=c=>c.type===0?N.deserialize(c):h.deserialize(c)})(b=e.ITestMessage||(e.ITestMessage={}));var f;(function(o){o.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),o.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(b.serialize)}),o.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(b.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const a="\0",s=(o,c)=>o+a+c;e.namespaceTestTag=s;const l=o=>{const c=o.indexOf(a);return{ctrlId:o.slice(0,c),tagId:o.slice(c+1)}};e.denamespaceTestTag=l;var g;(function(o){o.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),o.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?i.URI.revive(c.uri):void 0,range:c.range?C.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(g=e.ITestItem||(e.ITestItem={}));var E;(function(o){o[o.NotExpandable=0]="NotExpandable",o[o.Expandable=1]="Expandable",o[o.BusyExpanding=2]="BusyExpanding",o[o.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var L;(function(o){o.serialize=c=>({expand:c.expand,item:g.serialize(c.item)}),o.deserialize=c=>({controllerId:D.TestId.root(c.item.extId),expand:c.expand,item:g.deserialize(c.item)})})(L=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(o){o.serialize=c=>{let m;return c.item&&(m={},c.item.label!==void 0&&(m.label=c.item.label),c.item.tags!==void 0&&(m.tags=c.item.tags),c.item.busy!==void 0&&(m.busy=c.item.busy),c.item.uri!==void 0&&(m.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(m.range=c.item.range?.toJSON()),c.item.description!==void 0&&(m.description=c.item.description),c.item.error!==void 0&&(m.error=c.item.error),c.item.sortText!==void 0&&(m.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:m}},o.deserialize=c=>{let m;return c.item&&(m={},c.item.label!==void 0&&(m.label=c.item.label),c.item.tags!==void 0&&(m.tags=c.item.tags),c.item.busy!==void 0&&(m.busy=c.item.busy),c.item.range!==void 0&&(m.range=c.item.range?C.Range.lift(c.item.range):null),c.item.description!==void 0&&(m.description=c.item.description),c.item.error!==void 0&&(m.error=c.item.error),c.item.sortText!==void 0&&(m.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:m}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(o,c)=>{c.expand!==void 0&&(o.expand=c.expand),c.item!==void 0&&(o.item=o.item?Object.assign(o.item,c.item):c.item)};e.applyTestItemUpdate=t;var d;(function(o){o.serializeWithoutMessages=c=>({...L.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serializeWithoutMessages),retired:c.retired}),o.serialize=c=>({...L.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serialize),retired:c.retired}),o.deserialize=c=>({...L.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var r;(function(o){o[o.Function=0]="Function",o[o.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var u;(function(o){o[o.Add=0]="Add",o[o.Update=1]="Update",o[o.DocumentSynced=2]="DocumentSynced",o[o.Remove=3]="Remove",o[o.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",o[o.Retire=5]="Retire",o[o.AddTag=6]="AddTag",o[o.RemoveTag=7]="RemoveTag"})(u=e.TestDiffOpType||(e.TestDiffOpType={}));var n;(function(o){o.deserialize=c=>c.op===0?{op:c.op,item:L.deserialize(c.item)}:c.op===1?{op:c.op,item:v.deserialize(c.item)}:c.op===2?{op:c.op,uri:i.URI.revive(c.uri),docv:c.docv}:c,o.serialize=c=>c.op===0?{op:c.op,item:L.serialize(c.item)}:c.op===1?{op:c.op,item:v.serialize(c.item)}:c})(n=e.TestsDiffOp||(e.TestsDiffOp={}));class p{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(c){const m=this.o();for(const P of c)switch(P.op){case 0:this.j(L.deserialize(P.item),m);break;case 1:this.k(v.deserialize(P.item),m);break;case 3:this.l(P.itemId,m);break;case 5:this.m(P.itemId);break;case 4:this.updatePendingRoots(P.amount);break;case 6:this.c.set(P.tag.id,P.tag);break;case 7:this.c.delete(P.id);break}m.complete?.()}j(c,m){const P=D.TestId.parentId(c.item.extId)?.toString();let T;if(!P)T=this.p(c),this.f.add(T),this.d.set(c.item.extId,T);else if(this.d.has(P)){const V=this.d.get(P);V.children.add(c.item.extId),T=this.p(c,V),this.d.set(c.item.extId,T)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return m.add?.(T),c.expand===2&&this.g++,T}k(c,m){const P=this.d.get(c.extId);if(!!P)return c.expand!==void 0&&(P.expand===2&&this.g--,c.expand===2&&this.g++),(0,e.applyTestItemUpdate)(P,c),m.update?.(P),P}l(c,m){const P=this.d.get(c);if(!P)return;const T=D.TestId.parentId(P.item.extId)?.toString();T?this.d.get(T).children.delete(P.item.extId):this.f.delete(P);const V=[[c]];for(;V.length;)for(const _ of V.pop()){const K=this.d.get(_);K&&(V.push(K.children),this.d.delete(_),m.remove?.(K,K!==P),K.expand===2&&this.g--)}}m(c){}updatePendingRoots(c){this.h+=c}o(){return{}}}e.AbstractIncrementalTestCollection=p}),define(ke[72],Te([1,0,17,4,6,49,56,45]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(g,E)=>g===E,w=Object.entries({range:(g,E)=>g===E?!0:!g||!E?!1:g.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(g,E)=>!(g.length!==E.length||g.some(L=>!E.includes(L)))}),h=(g,E)=>{let L;for(const[v,t]of w)t(g[v],E[v])||(L?L[v]=E[v]:L={[v]:E[v]});return L};class b extends D.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new C.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const L of this.tree.values())this.G(L)}get resolveHandler(){return this.h}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const L of this.k)if(L.op===2&&L.uri===E.uri){L.docv=E.docv;return}break}case 1:{const L=this.k[this.k.length-1];if(L){if(L.op===1&&L.item.extId===E.item.extId){(0,y.applyTestItemUpdate)(L.item,E.item);return}if(L.op===0&&L.item.item.extId===E.item.extId){(0,y.applyTestItemUpdate)(L.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,L){const v=this.tree.get(E);if(!!v){if((v.expandLevels===void 0||L>v.expandLevels)&&(v.expandLevels=L),v.expand===1){const t=this.I(v);return t.isOpen()?this.H(v,L-1):t.wait().then(()=>this.H(v,L-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,L-1)):this.H(v,L-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,L){switch(L.op){case 3:this.L(O.TestId.joinToString(E.fullId,L.id));break;case 0:this.u(L.item,E);break;case 5:for(const v of L.ops)this.p(E,v);break;case 1:this.w(L.new,L.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:L.update}});break;case 6:this.s(E.actual.uri);break;default:(0,M.assertNever)(L)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,L){const v=O.TestId.fromExtHostTestItem(E,this.root.id,L?.actual),t=this.m.getApiFor(E);t.parent&&t.parent!==L?.actual&&this.m.getChildren(t.parent).delete(E.id);let d=this.tree.get(v.toString());if(!d){d={fullId:v,actual:E,expandLevels:L?.expandLevels?L.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(E,L),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(E)}}),this.F(E,d,L);return}if(d.actual===E){this.D(E,d,L);return}if(d.actual.uri?.toString()!==E.uri?.toString())return this.L(v.toString()),this.u(E,L);const r=this.m.getChildren(d.actual),u=d.actual,n=h(this.m.toITestItem(u),this.m.toITestItem(E));this.m.getApiFor(u).listener=void 0,d.actual=E,d.expand=0,n&&(n.hasOwnProperty("tags")&&(this.w(E.tags,u.tags,v.toString()),delete n.tags),this.p(d,{op:4,update:n})),this.F(E,d,L);for(const[p,o]of r)this.m.getChildren(E).get(o.id)||this.L(O.TestId.joinToString(v,o.id));this.s(d.actual.uri)}w(E,L,v){const t=new Set(L.map(d=>d.id));for(const d of E)t.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:v,item:{tags:E.map(d=>(0,y.namespaceTestTag)(this.m.controllerId,d.id))}}}),t.forEach(this.z,this)}y(E){const L=this.j.get(E.id);L?L.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const L=this.j.get(E);L&&!--L.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.m.controllerId,E)}))}C(E,L){this.m.getApiFor(E).parent=L&&L.actual!==this.root?L.actual:void 0}D(E,L,v){this.C(E,v);const t=this.m.getApiFor(E);t.parent=v?.actual,t.listener=d=>this.p(L,d),this.G(L)}F(E,L,v){this.D(E,L,v);for(const[t,d]of this.m.getChildren(E))this.u(d,L)}G(E){let L;this.h?E.resolveBarrier?L=E.resolveBarrier.isOpen()?3:2:L=E.actual.canResolveChildren?1:0:L=0,L!==E.expand&&(E.expand=L,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:L}}),L===1&&E.expandLevels!==void 0&&this.I(E))}H(E,L){if(L<0)return;const v=[];for(const[t,d]of this.m.getChildren(E.actual)){const r=this.expand(O.TestId.joinToString(E.fullId,d.id),L);(0,i.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const d=new i.Barrier;return d.open(),d}E.expand=2,this.J(E);const L=E.resolveBarrier=new i.Barrier,v=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let t;try{t=this.h(E.actual===this.root?void 0:E.actual)}catch(d){v(d)}return(0,i.isThenable)(t)?t.catch(v).then(()=>{L.open(),this.G(E)}):(L.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const L=this.tree.get(E);if(!L)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const v=[L];for(;v.length;){const t=v.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.z(d.id);this.tree.delete(t.fullId.toString());for(const[d,r]of this.m.getChildren(t.actual))v.push(this.tree.get(O.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=b;class f extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=f;class a extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class s extends Error{constructor(E,L,v){super(`TestItem with ID "${E}" is from controller "${L}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=s;const l=(g,E,L)=>{let v=new Map;return{get size(){return v.size},forEach(t,d){for(const r of v.values())t.call(d,r,this)},[Symbol.iterator](){return v.entries()},replace(t){const d=new Map,r=new Set(v.keys()),u={op:5,ops:[]};for(const n of t){if(!(n instanceof L))throw new a(n.id);const p=E(n).controllerId;if(p!==g.controllerId)throw new s(n.id,p,g.controllerId);if(d.has(n.id))throw new f(n.id);d.set(n.id,n),r.delete(n.id),u.ops.push({op:0,item:n})}for(const n of r.keys())u.ops.push({op:3,id:n});g.listener?.(u),v=d},add(t){if(!(t instanceof L))throw new a(t.id);v.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){v.delete(t)&&g.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=l}),define(ke[96],Te([1,0,72]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,D=(y,O)=>{const S={controllerId:O};return C.set(y,S),S};e.createPrivateApiFor=D;const M=y=>{const O=C.get(y);if(!O)throw new i.InvalidTestItemError(y?.id||"<unknown>");return O};e.getPrivateApiFor=M}),define(ke[73],Te([1,0,15,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(O,S){return O.scheme===i.Schemas.http||O.scheme===i.Schemas.https?O:(S&&S.authority&&S.isRemote&&O.scheme===i.Schemas.file&&(O=C.URI.from({scheme:i.Schemas.vscodeRemote,authority:S.authority,path:O.path})),C.URI.from({scheme:i.Schemas.https,authority:`${O.scheme}+${M(O.authority)}.${e.webviewRootResourceAuthority}`,path:O.path,fragment:O.fragment,query:O.query}))}e.asWebviewUri=D;function M(O){return O.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function y(O){return O.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=y}),define(ke[187],Te([1,0,4,6,73]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(O,S,k){this.d=O,this.e=S,this.f=k,this.a=0,this.b=new C.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const N=S.getVisibleTextEditors();for(const w of this.c.values())N.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,S,k,N,w){let h;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===O){h=E;break}if(!h)throw new Error("not a visible editor");const b=this,f=this.a++,a=new i.Emitter,s=new i.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,D.asWebviewUri)(E,b.f)}get cspSource(){return D.webviewGenericCspSource}set options(E){this.b=E,b.d.$setOptions(f,E)}get options(){return this.b}set html(E){this.a=E,b.d.$setHtml(f,E)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(E){return b.d.$postMessage(f,E)}},g=new class{constructor(){this.editor=O,this.line=S,this.height=k,this.webview=l,this.onDidDispose=s.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),s.fire(),s.dispose(),a.dispose())}};return this.d.$createEditorInset(f,h.id,h.value.document.uri,S+1,k,N||{},w.identifier,w.extensionLocation),this.c.set(f,{editor:O,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(O){const S=this.c.get(O);S&&S.inset.dispose()}$onDidReceiveMessage(O,S){this.c.get(O)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=M}),define(ke[188],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(y,O){super(O),this.variable=y}}e.VariableError=D}),define(ke[189],Te([1,0,19,51,9,22,20,87,153,188,10]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(b,f,a,s){this.g=new Map,this.a=b,this.b=f,this.d=a,s&&(this.c=s.then(l=>this.h(l)))}h(b){if(y.isWindows){const f=Object.create(null);return Object.keys(b).forEach(a=>{f[a.toLowerCase()]=b[a]}),f}return b}resolveWithEnvironment(b,f,a){return this.j({env:this.h(b),userHome:void 0},f?f.uri:void 0,a)}async resolveAsync(b,f){const a={env:await this.c,userHome:await this.d};return this.j(a,b?b.uri:void 0,f)}async i(b,f,a,s){const l=M.deepClone(f);y.isWindows&&l.windows?Object.keys(l.windows).forEach(E=>l[E]=l.windows[E]):y.isMacintosh&&l.osx?Object.keys(l.osx).forEach(E=>l[E]=l.osx[E]):y.isLinux&&l.linux&&Object.keys(l.linux).forEach(E=>l[E]=l.linux[E]),delete l.windows,delete l.osx,delete l.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,b?b.uri:void 0,l,a,s)}async resolveAnyAsync(b,f,a){return this.i(b,f,a)}async resolveAnyMap(b,f,a){const s=new Map;return{newConfig:await this.i(b,f,a,s),resolvedVariables:s}}resolveWithInteractionReplace(b,f,a,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,a,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,f)}async j(b,f,a,s,l){if(D.isString(a))return this.l(b,f,a,s,l);if(Array.isArray(a))return Promise.all(a.map(g=>this.j(b,f,g,s,l)));if(D.isObject(a)){const g=Object.create(null),E=await Promise.all(Object.keys(a).map(async L=>[await this.l(b,f,L,s,l),await this.j(b,f,a[L],s,l)]));for(const[L,v]of E)g[L]=v;return g}return a}l(b,f,a,s,l){return(0,N.replaceAsync)(a,w.VARIABLE_REGEXP,async(g,E)=>{if(E.includes(w.VARIABLE_LHS))return g;let L=await this.n(b,g,E,f,s);return l?.set(E,L),L!==g&&D.isString(L)&&L.match(w.VARIABLE_REGEXP)&&(L=await this.l(b,f,L,s,l)),L})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,f,a,s,l){let g;const E=a.split(":");E.length>1&&(a=E[0],g=E[1]);const L=d=>{const r=this.a.getFilePath();if(r)return(0,O.normalizeDriveLetter)(r);throw new k.VariableError(d,(0,S.localize)(0,null,f))},v=d=>{const r=L(d);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,O.normalizeDriveLetter)(u)}throw new k.VariableError(d,(0,S.localize)(1,null,f,i.basename(r)))},t=d=>{if(g){const r=this.a.getFolderUri(g);if(r)return r;throw new k.VariableError(d,(0,S.localize)(2,null,f,g))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(d,(0,S.localize)(3,null,f)):new k.VariableError(d,(0,S.localize)(4,null,f))};switch(a){case"env":if(g){if(b.env){const d=b.env[y.isWindows?g.toLowerCase():g];if(D.isString(d))return d}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,f));case"config":if(g){const d=this.a.getConfigurationValue(s,g);if(D.isUndefinedOrNull(d))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,f,g));if(D.isObject(d))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,f,g));return d}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,f));case"command":return this.o(k.VariableKind.Command,f,g,l,"command");case"input":return this.o(k.VariableKind.Input,f,g,l,"input");case"extensionInstallFolder":if(g){const d=await this.a.getExtension(g);if(!d)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,f,g));return this.m(d.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,f));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,O.normalizeDriveLetter)(this.m(t(k.VariableKind.WorkspaceFolder)));case"cwd":return s||g?(0,O.normalizeDriveLetter)(this.m(t(k.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.normalizeDriveLetter)(i.basename(this.m(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,f))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,f))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,f))}case"file":return L(k.VariableKind.File);case"fileWorkspaceFolder":return v(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||g?i.relative(this.m(t(k.VariableKind.RelativeFile)),L(k.VariableKind.RelativeFile)):L(k.VariableKind.RelativeFile);case"relativeFileDirname":{const d=i.dirname(L(k.VariableKind.RelativeFileDirname));if(s||g){const r=i.relative(this.m(t(k.VariableKind.RelativeFileDirname)),d);return r.length===0?".":r}return d}case"fileDirname":return i.dirname(L(k.VariableKind.FileDirname));case"fileExtname":return i.extname(L(k.VariableKind.FileExtname));case"fileBasename":return i.basename(L(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=i.basename(L(k.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-i.extname(d).length)}case"fileDirnameBasename":return i.basename(i.dirname(L(k.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||f}case"execInstallFolder":{const d=this.a.getAppRoot();return d||f}case"pathSeparator":return i.sep;default:try{const d=g?`${a}:${g}`:a;return this.o(k.VariableKind.Unknown,f,d,l,void 0)}catch{return f}}}}o(b,f,a,s,l){if(a&&s){const g=l===void 0?s[a]:s[l+":"+a];if(typeof g=="string")return g;throw new k.VariableError(b,(0,S.localize)(14,null,f))}return f}}w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=w}),define(ke[97],Te([1,0,3,95]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var D;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var O;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(O=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const a=f;return(0,C.isEditorInput)(a?.editor)&&(0,C.isEditorInput)(a?.replacement)}e.isEditorReplacement=k;var N;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function h(f){const a=f;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=h;function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ke[190],Te([1,0,3,97]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(M){const y=M;return typeof M=="number"||(0,C.isEditorGroup)(y)}e.isPreferredGroup=D}),define(ke[191],Te([1,0,3,159]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(C.IEnvironmentService)}),define(ke[98],Te([1,0,25,4,19]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=M;class y{static isHostExtension(w,h,b){if(h.getExtensionDescription(w))return!1;const f=b.getExtensionDescription(w);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(w){this.c=new C.Emitter,this.onDidChange=this.c.event,this.d=w,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const w of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(w.identifier),w),this.f.push(w),Array.isArray(w.activationEvents))for(let h of w.activationEvents)h==="onUri"&&(h=`onUri:${i.ExtensionIdentifier.toKey(w.identifier)}`),this.g.has(h)||this.g.set(h,[]),this.g.get(h).push(w)}}set(w){this.d=w,this.h(),this.c.fire(void 0)}deltaExtensions(w,h){this.d=k(this.d,h),this.d=this.d.concat(w);const b=y.j(this.d);return this.d=k(this.d,b.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new M(b)}static j(w){const h=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,g){this.addNode(l),this.addNode(g),this.c.has(l)?this.c.get(l).push(g):this.c.set(l,[g])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,g){const E=h.getArcs(l);for(let L=0;L<E.length;L++)if(!g.has(E[L]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const l of w){const g=i.ExtensionIdentifier.toKey(l.identifier);if(b.set(g,l),l.extensionDependencies)for(const E of l.extensionDependencies){const L=i.ExtensionIdentifier.toKey(E);h.addArc(g,L)}}const f=new Set;h.getNodes().filter(l=>h.getArcs(l).length===0).forEach(l=>f.add(l));const a=h.getNodes().filter(l=>!f.has(l));let s;do{s=!1;for(let l=0;l<a.length;l++){const g=a[l];h.hasOnlyGoodArcs(g,f)&&(a.splice(l,1),l--,f.add(g),s=!0)}}while(s);return a.map(l=>b.get(l))}containsActivationEvent(w){return this.g.has(w)}containsExtension(w){return this.e.has(i.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const h=this.g.get(w);return h?h.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(w){const h=this.e.get(i.ExtensionIdentifier.toKey(w));return h||void 0}getExtensionDescriptionByUUID(w){for(const h of this.f)if(h.uuid===w)return h}getExtensionDescriptionByIdOrUUID(w,h){return this.getExtensionDescription(w)??(h?this.getExtensionDescriptionByUUID(h):void 0)}}e.ExtensionDescriptionRegistry=y;var O;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(O||(O={}));function S(N,w){const h=N.isBuiltin?0:N.isUnderDevelopment?2:1,b=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(h!==b)return h-b;const f=D.posix.basename(N.extensionLocation.path),a=D.posix.basename(w.extensionLocation.path);return f<a?-1:f>a?1:0}function k(N,w){const h=new Set;return w.forEach(b=>h.add(i.ExtensionIdentifier.toKey(b))),N.filter(b=>!h.has(i.ExtensionIdentifier.toKey(b.identifier)))}}),define(ke[74],Te([1,0,23]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var D;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function y(k){const N=i.VSBuffer.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=y;function O(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=O;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ke[57],Te([1,0,3,4,11,27,74,50,52,22,2,6,143]),function(te,e,i,C,D,M,y,O,S,k,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class extends w.Disposable{constructor(l,g){super(),this.m=l,this.n=g,this.a=this.B(new C.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=N.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(E=>{(0,D.isLogLevel)(E)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(l,g,E){const L=this.getTelemetryDetails(),v=new f(g,E,l,this.k,this.i,this.getBuiltInCommonProperties(l),{isUsageEnabled:L.isUsageEnabled,isErrorsEnabled:L.isErrorsEnabled});return this.l.set(l.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(l,g,E){this.f=l,this.g=g,this.c=E??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(l){const g={};switch(g["common.extname"]=`${l.publisher}.${l.name}`,g["common.extversion"]=l.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=a(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case y.UIKind.Web:g["common.uikind"]="web";break;case y.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,O.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const g=this.getTelemetryDetails();this.l.forEach(E=>{E.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(l,g){const E=this.l.get(l.value);return!E||E.ignoreUnhandledExtHostErrors?!1:(E.logError(g),!0)}};b=Ke([je(0,M.IExtHostInitDataService),je(1,D.ILoggerService)],b),e.ExtHostTelemetry=b;class f{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,g,E,L,v,t,d){this.g=E,this.h=L,this.i=v,this.j=t,this.a=new C.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(l,g){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let g=l.properties??l;return g=(0,S.cleanData)(g,[]),this.c&&(g=(0,k.mixin)(g,this.c)),this.b||(g=(0,k.mixin)(g,this.j)),l.properties?l.properties=g:l=g,l}k(l,g){!this.f||(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(l,g),this.h.trace(l,g))}logUsage(l,g){!this.d.isUsageEnabled||this.k(l,g)}logError(l,g){!this.d.isErrorsEnabled||!this.f||(typeof l=="string"?this.k(l,g):this.f.sendErrorData(l,g))}get apiTelemetryLogger(){if(!this.e){const l=this,g={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(g)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=f;function a(s){const l=Date.now()-new Date(s).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.isNewAppInstall=a,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(ke[26],Te([1,0,4,2,3,25,169]),function(te,e,i,C,D,M,y){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(p){this.affinity=p,this.kind=1}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(p){this.affinity=p,this.kind=2}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class N{constructor(){this.kind=3,this.affinity=0}equals(p){return this.kind===p.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class w{constructor(p){this.dependency=p}}e.MissingExtensionDependency=w;var h;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(h=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(p,o){const c=[],m=[],P=[],T=[],V=l(this.c),_=l(p),K=(F,H)=>F.extensionLocation.toString()===H.extensionLocation.toString()||F.isBuiltin===H.isBuiltin||F.isUserBuiltin===H.isUserBuiltin||F.isUnderDevelopment===H.isUnderDevelopment;for(const F of this.c){const H=_.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){c.push(F.identifier),V.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}if(!K(F,H)){c.push(F.identifier),V.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of p){const H=V.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){m.push(F);continue}if(!K(H,F)){c.push(H.identifier),V.delete(M.ExtensionIdentifier.toKey(H.identifier));continue}}const A=s(this.d),U=s(o);for(const F of this.d)U.has(M.ExtensionIdentifier.toKey(F))||P.push(F);for(const F of o)A.has(M.ExtensionIdentifier.toKey(F))||T.push(F);const R={toRemove:c,toAdd:m,myToRemove:P,myToAdd:T};return this.delta(R),R}delta(p){const{toRemove:o,toAdd:c,myToRemove:m,myToAdd:P}=p,T=s(o),V=s(m);for(let _=0;_<this.c.length;_++)T.has(M.ExtensionIdentifier.toKey(this.c[_].identifier))&&(this.c.splice(_,1),_--);for(let _=0;_<this.d.length;_++)V.has(M.ExtensionIdentifier.toKey(this.d[_]))&&(this.d.splice(_,1),_--);for(const _ of c)this.c.push(_);for(const _ of P)this.d.push(_)}containsExtension(p){for(const o of this.d)if(M.ExtensionIdentifier.equals(o,p))return!0;return!1}}e.ExtensionHostExtensions=f;class a{constructor(p){if(this[O]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,p)for(const o of p)this.add(o)}get size(){return this.c.size}add(p){return this.c.set(this.d(p),p),this}clear(){this.c.clear()}delete(p){return this.c.delete(this.d(p))}has(p){return this.c.has(this.d(p))}forEach(p,o){this.c.forEach(c=>p.call(o,c,c,this))}*entries(){for(const[p,o]of this.c)yield[o,o]}keys(){return this.c.values()}values(){return this.c.values()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=a;function s(n){const p=new Set;for(const o of n)p.add(M.ExtensionIdentifier.toKey(o));return p}e.extensionIdentifiersArrayToSet=s;function l(n){const p=new Map;for(const o of n)p.set(M.ExtensionIdentifier.toKey(o.identifier),o);return p}function g(n,p){return n.enabledApiProposals?n.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=g;function E(n,p){if(!g(n,p))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=E;class L{constructor(p,o,c,m){this.codeLoadingTime=p,this.activateCallTime=o,this.activateResolvedTime=c,this.activationReason=m}}e.ActivationTimes=L;class v{constructor(p,o){this.description=p,this.value=o}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var t;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function d(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function r(n,p){return{identifier:new M.ExtensionIdentifier((0,y.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!p,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,browserNlsBundleUris:n.browserNlsBundleUris}}e.toExtensionDescription=r;class u{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p,o){return Promise.resolve(0)}getInspectPorts(p,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(ke[192],Te([1,0,12,98,25,26,11,17]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(l,g,E,L){this.startup=l,this.codeLoadingTime=g,this.activateCallTime=E,this.activateResolvedTime=L}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,g){return l===-1||g===-1?-1:g-l}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class N{constructor(l,g,E,L,v,t){this.activationFailed=l,this.activationFailedError=g,this.activationTimes=E,this.module=L,this.exports=v,this.subscriptions=t}}e.ActivatedExtension=N;class w extends N{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class h extends N{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class b extends N{constructor(l){super(!0,l,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(l,g,E,L){this.g=L,this.a=l,this.b=g,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,g]of this.d)g.dispose()}isActivated(l){const g=this.d.get(D.ExtensionIdentifier.toKey(l));return Boolean(g&&g.value)}getActivatedExtension(l){const g=this.d.get(D.ExtensionIdentifier.toKey(l));if(!g||!g.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return g.value}async activateByEvent(l,g){if(this.f[l])return;const E=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(E.map(L=>({id:L.identifier,reason:{startup:g,extensionId:L.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,g){const E=this.a.getExtensionDescription(l);if(!E)throw new Error(`Extension '${l}' is not known`);return this.h([{id:E.identifier,reason:g}])}async h(l){const g=l.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(g.map(E=>E.wait()))}j(l){if(this.d.has(D.ExtensionIdentifier.toKey(l.id)))return this.d.get(D.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const g=this.a.getExtensionDescription(l.id);if(!g){const v=new Error(`Cannot activate unknown extension '${l.id.value}'`),t=this.k(l,null,[],new b(v));return this.c.onExtensionActivationError(l.id,v,new M.MissingExtensionDependency(l.id.value)),t}const E=[],L=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const v of L){if(this.m(v))continue;const t=this.d.get(D.ExtensionIdentifier.toKey(v));if(t){E.push(t);continue}if(this.l(v)){E.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:l.reason}));continue}const d=this.a.getExtensionDescription(v);if(d){if(!d.main&&!d.browser)continue;E.push(this.j({id:d.identifier,reason:l.reason}));continue}const r=g.displayName||g.identifier.value,u=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),n=this.k(l,g.displayName,[],new b(u));return this.c.onExtensionActivationError(g.identifier,u,new M.MissingExtensionDependency(v)),n}return this.k(l,g.displayName,E,null)}k(l,g,E,L){const v=new a(l.id,g,l.reason,E,L,this.c,this.g);return this.d.set(D.ExtensionIdentifier.toKey(l.id),v),v}l(l){return C.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const g=this.b.getExtensionDescription(l);return g?!g.main&&!g.browser:!1}};f=Ke([je(3,y.ILogService)],f),e.ExtensionsActivator=f;let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,g,E,L,v,t,d){this.c=l,this.d=g,this.f=E,this.g=L,this.h=v,this.j=t,this.k=d,this.a=new O.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const g=this.g[l];if(g.value&&!g.value.activationFailed){this.g.splice(l,1),l--;continue}if(g.value&&g.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);E.detail=g.value.activationFailedError,this.h=new b(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const g=new Error;if(l&&l.name&&(g.name=l.name),l&&l.message?g.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(g.stack=l.stack),this.h=new b(g),this.b&&i.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};a=Ke([je(6,y.ILogService)],a)});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[7],Te([1,0,16,12,86,28,65,10,9,2,34,43,94,71,26]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f){"use strict";var a,s,l,g,E,L,v,t,d,r,u,n,p,o,c,m,P,T,V,_,K,A,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...Ee]=arguments;return Reflect.construct(z,Ee,ie.constructor)}}})}var F;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var H;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(H=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=L=class{static from(...B){let ie=B;return new L(function(){if(ie){for(const Ee of ie)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ie=void 0}})}constructor(B){a.set(this,void 0),Je(this,a,B,"f")}dispose(){typeof Le(this,a,"f")=="function"&&(Le(this,a,"f").call(this),Je(this,a,void 0,"f"))}};a=new WeakMap,j=L=Ke([R],j),e.Disposable=j;let le=v=class{static Min(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ee=1;Ee<B.length;Ee++){const xe=B[Ee];xe.isBefore(ie)&&(ie=xe)}return ie}static Max(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ee=1;Ee<B.length;Ee++){const xe=B[Ee];xe.isAfter(ie)&&(ie=xe)}return ie}static isPosition(B){if(!B)return!1;if(B instanceof v)return!0;const{line:ie,character:Ee}=B;return typeof ie=="number"&&typeof Ee=="number"}static of(B){if(B instanceof v)return B;if(this.isPosition(B))return new v(B.line,B.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(B,ie){if(B<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this.c=B,this.e=ie}isBefore(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<B.e}isBeforeOrEqual(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<=B.e}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this.c===B.c&&this.e===B.e}compareTo(B){return this.c<B.c?-1:this.c>B.line?1:this.e<B.e?-1:this.e>B.e?1:0}translate(B,ie=0){if(B===null||ie===null)throw(0,C.illegalArgument)();let Ee;return typeof B>"u"?Ee=0:typeof B=="number"?Ee=B:(Ee=typeof B.lineDelta=="number"?B.lineDelta:0,ie=typeof B.characterDelta=="number"?B.characterDelta:0),Ee===0&&ie===0?this:new v(this.line+Ee,this.character+ie)}with(B,ie=this.character){if(B===null||ie===null)throw(0,C.illegalArgument)();let Ee;return typeof B>"u"?Ee=this.line:typeof B=="number"?Ee=B:(Ee=typeof B.line=="number"?B.line:this.line,ie=typeof B.character=="number"?B.character:this.character),Ee===this.line&&ie===this.character?this:new v(Ee,ie)}toJSON(){return{line:this.line,character:this.character}}};le=v=Ke([R],le),e.Position=le;let ge=t=class{static isRange(B){return B instanceof t?!0:B?le.isPosition(B.start)&&le.isPosition(B.end):!1}static of(B){if(B instanceof t)return B;if(this.isRange(B))return new t(B.start,B.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(B,ie,Ee,xe){let _e,at;if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof xe=="number"?(_e=new le(B,ie),at=new le(Ee,xe)):le.isPosition(B)&&le.isPosition(ie)&&(_e=le.of(B),at=le.of(ie)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(B){return t.isRange(B)?this.contains(B.start)&&this.contains(B.end):le.isPosition(B)?!(le.of(B).isBefore(this.c)||this.e.isBefore(B)):!1}isEqual(B){return this.c.isEqual(B.c)&&this.e.isEqual(B.e)}intersection(B){const ie=le.Max(B.start,this.c),Ee=le.Min(B.end,this.e);if(!ie.isAfter(Ee))return new t(ie,Ee)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ie=le.Min(B.start,this.c),Ee=le.Max(B.end,this.end);return new t(ie,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(B,ie=this.end){if(B===null||ie===null)throw(0,C.illegalArgument)();let Ee;return B?le.isPosition(B)?Ee=B:(Ee=B.start||this.start,ie=B.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&ie.isEqual(this.end)?this:new t(Ee,ie)}toJSON(){return[this.start,this.end]}};ge=t=Ke([R],ge),e.Range=ge;let re=d=class extends ge{static isSelection(B){return B instanceof d?!0:B?ge.isRange(B)&&le.isPosition(B.anchor)&&le.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(B,ie,Ee,xe){let _e,at;if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof xe=="number"?(_e=new le(B,ie),at=new le(Ee,xe)):le.isPosition(B)&&le.isPosition(ie)&&(_e=le.of(B),at=le.of(ie)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};re=d=Ke([R],re),e.Selection=re;class ae{constructor(B,ie,Ee){if(typeof B!="string"||B.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ee)))throw(0,C.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(ie),this.connectionToken=Ee}}e.ResolvedAuthority=ae;class ce extends Error{static NotAvailable(B,ie){return new ce(B,h.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(B){return new ce(B,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(B,ie=h.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(B),this._message=B,this._code=ie,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.RemoteAuthorityResolverError=ce;var Se;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(Se=e.EndOfLine||(e.EndOfLine={}));var x;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let X=r=class{static isTextEdit(B){return B instanceof r?!0:B?ge.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ie){return new r(B,ie)}static insert(B,ie){return r.replace(new ge(B,B),ie)}static delete(B){return r.replace(B,"")}static setEndOfLine(B){const ie=new r(new ge(new le(0,0),new le(0,0)),"");return ie.newEol=B,ie}get range(){return this.c}set range(B){if(B&&!ge.isRange(B))throw(0,C.illegalArgument)("range");this.c=B}get newText(){return this.e||""}set newText(B){if(B&&typeof B!="string")throw(0,C.illegalArgument)("newText");this.e=B}get newEol(){return this.f}set newEol(B){if(B&&typeof B!="number")throw(0,C.illegalArgument)("newEol");this.f=B}constructor(B,ie){this.c=B,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};X=r=Ke([R],X),e.TextEdit=X;let J=u=class{static isNotebookCellEdit(B){return B instanceof u?!0:B?Kt.isNotebookRange(B)&&Array.isArray(B.newCells):!1}static replaceCells(B,ie){return new u(B,ie)}static insertCells(B,ie){return new u(new Kt(B,B),ie)}static deleteCells(B){return new u(B,[])}static updateCellMetadata(B,ie){const Ee=new u(new Kt(B,B),[]);return Ee.newCellMetadata=ie,Ee}static updateNotebookMetadata(B){const ie=new u(new Kt(0,0),[]);return ie.newNotebookMetadata=B,ie}constructor(B,ie){this.range=B,this.newCells=ie}};J=u=Ke([R],J),e.NotebookEdit=J;class de{static isSnippetTextEdit(B){return B instanceof de?!0:B?ge.isRange(B.range)&&We.isSnippetString(B.snippet):!1}static replace(B,ie){return new de(B,ie)}static insert(B,ie){return de.replace(new ge(B,B),ie)}constructor(B,ie){this.range=B,this.snippet=ie}}e.SnippetTextEdit=de;var ye;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(ye=e.FileEditType||(e.FileEditType={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(B,ie,Ee,xe){this.c.push({_type:1,from:B,to:ie,options:Ee,metadata:xe})}createFile(B,ie,Ee){this.c.push({_type:1,from:void 0,to:B,options:ie,metadata:Ee})}deleteFile(B,ie,Ee){this.c.push({_type:1,from:B,to:void 0,options:ie,metadata:Ee})}e(B,ie,Ee){this.c.push({_type:3,metadata:Ee,uri:B,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(B,ie,Ee,xe){const _e=ie.start,at=ie.end;(_e!==at||Ee.length>0)&&this.c.push({_type:5,uri:B,index:_e,count:at-_e,cells:Ee,metadata:xe})}g(B,ie,Ee,xe){this.c.push({_type:3,metadata:xe,uri:B,edit:{editType:8,index:ie,metadata:Ee}})}replace(B,ie,Ee,xe){this.c.push({_type:2,uri:B,edit:new X(ie,Ee),metadata:xe})}insert(B,ie,Ee,xe){this.replace(B,new ge(ie,ie),Ee,xe)}delete(B,ie,Ee){this.replace(B,ie,"",Ee)}has(B){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===B.toString())}set(B,ie){if(ie)for(const Ee of ie){if(!Ee)continue;let xe,_e;Array.isArray(Ee)?(xe=Ee[0],_e=Ee[1]):xe=Ee,J.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(B,xe.range.start,xe.newCellMetadata,_e):xe.newNotebookMetadata?this.e(B,xe.newNotebookMetadata,_e):this.f(B,xe.range,xe.newCells,_e):de.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:B,range:xe.range,edit:xe.snippet,metadata:_e}):this.c.push({_type:2,uri:B,edit:xe,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const xe=this.c[Ee];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===B.toString()&&(this.c[Ee]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(B){const ie=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===B.toString()&&ie.push(Ee.edit);return ie}entries(){const B=new M.ResourceMap;for(const ie of this.c)if(ie._type===2){let Ee=B.get(ie.uri);Ee||(Ee=[ie.uri,[]],B.set(ie.uri,Ee)),Ee[1].push(ie.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ne=Ke([R],Ne),e.WorkspaceEdit=Ne;let We=n=class{static isSnippetString(B){return B instanceof n?!0:B?typeof B.value=="string":!1}static c(B){return B.replace(/\$|}|\\/g,"\\$&")}constructor(B){this.e=1,this.value=B||""}appendText(B){return this.value+=n.c(B),this}appendTabstop(B=this.e++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ie=this.e++){if(typeof B=="function"){const Ee=new n;Ee.e=this.e,B(Ee),this.e=Ee.e,B=Ee.value}else B=n.c(B);return this.value+="${",this.value+=ie,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ie=this.e++){const Ee=B.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(B,ie){if(typeof ie=="function"){const Ee=new n;Ee.e=this.e,ie(Ee),this.e=Ee.e,ie=Ee.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};We=n=Ke([R],We),e.SnippetString=We;var Pe;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Ce;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=p=class{static isLocation(B){return B instanceof p?!0:B?ge.isRange(B.range)&&k.URI.isUri(B.uri):!1}constructor(B,ie){if(this.uri=B,ie)if(ge.isRange(ie))this.range=ge.of(ie);else if(le.isPosition(ie))this.range=new ge(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};we=p=Ke([R],we),e.Location=we;let se=class{static is(B){return B?typeof B.message=="string"&&B.location&&ge.isRange(B.location.range)&&k.URI.isUri(B.location.uri):!1}constructor(B,ie){this.location=B,this.message=ie}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.location.range.isEqual(ie.location.range)&&B.location.uri.toString()===ie.location.uri.toString()}};se=Ke([R],se),e.DiagnosticRelatedInformation=se;let ue=class{constructor(B,ie,Ee=Ce.Error){if(!ge.isRange(B))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=B,this.message=ie,this.severity=Ee}toJSON(){return{severity:Ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.severity===ie.severity&&B.code===ie.code&&B.severity===ie.severity&&B.source===ie.source&&B.range.isEqual(ie.range)&&(0,i.equals)(B.tags,ie.tags)&&(0,i.equals)(B.relatedInformation,ie.relatedInformation,se.isEqual)}};ue=Ke([R],ue),e.Diagnostic=ue;let Z=class{constructor(B,ie){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ie}};Z=Ke([R],Z),e.Hover=Z;var I;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(B,ie=I.Text){this.range=B,this.kind=ie}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=Ke([R],$),e.DocumentHighlight=$;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var q;(function(z){z[z.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let ee=o=class{static validate(B){if(!B.name)throw new Error("name must not be falsy")}constructor(B,ie,Ee,xe,_e){this.name=B,this.kind=ie,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),xe instanceof we?this.location=xe:Ee instanceof ge&&(this.location=new we(xe,Ee)),o.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ee=o=Ke([R],ee),e.SymbolInformation=ee;let fe=c=class{static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children?.forEach(c.validate)}constructor(B,ie,Ee,xe,_e){this.name=B,this.detail=ie,this.kind=Ee,this.range=xe,this.selectionRange=_e,this.children=[],c.validate(this)}};fe=c=Ke([R],fe),e.DocumentSymbol=fe;var De;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(De=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(B,ie){this.title=B,this.kind=ie}};oe=Ke([R],oe),e.CodeAction=oe;let ve=m=class{constructor(B){this.value=B}append(B){return new m(this.value?this.value+m.c+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+m.c)}};ve.c=".",ve=m=Ke([R],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(B,ie){if(this.range=B,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=Ke([R],be),e.SelectionRange=be;class He{constructor(B,ie,Ee,xe,_e,at){this.kind=B,this.name=ie,this.detail=Ee,this.uri=xe,this.range=_e,this.selectionRange=at}}e.CallHierarchyItem=He;class qe{constructor(B,ie){this.fromRanges=ie,this.from=B}}e.CallHierarchyIncomingCall=qe;class tt{constructor(B,ie){this.fromRanges=ie,this.to=B}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(B,ie){this.range=B,this.command=ie}get isResolved(){return!!this.command}};et=Ke([R],et),e.CodeLens=et;let it=P=class{static isMarkdownString(B){return B instanceof P?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}constructor(B,ie=!1){s.set(this,void 0),Je(this,s,new D.MarkdownString(B,{supportThemeIcons:ie}),"f")}get value(){return Le(this,s,"f").value}set value(B){Le(this,s,"f").value=B}get isTrusted(){return Le(this,s,"f").isTrusted}set isTrusted(B){Le(this,s,"f").isTrusted=B}get supportThemeIcons(){return Le(this,s,"f").supportThemeIcons}set supportThemeIcons(B){Le(this,s,"f").supportThemeIcons=B}get supportHtml(){return Le(this,s,"f").supportHtml}set supportHtml(B){Le(this,s,"f").supportHtml=B}get baseUri(){return Le(this,s,"f").baseUri}set baseUri(B){Le(this,s,"f").baseUri=B}appendText(B){return Le(this,s,"f").appendText(B),this}appendMarkdown(B){return Le(this,s,"f").appendMarkdown(B),this}appendCodeblock(B,ie){return Le(this,s,"f").appendCodeblock(ie??"",B),this}};s=new WeakMap,it=P=Ke([R],it),e.MarkdownString=it;let dt=class{constructor(B,ie){this.label=B,this.documentation=ie}};dt=Ke([R],dt),e.ParameterInformation=dt;let Fe=class{constructor(B,ie){this.label=B,this.documentation=ie,this.parameters=[]}};Fe=Ke([R],Fe),e.SignatureInformation=Fe;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=Ke([R],ot),e.SignatureHelp=ot;var Y;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(B){this.value=B}};pe=Ke([R],pe),e.InlayHintLabelPart=pe;let Me=class{constructor(B,ie,Ee){this.position=B,this.label=ie,this.kind=Ee}};Me=Ke([R],Me),e.InlayHint=Me;var ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(z){z[z.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(B,ie){this.label=B,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=Ke([R],nt),e.CompletionItem=nt;let vt=class{constructor(B=[],ie=!1){this.items=B,this.isIncomplete=ie}};vt=Ke([R],vt),e.CompletionList=vt;let wt=class{constructor(B,ie,Ee){this.insertText=B,this.range=ie,this.command=Ee}};wt=Ke([R],wt),e.InlineSuggestion=wt;let Ct=class{constructor(B){this.commands=void 0,this.items=B}};Ct=Ke([R],Ct),e.InlineSuggestionList=Ct;var jt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(jt=e.ViewColumn||(e.ViewColumn={}));var rt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Gt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Gt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function B(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=B}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Bt=class{constructor(B,ie){if(ie&&!k.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!ge.isRange(B)||B.isEmpty)throw(0,C.illegalArgument)("range");this.range=B,this.target=ie}};Bt=Ke([R],Bt),e.DocumentLink=Bt;let Ot=class{constructor(B,ie,Ee,xe){this.red=B,this.green=ie,this.blue=Ee,this.alpha=xe}};Ot=Ke([R],Ot),e.Color=Ot;let Ge=class{constructor(B,ie){if(ie&&!(ie instanceof Ot))throw(0,C.illegalArgument)("color");if(!ge.isRange(B)||B.isEmpty)throw(0,C.illegalArgument)("range");this.range=B,this.color=ie}};Ge=Ke([R],Ge),e.ColorInformation=Ge;let Nt=class{constructor(B){if(!B||typeof B!="string")throw(0,C.illegalArgument)("label");this.label=B}};Nt=Ke([R],Nt),e.ColorPresentation=Nt;var Mt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var zt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(zt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ft;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ft=e.TerminalExitReason||(e.TerminalExitReason={}));class Ie{constructor(B,ie,Ee){if(this.startIndex=B,this.length=ie,this.tooltip=Ee,typeof B!="number"||B<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=Ie;class Ae{constructor(B){this.uri=B}}e.TerminalQuickFixOpener=Ae;class me{constructor(B){this.terminalCommand=B}}e.TerminalQuickFixCommand=me;var G;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(G=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(B){if(this.options=B,typeof B!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Re;var Be;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Be=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let $e=T=class{static from(B){switch(B){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}constructor(B,ie){if(this.label=ie,typeof B!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this.c=B}get id(){return this.c}};$e.Clean=new T("clean","Clean"),$e.Build=new T("build","Build"),$e.Rebuild=new T("rebuild","Rebuild"),$e.Test=new T("test","Test"),$e=T=Ke([R],$e),e.TaskGroup=$e;function Ze(z){let B="";for(let ie=0;ie<z.length;ie++)B+=z[ie].replace(/,/g,",,")+",";return B}let ct=class{constructor(B,ie,Ee){if(typeof B!="string")throw(0,C.illegalArgument)("process");this.e=[],this.c=B,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Ee):this.f=ie)}get process(){return this.c}set process(B){if(typeof B!="string")throw(0,C.illegalArgument)("process");this.c=B}get args(){return this.e}set args(B){Array.isArray(B)||(B=[]),this.e=B}get options(){return this.f}set options(B){this.f=B}computeId(){const B=[];if(B.push("process"),this.c!==void 0&&B.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)B.push(ie);return Ze(B)}};ct=Ke([R],ct),e.ProcessExecution=ct;let Tt=class{constructor(B,ie,Ee){if(this.f=[],Array.isArray(ie)){if(!B)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,C.illegalArgument)("command");this.e=B,this.f=ie,this.g=Ee}else{if(typeof B!="string")throw(0,C.illegalArgument)("commandLine");this.c=B,this.g=ie}}get commandLine(){return this.c}set commandLine(B){if(typeof B!="string")throw(0,C.illegalArgument)("commandLine");this.c=B}get command(){return this.e?this.e:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,C.illegalArgument)("command");this.e=B}get args(){return this.f}set args(B){this.f=B||[]}get options(){return this.g}set options(B){this.g=B}computeId(){const B=[];if(B.push("shell"),this.c!==void 0&&B.push(this.c),this.e!==void 0&&B.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)B.push(typeof ie=="string"?ie:ie.value);return Ze(B)}};Tt=Ke([R],Tt),e.ShellExecution=Tt;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class It{constructor(B){this.c=B}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(B){this.c=B}get callback(){return this.c}}e.CustomExecution=It;let St=V=class{constructor(B,ie,Ee,xe,_e,at){this.j=!1,this.k=this.definition=B;let lt;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=Ee,this.execution=xe,lt=_e,this.j=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this.m=this.name=Ee,this.t=this.source=xe,this.execution=_e,lt=at):(this.target=ie,this.m=this.name=Ee,this.t=this.source=xe,this.execution=_e,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(B){this.h=B}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:V.e,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:V.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:V.c,id:this.n.computeId()}:this.k={type:V.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(B){if(B==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=B}get scope(){return this.l}set target(B){this.y(),this.l=B}get name(){return this.m}set name(B){if(typeof B!="string")throw(0,C.illegalArgument)("name");this.y(),this.m=B}get execution(){return this.n}set execution(B){B===null&&(B=void 0),this.y(),this.n=B;const ie=this.k.type;(V.g===ie||V.e===ie||V.f===ie||V.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(B){if(Array.isArray(B))this.y(),this.o=B,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.y(),this.r=B}get source(){return this.t}set source(B){if(typeof B!="string"||B.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.y(),this.t=B}get group(){return this.u}set group(B){B===null&&(B=void 0),this.y(),this.u=B}get detail(){return this.x}set detail(B){B===null&&(B=void 0),this.x=B}get presentationOptions(){return this.v}set presentationOptions(B){B==null&&(B=Object.create(null)),this.y(),this.v=B}get runOptions(){return this.w}set runOptions(B){B==null&&(B=Object.create(null)),this.y(),this.w=B}};St.c="customExecution",St.e="process",St.f="shell",St.g="$empty",St=V=Ke([R],St),e.Task=St;var yt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(z){function B(ie){const Ee=ie;return(0,S.isNumber)(Ee.value)?Ee.tooltip&&!(0,S.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}z.isViewBadge=B})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=_=class{static isTreeItem(B,ie){const Ee=B;if(Ee.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const xe=(0,S.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,S.isObject)(Ee.checkboxState)&&(0,S.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,S.isNumber)(Ee.checkboxState)&&(0,S.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(xe===void 0||xe!==si.Checked&&xe!==si.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(B instanceof _)return!0;if(Ee.label!==void 0&&!(0,S.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,S.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,S.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,S.isString)(Ee.iconPath.id))){const xe=Ee.iconPath;if(!xe||!(0,S.isString)(xe.light)&&!k.URI.isUri(xe.light)&&!(0,S.isString)(xe.dark)&&!k.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,S.isString)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,S.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof it)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<pt.None&&Ee.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,S.isString)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(B,ie=pt.None){this.collapsibleState=ie,k.URI.isUri(B)?this.resourceUri=B:this.label=B}};Jt=_=Ke([R],Jt),e.TreeItem=Jt;var pt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(B,ie){this.value=B,this.id=ie??(0,N.generateUuid)()}};oi=Ke([R],oi),e.DataTransferItem=oi;let Zt=class{constructor(B){l.set(this,new Map);for(const[ie,Ee]of B??[]){const xe=Le(this,l,"f").get(ie);xe?xe.push(Ee):Le(this,l,"f").set(ie,[Ee])}}get(B){return Le(this,l,"f").get(B)?.[0]}set(B,ie){Le(this,l,"f").set(B,[ie])}forEach(B,ie){for(const[Ee,xe]of Le(this,l,"f"))for(const _e of xe)B.call(ie,_e,Ee,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[B,ie]of Le(this,l,"f"))for(const Ee of ie)yield[B,Ee]}};Zt=Ke([R],Zt),e.DataTransfer=Zt;let vi=class{constructor(B){this.insertText=B}};vi=Ke([R],vi),e.DocumentDropEdit=vi;let At=class{constructor(B){this.insertText=B}};At=Ke([R],At),e.DocumentPasteEdit=At;let Wt=class{constructor(B,ie){this.id=B,this.color=ie}static isThemeIcon(B){return typeof B.id!="string"?(console.log("INVALID ThemeIcon, invalid id",B.id),!1):!0}};Wt=Ke([R],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let bi=class{constructor(B){this.id=B}};bi=Ke([R],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(B){this.c=B,this.e=k.URI.file(B)}get baseUri(){return this.e}set baseUri(B){this.e=B,this.c=B.fsPath}constructor(B,ie){if(typeof B!="string"&&(!B||!k.URI.isUri(B)&&!k.URI.isUri(B.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof B=="string"?this.baseUri=k.URI.file(B):k.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=Ke([R],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(z,B){ut.set(z,B)}e.setBreakpointId=Bi;let Ut=class{constructor(B,ie,Ee,xe){this.enabled=typeof B=="boolean"?B:!0,typeof ie=="string"&&(this.condition=ie),typeof Ee=="string"&&(this.hitCondition=Ee),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=ut.get(this)??(0,N.generateUuid)()),this.c}};Ut=Ke([R],Ut),e.Breakpoint=Ut;let Qt=class extends Ut{constructor(B,ie,Ee,xe,_e){if(super(ie,Ee,xe,_e),B===null)throw(0,C.illegalArgument)("location");this.location=B}};Qt=Ke([R],Qt),e.SourceBreakpoint=Qt;let ci=class extends Ut{constructor(B,ie,Ee,xe,_e){super(ie,Ee,xe,_e),this.functionName=B}};ci=Ke([R],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(B,ie,Ee,xe,_e,at,lt){if(super(xe,_e,at,lt),!ie)throw(0,C.illegalArgument)("dataId");this.label=B,this.dataId=ie,this.canPersist=Ee}};Ei=Ke([R],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(B,ie,Ee){this.command=B,this.args=ie||[],this.options=Ee}};wi=Ke([R],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(B,ie){this.port=B,this.host=ie}};ui=Ke([R],ui),e.DebugAdapterServer=ui;let Si=class{constructor(B){this.path=B}};Si=Ke([R],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(B){this.implementation=B}};li=Ke([R],li),e.DebugAdapterInlineImplementation=li;let ti=class{constructor(B,ie){this.range=B,this.expression=ie}};ti=Ke([R],ti),e.EvaluatableExpression=ti;var $i;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(B,ie){this.range=B,this.text=ie}};ii=Ke([R],ii),e.InlineValueText=ii;let ni=class{constructor(B,ie,Ee=!0){this.range=B,this.variableName=ie,this.caseSensitiveLookup=Ee}};ni=Ke([R],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(B,ie){this.range=B,this.expression=ie}};yi=Ke([R],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(B,ie){this.frameId=B,this.stoppedLocation=ie}};Di=Ke([R],Di),e.InlineValueContext=Di;var ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ii=K=class extends Error{static FileExists(B){return new K(B,w.FileSystemProviderErrorCode.FileExists,K.FileExists)}static FileNotFound(B){return new K(B,w.FileSystemProviderErrorCode.FileNotFound,K.FileNotFound)}static FileNotADirectory(B){return new K(B,w.FileSystemProviderErrorCode.FileNotADirectory,K.FileNotADirectory)}static FileIsADirectory(B){return new K(B,w.FileSystemProviderErrorCode.FileIsADirectory,K.FileIsADirectory)}static NoPermissions(B){return new K(B,w.FileSystemProviderErrorCode.NoPermissions,K.NoPermissions)}static Unavailable(B){return new K(B,w.FileSystemProviderErrorCode.Unavailable,K.Unavailable)}constructor(B,ie=w.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(B)?B.toString(!0):B),this.code=Ee?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,K.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Ii=K=Ke([R],Ii),e.FileSystemError=Ii;let Ci=class{constructor(B,ie,Ee){this.start=B,this.end=ie,this.kind=Ee}};Ci=Ke([R],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(B,ie=[]){this.tokenTypes=B,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,S.isStringArray)(z)}class Ue{constructor(B){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,B){this.l=!0;for(let ie=0,Ee=B.tokenTypes.length;ie<Ee;ie++)this.j.set(B.tokenTypes[ie],ie);for(let ie=0,Ee=B.tokenModifiers.length;ie<Ee;ie++)this.k.set(B.tokenModifiers[ie],ie)}}push(B,ie,Ee,xe,_e){if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof xe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(B,ie,Ee,xe,_e);if(ge.isRange(B)&&typeof ie=="string"&&Oi(Ee))return this.m(B,ie,Ee);throw(0,C.illegalArgument)()}m(B,ie,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const xe=B.start.line,_e=B.start.character,at=B.end.character-B.start.character,lt=this.j.get(ie);let Lt=0;if(Ee)for(const Vt of Ee){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Vt);Lt|=1<<xt>>>0}this.n(xe,_e,at,lt,Lt)}n(B,ie,Ee,xe,_e){if(this.f&&(B<this.c||B===this.c&&ie<this.e)){this.f=!1;const Lt=this.g.length/5|0;let Vt=0,xt=0;for(let Xt=0;Xt<Lt;Xt++){let Yt=this.g[5*Xt],Pi=this.g[5*Xt+1];Yt===0?(Yt=Vt,Pi+=xt):Yt+=Vt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pi,Vt=Yt,xt=Pi}}let at=B,lt=ie;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=Ee,this.g[this.h++]=xe,this.g[this.h++]=_e,this.c=B,this.e=ie}static o(B){const ie=[],Ee=B.length/5|0;for(let lt=0;lt<Ee;lt++)ie[lt]=lt;ie.sort((lt,Lt)=>{const Vt=B[5*lt],xt=B[5*Lt];if(Vt===xt){const Xt=B[5*lt+1],Yt=B[5*Lt+1];return Xt-Yt}return Vt-xt});const xe=new Uint32Array(B.length);let _e=0,at=0;for(let lt=0;lt<Ee;lt++){const Lt=5*ie[lt],Vt=B[Lt+0],xt=B[Lt+1],Xt=B[Lt+2],Yt=B[Lt+3],Pi=B[Lt+4],sn=Vt-_e,Rn=sn===0?xt-at:xt,Ai=5*lt;xe[Ai+0]=sn,xe[Ai+1]=Rn,xe[Ai+2]=Xt,xe[Ai+3]=Yt,xe[Ai+4]=Pi,_e=Vt,at=xt}return xe}build(B){return this.f?new Ht(new Uint32Array(this.g),B):new Ht(Ue.o(this.g),B)}}e.SemanticTokensBuilder=Ue;class Ht{constructor(B,ie){this.resultId=ie,this.data=B}}e.SemanticTokens=Ht;class Li{constructor(B,ie,Ee){this.start=B,this.deleteCount=ie,this.data=Ee}}e.SemanticTokensEdit=Li;class gt{constructor(B,ie){this.resultId=ie,this.edits=B}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Wt("arrow-left")},di=Ke([R],di),e.QuickInputButtons=di;var Fi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(B){if(typeof B.badge=="string"){let ie=(0,O.nextCharLength)(B.badge,0);if(ie<B.badge.length&&(ie+=(0,O.nextCharLength)(B.badge,ie)),B.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(B.badge&&!Wt.isThemeIcon(B.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}constructor(B,ie,Ee){this.badge=B,this.tooltip=ie,this.color=Ee}}e.FileDecoration=qi;let Ti=class{constructor(B){this.kind=B}};Ti=Ke([R],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(B){return B instanceof Kt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(B,ie){if(B<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");B<=ie?(this.c=B,this.e=ie):(this.c=ie,this.e=B)}with(B){let ie=this.c,Ee=this.e;return B.start!==void 0&&(ie=B.start),B.end!==void 0&&(Ee=B.end),ie===this.c&&Ee===this.e?this:new Kt(ie,Ee)}}e.NotebookRange=Kt;class fi{static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ie=>fi.isNotebookCellData(ie))}static isNotebookCellData(B){return!0}constructor(B,ie,Ee,xe,_e,at,lt){this.kind=B,this.value=ie,this.languageId=Ee,this.mime=xe,this.outputs=_e??[],this.metadata=at,this.executionSummary=lt,fi.validate(this)}}e.NotebookCellData=fi;class xi{constructor(B){this.cells=B}}e.NotebookData=xi;class $t{static isNotebookCellOutputItem(B){return B instanceof $t?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ie={name:B.name,message:B.message,stack:B.stack};return $t.json(ie,"application/vnd.code.notebook.error")}static stdout(B){return $t.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return $t.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ie="application/octet-stream"){return new $t(B,ie)}static text(B,ie=y.Mimes.text){const Ee=Le($t,g,"f",E).encode(String(B));return new $t(Ee,ie)}static json(B,ie="text/x-json"){const Ee=JSON.stringify(B,void 0,"	");return $t.text(Ee,ie)}constructor(B,ie){this.data=B,this.mime=ie;const Ee=(0,y.normalizeMimeType)(ie,!0);if(!Ee)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}g=$t,E={value:new TextEncoder},e.NotebookCellOutputItem=$t;class mi{static isNotebookCellOutput(B){return B instanceof mi?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&Array.isArray(B.items)}static ensureUniqueMimeTypes(B,ie=!1){const Ee=new Set,xe=new Set;for(let _e=0;_e<B.length;_e++){const at=B[_e],lt=(0,y.normalizeMimeType)(at.mime);if(!Ee.has(lt)||(0,b.isTextStreamMime)(lt)){Ee.add(lt);continue}xe.add(_e),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return xe.size===0?B:B.filter((_e,at)=>!xe.has(at))}constructor(B,ie,Ee){this.items=mi.ensureUniqueMimeTypes(B,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ee):(this.id=(0,N.generateUuid)(),this.metadata=ie??Ee)}}e.NotebookCellOutput=mi;var Gi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var he;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(he=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Oe{constructor(B,ie){this.text=B,this.alignment=ie}}e.NotebookCellStatusBarItem=Oe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(B,ie=[]){this.uri=B,this.provides=(0,i.asArray)(ie)}}e.NotebookRendererScript=Rt;class un{constructor(B){this.label=B}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(B,ie){this.label=B,this.timestamp=ie}};Qi=Ke([R],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(B,ie){this.ranges=B,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(B,ie){this.c=B,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ni=class{constructor(B=void 0,ie=void 0,Ee=void 0){this.include=B,this.exclude=ie,this.profile=Ee}};Ni=Ke([R],Ni),e.TestRunRequest=Ni;let Yi=class extends Ni{constructor(B=void 0,ie=void 0,Ee=void 0,xe=!1){super(B,ie,Ee),this.continuous=xe}};Yi=Ke([R],Yi),e.TestRunRequest2=Yi;let _i=A=class{static diff(B,ie,Ee){const xe=new A(B);return xe.expectedOutput=ie,xe.actualOutput=Ee,xe}constructor(B){this.message=B}};_i=A=Ke([R],_i),e.TestMessage=_i;let Ji=class{constructor(B){this.id=B}};Ji=Ke([R],Ji),e.TestTag=Ji;let gi=class{constructor(B,ie){this.covered=B,this.total=ie}};gi=Ke([R],gi),e.CoveredCount=gi;let Zi=U=class{static fromDetails(B,ie){const Ee=new gi(0,0),xe=new gi(0,0),_e=new gi(0,0);for(const lt of ie)if("branches"in lt){Ee.total+=1,Ee.covered+=lt.executionCount>0?1:0;for(const Lt of lt.branches)xe.total+=1,xe.covered+=Lt.executionCount>0?1:0}else _e.total+=1,_e.covered+=lt.executionCount>0?1:0;const at=new U(B,Ee,xe.total>0?xe:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=ie,at}constructor(B,ie,Ee,xe){this.uri=B,this.statementCoverage=ie,this.branchCoverage=Ee,this.functionCoverage=xe}};Zi=U=Ke([R],Zi),e.FileCoverage=Zi;let en=class{constructor(B,ie,Ee=[]){this.executionCount=B,this.location=ie,this.branches=Ee}};en=Ke([R],en),e.StatementCoverage=en;let tn=class{constructor(B,ie){this.executionCount=B,this.location=ie}};tn=Ke([R],tn),e.BranchCoverage=tn;let nn=class{constructor(B,ie){this.executionCount=B,this.location=ie}};nn=Ke([R],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(B,ie,Ee,xe,_e,at){this.kind=B,this.name=ie,this.detail=Ee,this.uri=xe,this.range=_e,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(B){this.uri=B}}e.TextTabInput=Sn;class yn{constructor(B,ie){this.original=B,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(B,ie,Ee,xe){this.base=B,this.input1=ie,this.input2=Ee,this.result=xe}}e.TextMergeTabInput=Dn;class In{constructor(B,ie){this.uri=B,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(B){this.viewType=B}}e.WebviewEditorTabInput=Cn;class kn{constructor(B,ie){this.uri=B,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(B,ie,Ee){this.original=B,this.modified=ie,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(B,ie){this.uri=B,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(ke[99],Te([1,0,49,15,10,258,131,7,16]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function N(f,a){a?k.set(f,a):k.delete(f)}e.setWordDefinitionFor=N;function w(f){return k.get(f)}class h extends M.MirrorTextModel{constructor(a,s,l,g,E,L,v,t){super(s,l,g,E),this.m=a,this.p=L,this.q=v,this.notebook=t,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,S.equals)(this.d,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.c},get fileName(){return a.c.fsPath},get isUntitled(){return a.c.scheme===C.Schemas.untitled},get languageId(){return a.p},get version(){return a.g},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(s){return s?a.s(s):a.getText()},get eol(){return a.f===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return a.d.length},lineAt(s){return a.t(s)},offsetAt(s){return a.u(s)},positionAt(s){return a.v(s)},validateRange(s){return a.w(s)},validatePosition(s){return a.x(s)},getWordRangeAtPosition(s,l){return a.y(s,l)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,i.ok)(!this.b),this.p=a}_acceptIsDirty(a){(0,i.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(a){const s=this.w(a);if(s.isEmpty)return"";if(s.isSingleLine)return this.d[s.start.line].substring(s.start.character,s.end.character);const l=this.f,g=s.start.line,E=s.end.line,L=[];L.push(this.d[g].substring(s.start.character));for(let v=g+1;v<E;v++)L.push(this.d[v]);return L.push(this.d[E].substring(0,s.end.character)),L.join(l)}t(a){let s;if(a instanceof O.Position?s=a.line:typeof a=="number"&&(s=a),typeof s!="number"||s<0||s>=this.d.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new b(s,this.d[s],s===this.d.length-1)}u(a){return a=this.x(a),this.k(),this.h.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.k();const s=this.h.getIndexOf(a),l=this.d[s.index].length;return new O.Position(s.index,Math.min(s.remainder,l))}w(a){if(!(a instanceof O.Range))throw new Error("Invalid argument");const s=this.x(a.start),l=this.x(a.end);return s===a.start&&l===a.end?a:new O.Range(s.line,s.character,l.line,l.character)}x(a){if(!(a instanceof O.Position))throw new Error("Invalid argument");if(this.d.length===0)return a.with(0,0);let{line:s,character:l}=a,g=!1;if(s<0)s=0,l=0,g=!0;else if(s>=this.d.length)s=this.d.length-1,l=this.d[s].length,g=!0;else{const E=this.d[s].length;l<0?(l=0,g=!0):l>E&&(l=E,g=!0)}return g?new O.Position(s,l):a}y(a,s){const l=this.x(a);if(!s)s=w(this.p);else if((0,D.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const g=(0,y.getWordAtText)(l.character+1,(0,y.ensureValidWordDefinition)(s),this.d[l.line],0);if(g)return new O.Range(l.line,g.startColumn-1,l.line,g.endColumn-1)}}e.ExtHostDocumentData=h;class b{constructor(a,s,l){this.a=a,this.b=s,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(ke[193],Te([1,0,7,18,4]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(O){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(O){let S;switch(O){case"light":S=i.ColorThemeKind.Light;break;case"hcDark":S=i.ColorThemeKind.HighContrast;break;case"hcLight":S=i.ColorThemeKind.HighContrastLight;break;default:S=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=Ke([je(0,C.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(ke[8],Te([1,0,16,23,116,194,86,28,112,66,65,22,9,2,44,75,91,96,95,71,45,56,190,7]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ie){function Ae(G){const{selectionStartLineNumber:Re,selectionStartColumn:Be,positionLineNumber:Qe,positionColumn:$e}=G,Ze=new d.Position(Re-1,Be-1),ct=new d.Position(Qe-1,$e-1);return new d.Selection(Ze,ct)}Ie.to=Ae;function me(G){const{anchor:Re,active:Be}=G;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ie.from=me})(r=e.Selection||(e.Selection={}));var u;(function(Ie){function Ae(G){if(!G)return;const{start:Re,end:Be}=G;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ie.from=Ae;function me(G){if(!G)return;const{startLineNumber:Re,startColumn:Be,endLineNumber:Qe,endColumn:$e}=G;return new d.Range(Re-1,Be-1,Qe-1,$e-1)}Ie.to=me})(u=e.Range||(e.Range={}));var n;(function(Ie){function Ae(me){switch(me){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Ie.to=Ae})(n=e.TokenType||(e.TokenType={}));var p;(function(Ie){function Ae(G){return new d.Position(G.lineNumber-1,G.column-1)}Ie.to=Ae;function me(G){return{lineNumber:G.line+1,column:G.character+1}}Ie.from=me})(p=e.Position||(e.Position={}));var o;(function(Ie){function Ae(Re,Be){return(0,i.coalesce)((0,i.asArray)(Re).map(Qe=>me(Qe,Be)))}Ie.from=Ae;function me(Re,Be){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:G(Re.scheme,Be),pattern:Q.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function G(Re,Be){return Be&&typeof Re=="string"?Be.transformOutgoingScheme(Re):Re}})(o=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(Ie){function Ae(G){switch(G){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Ie.from=Ae;function me(G){switch(G){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Ie.to=me})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Ie){function Ae(G){let Re;return G.code&&((0,h.isString)(G.code)||(0,h.isNumber)(G.code)?Re=String(G.code):Re={value:String(G.code.value),target:G.code.target}),{...u.from(G.range),message:G.message,source:G.source,code:Re,severity:T.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(P.from),tags:Array.isArray(G.tags)?(0,i.coalesce)(G.tags.map(c.from)):void 0}}Ie.from=Ae;function me(G){const Re=new d.Diagnostic(u.to(G),G.message,T.to(G.severity));return Re.source=G.source,Re.code=(0,h.isString)(G.code)?G.code:G.code?.value,Re.relatedInformation=G.relatedInformation&&G.relatedInformation.map(P.to),Re.tags=G.tags&&(0,i.coalesce)(G.tags.map(c.to)),Re}Ie.to=me})(m=e.Diagnostic||(e.Diagnostic={}));var P;(function(Ie){function Ae(G){return{...u.from(G.location.range),message:G.message,resource:G.location.uri}}Ie.from=Ae;function me(G){return new d.DiagnosticRelatedInformation(new d.Location(G.resource,u.to(G)),G.message)}Ie.to=me})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var T;(function(Ie){function Ae(G){switch(G){case d.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Ie.from=Ae;function me(G){switch(G){case s.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Ie.to=me})(T=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var V;(function(Ie){function Ae(G){return typeof G=="number"&&G>=d.ViewColumn.One?G-1:G===d.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Ie.from=Ae;function me(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=me})(V=e.ViewColumn||(e.ViewColumn={}));function _(Ie){return typeof Ie.range<"u"}function K(Ie){return Ie.length===0?!0:!!_(Ie[0])}e.isDecorationOptionsArr=K;var A;(function(Ie){function Ae($e){return $e.map(Ie.from)}Ie.fromMany=Ae;function me($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function G($e){let Ze;if(me($e)){const{language:Et,value:It}=$e;Ze={value:"```"+Et+`
`+It+"\n```\n"}}else d.MarkdownString.isMarkdownString($e)?Ze={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml,baseUri:$e.baseUri}:typeof $e=="string"?Ze={value:$e}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Tt=Et=>{try{let It=b.URI.parse(Et,!0);It=It.with({query:Re(It.query,ct)}),ct[Et]=It}catch{}return""},bt=new S.marked.Renderer;return bt.link=Tt,bt.image=Et=>typeof Et=="string"?Tt(y.parseHrefAndDimensions(Et).href):"",(0,S.marked)(Ze.value,{renderer:bt}),Ze}Ie.from=G;function Re($e,Ze){if(!$e)return $e;let ct;try{ct=(0,k.parse)($e)}catch{}if(!ct)return $e;let Tt=!1;return ct=(0,w.cloneAndChange)(ct,bt=>{if(b.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Et]=bt,Tt=!0,Et}else return}),Tt?JSON.stringify(ct):$e}function Be($e){const Ze=new d.MarkdownString($e.value,$e.supportThemeIcons);return Ze.isTrusted=$e.isTrusted,Ze.supportHtml=$e.supportHtml,Ze.baseUri=$e.baseUri?b.URI.from($e.baseUri):void 0,Ze}Ie.to=Be;function Qe($e){if(!!$e)return typeof $e=="string"?$e:Ie.from($e)}Ie.fromStrict=Qe})(A=e.MarkdownString||(e.MarkdownString={}));function U(Ie){return K(Ie)?Ie.map(Ae=>({range:u.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?A.fromMany(Ae.hoverMessage):Ae.hoverMessage?A.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ie.map(Ae=>({range:u.from(Ae)}))}e.fromRangeOrRangeWithMessage=U;function R(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?b.URI.file(Ie):Ie}e.pathOrURIToURI=R;var F;(function(Ie){function Ae(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?R(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ie.from=Ae})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(Ie){function Ae(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?R(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?F.from(me.before):void 0,after:me.after?F.from(me.after):void 0}}Ie.from=Ae})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Ie){function Ae(me){if(typeof me>"u")return me;switch(me){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Ae})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(Ie){function Ae(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?j.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?H.from(me.light):void 0,dark:me.dark?H.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?R(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?F.from(me.before):void 0,after:me.after?F.from(me.after):void 0}}Ie.from=Ae})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ge;(function(Ie){function Ae(G){return{text:G.newText,eol:G.newEol&&it.from(G.newEol),range:u.from(G.range)}}Ie.from=Ae;function me(G){const Re=new d.TextEdit(u.to(G.range),G.text);return Re.newEol=typeof G.eol>"u"?void 0:it.to(G.eol),Re}Ie.to=me})(ge=e.TextEdit||(e.TextEdit={}));var re;(function(Ie){function Ae(G,Re){const Be={edits:[]};if(G instanceof d.WorkspaceEdit){const Qe=new O.ResourceSet;for(const $e of G._allEntries())$e._type===1&&b.URI.isUri($e.to)&&$e.from===void 0&&Qe.add($e.to);for(const $e of G._allEntries())$e._type===1?Be.edits.push({oldResource:$e.from,newResource:$e.to,options:{...$e.options,contentsBase64:$e.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap($e.options.contents))},metadata:$e.metadata}):$e._type===2?Be.edits.push({resource:$e.uri,textEdit:ge.from($e.edit),versionId:Qe.has($e.uri)?void 0:Re?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===6?Be.edits.push({resource:$e.uri,textEdit:{range:u.from($e.range),text:$e.edit.value,insertAsSnippet:!0},versionId:Qe.has($e.uri)?void 0:Re?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Be.edits.push({metadata:$e.metadata,resource:$e.uri,cellEdit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Be.edits.push({metadata:$e.metadata,resource:$e.uri,notebookVersionId:Re?.getNotebookDocumentVersion($e.uri),cellEdit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(vt.from)}})}return Be}Ie.from=Ae;function me(G){const Re=new d.WorkspaceEdit;for(const Be of G.edits)Be.textEdit?Re.replace(b.URI.revive(Be.resource),u.to(Be.textEdit.range),Be.textEdit.text):Re.renameFile(b.URI.revive(Be.oldResource),b.URI.revive(Be.newResource),Be.options);return Re}Ie.to=me})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ae;(function(Ie){const Ae=Object.create(null);Ae[d.SymbolKind.File]=0,Ae[d.SymbolKind.Module]=1,Ae[d.SymbolKind.Namespace]=2,Ae[d.SymbolKind.Package]=3,Ae[d.SymbolKind.Class]=4,Ae[d.SymbolKind.Method]=5,Ae[d.SymbolKind.Property]=6,Ae[d.SymbolKind.Field]=7,Ae[d.SymbolKind.Constructor]=8,Ae[d.SymbolKind.Enum]=9,Ae[d.SymbolKind.Interface]=10,Ae[d.SymbolKind.Function]=11,Ae[d.SymbolKind.Variable]=12,Ae[d.SymbolKind.Constant]=13,Ae[d.SymbolKind.String]=14,Ae[d.SymbolKind.Number]=15,Ae[d.SymbolKind.Boolean]=16,Ae[d.SymbolKind.Array]=17,Ae[d.SymbolKind.Object]=18,Ae[d.SymbolKind.Key]=19,Ae[d.SymbolKind.Null]=20,Ae[d.SymbolKind.EnumMember]=21,Ae[d.SymbolKind.Struct]=22,Ae[d.SymbolKind.Event]=23,Ae[d.SymbolKind.Operator]=24,Ae[d.SymbolKind.TypeParameter]=25;function me(Re){return typeof Ae[Re]=="number"?Ae[Re]:6}Ie.from=me;function G(Re){for(const Be in Ae)if(Ae[Be]===Re)return Number(Be);return d.SymbolKind.Property}Ie.to=G})(ae=e.SymbolKind||(e.SymbolKind={}));var ce;(function(Ie){function Ae(G){switch(G){case d.SymbolTag.Deprecated:return 1}}Ie.from=Ae;function me(G){switch(G){case 1:return d.SymbolTag.Deprecated}}Ie.to=me})(ce=e.SymbolTag||(e.SymbolTag={}));var Se;(function(Ie){function Ae(G){return{name:G.name,kind:ae.from(G.kind),tags:G.tags&&G.tags.map(ce.from),containerName:G.containerName,location:ye.from(G.location)}}Ie.from=Ae;function me(G){const Re=new d.SymbolInformation(G.name,ae.to(G.kind),G.containerName,ye.to(G.location));return Re.tags=G.tags&&G.tags.map(ce.to),Re}Ie.to=me})(Se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(Ie){function Ae(G){const Re={name:G.name||"!!MISSING: name!!",detail:G.detail,range:u.from(G.range),selectionRange:u.from(G.selectionRange),kind:ae.from(G.kind),tags:G.tags?.map(ce.from)??[]};return G.children&&(Re.children=G.children.map(Ae)),Re}Ie.from=Ae;function me(G){const Re=new d.DocumentSymbol(G.name,G.detail,ae.to(G.kind),u.to(G.range),u.to(G.selectionRange));return(0,i.isNonEmptyArray)(G.tags)&&(Re.tags=G.tags.map(ce.to)),G.children&&(Re.children=G.children.map(me)),Re}Ie.to=me})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(Ie){function Ae(G){const Re=new d.CallHierarchyItem(ae.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),u.to(G.range),u.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}Ie.to=Ae;function me(G,Re,Be){if(Re=Re??G._sessionId,Be=Be??G._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,name:G.name,detail:G.detail,kind:ae.from(G.kind),uri:G.uri,range:u.from(G.range),selectionRange:u.from(G.selectionRange),tags:G.tags?.map(ce.from)}}Ie.from=me})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(Ie){function Ae(me){return new d.CallHierarchyIncomingCall(X.to(me.from),me.fromRanges.map(G=>u.to(G)))}Ie.to=Ae})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var de;(function(Ie){function Ae(me){return new d.CallHierarchyOutgoingCall(X.to(me.to),me.fromRanges.map(G=>u.to(G)))}Ie.to=Ae})(de=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ye;(function(Ie){function Ae(G){return{range:G.range&&u.from(G.range),uri:G.uri}}Ie.from=Ae;function me(G){return new d.Location(b.URI.revive(G.uri),u.to(G.range))}Ie.to=me})(ye=e.location||(e.location={}));var Ne;(function(Ie){function Ae(G){const Re=G,Be=G;return{originSelectionRange:Re.originSelectionRange?u.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Be.uri,range:u.from(Re.targetRange?Re.targetRange:Be.range),targetSelectionRange:Re.targetSelectionRange?u.from(Re.targetSelectionRange):void 0}}Ie.from=Ae;function me(G){return{targetUri:b.URI.revive(G.uri),targetRange:u.to(G.range),targetSelectionRange:G.targetSelectionRange?u.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?u.to(G.originSelectionRange):void 0}}Ie.to=me})(Ne=e.DefinitionLink||(e.DefinitionLink={}));var We;(function(Ie){function Ae(G){return{range:u.from(G.range),contents:A.fromMany(G.contents)}}Ie.from=Ae;function me(G){return new d.Hover(G.contents.map(A.to),u.to(G.range))}Ie.to=me})(We=e.Hover||(e.Hover={}));var Pe;(function(Ie){function Ae(G){return{range:u.from(G.range),expression:G.expression}}Ie.from=Ae;function me(G){return new d.EvaluatableExpression(u.to(G.range),G.expression)}Ie.to=me})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ce;(function(Ie){function Ae(G){if(G instanceof d.InlineValueText)return{type:"text",range:u.from(G.range),text:G.text};if(G instanceof d.InlineValueVariableLookup)return{type:"variable",range:u.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Ae;function me(G){switch(G.type){case"text":return{range:u.to(G.range),text:G.text};case"variable":return{range:u.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:u.to(G.range),expression:G.expression}}}Ie.to=me})(Ce=e.InlineValue||(e.InlineValue={}));var we;(function(Ie){function Ae(G){return{frameId:G.frameId,stoppedLocation:u.from(G.stoppedLocation)}}Ie.from=Ae;function me(G){return new d.InlineValueContext(G.frameId,u.to(G.stoppedLocation))}Ie.to=me})(we=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(Ie){function Ae(G){return{range:u.from(G.range),kind:G.kind}}Ie.from=Ae;function me(G){return new d.DocumentHighlight(u.to(G.range),G.kind)}Ie.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ue;(function(Ie){function Ae(me){switch(me){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Ie.to=Ae})(ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Ie){function Ae(me){return{triggerKind:ue.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ie.to=Ae})(Z=e.CompletionContext||(e.CompletionContext={}));var I;(function(Ie){function Ae(G){switch(G){case d.CompletionItemTag.Deprecated:return 1}}Ie.from=Ae;function me(G){switch(G){case 1:return d.CompletionItemTag.Deprecated}}Ie.to=me})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Ie){const Ae=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function me(Be){return Ae.get(Be)??9}Ie.from=me;const G=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Be){return G.get(Be)??d.CompletionItemKind.Property}Ie.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(Ie){function Ae(me,G){const Re=new d.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=$.to(me.kind),Re.tags=me.tags?.map(I.to),Re.detail=me.detail,Re.documentation=y.isMarkdownString(me.documentation)?A.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,f.Range.isIRange(me.range)?Re.range=u.to(me.range):typeof me.range=="object"&&(Re.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new d.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(Be=>ge.to(Be))),Re.command=G&&me.command?G.fromInternal(me.command):void 0,Re}Ie.to=Ae})(W=e.CompletionItem||(e.CompletionItem={}));var q;(function(Ie){function Ae(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:A.fromStrict(G.documentation)}}Ie.from=Ae;function me(G){return{label:G.label,documentation:y.isMarkdownString(G.documentation)?A.to(G.documentation):G.documentation}}Ie.to=me})(q=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(Ie){function Ae(G){return{label:G.label,documentation:A.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(q.from):[],activeParameter:G.activeParameter}}Ie.from=Ae;function me(G){return{label:G.label,documentation:y.isMarkdownString(G.documentation)?A.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(q.to):[],activeParameter:G.activeParameter}}Ie.to=me})(ee=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(Ie){function Ae(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ee.from):[]}}Ie.from=Ae;function me(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ee.to):[]}}Ie.to=me})(fe=e.SignatureHelp||(e.SignatureHelp={}));var De;(function(Ie){function Ae(me,G){const Re=new d.InlayHint(p.to(G.position),typeof G.label=="string"?G.label:G.label.map(oe.to.bind(void 0,me)),G.kind&&ve.to(G.kind));return Re.textEdits=G.textEdits&&G.textEdits.map(ge.to),Re.tooltip=y.isMarkdownString(G.tooltip)?A.to(G.tooltip):G.tooltip,Re.paddingLeft=G.paddingLeft,Re.paddingRight=G.paddingRight,Re}Ie.to=Ae})(De=e.InlayHint||(e.InlayHint={}));var oe;(function(Ie){function Ae(me,G){const Re=new d.InlayHintLabelPart(G.label);return Re.tooltip=y.isMarkdownString(G.tooltip)?A.to(G.tooltip):G.tooltip,a.Command.is(G.command)&&(Re.command=me.fromInternal(G.command)),G.location&&(Re.location=ye.to(G.location)),Re}Ie.to=Ae})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(Ie){function Ae(G){return G}Ie.from=Ae;function me(G){return G}Ie.to=me})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(Ie){function Ae(G){return{range:u.from(G.range),url:G.target,tooltip:G.tooltip}}Ie.from=Ae;function me(G){let Re;if(G.url)try{Re=typeof G.url=="string"?b.URI.parse(G.url,!0):b.URI.revive(G.url)}catch{}return new d.DocumentLink(u.to(G.range),Re)}Ie.to=me})(be=e.DocumentLink||(e.DocumentLink={}));var He;(function(Ie){function Ae(G){const Re=new d.ColorPresentation(G.label);return G.textEdit&&(Re.textEdit=ge.to(G.textEdit)),G.additionalTextEdits&&(Re.additionalTextEdits=G.additionalTextEdits.map(Be=>ge.to(Be))),Re}Ie.to=Ae;function me(G){return{label:G.label,textEdit:G.textEdit?ge.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Re=>ge.from(Re)):void 0}}Ie.from=me})(He=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Ie){function Ae(G){return new d.Color(G[0],G[1],G[2],G[3])}Ie.to=Ae;function me(G){return[G.red,G.green,G.blue,G.alpha]}Ie.from=me})(qe=e.Color||(e.Color={}));var tt;(function(Ie){function Ae(G){return{range:u.from(G.range)}}Ie.from=Ae;function me(G){return new d.SelectionRange(u.to(G.range))}Ie.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Ie){function Ae(me){switch(me){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Ie.to=Ae})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(Ie){function Ae(G){switch(G){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Ae;function me(G){switch(G){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}Ie.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(Ie){function Ae(G){if(G===d.EndOfLine.CRLF)return 1;if(G===d.EndOfLine.LF)return 0}Ie.from=Ae;function me(G){if(G===1)return d.EndOfLine.CRLF;if(G===0)return d.EndOfLine.LF}Ie.to=me})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(Ie){function Ae(me){if(typeof me=="object")return me.viewId;switch(me){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Ae})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(Ie){function Ae(G){const Re={start:G.start+1,end:G.end+1};return G.kind&&(Re.kind=ot.from(G.kind)),Re}Ie.from=Ae;function me(G){const Re={start:G.start-1,end:G.end-1};return G.kind&&(Re.kind=ot.to(G.kind)),Re}Ie.to=me})(Fe=e.FoldingRange||(e.FoldingRange={}));var ot;(function(Ie){function Ae(G){if(G)switch(G){case d.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}Ie.from=Ae;function me(G){if(G)switch(G.value){case a.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}Ie.to=me})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(Ie){function Ae(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ie.from=Ae})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(Ie){function Ae(Be){return Be instanceof d.RelativePattern?Be.toJSON():typeof Be=="string"?Be:me(Be)||G(Be)?new d.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ie.from=Ae;function me(Be){const Qe=Be;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function G(Be){const Qe=Be;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(Be){return typeof Be=="string"?Be:new d.RelativePattern(b.URI.revive(Be.baseUri),Be.pattern)}Ie.to=Re})(Q=e.GlobPattern||(e.GlobPattern={}));var pe;(function(Ie){function Ae(me){if(me){if(Array.isArray(me))return me.map(Ae);if(typeof me=="string")return me;{const G=me;return{language:G.language,scheme:G.scheme,pattern:Q.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ie.from=Ae})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(Ie){function Ae(G){return{start:G.start,end:G.end}}Ie.from=Ae;function me(G){return new d.NotebookRange(G.start,G.end)}Ie.to=me})(Me=e.NotebookRange||(e.NotebookRange={}));var ze;(function(Ie){function Ae(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ie.to=Ae;function me(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ie.from=me})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(Ie){function Ae(me){if(me===E.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(me===E.NotebookCellExecutionState.Pending)return;if(me===E.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ie.to=Ae})(Ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(Ie){function Ae(G){switch(G){case d.NotebookCellKind.Markup:return E.CellKind.Markup;case d.NotebookCellKind.Code:default:return E.CellKind.Code}}Ie.from=Ae;function me(G){switch(G){case E.CellKind.Markup:return d.NotebookCellKind.Markup;case E.CellKind.Code:default:return d.NotebookCellKind.Code}}Ie.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(Ie){function Ae(G){const Re={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)d.NotebookCellData.validate(Be),Re.cells.push(vt.from(Be));return Re}Ie.from=Ae;function me(G){const Re=new d.NotebookData(G.cells.map(vt.to));return(0,h.isEmptyObject)(G.metadata)||(Re.metadata=G.metadata),Re}Ie.to=me})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(Ie){function Ae(G){return{cellKind:Ye.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:ze.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ct.from):[]}}Ie.from=Ae;function me(G){return new d.NotebookCellData(Ye.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ct.to):void 0,G.metadata,G.internalMetadata?ze.to(G.internalMetadata):void 0)}Ie.to=me})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(Ie){function Ae(G){return{mime:G.mime,valueBytes:C.VSBuffer.wrap(G.data)}}Ie.from=Ae;function me(G){return new d.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}Ie.to=me})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(Ie){function Ae(G){return{outputId:G.id,items:G.items.map(wt.from),metadata:G.metadata}}Ie.from=Ae;function me(G){const Re=G.items.map(wt.to);return new d.NotebookCellOutput(Re,G.outputId,G.metadata)}Ie.to=me})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var jt;(function(Ie){function Ae(Re){return G(Re)?{include:(0,h.withNullAsUndefined)(Q.from(Re.include)),exclude:(0,h.withNullAsUndefined)(Q.from(Re.exclude))}:(0,h.withNullAsUndefined)(Q.from(Re))}Ie.from=Ae;function me(Re){return G(Re)?{include:Q.to(Re.include),exclude:Q.to(Re.exclude)}:Q.to(Re)}Ie.to=me;function G(Re){const Be=Re;return Be?!(0,h.isUndefinedOrNull)(Be.include)&&!(0,h.isUndefinedOrNull)(Be.exclude):!1}})(jt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Ie){function Ae(me,G,Re){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ie.from=Ae})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(Ie){function Ae(me,G,Re){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:G.toInternal(Be,Re),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ie.from=Ae})(mt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(Ie){function Ae(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ie.from=Ae})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Gt;(function(Ie){function Ae(G){return{uri:G.uri,provides:G.provides}}Ie.from=Ae;function me(G){return new d.NotebookRendererScript(b.URI.revive(G.uri),G.provides)}Ie.to=me})(Gt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(Ie){function Ae(G){return{message:A.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:u.from(G.location.range),uri:G.location.uri}}}Ie.from=Ae;function me(G){const Re=new d.TestMessage(typeof G.message=="string"?G.message:A.to(G.message));return Re.actualOutput=G.actual,Re.expectedOutput=G.expected,Re.location=G.location?ye.to(G.location):void 0,Re}Ie.to=me})(Pt=e.TestMessage||(e.TestMessage={}));var ht;(function(Ie){Ie.namespace=v.namespaceTestTag,Ie.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var kt;(function(Ie){function Ae(G){const Re=(0,l.getPrivateApiFor)(G).controllerId;return{extId:L.TestId.fromExtHostTestItem(G,Re).toString(),label:G.label,uri:b.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>ht.namespace(Re,Be.id)),range:f.Range.lift(u.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&A.fromStrict(G.error)||null}}Ie.from=Ae;function me(G){return{parent:void 0,error:void 0,id:L.TestId.fromString(G.extId).localId,label:G.label,uri:b.URI.revive(G.uri),tags:(G.tags||[]).map(Re=>{const{tagId:Be}=ht.denamespace(Re);return new d.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ie.toPlain=me})(kt=e.TestItem||(e.TestItem={})),function(Ie){function Ae(G){return{id:G.id}}Ie.from=Ae;function me(G){return new d.TestTag(G.id)}Ie.to=me}(ht=e.TestTag||(e.TestTag={}));var Bt;(function(Ie){const Ae=(G,Re)=>{const Be=[];for(const[$e,Ze]of Re)L.TestId.compare(Ze.item.extId,$e)===2&&(Re.delete($e),Be.push(Ze));const Qe={...kt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(Ze=>Ze.type===0).map(Pt.to)})),children:Be.map($e=>Ae($e,Re))};for(const $e of Qe.children)$e.parent=Qe;return Qe};function me(G){const Re=[],Be=new Map;for(const Qe of G.items){Be.set(Qe.item.extId,Qe);const $e=L.TestId.root(Qe.item.extId);G.request.targets.some(Ze=>Ze.controllerId===$e&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:G.completedAt,results:Re.map(Qe=>Ae(Qe,Be))}}Ie.to=me})(Bt=e.TestResults||(e.TestResults={}));var Ot;(function(Ie){function Ae(Be){return{covered:Be.covered,total:Be.covered}}function me(Be){return"line"in Be?p.from(Be):u.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:me(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&me(Qe.location)})):void 0}:{type:0,count:Be.executionCount,location:me(Be.location)}}Ie.fromDetailed=G;function Re(Be){return{uri:Be.uri,statement:Ae(Be.statementCoverage),branch:Be.branchCoverage&&Ae(Be.branchCoverage),function:Be.functionCoverage&&Ae(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Ie.fromFile=Re})(Ot=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(Ie){function Ae(me){switch(me){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Ie.to=Ae})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Ie){function Ae(G){const Re=new d.TypeHierarchyItem(ae.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),u.to(G.range),u.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}Ie.to=Ae;function me(G,Re,Be){if(Re=Re??G._sessionId,Be=Be??G._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,kind:ae.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:u.from(G.range),selectionRange:u.from(G.selectionRange),tags:G.tags?.map(ce.from)}}Ie.from=me})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(Ie){function Ae(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}Ie.from=Ae})(Mt=e.ViewBadge||(e.ViewBadge={}));var zt;(function(Ie){function Ae(Be,Qe,$e){const Ze=Qe.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,M.once)(()=>$e())}}}("",Qe.id):Be===N.Mimes.uriList&&Qe.uriListData?new d.DataTransferItem(Re(Qe.uriListData)):new d.DataTransferItem(Qe.asString)}Ie.to=Ae;async function me(Be,Qe){const $e=await Qe.asString();if(Be===N.Mimes.uriList)return{id:Qe.id,asString:$e,fileData:void 0,uriListData:G($e)};const Ze=Qe.asFile();return{id:Qe.id,asString:$e,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}Ie.from=me;function G(Be){return D.UriList.split(Be).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Re(Be){return D.UriList.create(Be.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(zt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(Ie){function Ae(G,Re){const Be=G.items.map(([Qe,$e])=>[Qe,zt.to(Qe,$e,()=>Re($e.id))]);return new d.DataTransfer(Be)}Ie.toDataTransfer=Ae;async function me(G){const Re={items:[]},Be=[];return G.forEach((Qe,$e)=>{Be.push((async()=>{Re.items.push([$e,await zt.from($e,Qe)])})())}),await Promise.all(Be),Re}Ie.toDataTransferDTO=me})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(ke[195],Te([1,0,2,12,7,8,161]),function(te,e,i,C,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class O{constructor(k,N,w,h={timeout:1500,errors:3}){this.c=k,this.d=N,this.f=w,this.g=h,this.a=new y.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(N,w,h)=>{const f={dispose:this.a.push([N,w,k])};return Array.isArray(h)&&h.push(f),f}}async $participateInSave(k,N){const w=i.URI.revive(k);let h=!1;const b=setTimeout(()=>h=!0,this.g.timeout),f=[];try{for(const a of[...this.a]){if(h)break;const s=this.d.getDocument(w),l=await this.h(a,{document:s,reason:M.TextDocumentSaveReason.to(N)});f.push(l)}}finally{clearTimeout(b)}return f}h([k,N,w],h){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(w,k,N,h).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const a=this.b.get(k);this.b.set(k,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,N,w,h){const b=[],f=Date.now(),{document:a,reason:s}=h,{version:l}=a,g=Object.freeze({document:a,reason:s,waitUntil(E){if(Object.isFrozen(b))throw(0,C.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(E))}});try{N.apply(w,[g])}catch(E){return Promise.reject(E)}return Object.freeze(b),new Promise((E,L)=>{const v=setTimeout(()=>L(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(v),E(t)}).catch(t=>{clearTimeout(v),L(t)})}).then(E=>{const L={edits:[]};for(const v of E)if(Array.isArray(v)&&v.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:d,range:r}of v)L.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:t,eol:d&&M.EndOfLine.from(d)}});if(L.edits.length!==0)return l===a.version?this.f.$tryApplyWorkspaceEdit(L):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=O}),define(ke[196],Te([1,0,15,2,8,7,71]),function(te,e,i,C,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class O{constructor(w,h,b,f){this.start=w,this.deletedCount=h,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(w,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,h,b){this.notebook=w,this.h=h,this.j=b,this.handle=b.handle,this.uri=C.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(D.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return w.g},set mime(f){w.g=f},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(b)}return this.f}setOutputs(w){this.a=w.map(D.NotebookCellOutput.to)}setOutputItems(w,h,b){const f=b.map(D.NotebookCellOutputItem.to),a=this.a.find(s=>s.id===w);if(a&&(h||(a.items.length=0),a.items.push(...f),a.items.length>1&&a.items.every(s=>y.isTextStreamMime(s.mime)))){const s=new Map,l=[];a.items.forEach(g=>{let E;s.has(g.mime)?E=s.get(g.mime):(E=[],s.set(g.mime,E),l.push(g.mime)),E.push(g.data)}),a.items.length=0,l.forEach(g=>{const E=y.compressOutputItemStreams(s.get(g));a.items.push({mime:g,data:E.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=S;class k{constructor(w,h,b,f,a){this.k=w,this.l=h,this.m=b,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,h={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===i.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(b){return b=w.n(b),w.b[b].apiCell},getCells(b){return(b?w.p(b):w.b).map(a=>a.apiCell)},save(){return w.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,h,b){this.g=w.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},a=[];for(const l of w.rawEvents)l.kind===y.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,f.contentChanges):l.kind===y.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,f.contentChanges):l.kind===y.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===y.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===y.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===y.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),a.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),a.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const s=new Map;for(let l=0;l<a.length;l++){const g=a[l],E=s.get(g.cell);if(E===void 0){const L=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});s.set(g.cell,L-1)}else f.cellChanges[E]={...f.cellChanges[E],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let h=w.start|0,b=w.end|0;return h<0&&(h=0),b>this.b.length&&(b=this.b.length),w.with({start:h,end:b})}p(w){w=this.o(w);const h=[];for(let b=w.start;b<w.end;b++)h.push(this.b[b]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,h,b){if(this.j)return;const f=[],a=[],s=[];if(w.reverse().forEach(l=>{const E=l[2].map(t=>{const d=new S(this,this.l,t);return h||a.push(S.asModelAddData(this.apiNotebook,t)),d}),L=new O(l[0],l[1],[],E),v=this.b.splice(l[0],l[1],...E);for(const t of v)s.push(t.uri),L.deletedItems.push(t.apiCell);f.push(L)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:s}),b)for(const l of f)b.push(l.asApiEvent())}s(w,h,b,f){const a=this.b.splice(w,h);this.b.splice(b,0,...a);const s=[new O(w,h,a.map(l=>l.apiCell),[]),new O(b,0,[],a)];for(const l of s)f.push(l.asApiEvent())}t(w,h){this.b[w].setOutputs(h)}u(w,h,b,f){this.b[w].setOutputItems(h,b,f)}v(w,h){const b=this.b[w];b.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(b.uri,h)}w(w,h){const b=this.b[w];b.apiCell.mime=h}x(w,h){this.b[w].setMetadata(h)}y(w,h){this.b[w].setInternalMetadata(h)}getCellFromApiCell(w){return this.b.find(h=>h.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(h=>h.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}k.a=0,e.ExtHostNotebookDocument=k}),define(ke[100],Te([1,0,12,8,7]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(O,S,k,N,w,h){this.id=O,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=N,this.c=h}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(S){this.selections=[S]},get selections(){return O.a},set selections(S){if(!Array.isArray(S)||!S.every(D.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");O.a=S,O.g(S)},get visibleRanges(){return O.b},revealRange(S,k){O.f.$tryRevealRange(O.id,C.NotebookRange.from(S),k??D.NotebookEditorRevealType.Default)},get viewColumn(){return O.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(C.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(ke[197],Te([1,0,4,11,8]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(O,S){this.c=O,this.d=S,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,S);const k=this.d.getEditorById(O);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(D.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(D.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const S in O)this.d.getEditorById(S)._acceptViewColumn(D.ViewColumn.to(O[S]))}};M=Ke([je(0,C.ILogService)],M),e.ExtHostNotebookEditors=M}),define(ke[198],Te([1,0,8,165,141,21,64,12]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(h){this.b=0,this.c=new Map,this.a=h}async withProgress(h,b,f){const a=this.b++,{title:s,location:l,cancellable:g}=b,E={label:(0,D.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this.a.$startProgress(a,{location:i.ProgressLocation.from(l),title:s,source:E,cancellable:g},h.isUnderDevelopment?void 0:h.identifier.value).catch(O.onUnexpectedExternalError),this.d(a,f,!!g)}d(h,b,f){let a;f&&(a=new M.CancellationTokenSource,this.c.set(h,a));const s=g=>{this.a.$progressEnd(g),this.c.delete(g),a?.dispose()};let l;try{l=b(new N(this.a,h),f&&a?a.token:M.CancellationToken.None)}catch(g){throw s(h),g}return l.then(g=>s(h),g=>s(h)),l}$acceptProgressCanceled(h){const b=this.c.get(h);b&&(b.cancel(),this.c.delete(h))}}e.ExtHostProgress=S;function k(w,h){return w.message=h.message,typeof h.increment=="number"&&(typeof w.increment=="number"?w.increment+=h.increment:w.increment=h.increment),w}class N extends C.Progress{constructor(h,b){super(f=>this.throttledReport(f)),this.c=h,this.d=b}throttledReport(h){this.c.$progressReport(this.d,h)}}Ke([(0,y.throttle)(100,(w,h)=>k(w,h),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(ke[101],Te([1,0,44,96,45,72,56,8,2]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,L,v,t)=>{let d=L;return{enumerable:!0,configurable:!1,get(){return d},set(r){if(!v(d,r)){const u=d;d=r,E.listener?.(t(r,u))}}}},N=(E,L)=>E===L,w={range:(E,L)=>E===L?!0:!E||!L?!1:E.isEqual(L),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(E,L)=>!(E.length!==L.length||E.some(v=>!L.find(t=>v.id===t.id)))},h=E=>L=>({op:4,update:E(L)}),b=(E,L)=>({range:(()=>{let v;const t=h(d=>({range:i.Range.lift(O.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return v},set(d){E.listener?.({op:6}),w.range(v,d)||(v=d,E.listener?.(t(d)))}}})(),label:k(E,L,w.label,h(v=>({label:v}))),description:k(E,void 0,w.description,h(v=>({description:v}))),sortText:k(E,void 0,w.sortText,h(v=>({sortText:v}))),canResolveChildren:k(E,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:k(E,!1,w.busy,h(v=>({busy:v}))),error:k(E,void 0,w.error,h(v=>({error:O.MarkdownString.fromStrict(v)||null}))),tags:k(E,[],w.tags,(v,t)=>({op:1,new:v.map(O.TestTag.from),old:t.map(O.TestTag.from)}))}),f=E=>{const L=D.TestId.fromString(E.extId),v=new s(L.controllerId,L.localId,E.label,S.URI.revive(E.uri)||void 0);return v.range=O.Range.to(E.range||void 0),v.description=E.description||void 0,v.sortText=E.sortText||void 0,v.tags=E.tags.map(t=>O.TestTag.to({id:(0,y.denamespaceTestTag)(t).tagId})),v},a=E=>{let L;for(const v of E.tests){const t=f(v.item);(0,C.getPrivateApiFor)(t).parent=L,L=t}return L};e.toItemFromContext=a;class s{constructor(L,v,t,d){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,C.createPrivateApiFor)(this,L);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof l?void 0:r.parent}},children:{value:(0,M.createTestItemChildren)(r,C.getPrivateApiFor,s),enumerable:!0,writable:!1},...b(r,t)})}}e.TestItemImpl=s;class l extends s{constructor(L,v){super(L,L,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class g extends M.TestItemCollection{constructor(L,v,t){super({controllerId:L,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:C.getPrivateApiFor,getChildren:d=>d.children,root:new l(L,v),toITestItem:O.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ke[102],Te([1,0,49,12,83,8,7]),function(te,e,i,C,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class O{constructor(h,b,f){const a=O.c.nextId();h.$registerTextEditorDecorationType(b.identifier,a,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:a,dispose(){h.$removeTextEditorDecorationType(a)}})}}O.c=new D.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=O;class S{constructor(h,b){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,b){this.k();let f=null;if(h instanceof y.Position)f=new y.Range(h,h);else if(h instanceof y.Range)f=h;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(h,b){this.k(),this.l(new y.Range(h,h),b,!0)}delete(h){this.k();let b=null;if(h instanceof y.Range)b=h;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(h,b,f){const a=this.c.validateRange(h);this.g.push({range:a,text:b,forceMoveMarkers:f})}setEndOfLine(h){if(this.k(),h!==y.EndOfLine.LF&&h!==y.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this.h=h}}class k{constructor(h,b,f,a){this.c=h,this.d=b,this._accept(f),this.e=a;const s=this;this.value={get tabSize(){return s.f},set tabSize(l){s.m(l)},get indentSize(){return s.g},set indentSize(l){s.o(l)},get insertSpaces(){return s.h},set insertSpaces(l){s.q(l)},get cursorStyle(){return s.j},set cursorStyle(l){s.s(l)},get lineNumbers(){return s.k},set lineNumbers(l){s.t(l)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.insertSpaces,this.j=h.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(h.lineNumbers)}l(h){if(h==="auto")return"auto";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}m(h){const b=this.l(h);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}o(h){const b=this.n(h);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}q(h){const b=this.p(h);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(h){this.j!==h&&(this.j=h,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}t(h){this.k!==h&&(this.k=h,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(h)})))}assign(h){const b={};let f=!1;if(typeof h.tabSize<"u"){const a=this.l(h.tabSize);a==="auto"?(f=!0,b.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,f=!0,b.tabSize=a)}if(typeof h.indentSize<"u"){const a=this.n(h.indentSize);a==="tabSize"?(f=!0,b.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,f=!0,b.indentSize=a)}if(typeof h.insertSpaces<"u"){const a=this.p(h.insertSpaces);a==="auto"?(f=!0,b.insertSpaces=a):this.h!==a&&(this.h=a,f=!0,b.insertSpaces=a)}typeof h.cursorStyle<"u"&&this.j!==h.cursorStyle&&(this.j=h.cursorStyle,f=!0,b.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.k!==h.lineNumbers&&(this.k=h.lineNumbers,f=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(h.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(h,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=k;class N{constructor(h,b,f,a,s,l,g,E){this.id=h,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=s,this.d=new k(this.j,this.id,l,f),this.e=g,this.f=E;const L=this;this.value=Object.freeze({get document(){return a.value},set document(v){throw(0,C.readonly)("document")},get selection(){return L.c&&L.c[0]},set selection(v){if(!(v instanceof y.Selection))throw(0,C.illegalArgument)("selection");L.c=[v],L.l()},get selections(){return L.c},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof y.Selection)))throw(0,C.illegalArgument)("selections");L.c=v,L.l()},get visibleRanges(){return L.e},set visibleRanges(v){throw(0,C.readonly)("visibleRanges")},get options(){return L.d.value},set options(v){L.g||L.d.assign(v)},get viewColumn(){return L.f},set viewColumn(v){throw(0,C.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(L.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new S(a.value,t);return v(d),L.m(d)},insertSnippet(v,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(L.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=L.c.map(u=>M.Range.from(u));else if(t instanceof y.Position){const{lineNumber:u,column:n}=M.Position.from(t);r=[{startLineNumber:u,startColumn:n,endLineNumber:u,endColumn:n}]}else if(t instanceof y.Range)r=[M.Range.from(t)];else{r=[];for(const u of t)if(u instanceof y.Range)r.push(M.Range.from(u));else{const{lineNumber:n,column:p}=M.Position.from(u);r.push({startLineNumber:n,startColumn:p,endLineNumber:n,endColumn:p})}}return b.$tryInsertSnippet(h,a.value.version,v.value,r,d)},setDecorations(v,t){const d=t.length===0;d&&!L.h.has(v.key)||(d?L.h.delete(v.key):L.h.add(v.key),L.n(()=>{if(M.isDecorationOptionsArr(t))return b.$trySetDecorations(h,v.key,M.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let u=0,n=t.length;u<n;u++){const p=t[u];r[4*u]=p.start.line+1,r[4*u+1]=p.start.character+1,r[4*u+2]=p.end.line+1,r[4*u+3]=p.end.character+1}return b.$trySetDecorationsFast(h,v.key,r)}}))},revealRange(v,t){L.n(()=>b.$tryRevealRange(h,M.Range.from(v),t||y.TextEditorRevealType.Default))},show(v){b.$tryShowEditor(h,M.ViewColumn.from(v))},hide(){b.$tryHideEditor(h)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,i.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,i.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,i.ok)(!this.g),this.f=h}_acceptSelections(h){(0,i.ok)(!this.g),this.c=h}async l(){const h=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const b=h.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(s=>s.range);f.sort((s,l)=>s.end.line===l.end.line?s.end.character===l.end.character?s.start.line===l.start.line?s.start.character-l.start.character:s.start.line-l.start.line:s.end.character-l.end.character:s.end.line-l.end.line);for(let s=0,l=f.length-1;s<l;s++){const g=f[s].end;if(f[s+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=b.edits.map(s=>({range:M.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,a,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=N}),define(ke[199],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[200],Te([1,0,154,12,29,90,69,30,25,199,164,156]),function(te,e,i,C,D,M,y,O,S,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=O.Registry.as(y.Extensions.JSONContribution);class b{constructor(v,t,d){this.a=v,this.b=t,this.c=d}d(v,t){this.a({type:v,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(D.default.Error,v)}warn(v){this.d(D.default.Warning,v)}info(v){this.d(D.default.Info,v)}}e.ExtensionMessageCollector=b;class f{static a(v){const t=new Set;for(let d=0,r=v.length;d<r;d++)t.add(S.ExtensionIdentifier.toKey(v[d].description.identifier));return t}static compute(v,t){if(!v||!v.length)return new f(t,[]);if(!t||!t.length)return new f([],v);const d=this.a(v),r=this.a(t),u=t.filter(p=>!d.has(S.ExtensionIdentifier.toKey(p.description.identifier))),n=v.filter(p=>!r.has(S.ExtensionIdentifier.toKey(p.description.identifier)));return new f(u,n)}constructor(v,t){this.added=v,this.removed=t}}e.ExtensionPointUserDelta=f;class a{constructor(v,t){this.name=v,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=f.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,C.onUnexpectedError)(v)}}}e.ExtensionPoint=a;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const t=new a(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,t),v.activationEventsGenerator&&w.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,h.registerSchema(l,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const E={ExtensionsRegistry:"ExtensionsRegistry"};O.Registry.add(E.ExtensionsRegistry,new g),e.ExtensionsRegistry=O.Registry.as(E.ExtensionsRegistry),h.registerSchema(l,e.schema),h.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(ke[201],Te([1,0,151,9,22,200,42,4]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(h){function b(f,a,s){if(!f)return;const l=C.isString(f.type)?f.type:void 0;if(!l||l.length===0){s.error(i.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const E of f.required)C.isString(E)&&g.push(E);return{extensionId:a.value,taskType:l,required:g,properties:f.properties?D.deepClone(f.properties):{},when:f.when?y.ContextKeyExpr.deserialize(f.when):void 0}}h.from=b})(k||(k={}));const N=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,b)=>{for(const f of h)f.type&&b.push(`onTaskType:${f.type}`)},jsonSchema:{description:i.localize(4,null),type:"array",items:S}});class w{constructor(){this.d=new O.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{N.setHandler((a,s)=>{this.c=void 0;try{for(const l of s.removed){const g=l.value;for(const E of g)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const l of s.added){const g=l.value;for(const E of g){const L=k.from(E,l.description.identifier,l.collector);L&&(this.a[L.taskType]=L)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const a={type:"object",additionalProperties:!1};f.required.length>0&&(a.required=f.required.slice(0)),f.properties!==void 0?a.properties=D.deepClone(f.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[f.taskType]},b.push(a)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new w}),define(ke[202],Te([1,0,152,9,24,22,42,201]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var S;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function F(H){if(!H)return R.Strong;switch(H.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=F}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var N;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(R){function F(H){switch(H.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=F}(N=e.RevealKind||(e.RevealKind={}));var w;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function F(H){switch(H.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=F}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var h;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(h=e.PanelKind||(e.PanelKind={})),function(R){function F(H){switch(H.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=F}(h=e.PanelKind||(e.PanelKind={}));var b;(function(R){R.defaults={echo:!0,reveal:N.Always,revealProblems:w.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(R){function F(j){switch(j.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=F;function H(j){switch(j){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=H}(f=e.RuntimeType||(e.RuntimeType={}));var a;(function(R){function F(H){return C.isString(H)?H:H.value}R.value=F})(a=e.CommandString||(e.CommandString={}));var s;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function F(j){return j===R.Clean._id||j===R.Build._id||j===R.Rebuild._id||j===R.Test._id}R.is=F;function H(j){if(j!==void 0)return C.isString(j)?F(j)?{_id:j,isDefault:!1}:void 0:j}R.from=H})(s=e.TaskGroup||(e.TaskGroup={}));var l;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var g;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function F(H){switch(H){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=F})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(R){R.parallel="parallel",R.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var L;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(L=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:L.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(F,H,j,le,ge,re){this._label="",this._id=F,H&&(this._label=H),j&&(this.type=j),this.runOptions=le,this.configurationProperties=ge,this._source=re}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,H=!1){if(F===void 0)return!1;if(C.isString(F))return F===this._label||F===this.configurationProperties.identifier||H&&F===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class d extends t{constructor(F,H,j,le,ge,re,ae,ce){super(F,j,void 0,ae,ce,H),this.command={},this._source=H,this.hasDefinedMatchers=re,ge&&(this.command=ge)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case f.Shell:H="shell";break;case f.Process:H="process";break;case f.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=d;class r extends t{constructor(F,H,j,le,ge,re,ae){super(F,j,le,re,ae,H),this._source=H,this.configures=ge}static is(F){return F instanceof r}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(j)}}e.ConfiguringTask=r;class u extends t{constructor(F,H,j,le,ge,re,ae,ce,Se){super(F,j,le,ce,Se,H),this.defines=ge,this.hasDefinedMatchers=ae,this.command=re,this.icon=Se.icon,this.hide=Se.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof u}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new u(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=u;class n extends t{constructor(F,H,j,le,ge,re){super(F,j,le,ge,re,H),this._source=H}clone(){return new n(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof n}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new n(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=n;var p;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(p=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(p=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class c{constructor(F){this.c=new Map;for(let H=0;H<F.length;H++)this.c.set(F[H].uri.toString(),H)}compare(F,H){const j=F.getWorkspaceFolder(),le=H.getWorkspaceFolder();if(j&&le){let ge=this.c.get(j.uri.toString());ge=ge===void 0?0:ge+1;let re=this.c.get(le.uri.toString());return re=re===void 0?0:re+1,ge===re?F._label.localeCompare(H._label):ge-re}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=c;var m;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(m=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(R){R.SingleRun="singleRun",R.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var T;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(T=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(R){function F(H,j,le,ge){if(j){const re={kind:H,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return H==="start"?re.resolvedVariables=ge:H==="processStarted"?re.processId=ge:H==="processEnded"&&(re.exitCode=ge),Object.freeze(re)}else return Object.freeze({kind:"changed"})}R.create=F})(V=e.TaskEvent||(e.TaskEvent={}));var _;(function(R){function F(j){const le=Object.keys(j).sort();let ge="";for(const re of le){let ae=j[re];ae instanceof Object?ae=F(ae):typeof ae=="string"&&(ae=ae.replace(/,/g,",,")),ge+=re+","+ae+","}return ge}function H(j){const ge={_key:F(j),type:j.taskType};return Object.assign(ge,j),ge}R.create=H})(_=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var K;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(K=e.TaskSettingId||(e.TaskSettingId={}));var A;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(A=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(R){function F(H,j){const le=O.TaskDefinitionRegistry.get(H.type);if(le===void 0){const ce=M.deepClone(H);return delete ce._key,_.create(ce)}const ge=Object.create(null);ge.type=le.taskType;const re=new Set;le.required.forEach(ce=>re.add(ce));const ae=le.properties;for(const ce of Object.keys(ae)){const Se=H[ce];if(Se!=null)ge[ce]=Se;else if(re.has(ce)){const x=ae[ce];if(x.default!==void 0)ge[ce]=M.deepClone(x.default);else switch(x.type){case"boolean":ge[ce]=!1;break;case"number":case"integer":ge[ce]=0;break;case"string":ge[ce]="";break;default:j.error(i.localize(2,null,JSON.stringify(H,void 0,0),ce));return}}}return _.create(ge)}R.createTaskIdentifier=F})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(ke[203],Te([1,0,12]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((y,O)=>{this.b=y,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(y){this.f||this.h||(this.f=!0,this.g=y,this.a&&this.b(y))}resolveErr(y){this.f||this.h||(this.h=!0,this.i=y,this.a?this.d(y):(0,i.onUnexpectedError)(y))}then(y,O){return this.j().then(y,O)}catch(y){return this.j().then(void 0,y)}finally(y){return this.j().finally(y)}}e.LazyPromise=C;class D extends C{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=D}),define(ke[46],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++i.count}}i.count=0,e.ProxyIdentifier=i;const C=[];function D(O){const S=new i(O);return C[S.nid]=S,S}e.createProxyIdentifier=D;function M(O){return C[O].sid}e.getStringIdentifierForProxy=M;class y{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=y}),define(ke[5],Te([1,0,46]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var O;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(O=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(s){return s._id=w.a++,s}}w.a=0,e.IdObject=w;var h;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,i.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,i.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(ke[76],Te([1,0,3,11,5,18]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,k,N){const w=this.d(S,k);this.a.has(w)||(this.a.add(w),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};y=Ke([je(0,M.IExtHostRpcService),je(1,C.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(O,S,k){}})}),define(ke[204],Te([1,0,4,5,7,25]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,N,w={}){const h=M.ExtensionIdentifier.toKey(S.identifier),b=this.f.get(h)||[],f=[...N].sort().join(" ");let a=b.find(s=>s.providerId===k&&s.scopes===f);if(a)return a.result;{const s=this.g(S,h,k,N,w);a={providerId:k,scopes:f,result:s},b.push(a),this.f.set(h,b);try{await s}finally{const l=b.findIndex(g=>g.providerId===k&&g.scopes===f);l>-1&&(b.splice(l),this.f.set(h,b))}return s}}async g(S,k,N,w,h={}){await this.a.$ensureProvider(N);const b=S.displayName||S.name;return this.a.$getSession(N,w,k,b,h)}async removeSession(S,k){const N=this.b.get(S);return N?N.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,N,w){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:N,options:w??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===S)||this.c.push({id:S,label:k});const h=N.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(S,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,w?.supportsMultipleAccounts??!1),new D.Disposable(()=>{h.dispose(),this.b.delete(S);const b=this.c.findIndex(f=>f.id===S);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ke[205],Te([1,0,5,18,8]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(O,S){this.a=O.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(O,S,k){const N=D.WorkspaceEdit.from(O,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,k?.isRefactoring??!1)}};M=Ke([je(0,C.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(ke[206],Te([1,0,5]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(M){const y=M.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(O){return y.$writeText(O)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[37],Te([1,0,9,7,8,22,5,16,11,66,44,259,2,6,3,18,101,23,46,39,77,52,57]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v,t){"use strict";var d,r,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(T,V,_){d.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),u.set(this,void 0),Je(this,d,T.getProxy(y.MainContext.MainThreadCommands),"f"),this.d=V,Je(this,u,_,"f"),Je(this,r,T.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new p(this,K=>{const A=this.c.get(K);return A?.result===c.Void?A:void 0},V),this.f=[{processArgument(K){return(0,k.revive)(K)}},{processArgument(K){return(0,M.cloneAndChange)(K,function(A){if(N.Range.isIRange(A))return D.Range.to(A);if(w.Position.isIPosition(A))return D.Position.to(A);if(N.Range.isIRange(A.range)&&h.URI.isUri(A.uri))return D.location.to(A);if(A instanceof l.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(T){this.f.push(T)}registerApiCommand(T){const V=this.registerCommand(!1,T.id,async(..._)=>{const K=T.args.map((U,R)=>{if(!U.validate(_[R]))throw new Error(`Invalid argument '${U.name}' when running '${T.id}', received: ${_[R]}`);return U.convert(_[R])}),A=await this.executeCommand(T.internalId,...K);return T.result.convert(A,_,this.converter)},void 0,{description:T.description,args:T.args,returns:T.result.description});return this.c.set(T.id,T),new C.Disposable(()=>{V.dispose(),this.c.delete(T.id)})}registerCommand(T,V,_,K,A,U){if(this.d.trace("ExtHostCommands#registerCommand",V),!V.trim().length)throw new Error("invalid id");if(this.b.has(V))throw new Error(`command '${V}' already exists`);return this.b.set(V,{callback:_,thisArg:K,description:A,extension:U}),T&&Le(this,d,"f").$registerCommand(V),new C.Disposable(()=>{this.b.delete(V)&&T&&Le(this,d,"f").$unregisterCommand(V)})}executeCommand(T,...V){return this.d.trace("ExtHostCommands#executeCommand",T),this.g(T,V,!0)}async g(T,V,_){if(this.b.has(T))return Le(this,d,"f").$fireCommandActivationEvent(T),this.h(T,V,!1);{let K=!1;const A=(0,M.cloneAndChange)(V,function(U){if(U instanceof C.Position)return D.Position.from(U);if(U instanceof C.Range)return D.Range.from(U);if(U instanceof C.Location)return D.location.from(U);if(C.NotebookRange.isNotebookRange(U))return D.NotebookRange.from(U);if(U instanceof ArrayBuffer)return K=!0,l.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return K=!0,l.VSBuffer.wrap(U);if(U instanceof l.VSBuffer)return K=!0,U;if(!Array.isArray(U))return U});try{const U=await Le(this,d,"f").$executeCommand(T,K?new g.SerializableObjectWithBuffers(A):A,_);return(0,k.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(T,V,!1);throw U}}}async h(T,V,_){const K=this.b.get(T);if(!K)throw new Error("Unknown command");const{callback:A,thisArg:U,description:R}=K;if(R)for(let H=0;H<R.args.length;H++)try{(0,i.validateConstraint)(V[H],R.args[H].constraint)}catch{throw new Error(`Running the contributed command: '${T}' failed. Illegal argument '${R.args[H].name}' - ${R.args[H].description}`)}const F=L.StopWatch.create();try{return await A.apply(U,V)}catch(H){if(T===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...V);j&&(T=j.command)}if(this.d.error(H,T,K.extension?.identifier),!_)throw H;if(K.extension?.identifier){const j=Le(this,u,"f").onExtensionError(K.extension.identifier,H);this.d.trace("forwarded error to extension?",j,K.extension?.identifier)}throw new class extends Error{constructor(){super((0,E.toErrorMessage)(H)),this.id=T,this.source=K.extension?.displayName??K.extension?.name}}}finally{this.j(K,T,F.elapsed())}}j(T,V,_){!T.extension||Le(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:T.extension.identifier.value,id:new v.TelemetryTrustedValue(V),duration:_})}$executeContributedCommand(T,...V){this.d.trace("ExtHostCommands#$executeContributedCommand",T);const _=this.b.get(T);return _?(V=V.map(K=>this.f.reduce((A,U)=>U.processArgument(A,_.extension?.identifier),K)),this.h(T,V,!0)):Promise.reject(new Error(`Contributed command '${T}' does not exist.`))}getCommands(T=!1){return this.d.trace("ExtHostCommands#getCommands",T),Le(this,d,"f").$getCommands().then(V=>(T&&(V=V.filter(_=>_[0]!=="_")),V))}$getContributedCommandHandlerDescriptions(){const T=Object.create(null);for(const[V,_]of this.b){const{description:K}=_;K&&(T[V]=K)}return Promise.resolve(T)}};d=new WeakMap,r=new WeakMap,u=new WeakMap,n=Ke([je(0,a.IExtHostRpcService),je(1,S.ILogService),je(2,t.IExtHostTelemetry)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class p{constructor(T,V,_){this.d=T,this.f=V,this.g=_,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(T,V){if(!T)return;const _={$ident:void 0,id:T.command,title:T.title,tooltip:T.tooltip};if(!T.command)return _;const K=this.f(T.command);if(K)_.id=K.internalId,_.arguments=K.args.map((A,U)=>A.convert(T.arguments&&T.arguments[U]));else if((0,O.isNonEmptyArray)(T.arguments)){const A=`${T.command}/${++this.c}`;this.b.set(A,T),V.add((0,b.toDisposable)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),_.$ident=A,_.id=this.delegatingCommandId,_.arguments=[A],this.g.trace("CommandsConverter#CREATE",T.command,A)}return _}fromInternal(T){return typeof T.$ident=="string"?this.b.get(T.$ident):{command:T.id,title:T.title,arguments:T.arguments}}getActualCommand(...T){return this.b.get(T[0])}h(...T){const V=this.getActualCommand(...T);return this.g.trace("CommandsConverter#EXECUTE",T[0],V?V.command:"MISSING"),V?this.d.executeCommand(V.command,...V.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${T[0]}`)}}e.CommandsConverter=p;class o{constructor(T,V,_,K){this.name=T,this.description=V,this.validate=_,this.convert=K}optional(){return new o(this.name,`(optional) ${this.description}`,T=>T==null||this.validate(T),T=>T===void 0?void 0:T===null?null:this.convert(T))}with(T,V){return new o(T??this.name,V??this.description,this.validate,this.convert)}}o.Uri=new o("uri","Uri of a text document",P=>h.URI.isUri(P),P=>P),o.Position=new o("position","A position in a text document",P=>C.Position.isPosition(P),D.Position.from),o.Range=new o("range","A range in a text document",P=>C.Range.isRange(P),D.Range.from),o.Selection=new o("selection","A selection in a text document",P=>C.Selection.isSelection(P),D.Selection.from),o.Number=new o("number","",P=>typeof P=="number",P=>P),o.String=new o("string","",P=>typeof P=="string",P=>P),o.CallHierarchyItem=new o("item","A call hierarchy item",P=>P instanceof C.CallHierarchyItem,D.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",P=>P instanceof C.TypeHierarchyItem,D.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",P=>P instanceof s.TestItemImpl,D.TestItem.from),e.ApiCommandArgument=o;class c{constructor(T,V){this.description=T,this.convert=V}}c.Void=new c("no result",P=>P),e.ApiCommandResult=c;class m{constructor(T,V,_,K,A){this.id=T,this.internalId=V,this.description=_,this.args=K,this.result=A}}e.ApiCommand=m}),define(ke[207],Te([1,0,2,8,7,75,37,16,88,92,15]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(C.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,s)=>{if((0,O.isFalsyOrEmpty)(a))return;class l extends D.SymbolInformation{static to(E){const L=new l(E.name,C.SymbolKind.to(E.kind),E.containerName||"",new D.Location(s[0],C.Range.to(E.range)));return L.detail=E.detail,L.range=L.location.range,L.selectionRange=C.Range.to(E.selectionRange),L.children=E.children?E.children.map(l.to):[],L}}return a.map(l.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(C.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(C.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(s=>D.Position.isPosition(s)),a=>a.map(C.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(s=>{let l;for(const g of s.reverse())l=new D.SelectionRange(C.Range.to(g),l);return l}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(C.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(C.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(C.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(C.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:C.Range.to(a.range),placeholder:a.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return C.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(C.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,S.decodeSemanticTokensDto)(a);if(s.type==="full")return new D.SemanticTokens(s.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,S.decodeSemanticTokensDto)(a);if(s.type==="full")return new D.SemanticTokens(s.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,s,l)=>{if(!a)return new D.CompletionList([]);const g=a.suggestions.map(E=>C.CompletionItem.to(E,l));return new D.CompletionList(g,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return C.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,s,l)=>b(g=>new D.CodeLens(C.Range.to(g.range),g.command&&l.fromInternal(g.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>D.Range.isRange(a),a=>D.Selection.isSelection(a)?C.Selection.from(a):C.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,s,l)=>b(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(g.command)}else{const E=new D.CodeAction(g.title,g.kind?new D.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=C.WorkspaceEdit.to(g.edit)),g.command&&(E.command=l.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(s=>new D.ColorInformation(C.Range.to(s.range),C.Color.to(s.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof D.Color,C.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:C.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(C.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,s,l)=>a.map(C.InlayHint.to.bind(void 0,l)))),new y.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(a,s)=>{if(a)return a.map(C.FoldingRange.to)})),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(s=>C.NotebookExclusiveDocumentPattern.to(s))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(C.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>i.URI.isUri(a)||typeof a=="string"&&(0,k.matchesSomeScheme)(a,N.Schemas.http,N.Schemas.https),a=>a),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void),new y.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[y.ApiCommandArgument.String.with("name","The context key name"),new y.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],y.ApiCommandResult.Void)];class h{static register(s){w.forEach(s.registerApiCommand,s)}}e.ExtHostApiCommands=h;function b(a){return s=>{if(Array.isArray(s))return s.map(a)}}function f(a){if(!Array.isArray(a))return;const s=[];for(const l of a)M.isLocationLink(l)?s.push(C.DefinitionLink.to(l)):s.push(C.location.to(l));return s}}),define(ke[208],Te([1,0,17,64,4,6,2,75,25,8,7,5]),function(te,e,i,C,D,M,y,O,S,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function h(b,f,a){const s=b.getProxy(w.MainContext.MainThreadComments);class l{constructor(){this.b=new Map,this.c=new Map,f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const p=this.b.get(n.handle);return p?p.value:n}else if(n&&n.$mid===7){const p=this.b.get(n.commentControlHandle);if(!p)return n;const o=p.getCommentThread(n.commentThreadHandle);return o?o.value:n}else if(n&&(n.$mid===9||n.$mid===8)){const p=this.b.get(n.thread.commentControlHandle);if(!p)return n;const o=p.getCommentThread(n.thread.commentThreadHandle);return o?n.$mid===8?o.value:{thread:o.value,text:n.text}:n}else if(n&&n.$mid===10){const p=this.b.get(n.thread.commentControlHandle);if(!p)return n;const o=p.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;const c=n.commentUniqueId,m=o.getCommentByUniqueId(c);return m||n}else if(n&&n.$mid===11){const p=this.b.get(n.thread.commentControlHandle);if(!p)return n;const o=p.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;const c=n.text,m=n.commentUniqueId,P=o.getCommentByUniqueId(m);return P?(typeof P.body=="string"?P.body=c:P.body=new N.MarkdownString(c),P):n}return n}})}createCommentController(n,p,o){const c=l.a++,m=new E(n,c,p,o);this.b.set(m.handle,m);const P=this.c.get(S.ExtensionIdentifier.toKey(n.identifier))||[];return P.push(m),this.c.set(S.ExtensionIdentifier.toKey(n.identifier),P),m.value}$createCommentThreadTemplate(n,p,o){const c=this.b.get(n);!c||c.$createCommentThreadTemplate(p,o)}async $updateCommentThreadTemplate(n,p,o){const c=this.b.get(n);!c||c.$updateCommentThreadTemplate(p,o)}$deleteCommentThread(n,p){this.b.get(n)?.$deleteCommentThread(p)}$provideCommentingRanges(n,p,o){const c=this.b.get(n);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const m=a.getDocument(y.URI.revive(p));return(0,i.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(m,o)).then(P=>P?P.map(T=>k.Range.from(T)):void 0)}$toggleReaction(n,p,o,c,m){const P=this.b.get(n);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const T=P.getCommentThread(p);if(T){const V=T.getCommentByUniqueId(c.uniqueIdInThread);if(P!==void 0&&V&&P.reactionHandler)return P.reactionHandler(V,t(m))}return Promise.resolve(void 0)})}dispose(){}}l.a=0;class g{set threadId(n){this.n=n}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(n){n.isEqual(this.p)||(this.p=n,this.b.range=n,this.c.fire())}get range(){return this.p}set canReply(n){this.d!==n&&(this.d=n,this.b.canReply=n,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(n){this.e=n,this.b.label=n,this.c.fire()}get contextValue(){return this.f}set contextValue(n){this.f=n,this.b.contextValue=n,this.c.fire()}get comments(){return this.q}set comments(n){this.q=n,this.b.comments=n,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(n){this.g=n,this.b.collapsibleState=n,this.c.fire()}get state(){return this.h}set state(n){this.h=n,this.b.state=n,this.c.fire()}get isDisposed(){return this.j}constructor(n,p,o,c,m,P,T,V){this.m=p,this.n=o,this.o=c,this.p=m,this.q=P,this.extensionDescription=T,this.r=V,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${n}.${this.handle}`),s.$createCommentThread(p,this.handle,this.n,this.o,k.Range.from(this.p),T.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{s.$deleteCommentThread(p,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(K){_.range=K},get comments(){return _.comments},set comments(K){_.comments=K},get collapsibleState(){return _.collapsibleState},set collapsibleState(K){_.collapsibleState=K},get canReply(){return _.canReply},set canReply(K){_.canReply=K},get contextValue(){return _.contextValue},set contextValue(K){_.contextValue=K},get label(){return _.label},set label(K){_.label=K},get state(){return _.state},set state(K){_.state=K},dispose:()=>{_.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const n=o=>Object.prototype.hasOwnProperty.call(this.b,o),p={};n("range")&&(p.range=k.Range.from(this.p)),n("label")&&(p.label=this.label),n("contextValue")&&(p.contextValue=this.contextValue??null),n("comments")&&(p.comments=this.q.map(o=>L(this,o,this.k))),n("collapsibleState")&&(p.collapseState=d(this.g)),n("canReply")&&(p.canReply=this.canReply),n("state")&&(p.state=r(this.h)),n("isTemplate")&&(p.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(n){for(const p of this.k){const o=p[0],c=p[1];if(n===c)return o}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(n=>n.dispose())}}g.a=0,Ke([(0,C.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(n){this.b=n,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(n){this.c=n,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this.d}set options(n){this.d=n,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(n,p,o,c){this.f=n,this.g=p,this.h=o,this.i=c,this.a=new Map,s.$registerCommentController(this.handle,o,c);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(P){m.options=P},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(P){m.commentingRangeProvider=P},get reactionHandler(){return m.reactionHandler},set reactionHandler(P){m.reactionHandler=P},createCommentThread(P,T,V){return m.createCommentThread(P,T,V).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(n,p,o,c){if(typeof n=="string"){const m=new g(this.id,this.handle,n,p,o,c,this.f,!1);return this.a.set(m.handle,m),m}else{const m=new g(this.id,this.handle,void 0,n,p,o,this.f,!1);return this.a.set(m.handle,m),m}}$createCommentThreadTemplate(n,p){const o=new g(this.id,this.handle,void 0,y.URI.revive(n),k.Range.to(p),[],this.f,!0);return o.collapsibleState=O.CommentThreadCollapsibleState.Expanded,this.a.set(o.handle,o),o}$updateCommentThreadTemplate(n,p){const o=this.a.get(n);o&&(o.range=k.Range.to(p))}$deleteCommentThread(n){this.a.get(n)?.dispose(),this.a.delete(n)}getCommentThread(n){return this.a.get(n)}dispose(){this.a.forEach(n=>{n.dispose()}),this.e.forEach(n=>n.dispose())}}function L(u,n,p){let o=p.get(n);o||(o=++u.commentHandle,p.set(n,o));const c=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:o,body:typeof n.body=="string"?n.body:k.MarkdownString.from(n.body),userName:n.author.name,userIconPath:c,label:n.label,commentReactions:n.reactions?n.reactions.map(m=>v(m)):void 0,timestamp:n.timestamp?.toJSON()}}function v(u){return{label:u.label,iconPath:u.iconPath?k.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function t(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?y.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function d(u){if(u!==void 0)switch(u){case N.CommentThreadCollapsibleState.Expanded:return O.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return O.CommentThreadCollapsibleState.Collapsed}return O.CommentThreadCollapsibleState.Collapsed}function r(u){if(u!==void 0)switch(u){case N.CommentThreadState.Unresolved:return O.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return O.CommentThreadState.Resolved}return O.CommentThreadState.Unresolved}return new l}e.createExtHostComments=h}),define(ke[209],Te([1,0,22,5,27,18]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(N,w){this.a=N.getProxy(C.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,w){const h=this,b=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){h.e(N,w,b,arguments)}})}e(N,w,h,b){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:S(b,this.b)}),this.c&&this.f(N,h,b)}};y=Ke([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const O=1e5;function S(k,N){const w=[];if(k.length)for(let h=0;h<k.length;h++){let b=k[h];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}w.push(b)}if(N){const h=new Error().stack;h&&w.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,i.safeStringify)(w);return h.length>O?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(ke[103],Te([1,0,2,5,7,3,18,11,16,10,19,26]),function(te,e,i,C,D,M,y,O,S,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let h=class Mi{constructor(f,a){this.h=a,this.f=new Map,this.g=f.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,a){const s=Mi.c++;this.f.set(s,{provider:f,extensionDescription:a}),this.g.$registerDecorationProvider(s,a.identifier.value);const l=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(s,null);return}const E=(0,S.asArray)(g);if(E.length<=Mi.d){this.g.$onDidChange(s,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,E.length);const L=E.map(d=>({uri:d,rank:(0,k.count)(d.path,"/")})),v=(0,S.groupBy)(L,(d,r)=>d.rank-r.rank||(0,k.compare)(d.uri.path,r.uri.path)),t=[];e:for(const d of v){let r;for(const u of d){const n=(0,N.dirname)(u.uri.path);if(r!==n&&(r=n,t.push(u.uri)>=Mi.d))break e}}this.g.$onDidChange(s,t)});return new D.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(f,a,s){if(!this.f.has(f))return Object.create(null);const l=Object.create(null),{provider:g,extensionDescription:E}=this.f.get(f);return await Promise.all(a.map(async L=>{try{const{uri:v,id:t}=L,d=await Promise.resolve(g.provideFileDecoration(i.URI.revive(v),s));if(!d)return;try{D.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,w.checkProposedApiEnabled)(E,"codiconDecoration"),l[t]=[d.propagate,d.tooltip,d.badge,d.color]}catch(r){this.h.warn(`INVALID decoration from extension '${E}': ${r}`)}}catch(v){this.h.error(v)}})),l}};h.c=0,h.d=250,h=Ke([je(0,y.IExtHostRpcService),je(1,O.ILogService)],h),e.ExtHostDecorations=h,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[210],Te([1,0,139,91,2,5,7,8,4,11,28,36]),function(te,e,i,C,D,M,y,O,S,k,N,w){"use strict";var h,b,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(g,E,L,v,t,d,r){this.d=g,this.e=E,this.f=L,this.g=v,h.set(this,void 0),b.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new N.ResourceMap(u=>t.getComparisonKey(u)),"f"),Je(this,h,d,"f"),Je(this,b,r,"f")}dispose(){this.c||(Le(this,b,"f").fire([...Le(this,f,"f").keys()]),Le(this,h,"f")?.$clear(this.e),Le(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,E){if(!g){this.clear();return}this.h();let L=[];if(D.URI.isUri(g)){if(!E){this.delete(g);return}Le(this,f,"f").set(g,E.slice()),L=[g]}else if(Array.isArray(g)){L=[];let t;g=[...g].sort(a.j);for(const d of g){const[r,u]=d;if((!t||r.toString()!==t.toString())&&(t&&Le(this,f,"f").get(t).length===0&&Le(this,f,"f").delete(t),t=r,L.push(r),Le(this,f,"f").set(r,[])),u)Le(this,f,"f").get(r)?.push(...u);else{const n=Le(this,f,"f").get(r);n&&(n.length=0)}}}if(Le(this,b,"f").fire(L),!Le(this,h,"f"))return;const v=[];for(const t of L){let d=[];const r=Le(this,f,"f").get(t);if(r)if(r.length>this.f){d=[];const u=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const p of r)if(p.severity===u[n]&&d.push({...O.Diagnostic.from(p),modelVersionId:this.g(t)})===this.f)break e;d.push({severity:C.MarkerSeverity.Info,message:(0,i.localize)(0,null,r.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=r.map(u=>({...O.Diagnostic.from(u),modelVersionId:this.g(t)}));v.push([t,d])}Le(this,h,"f").$changeMany(this.e,v)}delete(g){this.h(),Le(this,b,"f").fire([g]),Le(this,f,"f").delete(g),Le(this,h,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Le(this,b,"f").fire([...Le(this,f,"f").keys()]),Le(this,f,"f").clear(),Le(this,h,"f")?.$clear(this.e)}forEach(g,E){this.h();for(const[L,v]of this)g.call(E,L,v,this)}*[(h=new WeakMap,b=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const g of Le(this,f,"f").keys())yield[g,this.get(g)]}get(g){this.h();const E=Le(this,f,"f").get(g);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(g){return this.h(),Array.isArray(Le(this,f,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,E){return g[0].toString()<E[0].toString()?-1:g[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=a;let s=class pi{static _mapper(g){const E=new N.ResourceMap;for(const L of g)E.set(L,L);return{uris:Object.freeze(Array.from(E.values()))}}constructor(g,E,L,v){this.h=E,this.j=L,this.k=v,this.f=new Map,this.g=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,E){const{f:L,e:v,g:t,h:d,j:r,k:u}=this,n=new class{$changeMany(c,m){v.$changeMany(c,m),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,c,m.length===0?"CLEARING":m)}$clear(c){v.$clear(c),d.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,c)}dispose(){v.dispose()}};let p;if(!E)E="_generated_diagnostic_collection_name_#"+pi.c++,p=E;else if(!L.has(E))p=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do p=E+pi.c++;while(L.has(p))}return new class extends a{constructor(){super(E,p,pi.d,c=>u.getDocument(c)?.version,r.extUri,n,t),L.set(p,this)}dispose(){super.dispose(),L.delete(p)}}}getDiagnostics(g){if(g)return this.l(g);{const E=new Map,L=[];for(const v of this.f.values())v.forEach((t,d)=>{let r=E.get(t.toString());typeof r>"u"&&(r=L.length,E.set(t.toString(),r),L.push([t,[]])),L[r][1]=L[r][1].concat(...d)});return L}}l(g){let E=[];for(const L of this.f.values())L.has(g)&&(E=E.concat(L.get(g)));return E}$acceptMarkersChange(g){if(!this.m){const E="_generated_mirror",L=new a(E,E,pi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(E,L),this.m=L}for(const[E,L]of g)this.m.set(D.URI.revive(E),L.map(O.Diagnostic.to))}};s.c=0,s.d=1e3,s=Ke([je(1,k.ILogService),je(2,w.IExtHostFileSystemInfo)],s),e.ExtHostDiagnostics=s}),define(ke[211],Te([1,0,2,5,26]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(O){this.a=O.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(O,S){return S?.allowUIResources&&(0,D.checkProposedApiEnabled)(O,"showLocal"),this.a.$showOpenDialog(S).then(k=>k?k.map(N=>i.URI.revive(N)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(S=>S?i.URI.revive(S):void 0)}}e.ExtHostDialogs=M}),define(ke[212],Te([1,0,12,2,7,5,15,21,10]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(w,h,b){this.d=h,this.e=b,this.b=new Map,this.c=w.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,h){if(Object.keys(y.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const b=k.a++;this.b.set(b,h),this.c.$registerTextContentProvider(b,w);let f;return typeof h.onDidChange=="function"&&(f=h.onDidChange(a=>{if(a.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent(b,a).then(s=>{if(!s&&typeof s!="string")return;const l=this.d.getDocument(a);if(!l)return;const g=(0,S.splitLines)(s);if(!l.equalLines(g))return this.c.$onVirtualDocumentChange(a,s)},i.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(w,h){const b=this.b.get(w);return b?Promise.resolve(b.provideTextDocumentContent(C.URI.revive(h),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}k.a=0,e.ExtHostDocumentContentProvider=k}),define(ke[213],Te([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(b,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.DisposableStore,this.h=new Map,this.f=b.getProxy(M.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(a=>{for(const s of a)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const s of a)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let a=this.h.get(b.toString());return a||(a=this.f.$tryOpenDocument(b).then(s=>{this.h.delete(b.toString());const l=D.URI.revive(s);return(0,S.assertIsDefined)(this.g.getDocument(l))},s=>(this.h.delete(b.toString()),Promise.reject(s))),this.h.set(b.toString(),a)),a}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>D.URI.revive(f))}$acceptModelLanguageChanged(b,f){const a=D.URI.revive(b),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(f),this.a.fire(s.document)}$acceptModelSaved(b){const f=D.URI.revive(b),a=this.g.getDocument(f);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(b,f){const a=D.URI.revive(b),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,a){const s=D.URI.revive(b),l=this.g.getDocument(s);if(!l)throw new Error("unknown document");l._acceptIsDirty(a),l.onEvents(f);let g;f.isUndoing?g=N.TextDocumentChangeReason.Undo:f.isRedoing&&(g=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:f.changes.map(E=>({range:O.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:g}))}setWordDefinitionFor(b,f){(0,y.setWordDefinitionFor)(b,f)}}e.ExtHostDocuments=w}),define(ke[58],Te([1,0,49,4,6,2,3,5,99,18,102,8,11,28,15,185,85]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(L){this.value=L,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(L,v){this.h=L,this.i=v,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new C.Emitter,this.e=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(L){this.acceptDocumentsAndEditorsDelta(L)}acceptDocumentsAndEditorsDelta(L){const v=[],t=[],d=[];if(L.removedDocuments)for(const r of L.removedDocuments){const u=M.URI.revive(r),n=this.c.get(u);n?.unref()&&(this.c.delete(u),v.push(n.value))}if(L.addedDocuments)for(const r of L.addedDocuments){const u=M.URI.revive(r.uri);let n=this.c.get(u);if(n&&u.scheme!==f.Schemas.vscodeNotebookCell&&u.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);n||(n=new l(new S.ExtHostDocumentData(this.h.getProxy(O.MainContext.MainThreadDocuments),u,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(u,n),t.push(n.value)),n.ref()}if(L.removedEditors)for(const r of L.removedEditors){const u=this.b.get(r);this.b.delete(r),u&&d.push(u)}if(L.addedEditors)for(const r of L.addedEditors){const u=M.URI.revive(r.documentUri);i.ok(this.c.has(u),`document '${u}' does not exist`),i.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const n=this.c.get(u).value,p=new N.ExtHostTextEditor(r.id,this.h.getProxy(O.MainContext.MainThreadTextEditors),this.i,new s.Lazy(()=>n.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(o=>w.Range.to(o)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,p)}L.newActiveEditor!==void 0&&(i.ok(L.newActiveEditor===null||this.b.has(L.newActiveEditor),`active editor '${L.newActiveEditor}' does not exist`),this.a=L.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(d),L.removedDocuments&&this.e.fire(v),L.addedDocuments&&this.d.fire(t),(L.removedEditors||L.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),L.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(L){return this.c.get(L)?.value}allDocuments(){return a.Iterable.map(this.c.values(),L=>L.value)}getEditor(L){return this.b.get(L)}activeEditor(L){if(!this.a)return;const v=this.b.get(this.a);return L?v:v?.value}allEditors(){return[...this.b.values()]}};g=Ke([je(0,k.IExtHostRpcService),je(1,h.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ke[59],Te([1,0,8,5,2,4,3,7,18,9,63]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class w{constructor(s,l,g){this.e=g,this.d=l,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,l={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new O.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new O.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new O.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.WebviewEditorTabInput(this.b.input.viewType);case 4:return new O.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.TerminalEditorTabInput;case 9:return new O.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class h{constructor(s,l){this.c=[],this.d="",this.b=s,this.e=l;for(const g of s.tabs)g.isActive&&(this.d=g.id),this.c.push(new w(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,l={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return i.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(g=>g.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(g=>g.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const g=new w(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,g),s.tabDto.isActive&&(this.d=g.tabId),g}else if(s.kind===1){const g=this.c.splice(s.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(s.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,g),g}const l=this.c.find(g=>g.tabId===s.tabDto.id);if(!l)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(s.tabDto),l}activeTabId(){return this.d}}let b=class{constructor(s){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=s.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,l={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(g=>g.apiObject))},get activeTabGroup(){const g=s.d;return(0,k.assertIsDefined)(s.e.find(L=>L.groupId===g)?.apiObject)},close:async(g,E)=>{const L=Array.isArray(g)?g:[g];return L.length?f(L[0])?this.j(L,E):this.i(L,E):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(s){const l=new Set(this.e.map(r=>r.groupId)),g=new Set(s.map(r=>r.groupId)),E=(0,N.diffSets)(l,g),L=this.e.filter(r=>E.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],t=[];this.e=s.map(r=>{const u=new h(r,()=>this.d);return E.added.includes(u.groupId)?v.push(u.apiObject):t.push(u.apiObject),u});const d=(0,k.assertIsDefined)(s.find(r=>r.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:v,closed:L,changed:t}))}$acceptTabGroupUpdate(s){const l=this.e.find(g=>g.groupId===s.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const l=this.e.find(E=>E.groupId===s.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const g=l.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(s){for(const l of this.e)for(const g of l.tabs)if(g.apiObject===s)return g}h(s){return this.e.find(l=>l.apiObject===s)}async i(s,l){const g=[];for(const E of s){const L=this.g(E);if(!L)throw new Error("Tab close: Invalid tab not found!");g.push(L.tabId)}return this.a.$closeTab(g,l)}async j(s,l){const g=[];for(const E of s){const L=this.h(E);if(!L)throw new Error("Group close: Invalid group not found!");g.push(L.groupId)}return this.a.$closeGroup(g,l)}};b=Ke([je(0,S.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function f(a){return a.tabs!==void 0}}),define(ke[214],Te([1,0,2,5,6,7,8,260,10,23,26]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const a=this.a.indexOf(f);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),a=[];let s,l,g=14,E=14;for(const L of f){let v=s?(0,S.commonPrefixLength)(s,L):0;for(v===0?l=1:l=E;v<L.length;v++)v+1===L.length?(g=E,E=9):E+=1,a.push([l,L.toUpperCase().charCodeAt(v),E]),a.push([l,L.toLowerCase().charCodeAt(v),E]),l=E;s=L,E=g}a.push([9,58,10]),a.push([10,47,12]),this.b=new O.StateMachine(a)}}provideDocumentLinks(f){this.c();const a=[],s=O.LinkComputer.computeLinks({getLineContent(l){return f.lineAt(l-1).text},getLineCount(){return f.lineCount}},this.b);for(const l of s){const g=y.DocumentLink.to(l);g.target&&a.push(g)}return a}}class h{constructor(f,a){this.i=a,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,a,s,l={}){if(this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const g=this.h++;this.b.add(a),this.d.add(a),this.c.set(g,s);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof s.copy=="function"&&(E+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,N.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(g,a,E).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${a}`),console.error(v)});const L=s.onDidChangeFile(v=>{const t=[];for(const d of v){const{uri:r,type:u}=d;if(r.scheme!==a)continue;let n;switch(u){case M.FileChangeType.Changed:n=0;break;case M.FileChangeType.Created:n=1;break;case M.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:n})}this.a.$onFileSystemChange(g,t)});return(0,D.toDisposable)(()=>{L.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(f){const{type:a,ctime:s,mtime:l,size:g,permissions:E}=f;return{type:a,ctime:s,mtime:l,size:g,permissions:E}}$stat(f,a){return Promise.resolve(this.k(f).stat(i.URI.revive(a))).then(s=>h.j(s))}$readdir(f,a){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(a)))}$readFile(f,a){return Promise.resolve(this.k(f).readFile(i.URI.revive(a))).then(s=>k.VSBuffer.wrap(s))}$writeFile(f,a,s,l){return Promise.resolve(this.k(f).writeFile(i.URI.revive(a),s.buffer,l))}$delete(f,a,s){return Promise.resolve(this.k(f).delete(i.URI.revive(a),s))}$rename(f,a,s,l){return Promise.resolve(this.k(f).rename(i.URI.revive(a),i.URI.revive(s),l))}$copy(f,a,s,l){const g=this.k(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(i.URI.revive(a),i.URI.revive(s),l))}$mkdir(f,a){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(a)))}$watch(f,a,s,l){const g=this.k(f).watch(i.URI.revive(s),l);this.f.set(a,g)}$unwatch(f,a){const s=this.f.get(a);s&&(s.dispose(),this.f.delete(a))}$open(f,a,s){const l=this.k(f);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(i.URI.revive(a),s))}$close(f,a){const s=this.k(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(a))}$read(f,a,s,l){const g=this.k(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(l);return Promise.resolve(g.read(a,s,E.buffer,0,l)).then(L=>E.slice(0,L))}$write(f,a,s,l){const g=this.k(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(a,s,l.buffer,0,l.byteLength))}k(f){const a=this.c.get(f);if(!a){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return a}}e.ExtHostFileSystem=h}),define(ke[60],Te([1,0,5,43,7,23,3,18,36,6]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class _t{constructor(h,b){this.b=new Map,this.a=h.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(a){try{const s=f.b.get(a.scheme);if(!s)return await f.a.$stat(a);await f.a.$ensureActivation(a.scheme);const l=await s.stat(a);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(s){_t.c(s)}},async readDirectory(a){try{const s=f.b.get(a.scheme);return s?(await f.a.$ensureActivation(a.scheme),(await s.readDirectory(a)).slice()):await f.a.$readdir(a)}catch(s){return _t.c(s)}},async createDirectory(a){try{return await f.a.$mkdir(a)}catch(s){return _t.c(s)}},async readFile(a){try{const s=f.b.get(a.scheme);return s?(await f.a.$ensureActivation(a.scheme),(await s.readFile(a)).slice()):(await f.a.$readFile(a)).buffer}catch(s){return _t.c(s)}},async writeFile(a,s){try{return await f.a.$writeFile(a,M.VSBuffer.wrap(s))}catch(l){return _t.c(l)}},async delete(a,s){try{const l=f.b.get(a.scheme);return l?(await f.a.$ensureActivation(a.scheme),await l.delete(a,{recursive:!1,...s})):await f.a.$delete(a,{recursive:!1,useTrash:!1,...s})}catch(l){return _t.c(l)}},async rename(a,s,l){try{return await f.a.$rename(a,s,{overwrite:!1,...l})}catch(g){return _t.c(g)}},async copy(a,s,l){try{return await f.a.$copy(a,s,{overwrite:!1,...l})}catch(g){return _t.c(g)}},isWritableFileSystem(a){const s=b.getCapabilities(a);if(typeof s=="number")return!(s&2048)}})}static c(h){if(h instanceof D.FileSystemError)throw h;if(!(h instanceof Error))throw new D.FileSystemError(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(h.message);switch(h.name){case C.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(h.message);case C.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(h.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(h.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(h.message);case C.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(h.message);case C.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(h.message);default:throw new D.FileSystemError(h.message,h.name)}}addFileSystemProvider(h,b){return this.b.set(h,b),(0,k.toDisposable)(()=>this.b.delete(h))}};N=Ke([je(0,O.IExtHostRpcService),je(1,S.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ke[215],Te([1,0,4,35,2,5,8,7]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(w,h,b,f,a,s,l,g){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const E=this.h(w,b,a);this.g=0,s&&(this.g+=1),l&&(this.g+=2),g&&(this.g+=4);const L=(0,C.parse)(a),v=typeof a=="string",t=f(d=>{if(!s)for(const r of d.created){const u=D.URI.revive(r);L(u.fsPath)&&(!v||h.getWorkspaceFolder(u))&&this.a.fire(u)}if(!l)for(const r of d.changed){const u=D.URI.revive(r);L(u.fsPath)&&(!v||h.getWorkspaceFolder(u))&&this.b.fire(u)}if(!g)for(const r of d.deleted){const u=D.URI.revive(r);L(u.fsPath)&&(!v||h.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=O.Disposable.from(E,this.a,this.b,this.c,t)}h(w,h,b){const f=O.Disposable.from();if(typeof b=="string")return f;const a=w.getProxy(M.MainContext.MainThreadFileSystem);let s=!1;(b.pattern.includes(C.GLOBSTAR)||b.pattern.includes(C.GLOB_SPLIT))&&(s=!0);const l=Math.random();return a.$watch(h.identifier.value,l,b.baseUri,{recursive:s,excludes:[]}),O.Disposable.from({dispose:()=>a.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(w,h,b){this.j=w,this.k=h,this.l=b,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,h,b,f,a,s){return new S(this.j,w,h,this.a.event,y.GlobPattern.from(b),f,a,s)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,h){switch(w){case 2:this.b.fire(Object.freeze({files:h.map(b=>({oldUri:D.URI.revive(b.source),newUri:D.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:h.map(b=>D.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:h.map(b=>D.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,h){return(b,f,a)=>{const s=function(g){b.call(f,g)};return s.extension=w,h.event(s,void 0,a)}}async $onWillRunFileOperation(w,h,b,f){switch(w){case 2:return await this.n(this.g,{files:h.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))},b,f);case 1:return await this.n(this.i,{files:h.map(a=>D.URI.revive(a.target))},b,f);case 0:case 3:return await this.n(this.h,{files:h.map(a=>D.URI.revive(a.target))},b,f)}}async n(w,h,b,f){const a=new Set,s=[];if(await w.fireAsync(h,f,async(g,E)=>{const L=Date.now(),v=await Promise.resolve(g);v instanceof O.WorkspaceEdit&&(s.push([E.extension,v]),a.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-L>b&&this.k.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||s.length===0)return;const l={edits:[]};for(const[,g]of s){const{edits:E}=y.WorkspaceEdit.from(g,{getTextDocumentVersion:L=>this.l.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(E)}return{edit:l,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=k}),define(ke[216],Te([1,0,2,37]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(y,O,S,k,N){this.a=O,this.b=S,this.c=k;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new C.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new C.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new C.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new C.ApiCommandResult("Notebook and input URI",h=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const b=this.a.getEditorById(h.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:i.URI.revive(h.notebookUri),inputUri:i.URI.revive(h.inputUri),notebookEditor:b.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:i.URI.revive(h.notebookUri),inputUri:i.URI.revive(h.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(y,O,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:S,uri:y,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=D}),define(ke[217],Te([1,0,6,5]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(y){this.b=0,this.a=y.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,y),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.ExtHostLabelService=D}),define(ke[218],Te([1,0,2,22,8,7,75,5,10,44,16,9,261,21,6,88,83,54,77,12,17,26]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(W,$);if(!(0,N.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(D.DocumentSymbol.from):t.f(q)}static f(I){I=I.slice(0).sort((q,ee)=>{let fe=q.location.range.start.compareTo(ee.location.range.start);return fe===0&&(fe=ee.location.range.end.compareTo(q.location.range.end)),fe});const $=[],W=[];for(const q of I){const ee={name:q.name||"!!MISSING: name!!",kind:D.SymbolKind.from(q.kind),tags:q.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:D.Range.from(q.location.range),selectionRange:D.Range.from(q.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),$.push(ee);break}const fe=W[W.length-1];if(k.Range.containsRange(fe.range,ee.range)&&!k.Range.equalsRange(fe.range,ee.range)){fe.children?.push(ee),W.push(ee);break}W.pop()}}return $}}class d{constructor(I,$,W){this.g=I,this.h=$,this.j=W,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const W=this.g.getDocument(I),q=await this.j.provideCodeLenses(W,$);if(!q||$.isCancellationRequested)return;const ee=this.e.add(q),fe=new f.DisposableStore;this.f.set(ee,fe);const De={cacheId:ee,lenses:[]};for(let oe=0;oe<q.length;oe++)De.lenses.push({cacheId:[ee,oe],range:D.Range.from(q[oe].range),command:this.h.toInternal(q[oe].command,fe)});return De}async resolveCodeLens(I,$){const W=I.cacheId&&this.e.get(...I.cacheId);if(!W)return;let q;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?q=W:q=await this.j.resolveCodeLens(W,$),q||(q=W),$.isCancellationRequested)return;const ee=I.cacheId&&this.f.get(I.cacheId[0]);if(!!ee)return I.command=this.h.toInternal(q.command??d.d,ee),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}d.d={command:"missing",title:"!!MISSING: command!!"};function r(Z){return Array.isArray(Z)?Z.map(D.DefinitionLink.from):Z?[D.DefinitionLink.from(Z)]:[]}class u{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideDefinition(q,ee,W);return r(fe)}}class n{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideDeclaration(q,ee,W);return r(fe)}}class p{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideImplementation(q,ee,W);return r(fe)}}class o{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideTypeDefinition(q,ee,W);return r(fe)}}class c{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideHover(q,ee,W);if(!(!fe||(0,N.isFalsyOrEmpty)(fe.contents)))return fe.range||(fe.range=q.getWordRangeAtPosition(ee)),fe.range||(fe.range=new M.Range(ee,ee)),D.Hover.from(fe)}}class m{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideEvaluatableExpression(q,ee,W);if(fe)return D.EvaluatableExpression.from(fe)}}class P{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,W,q){const ee=this.d.getDocument(I),fe=await this.e.provideInlineValues(ee,D.Range.to($),D.InlineValueContext.to(W),q);if(Array.isArray(fe))return fe.map(De=>D.InlineValue.from(De))}}class T{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideDocumentHighlights(q,ee,W);if(Array.isArray(fe))return fe.map(D.DocumentHighlight.from)}}class V{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),fe=await this.e.provideLinkedEditingRanges(q,ee,W);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,N.coalesce)(fe.ranges.map(D.Range.from)),wordPattern:fe.wordPattern}}}class _{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,W,q){const ee=this.d.getDocument(I),fe=D.Position.to($),De=await this.e.provideReferences(ee,fe,W,q);if(Array.isArray(De))return De.map(D.location.from)}}class K{constructor(I,$,W,q,ee,fe,De){this.g=I,this.h=$,this.j=W,this.k=q,this.l=ee,this.m=fe,this.n=De,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,W,q){const ee=this.g.getDocument(I),fe=h.Selection.isISelection($)?D.Selection.to($):D.Range.to($),De=[];for(const tt of this.j.getDiagnostics(I))if(fe.intersection(tt.range)&&De.push(tt)>K.d)break;const oe={diagnostics:De,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},ve=await this.k.provideCodeActions(ee,fe,oe,q);if(!(0,N.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const be=this.e.add(ve),He=new f.DisposableStore;this.f.set(be,He);const qe=[];for(let tt=0;tt<ve.length;tt++){const Xe=ve[tt];!Xe||(K.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,He)})):(oe.only&&(Xe.kind?oe.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[be,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,He),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(D.Diagnostic.from),edit:Xe.edit&&D.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:be,actions:qe}}async resolveCodeAction(I,$){const[W,q]=I,ee=this.e.get(W,q);if(!ee||K.o(ee)||!this.k.resolveCodeAction)return;const fe=await this.k.resolveCodeAction(ee,$)??ee;return fe?.edit?D.WorkspaceEdit.from(fe.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}K.d=1e3;class A{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async prepareDocumentPaste(I,$,W,q){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(I),fe=$.map(oe=>D.Range.to(oe)),De=D.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(ee,fe,De,q),D.DataTransfer.toDataTransferDTO(De)}async providePasteEdits(I,$,W,q,ee){const fe=this.e.getDocument($),De=W.map(be=>D.Range.to(be)),oe=D.DataTransfer.toDataTransfer(q,async be=>(await this.d.$resolvePasteFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentPasteEdits(fe,De,oe,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class U{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,W){const q=this.d.getDocument(I),ee=await this.e.provideDocumentFormattingEdits(q,$,W);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class R{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,W,q){const ee=this.d.getDocument(I),fe=D.Range.to($),De=await this.e.provideDocumentRangeFormattingEdits(ee,fe,W,q);if(Array.isArray(De))return De.map(D.TextEdit.from)}}class F{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,W,q,ee){const fe=this.d.getDocument(I),De=D.Position.to($),oe=await this.e.provideOnTypeFormattingEdits(fe,De,W,q,ee);if(Array.isArray(oe))return oe.map(D.TextEdit.from)}}class H{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const W=await this.e.provideWorkspaceSymbols(I,$);if(!(0,N.isNonEmptyArray)(W))return{symbols:[]};const q=this.d.add(W),ee={cacheId:q,symbols:[]};for(let fe=0;fe<W.length;fe++){const De=W[fe];if(!De||!De.name){this.f.warn("INVALID SymbolInformation",De);continue}ee.symbols.push({...D.WorkspaceSymbol.from(De),cacheId:[q,fe]})}return ee}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this.d.get(...I.cacheId);if(W){const q=await this.e.resolveWorkspaceSymbol(W,$);return q&&(0,C.mixin)(I,D.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideRenameEdits(I,$,W,q){const ee=this.d.getDocument(I),fe=D.Position.to($);try{const De=await this.e.provideRenameEdits(ee,fe,W,q);return De?D.WorkspaceEdit.from(De):void 0}catch(De){const oe=j.g(De);return oe?{rejectReason:oe,edits:void 0}:Promise.reject(De)}}async resolveRenameLocation(I,$,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),ee=D.Position.to($);try{const fe=await this.e.prepareRename(q,ee,W);let De,oe;if(M.Range.isRange(fe)?(De=fe,oe=q.getText(fe)):(0,w.isObject)(fe)&&(De=fe.range,oe=fe.placeholder),!De||!oe)return;if(De.start.line>ee.line||De.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(De),text:oe}}catch(fe){const De=j.g(fe);return De?{rejectReason:De,range:void 0,text:void 0}:Promise.reject(fe)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class le{constructor(I,$){this.resultId=I,this.tokens=$}}class ge{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,W){const q=this.f.getDocument(I),ee=$!==0?this.d.get($):null;let fe=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,ee.resultId,W):await this.g.provideDocumentSemanticTokens(q,W);return ee&&this.d.delete($),fe?(fe=ge.h(fe),this.o(ge.n(ee,fe),fe)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return ge.j(I)?ge.k(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):ge.l(I)?ge.m(I)?I:new M.SemanticTokensEdits(I.edits.map($=>new M.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!ge.j($)||!I||!I.tokens)return $;const W=I.tokens,q=W.length,ee=$.data,fe=ee.length;let De=0;const oe=Math.min(q,fe);for(;De<oe&&W[De]===ee[De];)De++;if(De===q&&De===fe)return new M.SemanticTokensEdits([],$.resultId);let ve=0;const be=oe-De;for(;ve<be&&W[q-ve-1]===ee[fe-ve-1];)ve++;return new M.SemanticTokensEdits([{start:De,deleteCount:q-De-ve,data:ee.subarray(De,fe-ve)}],$.resultId)}o(I,$){if(ge.j(I)){const W=this.e++;return this.d.set(W,new le(I.resultId,I.data)),(0,a.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(ge.l(I)){const W=this.e++;return ge.j($)?this.d.set(W,new le($.resultId,$.data)):this.d.set(W,new le(I.resultId)),(0,a.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class re{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,W){const q=this.d.getDocument(I),ee=await this.e.provideDocumentRangeSemanticTokens(q,D.Range.to($),W);return ee?this.f(ee):null}f(I){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ae{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,W,q,ee){this.f=I,this.g=$,this.h=W,this.j=q,this.k=ee,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,W,q){const ee=this.f.getDocument(I),fe=D.Position.to($),De=ee.getWordRangeAtPosition(fe)||new M.Range(fe,fe),oe=De.with({end:fe}),ve=new g.StopWatch(!0),be=await this.h.provideCompletionItems(ee,fe,q,D.CompletionContext.to(W));if(!be||q.isCancellationRequested)return;const He=Array.isArray(be)?new M.CompletionList(be):be,qe=ae.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(qe,tt);const Xe=[],et={x:qe,b:Xe,a:{replace:D.Range.from(De),insert:D.Range.from(oe)},c:He.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<He.items.length;it++){const dt=He.items[it],Fe=this.l(dt,[qe,it],oe,De);Xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveCompletionItem(W,$);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,W,q){const ee=this.e.get($[0]);if(!ee)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(I.command,ee),De={x:$,a:I.label,b:I.kind!==void 0?D.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(D.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:D.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(D.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),De.h=I.textEdit.newText):typeof I.insertText=="string"?De.h=I.insertText:I.insertText instanceof M.SnippetString&&(De.h=I.insertText.value,De.i|=4);let oe;return I.textEdit?oe=I.textEdit.range:I.range&&(oe=I.range),M.Range.isRange(oe)?De.j=D.Range.from(oe):oe&&(!W?.isEqual(oe.inserting)||!q?.isEqual(oe.replacing))&&(De.j={insert:D.Range.from(oe.inserting),replace:D.Range.from(oe.replacing)}),De}}class ce{async provideInlineCompletions(I,$,W,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}handlePartialAccept(I,$,W){}}class Se extends ce{constructor(I,$,W,q){super(),this.f=I,this.g=$,this.h=W,this.j=q,this.d=new x,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(I,$,W,q){const ee=this.g.getDocument(I),fe=D.Position.to($),De=await this.h.provideInlineCompletionItems(ee,fe,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},q);if(!De||q.isCancellationRequested)return;const oe=Array.isArray(De)?De:De.items,ve=this.e?Array.isArray(De)?[]:De.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:oe}),items:oe.map((qe,tt)=>{let Xe;qe.command&&(be||(be=new f.DisposableStore),Xe=this.j.toInternal(qe.command,be));const et=qe.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:qe.filterText,range:qe.range?D.Range.from(qe.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?qe.completeBracketPairs:!1}}),commands:ve.map(qe=>(be||(be=new f.DisposableStore),this.j.toInternal(qe,be)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const W=this.d.get(I)?.items[$];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}handlePartialAccept(I,$,W){const q=this.d.get(I)?.items[$];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,W)}}class x{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class X{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,$,W,q){const ee=this.e.getDocument(I),fe=D.Position.to($),De=this.g(W),oe=await this.f.provideSignatureHelp(ee,fe,q,De);if(oe){const ve=this.d.add([oe]);return{...D.SignatureHelp.from(oe),id:ve}}}g(I){let $;if(I.activeSignatureHelp){const W=D.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?($=q,$.activeSignature=W.activeSignature,$.activeParameter=W.activeParameter):$=W}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class J{constructor(I,$,W,q,ee){this.f=I,this.g=$,this.h=W,this.j=q,this.k=ee,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,W){const q=this.f.getDocument(I),ee=D.Range.to($),fe=await this.h.provideInlayHints(q,ee,W);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(W.isCancellationRequested)return;const De=this.d.add(fe);this.e.set(De,new f.DisposableStore);const oe={hints:[],cacheId:De};for(let ve=0;ve<fe.length;ve++)this.l(fe[ve],ee)&&oe.hints.push(this.m(fe[ve],[De,ve]));return this.j.trace(`[InlayHints] ${oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),oe}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveInlayHint(W,$);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const W=this.e.get($[0]);if(!W)throw Error("DisposableStore is missing...");const q={label:"",cacheId:$,tooltip:D.MarkdownString.fromStrict(I.tooltip),position:D.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(D.TextEdit.from),kind:I.kind&&D.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(ee=>{const fe={label:ee.value};return fe.tooltip=D.MarkdownString.fromStrict(ee.tooltip),M.Location.isLocation(ee.location)&&(fe.location=D.location.from(ee.location)),ee.command&&(fe.command=this.g.toInternal(ee.command,W)),fe}),q}}class de{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("DocumentLink")}async provideLinks(I,$){const W=this.e.getDocument(I),q=await this.f.provideDocumentLinks(W,$);if(!(!Array.isArray(q)||q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(de.g).map(D.DocumentLink.from)};{const ee=this.d.add(q),fe={links:[],cacheId:ee};for(let De=0;De<q.length;De++){if(!de.g(q[De]))continue;const oe=D.DocumentLink.from(q[De]);oe.cacheId=[ee,De],fe.links.push(oe)}return fe}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.f.resolveDocumentLink(W,$);if(!(!q||!de.g(q)))return D.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class ye{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentColors(W,$);return Array.isArray(q)?q.map(fe=>({color:D.Color.from(fe.color),range:D.Range.from(fe.range)})):[]}async provideColorPresentations(I,$,W){const q=this.d.getDocument(I),ee=D.Range.to($.range),fe=D.Color.to($.color),De=await this.e.provideColorPresentations(fe,{document:q,range:ee},W);if(!!Array.isArray(De))return De.map(D.ColorPresentation.from)}}class Ne{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,W){const q=this.d.getDocument(I),ee=await this.e.provideFoldingRanges(q,$,W);if(!!Array.isArray(ee))return ee.map(D.FoldingRange.from)}}class We{constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideSelectionRanges(I,$,W){const q=this.d.getDocument(I),ee=$.map(D.Position.to),fe=await this.e.provideSelectionRanges(q,ee,W);if(!(0,N.isNonEmptyArray)(fe))return[];if(fe.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const De=[];for(let oe=0;oe<ee.length;oe++){const ve=[];De.push(ve);let be=ee[oe],He=fe[oe];for(;;){if(!He.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(D.SelectionRange.from(He)),!He.parent)break;be=He.range,He=He.parent}}return De}}class Pe{constructor(I,$){this.f=I,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),ee=D.Position.to($),fe=await this.g.prepareCallHierarchy(q,ee,W);if(!fe)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(fe)?fe.map(oe=>this.h(De,oe)):[this.h(De,fe)]}async provideCallsTo(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(q,W);if(!!ee)return ee.map(fe=>({from:this.h(I,fe.from),fromRanges:fe.fromRanges.map(De=>D.Range.from(De))}))}async provideCallsFrom(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(q,W);if(!!ee)return ee.map(fe=>({to:this.h(I,fe.to),fromRanges:fe.fromRanges.map(De=>D.Range.from(De))}))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.CallHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Ce{constructor(I,$){this.f=I,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),ee=D.Position.to($),fe=await this.g.prepareTypeHierarchy(q,ee,W);if(!fe)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(fe)?fe.map(oe=>this.h(De,oe)):[this.h(De,fe)]}async provideSupertypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(q,W);if(!!ee)return ee.map(fe=>this.h(I,fe))}async provideSubtypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(q,W);if(!!ee)return ee.map(fe=>this.h(I,fe))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.TypeHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class we{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async provideDocumentOnDropEdits(I,$,W,q,ee){const fe=this.e.getDocument($),De=D.Position.to(W),oe=D.DataTransfer.toDataTransfer(q,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentDropEdits(fe,De,oe,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class se{constructor(I,$){this.adapter=I,this.extension=$}}class ue{constructor(I,$,W,q,ee,fe,De,oe){this.g=$,this.h=W,this.j=q,this.k=ee,this.l=fe,this.m=De,this.n=oe,this.f=new Map,this.e=I.getProxy(O.MainContext.MainThreadLanguageFeatures)}o(I){return D.DocumentSelector.from(I,this.g)}p(I){return new M.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ue.d++}async s(I,$,W,q,ee,fe=!1){const De=this.f.get(I);if(!De||!(De.adapter instanceof $))return q;const oe=Date.now();fe||this.l.trace(`[${De.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ve=W(De.adapter,De.extension);return Promise.resolve(ve).catch(be=>{(0,E.isCancellationError)(be)||(this.l.error(`[${De.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(De.extension.identifier,be))}).finally(()=>{fe||this.l.trace(`[${De.extension.identifier.value}] provider DONE after ${Date.now()-oe}ms`)}),b.CancellationToken.isCancellationToken(ee)?(0,L.raceCancellationError)(ve,ee):ve}t(I,$){const W=this.q();return this.f.set(W,new se(I,$)),W}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,W,q){const ee=this.t(new t(this.h,W),I),fe=q&&q.label||ue.u(I);return this.e.$registerDocumentSymbolProvider(ee,this.o($),fe),this.p(ee)}$provideDocumentSymbols(I,$,W){return this.s(I,t,q=>q.provideDocumentSymbols(i.URI.revive($),W),void 0,W)}registerCodeLensProvider(I,$,W){const q=this.q(),ee=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new se(new d(this.h,this.j.converter,W),I)),this.e.$registerCodeLensSupport(q,this.o($),ee);let fe=this.p(q);if(ee!==void 0){const De=W.onDidChangeCodeLenses(oe=>this.e.$emitCodeLensEvent(ee));fe=M.Disposable.from(fe,De)}return fe}$provideCodeLenses(I,$,W){return this.s(I,d,q=>q.provideCodeLenses(i.URI.revive($),W),void 0,W)}$resolveCodeLens(I,$,W){return this.s(I,d,q=>q.resolveCodeLens($,W),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,d,W=>Promise.resolve(W.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,W){const q=this.t(new u(this.h,W),I);return this.e.$registerDefinitionSupport(q,this.o($)),this.p(q)}$provideDefinition(I,$,W,q){return this.s(I,u,ee=>ee.provideDefinition(i.URI.revive($),W,q),[],q)}registerDeclarationProvider(I,$,W){const q=this.t(new n(this.h,W),I);return this.e.$registerDeclarationSupport(q,this.o($)),this.p(q)}$provideDeclaration(I,$,W,q){return this.s(I,n,ee=>ee.provideDeclaration(i.URI.revive($),W,q),[],q)}registerImplementationProvider(I,$,W){const q=this.t(new p(this.h,W),I);return this.e.$registerImplementationSupport(q,this.o($)),this.p(q)}$provideImplementation(I,$,W,q){return this.s(I,p,ee=>ee.provideImplementation(i.URI.revive($),W,q),[],q)}registerTypeDefinitionProvider(I,$,W){const q=this.t(new o(this.h,W),I);return this.e.$registerTypeDefinitionSupport(q,this.o($)),this.p(q)}$provideTypeDefinition(I,$,W,q){return this.s(I,o,ee=>ee.provideTypeDefinition(i.URI.revive($),W,q),[],q)}registerHoverProvider(I,$,W,q){const ee=this.t(new c(this.h,W),I);return this.e.$registerHoverProvider(ee,this.o($)),this.p(ee)}$provideHover(I,$,W,q){return this.s(I,c,ee=>ee.provideHover(i.URI.revive($),W,q),void 0,q)}registerEvaluatableExpressionProvider(I,$,W,q){const ee=this.t(new m(this.h,W),I);return this.e.$registerEvaluatableExpressionProvider(ee,this.o($)),this.p(ee)}$provideEvaluatableExpression(I,$,W,q){return this.s(I,m,ee=>ee.provideEvaluatableExpression(i.URI.revive($),W,q),void 0,q)}registerInlineValuesProvider(I,$,W,q){const ee=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new P(this.h,W),I);this.e.$registerInlineValuesProvider(fe,this.o($),ee);let De=this.p(fe);if(ee!==void 0){const oe=W.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(ee));De=M.Disposable.from(De,oe)}return De}$provideInlineValues(I,$,W,q,ee){return this.s(I,P,fe=>fe.provideInlineValues(i.URI.revive($),W,q,ee),void 0,ee)}registerDocumentHighlightProvider(I,$,W){const q=this.t(new T(this.h,W),I);return this.e.$registerDocumentHighlightProvider(q,this.o($)),this.p(q)}$provideDocumentHighlights(I,$,W,q){return this.s(I,T,ee=>ee.provideDocumentHighlights(i.URI.revive($),W,q),void 0,q)}registerLinkedEditingRangeProvider(I,$,W){const q=this.t(new V(this.h,W),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o($)),this.p(q)}$provideLinkedEditingRanges(I,$,W,q){return this.s(I,V,async ee=>{const fe=await ee.provideLinkedEditingRanges(i.URI.revive($),W,q);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?ue.w(fe.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,$,W){const q=this.t(new _(this.h,W),I);return this.e.$registerReferenceSupport(q,this.o($)),this.p(q)}$provideReferences(I,$,W,q,ee){return this.s(I,_,fe=>fe.provideReferences(i.URI.revive($),W,q,ee),void 0,ee)}registerCodeActionProvider(I,$,W,q){const ee=new f.DisposableStore,fe=this.t(new K(this.h,this.j.converter,this.k,W,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(fe,this.o($),{providedKinds:q?.providedCodeActionKinds?.map(De=>De.value),documentation:q?.documentation?.map(De=>({kind:De.kind.value,command:this.j.converter.toInternal(De.command,ee)}))},ue.u(I),Boolean(W.resolveCodeAction)),ee.add(this.p(fe)),ee}$provideCodeActions(I,$,W,q,ee){return this.s(I,K,fe=>fe.provideCodeActions(i.URI.revive($),W,q,ee),void 0,ee)}$resolveCodeAction(I,$,W){return this.s(I,K,q=>q.resolveCodeAction($,W),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,K,W=>Promise.resolve(W.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,W){const q=this.t(new U(this.h,W),I);return this.e.$registerDocumentFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,$,W,q){return this.s(I,U,ee=>ee.provideDocumentFormattingEdits(i.URI.revive($),W,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,$,W){const q=this.t(new R(this.h,W),I);return this.e.$registerRangeFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,$,W,q,ee){return this.s(I,R,fe=>fe.provideDocumentRangeFormattingEdits(i.URI.revive($),W,q,ee),void 0,ee)}registerOnTypeFormattingEditProvider(I,$,W,q){const ee=this.t(new F(this.h,W),I);return this.e.$registerOnTypeFormattingSupport(ee,this.o($),q,I.identifier),this.p(ee)}$provideOnTypeFormattingEdits(I,$,W,q,ee,fe){return this.s(I,F,De=>De.provideOnTypeFormattingEdits(i.URI.revive($),W,q,ee,fe),void 0,fe)}registerWorkspaceSymbolProvider(I,$){const W=this.t(new H($,this.l),I);return this.e.$registerNavigateTypeSupport(W,typeof $.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(I,$,W){return this.s(I,H,q=>q.provideWorkspaceSymbols($,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,$,W){return this.s(I,H,q=>q.resolveWorkspaceSymbol($,W),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,H,W=>W.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,W){const q=this.t(new j(this.h,W,this.l),I);return this.e.$registerRenameSupport(q,this.o($),j.supportsResolving(W)),this.p(q)}$provideRenameEdits(I,$,W,q,ee){return this.s(I,j,fe=>fe.provideRenameEdits(i.URI.revive($),W,q,ee),void 0,ee)}$resolveRenameLocation(I,$,W,q){return this.s(I,j,ee=>ee.resolveRenameLocation(i.URI.revive($),W,q),void 0,q)}registerDocumentSemanticTokensProvider(I,$,W,q){const ee=this.t(new ge(this.h,W),I),fe=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o($),q,fe);let De=this.p(ee);if(fe){const oe=W.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(fe));De=M.Disposable.from(De,oe)}return De}$provideDocumentSemanticTokens(I,$,W,q){return this.s(I,ge,ee=>ee.provideDocumentSemanticTokens(i.URI.revive($),W,q),null,q)}$releaseDocumentSemanticTokens(I,$){this.s(I,ge,W=>W.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,W,q){const ee=this.t(new re(this.h,W),I);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o($),q),this.p(ee)}$provideDocumentRangeSemanticTokens(I,$,W,q){return this.s(I,re,ee=>ee.provideDocumentRangeSemanticTokens(i.URI.revive($),W,q),null,q)}registerCompletionItemProvider(I,$,W,q){const ee=this.t(new ae(this.h,this.j.converter,W,this.m,I),I);return this.e.$registerCompletionsProvider(ee,this.o($),q,ae.supportsResolving(W),`${I.identifier.value}(${q.join("")})`),this.p(ee)}$provideCompletionItems(I,$,W,q,ee){return this.s(I,ae,fe=>fe.provideCompletionItems(i.URI.revive($),W,q,ee),void 0,ee)}$resolveCompletionItem(I,$,W){return this.s(I,ae,q=>q.resolveCompletionItem($,W),void 0,W)}$releaseCompletionItems(I,$){this.s(I,ae,W=>W.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,W){const q=new Se(I,this.h,W,this.j.converter),ee=this.t(q,I);return this.e.$registerInlineCompletionsSupport(ee,this.o($),q.supportsHandleEvents),this.p(ee)}$provideInlineCompletions(I,$,W,q,ee){return this.s(I,ce,fe=>fe.provideInlineCompletions(i.URI.revive($),W,q,ee),void 0,ee)}$handleInlineCompletionDidShow(I,$,W){this.s(I,ce,async q=>{q.handleDidShowCompletionItem($,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(I,$,W,q){this.s(I,ce,async ee=>{ee.handlePartialAccept($,W,q)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,ce,async W=>{W.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,W,q){const ee=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,fe=this.t(new X(this.h,W),I);return this.e.$registerSignatureHelpProvider(fe,this.o($),ee),this.p(fe)}$provideSignatureHelp(I,$,W,q,ee){return this.s(I,X,fe=>fe.provideSignatureHelp(i.URI.revive($),W,q,ee),void 0,ee)}$releaseSignatureHelp(I,$){this.s(I,X,W=>W.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,W){const q=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new J(this.h,this.j.converter,W,this.l,I),I);this.e.$registerInlayHintsProvider(ee,this.o($),typeof W.resolveInlayHint=="function",q,ue.u(I));let fe=this.p(ee);if(q!==void 0){const De=W.onDidChangeInlayHints(oe=>this.e.$emitInlayHintsEvent(q));fe=M.Disposable.from(fe,De)}return fe}$provideInlayHints(I,$,W,q){return this.s(I,J,ee=>ee.provideInlayHints(i.URI.revive($),W,q),void 0,q)}$resolveInlayHint(I,$,W){return this.s(I,J,q=>q.resolveInlayHint($,W),void 0,W)}$releaseInlayHints(I,$){this.s(I,J,W=>W.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,W){const q=this.t(new de(this.h,W),I);return this.e.$registerDocumentLinkProvider(q,this.o($),typeof W.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,$,W){return this.s(I,de,q=>q.provideLinks(i.URI.revive($),W),void 0,W,$.scheme==="output")}$resolveDocumentLink(I,$,W){return this.s(I,de,q=>q.resolveLink($,W),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,de,W=>W.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,W){const q=this.t(new ye(this.h,W),I);return this.e.$registerDocumentColorProvider(q,this.o($)),this.p(q)}$provideDocumentColors(I,$,W){return this.s(I,ye,q=>q.provideColors(i.URI.revive($),W),[],W)}$provideColorPresentations(I,$,W,q){return this.s(I,ye,ee=>ee.provideColorPresentations(i.URI.revive($),W,q),void 0,q)}registerFoldingRangeProvider(I,$,W){const q=this.q(),ee=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new se(new Ne(this.h,W),I)),this.e.$registerFoldingRangeProvider(q,this.o($),I.identifier,ee);let fe=this.p(q);if(ee!==void 0){const De=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));fe=M.Disposable.from(fe,De)}return fe}$provideFoldingRanges(I,$,W,q){return this.s(I,Ne,ee=>ee.provideFoldingRanges(i.URI.revive($),W,q),void 0,q)}registerSelectionRangeProvider(I,$,W){const q=this.t(new We(this.h,W,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o($)),this.p(q)}$provideSelectionRanges(I,$,W,q){return this.s(I,We,ee=>ee.provideSelectionRanges(i.URI.revive($),W,q),[],q)}registerCallHierarchyProvider(I,$,W){const q=this.t(new Pe(this.h,W),I);return this.e.$registerCallHierarchyProvider(q,this.o($)),this.p(q)}$prepareCallHierarchy(I,$,W,q){return this.s(I,Pe,ee=>Promise.resolve(ee.prepareSession(i.URI.revive($),W,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,$,W,q){return this.s(I,Pe,ee=>ee.provideCallsTo($,W,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,$,W,q){return this.s(I,Pe,ee=>ee.provideCallsFrom($,W,q),void 0,q)}$releaseCallHierarchy(I,$){this.s(I,Pe,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,W){const q=this.t(new Ce(this.h,W),I);return this.e.$registerTypeHierarchyProvider(q,this.o($)),this.p(q)}$prepareTypeHierarchy(I,$,W,q){return this.s(I,Ce,ee=>Promise.resolve(ee.prepareSession(i.URI.revive($),W,q)),void 0,q)}$provideTypeHierarchySupertypes(I,$,W,q){return this.s(I,Ce,ee=>ee.provideSupertypes($,W,q),void 0,q)}$provideTypeHierarchySubtypes(I,$,W,q){return this.s(I,Ce,ee=>ee.provideSubtypes($,W,q),void 0,q)}$releaseTypeHierarchy(I,$){this.s(I,Ce,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,W){const q=this.q();return this.f.set(q,new se(new we(this.e,this.h,W,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o($)),this.p(q)}$provideDocumentOnDropEdits(I,$,W,q,ee,fe){return this.s(I,we,De=>Promise.resolve(De.provideDocumentOnDropEdits($,i.URI.revive(W),q,ee,fe)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,W,q){const ee=this.q();return this.f.set(ee,new se(new A(this.e,this.h,W,ee),I)),this.e.$registerPasteEditProvider(ee,this.o($),!!W.prepareDocumentPaste,q.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(I,$,W,q,ee){return this.s(I,A,fe=>fe.prepareDocumentPaste(i.URI.revive($),W,q,ee),void 0,ee)}$providePasteEdits(I,$,W,q,ee,fe){return this.s(I,A,De=>De.providePasteEdits($,i.URI.revive(W),q,ee,fe),void 0,fe)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ue.w(I.decreaseIndentPattern),increaseIndentPattern:ue.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ue.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ue.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ue.w(I.beforeText),afterText:I.afterText?ue.w(I.afterText):void 0,previousLineText:I.previousLineText?ue.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ue.z)}setLanguageConfiguration(I,$,W){const{wordPattern:q}=W;if(q&&(0,S.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor($,q):this.h.setWordDefinitionFor($,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const ee=this.q(),fe={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ue.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ue.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ue.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,$,fe),this.p(ee)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}ue.d=0,e.ExtHostLanguageFeatures=ue}),define(ke[219],Te([1,0,5,8,7,29,17,6]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(N,w,h,b){this.c=w,this.d=h,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,w){await this.a.$changeLanguage(N,w);const h=this.c.getDocumentData(N);if(!h)throw new Error(`document '${N.toString()}' NOT found`);return h.document}async tokenAtPosition(N,w){const h=N.version,b=C.Position.from(w),f=await this.a.$tokensAtPosition(N.uri,b),a={type:D.StandardTokenType.Other,range:N.getWordRangeAtPosition(w)??new D.Range(w.line,w.character,w.line,w.character)};if(!f)return a;const s={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!s.range.contains(w)||h!==N.version?a:s}createLanguageStatusItem(N,w,h){const b=this.f++,f=this.a,a=this.g,s=`${N.identifier.value}/${w}`;if(a.has(s))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);a.add(s);const l={selector:h,id:w,name:N.displayName??N.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const E=new O.DisposableStore,L=()=>{g?.dispose(),g=(0,y.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(b,{id:s,name:l.name??N.displayName??N.name,source:N.displayName??N.name,selector:C.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===D.LanguageStatusSeverity.Error?M.default.Error:l.severity===D.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},v={dispose(){E.dispose(),g?.dispose(),f.$removeLanguageStatus(b),a.delete(s)},get id(){return l.id},get name(){return l.name},set name(t){l.name=t,L()},get selector(){return l.selector},set selector(t){l.selector=t,L()},get text(){return l.text},set text(t){l.text=t,L()},get detail(){return l.detail},set detail(t){l.detail=t,L()},get severity(){return l.severity},set severity(t){l.severity=t,L()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(t){l.accessibilityInformation=t,L()},get command(){return l.command},set command(t){l.command=t,L()},get busy(){return l.busy},set busy(t){l.busy=t,L()}};return L(),v}}e.ExtHostLanguages=S}),define(ke[78],Te([1,0,20,10,2,3,11,5,27,18]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(h,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(O.MainContext.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(h,b){const{message:f,args:a,comment:s}=b;if(this.c)return(0,C.format2)(f,a??{});let l=f;s&&s.length>0&&(l+=`/${Array.isArray(s)?s.join(""):s}`);const g=this.d.get(h)?.contents[l];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,C.format2)(g??f,a??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let b;const f=await this.g(h);if(!f){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(f),s=JSON.parse(a);b=h.isBuiltin?s.contents?.bundle:s}catch(a){this.f.error(`Failed to load translations for ${h.identifier.value} from ${f}: ${a.message}`);return}b&&this.d.set(h.identifier.value,{contents:b,uri:f})}async g(h){if(h.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(h.identifier.value);return D.URI.revive(b)}return h.l10n?D.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=Ke([je(0,S.IExtHostInitDataService),je(1,k.IExtHostRpcService),je(2,y.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(ke[220],Te([1,0,11,5,27,18,2,66]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends i.AbstractLoggerService{constructor(w,h){super(h.logLevel,h.loggers.map(b=>(0,O.revive)(b))),this.l=w.getProxy(C.MainContext.MainThreadLogger)}$setLogLevel(w,h){h?this.setLogLevel(y.URI.revive(h),w):this.setLogLevel(w)}setVisibility(w,h){super.setVisibility(w,h),this.l.$setVisibility(w,h)}k(w,h,b){return new k(this.l,w,h,b)}};S=Ke([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class k extends i.AbstractMessageLogger{constructor(w,h,b,f){super(f?.logLevel==="always"),this.m=w,this.n=h,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(h,f).then(()=>{this.r(this.l),this.k=!0})}g(w,h){const b=[[w,h]];this.k?this.r(b):this.l.push(...b)}r(w){this.m.$log(this.n,w)}}}),define(ke[221],Te([1,0,5,11,26]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(O){return O&&O.title}let y=class{constructor(S,k){this.b=k,this.a=S.getProxy(i.MainContext.MainThreadMessageService)}showMessage(S,k,N,w,h){const b={source:{identifier:S.identifier,label:S.displayName||S.name}};let f;typeof w=="string"||M(w)?f=[w,...h]:(b.modal=w?.modal,b.useCustom=w?.useCustom,b.detail=w?.detail,f=h),b.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const a=[];for(let s=0;s<f.length;s++){const l=f[s];if(typeof l=="string")a.push({title:l,handle:s,isCloseAffordance:!1});else if(typeof l=="object"){const{title:g,isCloseAffordance:E}=l;a.push({title:g,isCloseAffordance:!!E,handle:s})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,N,b,a).then(s=>{if(typeof s=="number")return f[s]})}};y=Ke([je(1,C.ILogService)],y),e.ExtHostMessageService=y}),define(ke[222],Te([1,0,23,4,6,28,10,9,2,54,5,37,8,7,46,196,100]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,L,v,t){this.q=v,this.r=t,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new C.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(N.MainContext.MainThreadNotebook),this.c=E.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=L.converter,L.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const r=d.notebookEditor?.notebookUri,u=d.cell.handle,p=this.g.get(r)?.getCell(u);if(p)return p.apiCell}if(d&&d.$mid===14){const r=d.uri,u=this.g.get(r);if(u)return u.apiNotebook}return d}}),l.x(L)}getEditorById(E){const L=this.h.get(E);if(!L)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return L}getIdByEditor(E){for(const[L,v]of this.h)if(v.apiEditor===E)return L}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,L){const v=this.g.get(E);if(!v&&!L)throw new Error(`NO notebook document for '${E}'`);return v}static s(E,L){if(!L)return;const v=L.filenamePattern.map(t=>h.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(L.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${L.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:L.displayName,filenamePattern:v,exclusive:L.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,L,v){const t=l.a++,d=typeof v.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(t,v),this.b.$registerNotebookCellStatusBarItemProvider(t,d,L);let r;return d!==void 0&&(r=v.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(d))),new b.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,d),r?.dispose()})}async createNotebookDocument(E){const L=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&h.NotebookData.from(E.content)});return S.URI.revive(L)}async openNotebookDocument(E){const L=this.g.get(E);if(L)return L.apiNotebook;const v=await this.c.$tryOpenNotebook(E),t=this.g.get(S.URI.revive(v));return(0,O.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(E,L){S.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let v;typeof L=="object"?v={position:h.ViewColumn.from(L.viewColumn),preserveFocus:L.preserveFocus,selections:L.selections&&L.selections.map(h.NotebookRange.from),pinned:typeof L.preview=="boolean"?!L.preview:void 0}:v={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,v),d=t&&this.h.get(t)?.apiEditor;if(d)return d;throw t?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,L,v,t){const d=this.f.get(E),r=S.URI.revive(L),u=this.g.get(r);if(!u||!d)return;const n=u.getCellFromIndex(v);if(!n)return;const p=await d.provideCellStatusBarItems(n.apiCell,t);if(!p)return;const o=new D.DisposableStore,c=this.p.add([o]),P=(Array.isArray(p)?p:[p]).map(T=>h.NotebookStatusBarItem.from(T,this.i,o));return{cacheId:c,items:P}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,L,v,t,d){if((0,y.isFalsyOrWhitespace)(L))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,v),this.b.$registerNotebookSerializer(r,{id:E.identifier,location:E.extensionLocation},L,h.NotebookDocumentContentOptions.from(t),l.s(E,d)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(E,L,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const d=await t.deserializeNotebook(L.buffer,v);return new f.SerializableObjectWithBuffers(h.NotebookData.from(d))}async $notebookToData(E,L,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const d=await t.serializeNotebook(h.NotebookData.to(L.value),v);return i.VSBuffer.wrap(d)}w(E,L,v){if(this.h.has(L))throw new Error(`editor with id ALREADY EXSIST: ${L}`);const t=new s.ExtHostNotebookEditor(L,this.d,E,v.visibleRanges.map(h.NotebookRange.to),v.selections.map(h.NotebookRange.to),typeof v.viewColumn=="number"?h.ViewColumn.to(v.viewColumn):void 0);this.h.set(L,t)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const v of E.value.removedDocuments){const t=S.URI.revive(v),d=this.g.get(t);d&&(d.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(d.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===t.toString()&&this.h.delete(r.id)}if(E.value.addedDocuments){const v=[];for(const t of E.value.addedDocuments){const d=S.URI.revive(t.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const r=new a.ExtHostNotebookDocument(this.c,this.q,this.r,d,t);v.push(...t.cells.map(u=>a.ExtHostCell.asModelAddData(r.apiNotebook,u))),this.g.get(d)?.dispose(),this.g.set(d,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(r.apiNotebook)}}if(E.value.addedEditors)for(const v of E.value.addedEditors){if(this.h.has(v.id))return;const t=S.URI.revive(v.documentUri),d=this.g.get(t);d&&this.w(d,v.id,v)}const L=[];if(E.value.removedEditors)for(const v of E.value.removedEditors){const t=this.h.get(v);t&&(this.h.delete(v),this.k?.id===t.id&&(this.k=void 0),L.push(t))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const v=new Set;this.l.forEach(t=>v.add(t.id));for(const t of this.h.values()){const d=v.has(t.id);t._acceptVisibility(d)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const L=w.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[L,new w.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>i.VSBuffer.wrap(d))],new w.ApiCommandResult("Notebook Data",d=>h.NotebookData.to(d.value))),t=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[L,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new f.SerializableObjectWithBuffers(h.NotebookData.from(d)))],new w.ApiCommandResult("Bytes",d=>d.buffer));E.registerApiCommand(v),E.registerApiCommand(t)}}l.a=0,e.ExtHostNotebookController=l}),define(ke[223],Te([1,0,16,17,21,4,6,28,2,25,11,54,5,37,8,7,73,186,26,46]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let L=class{constructor(n,p,o,c,m){this.k=p,this.l=o,this.m=c,this.n=m,this.b=new O.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new w.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=n.getProxy(h.MainContext.MainThreadNotebookKernels);const P=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const V=this.l.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:V}}else if(T&&"notebookEditor"in T){const V=this.l.getIdByEditor(T.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return T})],b.ApiCommandResult.Void);this.m.registerApiCommand(P)}createNotebookController(n,p,o,c,m,P){for(const ce of this.h.values())if(ce.controller.id===p&&k.ExtensionIdentifier.equals(n.identifier,ce.extensionId))throw new Error(`notebook controller with id '${p}' ALREADY exist`);const T=this.i++,V=this;this.n.trace(`NotebookController[${T}], CREATED by ${n.identifier.value}, ${p}`);const _=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${n.identifier}'`);let K=!1;const A=new y.DisposableStore,U=new M.Emitter,R=new M.Emitter,F={id:r(n.identifier,p),notebookType:o,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:c||n.identifier.value,preloads:P?P.map(f.NotebookRendererScript.from):[]};let H=m??_,j;this.a.$addKernel(T,F).catch(ce=>{console.log(ce),K=!0});let le=0;const ge=()=>{if(K)return;const ce=++le;Promise.resolve().then(()=>{ce===le&&this.a.$updateKernel(T,F)})},re=new O.ResourceMap,ae={get id(){return p},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return F.label},set label(ce){F.label=ce??n.displayName??n.name,ge()},get detail(){return F.detail??""},set detail(ce){F.detail=ce,ge()},get description(){return F.description??""},set description(ce){F.description=ce,ge()},get kind(){return(0,g.checkProposedApiEnabled)(n,"notebookControllerKind"),F.kind??""},set kind(ce){(0,g.checkProposedApiEnabled)(n,"notebookControllerKind"),F.kind=ce,ge()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ce){F.supportedLanguages=ce,ge()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){F.supportsExecutionOrder=ce,ge()},get rendererScripts(){return F.preloads?F.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(ce){H=ce??_},get interruptHandler(){return j},set interruptHandler(ce){j=ce,F.supportsInterrupt=Boolean(ce),ge()},createNotebookCellExecution(ce){if(K)throw new Error("notebook controller is DISPOSED");if(!re.has(ce.notebook.uri))throw V.n.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return V._createNotebookCellExecution(ce,r(n.identifier,this.id))},dispose:()=>{K||(this.n.trace(`NotebookController[${T}], DISPOSED`),K=!0,this.h.delete(T),A.dispose(),U.dispose(),R.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(ce,Se){Se===a.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(T,ce.uri,Se)},onDidReceiveMessage:R.event,postMessage(ce,Se){return(0,g.checkProposedApiEnabled)(n,"notebookMessaging"),V.a.$postMessage(T,Se&&V.l.getIdByEditor(Se),ce)},asWebviewUri(ce){return(0,g.checkProposedApiEnabled)(n,"notebookMessaging"),(0,s.asWebviewUri)(ce,V.k.remote)}};return this.h.set(T,{extensionId:n.identifier,controller:ae,onDidReceiveMessage:R,onDidChangeSelection:U,associatedNotebooks:re}),ae}getIdByController(n){for(const[p,o]of this.h)if(o.controller===n)return r(o.extensionId,n.id);return null}createNotebookControllerDetectionTask(n,p){const o=this.d++,c=this;this.n.trace(`NotebookControllerDetectionTask[${o}], CREATED by ${n.identifier.value}`),this.a.$addKernelDetectionTask(o,p);const m={dispose:()=>{this.c.delete(o),c.a.$removeKernelDetectionTask(o)}};return this.c.set(o,m),m}registerKernelSourceActionProvider(n,p,o){const c=this.f++,m=typeof o.onDidChangeNotebookKernelSourceActions=="function"?c:void 0,P=this;this.e.set(c,o),this.n.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${n.identifier.value}`),this.a.$addKernelSourceActionProvider(c,c,p);let T;return m!==void 0&&(T=o.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.e.delete(c),P.a.$removeKernelSourceActionProvider(c,c),T?.dispose()}}}async $provideKernelSourceActions(n,p){const o=this.e.get(n);if(o){const c=new y.DisposableStore;return this.g.add([c]),(await o.provideNotebookKernelSourceActions(p)??[]).map(P=>f.NotebookKernelSourceAction.from(P,this.m.converter,c))}return[]}$acceptNotebookAssociation(n,p,o){const c=this.h.get(n);if(c){const m=this.l.getNotebookDocument(S.URI.revive(p));o?c.associatedNotebooks.set(m.uri,!0):c.associatedNotebooks.delete(m.uri),this.n.trace(`NotebookController[${n}] ASSOCIATE notebook`,m.uri.toString(),o),c.onDidChangeSelection.fire({selected:o,notebook:m.apiNotebook})}}async $executeCells(n,p,o){const c=this.h.get(n);if(!c)return;const m=this.l.getNotebookDocument(S.URI.revive(p)),P=[];for(const T of o){const V=m.getCell(T);V&&P.push(V.apiCell)}try{this.n.trace(`NotebookController[${n}] EXECUTE cells`,m.uri.toString(),P.length),await c.controller.executeHandler.call(c.controller,P,m.apiNotebook,c.controller)}catch(T){this.n.error(`NotebookController[${n}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(n,p,o){const c=this.h.get(n);if(!c)return;const m=this.l.getNotebookDocument(S.URI.revive(p));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,m.apiNotebook);else for(const P of o){const T=m.getCell(P);T&&this.b.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,p,o){const c=this.h.get(n);if(!c)return;const m=this.l.getEditorById(p);c.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:o}))}$cellExecutionChanged(n,p,o){const m=this.l.getNotebookDocument(S.URI.revive(n)).getCell(p);if(m){const P=o?f.NotebookCellExecutionState.to(o):a.NotebookCellExecutionState.Idle;P!==void 0&&this.j.fire({cell:m.apiCell,state:P})}}_createNotebookCellExecution(n,p){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this.l.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!c)throw new Error("invalid cell");if(this.b.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const m=new t(p,c,this.a);this.b.set(c.uri,m);const P=m.onDidChangeState(()=>{m.state===v.Resolved&&(m.dispose(),P.dispose(),this.b.delete(c.uri))});return m.asApiObject()}};L=Ke([je(4,N.ILogService)],L),e.ExtHostNotebookKernels=L;var v;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(v||(v={}));class t extends y.Disposable{get state(){return this.f}constructor(n,p,o){super(),this.j=p,this.k=o,this.b=t.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new d(10,c=>this.m(c)),this.i=p.internalMetadata.executionOrder,this.k.$createExecution(this.b,n,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(n){await this.h.addItem(n)}async m(n){const p=Array.isArray(n)?n:[n];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(p))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(n){let p=this.j;if(n&&(p=this.j.notebook.getCellFromApiCell(n)),!p)throw new Error("INVALID cell");return p.handle}s(n){return n.map(p=>{const o=a.NotebookCellOutput.ensureUniqueMimeTypes(p.items,!0);return o===p.items?f.NotebookCellOutput.from(p):f.NotebookCellOutput.from({items:o,id:p.id,metadata:p.metadata})})}async t(n,p,o){const c=this.r(p),m=this.s((0,i.asArray)(n));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:c,append:o,outputs:m})}async w(n,p,o){return n=a.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(n),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:n.map(f.NotebookCellOutputItem.from),outputId:p.id,append:o})}asApiObject(){const n=this;return Object.freeze({get token(){return n.g.token},get cell(){return n.j.apiCell},get executionOrder(){return n.i},set executionOrder(o){n.i=o,n.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:n.i}])},start(o){if(n.f===v.Resolved||n.f===v.Started)throw new Error("Cannot call start again");n.f=v.Started,n.c.fire(),n.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:o})},end(o,c){if(n.f===v.Resolved)throw new Error("Cannot call resolve twice");n.f=v.Resolved,n.c.fire(),n.h.flush(),n.k.$completeExecution(n.b,new E.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:o}))},clearOutput(o){return n.n(),n.t([],o,!1)},appendOutput(o,c){return n.n(),n.t(o,c,!0)},replaceOutput(o,c){return n.n(),n.t(o,c,!1)},appendOutputItems(o,c){return n.n(),n.w(o,c,!0)},replaceOutputItems(o,c){return n.n(),n.w(o,c,!1)}})}}t.a=0;class d{constructor(n,p){this.d=n,this.e=p,this.a=[],this.b=Date.now()}addItem(n){return this.a.push(n),this.c||(this.c=new C.DeferredPromise,this.b=Date.now(),(0,C.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const n=this.c;this.c=void 0;const p=this.a;return this.a=[],this.e(p).finally(()=>n.complete())}}function r(u,n){return`${u.value}/${n}`}e.createKernelId=r}),define(ke[224],Te([1,0,4,5,100]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(O,S){this.c=S,this.a=new Map,this.b=O.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(O,S,k){const N=this.c.getEditorById(O);this.a.get(S)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(O,S){if(!O.contributes?.notebookRenderer?.some(N=>N.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(N,w,h)=>this.d(S).event(N,w,h),postMessage:(N,w)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,w]=[w,N]);const h=w&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(h?.id,S,N)}}}d(O){let S=this.a.get(O);return S||(S=new i.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(O)}}),this.a.set(O,S),S)}}e.ExtHostNotebookRenderers=M}),define(ke[225],Te([1,0,6,9,2,26,5]),function(te,e,i,C,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class O{constructor(k){this.b=new Map,this.a=k.getProxy(y.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,N,w){if((0,M.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,w),this.a.$registerProfileContentHandler(N,w.name,w.description,k.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(k,N,w,h){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(N,w,h)}async $readProfile(k,N,w){const h=this.b.get(k);if(!h)throw new Error(`Unknown handler with id: ${k}`);return h.readProfile((0,C.isString)(N)?N:D.URI.revive(N),w)}}e.ExtHostProfileContentHandlers=O}),define(ke[226],Te([1,0,2,5,17,8]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class y{constructor(S,k){this.d=k,this.c=new Map,this.b=S.getProxy(C.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,k,N){const w=i.URI.revive(k),h=this.c.get(S);return h?(0,D.asPromise)(()=>h.provideOriginalResource(w,N)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(S,k,N,w){const h=y.a++;return this.c.set(h,k),this.b.$registerQuickDiffProvider(h,M.DocumentSelector.from(S,this.d),N,w),{dispose:()=>this.c.delete(h)}}}y.a=0,e.ExtHostQuickDiff=y}),define(ke[227],Te([1,0,21,4,6,5,2,7,12,16,29,38]),function(te,e,i,C,D,M,y,O,S,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(b,f,a){const s=b.getProxy(M.MainContext.MainThreadQuickOpen);class l{constructor(n,p){this.e=new Map,this.f=0,this.a=n,this.b=p}showQuickPick(n,p,o=i.CancellationToken.None){this.c=void 0;const c=Promise.resolve(n),m=++this.f,P=s.$show(m,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},o),T={},V=P.then(()=>T);return Promise.race([V,c]).then(_=>{if(_!==T)return c.then(K=>{const A=[];for(let U=0;U<K.length;U++){const R=K[U];typeof R=="string"?A.push({label:R,handle:U}):R.kind===O.QuickPickItemKind.Separator?A.push({type:"separator",label:R.label}):A.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:U})}return p&&typeof p.onDidSelectItem=="function"&&(this.c=U=>{p.onDidSelectItem(K[U])}),s.$setItems(m,A),P.then(U=>{if(typeof U=="number")return K[U];if(Array.isArray(U))return U.map(R=>K[R])})})}).then(void 0,_=>{if(!(0,S.isCancellationError)(_))return s.$setError(m,_),Promise.reject(_)})}$onItemSelected(n){this.c?.(n)}showInput(n,p=i.CancellationToken.None){return this.d=n?.validateInput,s.$input(n,typeof this.d=="function",p).then(void 0,o=>{if(!(0,S.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(n){if(!this.d)return;const p=await this.d(n);if(!p||typeof p=="string")return p;let o;switch(p.severity){case O.InputBoxValidationSeverity.Info:o=N.default.Info;break;case O.InputBoxValidationSeverity.Warning:o=N.default.Warning;break;case O.InputBoxValidationSeverity.Error:o=N.default.Error;break;default:o=p.message?N.default.Error:N.default.Ignore;break}return{content:p.message,severity:o}}async showWorkspaceFolderPick(n,p=i.CancellationToken.None){const o=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!o)return;const c=await this.a.getWorkspaceFolders2();if(!!c)return c.find(m=>m.uri.toString()===o.uri.toString())}createQuickPick(n){const p=new d(n,()=>this.e.delete(p._id));return this.e.set(p._id,p),p}createInputBox(n){const p=new r(n,()=>this.e.delete(p._id));return this.e.set(p._id,p),p}$onDidChangeValue(n,p){this.e.get(n)?._fireDidChangeValue(p)}$onDidAccept(n){this.e.get(n)?._fireDidAccept()}$onDidChangeActive(n,p){const o=this.e.get(n);o instanceof d&&o._fireDidChangeActive(p)}$onDidChangeSelection(n,p){const o=this.e.get(n);o instanceof d&&o._fireDidChangeSelection(p)}$onDidTriggerButton(n,p){this.e.get(n)?._fireDidTriggerButton(p)}$onDidTriggerItemButton(n,p,o){const c=this.e.get(n);c instanceof d&&c._fireDidTriggerItemButton(p,o)}$onDidHide(n){this.e.get(n)?._fireDidHide()}}class g{constructor(n,p){this.x=n,this.y=p,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.Emitter,this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(n){this.b=n,this.z({title:n})}get step(){return this.c}set step(n){this.c=n,this.z({step:n})}get totalSteps(){return this.d}set totalSteps(n){this.d=n,this.z({totalSteps:n})}get enabled(){return this.g}set enabled(n){this.g=n,this.z({enabled:n})}get busy(){return this.j}set busy(n){this.j=n,this.z({busy:n})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(n){this.k=n,this.z({ignoreFocusOut:n})}get value(){return this.l}set value(n){this.l=n,this.z({value:n})}get placeholder(){return this.m}set placeholder(n){this.m=n,this.z({placeholder:n})}get buttons(){return this.n}set buttons(n){this.n=n.slice(),this.o.clear(),n.forEach((p,o)=>{const c=p===O.QuickInputButtons.Back?-1:o;this.o.set(c,p)}),this.z({buttons:n.map((p,o)=>({...t(p),tooltip:p.tooltip,handle:p===O.QuickInputButtons.Back?-1:o}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(n){this.l=n,this.q.fire(n)}_fireDidTriggerButton(n){const p=this.o.get(n);p&&this.r.fire(p)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(n){if(!this.v){for(const p of Object.keys(n)){const o=n[p];this.u[p]=o===void 0?null:o}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function E(u){if(u instanceof O.ThemeIcon)return{id:u.id};const n=v(u),p=L(u);return{dark:typeof n=="string"?y.URI.file(n):n,light:typeof p=="string"?y.URI.file(p):p}}function L(u){return typeof u=="object"&&"light"in u?u.light:u}function v(u){return typeof u=="object"&&"dark"in u?u.dark:u}function t(u){const n=E(u.iconPath);let p,o;return"id"in n?o=w.ThemeIcon.asClassName(n):p=n,{iconPath:p,iconClass:o}}class d extends g{constructor(n,p){super(n.identifier,p),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.Emitter,this.L=[],this.M=new C.Emitter,this.N=new C.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(n){this.B=n.slice(),this.C.clear(),this.D.clear(),n.forEach((o,c)=>{this.C.set(c,o),this.D.set(o,c)});const p=[];for(let o=0;o<n.length;o++){const c=n[o];c.kind===O.QuickPickItemKind.Separator?p.push({type:"separator",label:c.label}):p.push({handle:o,label:c.label,description:c.description,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons?.map((m,P)=>({...t(m),tooltip:m.tooltip,handle:P}))})}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(n){this.E=n,this.z({canSelectMany:n})}get matchOnDescription(){return this.F}set matchOnDescription(n){this.F=n,this.z({matchOnDescription:n})}get matchOnDetail(){return this.G}set matchOnDetail(n){this.G=n,this.z({matchOnDetail:n})}get sortByLabel(){return this.H}set sortByLabel(n){this.H=n,this.z({sortByLabel:n})}get keepScrollPosition(){return this.I}set keepScrollPosition(n){this.I=n,this.z({keepScrollPosition:n})}get activeItems(){return this.J}set activeItems(n){this.J=n.filter(p=>this.D.has(p)),this.z({activeItems:this.J.map(p=>this.D.get(p))})}get selectedItems(){return this.L}set selectedItems(n){this.L=n.filter(p=>this.D.has(p)),this.z({selectedItems:this.L.map(p=>this.D.get(p))})}_fireDidChangeActive(n){const p=(0,k.coalesce)(n.map(o=>this.C.get(o)));this.J=p,this.K.fire(p)}_fireDidChangeSelection(n){const p=(0,k.coalesce)(n.map(o=>this.C.get(o)));this.L=p,this.M.fire(p)}_fireDidTriggerItemButton(n,p){const o=this.C.get(n);if(!o||!o.buttons||!o.buttons.length)return;const c=o.buttons[p];c&&this.N.fire({button:c,item:o})}}class r extends g{constructor(n,p){super(n.identifier,p),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(n){this.B=n,this.z({password:n})}get prompt(){return this.C}set prompt(n){this.C=n,this.z({prompt:n})}get valueSelection(){return this.D}set valueSelection(n){this.D=n,this.z({valueSelection:n})}get validationMessage(){return this.E}set validationMessage(n){this.E=n,n?typeof n=="string"?this.z({validationMessage:n,severity:N.default.Error}):this.z({validationMessage:n.message,severity:n.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new l(f,a)}e.createExtHostQuickOpen=h});var Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i};define(ke[228],Te([1,0,2,4,64,6,17,5,16,123,11,25,38,8,26]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f){"use strict";var a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(c){if(c)return typeof c.iconPath=="string"?i.URI.file(c.iconPath):i.URI.isUri(c.iconPath)||h.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function g(c,m){if(!c.iconPath&&!m.iconPath)return 0;if(c.iconPath){if(!m.iconPath)return 1}else return-1;const P=typeof c.iconPath=="string"?c.iconPath:i.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,T=typeof m.iconPath=="string"?m.iconPath:i.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,k.comparePaths)(P,T)}function E(c,m){let P=0;if(c.strikeThrough!==m.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==m.faded)return c.faded?1:-1;if(c.tooltip!==m.tooltip)return(c.tooltip||"").localeCompare(m.tooltip||"");if(P=g(c,m),P!==0)return P;if(c.light&&m.light)P=g(c.light,m.light);else{if(c.light)return 1;if(m.light)return-1}if(P!==0)return P;if(c.dark&&m.dark)P=g(c.dark,m.dark);else{if(c.dark)return 1;if(m.dark)return-1}return P}function L(c,m){if(c.command!==m.command)return c.command<m.command?-1:1;if(c.title!==m.title)return c.title<m.title?-1:1;if(c.tooltip!==m.tooltip){if(c.tooltip!==void 0&&m.tooltip!==void 0)return c.tooltip<m.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(c.arguments===m.arguments)return 0;if(c.arguments)if(m.arguments){if(c.arguments.length!==m.arguments.length)return c.arguments.length-m.arguments.length}else return 1;else return-1;for(let P=0;P<c.arguments.length;P++){const T=c.arguments[P],V=m.arguments[P];if(T!==V)return T<V?-1:1}return 0}function v(c,m){let P=(0,k.comparePaths)(c.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(P!==0)return P;if(c.command&&m.command)P=L(c.command,m.command);else{if(c.command)return 1;if(m.command)return-1}if(P!==0)return P;if(c.decorations&&m.decorations)P=E(c.decorations,m.decorations);else{if(c.decorations)return 1;if(m.decorations)return-1}return P}function t(c,m){for(let P=0;P<c.length;P++)if(c[P]!==m[P])return!1;return!0}function d(c,m){return c.command===m.command&&c.title===m.title&&c.tooltip===m.tooltip&&(c.arguments&&m.arguments?t(c.arguments,m.arguments):c.arguments===m.arguments)}function r(c,m){return(0,S.equals)(c,m,d)}class u{get value(){return this.d}set value(m){m=m??"",Le(this,a,"f").$setInputBoxValue(this.l,m),this.m(m)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(m){Le(this,a,"f").$setInputBoxPlaceholder(this.l,m),this.f=m}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(m){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=m,Le(this,a,"f").$setValidationProviderIsEnabled(this.l,!!m)}get enabled(){return this.h}set enabled(m){m=!!m,this.h!==m&&(this.h=m,Le(this,a,"f").$setInputBoxEnablement(this.l,m))}get visible(){return this.j}set visible(m){m=!!m,this.j!==m&&(this.j=m,Le(this,a,"f").$setInputBoxVisibility(this.l,m))}constructor(m,P,T){this.k=m,this.l=T,a.set(this,void 0),this.d="",this.e=new C.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,a,P,"f")}showValidationMessage(m,P){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,a,"f").$showValidationMessage(this.l,m,P)}$onInputBoxValueChange(m){this.m(m)}m(m){this.d=m,this.e.fire(m)}}e.ExtHostSCMInputBox=u,a=new WeakMap;class n{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(m){this.v=m,this.q.$updateGroupLabel(this.t,this.handle,m)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(m){this.p=m,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(m){this.f=[...m],this.k.fire()}constructor(m,P,T,V,_){this.q=m,this.s=P,this.t=T,this.u=V,this.v=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=n.d++}getResourceState(m){return this.g.get(m)}$executeResourceCommand(m,P){const T=this.h.get(m);return T?(0,y.asPromise)(()=>this.s.executeCommand(T.command,...T.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this.f].sort(v),T=(0,S.sortedDiff)(this.o,m,v).map(K=>{const A=K.toInsert.map(U=>{const R=this.e++;this.g.set(R,U);const F=U.resourceUri;let H;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const J=new M.DisposableStore;H=this.s.converter.toInternal(U.command,J),this.j.set(R,J)}else this.h.set(R,U.command);const j=l(U.decorations),le=U.decorations&&l(U.decorations.light)||j,ge=U.decorations&&l(U.decorations.dark)||j,re=[le,ge],ae=U.decorations&&U.decorations.tooltip||"",ce=U.decorations&&!!U.decorations.strikeThrough,Se=U.decorations&&!!U.decorations.faded,x=U.contextValue||"";return{rawResource:[R,F,re,ae,ce,Se,x,H],handle:R}});return{start:K.start,deleteCount:K.deleteCount,toInsert:A}}),V=T.map(({start:K,deleteCount:A,toInsert:U})=>[K,A,U.map(R=>R.rawResource)]),_=T.reverse();for(const{start:K,deleteCount:A,toInsert:U}of _){const R=U.map(H=>H.handle),F=this.n.splice(K,A,...R);for(const H of F)this.g.delete(H),this.h.delete(H),this.j.get(H)?.dispose(),this.j.delete(H)}return this.o=m,V}dispose(){this.l=!0,this.m.fire()}}n.d=0;class p{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(m){this.g!==m&&(this.g=m,Le(this,s,"f").$updateSourceControl(this.t,{count:m}))}get quickDiffProvider(){return this.h}set quickDiffProvider(m){this.h=m,Le(this,s,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this.j}set commitTemplate(m){m!==this.j&&(this.j=m,Le(this,s,"f").$updateSourceControl(this.t,{commitTemplate:m}))}get acceptInputCommand(){return this.l}set acceptInputCommand(m){this.k.value=new M.DisposableStore,this.l=m;const P=this.v.converter.toInternal(m,this.k.value);Le(this,s,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(m){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=m;const P=m!==void 0?{command:this.v.converter.toInternal(m.command,this.m.value),secondaryCommands:m.secondaryCommands?.map(T=>T.map(V=>this.v.converter.toInternal(V,this.m.value))),description:m.description,enabled:m.enabled}:void 0;Le(this,s,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(m){if(this.p&&m&&r(this.p,m))return;this.o.value=new M.DisposableStore,this.p=m;const P=(m||[]).map(T=>this.v.converter.toInternal(T,this.o.value));Le(this,s,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(m,P,T,V,_,K){this.u=m,this.v=T,this.w=V,this.x=_,this.y=K,s.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new C.Emitter,this.onDidChangeSelection=this.s.event,this.t=p.d++,this.z=new Map,this.A=new Set,Je(this,s,P,"f"),this.f=new u(m,Le(this,s,"f"),this.t),Le(this,s,"f").$registerSourceControl(this.t,V,_,K)}createResourceGroup(m,P){const T=new n(Le(this,s,"f"),this.v,this.t,m,P),V=C.Event.once(T.onDidDispose)(()=>this.z.delete(T));return this.z.set(T,V),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const m=[],P=[];for(const[T,V]of this.z){V.dispose();const _=T.onDidUpdateResourceStates(()=>{this.A.add(T),this.eventuallyUpdateResourceStates()});C.Event.once(T.onDidDispose)(()=>{this.A.delete(T),_.dispose(),this.e.delete(T.handle),Le(this,s,"f").$unregisterGroup(this.t,T.handle)}),m.push([T.handle,T.id,T.label,T.features]);const K=T._takeResourceStateSnapshot();K.length>0&&P.push([T.handle,K]),this.e.set(T.handle,T)}Le(this,s,"f").$registerGroups(this.t,m,P),this.z.clear()}eventuallyUpdateResourceStates(){const m=[];this.A.forEach(P=>{const T=P._takeResourceStateSnapshot();T.length!==0&&m.push([P.handle,T])}),m.length>0&&Le(this,s,"f").$spliceResourceStates(this.t,m),this.A.clear()}getResourceGroup(m){return this.e.get(m)}setSelectionState(m){this.q=m,this.s.fire(m)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(m=>m.dispose()),Le(this,s,"f").$unregisterSourceControl(this.t)}}s=new WeakMap,p.d=0,Ke([(0,D.debounce)(100)],p.prototype,"eventuallyAddResourceGroups",null),Ke([(0,D.debounce)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let o=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(m,P,T){this.l=P,this.m=T,this.g=new Map,this.h=new Map,this.j=new C.Emitter,this.e=m.getProxy(O.MainContext.MainThreadSCM),this.f=m.getProxy(O.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const _=this.g.get(V.sourceControlHandle);if(!_)return V;const K=_.getResourceGroup(V.groupHandle);return K?K.getResourceState(V.handle):V}else if(V&&V.$mid===4){const _=this.g.get(V.sourceControlHandle);return _?_.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const _=this.g.get(V.handle);return _||V}return V}})}createSourceControl(m,P,T,V){this.m.trace("ExtHostSCM#createSourceControl",m.identifier.value,P,T,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const _=on.d++,K=new p(m,this.e,this.l,P,T,V);this.g.set(_,K);const A=this.h.get(w.ExtensionIdentifier.toKey(m.identifier))||[];return A.push(K),this.h.set(w.ExtensionIdentifier.toKey(m.identifier),A),K}getLastInputBox(m){this.m.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const P=this.h.get(w.ExtensionIdentifier.toKey(m.identifier)),T=P&&P[P.length-1];return T&&T.inputBox}$provideOriginalResource(m,P,T){const V=i.URI.revive(P);this.m.trace("ExtHostSCM#$provideOriginalResource",m,V.toString());const _=this.g.get(m);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(V,T)).then(K=>K||null)}$onInputBoxValueChange(m,P){this.m.trace("ExtHostSCM#$onInputBoxValueChange",m);const T=this.g.get(m);return T&&T.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(m,P,T,V){this.m.trace("ExtHostSCM#$executeResourceCommand",m,P,T);const _=this.g.get(m);if(!_)return Promise.resolve(void 0);const K=_.getResourceGroup(P);return K?K.$executeResourceCommand(T,V):Promise.resolve(void 0)}$validateInput(m,P,T){this.m.trace("ExtHostSCM#$validateInput",m);const V=this.g.get(m);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>V.inputBox.validateInput(P,T)).then(_=>{if(!_)return Promise.resolve(void 0);const K=b.MarkdownString.fromStrict(_.message);return K?Promise.resolve([K,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this.g.get(m)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=m,Promise.resolve(void 0)}};o.d=0,o=Ke([je(2,N.ILogService)],o),e.ExtHostSCM=o}),define(ke[79],Te([1,0,5,4,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(O){this.b=new C.Emitter,this.onDidChangePassword=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,S){return this.a.$getPassword(O,S)}store(O,S,k){return this.a.$setPassword(O,S,k)}delete(O,S){return this.a.$deletePassword(O,S)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[229],Te([1,0,7,5,142,6,8,9]),function(te,e,i,C,D,M,y,O){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(f,a,s,l,g=i.StatusBarAlignment.Left,E){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,S,f,"f"),Je(this,k,a,"f"),this.c=N.a++,this.e=s,this.f=l,this.g=g,this.h=this.u(E)}u(f){if(!!(0,O.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!N.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof f=="string"?this.r={fromApi:f,internal:Le(this,k,"f").toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:Le(this,k,"f").toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let a;this.m?a=this.m:a=(0,D.localize)(0,null,this.e.displayName||this.e.name);let s=this.n;this.o&&(s=N.b.get(this.o.id));const l=y.MarkdownString.fromStrict(this.l);Le(this,S,"f").$setEntry(this.c,f,a,this.k,l,this.r?.internal,s,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,k=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=N;class w{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const a={message:f};return this.b.unshift(a),this.c(),new i.Disposable(()=>{const s=this.b.indexOf(a);s>=0&&(this.b.splice(s,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class h{constructor(f,a){this.a=f.getProxy(C.MainContext.MainThreadStatusBar),this.b=a,this.c=new w(this)}createStatusBarEntry(f,a,s,l){return new N(this.a,this.b,f,a,s,l)}setStatusBarMessage(f,a){const s=this.c.setMessage(f);let l;return typeof a=="number"?l=setTimeout(()=>s.dispose(),a):typeof a<"u"&&a.then(()=>s.dispose(),()=>s.dispose()),new i.Disposable(()=>{s.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=h}),define(ke[80],Te([1,0,5,4,3]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(O,S){this.c=S,this.b=new C.Emitter,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(O,S){this.a.$registerExtensionStorageKeysToSync(O,S)}async initializeExtensionStorage(O,S,k){const N=await this.a.$initializeExtensionStorage(O,S);let w;return N&&(w=this.d(O,S,N)),w||k}setValue(O,S,k){return this.a.$setValue(O,S,k)}$acceptValue(O,S,k){const N=this.d(O,S,k);N&&this.b.fire({shared:O,key:S,value:N})}d(O,S,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${O}): ${N}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(ke[81],Te([1,0,3,27,11,60,2]),function(te,e,i,C,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let O=class{constructor(k,N,w){this.d=N,this.f=w,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(k){return y.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(y.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:y.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(k){if(this.c)return y.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return y.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};O=Ke([je(0,C.IExtHostInitDataService),je(1,D.ILogService),je(2,M.IExtHostConsumerFileSystem)],O),e.ExtensionStoragePaths=O}),define(ke[61],Te([1,0,4,5,3,2,18,6,7,144,12,170,21,34,171,38,9,17,8]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class E{constructor(o,c,m,P){this.k=o,this._id=c,this.l=m,this.m=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const T=this;this.value={get name(){return T.m||""},get processId(){return T.b},get creationOptions(){return T.l},get exitStatus(){return T.h},get state(){return T.j},sendText(V,_=!0){T.o(),T.k.$sendText(T._id,V,_)},show(V){T.o(),T.k.$show(T._id,V)},hide(){T.o(),T.k.$hide(T._id)},dispose(){T.a||(T.a=!0,T.k.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(o,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:o.name,shellPath:(0,s.withNullAsUndefined)(o.shellPath),shellArgs:(0,s.withNullAsUndefined)(o.shellArgs),cwd:(0,s.withNullAsUndefined)(o.cwd),env:(0,s.withNullAsUndefined)(o.env),icon:(0,s.withNullAsUndefined)(u(o.iconPath)),color:a.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,s.withNullAsUndefined)(o.message),strictEnv:(0,s.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,s.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,s.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,s.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this.n(o.location,c?.resolvedExtHostIdentifier),isTransient:(0,s.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,c,m,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:m,color:a.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.n(o,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(o,c){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in o?{viewColumn:g.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(o){this.m=o}setExitStatus(o,c){this.h=Object.freeze({code:o,reason:c})}setDimensions(o,c){return o===this.d&&c===this.g||o===0||c===0?!1:(this.d=o,this.g=c,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(o){this.f?(this.f(o),this.f=void 0):this.b.then(c=>{c!==o&&(this.b=Promise.resolve(o))})}}e.ExtHostTerminal=E;class L{get onProcessReady(){return this.b.event}constructor(o){this.g=o,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${c}`)}async start(){}shutdown(){this.g.close()}input(o){this.g.handleInput?.(o)}resize(o,c){this.g.setDimensions?.({columns:o,rows:c})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this.g.onDidWrite(c=>this.a.fire(c)),this.g.onDidClose?.((c=void 0)=>{this.f.fire(c===void 0?void 0:c)}),this.g.onDidOverrideDimensions?.(c=>{c&&this.d.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this.g.onDidChangeName?.(c=>{this.d.fire({type:"title",value:c})}),this.g.open(o||void 0),o&&this.g.setDimensions?.(o),this.b.fire({pid:-1,cwd:""})}}let v=1,t=class extends O.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(o=>o.value)}get onDidWriteTerminalData(){return this.I.event}constructor(o,c){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=c.getProxy(C.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(o),this.B({dispose:()=>{for(const[m,P]of this.g)P.shutdown(!0)}})}getDefaultShell(o){return(o?this.n:this.m)?.path||""}getDefaultShellArgs(o){return(o?this.n:this.m)?.args||[]}createExtensionTerminal(o,c){const m=new E(this.a,(0,b.generateUuid)(),o,o.name),P=new L(o.pty);return m.createExtensionTerminal(o.location,this.L(o,c).resolvedExtHostIdentifier,u(o.iconPath),n(o.color)).then(T=>{const V=this.M(T,P);this.h[T]=V}),this.f.push(m),m.value}L(o,c){if(c=c||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const m=o.location.parentTerminal;if(m){const P=this.f.find(T=>T.value===m);P&&(c.resolvedExtHostIdentifier=P._id)}}else o.location&&typeof o.location!="object"?c.location=o.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(o,c){if(!this.O(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const P=new L(c),T=this.M(o,P);this.h[o]=T}async $acceptActiveTerminalChanged(o){const c=this.b;if(o===null){this.b=void 0,c!==this.b&&this.F.fire(this.b);return}const m=this.O(o);m&&(this.b=m,c!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(o,c){const m=this.O(o);m&&this.I.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(o,c,m){const P=this.O(o);P&&P.setDimensions(c,m)&&this.G.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(o,c,m){this.g.get(o)?.resize(c,m)}async $acceptTerminalTitleChange(o,c){const m=this.O(o);m&&(m.name=c)}async $acceptTerminalClosed(o,c,m){const P=this.Q(this.f,o);if(P!==null){const T=this.f.splice(P,1)[0];T.setExitStatus(c,m),this.C.fire(T.value)}}$acceptTerminalOpened(o,c,m,P){if(c){const _=this.Q(this.f,c);if(_!==null){this.f[_]._id=o,this.D.fire(this.terminals[_]),this.f[_].isOpen=!0;return}}const T={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},V=new E(this.a,o,T,m);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(o,c){this.O(o)?._setProcessId(c)}async $startExtensionTerminal(o,c){const m=this.O(o);if(!m)return{message:(0,k.localize)(0,null,o)};m.isOpen||await new Promise(T=>{const V=this.onDidOpenTerminal(async _=>{_===m.value&&(V.dispose(),T())})});const P=this.g.get(o);P?P.startSendingEvents(c):this.j[o]={initialDimensions:c}}M(o,c){const m=new O.DisposableStore;m.add(c.onProcessReady(T=>this.a.$sendProcessReady(o,T.pid,T.cwd))),m.add(c.onDidChangeProperty(T=>this.a.$sendProcessProperty(o,T))),this.s.startBuffering(o,c.onProcessData),m.add(c.onProcessExit(T=>this.N(o,T))),this.g.set(o,c);const P=this.j[o];return P&&c instanceof L&&(c.startSendingEvents(P.initialDimensions),delete this.j[o]),m}$acceptProcessAckDataEvent(o,c){this.g.get(o)?.acknowledgeDataEvent(c)}$acceptProcessInput(o,c){this.g.get(o)?.input(c)}$acceptTerminalInteraction(o){const c=this.O(o);c?.setInteractedWith()&&this.H.fire(c.value)}$acceptProcessResize(o,c,m){try{this.g.get(o)?.resize(c,m)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(o,c){this.g.get(o)?.shutdown(c)}$acceptProcessRequestInitialCwd(o){this.g.get(o)?.getInitialCwd().then(c=>this.a.$sendProcessProperty(o,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(o){this.g.get(o)?.getCwd().then(c=>this.a.$sendProcessProperty(o,{type:"cwd",value:c}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this.u.add(o),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(o),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(o,c,m){if(this.v.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this.v.set(c,m),this.a.$registerProfileProvider(c,o.identifier.value),new S.Disposable(()=>{this.v.delete(c),this.a.$unregisterProfileProvider(c)})}registerTerminalQuickFixProvider(o,c,m){if(this.w.has(o))throw new Error(`Terminal quick fix provider "${o}" is already registered`);return this.w.set(o,m),this.a.$registerQuickFixProvider(o,c),new S.Disposable(()=>{this.w.delete(o),this.a.$unregisterQuickFixProvider(o)})}async $provideTerminalQuickFixes(o,c){const m=new h.CancellationTokenSource().token;if(m.isCancellationRequested)return;const P=this.w.get(o);if(!P)return;const T=await P.provideTerminalQuickFixes(c,m);if(T!==null)return T}async $createContributedProfileTerminal(o,c){const m=new h.CancellationTokenSource().token;let P=await this.v.get(o)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,c);return}this.createTerminalFromOptions(P.options,c)}}async $provideLinks(o,c){const m=this.O(o);if(!m)return[];this.y.delete(o),this.z.get(o)?.dispose(!0);const T=new h.CancellationTokenSource;this.z.set(o,T);const V=[],_={terminal:m.value,line:c},K=[];for(const R of this.u)K.push(l.Promises.withAsyncBody(async F=>{T.token.onCancellationRequested(()=>F({provider:R,links:[]}));const H=await R.provideTerminalLinks(_,T.token)||[];T.token.isCancellationRequested||F({provider:R,links:H})}));const A=await Promise.all(K);if(T.token.isCancellationRequested)return[];const U=new Map;for(const R of A)R&&R.links.length>0&&V.push(...R.links.map(F=>{const H={id:v++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return U.set(H.id,{provider:R.provider,link:F}),H}));return this.y.set(o,U),V}$activateLink(o,c){const m=this.y.get(o)?.get(c);!m||m.provider.handleTerminalLink(m.link)}N(o,c){this.s.stopBuffering(o),this.g.delete(o),delete this.j[o];const m=this.h[o];m&&(m.dispose(),delete this.h[o]),this.a.$sendProcessExit(o,c)}O(o){return this.P(this.f,o)}P(o,c){const m=this.Q(o,c);return m!==null?o[m]:null}Q(o,c){let m=null;return o.some((P,T)=>P._id===c?(m=T,!0):!1),m}getEnvironmentVariableCollection(o){let c=this.l.get(o.identifier.value);return c||(c=new d,this.S(o.identifier.value,c)),c}R(o,c){const m=(0,w.serializeEnvironmentVariableCollection)(c.map);this.a.$setEnvironmentVariableCollection(o,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(o){o.forEach(c=>{const m=c[0],P=new d(c[1]);this.S(m,P)})}$acceptDefaultProfile(o,c){const m=this.m;this.m=o,this.n=c,m?.path!==o.path&&this.J.fire(o.path)}S(o,c){this.l.set(o,c),c.onDidChangeCollection(()=>{this.R(o,c)})}};t=Ke([je(1,y.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class d{get persistent(){return this.a}set persistent(o){this.a=o,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(o){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(o)}get size(){return this.map.size}replace(o,c){this.d(o,{value:c,type:S.EnvironmentVariableMutatorType.Replace})}append(o,c){this.d(o,{value:c,type:S.EnvironmentVariableMutatorType.Append})}prepend(o,c){this.d(o,{value:c,type:S.EnvironmentVariableMutatorType.Prepend})}d(o,c){const m=this.map.get(o);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(o,c),this.b.fire())}get(o){return this.map.get(o)}forEach(o,c){this.map.forEach((m,P)=>o.call(c,P,m,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends t{constructor(o){super(!1,o)}createTerminal(o,c,m){throw new N.NotSupportedError}createTerminalFromOptions(o,c){throw new N.NotSupportedError}};r=Ke([je(0,y.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function u(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function n(p){return a.ThemeColor.isThemeColor(p)?p:void 0}});var Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i};define(ke[230],Te([1,0,16,17,23,21,4,194,231,6,22,9,34,5,18,101,8,7,45,72,56,26]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v){"use strict";var t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(R,F,H){this.j=H,this.c=new y.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=R.getProxy(b.MainContext.MainThreadTesting),this.h=new _(this.f),this.g=new o(this.f),F.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,ge=le.tests[le.tests.length-1].item.extId;return this.d.get(g.TestId.root(ge))?.collection.tree.get(ge)?.actual??(0,a.toItemFromContext)(j)}})}createTestController(R,F,H,j){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const le=new k.DisposableStore,ge=le.add(new a.ExtHostTestItemCollection(F,H,this.j));ge.root.label=H;const re=new Map,ae=this.f,ce={items:ge.root.children,get label(){return H},set label(x){H=x,ge.root.label=x,ae.$updateController(F,{label:H})},get refreshHandler(){return j},set refreshHandler(x){j=x,ae.$updateController(F,{canRefresh:!!x})},get id(){return F},createRunProfile:(x,X,J,de,ye,Ne)=>{let We=(0,S.hash)(x);for(;re.has(We);)We++;return Ne!==void 0&&(0,v.checkProposedApiEnabled)(R,"testContinuousRun"),new K(this.f,re,F,We,x,X,J,de,ye,Ne)},createTestItem(x,X,J){return new a.TestItemImpl(F,x,X,J)},createTestRun:(x,X,J=!0)=>this.g.createTestRun(F,ge,x,X,J),set resolveHandler(x){ge.resolveHandler=x},get resolveHandler(){return ge.resolveHandler},dispose:()=>{le.dispose()}};ae.$registerTestController(F,H,!!j),le.add((0,k.toDisposable)(()=>ae.$unregisterTestController(F)));const Se={controller:ce,collection:ge,profiles:re};return this.d.set(F,Se),le.add((0,k.toDisposable)(()=>this.d.delete(F))),le.add(ge.onDidGenerateDiff(x=>ae.$publishDiff(F,x.map(L.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.h.checkout()}async runTests(R,F=M.CancellationToken.None){const H=c(R);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(H.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(le=>g.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:A[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:R.exclude?.map(le=>le.id)},F)}$syncTests(){for(const{collection:R}of this.d.values())R.flushDiff();return Promise.resolve()}$provideFileCoverage(R,F,H){return(0,i.mapFind)(this.g.trackers,le=>le.id===R?le.getCoverage(F):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(R,F,H,j){return(0,i.mapFind)(this.g.trackers,ge=>ge.id===R?ge.getCoverage(F):void 0)?.resolveFileCoverage(H,j)??Promise.resolve([])}$configureRunProfile(R,F){this.d.get(R)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(R,F){await this.d.get(R)?.controller.refreshHandler?.(F)}$publishTestResults(R){this.results=Object.freeze(R.map(F=>(0,N.deepFreeze)(s.TestResults.to(F))).concat(this.results).sort((F,H)=>H.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(R,F){const H=this.d.get(g.TestId.fromString(R).controllerId)?.collection;H&&(await H.expand(R,F<0?1/0:F),H.flushDiff())}$acceptDiff(R){this.h.applyDiff(R.map(L.TestsDiffOp.deserialize))}async $runControllerTests(R,F){return Promise.all(R.map(H=>this.k(H,!1,F)))}async $startContinuousRun(R,F){const H=new M.CancellationTokenSource(F),j=await Promise.all(R.map(le=>this.k(le,!0,H.token)));return!F.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>F.onCancellationRequested(le)),H.dispose(!0),j}async k(R,F,H){const j=this.d.get(R.controllerId);if(!j)return{};const{collection:le,profiles:ge}=j,re=ge.get(R.profileId);if(!re)return{};const ae=R.testIds.map(X=>le.tree.get(X)).filter(w.isDefined),ce=R.excludeExtIds.map(X=>j.collection.tree.get(X)).filter(w.isDefined).filter(X=>ae.some(J=>J.fullId.compare(X.fullId)===2));if(!ae.length)return{};const Se=new l.TestRunRequest2(ae.some(X=>X.actual instanceof a.TestItemRootImpl)?void 0:ae.map(X=>X.actual),ce.map(X=>X.actual),re,F),x=(0,L.isStartControllerTests)(R)&&this.g.prepareForMainThreadTestRun(Se,m.fromInternal(R,j.collection),H);try{return await re.runHandler(Se,H),{}}catch(X){return{error:String(X)}}finally{x&&(x.hasRunningTasks&&!H.isCancellationRequested&&await y.Event.toPromise(x.onEnd),x.dispose())}}$cancelExtensionTestRun(R){R===void 0?this.g.cancelAllRuns():this.g.cancelRunById(R)}};r=Ke([je(0,f.IExtHostRpcService)],r),e.ExtHostTesting=r;const u=1e4;var n;(function(U){U[U.Running=0]="Running",U[U.Cancelling=1]="Cancelling",U[U.Ended=2]="Ended"})(n||(n={}));class p extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(R,F,H){super(),this.k=R,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new y.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource(H));const j=this.B(new C.RunOnceScheduler(()=>this.m(),u));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(R){return this.f.get(R)?.coverage}createRun(R){const F=this.k.id,H=this.k.controllerId,j=(0,h.generateUuid)(),le=new P(this.l,F,j),ge=Se=>(x,...X)=>{if(ae){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(x)||(this.s(x),Se(x,...X))},re=(Se,x)=>{const X=x instanceof Array?x.map(s.TestMessage.from):[s.TestMessage.from(x)];if(Se.uri&&Se.range){const J={range:s.Range.from(Se.range),uri:Se.uri};for(const de of X)de.location=de.location||J}this.l.$appendTestMessagesInRun(F,j,g.TestId.fromExtHostTestItem(Se,H).toString(),X)};let ae=!1;const ce={isPersisted:this.k.isPersisted,token:this.h.token,name:R,get coverageProvider(){return le.coverageProvider},set coverageProvider(Se){le.coverageProvider=Se},enqueued:ge(Se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(Se,H).toString(),1)}),skipped:ge(Se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(Se,H).toString(),5)}),started:ge(Se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(Se,H).toString(),2)}),errored:ge((Se,x,X)=>{re(Se,x),this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(Se,H).toString(),6,X)}),failed:ge((Se,x,X)=>{re(Se,x),this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(Se,H).toString(),4,X)}),passed:ge((Se,x)=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(Se,this.k.controllerId).toString(),3,x)}),appendOutput:(Se,x,X)=>{ae||(X&&(this.k.isIncluded(X)?this.s(X):X=void 0),this.l.$appendOutputToRun(F,j,D.VSBuffer.fromString(Se),x&&s.location.from(x),X&&g.TestId.fromExtHostTestItem(X,H).toString()))},end:()=>{ae||(ae=!0,this.l.$finishedTestRunTask(F,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ce,coverage:le}),this.l.$startedTestRunTask(F,{id:j,name:R,running:!0}),ce}m(){for(const{run:R}of this.f.values())R.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(R){if(!(R instanceof a.TestItemImpl))throw new E.InvalidTestItemError(R.id);if(this.g.has(g.TestId.fromExtHostTestItem(R,this.k.controllerId).toString()))return;const F=[],H=this.k.colllection.root;for(;;){const j=s.TestItem.from(R);if(F.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),R===H))break;R=R.parent||H}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class o{get trackers(){return this.c.values()}constructor(R){this.d=R,this.c=new Map}prepareForMainThreadTestRun(R,F,H){return this.f(R,F,H)}cancelRunById(R){for(const F of this.c.values())if(F.id===R){F.cancel();return}}cancelAllRuns(){for(const R of this.c.values())R.cancel()}createTestRun(R,F,H,j,le){const ge=this.c.get(H);if(ge)return ge.createRun(j);const re=m.fromPublic(R,F,H,le),ae=c(H);this.d.$startedExtensionTestRun({controllerId:R,continuous:!!H.continuous,profile:ae&&{group:A[ae.kind],id:ae.profileId},exclude:H.exclude?.map(Se=>g.TestId.fromExtHostTestItem(Se,F.root.id).toString())??[],id:re.id,include:H.include?.map(Se=>g.TestId.fromExtHostTestItem(Se,F.root.id).toString())??[F.root.id],persist:le});const ce=this.f(H,re);return ce.onEnd(()=>{this.d.$finishedExtensionTestRun(re.id),ce.dispose()}),ce.createRun(j)}f(R,F,H){const j=new p(F,this.d,H);return this.c.set(R,j),j.onEnd(()=>this.c.delete(R)),j}}e.TestRunCoordinator=o;const c=U=>{if(!!U.profile){if(!(U.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class m{static fromPublic(R,F,H,j){return new m(R,(0,h.generateUuid)(),H.include?.map(le=>g.TestId.fromExtHostTestItem(le,R).toString())??[R],H.exclude?.map(le=>g.TestId.fromExtHostTestItem(le,R).toString())??[],j,F)}static fromInternal(R,F){return new m(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,F)}constructor(R,F,H,j,le,ge){this.controllerId=R,this.id=F,this.isPersisted=le,this.colllection=ge,this.c=H.map(re=>re+"\0"),this.d=j.map(re=>re+"\0")}isIncluded(R){const F=g.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const H of this.d)if(F===H||F.startsWith(H))return!1;for(const H of this.c)if(F===H||F.startsWith(H))return!0;return!1}}e.TestRunDto=m;class P{set coverageProvider(R){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this.c=R,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(R,F,H){this.f=R,this.g=F,this.h=H}async provideFileCoverage(R){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(R))());try{return(await this.d)?.map(s.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(R,F){const H=await this.d;let j=H?.[R];return!this.c||!H||!j?[]:(j.detailedCoverage||(j=H[R]=await this.c.resolveFileCoverage?.(j,F)??j),j.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class T{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(R){this.h=R,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(R){this.c.add(R)}update(R){Object.assign(R.revived,s.TestItem.toPlain(R.item)),this.c.has(R)||this.d.add(R)}remove(R){if(this.c.has(R)){this.c.delete(R);return}this.d.delete(R);const F=g.TestId.parentId(R.item.extId);if(F&&this.g.has(F.toString())){this.g.add(R.item.extId);return}this.f.add(R)}getChangeEvent(){const{c:R,d:F,f:H}=this;return{get added(){return[...R].map(j=>j.revived)},get updated(){return[...F].map(j=>j.revived)},get removed(){return[...H].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class V extends L.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new y.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(R){return this.d.get(R)}getMirroredTestDataByReference(R){return this.d.get(R.id)}p(R,F){return{...R,revived:s.TestItem.toPlain(R.item),depth:F?F.depth+1:0,children:new Set}}o(){return new T(this.q)}}class _{constructor(R){this.d=R}checkout(){this.c||(this.c=this.f());const R=this.c;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(F=>F.revived)},dispose:(0,O.once)(()=>{--R.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(R){return this.c?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.c?.tests.apply(R)}f(){const R=new V;return this.d.$subscribeToDiffs(),{observers:0,tests:R}}}class K{get label(){return this.d}set label(R){R!==this.d&&(this.d=R,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(R){R!==this.g&&(this.g=R,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:R}))}get isDefault(){return this.f}set isDefault(R){R!==this.f&&(this.f=R,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?s.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this.c}set configureHandler(R){R!==this.c&&(this.c=R,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}constructor(R,F,H,j,le,ge,re,ae=!1,ce=void 0,Se=!1){this.controllerId=H,this.profileId=j,this.d=le,this.kind=ge,this.runHandler=re,this.f=ae,this._tag=ce,this.g=Se,t.set(this,void 0),d.set(this,void 0),Je(this,t,R,"f"),Je(this,d,F,"f"),F.set(j,this);const x=A[ge];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${ge}`);Le(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:H,tag:ce?s.TestTag.namespace(this.controllerId,ce.id):null,label:le,group:x,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:Se})}dispose(){Le(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Le(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=K,t=new WeakMap,d=new WeakMap;const A={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(ke[232],Te([1,0,16,4,5,102,8,7]),function(te,e,i,C,D,M,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(N,w){this.i=w,this.a=new C.Emitter,this.b=new C.Emitter,this.c=new C.Emitter,this.d=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(h=>this.g.fire(h)),this.i.onDidChangeActiveTextEditor(h=>this.f.fire(h))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const w=this.i.allEditors();return N?w:w.map(h=>h.value)}async showTextDocument(N,w,h){let b;typeof w=="number"?b={position:y.ViewColumn.from(w),preserveFocus:h}:typeof w=="object"?b={position:y.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?y.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(N.uri,b),a=f&&this.i.getEditor(f);if(a)return a.value;throw f?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,w){return new M.TextEditorDecorationType(this.h,N,w).value}$acceptEditorPropertiesChanged(N,w){const h=this.i.getEditor(N);if(!h)throw new Error("unknown text editor");if(w.options&&h._acceptOptions(w.options),w.selections){const b=w.selections.selections.map(y.Selection.to);h._acceptSelections(b)}if(w.visibleRanges){const b=i.coalesce(w.visibleRanges.map(y.Range.to));h._acceptVisibleRanges(b)}if(w.options&&this.b.fire({textEditor:h.value,options:{...w.options,lineNumbers:y.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const b=O.TextEditorSelectionChangeKind.fromValue(w.selections.source),f=w.selections.selections.map(y.Selection.to);this.a.fire({textEditor:h.value,selections:f,kind:b})}if(w.visibleRanges){const b=i.coalesce(w.visibleRanges.map(y.Range.to));this.c.fire({textEditor:h.value,visibleRanges:b})}}$acceptEditorPositionData(N){for(const w in N){const h=this.i.getEditor(w);if(!h)throw new Error("Unknown text editor");const b=y.ViewColumn.to(N[w]);h.value.viewColumn!==b&&(h._acceptViewColumn(b),this.d.fire({textEditor:h.value,viewColumn:b}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=S}),define(ke[233],Te([1,0,2,3,5,6,7,8,25,9]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class N{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(D.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(a,s)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&S.ExtensionIdentifier.equals(s,this.b.get(a.source)?.extension)){const l=a.uri===void 0?void 0:i.URI.revive(a.uri);return this.c.get(a.source)?.get(w(l))?.get(a.handle)}else return;return a}})}async $getTimeline(b,f,a,s){return this.b.get(b)?.provider.provideTimeline(i.URI.revive(f),a,s)}registerTimelineProvider(b,f,a,s){const l=new M.DisposableStore,g=this.d(f.id,s,l).bind(this);let E;f.onDidChange&&(E=f.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:f.id}),this));const L=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(v,t,d){t?.resetCache&&(l.clear(),L.get(f.id)?.clear());const r=await f.provideTimeline(v,t,d);if(r==null)return;const u=g(v,t);return{...r,source:f.id,items:r.items.map(u)}},dispose(){for(const v of L.values())v.get(f.id)?.clear();E?.dispose(),l.dispose()}},a)}d(b,f,a){return(s,l)=>{let g;if(l?.cacheResults){let E=this.c.get(b);E===void 0&&(E=new Map,this.c.set(b,E));const L=w(s);g=E.get(L),g===void 0&&(g=new Map,E.set(L,g))}return E=>{const{iconPath:L,...v}=E,t=`${b}|${E.id??E.timestamp}`;g?.set(t,E);let d,r,u;E.iconPath&&(L instanceof y.ThemeIcon?u={id:L.id,color:L.color}:i.URI.isUri(L)?(d=L,r=L):{light:d,dark:r}=L);let n;return y.MarkdownString.isMarkdownString(v.tooltip)?n=O.MarkdownString.from(v.tooltip):(0,k.isString)(v.tooltip)?n=v.tooltip:y.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=O.MarkdownString.from(v.detail)):(0,k.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=v.detail),{...v,id:v.id??void 0,handle:t,source:b,command:E.command?f.toInternal(E.command,a):void 0,icon:d,iconDark:r,themeIcon:u,tooltip:n,accessibilityInformation:E.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,M.toDisposable)(()=>{for(const s of this.c.values())s.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=N;function w(h){return h?.toString()}}),define(ke[234],Te([1,0,6,15,2,5]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this.c=new Map,this.b=S.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,N,w){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const h=w.schemes.find(b=>!y.a.has(b));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,w.schemes,S,w.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,N){const w=this.c.get(S);if(!w)throw new Error(`Unknown opener with id: ${S}`);const h=D.URI.revive(k);return w.canOpenExternalUri(h,N)}async $openUri(S,k,N){const w=this.c.get(S);if(!w)throw new Error(`Unknown opener id: '${S}'`);return w.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},N)}}y.a=new Set([C.Schemas.http,C.Schemas.https]),e.ExtHostUriOpeners=y}),define(ke[235],Te([1,0,5,2,6,12,25]),function(te,e,i,C,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class O{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,N){if(this.c.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const w=O.a++;return this.c.add(y.ExtensionIdentifier.toKey(k)),this.d.set(w,N),this.b.$registerUriHandler(w,k),(0,D.toDisposable)(()=>{this.c.delete(y.ExtensionIdentifier.toKey(k)),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(k,N){const w=this.d.get(k);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(N))}catch(h){(0,M.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(k){return C.URI.revive(await this.b.$createAppUri(k))}}O.a=0,e.ExtHostUrls=O});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[62],Te([1,0,4,15,22,2,157,180,73,5]),function(te,e,i,C,D,M,y,O,S,k){"use strict";var N,w,h,b,f,a,s,l,g,E,L,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(T,V,_,K,A,U,R){N.set(this,void 0),w.set(this,void 0),h.set(this,void 0),b.set(this,void 0),f.set(this,void 0),a.set(this,void 0),s.set(this,""),l.set(this,void 0),g.set(this,!1),E.set(this,!1),L.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new i.Emitter),this._onDidDispose=Le(this,t,"f").event,Je(this,N,T,"f"),Je(this,w,V,"f"),Je(this,l,_,"f"),Je(this,b,K,"f"),Je(this,f,A,"f"),Je(this,a,U,"f"),Je(this,L,r(U),"f"),Je(this,v,u(U),"f"),Je(this,h,R,"f")}dispose(){Je(this,g,!0,"f"),Le(this,t,"f").fire(),Le(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(T){return Je(this,E,!0,"f"),(0,S.asWebviewUri)(T,Le(this,b,"f"))}get cspSource(){const T=Le(this,a,"f").extensionLocation;if(T.scheme===C.Schemas.https||T.scheme===C.Schemas.http){let V=T.toString();return V.endsWith("/")||(V+="/"),V+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Le(this,s,"f")}set html(T){this.a(),Le(this,s,"f")!==T&&(Je(this,s,T,"f"),Le(this,v,"f")&&!Le(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(T)&&(Je(this,E,!0,"f"),Le(this,h,"f").report("Webview vscode-resource: uris",Le(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,w,"f").$setHtml(Le(this,N,"f"),this.b(T)))}get options(){return this.a(),Le(this,l,"f")}set options(T){this.a(),D.equals(Le(this,l,"f"),T)||Le(this,w,"f").$setOptions(Le(this,N,"f"),o(Le(this,a,"f"),Le(this,f,"f"),T)),Je(this,l,T,"f")}async postMessage(T){if(Le(this,g,"f"))return!1;const V=(0,O.serializeWebviewMessage)(T,{serializeBuffersForPostMessage:Le(this,L,"f")});return Le(this,w,"f").$postMessage(Le(this,N,"f"),V.message,...V.buffers)}a(){if(Le(this,g,"f"))throw new Error("Webview is disposed")}b(T){if(!Le(this,v,"f"))return T;const V=Le(this,a,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,_=Le(this,a,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Le(this,a,"f").extensionLocation.authority:void 0;return T.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,A,U,R,F,H)=>{const j=M.URI.from({scheme:R||"file",path:decodeURIComponent(F)}),le=(0,S.asWebviewUri)(j,{isRemote:V,authority:_}).toString();return`${A}${le}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,A,U,R,F,H)=>{const j=M.URI.from({scheme:R||"file",path:decodeURIComponent(F)}),le=(0,S.asWebviewUri)(j,{isRemote:V,authority:_}).toString();return`${A}${le}${H}`})}}e.ExtHostWebview=d,N=new WeakMap,w=new WeakMap,h=new WeakMap,b=new WeakMap,f=new WeakMap,a=new WeakMap,s=new WeakMap,l=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,v=new WeakMap,t=new WeakMap;function r(P){try{const T=(0,y.normalizeVersion)((0,y.parseVersion)(P.engines.vscode));return!!T&&T.majorBase>=1&&T.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function u(P){try{const T=(0,y.normalizeVersion)((0,y.parseVersion)(P.engines.vscode));return T?T.majorBase<1||T.majorBase===1&&T.minorBase<60:!1}catch{return!1}}class n{constructor(T,V,_,K,A){this.c=V,this.d=_,this.e=K,this.f=A,this.b=new Map,this.a=T.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(T,V,_){const K=this.g(T);if(K){const{message:A}=(0,O.deserializeWebviewMessage)(V,_.value);K._onMessageEmitter.fire(A)}}$onMissingCsp(T,V){this.e.warn(`${V} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(T,V,_){const K=new d(T,this.a,c(V),this.c,this.d,_,this.f);return this.b.set(T,K),K._onDidDispose(()=>{this.b.delete(T)}),K}deleteWebview(T){this.b.delete(T)}g(T){return this.b.get(T)}}e.ExtHostWebviews=n;function p(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=p;function o(P,T,V){return{enableCommandUris:V.enableCommandUris,enableScripts:V.enableScripts,enableForms:V.enableForms,portMapping:V.portMapping,localResourceRoots:V.localResourceRoots||m(P,T)}}e.serializeWebviewOptions=o;function c(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(T=>M.URI.from(T))}}function m(P,T){return[...(T?.getWorkspaceFolders()||[]).map(V=>V.uri),P.extensionLocation]}}),define(ke[236],Te([1,0,21,231,6,15,24,2,8,62,54,5,7]),function(te,e,i,C,D,M,y,O,S,k,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(d,r){this.document=d,this.b=r,this.a=1,this.c=new N.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,r){await this.f(d).undo(),r||this.disposeBackup()}async redo(d,r){await this.f(d).redo(),r||this.disposeBackup()}disposeEdits(d){for(const r of d)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=v(this.document.uri)+this.a++;return(0,y.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const r=this.c.get(d,0);if(!r)throw new Error("No edit found");return r}}class f{constructor(){this.a=new Map}get(d,r){return this.a.get(this.b(d,r))}add(d,r,u){const n=this.b(d,r.uri);if(this.a.has(n))throw new Error(`Document already exists for viewType:${d} resource:${r.uri}`);const p=new b(r,u);return this.a.set(n,p),p}delete(d,r){const u=this.b(d,r.uri);this.a.delete(u)}b(d,r){return`${d}@@@${r}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class s{constructor(){this.a=new Map}addTextProvider(d,r,u){return this.b(0,d,r,u)}addCustomProvider(d,r,u){return this.b(1,d,r,u)}get(d){return this.a.get(d)}b(d,r,u,n){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:d,extension:u,provider:n}),new h.Disposable(()=>this.a.delete(r))}}class l{constructor(d,r,u,n,p){this.d=r,this.f=u,this.g=n,this.h=p,this.b=new s,this.c=new f,this.a=d.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,r,u,n){const p=new D.DisposableStore;return E(u)?(p.add(this.b.addTextProvider(r,d,u)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(d),r,n.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(d))):(p.add(this.b.addCustomProvider(r,d,u)),g(u)&&p.add(u.onDidChangeCustomDocument(o=>{const c=this.i(r,o.document.uri);if(L(o)){const m=c.addEdit(o);this.a.$onDidEdit(o.document.uri,r,m,o.label)}else this.a.$onContentChange(o.document.uri,r)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(d),r,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(d))),h.Disposable.from(p,new h.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(d,r,u,n,p){const o=this.b.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${r}'`);const c=O.URI.revive(d),m=await o.provider.openCustomDocument(c,{backupId:u,untitledDocumentData:n?.buffer},p);let P;return g(o.provider)&&this.f&&(P=this.f.workspaceValue(o.extension)??this.f.globalValue(o.extension)),this.c.add(r,m,P),{editable:g(o.provider)}}async $disposeCustomDocument(d,r){const u=this.b.get(r);if(!u)throw new Error(`No provider found for '${r}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${r}'`);const n=O.URI.revive(d),{document:p}=this.i(r,n);this.c.delete(r,p),p.dispose()}async $resolveCustomEditor(d,r,u,n,p,o){const c=this.b.get(u);if(!c)throw new Error(`No provider found for '${u}'`);const m=S.ViewColumn.to(p),P=this.g.createNewWebview(r,n.contentOptions,c.extension),T=this.h.createNewWebviewPanel(r,u,n.title,m,n.options,P,!0),V=O.URI.revive(d);switch(c.type){case 1:{const{document:_}=this.i(u,V);return c.provider.resolveCustomEditor(_,T,o)}case 0:{const _=this.d.getDocument(V);return c.provider.resolveCustomTextEditor(_,T,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,r,u){this.i(r,d).disposeEdits(u)}async $onMoveCustomEditor(d,r,u){const n=this.b.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const p=this.h.getWebviewPanel(d);if(!p)throw new Error("No webview found");const o=O.URI.revive(r),c=this.d.getDocument(o);await n.provider.moveCustomTextEditor(c,p,i.CancellationToken.None)}async $undo(d,r,u,n){return this.i(r,d).undo(u,n)}async $redo(d,r,u,n){return this.i(r,d).redo(u,n)}async $revert(d,r,u){const n=this.i(r,d);await this.j(r).revertCustomDocument(n.document,u),n.disposeBackup()}async $onSave(d,r,u){const n=this.i(r,d);await this.j(r).saveCustomDocument(n.document,u),n.disposeBackup()}async $onSaveAs(d,r,u,n){const p=this.i(r,d);return this.j(r).saveCustomDocumentAs(p.document,O.URI.revive(u),n)}async $backup(d,r,u){const n=this.i(r,d),o=await this.j(r).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},u);return n.updateBackup(o),o.id}i(d,r){const u=this.c.get(d,O.URI.revive(r));if(!u)throw new Error("No custom document found");return u}j(d){const u=this.b.get(d)?.provider;if(!u||!g(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=l;function g(t){return!!t.onDidChangeCustomDocument}function E(t){return typeof t.resolveCustomTextEditor=="function"}function L(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function v(t){const d=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,C.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[237],Te([1,0,4,6,2,34,8,62,5,7]),function(te,e,i,C,D,M,y,O,S,k){"use strict";var N,w,h,b,f,a,s,l,g,E,L,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends C.Disposable{constructor(p,o,c,m){super(),N.set(this,void 0),w.set(this,void 0),h.set(this,void 0),b.set(this,void 0),f.set(this,void 0),a.set(this,void 0),s.set(this,void 0),l.set(this,void 0),g.set(this,!0),E.set(this,void 0),L.set(this,!1),v.set(this,this.B(new i.Emitter)),this.onDidDispose=Le(this,v,"f").event,t.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Le(this,t,"f").event,Je(this,N,p,"f"),Je(this,w,o,"f"),Je(this,b,c,"f"),Je(this,h,m.viewType,"f"),Je(this,f,m.panelOptions,"f"),Je(this,l,m.viewColumn,"f"),Je(this,a,m.title,"f"),Je(this,E,m.active,"f")}dispose(){Le(this,L,"f")||(Je(this,L,!0,"f"),Le(this,v,"f").fire(),Le(this,w,"f").$disposeWebview(Le(this,N,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,b,"f")}get viewType(){return this.c(),Le(this,h,"f")}get title(){return this.c(),Le(this,a,"f")}set title(p){this.c(),Le(this,a,"f")!==p&&(Je(this,a,p,"f"),Le(this,w,"f").$setTitle(Le(this,N,"f"),p))}get iconPath(){return this.c(),Le(this,s,"f")}set iconPath(p){this.c(),Le(this,s,"f")!==p&&(Je(this,s,p,"f"),Le(this,w,"f").$setIconPath(Le(this,N,"f"),D.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Le(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,l,"f")=="number"&&Le(this,l,"f")<0))return Le(this,l,"f")}get active(){return this.c(),Le(this,E,"f")}get visible(){return this.c(),Le(this,g,"f")}_updateViewState(p){Le(this,L,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(Je(this,E,p.active,"f"),Je(this,g,p.visible,"f"),Je(this,l,p.viewColumn,"f"),Le(this,t,"f").fire({webviewPanel:this}))}reveal(p,o){this.c(),Le(this,w,"f").$reveal(Le(this,N,"f"),{viewColumn:typeof p>"u"?void 0:y.ViewColumn.from(p),preserveFocus:!!o})}c(){if(Le(this,L,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,w=new WeakMap,h=new WeakMap,b=new WeakMap,f=new WeakMap,a=new WeakMap,s=new WeakMap,l=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,v=new WeakMap,t=new WeakMap;class r{static c(){return(0,M.generateUuid)()}constructor(p,o,c){this.g=o,this.h=c,this.e=new Map,this.f=new Map,this.d=p.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(p,o,c,m,P={}){const T=typeof m=="object"?m.viewColumn:m,V={viewColumn:y.ViewColumn.from(T),preserveFocus:typeof m=="object"&&!!m.preserveFocus},_=(0,O.shouldSerializeBuffersForPostMessage)(p),K=r.c();this.d.$createWebviewPanel((0,O.toExtensionData)(p),K,o,{title:c,panelOptions:u(P),webviewOptions:(0,O.serializeWebviewOptions)(p,this.h,P),serializeBuffersForPostMessage:_},V);const A=this.g.createNewWebview(K,P,p);return this.createNewWebviewPanel(K,o,c,T,P,A,!0)}$onDidChangeWebviewPanelViewStates(p){const o=Object.keys(p);o.sort((c,m)=>{const P=p[c],T=p[m];return P.active?1:T.active?-1:+P.visible-+T.visible});for(const c of o){const m=this.getWebviewPanel(c);if(!m)continue;const P=p[c];m._updateViewState({active:P.active,visible:P.visible,viewColumn:y.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.e.delete(p),this.g.deleteWebview(p)}registerWebviewPanelSerializer(p,o,c){if(this.f.has(o))throw new Error(`Serializer for '${o}' already registered`);return this.f.set(o,{serializer:c,extension:p}),this.d.$registerSerializer(o,{serializeBuffersForPostMessage:(0,O.shouldSerializeBuffersForPostMessage)(p)}),new k.Disposable(()=>{this.f.delete(o),this.d.$unregisterSerializer(o)})}async $deserializeWebviewPanel(p,o,c,m){const P=this.f.get(o);if(!P)throw new Error(`No serializer found for '${o}'`);const{serializer:T,extension:V}=P,_=this.g.createNewWebview(p,c.webviewOptions,V),K=this.createNewWebviewPanel(p,o,c.title,m,c.panelOptions,_,c.active);await T.deserializeWebviewPanel(K,c.state)}createNewWebviewPanel(p,o,c,m,P,T,V){const _=new d(p,this.d,T,{viewType:o,title:c,viewColumn:m,panelOptions:P,active:V});return this.e.set(p,_),_}getWebviewPanel(p){return this.e.get(p)}}e.ExtHostWebviewPanels=r;function u(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[238],Te([1,0,4,6,62,8,5,7]),function(te,e,i,C,D,M,y,O){"use strict";var S,k,N,w,h,b,f,a,s,l,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends C.Disposable{constructor(t,d,r,u,n,p){super(),S.set(this,void 0),k.set(this,void 0),N.set(this,void 0),w.set(this,void 0),h.set(this,!1),b.set(this,void 0),f.set(this,void 0),a.set(this,void 0),s.set(this,void 0),l.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Le(this,l,"f").event,g.set(this,this.B(new i.Emitter)),this.onDidDispose=Le(this,g,"f").event,Je(this,N,r,"f"),Je(this,f,u,"f"),Je(this,S,t,"f"),Je(this,k,d,"f"),Je(this,w,n,"f"),Je(this,b,p,"f")}dispose(){Le(this,h,"f")||(Je(this,h,!0,"f"),Le(this,g,"f").fire(),Le(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,f,"f")}set title(t){this.a(),Le(this,f,"f")!==t&&(Je(this,f,t,"f"),Le(this,k,"f").$setWebviewViewTitle(Le(this,S,"f"),t))}get description(){return this.a(),Le(this,a,"f")}set description(t){this.a(),Le(this,a,"f")!==t&&(Je(this,a,t,"f"),Le(this,k,"f").$setWebviewViewDescription(Le(this,S,"f"),t))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,w,"f")}get viewType(){return Le(this,N,"f")}_setVisible(t){t===Le(this,b,"f")||Le(this,h,"f")||(Je(this,b,t,"f"),Le(this,l,"f").fire())}get badge(){return this.a(),Le(this,s,"f")}set badge(t){this.a(),!(t?.value===Le(this,s,"f")?.value&&t?.tooltip===Le(this,s,"f")?.tooltip)&&(Je(this,s,M.ViewBadge.from(t),"f"),Le(this,k,"f").$setWebviewViewBadge(Le(this,S,"f"),t))}show(t){this.a(),Le(this,k,"f").$show(Le(this,S,"f"),!!t)}a(){if(Le(this,h,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,N=new WeakMap,w=new WeakMap,h=new WeakMap,b=new WeakMap,f=new WeakMap,a=new WeakMap,s=new WeakMap,l=new WeakMap,g=new WeakMap;class L{constructor(t,d){this.d=d,this.b=new Map,this.c=new Map,this.a=t.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,r,u){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(t),d,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new O.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,r,u,n){const p=this.b.get(d);if(!p)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:c}=p,m=this.d.createNewWebview(t,{},c),P=new E(t,this.a,d,r,m,!0);this.c.set(t,P),await o.resolveWebviewView(P,{state:u},n)}async $onDidChangeWebviewViewVisibility(t,d){this.e(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.e(t);this.c.delete(t),d.dispose(),this.d.deleteWebview(t)}e(t){const d=this.c.get(t);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=L}),define(ke[104],Te([1,0,4,5,2,15,10,3,18]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class an{get state(){return this.d}constructor(w){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=w.getProxy(C.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,h){let b;if(typeof w=="string"){b=w;try{w=D.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,y.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,b,h)}async asExternalUri(w,h){if((0,y.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(w,h);return D.URI.from(b)}};k.a={focused:!0},k=Ke([je(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,O.createDecorator)("IExtHostWindow")}),define(ke[239],Te([1,0,209,27,18]),function(te,e,i,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends i.AbstractExtHostConsoleForwarder{constructor(O,S){super(O,S)}f(O,S,k){S.apply(console,k)}};M=Ke([je(0,D.IExtHostRpcService),je(1,C.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(ke[240],Te([1,0,17,23,21,12,4,6,127,203,46]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function h(P,T){try{return JSON.stringify(P,T)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class a{constructor(T,V){this.jsonString=T,this.referencedBuffers=V}}function s(P,T=null,V=!1){const _=[];return{jsonString:(V?h:JSON.stringify)(P,(A,U)=>{if(typeof U>"u")return f;if(typeof U=="object"){if(U instanceof C.VSBuffer){const R=_.push(U)-1;return{[b]:R}}if(T)return T(A,U)}return U}),referencedBuffers:_}}e.stringifyJsonWithBufferRefs=s;function l(P,T,V){return JSON.parse(P,(_,K)=>{if(K){const A=K[b];if(typeof A=="number")return T[A];if(V&&K.$mid===1)return V.transformIncoming(K)}return K})}e.parseJsonAndRestoreBufferRefs=l;function g(P,T){return JSON.stringify(P,T)}function E(P){return P?(T,V)=>V&&V.$mid===1?P.transformOutgoing(V):V:null}var L;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},d=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class u extends O.Disposable{constructor(T,V=null,_=null){super(),this[w]=!0,this.b=this.B(new y.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=V,this.g=_,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let K=0,A=N.ProxyIdentifier.count;K<A;K++)this.k[K]=null,this.l[K]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(K=>this.G(K))}dispose(){this.j=!0,Object.keys(this.s).forEach(T=>{this.s[T].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(T){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(T){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(T){this.t!==T&&(this.t=T,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(T){return this.g?(0,S.transformIncomingURIs)(T,this.g):T}getProxy(T){const{nid:V,sid:_}=T;return this.l[V]||(this.l[V]=this.F(V,_)),this.l[V]}F(T,V){const _={get:(K,A)=>(typeof A=="string"&&!K[A]&&A.charCodeAt(0)===36&&(K[A]=(...U)=>this.O(T,A,U)),A===r?V:K[A])};return new Proxy(Object.create(null),_)}set(T,V){return this.k[T.nid]=V,V}assertRegistered(T){for(let V=0,_=T.length;V<_;V++){const K=T[V];if(!this.k[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}G(T){if(this.j)return;const V=T.byteLength,_=n.read(T,0),K=_.readUInt8(),A=_.readUInt32();switch(K){case 1:case 2:{let{rpcId:U,method:R,args:F}=o.deserializeRequestJSONArgs(_);this.g&&(F=(0,S.transformIncomingURIs)(F,this.g)),this.H(V,A,U,R,F,K===2);break}case 3:case 4:{let{rpcId:U,method:R,args:F}=o.deserializeRequestMixedArgs(_);this.g&&(F=(0,S.transformIncomingURIs)(F,this.g)),this.H(V,A,U,R,F,K===4);break}case 5:{this.f?.logIncoming(V,A,0,"ack"),this.z(A);break}case 6:{this.I(V,A);break}case 7:{this.J(V,A,void 0);break}case 9:{let U=o.deserializeReplyOKJSON(_);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.J(V,A,U);break}case 10:{const U=o.deserializeReplyOKJSONWithBuffers(_,this.g);this.J(V,A,U);break}case 8:{const U=o.deserializeReplyOKVSBuffer(_);this.J(V,A,U);break}case 11:{let U=o.deserializeReplyErrError(_);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.L(V,A,U);break}case 12:{this.L(V,A,void 0);break}default:console.error("received unexpected message"),console.error(T)}}H(T,V,_,K,A,U){this.f?.logIncoming(T,V,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(_)}.${K}(`,A);const R=String(V);let F,H;if(U){const le=new D.CancellationTokenSource;A.push(le.token),F=this.M(_,K,A),H=()=>le.cancel()}else F=this.M(_,K,A),H=t;this.p[R]=H;const j=o.serializeAcknowledged(V);this.f?.logOutgoing(j.byteLength,V,1,"ack"),this.c.send(j),F.then(le=>{delete this.p[R];const ge=o.serializeReplyOK(V,le,this.h);this.f?.logOutgoing(ge.byteLength,V,1,"reply:",le),this.c.send(ge)},le=>{delete this.p[R];const ge=o.serializeReplyErr(V,le);this.f?.logOutgoing(ge.byteLength,V,1,"replyErr:",le),this.c.send(ge)})}I(T,V){this.f?.logIncoming(T,V,1,"receiveCancel");const _=String(V);this.p[_]?.()}J(T,V,_){this.f?.logIncoming(T,V,0,"receiveReply:",_);const K=String(V);if(!this.s.hasOwnProperty(K))return;const A=this.s[K];delete this.s[K],A.resolveOk(_)}L(T,V,_){this.f?.logIncoming(T,V,0,"receiveReplyErr:",_);const K=String(V);if(!this.s.hasOwnProperty(K))return;const A=this.s[K];delete this.s[K];let U;_&&(_.$isError?(U=new Error,U.name=_.name,U.message=_.message,U.stack=_.stack):U=_),A.resolveErr(U)}M(T,V,_){try{return Promise.resolve(this.N(T,V,_))}catch(K){return Promise.reject(K)}}N(T,V,_){const K=this.k[T];if(!K)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(T));const A=K[V];if(typeof A!="function")throw new Error("Unknown method "+V+" on actor "+(0,N.getStringIdentifierForProxy)(T));return A.apply(K,_)}O(T,V,_){if(this.j)return new k.CanceledLazyPromise;let K=null;if(_.length>0&&D.CancellationToken.isCancellationToken(_[_.length-1])&&(K=_.pop()),K&&K.isCancellationRequested)return Promise.reject(M.canceled());const A=o.serializeRequestArguments(_,this.h),U=++this.m,R=String(U),F=new k.LazyPromise;K&&K.onCancellationRequested(()=>{const j=o.serializeCancel(U);this.f?.logOutgoing(j.byteLength,U,0,"cancel"),this.c.send(o.serializeCancel(U))}),this.s[R]=F,this.y(U);const H=o.serializeRequest(U,T,V,A,!!K);return this.f?.logOutgoing(H.byteLength,U,0,`request: ${(0,N.getStringIdentifierForProxy)(T)}.${V}(`,_),this.c.send(H),F}}w=d,u.a=3*1e3,e.RPCProtocol=u;class n{static alloc(T,V,_){const K=new n(C.VSBuffer.alloc(_+1+4),0);return K.writeUInt8(T),K.writeUInt32(V),K}static read(T,V){return new n(T,V)}get buffer(){return this.a}constructor(T,V){this.a=T,this.b=V}static sizeUInt8(){return 1}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const _=this.a.slice(this.b,this.b+T).toString();return this.b+=T,_}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const _=this.a.slice(this.b,this.b+T).toString();return this.b+=T,_}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+T);return this.b+=T,V}static sizeMixedArray(T){let V=0;V+=1;for(let _=0,K=T.length;_<K;_++){const A=T[_];switch(V+=1,A.type){case 1:V+=this.sizeLongString(A.value);break;case 2:V+=this.sizeVSBuffer(A.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(A.value);for(let U=0;U<A.buffers.length;++U)V+=this.sizeVSBuffer(A.buffers[U]);break;case 4:break}}return V}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let V=0,_=T.length;V<_;V++){const K=T[V];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let A=0;A<K.buffers.length;++A)this.writeBuffer(K.buffers[A]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const V=new Array(T);for(let _=0;_<T;_++)switch(this.readUInt8()){case 1:V[_]=this.readLongString();break;case 2:V[_]=this.readVSBuffer();break;case 3:{const A=this.readUInt32(),U=this.readLongString(),R=[];for(let F=0;F<A;++F)R.push(this.readVSBuffer());V[_]=new N.SerializableObjectWithBuffers(l(U,R,null));break}case 4:V[_]=void 0;break}return V}}n.sizeUInt32=4;var p;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(p||(p={}));class o{static a(T){for(let V=0,_=T.length;V<_;V++)if(T[V]instanceof C.VSBuffer||T[V]instanceof N.SerializableObjectWithBuffers||typeof T[V]>"u")return!0;return!1}static serializeRequestArguments(T,V){if(this.a(T)){const _=[];for(let K=0,A=T.length;K<A;K++){const U=T[K];if(U instanceof C.VSBuffer)_[K]={type:2,value:U};else if(typeof U>"u")_[K]={type:4};else if(U instanceof N.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:F}=s(U.value,V);_[K]={type:3,value:C.VSBuffer.fromString(R),buffers:F}}else _[K]={type:1,value:C.VSBuffer.fromString(g(U,V))}}return{type:1,args:_}}return{type:0,args:g(T,V)}}static serializeRequest(T,V,_,K,A){switch(K.type){case 0:return this.b(T,V,_,K.args,A);case 1:return this.c(T,V,_,K.args,A)}}static b(T,V,_,K,A){const U=C.VSBuffer.fromString(_),R=C.VSBuffer.fromString(K);let F=0;F+=n.sizeUInt8(),F+=n.sizeShortString(U),F+=n.sizeLongString(R);const H=n.alloc(A?2:1,T,F);return H.writeUInt8(V),H.writeShortString(U),H.writeLongString(R),H.buffer}static deserializeRequestJSONArgs(T){const V=T.readUInt8(),_=T.readShortString(),K=T.readLongString();return{rpcId:V,method:_,args:JSON.parse(K)}}static c(T,V,_,K,A){const U=C.VSBuffer.fromString(_);let R=0;R+=n.sizeUInt8(),R+=n.sizeShortString(U),R+=n.sizeMixedArray(K);const F=n.alloc(A?4:3,T,R);return F.writeUInt8(V),F.writeShortString(U),F.writeMixedArray(K),F.buffer}static deserializeRequestMixedArgs(T){const V=T.readUInt8(),_=T.readShortString(),K=T.readMixedArray(),A=new Array(K.length);for(let U=0,R=K.length;U<R;U++){const F=K[U];typeof F=="string"?A[U]=JSON.parse(F):A[U]=F}return{rpcId:V,method:_,args:A}}static serializeAcknowledged(T){return n.alloc(5,T,0).buffer}static serializeCancel(T){return n.alloc(6,T,0).buffer}static serializeReplyOK(T,V,_){if(typeof V>"u")return this.d(T);if(V instanceof C.VSBuffer)return this.e(T,V);if(V instanceof N.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:A}=s(V.value,_,!0);return this.g(T,K,A)}else return this.f(T,h(V,_))}static d(T){return n.alloc(7,T,0).buffer}static e(T,V){let _=0;_+=n.sizeVSBuffer(V);const K=n.alloc(8,T,_);return K.writeVSBuffer(V),K.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,V){const _=C.VSBuffer.fromString(V);let K=0;K+=n.sizeLongString(_);const A=n.alloc(9,T,K);return A.writeLongString(_),A.buffer}static g(T,V,_){const K=C.VSBuffer.fromString(V);let A=0;A+=n.sizeUInt32,A+=n.sizeLongString(K);for(const R of _)A+=n.sizeVSBuffer(R);const U=n.alloc(10,T,A);U.writeUInt32(_.length),U.writeLongString(K);for(const R of _)U.writeBuffer(R);return U.buffer}static deserializeReplyOKJSON(T){const V=T.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(T,V){const _=T.readUInt32(),K=T.readLongString(),A=[];for(let U=0;U<_;++U)A.push(T.readVSBuffer());return new N.SerializableObjectWithBuffers(l(K,A,V))}static serializeReplyErr(T,V){const _=V?h(M.transformErrorForSerialization(V),null):void 0;if(typeof _!="string")return this.h(T);const K=C.VSBuffer.fromString(_);let A=0;A+=n.sizeLongString(K);const U=n.alloc(11,T,A);return U.writeLongString(K),U.buffer}static deserializeReplyErrError(T){const V=T.readLongString();return JSON.parse(V)}static h(T){return n.alloc(12,T,0).buffer}}var c;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var m;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(m||(m={}))}),define(ke[241],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(M){const y=O=>{self.removeEventListener("message",y);const S=O.data;Object.defineProperties(self,{postMessage:{value(k,N){S.postMessage(k,N)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",y)}.toString();class C extends EventTarget{constructor(M,y,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${i})('${y}'))`,k=new Blob([S],{type:"application/javascript"}),N=URL.createObjectURL(k),w=new MessageChannel,h=N,b={type:"_newWorker",id:h,port:w.port2,url:N,options:O};M(b,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{M({type:"_terminateWorker",id:h}),URL.revokeObjectURL(N),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(f){w.port1.onmessage=f}},onmessageerror:{get(){return w.port1.onmessageerror},set(f){w.port1.onmessageerror=f}}}),w.port1.addEventListener("messageerror",f=>{const a=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(a)}),w.port1.addEventListener("message",f=>{const a=new MessageEvent("message",{data:f.data});this.dispatchEvent(a)}),w.port1.start()}}e.NestedWorker=C}),define(ke[242],Te([1,0,4,30,42,3]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var y;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(N=>k.push(N)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}C.Registry.add(e.Extensions.OutputChannels,new O),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(ke[105],Te([1,0,5,3,18,25,11,242,60,27,36,121,23,9,43,4,6]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends y.AbstractMessageLogger{get disposed(){return this.l}constructor(v,t,d,r,u){super(),this.id=v,this.name=t,this.m=d,this.n=r,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(n=>this.setLevel(n)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Clear,v)}replace(v){const t=this.k;this.info(v),this.n.$update(this.id,O.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(v,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:t))}hide(){this.n.$close(this.id)}g(v,t){this.k+=h.VSBuffer.fromString(t).byteLength,(0,y.log)(this.m,v,t),this.visible&&(this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends l{appendLine(v){this.append(v)}}let E=class{constructor(v,t,d,r,u,n){this.i=t,this.j=d,this.k=r,this.l=u,this.m=n,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(v,t,d){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,u=(0,b.isString)(t)?t:void 0;if((0,b.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let n;const p=this.i.environment.extensionLogLevel?.find(([c])=>M.ExtensionIdentifier.equals(d.identifier,c))?.[1];p&&(n=(0,y.parseLogLevel)(p));const o=r?this.o(v,n,d):this.n(v,u,d);return o.then(c=>{this.g.set(c.id,c),c.visible=c.id===this.h}),r?this.r(v,n??this.m.getLevel(),o):this.q(v,o)}async n(v,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,u=this.k.extUri.joinPath(r,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(v,u,t,d.identifier.value);return new l(p,v,n,this.a,d)}async o(v,t,d){const r=await this.p(d),u=this.k.extUri.joinPath(r,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=u.toString(),p=this.l.createLogger(u,{id:n,name:v,logLevel:t,extensionId:d.identifier.value});return new g(n,v,p,this.a,d)}p(v){let t=this.d.get(v.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}return d})())}return t}q(v,t){let d=!1;const r=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return v},append(u){r(),t.then(n=>n.append(u))},appendLine(u){r(),t.then(n=>n.appendLine(u))},clear(){r(),t.then(u=>u.clear())},replace(u){r(),t.then(n=>n.replace(u))},show(u,n){r(),t.then(p=>p.show(u,n))},hide(){r(),t.then(u=>u.hide())},dispose(){d=!0,t.then(u=>u.dispose())}}}r(v,t,d){const r=new s.DisposableStore,u=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},n=r.add(new a.Emitter);function p(o){t=o,n.fire(o)}return d.then(o=>{r.add(o),o.logLevel!==t&&p(o.logLevel),r.add(o.onDidChangeLogLevel(c=>p(c)))}),{...this.q(v,d),get logLevel(){return t},onDidChangeLogLevel:n.event,trace(o,...c){u(),d.then(m=>m.trace(o,...c))},debug(o,...c){u(),d.then(m=>m.debug(o,...c))},info(o,...c){u(),d.then(m=>m.info(o,...c))},warn(o,...c){u(),d.then(m=>m.warn(o,...c))},error(o,...c){u(),d.then(m=>m.error(o,...c))},dispose(){r.dispose()}}}};E=Ke([je(0,D.IExtHostRpcService),je(1,k.IExtHostInitDataService),je(2,S.IExtHostConsumerFileSystem),je(3,N.IExtHostFileSystemInfo),je(4,y.ILoggerService),je(5,y.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(ke[243],Te([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(ke[244],Te([1,0,40,15,19,20,24,2,3,175,53,191,243]),function(te,e,i,C,D,M,y,O,S,k,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let b=class cn{constructor(a,s,l,g){this.d=a,this.e=s,this.f=l,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??a})()}hasValidBasename(a,s,l){return typeof s=="string"||typeof s>"u"?this.a.then(g=>this.h(a,g,s)):this.h(a,s,l)}h(a,s,l){return a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote?(0,i.isValidBasename)(l??(0,y.basename)(a),s===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,s){if(a.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(s.getWorkspace());if(l)return l;const g=s.getWorkspace().folders[0];if(g)return g.uri.scheme;const E=s.getWorkspace().configuration;return E?E.scheme:C.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?D.win32:D.posix)}async fileURI(a){let s="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const g=a.indexOf("/",2);g===-1?(s=a.substring(2),a="/"):(s=a.substring(2,g),a=a.substring(g)||"/")}return O.URI.from({scheme:C.Schemas.file,authority:s,path:a,query:"",fragment:""})}};b=Ke([je(1,h.IRemoteAgentService),je(2,w.IWorkbenchEnvironmentService),je(3,N.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(ke[106],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(y,O){this.line=y,this.character=O}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,O){return new i(0,0)}with(y){return new i(0,0)}}e.Position=i;class C{constructor(y,O,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(y,O),this.end=new i(S,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new C(0,0,0,0)}with(y){return new C(0,0,0,0)}}e.Range=C;var D;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ke[47],Te([1,0,16,35,22,40,10,3,19,12,106,17]),function(te,e,i,C,D,M,y,O,S,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",b=" characters skipped \u27EB",f=(h.length+b.length+5)*2;e.ISearchService=(0,O.createDecorator)("searchService");var a;(function(ae){ae[ae.file=0]="file",ae[ae.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(ae){ae[ae.File=1]="File",ae[ae.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function l(ae){return!!ae.preview}e.resultIsMatch=l;function g(ae){return!!ae.resource}e.isFileMatch=g;function E(ae){return!!ae.message}e.isProgressMessage=E;var L;(function(ae){ae[ae.Normal=0]="Normal",ae[ae.NewSearchStarted=1]="NewSearchStarted"})(L=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=v;class t{constructor(ce,Se,x){this.ranges=Se;const X=Array.isArray(Se)?Se:[Se];if(x&&x.matchLines===1&&d(X)){ce=(0,y.getNLines)(ce,x.matchLines);let J="",de=0,ye=0;const Ne=Math.floor(x.charsPerLine/5),We=[];for(const Pe of X){const Ce=Math.max(Pe.startColumn-Ne,0),we=Pe.startColumn+x.charsPerLine;if(Ce>ye+Ne+f){const se=h+(Ce-ye)+b;J+=se+ce.slice(Ce,we),de+=Ce-(ye+se.length)}else J+=ce.slice(ye,we);We.push(new u(0,Pe.startColumn-de,Pe.endColumn-de)),ye=we}this.preview={text:J,matches:Array.isArray(this.ranges)?We:We[0]}}else{const J=Array.isArray(Se)?Se[0].startLineNumber:Se.startLineNumber;this.preview={text:ce,matches:(0,i.mapArrayOrNot)(Se,de=>new r(de.startLineNumber-J,de.startColumn,de.endLineNumber-J,de.endColumn))}}}}e.TextSearchMatch=t;function d(ae){const ce=ae[0].startLineNumber;for(const Se of ae)if(Se.startLineNumber!==ce||Se.endLineNumber!==ce)return!1;return!0}class r{constructor(ce,Se,x,X){this.startLineNumber=ce,this.startColumn=Se,this.endLineNumber=x,this.endColumn=X}}e.SearchRange=r;class u extends r{constructor(ce,Se,x){super(ce,Se,ce,x)}}e.OneLineRange=u;var n;(function(ae){ae.List="list",ae.Tree="tree"})(n=e.ViewMode||(e.ViewMode={}));var p;(function(ae){ae.Default="default",ae.FileNames="fileNames",ae.Type="type",ae.Modified="modified",ae.CountDescending="countDescending",ae.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function o(ae,ce=!0){const Se=ae&&ae.files&&ae.files.exclude,x=ce&&ae&&ae.search&&ae.search.exclude;if(!Se&&!x)return;if(!Se||!x)return Se||x;let X=Object.create(null);return X=D.mixin(X,D.deepClone(Se)),X=D.mixin(X,D.deepClone(x),!0),X}e.getExcludes=o;function c(ae,ce){return ae.excludePattern&&C.match(ae.excludePattern,ce)?!1:ae.includePattern||ae.usingSearchPaths?ae.includePattern&&C.match(ae.includePattern,ce)?!0:ae.usingSearchPaths?!!ae.folderQueries&&ae.folderQueries.some(Se=>{const x=Se.folder.fsPath;if(M.isEqualOrParent(ce,x)){const X=S.relative(x,ce);return!Se.includePattern||!!C.match(Se.includePattern,X)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var m;(function(ae){ae[ae.unknownEncoding=1]="unknownEncoding",ae[ae.regexParseError=2]="regexParseError",ae[ae.globParseError=3]="globParseError",ae[ae.invalidLiteral=4]="invalidLiteral",ae[ae.rgProcessError=5]="rgProcessError",ae[ae.other=6]="other",ae[ae.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(ce,Se){super(ce),this.code=Se}}e.SearchError=P;function T(ae){const ce=ae.message;if((0,k.isCancellationError)(ae))return new P(ce,m.canceled);try{const Se=JSON.parse(ce);return new P(Se.message,Se.code)}catch{return new P(ce,m.other)}}e.deserializeSearchError=T;function V(ae){const ce={message:ae.message,code:ae.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=V;function _(ae){return ae.type==="error"?!0:ae.type==="success"}e.isSerializedSearchComplete=_;function K(ae){return ae.type==="success"}e.isSerializedSearchSuccess=K;function A(ae){return!!ae.path}e.isSerializedFileMatch=A;function U(ae,ce){const Se=ae.searchPath?ae.searchPath:ae.relativePath;return(0,y.fuzzyContains)(Se,ce)}e.isFilePatternMatch=U;class R{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function F(ae,ce){const Se={...ae||{},...ce||{}};return Object.keys(Se).filter(x=>{const X=Se[x];return typeof X=="boolean"&&X})}e.resolvePatternsForProvider=F;class H{constructor(ce,Se){this.c=null,this.a={...ce.excludePattern||{},...Se.excludePattern||{}},this.b=C.parse(this.a);let x=ce.includePattern;Se.includePattern&&(x?x={...x,...Se.includePattern}:x=Se.includePattern),x&&(this.c=C.parse(x))}matchesExcludesSync(ce,Se,x){return!!(this.b&&this.b(ce,Se,x))}includedInQuerySync(ce,Se,x){return!(this.b&&this.b(ce,Se,x)||this.c&&!this.c(ce,Se,x))}includedInQuery(ce,Se,x){const X=this.b(ce,Se,x),J=()=>this.c?!!this.c(ce,Se,x):!0;return(0,w.isThenable)(X)?X.then(de=>de?!1:J()):J()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=H;function j(ae){for(const ce in ae)if(typeof ae[ce]!="boolean")return!0;return!1}function le(ae){if(!ae)return;let ce;return Se=>(ce||(ce=(ae()||Promise.resolve([])).then(x=>x?re(x):{})),ce.then(x=>!!x[Se]))}e.hasSiblingPromiseFn=le;function ge(ae){if(!ae)return;let ce;return Se=>{if(!ce){const x=ae();ce=x?re(x):{}}return!!ce[Se]}}e.hasSiblingFn=ge;function re(ae){const ce={};for(const Se of ae)ce[Se]=!0;return ce}}),define(ke[31],Te([1,0,16,17,21,4,6,48,15,113,24,10,9,2,146,3,11,163,53,36,27,18,8,7,55,47,5]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v,t,d,r,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function p(K,A,U){return new N.ExtUri(R=>P(R,U)).isEqual(K,A)}function o(K,A,U){return p(K.uri,A.uri,U)?0:(0,w.compare)(K.uri.toString(),A.uri.toString())}function c(K,A,U){return K.index!==A.index?K.index<A.index?-1:1:p(K.uri,A.uri,U)?(0,w.compare)(K.name,A.name):(0,w.compare)(K.uri.toString(),A.uri.toString())}function m(K,A,U,R){const F=K.slice(0).sort((j,le)=>U(j,le,R)),H=A.slice(0).sort((j,le)=>U(j,le,R));return(0,i.delta)(F,H,(j,le)=>U(j,le,R))}function P(K,A){const U=A.getCapabilities(K.scheme);return!(U&&U&1024)}class T extends g.Workspace{static toExtHostWorkspace(A,U,R,F){if(!A)return{workspace:null,added:[],removed:[]};const{id:H,name:j,folders:le,configuration:ge,transient:re,isUntitled:ae}=A,ce=[],Se=U;U?le.forEach((de,ye)=>{const Ne=b.URI.revive(de.uri),We=T.o(R||U,Ne,F);We?(We.name=de.name,We.index=de.index,ce.push(We)):ce.push({uri:Ne,name:de.name,index:ye})}):ce.push(...le.map(({uri:de,name:ye,index:Ne})=>({uri:b.URI.revive(de),name:ye,index:Ne}))),ce.sort((de,ye)=>de.index<ye.index?-1:1);const x=new T(H,j,ce,!!re,ge?b.URI.revive(ge):null,!!ae,de=>P(de,F)),{added:X,removed:J}=m(Se?Se.workspaceFolders:[],x.workspaceFolders,o,F);return{workspace:x,added:X,removed:J}}static o(A,U,R){for(let F=0;F<A.folders.length;F++){const H=A.workspaceFolders[F];if(p(H.uri,U,R))return H}}constructor(A,U,R,F,H,j,le){super(A,R.map(ge=>new g.WorkspaceFolder(ge)),F,H,le),this.t=U,this.u=j,this.q=[],this.s=O.TernarySearchTree.forUris(le),R.forEach(ge=>{this.q.push(ge),this.s.set(ge.uri,ge)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(A,U){return U&&this.s.get(A)&&(A=(0,N.dirname)(A)),this.s.findSubstr(A)}resolveWorkspaceFolder(A){return this.s.get(A)}}let V=class{constructor(A,U,R,F,H){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=F,this.s=R,this.t=H,this.j=new k.Counter,this.k=new C.Barrier,this.o=A.getProxy(n.MainContext.MainThreadWorkspace),this.q=A.getProxy(n.MainContext.MainThreadMessageService);const j=U.workspace;this.l=j?new T(j.id,j.name,[],!!j.transient,j.configuration?b.URI.revive(j.configuration):null,!!j.isUntitled,le=>P(le,R)):void 0}$initializeWorkspace(A,U){this.v=U,this.$acceptWorkspaceData(A),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:S.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(A,U,R,...F){const H=[];if(Array.isArray(F)&&F.forEach(ae=>{b.URI.isUri(ae.uri)&&!H.some(ce=>p(ce.uri,ae.uri,this.s))&&H.push({uri:ae.uri,name:ae.name||(0,N.basenameOrAuthority)(ae.uri)})}),this.n||[U,R].some(ae=>typeof ae!="number"||ae<0)||R===0&&H.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(U+R>j.length)return!1;const le=j.slice(0);le.splice(U,R,...H.map(ae=>({uri:ae.uri,name:ae.name||(0,N.basenameOrAuthority)(ae.uri),index:void 0})));for(let ae=0;ae<le.length;ae++){const ce=le[ae];if(le.some((Se,x)=>x!==ae&&p(ce.uri,Se.uri,this.s)))return!1}le.forEach((ae,ce)=>ae.index=ce);const{added:ge,removed:re}=m(j,le,c,this.s);if(ge.length===0&&re.length===0)return!1;if(this.o){const ae=A.displayName||A.name;this.o.$updateWorkspaceFolders(ae,U,R,H).then(void 0,ce=>{this.n=void 0;const Se={source:{identifier:A.identifier,label:A.displayName||A.name}};this.q.$showMessage(l.Severity.Error,(0,f.localize)(0,null,ae,ce.toString()),Se,[])})}return this.y(le),!0}getWorkspaceFolder(A,U){if(!!this.x)return this.x.getWorkspaceFolder(A,U)}async getWorkspaceFolder2(A,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(A,U)}async resolveWorkspaceFolder(A){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(A)}getPath(){if(!this.x)return;const{folders:A}=this.x;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,U){let R,F="";if(typeof A=="string"?(R=b.URI.file(A),F=A):typeof A<"u"&&(R=A,F=A.fsPath),!R)return F;const H=this.getWorkspaceFolder(R,!0);if(!H)return F;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let j=(0,N.relativePath)(H.uri,R);return U&&H.name&&(j=`${H.name}/${j}`),j}y(A){this.x&&(this.n=T.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:A,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:U,added:R,removed:F}=T.toExtHostWorkspace(A,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:F}))}findFiles(A,U,R,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let j;if(U===null?j=!1:U&&(typeof U=="string"?j=U:j=U.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:ge}=_(t.GlobPattern.from(A));return this.o.$startFileSearch((0,h.withUndefinedAsNull)(le),(0,h.withUndefinedAsNull)(ge),(0,h.withUndefinedAsNull)(j),(0,h.withUndefinedAsNull)(R),H).then(re=>Array.isArray(re)?re.map(ae=>b.URI.revive(ae)):[])}async findTextInFiles(A,U,R,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),le=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ge,folder:re}=_(t.GlobPattern.from(U.include)),ae=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ce={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:le,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ge,excludePattern:ae},Se=!1;if(this.u[j]=x=>{if(Se)return;const X=b.URI.revive(x.resource);x.results.forEach(J=>{(0,u.resultIsMatch)(J)?R({uri:X,preview:{text:J.preview.text,matches:(0,i.mapArrayOrNot)(J.preview.matches,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,i.mapArrayOrNot)(J.ranges,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):R({uri:X,text:J.text,lineNumber:J.lineNumber})})},H.isCancellationRequested)return{};try{const x=await this.o.$startTextSearch(A,(0,h.withUndefinedAsNull)(re),ce,j,H);return delete this.u[j],x||{}}catch(x){throw delete this.u[j],x}}$handleTextSearchResult(A,U){this.u[U]?.(A)}saveAll(A){return this.o.$saveAll(A)}resolveProxy(A){return this.o.$resolveProxy(A)}get trusted(){return this.v}requestWorkspaceTrust(A){return this.o.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(A,U){if(this.w.has(A))throw new Error(`A provider has already been registered for scheme ${A}`);this.w.set(A,U);const R=this.t.transformOutgoingScheme(A),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,R),(0,y.toDisposable)(()=>{this.w.delete(A),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(A,U){this.h.info("Getting edit session identifier for workspaceFolder",A);const R=await this.resolveWorkspaceFolder(b.URI.revive(A));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const F=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!F),!F)return;const H=await F.provideEditSessionIdentity(R,U);if(this.h.info("Provider returned edit session identifier: ",H),!!H)return H}async $provideEditSessionIdentityMatch(A,U,R,F){this.h.info("Getting edit session identifier for workspaceFolder",A);const H=await this.resolveWorkspaceFolder(b.URI.revive(A));if(!H){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",H);const j=this.w.get(H.uri.scheme);if(this.h.info(`Provider for scheme ${H.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.(U,R,F);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(A){return(U,R,F)=>{const H=function(le){U.call(R,le)};return H.extension=A,this.A.event(H,void 0,F)}}async $onWillCreateEditSessionIdentity(A,U,R){const F=await this.resolveWorkspaceFolder(b.URI.revive(A));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},U,async(H,j)=>{const le=Date.now();await Promise.resolve(H),Date.now()-le>R&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),U.isCancellationRequested}};V=Ke([je(0,v.IExtHostRpcService),je(1,L.IExtHostInitDataService),je(2,E.IExtHostFileSystemInfo),je(3,s.ILogService),je(4,r.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function _(K){let A,U;return K&&(typeof K=="string"?A=K:(A=K.pattern,U=b.URI.revive(K.baseUri))),{includePattern:A,folder:U}}}),define(ke[32],Te([1,0,22,4,31,5,7,166,93,9,17,3,18,11,2]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(d,r){if(r){const u=r.split(".");let n=d;for(let p=0;n&&p<u.length;p++)n=n[u[p]];return n}}function s(d){return d instanceof f.URI}function l(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function g(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function E(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function L(d){if(s(d))return{resource:d};if(l(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(g(d))return{overrideIdentifier:d.languageId};if(E(d))return{resource:d.uri};if(d===null)return{resource:null}}let v=class{constructor(r,u,n){this.a=r.getProxy(M.MainContext.MainThreadConfiguration),this.c=u,this.b=n,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,u){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,u))}};v=Ke([je(0,h.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,b.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,u,n,p){this.a=new C.Emitter,this.b=r,this.f=p,this.c=u,this.e=O.Configuration.parse(n),this.d=this.k(n.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,u){const n={data:this.e.toData(),workspace:this.c.workspace};this.e=O.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(u,n))}getConfiguration(r,u,n){const p=L(u)||{},o=this.g(r?a(this.e.getValue(void 0,p,this.c.workspace),r):this.e.getValue(void 0,p,this.c.workspace));r&&this.h(r,p,n?.identifier);function c(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(P){return typeof a(o,P)<"u"},get:(P,T)=>{this.h(r?`${r}.${P}`:P,p,n?.identifier);let V=a(o,P);if(typeof V>"u")V=T;else{let _;const K=(A,U)=>{let R;const F=()=>{_=_||(0,i.deepClone)(o),R=R||a(_,U)};return(0,k.isObject)(A)?new Proxy(A,{get:(H,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return F(),()=>R;if(_)return R=R||a(_,U),R[j];const le=H[j];return typeof j=="string"?K(le,`${U}.${j}`):le},set:(H,j,le)=>(F(),R&&(R[j]=le),!0),deleteProperty:(H,j)=>(F(),R&&delete R[j],!0),defineProperty:(H,j,le)=>(F(),R&&Object.defineProperty(R,j,le),!0)}):A};V=K(V,P)}return V},update:(P,T,V,_)=>{P=r?`${r}.${P}`:P;const K=c(V);return T!==void 0?this.b.$updateConfigurationOption(K,P,T,p,_):this.b.$removeConfigurationOption(K,P,p,_)},inspect:P=>{P=r?`${r}.${P}`:P;const T=this.e.inspect(P,p,this.c.workspace);if(T)return{key:P,defaultValue:(0,i.deepClone)(T.policy?.value??T.default?.value),globalValue:(0,i.deepClone)(T.user?.value??T.application?.value),workspaceValue:(0,i.deepClone)(T.workspace?.value),workspaceFolderValue:(0,i.deepClone)(T.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(T.default?.override),globalLanguageValue:(0,i.deepClone)(T.user?.override??T.application?.override),workspaceLanguageValue:(0,i.deepClone)(T.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(T.workspaceFolder?.override),languageIds:(0,i.deepClone)(T.overrideIdentifiers)}}};return typeof o=="object"&&(0,i.mixin)(m,o,!1),Object.freeze(m)}g(r){const u=n=>(0,k.isObject)(n)?new Proxy(n,{get:(p,o)=>u(p[o]),set:(p,o,c)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(p,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(p,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return u(r)}h(r,u,n){const p=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),o=n?`[${n.value}] `:"";if(p===4){typeof u?.resource>"u"&&this.f.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){u?.resource&&this.f.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,u){const n=new O.ConfigurationChangeEvent(r,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,o)=>n.affectsConfiguration(p,L(o))})}k(r){return r.reduce((u,n)=>(u.set(n[0],n[1]),u),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[107],Te([1,0,2,17,4,5,7,31,58,32,21,61,18,27,3,15,20,11,76,202,12]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(A){function U(F){if(F!=null)return F}A.from=U;function R(F){if(F!=null)return F}A.to=R})(t||(t={}));var d;(function(A){function U(F){if(F!=null)return F}A.from=U;function R(F){if(F!=null)return F}A.to=R})(d||(d={}));var r;(function(A){function U(F){if(F!=null)return F}A.from=U;function R(F){if(F!=null)return F}A.to=R})(r||(r={}));var u;(function(A){function U(H){if(H){const j=H;return j&&!!j.process}else return!1}A.is=U;function R(H){if(H==null)return;const j={process:H.process,args:H.args};return H.options&&(j.options=r.from(H.options)),j}A.from=R;function F(H){if(H!=null)return new y.ProcessExecution(H.process,H.args,H.options)}A.to=F})(u||(u={}));var n;(function(A){function U(F){if(F!=null)return F}A.from=U;function R(F){if(F!=null)return F}A.to=R})(n||(n={}));var p;(function(A){function U(H){if(H){const j=H;return j&&(!!j.commandLine||!!j.command)}else return!1}A.is=U;function R(H){if(H==null)return;const j={};return H.commandLine!==void 0?j.commandLine=H.commandLine:(j.command=H.command,j.args=H.args),H.options&&(j.options=n.from(H.options)),j}A.from=R;function F(H){if(!(H==null||H.command===void 0&&H.commandLine===void 0))return H.commandLine?new y.ShellExecution(H.commandLine,H.options):new y.ShellExecution(H.command,H.args?H.args:[],H.options)}A.to=F})(p||(p={}));var o;(function(A){function U(H){if(H){const j=H;return j&&j.customExecution==="customExecution"}else return!1}A.is=U;function R(H){return{customExecution:"customExecution"}}A.from=R;function F(H,j){return j.get(H)}A.to=F})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var c;(function(A){function U(R,F){let H;return R.scope!==void 0&&typeof R.scope!="number"?H=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===y.TaskScope.Workspace&&F&&F.workspaceFile?H=F.workspaceFile:H=E.USER_TASKS_GROUP_KEY),{id:R._id,workspaceFolder:H}}A.from=U})(c=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(A){function U(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}A.from=U})(m||(m={}));var P;(function(A){function U(H,j){if(H==null)return[];const le=[];for(const ge of H){const re=R(ge,j);re&&le.push(re)}return le}A.fromMany=U;function R(H,j){if(H==null)return;let le;H.execution instanceof y.ProcessExecution?le=u.from(H.execution):H.execution instanceof y.ShellExecution?le=p.from(H.execution):H.execution&&H.execution instanceof y.CustomExecution&&(le=o.from(H.execution));const ge=t.from(H.definition);let re;return H.scope?typeof H.scope=="number"?re=H.scope:re=H.scope.uri:re=y.TaskScope.Workspace,!ge||!re?void 0:{_id:H._id,definition:ge,name:H.name,source:{extensionId:j.identifier.value,label:H.source,scope:re},execution:le,isBackground:H.isBackground,group:m.from(H.group),presentationOptions:d.from(H.presentationOptions),problemMatchers:H.problemMatchers,hasDefinedMatchers:H.hasDefinedMatchers,runOptions:H.runOptions?H.runOptions:{reevaluateOnRerun:!0},detail:H.detail}}A.from=R;async function F(H,j,le){if(H==null)return;let ge;u.is(H.execution)?ge=u.to(H.execution):p.is(H.execution)?ge=p.to(H.execution):o.is(H.execution)&&(ge=o.to(H._id,le));const re=t.to(H.definition);let ae;if(H.source&&(H.source.scope!==void 0?typeof H.source.scope=="number"?ae=H.source.scope:ae=await j.resolveWorkspaceFolder(i.URI.revive(H.source.scope)):ae=y.TaskScope.Workspace),!re||!ae)return;const ce=new y.Task(re,ae,H.name,H.source.label,ge,H.problemMatchers);return H.isBackground!==void 0&&(ce.isBackground=H.isBackground),H.group!==void 0&&(ce.group=y.TaskGroup.from(H.group._id),ce.group&&H.group.isDefault&&(ce.group=new y.TaskGroup(ce.group.id,ce.group.label),H.group.isDefault===!0&&(ce.group.isDefault=H.group.isDefault))),H.presentationOptions&&(ce.presentationOptions=d.to(H.presentationOptions)),H._id&&(ce._id=H._id),H.detail&&(ce.detail=H.detail),ce}A.to=F})(P=e.TaskDTO||(e.TaskDTO={}));var T;(function(A){function U(F){return F}A.from=U;function R(F){if(!!F)return Object.assign(Object.create(null),F)}A.to=R})(T||(T={}));class V{constructor(U,R,F){this._id=R,this.a=F,v.set(this,void 0),Je(this,v,U,"f")}get task(){return this.a}terminate(){Le(this,v,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}v=new WeakMap;let _=class{constructor(U,R,F,H,j,le,ge,re){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=U.getProxy(M.MainContext.MainThreadTask),this.b=F,this.c=H,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=re,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,R,F){if(!F)return new y.Disposable(()=>{});const H=this.w();return this.j.set(H,{type:R,provider:F,extension:U}),this.a.$registerTaskProvider(H,R),new y.Disposable(()=>{this.j.delete(H),this.a.$unregisterTaskProvider(H)})}registerTaskSystem(U,R){this.a.$registerTaskSystem(U,R)}fetchTasks(U){return this.a.$fetchTasks(T.from(U)).then(async R=>{const F=[];for(const H of R){const j=await P.to(H,this.b,this.m);j&&F.push(j)}return F})}get taskExecutions(){const U=[];return this.k.forEach(R=>U.push(R)),U}terminateTask(U){if(!(U instanceof V))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,R,F){const H=this.m.get(U.id);H&&(this.o.set(U.id,H),this.e.attachPtyToTerminal(R,await H.callback(F))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const R=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const R=await this.y(U.id);this.s.fire({execution:R,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const R=await this.y(U.id);this.t.fire({execution:R,exitCode:U.exitCode})}$provideTasks(U,R){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));const H=[],j=(0,C.asPromise)(()=>F.provider.provideTasks(N.CancellationToken.None)).then(le=>this.u(R,H,F,le));return new Promise(le=>{j.then(ge=>{Promise.all(H).then(()=>{le(ge)})})})}async $resolveTask(U,R){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));if(R.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${F.type}].`);const H=await P.to(R,this.b,this.m);if(!H)throw new Error("Unexpected: Task cannot be resolved.");const j=await F.provider.resolveTask(H,N.CancellationToken.None);if(!j)return;this.z(j,F);const le=P.from(j,F.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==H.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x(U,R,F){const H=await this.a.$createTaskId(U);!F&&!this.m.has(H)&&(this.n.add(H),this.o.set(H,R.execution)),this.m.set(H,R.execution)}async y(U,R){if(typeof U=="string"){const j=this.l.get(U);if(!j)throw new L.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const F=this.l.get(U.id);if(F)return F;const H=new Promise((j,le)=>{function ge(re,ae,ce){ce?j(new V(re,ae.id,ce)):le("Unexpected: Task does not exist.")}R?ge(this,U,R):P.to(U.task,this.b,this.m).then(re=>ge(this,U,re))});return this.l.set(U.id,H),H.then(j=>(this.k.set(U.id,j),j),j=>Promise.reject(j))}z(U,R){U._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const F=this.n.values();let H=F.next();for(;!H.done;)!this.o.has(H.value)&&this.p!==H.value&&(this.m.delete(H.value),this.n.delete(H.value)),H=F.next()}};_=Ke([je(0,h.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,O.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,w.IExtHostTerminalService),je(6,l.ILogService),je(7,g.IExtHostApiDeprecationService)],_),e.ExtHostTaskBase=_;let K=class extends _{constructor(U,R,F,H,j,le,ge,re){super(U,R,F,H,j,le,ge,re),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(0)})}async executeTask(U,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const F=P.from(R,U);if(F===void 0)throw new Error("Task is not valid");if(o.is(F.execution))await this.x(F,R,!1);else throw new L.NotSupportedError;const H=await this.y(await this.a.$getTaskExecution(F),R);return this.a.$executeTask(F).catch(j=>{throw new Error(j)}),H}u(U,R,F,H){const j=[];if(H)for(const le of H){this.z(le,F),(!le.definition||!U[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=P.from(le,F.extension);ge&&o.is(ge.execution)?(j.push(ge),R.push(this.x(ge,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:F.extension}}async v(U){if(o.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,R,F){}};K=Ke([je(0,h.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,O.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,w.IExtHostTerminalService),je(6,l.ILogService),je(7,g.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(ke[245],Te([1,0,19,21,39,35,24,77,47]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(h,b,f){this.k=h,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&M.parse(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&M.parse(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const b=this.k.folderQueries||[];return new Promise((f,a)=>{const s=l=>{this.f++,h(l)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const g=l.toString(),E=i.basename(g);this.j&&this.j(g,E)||this.v(s,{base:l,basename:E})}),Promise.all(b.map(l=>this.p(l,s))).then(l=>{f({limitHit:this.e,stats:l[0]||void 0})},l=>{a(new Error((0,D.toErrorMessage)(l)))})})}async p(h,b){const f=new C.CancellationTokenSource,a=this.q(h),s=this.r(),l=new S.QueryGlobTester(this.k,h),g=!l.hasSiblingExcludeClauses();let E;try{this.h.add(f),E=O.StopWatch.create();const L=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,f.token),v=E.elapsed(),t=O.StopWatch.create();return this.g&&!this.e||(L&&L.forEach(d=>{const r=i.posix.relative(h.folder.path,d.path);if(g){const u=i.basename(d.path);this.v(b,{base:h.folder,relativePath:r,basename:u});return}this.s(s,h.folder,r,b)}),this.g&&!this.e)?null:(this.u(s,l,b),{providerTime:v,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(h){const b=(0,S.resolvePatternsForProvider)(this.k.includePattern,h.includePattern),f=(0,S.resolvePatternsForProvider)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:f,includes:b,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},b,f,a){if(f===this.a){const l=i.basename(this.a);this.v(a,{base:b,relativePath:this.a,basename:l})}function s(l){const g=i.basename(l),E=i.dirname(l);let L=h[E];L||(L=h[E]=[],s(E)),L.push({base:b,relativePath:l,basename:g})}s(f)}u({rootEntries:h,pathToEntries:b},f,a){const s=this,l=this.a;function g(E){const L=(0,S.hasSiblingFn)(()=>E.map(v=>v.basename));for(let v=0,t=E.length;v<t;v++){const d=E[v],{relativePath:r,basename:u}=d;if(f.matchesExcludesSync(r,u,l!==u?L:void 0))continue;const n=b[r];if(n)g(n);else{if(r===l)continue;s.v(a,d)}if(s.e)break}}g(h)}v(h,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(b))}}class N{constructor(){this.b=new Map}fileSearch(h,b,f,a){const s=this.c(h.cacheKey),l=new k(h,b,s&&s.token);let g=0;const E=L=>{g+=L.length,f(L.map(v=>this.d(v)))};return this.e(l,N.a,E,a).then(L=>({limitHit:L.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:L.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(!!h)return this.b.has(h)||this.b.set(h,new C.CancellationTokenSource),this.b.get(h)}d(h){return h.relativePath?{resource:y.joinPath(h.base,h.relativePath)}:{resource:h.base}}e(h,b,f,a){a.onCancellationRequested(()=>{h.cancel()});const s=g=>{g&&(l.push(g),b>0&&l.length>=b&&(f(l),l=[]))};let l=[];return h.search(s).then(g=>(l.length&&f(l),g),g=>(l.length&&f(l),Promise.reject(g)))}}N.a=512,e.FileSearchManager=N}),define(ke[246],Te([1,0,16,63,35,87,28,15,19,24,10,9,2,262,155,41,11,53,97,244,47]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(P,T,V,_,K){this.a=P,this.b=T,this.c=V,this.d=_,this.e=K}text(P,T,V={}){P=this.f(P,V);const _=this.a.getValue(),K=T&&T.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(T?.map(l.toWorkspaceFolder),V),type:2,contentPattern:P,previewOptions:V.previewOptions,maxFileSize:V.maxFileSize,usePCRE2:_.search.usePCRE2||K||!1,beforeContext:V.beforeContext,afterContext:V.afterContext,userDisabledExcludesAndIgnoreFiles:V.disregardExcludeSettings&&V.disregardIgnoreFiles}}f(P,T){const V=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const _={...P,wordSeparators:V.editor.wordSeparators};return this.j(P,T)&&(_.isCaseSensitive=!0),this.k(P)&&(_.isMultiline=!0),_}file(P,T={}){return{...this.h(P,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}g(P,T){return P?(P=Array.isArray(P)?P.map(n):n(P),T?this.parseSearchPaths(P):{pattern:d(...Array.isArray(P)?P:[P])}):{}}h(P=[],T={}){const V=this.g(T.includePattern,T.expandPatterns),_=this.g(T.excludePattern,T.expandPatterns),K=P.length>1,A=(V.searchPaths&&V.searchPaths.length?V.searchPaths.map(F=>this.q(F,T,_)):P.map(F=>this.r(F,T,_,K))).filter(F=>!!F),U={_reason:T._reason,folderQueries:A,usingSearchPaths:!!(V.searchPaths&&V.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:_.pattern,includePattern:V.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const F=i.coalesce(i.flatten(this.c.groups.map(le=>le.editors.map(ge=>ge.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const H=F.filter(le=>(0,L.pathIncludedInQuery)(U,le.fsPath)),j=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...U,...j}}const R=T.extraFileResources&&T.extraFileResources.filter(F=>(0,L.pathIncludedInQuery)(U,F.fsPath));return U.extraFileResources=R&&R.length?R:void 0,U}i(P){const T=[],V=new y.ResourceMap,_={};let K=!1;return P.forEach(A=>{if(A.scheme===O.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(A)){const R=this.b.getWorkspaceFolder(A)?.uri??A.with({path:S.dirname(A.fsPath)});let F=V.get(R);F||(K=!0,F={folder:R,includePattern:{}},T.push(F),V.set(R,F));const H=S.relative(R.fsPath,A.fsPath);(0,w.assertIsDefined)(F.includePattern)[H.replace(/\\/g,"/")]=!0}else A.fsPath&&(K=!0,_[A.fsPath]=!0)}),{folderQueries:T,includePattern:_,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(P,T){if(T.isSmartCase){if(P.isRegExp){if(N.containsUppercaseCharacter(P.pattern,!0))return!0}else if(N.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,b.isMultilineRegexSource)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const T=j=>S.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),_=(Array.isArray(P)?P:r(P)).map(j=>{const le=this.e.resolvedUserHome;return le?(0,M.untildify)(j,le.scheme===O.Schemas.file?le.fsPath:le.path):j}),K=C.groupBy(_,j=>T(j)?"searchPaths":"exprSegments"),A=(K.exprSegments||[]).map(j=>N.rtrim(j,"/")).map(j=>N.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),u(j))),U={},R=this.m(K.searchPaths||[]);R&&R.length&&(U.searchPaths=R);const F=i.flatten(A),H=d(...F);return H&&(U.pattern=H),U}l(P,T){return T.disregardExcludeSettings?void 0:(0,L.getExcludes)(P,!T.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const T=P.flatMap(_=>{let{pathPortion:K,globPortion:A}=t(_);return A&&(A=p(A)),this.n(K).flatMap(R=>this.o(R,A))}),V=new Map;return T.forEach(_=>{const K=_.searchPath.toString(),A=V.get(K);A?_.pattern&&(A.pattern=A.pattern||{},A.pattern[_.pattern]=!0):V.set(K,{searchPath:_.searchPath,pattern:_.pattern?d(_.pattern):void 0})}),Array.from(V.values())}n(P){if(S.isAbsolute(P)){const T=this.b.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==O.Schemas.file?[{searchPath:T[0].uri.with({path:P})}]:[{searchPath:h.URI.file(S.normalize(P))}]}if(this.b.getWorkbenchState()===2){const T=this.b.getWorkspace().folders[0].uri;if(P=n(P),P.startsWith("../")||P===".."){const _=S.posix.resolve(T.path,P);return[{searchPath:T.with({path:_})}]}const V=p(P);return[{searchPath:T,pattern:V}]}else{if(P==="./"||P===".\\")return[];{const T=P.replace(/^\.[\/\\]/,""),_=this.b.getWorkspace().folders.map(K=>{const A=T.match(new RegExp(`^${N.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return A?{match:A,folder:K}:null}).filter(w.isDefined);if(_.length)return _.map(K=>{const A=K.match[1];return{searchPath:K.folder.uri,pattern:A&&p(A)}});{const K=P.match(/\.[\/\\](.+)[\/\\]?/),A=K?K[1]:P,U=f.localize(0,null,A);throw new Error(U)}}}}o(P,T){const V=P.pattern&&T?`${P.pattern}/${T}`:P.pattern||T,_=[{searchPath:P.searchPath,pattern:V}];return V&&!V.endsWith("**")&&_.push({searchPath:P.searchPath,pattern:V+"/**"}),_}q(P,T,V){const _=this.r((0,l.toWorkspaceFolder)(P.searchPath),T,V,!1);return _?{..._,includePattern:P.pattern}:null}r(P,T,V,_){let K;const A=h.URI.isUri(P)?P:P.uri;if(V.searchPaths){const j=V.searchPaths.filter(le=>(0,k.isEqual)(le.searchPath,A))[0];if(j&&!j.pattern)return null;j&&(K=j.pattern)}const U=this.a.getValue({resource:A}),F={...this.l(U,T)||{},...K||{}},H=h.URI.isUri(P)?(0,k.basename)(P):P.name;return{folder:A,folderName:_?H:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!U.search.followSymlinks}}};v=Ke([je(0,a.IConfigurationService),je(1,l.IWorkspaceContextService),je(2,g.IEditorGroupsService),je(3,s.ILogService),je(4,E.IPathService)],v),e.QueryBuilder=v;function t(m){const P=m.match(/[\*\{\}\(\)\[\]\?]/);if(P){const T=P.index,V=m.substr(0,T).match(/[/|\\][^/\\]*$/);if(V){let _=m.substr(0,V.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:m.substr((V.index||0)+1)}}}return{pathPortion:m}}function d(...m){return m.length?m.reduce((P,T)=>(P[T]=!0,P),Object.create(null)):void 0}function r(m){return D.splitGlobAware(m,",").map(P=>P.trim()).filter(P=>!!P.length)}function u(m){return[`**/${m}/**`,`**/${m}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function p(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(m){return m.replace(/([?*[\]])/g,"[$1]")}function c(m,P){m=i.distinct(m,_=>_.toString());const T=[],V=P.getWorkspace();return m&&m.forEach(_=>{let K;if(P.getWorkbenchState()===2)K=(0,k.relativePath)(V.folders[0].uri,_),K&&K!=="."&&(K="./"+K);else{const A=P.getWorkspaceFolder(_);if(A){const U=A.name;if(V.folders.filter(F=>F.name===U).length===1){const F=(0,k.relativePath)(A.uri,_);F===""?K=`./${A.name}`:K=`./${A.name}/${F}`}else K=_.fsPath}}K&&T.push(o(K))}),T}e.resolveResourcesForSearchIncludes=c}),define(ke[247],Te([1,0,24,2,21,12,3,246,47,53]),function(te,e,i,C,D,M,y,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function w(a,s){const l=s.activationEvents;if(!l)return Promise.resolve(void 0);const g=[],E=[];for(const u of l)if(/^workspaceContains:/.test(u)){const n=u.substr(18);n.indexOf("*")>=0||n.indexOf("?")>=0||a.forceUsingSearch?E.push(n):g.push(n)}if(g.length===0&&E.length===0)return Promise.resolve(void 0);let L;const v=new Promise((u,n)=>{L=u}),t=u=>L({activationEvent:u}),d=Promise.all(g.map(u=>h(a,u,t))).then(()=>{}),r=b(a,s.identifier,E,t);return Promise.all([d,r]).then(()=>{L(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function h(a,s,l){for(const g of a.folders)if(await a.exists(i.joinPath(C.URI.revive(g),s))){l(`workspaceContains:${s}`);return}}async function b(a,s,l,g){if(l.length===0)return Promise.resolve(void 0);const E=new D.CancellationTokenSource,L=a.checkExists(a.folders,l,E.token),v=setTimeout(async()=>{E.cancel(),a.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},N);let t=!1;try{t=await L}catch(d){M.isCancellationError(d)||M.onUnexpectedError(d)}E.dispose(),clearTimeout(v),t&&g(`workspaceContains:${l.join(",")}`)}function f(a,s,l,g){const E=a.get(y.IInstantiationService),L=a.get(S.ISearchService),t=E.createInstance(O.QueryBuilder).file(s.map(d=>(0,k.toWorkspaceFolder)(C.URI.revive(d))),{_reason:"checkExists",includePattern:l,exists:!0});return L.fileSearch(t,g).then(d=>!!d.limitHit,d=>M.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Le=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(ke[33],Te([1,0,140,19,82,24,17,6,48,2,11,5,32,192,80,31,26,98,12,25,23,177,7,94,3,27,81,18,68,70,61,4,247,79,179,15,78,77,20]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v,t,d,r,u,n,p,o,c,m,P,T,V,_,K,A,U,R){"use strict";var F,H,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let le=class Ui extends O.Disposable{constructor(x,X,J,de,ye,Ne,We,Pe,Ce,we,se){super(),this.a=this.B(new P.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=J,this.f=We,this.j=de,this.k=ye,this.l=Ne,this.m=Ce,this.p=we,this.s=se,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new y.Barrier,this.y=new y.Barrier,this.z=new y.Barrier,this.C=new y.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const ue=(0,s.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(ae(this.F,ue)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new V.ExtHostSecretState(this.g),this.I=Pe,this.h=x.createChild(new o.ServiceCollection([f.IExtHostStorage,this.G],[V.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(Z,I,$)=>{this.v.$onExtensionActivationError(Z,g.transformErrorForSerialization(I),$)},actualActivateExtension:async(Z,I)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(Z,this.D,this.F))return await this.v.$activateExtension(Z,I),new b.HostExtension;const $=this.D.getExtensionDescription(Z);return this.Y($,I)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.lb()}catch(x){g.onUnexpectedError(x)}}async Q(){this.I.onWillDeactivateAll();let x=[];try{x=this.D.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.X(ye))}catch{}await Promise.all(x)}terminate(x,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${x}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(de=>{this.l.error(de)}),this.g.dispose();const J=this.Q();Promise.race([(0,y.timeout)(5e3),J]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(x){return this.z.isOpen()?this.J.isActivated(x):!1}async getExtension(x){const X=await this.v.$getExtension(x);let J;if(X?.browserNlsBundleUris){J={};for(const de of Object.keys(X.browserNlsBundleUris))J[de]=k.URI.revive(X.browserNlsBundleUris[de])}return X&&{...X,identifier:new E.ExtensionIdentifier(X.identifier.value),extensionLocation:k.URI.revive(X.extensionLocation),browserNlsBundleUris:J}}R(x,X){return this.J.activateByEvent(x,X)}S(x,X){return this.J.activateById(x,X)}activateByIdWithErrors(x,X){return this.S(x,X).then(()=>{const J=this.J.getActivatedExtension(x);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(x=>this.D)}getExtensionExports(x){return this.z.isOpen()?this.J.getActivatedExtension(x).exports:null}async U(x){if(x.scheme!==K.Schemas.file)return x;const X=await this.c.realpath(x.fsPath);return k.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(x=>new ce(x))),this.L}async W(x){const X=S.TernarySearchTree.forUris(J=>M.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(x.map(async J=>{if(this.pb(J)){const de=await this.U(J.extensionLocation);X.set(de,J)}})),X}X(x){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(x))return X;const J=this.J.getActivatedExtension(x);if(!J)return X;try{typeof J.module.deactivate=="function"&&(X=Promise.resolve(J.module.deactivate()).then(void 0,de=>(this.l.error(de),Promise.resolve(void 0))))}catch(de){this.l.error(`An error occurred when deactivating the extension '${x.value}':`),this.l.error(de)}try{(0,O.dispose)(J.subscriptions)}catch(de){this.l.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.l.error(de)}return X}async Y(x,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(x.identifier):await this.v.$onWillActivateExtension(x.identifier),this.ab(x,X).then(J=>{const de=J.activationTimes;return this.v.$onDidActivateExtension(x.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,X),this.Z(x,X,"success",de),J},J=>{throw this.Z(x,X,"failure"),J})}Z(x,X,J,de){const ye=ge(x,X);this.u.$publicLog2("extensionActivationTimes",{...ye,...de||{},outcome:J})}ab(x,X){const J=ge(x,X);this.u.$publicLog2("activatePlugin",J);const de=this.pb(x);if(!de)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${x.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const ye=new b.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.qb(x,(0,M.joinPath)(x.extensionLocation,de),ye),this.bb(x)]).then(Ne=>(D.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Ui.cb(this.l,x.identifier,Ne[0],Ne[1],ye))).then(Ne=>(D.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Ne))}bb(x){const X=new v.ExtensionGlobalMemento(x,this.G),J=new v.ExtensionMemento(x.identifier.value,!1,this.G),de=new _.ExtensionSecrets(x,this.H),ye=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Ne=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([X.whenReady,J.whenReady,this.I.whenReady]).then(()=>{const We=this;let Pe,Ce;const we=(0,s.isProposedApiEnabled)(x,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(x.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:J,secrets:de,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(se){return C.join(x.extensionLocation.fsPath,se)},get storagePath(){return We.I.workspaceValue(x)?.fsPath},get globalStoragePath(){return We.I.globalValue(x).fsPath},get logPath(){return C.join(We.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return k.URI.joinPath(We.f.logsLocation,x.identifier.value)},get storageUri(){return We.I.workspaceValue(x)},get globalStorageUri(){return We.I.globalValue(x)},get extensionMode(){return ye},get extension(){return Pe===void 0&&(Pe=new re(We,x.identifier,x,Ne,!1)),Pe},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(x,"extensionRuntime"),We.extensionRuntime},get environmentVariableCollection(){return We.p.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!Ce){if(!we)return;const se=P.Event.buffer(P.Event.fromDOMEventEmitter(we,"message",ue=>ue.data));we.start(),Ce={onDidReceiveMessage:se,postMessage:we.postMessage.bind(we)}}return Ce}})})}static cb(x,X,J,de,ye){return J=J||{activate:void 0,deactivate:void 0},this.db(x,X,J,de,ye).then(Ne=>new b.ActivatedExtension(!1,null,ye.build(),J,Ne,de.subscriptions))}static db(x,X,J,de,ye){if(typeof J.activate=="function")try{ye.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${X.value}`);const Ne=typeof global=="object"?global:self,We=J.activate.apply(Ne,[de]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(We).then(Pe=>(ye.activateResolveStop(),Pe))}catch(Ne){return Promise.reject(Ne)}else return Promise.resolve(J)}eb(x,X){this.S(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:X}).then(void 0,J=>{this.l.error(J)})}fb(x,X=0){const de=Date.now();(0,R.setTimeout0)(()=>{for(let ye=X;ye<x.length;ye+=1){const Ne=x[ye];for(const We of Ne.activationEvents??[])if(We==="onStartupFinished")if(Date.now()-de>50){this.fb(x,ye);break}else this.eb(Ne,We)}})}gb(){this.v.$setPerformanceMarks(D.getMarks()),this.k.getConfigProvider().then(x=>{const X=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),J=this.D.getAllExtensionDescriptions();if(X)this.fb(J);else for(const de of J)if(de.activationEvents)for(const ye of de.activationEvents)ye==="onStartupFinished"&&this.eb(de,ye)})}hb(){const x=this.R("*",!0).then(void 0,ye=>{this.l.error(ye)});this.B(this.j.onDidChangeWorkspace(ye=>this.ib(ye.added)));const X=this.j.workspace?this.j.workspace.folders:[],J=this.ib(X),de=Promise.all([x,J]).then(()=>{});return Promise.race([de,(0,y.timeout)(1e4)]).then(()=>{this.gb()}),de}ib(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.jb(x,X))).then(()=>{})}async jb(x,X){if(this.isActivated(X.identifier))return;const J=!this.f.remote.isRemote&&!!this.f.remote.authority,de={logService:this.l,folders:x.map(Ne=>Ne.uri),forceUsingSearch:J,exists:Ne=>this.c.exists(Ne.fsPath),checkExists:(Ne,We,Pe)=>this.t.$checkExists(Ne,We,Pe)},ye=await(0,T.checkActivateWorkspaceContainsExtension)(de,X);if(!!ye)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:ye.activationEvent}).then(void 0,Ne=>this.l.error(Ne))}async $extensionTestsExecute(){await this.C.wait();try{return await this.kb()}catch(x){throw console.error(x),x}}async kb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:X}=this.f.environment;if(!x||!X)throw new Error(i.localize(0,null));const J=await this.qb(null,X,new b.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(i.localize(1,null,X.toString()));return new Promise((de,ye)=>{const Ne=(Ce,we)=>{Ce?ye(Ce):de(typeof we=="number"&&we>0?1:0)},We=(0,M.originalFSPath)(X),Pe=J.run(We,Ne);Pe&&Pe.then&&Pe.then(()=>{de(0)}).catch(Ce=>{ye(Ce instanceof Error&&Ce.stack?Ce.stack:String(Ce))})})}lb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.hb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,X){return this.M[x]=X,(0,O.toDisposable)(()=>{delete this.M[x]})}async mb(x){const X=x.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const J=x.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this.M[J]}}async $resolveAuthority(x,X){const J=U.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(x)},${X})][${J.elapsed()}ms] `,ye=we=>this.l.info(`${de()}${we}`),Ne=(we,se=void 0)=>this.l.error(`${de()}${we}`,se);ye("activating resolver...");const{authorityPrefix:We,resolver:Pe}=await this.mb(x);if(!Pe)return Ne("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${We}.`,detail:void 0}};const Ce=new y.IntervalTimer;try{ye("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Pe)),Ce.cancelAndSet(()=>ye("waiting..."),1e3),ye("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${We}`);const we=await Pe.resolve(x,{resolveAttempt:X});D.mark(`code/extHost/didResolveAuthorityOK/${We}`),Ce.dispose(),ye(`returned ${we.host}:${we.port}`);const se={authority:x,host:we.host,port:we.port,connectionToken:we.connectionToken},ue={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:ue,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(D.mark(`code/extHost/didResolveAuthorityError/${We}`),Ce.dispose(),Ne("returned an error",we),we instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(x,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(x)})`);const{resolver:J}=await this.mb(x);if(!J)return null;const de=k.URI.revive(X);if(typeof J.getCanonicalURI>"u")return de;const ye=await(0,y.asPromise)(()=>J.getCanonicalURI(de));return ye||de}static nb(x,X,J){const de=new l.ExtensionDescriptionRegistry(x.getAllExtensionDescriptions());de.deltaExtensions(J.toAdd,J.toRemove);const ye=(0,s.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(We=>We.identifier));for(const We of J.myToRemove)ye.delete(E.ExtensionIdentifier.toKey(We));for(const We of J.myToAdd)ye.add(E.ExtensionIdentifier.toKey(We));const Ne=ae(de,ye);return{globalRegistry:de,myExtensions:Ne}}$startExtensionHost(x){x.toAdd.forEach(de=>de.extensionLocation=k.URI.revive(de.extensionLocation));const{globalRegistry:X,myExtensions:J}=Ui.nb(this.F,this.D,x);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(J),this.lb()}$activateByEvent(x,X){return X===1?this.R(x,!1):this.z.wait().then(J=>this.R(x,!1))}async $activate(x,X){return await this.z.wait(),this.D.getExtensionDescription(x)?(await this.S(x,X),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Ne=>Ne.extensionLocation=k.URI.revive(Ne.extensionLocation));const{globalRegistry:X,myExtensions:J}=Ui.nb(this.F,this.D,x),de=await this.W(J);return(await this.getExtensionPathIndex()).setSearchTree(de),this.F.set(X.getAllExtensionDescriptions()),this.D.set(J),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const X=L.VSBuffer.alloc(x),J=Math.random()%256;for(let de=0;de<x;de++)X.writeUInt8(J,de);return X}async $updateRemoteConnectionData(x){this.P=x,this.a.fire()}};le=Ke([je(0,r.IInstantiationService),je(1,e.IHostUtils),je(2,p.IExtHostRpcService),je(3,a.IExtHostWorkspace),je(4,h.IExtHostConfiguration),je(5,N.ILogService),je(6,u.IExtHostInitDataService),je(7,n.IExtensionStoragePaths),je(8,c.IExtHostTunnelService),je(9,m.IExtHostTerminalService),je(10,A.IExtHostLocalizationService)],le),e.AbstractExtHostExtensionService=le;function ge(Se,x){return{id:Se.identifier.value,name:Se.name,extensionVersion:Se.version,publisherDisplayName:Se.publisher,activationEvents:Se.activationEvents?Se.activationEvents.join(","):null,isBuiltin:Se.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class re{constructor(x,X,J,de,ye){F.set(this,void 0),H.set(this,void 0),j.set(this,void 0),Je(this,F,x,"f"),Je(this,H,X,"f"),Je(this,j,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=C.normalize((0,M.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=de,this.isFromDifferentExtensionHost=ye}get isActive(){return Le(this,F,"f").isActivated(Le(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,F,"f").getExtensionExports(Le(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,F,"f").activateByIdWithErrors(Le(this,j,"f"),{startup:!1,extensionId:Le(this,H,"f"),activationEvent:"api"}),this.exports}}e.Extension=re,F=new WeakMap,H=new WeakMap,j=new WeakMap;function ae(Se,x){return Se.getAllExtensionDescriptions().filter(X=>x.has(E.ExtensionIdentifier.toKey(X.identifier)))}class ce{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.ExtensionPaths=ce}),define(ke[248],Te([1,0,82,2,5,32,26,25,18,27,3,33,51,11,10]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(v,t,d,r,u,n,p){this.c=v,this.d=t,this.e=d,this.f=r,this.g=u,this.h=n,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new l(this.c,t,this.d,v,this.i)),this.register(this.e.createInstance(g,t)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,t,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this.a.set(t,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(t=>v.alternativeModuleName(t))}};a=Ke([je(2,N.IInstantiationService),je(3,M.IExtHostConfiguration),je(4,w.IExtHostExtensionService),je(5,k.IExtHostInitDataService),je(6,b.ILogService)],a),e.RequireInterceptor=a;let s=class rn{constructor(v){if(v.environment.appRoot&&rn.a.size){const t=(0,f.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),d="[a-z0-9_.-]",r=`@${d}+\\/${d}+|${d}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${u}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const t=this.b.exec(this.c(v));if(!t)return;const[,d,r,u]=t,n=rn.a.get(r);if(n!==void 0)return console.warn(`${r} as been renamed to ${n}, please update your imports`),d+n+u}c(v){return v.replace(/\\/g,"/")}};s.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),s=Ke([je(0,k.IExtHostInitDataService)],s);class l{constructor(v,t,d,r,u){this.c=v,this.d=t,this.e=d,this.f=r,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(v,t){const d=this.d.findSubstr(t);if(d){let r=this.a.get(O.ExtensionIdentifier.toKey(d.identifier));return r||(r=this.c(d,this.e,this.f),this.a.set(O.ExtensionIdentifier.toKey(d.identifier),r)),r}if(!this.b){let r="";this.d.forEach((u,n)=>r+=`	${n} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(y.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(v,t,d){this.d=v,this.nodeModuleName="keytar",this.a=t.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=d,u=t.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let n=r.appRoot.fsPath;h.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.b=new Set,this.b.add(`${n}/node_modules.asar/keytar`),this.b.add(`${n}/node_modules/keytar`)}this.c={getPassword:(n,p)=>u.$getPassword(n,p),setPassword:(n,p,o)=>u.$setPassword(n,p,o),deletePassword:(n,p)=>u.$deletePassword(n,p),findPassword:n=>u.$findPassword(n),findCredentials(n){return u.$findCredentials(n)}}}load(v,t){const d=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const t=v.length;if(t<=7||!this.b)return;const d=t-7;if((v.charAt(d)==="/"||v.charAt(d)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};g=Ke([je(1,S.IExtHostRpcService),je(2,k.IExtHostInitDataService)],g);let E=class{constructor(v,t,d){this.e=v,this.f=t,this.nodeModuleName=["open","opn"],this.d=d.getProxy(D.MainContext.MainThreadTelemetry);const r=d.getProxy(D.MainContext.MainThreadWindow);this.c=(u,n)=>{const p=C.URI.parse(u);return n?this.g(u,n):p.scheme==="http"||p.scheme==="https"?r.$openUri(p,u,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?r.$openUri(p,u,{}):this.g(u,n)}}load(v,t,d){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=d(v),this.c}g(v,t){return this.i(),this.b(v,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=Ke([je(2,S.IExtHostRpcService)],E)}),define(ke[108],Te([1,0,85,6,19,51,3,58,59,33,7,31,189,32]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class f extends h.AbstractVariableResolverService{constructor(l,g,E,L,v,t,d){function r(){if(E){const u=E.activeEditor();if(u)return u.document.uri;const n=L.tabGroups.all.find(p=>p.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof N.TextDiffTabInput||n.input instanceof N.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof N.TextTabInput||n.input instanceof N.NotebookEditorTabInput||n.input instanceof N.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:u=>{const n=t.folders.filter(p=>p.name===u);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,n)=>v.getConfiguration(void 0,u).get(n),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=r();if(u)return D.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const u=r();if(u){const n=g.getWorkspaceFolder(u);if(n)return D.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(E){const u=E.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(E){const u=E.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>l.getExtension(u)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let a=class extends C.Disposable{constructor(l,g,E,L,v){super(),this.b=l,this.c=g,this.g=E,this.h=L,this.i=v,this.a=new i.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};a=Ke([je(0,k.IExtHostExtensionService),je(1,w.IExtHostWorkspace),je(2,O.IExtHostDocumentsAndEditors),je(3,b.IExtHostConfiguration),je(4,S.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(ke[109],Te([1,0,17,4,9,2,3,5,59,33,18,7,31,182,184,32,108]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,u,n,p,o,c){this.D=u,this.E=n,this.F=p,this.G=o,this.H=c,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new C.Emitter,this.n=new C.Emitter,this.o=new C.Emitter,this.u=new C.Emitter,this.k=r.getProxy(O.MainContext.MainThreadDebugService),this.z=new C.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(m=>{m.onDidChange(P=>{this.I(m)}),this.I(m)})}asDebugSourceUri(r,u){const n=r;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let p=`debug:${encodeURIComponent(n.path||"")}`,o="?";return u&&(p+=`${o}session=${encodeURIComponent(u.id)}`,o="&"),p+=`${o}ref=${n.sourceReference}`,M.URI.parse(p)}else{if(n.path)return M.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const u=[];for(const n of r.getAllExtensionDescriptions())if(n.contributes){const p=n.contributes.debuggers;if(p&&p.length>0)for(const o of p)(0,f.isDebuggerMainContribution)(o)&&u.push(o.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(u=>r.push(u)),r}addBreakpoints(r){this.T();const u=r.filter(o=>{const c=o.id;return this.w.has(c)?!1:(this.w.set(c,o),!0)});this.U(u,[],[]);const n=[],p=new Map;for(const o of u)if(o instanceof w.SourceBreakpoint){let c=p.get(o.location.uri.toString());c||(c={type:"sourceMulti",uri:o.location.uri,lines:[]},p.set(o.location.uri.toString(),c),n.push(c)),c.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof w.FunctionBreakpoint&&n.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(r){this.T();const u=r.filter(c=>this.w.delete(c.id));this.U([],u,[]);const n=u.filter(c=>c instanceof w.SourceBreakpoint).map(c=>c.id),p=u.filter(c=>c instanceof w.FunctionBreakpoint).map(c=>c.id),o=u.filter(c=>c instanceof w.DataBreakpoint).map(c=>c.id);return this.k.$unregisterBreakpoints(n,p,o)}startDebugging(r,u,n){return this.k.$startDebugging(r?r.uri:void 0,u,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,u,n){if(!u)return new w.Disposable(()=>{});const p=this.d++;return this.f.push({type:r,handle:p,provider:u}),this.k.$registerDebugConfigurationProvider(r,n,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,p),new w.Disposable(()=>{this.f=this.f.filter(o=>o.provider!==u),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(r,u,n){if(!n)return new w.Disposable(()=>{});if(!this.P(r,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:u,handle:p,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(u,p),new w.Disposable(()=>{this.h=this.h.filter(o=>o.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(r,u){if(!u)return new w.Disposable(()=>{});const n=this.i++;return this.j.push({type:r,handle:n,factory:u}),new w.Disposable(()=>{this.j=this.j.filter(p=>p.factory!==u)})}async $runInTerminal(r,u){return Promise.resolve(void 0)}async $substituteVariables(r,u){let n;const p=await this.W(r);return p&&(n={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(n,u)}J(r,u){if(r.type==="implementation")return new v(r.implementation)}K(){}async $startDASession(r,u){const n=this,p=await this.V(u);return this.R(this.M(p.type),p).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const c=this.L(o),m=this.J(c,p);if(!m)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const P=m;return this.A.set(r,P),this.Q(p).then(T=>(T&&this.B.set(r,T),P.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const _=V,K={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const A=await this.C.sign(_.arguments.value);K.body={signature:A},P.sendResponse(K)}else throw new Error("no signer")}catch(A){K.success=!1,K.message=A.message,P.sendResponse(K)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(V),V=(0,f.convertToVSCPaths)(V,!0),n.k.$acceptDAMessage(r,V)}),P.onError(V=>{T&&T.onError&&T.onError(V),this.k.$acceptDAError(r,V.name,V.message,V.stack)}),P.onExit(V=>{T&&T.onExit&&T.onExit((0,D.withNullAsUndefined)(V),void 0),this.k.$acceptDAExit(r,(0,D.withNullAsUndefined)(V),void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),P.startSession()))})}$sendDAMessage(r,u){u=(0,f.convertToDAPaths)(u,!1);const n=this.B.get(r);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(u),this.A.get(r)?.sendMessage(u)}$stopDASession(r){const u=this.B.get(r);this.B.delete(r),u&&u.onWillStopSession&&u.onWillStopSession();const n=this.A.get(r);return this.A.delete(r),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const u=[],n=[],p=[];if(r.added)for(const o of r.added){const c=o.id;if(c&&!this.w.has(c)){let m;if(o.type==="function")m=new w.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")m=new w.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const P=M.URI.revive(o.uri);m=new w.SourceBreakpoint(new w.Location(P,new w.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}(0,w.setBreakpointId)(m,c),this.w.set(c,m),u.push(m)}}if(r.removed)for(const o of r.removed){const c=this.w.get(o);c&&(this.w.delete(o),n.push(c))}if(r.changed){for(const o of r.changed)if(o.id){const c=this.w.get(o.id);if(c){if(c instanceof w.FunctionBreakpoint&&o.type==="function"){const m=c;m.enabled=o.enabled,m.condition=o.condition,m.hitCondition=o.hitCondition,m.logMessage=o.logMessage,m.functionName=o.functionName}else if(c instanceof w.SourceBreakpoint&&o.type==="source"){const m=c;m.enabled=o.enabled,m.condition=o.condition,m.hitCondition=o.hitCondition,m.logMessage=o.logMessage,m.location=new w.Location(M.URI.revive(o.uri),new w.Position(o.line,o.character))}p.push(c)}}}this.U(u,n,p)}$provideDebugConfigurations(r,u,n){return(0,i.asPromise)(async()=>{const p=this.O(r);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.W(u);return p.provideDebugConfigurations(o,n)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(r,u,n,p){return(0,i.asPromise)(async()=>{const o=this.O(r);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.W(u);return o.resolveDebugConfiguration(c,n,p)})}$resolveDebugConfigurationWithSubstitutedVariables(r,u,n,p){return(0,i.asPromise)(async()=>{const o=this.O(r);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.W(u);return o.resolveDebugConfigurationWithSubstitutedVariables(c,n,p)})}async $provideDebugAdapter(r,u){const n=this.N(r);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(u);return this.R(n,p).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.L(o)})}async $acceptDebugSessionStarted(r){const u=await this.V(r);this.m.fire(u)}async $acceptDebugSessionTerminated(r){const u=await this.V(r);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,u){(await this.V(r))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(r,u){const p={session:await this.V(r),event:u.event,body:u.body};this.u.fire(p)}L(r){if(r instanceof w.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof w.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const u=this.h.filter(n=>n.type===r);if(u.length>0)return u[0].factory}N(r){const u=this.h.filter(n=>n.handle===r);if(u.length>0)return u[0].factory}O(r){const u=this.f.filter(n=>n.handle===r);if(u.length>0)return u[0].provider}P(r,u){if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0){for(const p of n)if(p.label&&p.type&&p.type===u)return!0}}return!1}Q(r){const n=r.configuration.type,p=this.j.filter(o=>o.type===n||o.type==="*").map(o=>(0,i.asPromise)(()=>o.factory.createDebugAdapterTracker(r)).then(c=>c,c=>null));return Promise.race([Promise.all(p).then(o=>{const c=o.filter(m=>!!m);if(c.length>0)return new L(c)}),new Promise(o=>setTimeout(()=>o(void 0),1e3))]).catch(o=>{})}async R(r,u){const n=u.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new w.DebugAdapterServer(n));if(r){const o=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>r.createDebugAdapterDescriptor(u,this.S(u,o))).then(c=>{if(c)return c})}const p=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,p))}S(r,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,u,n){(r.length>0||u.length>0||n.length>0)&&this.z.fire(Object.freeze({added:r,removed:u,changed:n}))}async V(r){if(r)if(typeof r=="string"){const u=this.l.get(r);if(u)return u}else{let u=this.l.get(r.id);if(!u){const n=await this.W(r.folderUri),p=r.parent?this.l.get(r.parent):void 0;u=new g(this.k,r.id,r.type,r.name,n,r.configuration,p),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(r){if(r){const u=M.URI.revive(r);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};l=Ke([je(0,N.IExtHostRpcService),je(1,h.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,a.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,s.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class g{constructor(r,u,n,p,o,c,m){this.d=r,this.f=u,this.g=n,this.h=p,this.i=o,this.j=c,this.k=m}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,u){return this.d.$customDebugAdapterRequest(this.f,r,u)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=g;class E{constructor(r){this.value=Object.freeze({append(u){r.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=E;class L{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(u=>u.onError?u.onError(r):void 0)}onExit(r,u){this.d.forEach(n=>n.onExit?n.onExit(r,u):void 0)}}class v extends b.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends l{constructor(r,u,n,p,o,c){super(r,u,n,p,o,c)}};t=Ke([je(0,N.IExtHostRpcService),je(1,h.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,a.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,s.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(ke[249],Te([1,0,12,82,2,5,240,11,67,68,27,160,18,55,33,57]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class s{static async installEarlyHandler(E){const L=E.get(O.ILogService),t=E.get(h.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(d=>{L.error(d);const r=i.transformErrorForSerialization(d);t.$onUnexpectedError(r)})}static async installFullHandler(E){const L=E.get(O.ILogService),v=E.get(h.IExtHostRpcService),t=E.get(f.IExtHostExtensionService),d=E.get(a.IExtHostTelemetry),r=v.getProxy(M.MainContext.MainThreadExtensionService),u=v.getProxy(M.MainContext.MainThreadErrors),n=await t.getExtensionPathIndex(),p=new WeakMap;Error.prepareStackTrace=(o,c)=>{let m="",P,T;for(const V of c)m+=`
	at ${V.toString()}`,T=V.getFileName(),!P&&T&&(P=n.findSubstr(D.URI.file(T)));return p.set(o,P?.identifier),`${o.name||"Error"}: ${o.message||""}${m}`},i.setUnexpectedErrorHandler(o=>{L.error(o);const c=i.transformErrorForSerialization(o),m=p.get(o);if(!m){u.$onUnexpectedError(c);return}r.$onExtensionRuntimeError(m,c);const P=d.onExtensionError(m,o);L.trace("forwarded error to extension?",P,m)})}}Error.stackTraceLimit=100;class l{constructor(E,L,v,t,d){this.a=v,this.b=new y.RPCProtocol(E,null,t),L=l.e(L,this.b);const r=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...L,messagePorts:d}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this.b)),r.set(b.IURITransformerService,new b.URITransformerService(t)),r.set(f.IHostUtils,v);const u=new w.InstantiationService(r,!0);u.invokeFunction(s.installEarlyHandler),this.d=u.invokeFunction(n=>n.get(O.ILogService)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",L),this.c=u.invokeFunction(n=>n.get(f.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(s.installFullHandler)}async asBrowserUri(E){const L=this.b.getProxy(M.MainContext.MainThreadExtensionService);return D.URI.revive(await L.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,L){E.allExtensions.forEach(t=>{t.extensionLocation=D.URI.revive(L.transformIncomingURIs(t.extensionLocation));const d={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>d[r]=D.URI.revive(L.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=d)}),E.environment.appRoot=D.URI.revive(L.transformIncomingURIs(E.environment.appRoot));const v=E.environment.extensionDevelopmentLocationURI;return v&&(E.environment.extensionDevelopmentLocationURI=v.map(t=>D.URI.revive(L.transformIncomingURIs(t)))),E.environment.extensionTestsLocationURI=D.URI.revive(L.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=D.URI.revive(L.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=D.URI.revive(L.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=D.URI.revive(L.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=D.URI.revive(L.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=D.URI.revive(L.transformIncomingURIs(E.logsLocation)),E.logFile=D.URI.revive(L.transformIncomingURIs(E.logFile)),E.workspace=L.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=l}),define(ke[250],Te([1,0,16,17,21,39,15,19,24,2,47]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(g,E,L,v){this.d=g,this.e=E,this.f=L,this.g=v,this.a=null,this.b=!1,this.c=0}search(g,E){const L=this.d.folderQueries||[],v=new D.CancellationTokenSource;return E.onCancellationRequested(()=>v.cancel()),new Promise((t,d)=>{this.a=new b(g);let r=!1;const u=(n,p)=>{if(!r&&!this.b){const o=this.h(n);a(n)&&typeof this.d.maxResults=="number"&&this.c+o>this.d.maxResults&&(this.b=!0,r=!0,v.cancel(),n=this.j(n,this.d.maxResults-this.c));const c=this.h(n);this.c+=c,(c>0||!a(n))&&this.a.add(n,p)}};Promise.all(L.map((n,p)=>this.k(n,o=>u(o,p),v.token))).then(n=>{v.dispose(),this.a.flush();const p=n.some(o=>!!o&&!!o.limitHit);t({limitHit:this.b||p,messages:(0,i.flatten)(n.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.g}})},n=>{v.dispose();const p=(0,M.toErrorMessage)(n);d(new Error(p))})})}h(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,E){const L=Array.isArray(g.ranges)?g.ranges:[g.ranges],v=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:L.slice(0,E),preview:{matches:v.slice(0,E),text:g.preview.text},uri:g.uri}}async k(g,E,L){const v=new N.QueryGlobTester(this.d,g),t=[],d={report:n=>{if(!this.l(n))return;const p=g.folder.scheme===y.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(n.uri))):void 0,o=S.relativePath(g.folder,n.uri);if(o){const c=v.includedInQuery(o,O.basename(o),p);(0,C.isThenable)(c)?t.push(c.then(m=>{m&&E(n)})):c&&E(n)}}},r=this.n(g),u=await this.e.provideTextSearchResults(h(this.d.contentPattern),r,d,L);return t.length&&await Promise.all(t),u}l(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const E=(0,N.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),L=(0,N.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),v={folder:k.URI.from(g.folder),excludes:L,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=w;function h(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class b{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new s(512,E=>this.g(E))}add(g,E){this.d&&(this.b!==E||!S.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:g.uri,results:[]}),this.d.results.push(f(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=b;function f(l){return a(l)?{preview:{matches:(0,i.mapArrayOrNot)(l.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:l.preview.text},ranges:(0,i.mapArrayOrNot)(l.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function a(l){return!!l.preview}e.extensionResultIsMatch=a;class s{constructor(g,E){this.g=g,this.h=E,this.c=0,this.d=[],this.e=0}addItem(g,E){!g||this.j(g,E)}addItems(g,E){!g||this.k(g,E)}j(g,E){this.d.push(g),this.e+=E,this.l()}k(g,E){this.d=this.d.concat(g),this.e+=E,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}s.a=4e3,s.b=50,e.BatchedCollector=s}),define(ke[110],Te([1,0,6,5,3,245,18,55,11,2,250]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let w=class{constructor(a,s,l){this.k=a,this.l=s,this.n=l,this.c=this.k.getProxy(C.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,s){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const l=this.d++;return this.e.set(l,s),this.c.$registerTextSearchProvider(l,this.o(a)),(0,i.toDisposable)(()=>{this.g.delete(a),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(a,s){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const l=this.d++;return this.h.set(l,s),this.c.$registerFileSearchProvider(l,this.o(a)),(0,i.toDisposable)(()=>{this.i.delete(a),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(a,s,l,g){const E=h(l),L=this.h.get(a);if(L)return this.j.fileSearch(E,L,v=>{this.c.$handleFileMatch(a,s,v.map(t=>t.resource))},g);throw new Error("unknown provider: "+a)}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,s,l,g){const E=this.e.get(a);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const L=h(l);return this.q(L,E).search(t=>this.c.$handleTextMatch(a,s,t),g)}$enableExtensionHostSearch(){}q(a,s){return new N.TextSearchManager(a,s,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};w=Ke([je(0,y.IExtHostRpcService),je(1,O.IURITransformerService),je(2,S.ILogService)],w),e.ExtHostSearch=w;function h(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(a=>k.URI.revive(a))}}e.reviveQuery=h;function b(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(ke[251],Te([1,0,67,105,31,103,32,37,58,61,107,109,110,80,70,76,104,60,36,79,57,59,220,11,176,108,78]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v,t,d,r,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(n.IExtHostLocalizationService,n.ExtHostLocalizationService,1),(0,i.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,1),(0,i.registerSingleton)(d.ILogService,r.ExtHostLogService,1),(0,i.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(O.IExtHostCommands,O.ExtHostCommands,0),(0,i.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,0),(0,i.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,i.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,i.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,i.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,i.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,i.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,0),(0,i.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,i.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,i.registerSingleton)(L.IExtHostTelemetry,L.ExtHostTelemetry,0),(0,i.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,i.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(ke[252],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const M=this.a.get(D);return this.a.delete(D),M}}addDragOperationTransfer(D,M){this.a.set(D,M)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,M){this.b.set(D,M)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=i}),define(ke[253],Te([1,0,145,7,24,2,4,6,181,17,7,9,16,8,21,252,26]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(L,v){if((0,w.isString)(L))return{label:L};if(L&&typeof L=="object"&&typeof L.label=="string"){let t;return Array.isArray(L.highlights)&&(t=L.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:L.label,highlights:t}}}class g{constructor(v,t,d){this.d=v,this.e=t,this.f=d,this.a=new Map,this.b=new a.TreeviewsService;function r(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>r(u)?this.i(u):Array.isArray(u)&&u.length>0?u.map(n=>r(n)?this.i(n):n):u})}registerTreeDataProvider(v,t,d){const r=this.createTreeView(v,{treeDataProvider:t},d);return{dispose:()=>r.dispose()}}createTreeView(v,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],n=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,o=this.h(v,t,d),c=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:u,hasHandleDrag:n,hasHandleDrop:p});return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,s.checkProposedApiEnabled)(d,"treeItemCheckbox"),o.onDidChangeCheckboxState},get message(){return o.message},set message(m){o.message=m},get title(){return o.title},set title(m){o.title=m},get description(){return o.description},set description(m){o.description=m},get badge(){return o.badge},set badge(m){m!==void 0&&N.ViewBadge.isViewBadge(m)?o.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(o.badge=void 0)},reveal:(m,P)=>o.reveal(m,P),dispose:async()=>{await c,this.a.delete(v),o.dispose()}}}$getChildren(v,t){const d=this.a.get(v);return d?d.getChildren(t):Promise.reject(new S.NoTreeViewError(v))}async $handleDrop(v,t,d,r,u,n,p,o){const c=this.a.get(v);if(!c)return Promise.reject(new S.NoTreeViewError(v));const m=b.DataTransfer.toDataTransfer(d,async P=>(await this.d.$resolveDropFileData(v,t,P)).buffer);return p===v&&o&&await this.g(m,c,o,u,n),c.onDrop(m,r,u)}async g(v,t,d,r,u){const n=this.b.removeDragOperationTransfer(u);if(n)(await n)?.forEach((p,o)=>{p&&v.set(o,p)});else if(u&&t.handleDrag){const p=t.handleDrag(d,v,r);this.b.addDragOperationTransfer(u,p),await p}return v}async $handleDrag(v,t,d,r){const u=this.a.get(v);if(!u)return Promise.reject(new S.NoTreeViewError(v));const n=await this.g(new C.DataTransfer,u,t,r,d);if(!!n)return b.DataTransfer.toDataTransferDTO(n)}async $hasResolve(v){const t=this.a.get(v);if(!t)throw new S.NoTreeViewError(v);return t.hasResolve}$resolve(v,t,d){const r=this.a.get(v);if(!r)throw new S.NoTreeViewError(v);return r.resolveTreeItem(t,d)}$setExpanded(v,t,d){const r=this.a.get(v);if(!r)throw new S.NoTreeViewError(v);r.setExpanded(t,d)}$setSelection(v,t){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setSelection(t)}$setFocus(v,t){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setFocus(t)}$setVisible(v,t){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setVisible(t)}$changeCheckboxState(v,t){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setCheckboxState(t)}h(v,t,d){const r=new E(v,t,this.d,this.e.converter,this.f,d);return this.a.set(v,r),r}i(v){const t=this.a.get(v.$treeViewId);return t&&"$treeItemHandle"in v?t.getExtensionElement(v.$treeItemHandle):t&&"$focusedTreeItem"in v&&v.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=g;class E extends O.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,w.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,t,d,r,u,n){if(super(),this.C=v,this.D=d,this.F=r,this.G=u,this.H=n,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new y.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new y.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new y.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new y.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new y.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new y.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new f.CancellationTokenSource,n.contributes&&n.contributes.views)for(const c in n.contributes.views)for(const m of n.contributes.views[c])m.id===v&&(this.J=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(c=>this.w.fire({message:!1,element:c})));let p,o;this.B(y.Event.debounce(this.w.event,(c,m)=>(c||(c={message:!1,elements:[]}),m.element!==!1&&(p||(p=new Promise(P=>o=P),this.y=this.y.then(()=>p)),Array.isArray(m.element)?c.elements.push(...m.element):c.elements.push(m.element)),m.message&&(c.message=!0),c),200,!0)(({message:c,elements:m})=>{m.length&&(this.z=this.z.then(()=>{const P=o;return p=null,this.U(m).then(()=>P())})),c&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const t=v?this.getExtensionElement(v):void 0;if(v&&!t)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let d=this.Q(v);return d||(d=await this.R(t)),d?d.map(r=>r.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,t){t=t||{select:!0,focus:!1};const d=(0,w.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,w.isUndefinedOrNull)(t.focus)?!1:t.focus,u=(0,w.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(n=>this.P(v,n[n.length-1]).then(p=>this.D.$reveal(this.C,{item:p.item,parentChain:n.map(o=>o.item)},{select:d,focus:r,expand:u})),n=>this.G.error(n)):this.D.$reveal(this.C,void 0,{select:d,focus:r,expand:u})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=b.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,t){const d=this.getExtensionElement(v);d&&(t?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(v){(0,h.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const t=(await Promise.all(v.map(async d=>{const r=this.getExtensionElement(d.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(v,t,d){const r=[];for(const u of v){const n=this.getExtensionElement(u);n&&r.push(n)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,t,d){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,v,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,t){if(!this.f.resolveTreeItem)return;const d=this.i.get(v);if(d){const r=this.j.get(d);if(r){const u=await this.f.resolveTreeItem(r.extensionItem,d,t)??r.extensionItem;return this.db(u),r.item.tooltip=this.ab(u.tooltip),r.item.command=this.bb(r.disposableStore,u.command),r.item}}}N(v){return this.O(v).then(t=>t?this.N(t).then(d=>this.P(t,d[d.length-1]).then(r=>(d.push(r),d))):Promise.resolve([]))}O(v){const t=this.j.get(v);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(v))}P(v,t){const d=this.j.get(v);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.f.getTreeItem(v)).then(r=>this.gb(v,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(r);if(u){const n=this.j.get(u);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(v){if(v){let t;if(typeof v=="string"){const d=this.getExtensionElement(v);t=d?this.j.get(d):void 0}else t=v;return t&&t.children||void 0}return this.h}async R(v){this.nb(v);const t=new f.CancellationTokenSource(this.S.token);try{const d=v?this.j.get(v):void 0,r=await this.f.getChildren(v);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,h.coalesce)(r||[]).map(async n=>{const p=await this.f.getTreeItem(n);return p&&!t.token.isCancellationRequested?this.Z(n,p,d):null}));return t.token.isCancellationRequested?void 0:(0,h.coalesce)(u)}finally{t.dispose()}}U(v){if(v.some(d=>!d))return this.S.dispose(!0),this.S=new f.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(v);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(v){const t=new Set,d=v.map(u=>this.j.get(u));for(const u of d)if(u&&!t.has(u.item.handle)){let n=u;for(;n&&n.parent&&d.findIndex(p=>n&&n.parent&&p&&p.item.handle===n.parent.item.handle)===-1;){const p=this.i.get(n.parent.item.handle);n=p?this.j.get(p):void 0}n&&!n.parent&&t.add(u.item.handle)}const r=[];return t.forEach(u=>{const n=this.i.get(u);if(n){const p=this.j.get(n);p&&(!p.parent||!t.has(p.parent.item.handle))&&r.push(u)}}),r}X(v){const t={};return Promise.all(v.map(d=>this.Y(d).then(r=>{r&&(t[d]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(v){const t=this.getExtensionElement(v);if(t){const d=this.j.get(t);if(d)return this.nb(t),(0,k.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const u=this.eb(t,r,d.parent);return this.lb(t,u,d,d.parent),d.dispose(),u}return null})}return Promise.resolve(null)}Z(v,t,d){const r=this.eb(v,t,d);if(t.id&&this.i.has(r.item.handle))throw new Error((0,i.localize)(0,null,t.id));return this.kb(v,r),this.mb(r,d),r}ab(v){return N.MarkdownString.isMarkdownString(v)?b.MarkdownString.from(v):v}bb(v,t){return t?{...this.F.toInternal(t,v),originalId:t.command}:void 0}cb(v){if(!v.checkboxState)return;let t,d;return typeof v.checkboxState=="number"?t=v.checkboxState:(t=v.checkboxState.state,d=v.checkboxState.tooltip),{isChecked:t===N.TreeItemCheckboxState.Checked,tooltip:d}}db(v){if(!N.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,t,d){this.db(t);const r=new O.DisposableStore,u=this.gb(v,t,d),n=this.hb(t);return{item:{handle:u,parentHandle:d?d.item.handle:void 0,label:l(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:n,iconDark:this.ib(t)||n,themeIcon:this.fb(t),collapsibleState:(0,w.isUndefinedOrNull)(t.collapsibleState)?N.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(v){return v.iconPath instanceof N.ThemeIcon?v.iconPath:void 0}gb(v,{id:t,label:d,resourceUri:r},u,n){if(t)return`${E.b}/${t}`;const p=l(d,this.H),o=u?u.item.handle:E.a;let c=p?p.label:r?(0,D.basename)(r):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const m=this.j.has(v)?this.j.get(v).item.handle:void 0,P=this.Q(u)||[];let T,V=0;do{if(T=`${o}/${V}:${c}`,n||!this.i.has(T)||m===T)break;V++}while(V<=P.length);return T}hb(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon))return typeof v.iconPath=="string"||M.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return M.URI.isUri(v)?v:M.URI.file(v)}kb(v,t){this.i.set(t.item.handle,v),this.j.set(v,t)}lb(v,t,d,r){this.i.delete(t.item.handle),this.j.delete(v),t.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(v,t);const u=this.Q(r)||[],n=u.filter(p=>p.item.handle===d.item.handle)[0];n&&u.splice(u.indexOf(n),1,t)}mb(v,t){t?(t.children||(t.children=[]),t.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const t=this.j.get(v);if(t){if(t.children)for(const d of t.children){const r=this.i.get(d.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(v){const t=this.j.get(v);if(t){if(t.children)for(const d of t.children){const r=this.i.get(d.item.handle);r&&this.ob(r)}this.j.delete(v),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(ke[254],Te([1,0,21,12,4,29,2,130,263,118,128,43,5,74,207,206,37,208,32,210,211,212,195,213,58,33,214,215,218,219,221,105,198,227,228,229,80,61,232,253,8,7,52,235,62,104,31,187,217,50,103,107,109,110,11,55,18,27,222,193,70,76,204,233,81,60,238,236,237,205,36,230,234,79,59,57,223,106,224,15,92,197,178,216,6,26,183,78,174,225,226]),function(te,e,i,C,D,M,y,O,S,k,N,w,h,b,f,a,s,l,g,E,L,v,t,d,r,u,n,p,o,c,m,P,T,V,_,K,A,U,R,F,H,j,le,ge,re,ae,ce,Se,x,X,J,de,ye,Ne,We,Pe,Ce,we,se,ue,Z,I,$,W,q,ee,fe,De,oe,ve,be,He,qe,tt,Xe,et,it,dt,Fe,ot,Y,Q,pe,Me,ze,Ve,Ye,nt,vt,wt,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(rt){const mt=rt.get(we.IExtHostInitDataService),Ft=rt.get(be.IExtHostFileSystemInfo),Gt=rt.get(ee.IExtHostConsumerFileSystem),Pt=rt.get(u.IExtHostExtensionService),ht=rt.get(ce.IExtHostWorkspace),kt=rt.get(et.IExtHostTelemetry),Bt=rt.get(g.IExtHostConfiguration),Ot=rt.get(Pe.IURITransformerService),Ge=rt.get(Ce.IExtHostRpcService),Nt=rt.get(A.IExtHostStorage),Mt=rt.get(q.IExtensionStoragePaths),zt=rt.get(We.ILoggerService),ft=rt.get(We.ILogService),Ie=rt.get(Z.IExtHostTunnelService),Ae=rt.get(I.IExtHostApiDeprecationService),me=rt.get(ae.IExtHostWindow),G=rt.get(tt.IExtHostSecretState),Re=rt.get(Xe.IExtHostEditorTabs);Ge.set(h.ExtHostContext.ExtHostFileSystemInfo,Ft),Ge.set(h.ExtHostContext.ExtHostLogLevelServiceShape,zt),Ge.set(h.ExtHostContext.ExtHostWorkspace,ht),Ge.set(h.ExtHostContext.ExtHostConfiguration,Bt),Ge.set(h.ExtHostContext.ExtHostExtensionService,Pt),Ge.set(h.ExtHostContext.ExtHostStorage,Nt),Ge.set(h.ExtHostContext.ExtHostTunnelService,Ie),Ge.set(h.ExtHostContext.ExtHostWindow,me),Ge.set(h.ExtHostContext.ExtHostSecretState,G),Ge.set(h.ExtHostContext.ExtHostTelemetry,kt),Ge.set(h.ExtHostContext.ExtHostEditorTabs,Re);const Be=Ge.set(h.ExtHostContext.ExtHostDecorations,rt.get(J.IExtHostDecorations)),Qe=Ge.set(h.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(r.IExtHostDocumentsAndEditors)),$e=Ge.set(h.ExtHostContext.ExtHostCommands,rt.get(s.IExtHostCommands)),Ze=Ge.set(h.ExtHostContext.ExtHostTerminalService,rt.get(U.IExtHostTerminalService)),ct=Ge.set(h.ExtHostContext.ExtHostDebugService,rt.get(ye.IExtHostDebugService)),Tt=Ge.set(h.ExtHostContext.ExtHostSearch,rt.get(Ne.IExtHostSearch)),bt=Ge.set(h.ExtHostContext.ExtHostTask,rt.get(de.IExtHostTask)),Et=Ge.set(h.ExtHostContext.ExtHostOutputService,rt.get(P.IExtHostOutputService)),It=Ge.set(h.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),St=Ge.set(h.ExtHostContext.ExtHostUrls,new ge.ExtHostUrls(Ge)),yt=Ge.set(h.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ge,Qe)),qt=Ge.set(h.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ge,Qe,ft)),Jt=Ge.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ft,yt,Ge.getProxy(h.MainContext.MainThreadBulkEdits))),pt=Ge.set(h.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,$e,Qe,yt)),si=Ge.set(h.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(pt)),oi=Ge.set(h.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(ft,pt)),Zt=Ge.set(h.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,mt,pt,$e,ft)),vi=Ge.set(h.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,pt)),At=Ge.set(h.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(Ge,Qe)),Wt=Ge.set(h.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(Ge.getProxy(h.MainContext.MainThreadTreeViews),$e,ft)),bi=Ge.set(h.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(Ge.getProxy(h.MainContext.MainThreadEditorInsets),At,mt.remote)),ai=Ge.set(h.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,ft,Ft,Qe)),ei=Ge.set(h.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Ge,yt,$e.converter,Ot)),ut=Ge.set(h.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Ge,Ot,yt,$e,ai,ft,Ae,kt)),Bi=Ge.set(h.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ge,ut)),Ut=Ge.set(h.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(Ge,ft,Qe)),Qt=Ge.set(h.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(Ge,ht,$e)),ci=Ge.set(h.ExtHostContext.ExtHostSCM,new _.ExtHostSCM(Ge,$e,ft)),Ei=Ge.set(h.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(Ge,Ot)),wi=Ge.set(h.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,$e,yt)),ui=Ge.set(h.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(Ge.getProxy(h.MainContext.MainThreadProgress))),Si=Ge.set(h.ExtHostContext.ExtHosLabelService,new x.ExtHostLabelService(Ge)),li=Ge.set(h.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(Ge)),ti=Ge.set(h.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),$i=Ge.set(h.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,$e)),ii=Ge.set(h.ExtHostContext.ExtHostWebviews,new re.ExtHostWebviews(Ge,mt.remote,ht,ft,Ae)),ni=Ge.set(h.ExtHostContext.ExtHostWebviewPanels,new oe.ExtHostWebviewPanels(Ge,ii,ht)),yi=Ge.set(h.ExtHostContext.ExtHostCustomEditors,new De.ExtHostCustomEditors(Ge,yt,Mt,ii,ni)),Di=Ge.set(h.ExtHostContext.ExtHostWebviewViews,new fe.ExtHostWebviewViews(Ge,ii)),ri=Ge.set(h.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ge,$e,Qe)),Ii=Ge.set(h.ExtHostContext.ExtHostUriOpeners,new qe.ExtHostUriOpeners(Ge)),Ci=Ge.set(h.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(h.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,pt,Qe,$e,ft));const zi=Object.values(h.ExtHostContext);Ge.assertRegistered(zi);const Wi=new ve.ExtHostBulkEdits(Ge,Qe),Hi=new a.ExtHostClipboard(Ge),ki=new m.ExtHostMessageService(Ge,ft),Ri=new L.ExtHostDialogs(Ge),Oi=new K.ExtHostStatusBar(Ge,$e.converter);return f.ExtHostApiCommands.register($e),function(Ue,Ht,Li){const gt=function(){let ne=!Ue.isUnderDevelopment;function he(){ne||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")he();else{const Dt=st;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return st}}(),Vi={getSession(ne,he,Oe){return ti.getSession(Ue,ne,he,Oe)},async hasSession(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,ne,he,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,he,Oe,st){return ti.registerAuthenticationProvider(ne,he,Oe,st)}},di={registerCommand(ne,he,Oe){return $e.registerCommand(!0,ne,he,Oe,void 0,Ue)},registerTextEditorCommand(ne,he,Oe){return $e.registerCommand(!0,ne,(...st)=>{const Dt=At.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Rt=>{he.apply(Oe,[Dt,Rt,...st])}).then(Rt=>{Rt||ft.warn("Edits from command "+ne+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+ne,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,he,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"diffCommand"),$e.registerCommand(!0,ne,async(...st)=>{const Dt=Qe.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);he.apply(Oe,[Rt,...st])},void 0,void 0,Ue)),executeCommand(ne,...he){return $e.executeCommand(ne,...he)},getCommands(ne=!1){return $e.getCommands(ne)}},Fi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ue,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return et.ExtHostTelemetryLogger.validateSender(ne),kt.instantiateLogger(Ue,ne)},openExternal(ne,he){return me.openUri(ne,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===mt.environment.appUriScheme)return St.createAppUri(ne);try{return await me.asExternalUri(ne,{allowTunneling:!!mt.remote.authority})}catch(he){if((0,Y.matchesScheme)(ne,ot.Schemas.http)||(0,Y.matchesScheme)(ne,ot.Schemas.https))return ne;throw he}},get remoteName(){return(0,X.getRemoteName)(mt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};mt.environment.extensionTestsLocationURI||Object.freeze(Fi);const ji={createTestController(ne,he,Oe){return ri.createTestController(Ue,ne,he,Oe)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(ne){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(ne)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},hi=mt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ne,he){(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Oe=Ht.mine.getExtensionDescription(ne);if(Oe)return new u.Extension(Pt,Ue.identifier,Oe,hi,!1);if(he){const st=Ht.all.getExtensionDescription(ne);if(st)return new u.Extension(Pt,Ue.identifier,st,hi,!0)}},get all(){const ne=[];for(const he of Ht.mine.getAllExtensionDescriptions())ne.push(new u.Extension(Pt,Ue.identifier,he,hi,!1));return ne},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Ht.all.getAllExtensionDescriptions()){const st=!ne.has(Oe.identifier);he.push(new u.Extension(Pt,Ue.identifier,Oe,hi,st))}return he},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")?D.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Ti={createDiagnosticCollection(ne){return ai.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ne=>ai.getDiagnostics(ne),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ne,he){return ei.changeLanguage(ne.uri,he)},match(ne,he){const Oe=yt.getDocumentData(he.uri)?.notebook;return(0,N.score)(H.LanguageSelector.from(ne),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,he,Oe){return ut.registerCodeActionProvider(Ue,gt(ne),he,Oe)},registerDocumentPasteEditProvider(ne,he,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,gt(ne),he,Oe)},registerCodeLensProvider(ne,he){return ut.registerCodeLensProvider(Ue,gt(ne),he)},registerDefinitionProvider(ne,he){return ut.registerDefinitionProvider(Ue,gt(ne),he)},registerDeclarationProvider(ne,he){return ut.registerDeclarationProvider(Ue,gt(ne),he)},registerImplementationProvider(ne,he){return ut.registerImplementationProvider(Ue,gt(ne),he)},registerTypeDefinitionProvider(ne,he){return ut.registerTypeDefinitionProvider(Ue,gt(ne),he)},registerHoverProvider(ne,he){return ut.registerHoverProvider(Ue,gt(ne),he,Ue.identifier)},registerEvaluatableExpressionProvider(ne,he){return ut.registerEvaluatableExpressionProvider(Ue,gt(ne),he,Ue.identifier)},registerInlineValuesProvider(ne,he){return ut.registerInlineValuesProvider(Ue,gt(ne),he,Ue.identifier)},registerDocumentHighlightProvider(ne,he){return ut.registerDocumentHighlightProvider(Ue,gt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ut.registerLinkedEditingRangeProvider(Ue,gt(ne),he)},registerReferenceProvider(ne,he){return ut.registerReferenceProvider(Ue,gt(ne),he)},registerRenameProvider(ne,he){return ut.registerRenameProvider(Ue,gt(ne),he)},registerDocumentSymbolProvider(ne,he,Oe){return ut.registerDocumentSymbolProvider(Ue,gt(ne),he,Oe)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,he){return ut.registerDocumentFormattingEditProvider(Ue,gt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ut.registerDocumentRangeFormattingEditProvider(Ue,gt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,gt(ne),he,[Oe].concat(st))},registerDocumentSemanticTokensProvider(ne,he,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,gt(ne),he,Oe)},registerDocumentRangeSemanticTokensProvider(ne,he,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,gt(ne),he,Oe)},registerSignatureHelpProvider(ne,he,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,gt(ne),he,Oe):ut.registerSignatureHelpProvider(Ue,gt(ne),he,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(ne,he,...Oe){return ut.registerCompletionItemProvider(Ue,gt(ne),he,Oe)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,gt(ne),he)},registerDocumentLinkProvider(ne,he){return ut.registerDocumentLinkProvider(Ue,gt(ne),he)},registerColorProvider(ne,he){return ut.registerColorProvider(Ue,gt(ne),he)},registerFoldingRangeProvider(ne,he){return ut.registerFoldingRangeProvider(Ue,gt(ne),he)},registerSelectionRangeProvider(ne,he){return ut.registerSelectionRangeProvider(Ue,ne,he)},registerCallHierarchyProvider(ne,he){return ut.registerCallHierarchyProvider(Ue,ne,he)},registerTypeHierarchyProvider(ne,he){return ut.registerTypeHierarchyProvider(Ue,ne,he)},setLanguageConfiguration:(ne,he)=>ut.setLanguageConfiguration(Ue,ne,he),getTokenInformationAtPosition(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"tokenInformation"),ei.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ut.registerInlayHintsProvider(Ue,ne,he)},createLanguageStatusItem(ne,he){return ei.createLanguageStatusItem(Ue,ne,he)},registerDocumentDropEditProvider(ne,he){return ut.registerDocumentOnDropEditProvider(Ue,ne,he)}},Ki={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(ne,he,Oe){const st=await(y.URI.isUri(ne)?Promise.resolve(Kt.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(st,he,Oe)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,he,Oe){return At.onDidChangeActiveTextEditor(ne,he,Oe)},onDidChangeVisibleTextEditors(ne,he,Oe){return At.onDidChangeVisibleTextEditors(ne,he,Oe)},onDidChangeTextEditorSelection(ne,he,Oe){return At.onDidChangeTextEditorSelection(ne,he,Oe)},onDidChangeTextEditorOptions(ne,he,Oe){return At.onDidChangeTextEditorOptions(ne,he,Oe)},onDidChangeTextEditorVisibleRanges(ne,he,Oe){return At.onDidChangeTextEditorVisibleRanges(ne,he,Oe)},onDidChangeTextEditorViewColumn(ne,he,Oe){return At.onDidChangeTextEditorViewColumn(ne,he,Oe)},onDidCloseTerminal(ne,he,Oe){return Ze.onDidCloseTerminal(ne,he,Oe)},onDidOpenTerminal(ne,he,Oe){return Ze.onDidOpenTerminal(ne,he,Oe)},onDidChangeActiveTerminal(ne,he,Oe){return Ze.onDidChangeActiveTerminal(ne,he,Oe)},onDidChangeTerminalDimensions(ne,he,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(ne,he,Oe)},onDidChangeTerminalState(ne,he,Oe){return Ze.onDidChangeTerminalState(ne,he,Oe)},onDidWriteTerminalData(ne,he,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(ne,he,Oe)},get state(){return me.state},onDidChangeWindowState(ne,he,Oe){return me.onDidChangeWindowState(ne,he,Oe)},showInformationMessage(ne,...he){return ki.showMessage(Ue,M.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return ki.showMessage(Ue,M.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return ki.showMessage(Ue,M.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Oe){return Qt.showQuickPick(ne,he,Oe)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Qt.showInput(ne,he)},showOpenDialog(ne){return Ri.showOpenDialog(Ue,ne)},showSaveDialog(ne){return Ri.showSaveDialog(ne)},createStatusBarItem(ne,he,Oe){let st,Dt,Rt;return typeof ne=="string"?(st=ne,Dt=he,Rt=Oe):(Dt=ne,Rt=he),Oi.createStatusBarEntry(Ue,st,Dt,Rt)},setStatusBarMessage(ne,he){return Oi.setStatusBarMessage(ne,he)},withScmProgress(ne){return Ae.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ui.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(he,Oe)=>ne({report(st){}}))},withProgress(ne,he){return ui.withProgress(Ue,ne,he)},createOutputChannel(ne,he){return Et.createOutputChannel(ne,he,Ue)},createWebviewPanel(ne,he,Oe,st){return ni.createWebviewPanel(Ue,ne,he,Oe,st)},createWebviewTextEditorInset(ne,he,Oe,st){return(0,Ve.checkProposedApiEnabled)(Ue,"editorInsets"),bi.createWebviewEditorInset(ne,he,Oe,st,Ue)},createTerminal(ne,he,Oe){return typeof ne=="object"?"pty"in ne?Ze.createExtensionTerminal(ne):Ze.createTerminalFromOptions(ne):Ze.createTerminal(ne,he,Oe)},registerTerminalLinkProvider(ne){return Ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return Ze.registerProfileProvider(Ue,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,he)},registerTreeDataProvider(ne,he){return Wt.registerTreeDataProvider(ne,he,Ue)},createTreeView(ne,he){return Wt.createTreeView(ne,he,Ue)},registerWebviewPanelSerializer:(ne,he)=>ni.registerWebviewPanelSerializer(Ue,ne,he),registerCustomEditorProvider:(ne,he,Oe={})=>yi.registerCustomEditorProvider(Ue,ne,he,Oe),registerFileDecorationProvider(ne){return Be.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return St.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Oe){return li.onDidChangeActiveColorTheme(ne,he,Oe)},registerWebviewViewProvider(ne,he,Oe){return Di.registerWebviewViewProvider(Ue,ne,he,Oe?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Oe){return pt.onDidChangeActiveNotebookEditor(ne,he,Oe)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Oe){return oi.onDidChangeNotebookEditorSelection(ne,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,he,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Oe)},showNotebookDocument(ne,he){return pt.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ii.registerExternalUriOpener(Ue.identifier,ne,he,Oe)},registerProfileContentHandler(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ci.registrProfileContentHandler(Ue,ne,he)},registerQuickDiffProvider(ne,he,Oe,st){return(0,Ve.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ei.registerQuickDiffProvider(gt(ne),he,Oe,st)},get tabGroups(){return Re.tabGroups}},Kt={get rootPath(){return Ae.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ht.getWorkspaceFolder(ne)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ne){throw C.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,he,...Oe)=>ht.updateWorkspaceFolders(Ue,ne,he||0,...Oe),onDidChangeWorkspaceFolders:function(ne,he,Oe){return ht.onDidChangeWorkspace(ne,he,Oe)},asRelativePath:(ne,he)=>ht.getRelativePath(ne,he),findFiles:(ne,he,Oe,st)=>ht.findFiles(ne,he,Oe,Ue.identifier,st),findTextInFiles:(ne,he,Oe,st)=>{(0,Ve.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Rt;return typeof he=="object"?(Dt=he,Rt=Oe):(Dt={},Rt=he,st=Oe),ht.findTextInFiles(ne,Dt||{},Rt,Ue.identifier,st)},saveAll:ne=>ht.saveAll(ne),applyEdit(ne,he){return Wi.applyWorkspaceEdit(ne,Ue,he)},createFileSystemWatcher:(ne,he,Oe,st)=>Ut.createFileSystemWatcher(ht,Ue,ne,he,Oe,st),get textDocuments(){return yt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let he;const Oe=ne;if(typeof ne=="string")he=Promise.resolve(y.URI.file(ne));else if(y.URI.isUri(ne))he=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")he=yt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>yt.ensureDocumentData(st).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,he,Oe)=>yt.onDidAddDocument(ne,he,Oe),onDidCloseTextDocument:(ne,he,Oe)=>yt.onDidRemoveDocument(ne,he,Oe),onDidChangeTextDocument:(ne,he,Oe)=>yt.onDidChangeDocument(ne,he,Oe),onDidSaveTextDocument:(ne,he,Oe)=>yt.onDidSaveDocument(ne,he,Oe),onWillSaveTextDocument:(ne,he,Oe)=>Jt.getOnWillSaveTextDocumentEvent(Ue)(ne,he,Oe),get notebookDocuments(){return pt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Oe;if(y.URI.isUri(ne))Oe=ne,await pt.openNotebookDocument(ne);else if(typeof ne=="string")Oe=y.URI.revive(await pt.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,he,Oe){return si.onDidSaveNotebookDocument(ne,he,Oe)},onDidChangeNotebookDocument(ne,he,Oe){return si.onDidChangeNotebookDocument(ne,he,Oe)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Oe,st){return pt.registerNotebookSerializer(Ue,ne,he,Oe,(0,Ve.isProposedApiEnabled)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ne,he,Oe)=>Li.onDidChangeConfiguration(ne,he,Oe),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Li.getConfiguration(ne,he,Ue)},registerTextDocumentContentProvider(ne,he){return qt.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Ae.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ue,ne,he)),registerFileSystemProvider(ne,he,Oe){return(0,ze.combinedDisposable)(Bi.registerFileSystemProvider(Ue,ne,he,Oe),Gt.addFileSystemProvider(ne,he))},get fs(){return Gt.value},registerFileSearchProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Tt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"textSearchProvider"),Tt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Pt.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Si.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Oe)=>Ut.onDidCreateFile(ne,he,Oe),onDidDeleteFiles:(ne,he,Oe)=>Ut.onDidDeleteFile(ne,he,Oe),onDidRenameFiles:(ne,he,Oe)=>Ut.onDidRenameFile(ne,he,Oe),onWillCreateFiles:(ne,he,Oe)=>Ut.getOnWillCreateFileEvent(Ue)(ne,he,Oe),onWillDeleteFiles:(ne,he,Oe)=>Ut.getOnWillDeleteFileEvent(Ue)(ne,he,Oe),onWillRenameFiles:(ne,he,Oe)=>Ut.getOnWillRenameFileEvent(Ue)(ne,he,Oe),openTunnel:ne=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),Ie.openTunnel(Ue,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),Ie.getTunnels()},onDidChangeTunnels:(ne,he,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),Ie.onDidChangeTunnels(ne,he,Oe)),registerPortAttributesProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"portsAttributes"),Ie.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"timeline"),$i.registerTimelineProvider(ne,he,Ue.identifier,$e.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ne=>((0,Ve.checkProposedApiEnabled)(Ue,"workspaceTrust"),ht.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Oe)=>ht.onDidGrantWorkspaceTrust(ne,he,Oe),registerEditSessionIdentityProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ne,he)),onWillCreateEditSessionIdentity:(ne,he,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ue)(ne,he,Oe))},fi={get inputBox(){return Ae.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ue)},createSourceControl(ne,he,Oe){return ci.createSourceControl(Ue,ne,he,Oe)}},xi={createCommentController(ne,he){return wi.createCommentController(Ue,ne,he)}},$t={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ne,he,Oe){return ct.onDidStartDebugSession(ne,he,Oe)},onDidTerminateDebugSession(ne,he,Oe){return ct.onDidTerminateDebugSession(ne,he,Oe)},onDidChangeActiveDebugSession(ne,he,Oe){return ct.onDidChangeActiveDebugSession(ne,he,Oe)},onDidReceiveDebugSessionCustomEvent(ne,he,Oe){return ct.onDidReceiveDebugSessionCustomEvent(ne,he,Oe)},onDidChangeBreakpoints(ne,he,Oe){return ct.onDidChangeBreakpoints(ne,he,Oe)},registerDebugConfigurationProvider(ne,he,Oe){return ct.registerDebugConfigurationProvider(ne,he,Oe||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return ct.registerDebugAdapterDescriptorFactory(Ue,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return ct.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ct.startDebugging(ne,he,{parentSession:Oe}):ct.startDebugging(ne,he,Oe||{})},stopDebugging(ne){return ct.stopDebugging(ne)},addBreakpoints(ne){return ct.addBreakpoints(ne)},removeBreakpoints(ne){return ct.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return ct.asDebugSourceUri(ne,he)}},mi={registerTaskProvider:(ne,he)=>bt.registerTaskProvider(Ue,ne,he),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Ue,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,he,Oe)=>bt.onDidStartTask(ne,he,Oe),onDidEndTask:(ne,he,Oe)=>bt.onDidEndTask(ne,he,Oe),onDidStartTaskProcess:(ne,he,Oe)=>bt.onDidStartTaskProcess(ne,he,Oe),onDidEndTaskProcess:(ne,he,Oe)=>bt.onDidEndTaskProcess(ne,he,Oe)},Gi={createNotebookController(ne,he,Oe,st,Dt){return Zt.createNotebookController(Ue,ne,he,Oe,st,(0,Ve.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>pt.registerNotebookCellStatusBarItemProvider(Ue,ne,he),createRendererMessaging(ne){return vi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,he,Oe)}},Xi={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return It.getMessage(Ue.identifier.value,{message:he,args:Oe})}return It.getMessage(Ue.identifier.value,ne[0])},get bundle(){return It.getBundle(Ue.identifier.value)},get uri(){return It.getBundleUri(Ue.identifier.value)}};return{version:mt.version,authentication:Vi,commands:di,comments:xi,debug:$t,env:Fi,extensions:qi,l10n:Xi,languages:Ti,notebooks:Gi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:Kt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:k.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:O.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:b.UIKind,Uri:y.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:We.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=jt}),define(ke[255],Te([1,0,254,33,2,248,7,17,239]),function(te,e,i,C,D,M,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends M.RequireInterceptor{j(){}getModule(b,f){for(const a of this.b){const s=a(b);if(s){b=s;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=y.ExtensionRuntime.Webworker}async ob(){this.h.createInstance(S.ExtHostConsoleForwarder);const b=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.ub()}pb(b){return b.browser}async qb(b,f,a){f=f.with({path:w(f.path,".js")});const s=b?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const l=D.URI.revive(await this.v.$asBrowserUri(f)),g=await fetch(l.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),g.status!==200)throw new Error(g.statusText);const E=await g.text(),L=`${f.toString(!0)}#vscode-extension`,v=`${E}
//# sourceURL=${L}`;let t;try{t=new Function("module","exports","require",v)}catch(n){throw console.error(s?`Loading code for extension ${s} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${f.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}b&&await this.s.initializeLocalizedMessages(b);const d={},r={exports:d},u=n=>{const p=this.r.getModule(n,f);if(p===void 0)throw new Error(`Cannot load module '${n}'`);return p};try{return a.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),t(r,d,u),r.exports!==d?r.exports:d}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),a.codeLoadingStop()}}async $setRemoteEnvironment(b){}async ub(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,O.timeout)(10)}}e.ExtHostExtensionService=N;function w(h,b){return h.endsWith(b)?h:h+b}}),define(ke[256],Te([1,0,67,33,81,255]),function(te,e,i,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(C.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,i.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(ke[264],Te([1,0,23,4,74,249,241,19,82,15,2,251,256]),function(te,e,i,C,D,M,y,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function a(t){self.fetch=async function(d,r){return d instanceof Request||b(String(d))&&(d=(await t(N.URI.parse(String(d)))).toString(!0)),f(d,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,r,u,n,p){(async()=>(b(r.toString())&&(r=(await t(N.URI.parse(r.toString()))).toString(!0)),super.open(d,r,u??!0,n,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,r){if(/^file:/i.test(d.toString()))d=k.FileAccess.uriToBrowserUri(N.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const n=`(${function(m){function P(_){return typeof _=="string"||_ instanceof URL?String(_).replace(/^file:\/\//i,"vscode-file://vscode-app"):_}const T=fetch.bind(self);self.fetch=function(_,K){return _ instanceof Request?T(_,K):T(P(_),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(_,K,A,U,R){return super.open(_,P(K),A??!0,U,R)}};const V=importScripts.bind(self);self.importScripts=(..._)=>{V(..._.map(P))},V(m)}.toString()}('${d}'))`;r=r||{},r.name=r.name||O.basename(d.toString());const p=new Blob([n],{type:"application/javascript"}),o=URL.createObjectURL(p);return new t(o,r)}}else self.Worker=class extends y.NestedWorker{constructor(t,d){super(h,t,{name:O.basename(t.toString()),...d})}};const s=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class l{constructor(){const d=new MessageChannel,r=new C.Emitter;let u=!1;h(d.port2,[d.port2]),d.port1.onmessage=n=>{const{data:p}=n;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const o=i.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,D.isMessageOfType)(o,2)){u=!0,E("received terminate message from renderer");return}r.fire(o)},this.protocol={onMessage:r.event,send:n=>{if(!u){const p=n.buffer.buffer.slice(n.buffer.byteOffset,n.buffer.byteOffset+n.buffer.byteLength);d.port1.postMessage(p,[p])}}}}}function g(t){return new Promise(d=>{const r=t.onMessage(u=>{r.dispose();const n=JSON.parse(u.toString());t.send((0,D.createMessageOfType)(0)),d({protocol:t,initData:n})});t.send((0,D.createMessageOfType)(1))})}let E=t=>w();function L(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){S.mark("code/extHost/willConnectToRenderer");const t=new l;return{onmessage(d){!L(d)||g(t.protocol).then(r=>{S.mark("code/extHost/didWaitForInitData");const u=new M.ExtensionHostMain(r.protocol,r.initData,s,null,d.data);a(n=>u.asBrowserUri(n)),E=n=>u.terminate(n)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b2cc8c48b93222cd9727c4e70be3a269b132e5d8/core/vs/workbench/api/worker/extensionHostWorker.js.map
